// Test linearization of two-dimensional barycentres

#include"verasco.h"

// barycentre multiplied by c interval [lb,ub]
void barycentre(int lb, int ub,int c) { 
  int x=any_int(), y=any_int(), a=any_int(), r;

  // check test validity !
  verasco_assert(0 <= c);
  verasco_assert(lb <= ub);

  // initialization of inputs
  verasco_assume(0 <= a);
  verasco_assume(lb <= x);
  verasco_assume(lb <= y);
  verasco_assume(a <= c);
  verasco_assume(x <= ub);
  verasco_assume(y <= ub);

  // TESTS
  switch (any_int()) {
  case 0:
    r=a*x+c*y-y*a;
    break;
  case 1:
    r=a*(x-y)+c*y;
    break;
  default:
    r=(c-a)*y+x*a;
  }

  // result check
  verasco_assert(c*lb <= r);
  verasco_assert(r <= c*ub);
}

void test_barycentre() { 
  barycentre(-100,100,5);
  barycentre(-20,120,10);
  barycentre(100,200,20);
  barycentre(-2,3,10);
  barycentre(-2,2,5);
  barycentre(-1,1,5);
  barycentre(0,0,5);
  barycentre(-1,5,100);
}

int main(){
  test_barycentre();
  return 0;
}
