// Test linearization of two-dimensional barycentres

#include"verasco.h"

#define CTE 10000000

// barycentre0 with
// x=(2*x1-3*x2)
// y=(5*y1+3*y2)
void barycentre0(int lb, int ub,int c) { 
  int x1=any_int(), x2=any_int(), y1=any_int(), y2=any_int(), a=any_int(), r;

  // check test validity !
  verasco_assert(0 <= c);
  verasco_assert(lb <= ub);

  // auxiliary init (TODO: TRY TO REMOVE THIS ?)
  verasco_assume(-CTE <= x1 && x1 <= CTE);
  verasco_assume(-CTE <= x2 && x2 <= CTE);
  verasco_assume(-CTE <= y1 && y1 <= CTE);
  verasco_assume(-CTE <= y2 && y2 <= CTE);


  // initialization of inputs
  verasco_assume(0 <= a && a <= c);
  verasco_assume(lb <= (2*x1-3*x2) && (2*x1-3*x2) <= ub);
  verasco_assume(lb <= (5*y1+3*y2) && (5*y1+3*y2) <= ub);


  // TESTS
  switch (any_int()) {
  case 0:
    r=a*(2*x1-3*x2)+c*(5*y1+3*y2)-(5*y1+3*y2)*a;
    break;
  case 1:
    r=a*((2*x1-3*x2)-(5*y1+3*y2))+c*(5*y1+3*y2);
    break;
  default:
    r=(c-a)*(5*y1+3*y2)+(2*x1-3*x2)*a;
  }

  // result check
  verasco_assert(c*lb <= r);
  verasco_assert(r <= c*ub);
}

void test_barycentre0() { 
  // TODO: have greater values like test_barycentre
  barycentre0(-100,100,5);
  barycentre0(-20,12,1);
  barycentre0(10,20,2);
  barycentre0(-2,3,3);
  barycentre0(-2,2,5);
  barycentre0(-1,1,5);
  barycentre0(0,0,5);
  barycentre0(-1,5,5);
}


int main(){
  test_barycentre0();
  return 0;
}
