open Camlcoq

(** Pretty-printing support for Coq standard library types.
The [Raw] version of each function produces a string which
describes the structure of its argument in terms of constructors.
The primed version produces a Coq string. *)

val posPr: P.t -> string
val posPrRaw: P.t -> string

val posPr': P.t -> char list
val posPrRaw': P.t -> char list

val zPr: Z.t -> string
val zPrRaw: Z.t -> string

val zPr': Z.t -> char list
val zPrRaw': Z.t -> char list

val charListTr: char list -> string
val stringTr: string -> char list

val posTr: P.t -> Nb.Z.t
val zTr: Z.t -> Nb.Z.t
