  

Require Import Cabs.
Require Import List.



Require Import List.
Require Import Int31.
Require Import Syntax.
Require Import Tuples.
Require Import Alphabet.
Require Grammar.
Require Automaton.

Unset Elimination Schemes.

Module Import Gram <: Grammar.T.

Inductive terminal' : Set :=
  | ADD_ASSIGN't
  | ALIGNAS't
  | ALIGNOF't
  | AND't
  | ANDAND't
  | AND_ASSIGN't
  | ASM't
  | ATTRIBUTE't
  | AUTO't
  | BANG't
  | BAR't
  | BARBAR't
  | BREAK't
  | BUILTIN_VA_ARG't
  | CASE't
  | CHAR't
  | COLON't
  | COMMA't
  | CONST't
  | CONSTANT't
  | CONTINUE't
  | DEC't
  | DEFAULT't
  | DIV_ASSIGN't
  | DO't
  | DOT't
  | DOUBLE't
  | ELLIPSIS't
  | ELSE't
  | ENUM't
  | EOF't
  | EQ't
  | EQEQ't
  | EXTERN't
  | FLOAT't
  | FOR't
  | GEQ't
  | GOTO't
  | GT't
  | HAT't
  | IF't
  | INC't
  | INLINE't
  | INT't
  | LBRACE't
  | LBRACK't
  | LEFT't
  | LEFT_ASSIGN't
  | LEQ't
  | LONG't
  | LPAREN't
  | LT't
  | MINUS't
  | MOD_ASSIGN't
  | MUL_ASSIGN't
  | NEQ't
  | OR_ASSIGN't
  | OTHER_NAME't
  | PACKED't
  | PERCENT't
  | PLUS't
  | PRAGMA't
  | PTR't
  | QUESTION't
  | RBRACE't
  | RBRACK't
  | REGISTER't
  | RESTRICT't
  | RETURN't
  | RIGHT't
  | RIGHT_ASSIGN't
  | RPAREN't
  | SEMICOLON't
  | SHORT't
  | SIGNED't
  | SIZEOF't
  | SLASH't
  | STAR't
  | STATIC't
  | STRING_LITERAL't
  | STRUCT't
  | SUB_ASSIGN't
  | SWITCH't
  | TILDE't
  | TYPEDEF't
  | TYPEDEF_NAME't
  | UNDERSCORE_BOOL't
  | UNION't
  | UNSIGNED't
  | VAR_NAME't
  | VOID't
  | VOLATILE't
  | WHILE't
  | XOR_ASSIGN't.
Definition terminal := terminal'.

Program Instance terminalNum : Numbered terminal :=
  { inj := fun x => match x return _ with | ADD_ASSIGN't => Int31.On | ALIGNAS't => Int31.In | ALIGNOF't => (twice Int31.In) | AND't => (twice_plus_one Int31.In) | ANDAND't => (twice (twice Int31.In)) | AND_ASSIGN't => (twice_plus_one (twice Int31.In)) | ASM't => (twice (twice_plus_one Int31.In)) | ATTRIBUTE't => (twice_plus_one (twice_plus_one Int31.In)) | AUTO't => (twice (twice (twice Int31.In))) | BANG't => (twice_plus_one (twice (twice Int31.In))) | BAR't => (twice (twice_plus_one (twice Int31.In))) | BARBAR't => (twice_plus_one (twice_plus_one (twice Int31.In))) | BREAK't => (twice (twice (twice_plus_one Int31.In))) | BUILTIN_VA_ARG't => (twice_plus_one (twice (twice_plus_one Int31.In))) | CASE't => (twice (twice_plus_one (twice_plus_one Int31.In))) | CHAR't => (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))) | COLON't => (twice (twice (twice (twice Int31.In)))) | COMMA't => (twice_plus_one (twice (twice (twice Int31.In)))) | CONST't => (twice (twice_plus_one (twice (twice Int31.In)))) | CONSTANT't => (twice_plus_one (twice_plus_one (twice (twice Int31.In)))) | CONTINUE't => (twice (twice (twice_plus_one (twice Int31.In)))) | DEC't => (twice_plus_one (twice (twice_plus_one (twice Int31.In)))) | DEFAULT't => (twice (twice_plus_one (twice_plus_one (twice Int31.In)))) | DIV_ASSIGN't => (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In)))) | DO't => (twice (twice (twice (twice_plus_one Int31.In)))) | DOT't => (twice_plus_one (twice (twice (twice_plus_one Int31.In)))) | DOUBLE't => (twice (twice_plus_one (twice (twice_plus_one Int31.In)))) | ELLIPSIS't => (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In)))) | ELSE't => (twice (twice (twice_plus_one (twice_plus_one Int31.In)))) | ENUM't => (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In)))) | EOF't => (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))) | EQ't => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))) | EQEQ't => (twice (twice (twice (twice (twice Int31.In))))) | EXTERN't => (twice_plus_one (twice (twice (twice (twice Int31.In))))) | FLOAT't => (twice (twice_plus_one (twice (twice (twice Int31.In))))) | FOR't => (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In))))) | GEQ't => (twice (twice (twice_plus_one (twice (twice Int31.In))))) | GOTO't => (twice_plus_one (twice (twice_plus_one (twice (twice Int31.In))))) | GT't => (twice (twice_plus_one (twice_plus_one (twice (twice Int31.In))))) | HAT't => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice Int31.In))))) | IF't => (twice (twice (twice (twice_plus_one (twice Int31.In))))) | INC't => (twice_plus_one (twice (twice (twice_plus_one (twice Int31.In))))) | INLINE't => (twice (twice_plus_one (twice (twice_plus_one (twice Int31.In))))) | INT't => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice Int31.In))))) | LBRACE't => (twice (twice (twice_plus_one (twice_plus_one (twice Int31.In))))) | LBRACK't => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice Int31.In))))) | LEFT't => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In))))) | LEFT_ASSIGN't => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In))))) | LEQ't => (twice (twice (twice (twice (twice_plus_one Int31.In))))) | LONG't => (twice_plus_one (twice (twice (twice (twice_plus_one Int31.In))))) | LPAREN't => (twice (twice_plus_one (twice (twice (twice_plus_one Int31.In))))) | LT't => (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one Int31.In))))) | MINUS't => (twice (twice (twice_plus_one (twice (twice_plus_one Int31.In))))) | MOD_ASSIGN't => (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one Int31.In))))) | MUL_ASSIGN't => (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In))))) | NEQ't => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In))))) | OR_ASSIGN't => (twice (twice (twice (twice_plus_one (twice_plus_one Int31.In))))) | OTHER_NAME't => (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one Int31.In))))) | PACKED't => (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In))))) | PERCENT't => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In))))) | PLUS't => (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))) | PRAGMA't => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))) | PTR't => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))) | QUESTION't => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))) | RBRACE't => (twice (twice (twice (twice (twice (twice Int31.In)))))) | RBRACK't => (twice_plus_one (twice (twice (twice (twice (twice Int31.In)))))) | REGISTER't => (twice (twice_plus_one (twice (twice (twice (twice Int31.In)))))) | RESTRICT't => (twice_plus_one (twice_plus_one (twice (twice (twice (twice Int31.In)))))) | RETURN't => (twice (twice (twice_plus_one (twice (twice (twice Int31.In)))))) | RIGHT't => (twice_plus_one (twice (twice_plus_one (twice (twice (twice Int31.In)))))) | RIGHT_ASSIGN't => (twice (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In)))))) | RPAREN't => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In)))))) | SEMICOLON't => (twice (twice (twice (twice_plus_one (twice (twice Int31.In)))))) | SHORT't => (twice_plus_one (twice (twice (twice_plus_one (twice (twice Int31.In)))))) | SIGNED't => (twice (twice_plus_one (twice (twice_plus_one (twice (twice Int31.In)))))) | SIZEOF't => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice Int31.In)))))) | SLASH't => (twice (twice (twice_plus_one (twice_plus_one (twice (twice Int31.In)))))) | STAR't => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice Int31.In)))))) | STATIC't => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice Int31.In)))))) | STRING_LITERAL't => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice Int31.In)))))) | STRUCT't => (twice (twice (twice (twice (twice_plus_one (twice Int31.In)))))) | SUB_ASSIGN't => (twice_plus_one (twice (twice (twice (twice_plus_one (twice Int31.In)))))) | SWITCH't => (twice (twice_plus_one (twice (twice (twice_plus_one (twice Int31.In)))))) | TILDE't => (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice Int31.In)))))) | TYPEDEF't => (twice (twice (twice_plus_one (twice (twice_plus_one (twice Int31.In)))))) | TYPEDEF_NAME't => (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice Int31.In)))))) | UNDERSCORE_BOOL't => (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice Int31.In)))))) | UNION't => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice Int31.In)))))) | UNSIGNED't => (twice (twice (twice (twice_plus_one (twice_plus_one (twice Int31.In)))))) | VAR_NAME't => (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice Int31.In)))))) | VOID't => (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice Int31.In)))))) | VOLATILE't => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice Int31.In)))))) | WHILE't => (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In)))))) | XOR_ASSIGN't => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In)))))) end;
    surj := (fun n => match n return _ with | 0 => ADD_ASSIGN't | 1 => ALIGNAS't | 2 => ALIGNOF't | 3 => AND't | 4 => ANDAND't | 5 => AND_ASSIGN't | 6 => ASM't | 7 => ATTRIBUTE't | 8 => AUTO't | 9 => BANG't | 10 => BAR't | 11 => BARBAR't | 12 => BREAK't | 13 => BUILTIN_VA_ARG't | 14 => CASE't | 15 => CHAR't | 16 => COLON't | 17 => COMMA't | 18 => CONST't | 19 => CONSTANT't | 20 => CONTINUE't | 21 => DEC't | 22 => DEFAULT't | 23 => DIV_ASSIGN't | 24 => DO't | 25 => DOT't | 26 => DOUBLE't | 27 => ELLIPSIS't | 28 => ELSE't | 29 => ENUM't | 30 => EOF't | 31 => EQ't | 32 => EQEQ't | 33 => EXTERN't | 34 => FLOAT't | 35 => FOR't | 36 => GEQ't | 37 => GOTO't | 38 => GT't | 39 => HAT't | 40 => IF't | 41 => INC't | 42 => INLINE't | 43 => INT't | 44 => LBRACE't | 45 => LBRACK't | 46 => LEFT't | 47 => LEFT_ASSIGN't | 48 => LEQ't | 49 => LONG't | 50 => LPAREN't | 51 => LT't | 52 => MINUS't | 53 => MOD_ASSIGN't | 54 => MUL_ASSIGN't | 55 => NEQ't | 56 => OR_ASSIGN't | 57 => OTHER_NAME't | 58 => PACKED't | 59 => PERCENT't | 60 => PLUS't | 61 => PRAGMA't | 62 => PTR't | 63 => QUESTION't | 64 => RBRACE't | 65 => RBRACK't | 66 => REGISTER't | 67 => RESTRICT't | 68 => RETURN't | 69 => RIGHT't | 70 => RIGHT_ASSIGN't | 71 => RPAREN't | 72 => SEMICOLON't | 73 => SHORT't | 74 => SIGNED't | 75 => SIZEOF't | 76 => SLASH't | 77 => STAR't | 78 => STATIC't | 79 => STRING_LITERAL't | 80 => STRUCT't | 81 => SUB_ASSIGN't | 82 => SWITCH't | 83 => TILDE't | 84 => TYPEDEF't | 85 => TYPEDEF_NAME't | 86 => UNDERSCORE_BOOL't | 87 => UNION't | 88 => UNSIGNED't | 89 => VAR_NAME't | 90 => VOID't | 91 => VOLATILE't | 92 => WHILE't | 93 => XOR_ASSIGN't | _ => ADD_ASSIGN't end)%int31;
  inj_bound := 94%int31 }.
Solve Obligations using (intro x; case x; reflexivity).

Instance TerminalAlph : Alphabet terminal := _.

Inductive nonterminal' : Set :=
  | AND_expression'nt
  | abstract_declarator'nt
  | additive_expression'nt
  | argument_expression_list'nt
  | asm_arguments'nt
  | asm_attributes'nt
  | asm_flags'nt
  | asm_op_name'nt
  | asm_operand'nt
  | asm_operands'nt
  | asm_operands_ne'nt
  | asm_statement'nt
  | assignment_expression'nt
  | assignment_operator'nt
  | attribute_specifier'nt
  | attribute_specifier_list'nt
  | block_item'nt
  | block_item_list'nt
  | c_initializer'nt
  | cast_expression'nt
  | compound_statement'nt
  | conditional_expression'nt
  | constant_expression'nt
  | declaration'nt
  | declaration_list'nt
  | declaration_specifiers'nt
  | declarator'nt
  | designation'nt
  | designator'nt
  | designator_list'nt
  | direct_abstract_declarator'nt
  | direct_declarator'nt
  | direct_old_function_declarator'nt
  | enum_specifier'nt
  | enumeration_constant'nt
  | enumerator'nt
  | enumerator_list'nt
  | equality_expression'nt
  | exclusive_OR_expression'nt
  | expression'nt
  | expression_statement'nt
  | external_declaration'nt
  | function_definition'nt
  | function_specifier'nt
  | gcc_attribute'nt
  | gcc_attribute_list'nt
  | gcc_attribute_word'nt
  | identifier_list'nt
  | inclusive_OR_expression'nt
  | init_declarator'nt
  | init_declarator_list'nt
  | initializer_list'nt
  | iteration_statement_statement_dangerous_'nt
  | iteration_statement_statement_safe_'nt
  | jump_statement'nt
  | labeled_statement_statement_dangerous_'nt
  | labeled_statement_statement_safe_'nt
  | logical_AND_expression'nt
  | logical_OR_expression'nt
  | multiplicative_expression'nt
  | old_function_declarator'nt
  | parameter_declaration'nt
  | parameter_list'nt
  | parameter_type_list'nt
  | pointer'nt
  | postfix_expression'nt
  | primary_expression'nt
  | relational_expression'nt
  | selection_statement_dangerous'nt
  | selection_statement_safe'nt
  | shift_expression'nt
  | specifier_qualifier_list'nt
  | statement_dangerous'nt
  | statement_safe'nt
  | storage_class_specifier'nt
  | struct_declaration'nt
  | struct_declaration_list'nt
  | struct_declarator'nt
  | struct_declarator_list'nt
  | struct_or_union'nt
  | struct_or_union_specifier'nt
  | translation_unit'nt
  | translation_unit_file'nt
  | type_name'nt
  | type_qualifier'nt
  | type_qualifier_list'nt
  | type_specifier'nt
  | unary_expression'nt
  | unary_operator'nt.
Definition nonterminal := nonterminal'.

Program Instance nonterminalNum : Numbered nonterminal :=
  { inj := fun x => match x return _ with | AND_expression'nt => Int31.On | abstract_declarator'nt => Int31.In | additive_expression'nt => (twice Int31.In) | argument_expression_list'nt => (twice_plus_one Int31.In) | asm_arguments'nt => (twice (twice Int31.In)) | asm_attributes'nt => (twice_plus_one (twice Int31.In)) | asm_flags'nt => (twice (twice_plus_one Int31.In)) | asm_op_name'nt => (twice_plus_one (twice_plus_one Int31.In)) | asm_operand'nt => (twice (twice (twice Int31.In))) | asm_operands'nt => (twice_plus_one (twice (twice Int31.In))) | asm_operands_ne'nt => (twice (twice_plus_one (twice Int31.In))) | asm_statement'nt => (twice_plus_one (twice_plus_one (twice Int31.In))) | assignment_expression'nt => (twice (twice (twice_plus_one Int31.In))) | assignment_operator'nt => (twice_plus_one (twice (twice_plus_one Int31.In))) | attribute_specifier'nt => (twice (twice_plus_one (twice_plus_one Int31.In))) | attribute_specifier_list'nt => (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))) | block_item'nt => (twice (twice (twice (twice Int31.In)))) | block_item_list'nt => (twice_plus_one (twice (twice (twice Int31.In)))) | c_initializer'nt => (twice (twice_plus_one (twice (twice Int31.In)))) | cast_expression'nt => (twice_plus_one (twice_plus_one (twice (twice Int31.In)))) | compound_statement'nt => (twice (twice (twice_plus_one (twice Int31.In)))) | conditional_expression'nt => (twice_plus_one (twice (twice_plus_one (twice Int31.In)))) | constant_expression'nt => (twice (twice_plus_one (twice_plus_one (twice Int31.In)))) | declaration'nt => (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In)))) | declaration_list'nt => (twice (twice (twice (twice_plus_one Int31.In)))) | declaration_specifiers'nt => (twice_plus_one (twice (twice (twice_plus_one Int31.In)))) | declarator'nt => (twice (twice_plus_one (twice (twice_plus_one Int31.In)))) | designation'nt => (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In)))) | designator'nt => (twice (twice (twice_plus_one (twice_plus_one Int31.In)))) | designator_list'nt => (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In)))) | direct_abstract_declarator'nt => (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))) | direct_declarator'nt => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))) | direct_old_function_declarator'nt => (twice (twice (twice (twice (twice Int31.In))))) | enum_specifier'nt => (twice_plus_one (twice (twice (twice (twice Int31.In))))) | enumeration_constant'nt => (twice (twice_plus_one (twice (twice (twice Int31.In))))) | enumerator'nt => (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In))))) | enumerator_list'nt => (twice (twice (twice_plus_one (twice (twice Int31.In))))) | equality_expression'nt => (twice_plus_one (twice (twice_plus_one (twice (twice Int31.In))))) | exclusive_OR_expression'nt => (twice (twice_plus_one (twice_plus_one (twice (twice Int31.In))))) | expression'nt => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice Int31.In))))) | expression_statement'nt => (twice (twice (twice (twice_plus_one (twice Int31.In))))) | external_declaration'nt => (twice_plus_one (twice (twice (twice_plus_one (twice Int31.In))))) | function_definition'nt => (twice (twice_plus_one (twice (twice_plus_one (twice Int31.In))))) | function_specifier'nt => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice Int31.In))))) | gcc_attribute'nt => (twice (twice (twice_plus_one (twice_plus_one (twice Int31.In))))) | gcc_attribute_list'nt => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice Int31.In))))) | gcc_attribute_word'nt => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In))))) | identifier_list'nt => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In))))) | inclusive_OR_expression'nt => (twice (twice (twice (twice (twice_plus_one Int31.In))))) | init_declarator'nt => (twice_plus_one (twice (twice (twice (twice_plus_one Int31.In))))) | init_declarator_list'nt => (twice (twice_plus_one (twice (twice (twice_plus_one Int31.In))))) | initializer_list'nt => (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one Int31.In))))) | iteration_statement_statement_dangerous_'nt => (twice (twice (twice_plus_one (twice (twice_plus_one Int31.In))))) | iteration_statement_statement_safe_'nt => (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one Int31.In))))) | jump_statement'nt => (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In))))) | labeled_statement_statement_dangerous_'nt => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In))))) | labeled_statement_statement_safe_'nt => (twice (twice (twice (twice_plus_one (twice_plus_one Int31.In))))) | logical_AND_expression'nt => (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one Int31.In))))) | logical_OR_expression'nt => (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In))))) | multiplicative_expression'nt => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In))))) | old_function_declarator'nt => (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))) | parameter_declaration'nt => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))) | parameter_list'nt => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))) | parameter_type_list'nt => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))) | pointer'nt => (twice (twice (twice (twice (twice (twice Int31.In)))))) | postfix_expression'nt => (twice_plus_one (twice (twice (twice (twice (twice Int31.In)))))) | primary_expression'nt => (twice (twice_plus_one (twice (twice (twice (twice Int31.In)))))) | relational_expression'nt => (twice_plus_one (twice_plus_one (twice (twice (twice (twice Int31.In)))))) | selection_statement_dangerous'nt => (twice (twice (twice_plus_one (twice (twice (twice Int31.In)))))) | selection_statement_safe'nt => (twice_plus_one (twice (twice_plus_one (twice (twice (twice Int31.In)))))) | shift_expression'nt => (twice (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In)))))) | specifier_qualifier_list'nt => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In)))))) | statement_dangerous'nt => (twice (twice (twice (twice_plus_one (twice (twice Int31.In)))))) | statement_safe'nt => (twice_plus_one (twice (twice (twice_plus_one (twice (twice Int31.In)))))) | storage_class_specifier'nt => (twice (twice_plus_one (twice (twice_plus_one (twice (twice Int31.In)))))) | struct_declaration'nt => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice Int31.In)))))) | struct_declaration_list'nt => (twice (twice (twice_plus_one (twice_plus_one (twice (twice Int31.In)))))) | struct_declarator'nt => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice Int31.In)))))) | struct_declarator_list'nt => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice Int31.In)))))) | struct_or_union'nt => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice Int31.In)))))) | struct_or_union_specifier'nt => (twice (twice (twice (twice (twice_plus_one (twice Int31.In)))))) | translation_unit'nt => (twice_plus_one (twice (twice (twice (twice_plus_one (twice Int31.In)))))) | translation_unit_file'nt => (twice (twice_plus_one (twice (twice (twice_plus_one (twice Int31.In)))))) | type_name'nt => (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice Int31.In)))))) | type_qualifier'nt => (twice (twice (twice_plus_one (twice (twice_plus_one (twice Int31.In)))))) | type_qualifier_list'nt => (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice Int31.In)))))) | type_specifier'nt => (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice Int31.In)))))) | unary_expression'nt => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice Int31.In)))))) | unary_operator'nt => (twice (twice (twice (twice_plus_one (twice_plus_one (twice Int31.In)))))) end;
    surj := (fun n => match n return _ with | 0 => AND_expression'nt | 1 => abstract_declarator'nt | 2 => additive_expression'nt | 3 => argument_expression_list'nt | 4 => asm_arguments'nt | 5 => asm_attributes'nt | 6 => asm_flags'nt | 7 => asm_op_name'nt | 8 => asm_operand'nt | 9 => asm_operands'nt | 10 => asm_operands_ne'nt | 11 => asm_statement'nt | 12 => assignment_expression'nt | 13 => assignment_operator'nt | 14 => attribute_specifier'nt | 15 => attribute_specifier_list'nt | 16 => block_item'nt | 17 => block_item_list'nt | 18 => c_initializer'nt | 19 => cast_expression'nt | 20 => compound_statement'nt | 21 => conditional_expression'nt | 22 => constant_expression'nt | 23 => declaration'nt | 24 => declaration_list'nt | 25 => declaration_specifiers'nt | 26 => declarator'nt | 27 => designation'nt | 28 => designator'nt | 29 => designator_list'nt | 30 => direct_abstract_declarator'nt | 31 => direct_declarator'nt | 32 => direct_old_function_declarator'nt | 33 => enum_specifier'nt | 34 => enumeration_constant'nt | 35 => enumerator'nt | 36 => enumerator_list'nt | 37 => equality_expression'nt | 38 => exclusive_OR_expression'nt | 39 => expression'nt | 40 => expression_statement'nt | 41 => external_declaration'nt | 42 => function_definition'nt | 43 => function_specifier'nt | 44 => gcc_attribute'nt | 45 => gcc_attribute_list'nt | 46 => gcc_attribute_word'nt | 47 => identifier_list'nt | 48 => inclusive_OR_expression'nt | 49 => init_declarator'nt | 50 => init_declarator_list'nt | 51 => initializer_list'nt | 52 => iteration_statement_statement_dangerous_'nt | 53 => iteration_statement_statement_safe_'nt | 54 => jump_statement'nt | 55 => labeled_statement_statement_dangerous_'nt | 56 => labeled_statement_statement_safe_'nt | 57 => logical_AND_expression'nt | 58 => logical_OR_expression'nt | 59 => multiplicative_expression'nt | 60 => old_function_declarator'nt | 61 => parameter_declaration'nt | 62 => parameter_list'nt | 63 => parameter_type_list'nt | 64 => pointer'nt | 65 => postfix_expression'nt | 66 => primary_expression'nt | 67 => relational_expression'nt | 68 => selection_statement_dangerous'nt | 69 => selection_statement_safe'nt | 70 => shift_expression'nt | 71 => specifier_qualifier_list'nt | 72 => statement_dangerous'nt | 73 => statement_safe'nt | 74 => storage_class_specifier'nt | 75 => struct_declaration'nt | 76 => struct_declaration_list'nt | 77 => struct_declarator'nt | 78 => struct_declarator_list'nt | 79 => struct_or_union'nt | 80 => struct_or_union_specifier'nt | 81 => translation_unit'nt | 82 => translation_unit_file'nt | 83 => type_name'nt | 84 => type_qualifier'nt | 85 => type_qualifier_list'nt | 86 => type_specifier'nt | 87 => unary_expression'nt | 88 => unary_operator'nt | _ => AND_expression'nt end)%int31;
  inj_bound := 89%int31 }.
Solve Obligations using (intro x; case x; reflexivity).

Instance NonTerminalAlph : Alphabet nonterminal := _.

Include Grammar.Symbol.

Definition terminal_semantic_type (t:terminal) : Type:=
  match t with
    | XOR_ASSIGN't =>       (cabsloc)%type
    | WHILE't =>       (cabsloc)%type
    | VOLATILE't =>       (cabsloc)%type
    | VOID't =>       (cabsloc)%type
    | VAR_NAME't =>       (string * cabsloc)%type
    | UNSIGNED't =>       (cabsloc)%type
    | UNION't =>       (cabsloc)%type
    | UNDERSCORE_BOOL't =>       (cabsloc)%type
    | TYPEDEF_NAME't =>       (string * cabsloc)%type
    | TYPEDEF't =>       (cabsloc)%type
    | TILDE't =>       (cabsloc)%type
    | SWITCH't =>       (cabsloc)%type
    | SUB_ASSIGN't =>       (cabsloc)%type
    | STRUCT't =>       (cabsloc)%type
    | STRING_LITERAL't =>       (bool * list char_code * cabsloc)%type
    | STATIC't =>       (cabsloc)%type
    | STAR't =>       (cabsloc)%type
    | SLASH't =>       (cabsloc)%type
    | SIZEOF't =>       (cabsloc)%type
    | SIGNED't =>       (cabsloc)%type
    | SHORT't =>       (cabsloc)%type
    | SEMICOLON't =>       (cabsloc)%type
    | RPAREN't =>       (cabsloc)%type
    | RIGHT_ASSIGN't =>       (cabsloc)%type
    | RIGHT't =>       (cabsloc)%type
    | RETURN't =>       (cabsloc)%type
    | RESTRICT't =>       (cabsloc)%type
    | REGISTER't =>       (cabsloc)%type
    | RBRACK't =>       (cabsloc)%type
    | RBRACE't =>       (cabsloc)%type
    | QUESTION't =>       (cabsloc)%type
    | PTR't =>       (cabsloc)%type
    | PRAGMA't =>       (string * cabsloc)%type
    | PLUS't =>       (cabsloc)%type
    | PERCENT't =>       (cabsloc)%type
    | PACKED't =>       (cabsloc)%type
    | OTHER_NAME't =>       (string * cabsloc)%type
    | OR_ASSIGN't =>       (cabsloc)%type
    | NEQ't =>       (cabsloc)%type
    | MUL_ASSIGN't =>       (cabsloc)%type
    | MOD_ASSIGN't =>       (cabsloc)%type
    | MINUS't =>       (cabsloc)%type
    | LT't =>       (cabsloc)%type
    | LPAREN't =>       (cabsloc)%type
    | LONG't =>       (cabsloc)%type
    | LEQ't =>       (cabsloc)%type
    | LEFT_ASSIGN't =>       (cabsloc)%type
    | LEFT't =>       (cabsloc)%type
    | LBRACK't =>       (cabsloc)%type
    | LBRACE't =>       (cabsloc)%type
    | INT't =>       (cabsloc)%type
    | INLINE't =>       (cabsloc)%type
    | INC't =>       (cabsloc)%type
    | IF't =>       (cabsloc)%type
    | HAT't =>       (cabsloc)%type
    | GT't =>       (cabsloc)%type
    | GOTO't =>       (cabsloc)%type
    | GEQ't =>       (cabsloc)%type
    | FOR't =>       (cabsloc)%type
    | FLOAT't =>       (cabsloc)%type
    | EXTERN't =>       (cabsloc)%type
    | EQEQ't =>       (cabsloc)%type
    | EQ't =>       (cabsloc)%type
    | EOF't => unit%type
    | ENUM't =>       (cabsloc)%type
    | ELSE't =>       (cabsloc)%type
    | ELLIPSIS't =>       (cabsloc)%type
    | DOUBLE't =>       (cabsloc)%type
    | DOT't =>       (cabsloc)%type
    | DO't =>       (cabsloc)%type
    | DIV_ASSIGN't =>       (cabsloc)%type
    | DEFAULT't =>       (cabsloc)%type
    | DEC't =>       (cabsloc)%type
    | CONTINUE't =>       (cabsloc)%type
    | CONSTANT't =>       (constant * cabsloc)%type
    | CONST't =>       (cabsloc)%type
    | COMMA't =>       (cabsloc)%type
    | COLON't =>       (cabsloc)%type
    | CHAR't =>       (cabsloc)%type
    | CASE't =>       (cabsloc)%type
    | BUILTIN_VA_ARG't =>       (cabsloc)%type
    | BREAK't =>       (cabsloc)%type
    | BARBAR't =>       (cabsloc)%type
    | BAR't =>       (cabsloc)%type
    | BANG't =>       (cabsloc)%type
    | AUTO't =>       (cabsloc)%type
    | ATTRIBUTE't =>       (cabsloc)%type
    | ASM't =>       (cabsloc)%type
    | AND_ASSIGN't =>       (cabsloc)%type
    | ANDAND't =>       (cabsloc)%type
    | AND't =>       (cabsloc)%type
    | ALIGNOF't =>       (cabsloc)%type
    | ALIGNAS't =>       (cabsloc)%type
    | ADD_ASSIGN't =>       (cabsloc)%type
  end.

Definition nonterminal_semantic_type (nt:nonterminal) : Type:=
  match nt with
    | unary_operator'nt =>      (unary_operator * cabsloc)%type
    | unary_expression'nt =>      (expression * cabsloc)%type
    | type_specifier'nt =>      (typeSpecifier * cabsloc)%type
    | type_qualifier_list'nt =>      (list cvspec (* Reverse order *))%type
    | type_qualifier'nt =>      (cvspec * cabsloc)%type
    | type_name'nt =>      (list spec_elem * decl_type)%type
    | translation_unit_file'nt =>       (list definition)%type
    | translation_unit'nt =>      (list definition (* Reverse order *))%type
    | struct_or_union_specifier'nt =>      (typeSpecifier * cabsloc)%type
    | struct_or_union'nt =>      (structOrUnion * cabsloc)%type
    | struct_declarator_list'nt =>      (list (option name * option expression) (* Reverse order *))%type
    | struct_declarator'nt =>      (option name * option expression)%type
    | struct_declaration_list'nt =>      (list field_group (* Reverse order *))%type
    | struct_declaration'nt =>      (field_group)%type
    | storage_class_specifier'nt =>      (storage * cabsloc)%type
    | statement_safe'nt =>      (statement)%type
    | statement_dangerous'nt =>      (statement)%type
    | specifier_qualifier_list'nt =>      (list spec_elem * cabsloc)%type
    | shift_expression'nt =>      (expression * cabsloc)%type
    | selection_statement_safe'nt =>      (statement)%type
    | selection_statement_dangerous'nt =>      (statement)%type
    | relational_expression'nt =>      (expression * cabsloc)%type
    | primary_expression'nt =>      (expression * cabsloc)%type
    | postfix_expression'nt =>      (expression * cabsloc)%type
    | pointer'nt =>      ((decl_type -> decl_type) * cabsloc)%type
    | parameter_type_list'nt =>      (list parameter * bool)%type
    | parameter_list'nt =>      (list parameter (* Reverse order *))%type
    | parameter_declaration'nt =>      (parameter)%type
    | old_function_declarator'nt =>      (name * list string)%type
    | multiplicative_expression'nt =>      (expression * cabsloc)%type
    | logical_OR_expression'nt =>      (expression * cabsloc)%type
    | logical_AND_expression'nt =>      (expression * cabsloc)%type
    | labeled_statement_statement_safe_'nt =>      (statement)%type
    | labeled_statement_statement_dangerous_'nt =>      (statement)%type
    | jump_statement'nt =>      (statement)%type
    | iteration_statement_statement_safe_'nt =>      (statement)%type
    | iteration_statement_statement_dangerous_'nt =>      (statement)%type
    | initializer_list'nt =>      (list (list initwhat * init_expression) (* Reverse order *))%type
    | init_declarator_list'nt =>      (list init_name (* Reverse order *))%type
    | init_declarator'nt =>      (init_name)%type
    | inclusive_OR_expression'nt =>      (expression * cabsloc)%type
    | identifier_list'nt =>      (list string (* Reverse order *))%type
    | gcc_attribute_word'nt =>      (gcc_attribute_word)%type
    | gcc_attribute_list'nt =>      (list gcc_attribute)%type
    | gcc_attribute'nt =>      (gcc_attribute)%type
    | function_specifier'nt =>      (cabsloc)%type
    | function_definition'nt =>      (definition)%type
    | external_declaration'nt =>      (definition)%type
    | expression_statement'nt =>      (statement)%type
    | expression'nt =>      (expression * cabsloc)%type
    | exclusive_OR_expression'nt =>      (expression * cabsloc)%type
    | equality_expression'nt =>      (expression * cabsloc)%type
    | enumerator_list'nt =>      (list (string * option expression * cabsloc) (* Reverse order *))%type
    | enumerator'nt =>      (string * option expression * cabsloc)%type
    | enumeration_constant'nt =>      (string * cabsloc)%type
    | enum_specifier'nt =>      (typeSpecifier * cabsloc)%type
    | direct_old_function_declarator'nt =>      (name * list string)%type
    | direct_declarator'nt =>      (name)%type
    | direct_abstract_declarator'nt =>      (decl_type)%type
    | designator_list'nt =>      (list initwhat (* Reverse order *))%type
    | designator'nt =>      (initwhat)%type
    | designation'nt =>      (list initwhat)%type
    | declarator'nt =>      (name)%type
    | declaration_specifiers'nt =>      (list spec_elem * cabsloc)%type
    | declaration_list'nt =>      (list definition)%type
    | declaration'nt =>      (definition)%type
    | constant_expression'nt =>      (expression * cabsloc)%type
    | conditional_expression'nt =>      (expression * cabsloc)%type
    | compound_statement'nt =>      (statement)%type
    | cast_expression'nt =>      (expression * cabsloc)%type
    | c_initializer'nt =>      (init_expression)%type
    | block_item_list'nt =>      (list statement (* Reverse order *))%type
    | block_item'nt =>      (statement)%type
    | attribute_specifier_list'nt =>      (list attribute)%type
    | attribute_specifier'nt =>      (attribute * cabsloc)%type
    | assignment_operator'nt =>      (binary_operator)%type
    | assignment_expression'nt =>      (expression * cabsloc)%type
    | asm_statement'nt =>      (statement)%type
    | asm_operands_ne'nt =>      (list asm_operand)%type
    | asm_operands'nt =>      (list asm_operand)%type
    | asm_operand'nt =>      (asm_operand)%type
    | asm_op_name'nt =>      (option string)%type
    | asm_flags'nt =>      (list asm_flag)%type
    | asm_attributes'nt =>      (list cvspec)%type
    | asm_arguments'nt =>      (list asm_operand * list asm_operand * list asm_flag)%type
    | argument_expression_list'nt =>      (list expression (* Reverse order *))%type
    | additive_expression'nt =>      (expression * cabsloc)%type
    | abstract_declarator'nt =>      (decl_type)%type
    | AND_expression'nt =>      (expression * cabsloc)%type
  end.

Definition symbol_semantic_type (s:symbol) : Type:=
  match s with
    | T t => terminal_semantic_type t
    | NT nt => nonterminal_semantic_type nt
  end.

Inductive production' : Set :=
  | Prod'unary_operator'5
  | Prod'unary_operator'4
  | Prod'unary_operator'3
  | Prod'unary_operator'2
  | Prod'unary_operator'1
  | Prod'unary_operator'0
  | Prod'unary_expression'7
  | Prod'unary_expression'6
  | Prod'unary_expression'5
  | Prod'unary_expression'4
  | Prod'unary_expression'3
  | Prod'unary_expression'2
  | Prod'unary_expression'1
  | Prod'unary_expression'0
  | Prod'type_specifier'12
  | Prod'type_specifier'11
  | Prod'type_specifier'10
  | Prod'type_specifier'9
  | Prod'type_specifier'8
  | Prod'type_specifier'7
  | Prod'type_specifier'6
  | Prod'type_specifier'5
  | Prod'type_specifier'4
  | Prod'type_specifier'3
  | Prod'type_specifier'2
  | Prod'type_specifier'1
  | Prod'type_specifier'0
  | Prod'type_qualifier_list'1
  | Prod'type_qualifier_list'0
  | Prod'type_qualifier'3
  | Prod'type_qualifier'2
  | Prod'type_qualifier'1
  | Prod'type_qualifier'0
  | Prod'type_name'1
  | Prod'type_name'0
  | Prod'translation_unit_file'1
  | Prod'translation_unit_file'0
  | Prod'translation_unit'3
  | Prod'translation_unit'2
  | Prod'translation_unit'1
  | Prod'translation_unit'0
  | Prod'struct_or_union_specifier'2
  | Prod'struct_or_union_specifier'1
  | Prod'struct_or_union_specifier'0
  | Prod'struct_or_union'1
  | Prod'struct_or_union'0
  | Prod'struct_declarator_list'1
  | Prod'struct_declarator_list'0
  | Prod'struct_declarator'2
  | Prod'struct_declarator'1
  | Prod'struct_declarator'0
  | Prod'struct_declaration_list'1
  | Prod'struct_declaration_list'0
  | Prod'struct_declaration'1
  | Prod'struct_declaration'0
  | Prod'storage_class_specifier'4
  | Prod'storage_class_specifier'3
  | Prod'storage_class_specifier'2
  | Prod'storage_class_specifier'1
  | Prod'storage_class_specifier'0
  | Prod'statement_safe'6
  | Prod'statement_safe'5
  | Prod'statement_safe'4
  | Prod'statement_safe'3
  | Prod'statement_safe'2
  | Prod'statement_safe'1
  | Prod'statement_safe'0
  | Prod'statement_dangerous'6
  | Prod'statement_dangerous'5
  | Prod'statement_dangerous'4
  | Prod'statement_dangerous'3
  | Prod'statement_dangerous'2
  | Prod'statement_dangerous'1
  | Prod'statement_dangerous'0
  | Prod'specifier_qualifier_list'3
  | Prod'specifier_qualifier_list'2
  | Prod'specifier_qualifier_list'1
  | Prod'specifier_qualifier_list'0
  | Prod'shift_expression'2
  | Prod'shift_expression'1
  | Prod'shift_expression'0
  | Prod'selection_statement_safe'1
  | Prod'selection_statement_safe'0
  | Prod'selection_statement_dangerous'2
  | Prod'selection_statement_dangerous'1
  | Prod'selection_statement_dangerous'0
  | Prod'relational_expression'4
  | Prod'relational_expression'3
  | Prod'relational_expression'2
  | Prod'relational_expression'1
  | Prod'relational_expression'0
  | Prod'primary_expression'3
  | Prod'primary_expression'2
  | Prod'primary_expression'1
  | Prod'primary_expression'0
  | Prod'postfix_expression'10
  | Prod'postfix_expression'9
  | Prod'postfix_expression'8
  | Prod'postfix_expression'7
  | Prod'postfix_expression'6
  | Prod'postfix_expression'5
  | Prod'postfix_expression'4
  | Prod'postfix_expression'3
  | Prod'postfix_expression'2
  | Prod'postfix_expression'1
  | Prod'postfix_expression'0
  | Prod'pointer'3
  | Prod'pointer'2
  | Prod'pointer'1
  | Prod'pointer'0
  | Prod'parameter_type_list'1
  | Prod'parameter_type_list'0
  | Prod'parameter_list'1
  | Prod'parameter_list'0
  | Prod'parameter_declaration'2
  | Prod'parameter_declaration'1
  | Prod'parameter_declaration'0
  | Prod'old_function_declarator'1
  | Prod'old_function_declarator'0
  | Prod'multiplicative_expression'3
  | Prod'multiplicative_expression'2
  | Prod'multiplicative_expression'1
  | Prod'multiplicative_expression'0
  | Prod'logical_OR_expression'1
  | Prod'logical_OR_expression'0
  | Prod'logical_AND_expression'1
  | Prod'logical_AND_expression'0
  | Prod'labeled_statement_statement_safe_'2
  | Prod'labeled_statement_statement_safe_'1
  | Prod'labeled_statement_statement_safe_'0
  | Prod'labeled_statement_statement_dangerous_'2
  | Prod'labeled_statement_statement_dangerous_'1
  | Prod'labeled_statement_statement_dangerous_'0
  | Prod'jump_statement'4
  | Prod'jump_statement'3
  | Prod'jump_statement'2
  | Prod'jump_statement'1
  | Prod'jump_statement'0
  | Prod'iteration_statement_statement_safe_'13
  | Prod'iteration_statement_statement_safe_'12
  | Prod'iteration_statement_statement_safe_'11
  | Prod'iteration_statement_statement_safe_'10
  | Prod'iteration_statement_statement_safe_'9
  | Prod'iteration_statement_statement_safe_'8
  | Prod'iteration_statement_statement_safe_'7
  | Prod'iteration_statement_statement_safe_'6
  | Prod'iteration_statement_statement_safe_'5
  | Prod'iteration_statement_statement_safe_'4
  | Prod'iteration_statement_statement_safe_'3
  | Prod'iteration_statement_statement_safe_'2
  | Prod'iteration_statement_statement_safe_'1
  | Prod'iteration_statement_statement_safe_'0
  | Prod'iteration_statement_statement_dangerous_'13
  | Prod'iteration_statement_statement_dangerous_'12
  | Prod'iteration_statement_statement_dangerous_'11
  | Prod'iteration_statement_statement_dangerous_'10
  | Prod'iteration_statement_statement_dangerous_'9
  | Prod'iteration_statement_statement_dangerous_'8
  | Prod'iteration_statement_statement_dangerous_'7
  | Prod'iteration_statement_statement_dangerous_'6
  | Prod'iteration_statement_statement_dangerous_'5
  | Prod'iteration_statement_statement_dangerous_'4
  | Prod'iteration_statement_statement_dangerous_'3
  | Prod'iteration_statement_statement_dangerous_'2
  | Prod'iteration_statement_statement_dangerous_'1
  | Prod'iteration_statement_statement_dangerous_'0
  | Prod'initializer_list'3
  | Prod'initializer_list'2
  | Prod'initializer_list'1
  | Prod'initializer_list'0
  | Prod'init_declarator_list'1
  | Prod'init_declarator_list'0
  | Prod'init_declarator'1
  | Prod'init_declarator'0
  | Prod'inclusive_OR_expression'1
  | Prod'inclusive_OR_expression'0
  | Prod'identifier_list'1
  | Prod'identifier_list'0
  | Prod'gcc_attribute_word'2
  | Prod'gcc_attribute_word'1
  | Prod'gcc_attribute_word'0
  | Prod'gcc_attribute_list'1
  | Prod'gcc_attribute_list'0
  | Prod'gcc_attribute'3
  | Prod'gcc_attribute'2
  | Prod'gcc_attribute'1
  | Prod'gcc_attribute'0
  | Prod'function_specifier'0
  | Prod'function_definition'1
  | Prod'function_definition'0
  | Prod'external_declaration'2
  | Prod'external_declaration'1
  | Prod'external_declaration'0
  | Prod'expression_statement'1
  | Prod'expression_statement'0
  | Prod'expression'1
  | Prod'expression'0
  | Prod'exclusive_OR_expression'1
  | Prod'exclusive_OR_expression'0
  | Prod'equality_expression'2
  | Prod'equality_expression'1
  | Prod'equality_expression'0
  | Prod'enumerator_list'1
  | Prod'enumerator_list'0
  | Prod'enumerator'1
  | Prod'enumerator'0
  | Prod'enumeration_constant'0
  | Prod'enum_specifier'4
  | Prod'enum_specifier'3
  | Prod'enum_specifier'2
  | Prod'enum_specifier'1
  | Prod'enum_specifier'0
  | Prod'direct_old_function_declarator'0
  | Prod'direct_declarator'7
  | Prod'direct_declarator'6
  | Prod'direct_declarator'5
  | Prod'direct_declarator'4
  | Prod'direct_declarator'3
  | Prod'direct_declarator'2
  | Prod'direct_declarator'1
  | Prod'direct_declarator'0
  | Prod'direct_abstract_declarator'12
  | Prod'direct_abstract_declarator'11
  | Prod'direct_abstract_declarator'10
  | Prod'direct_abstract_declarator'9
  | Prod'direct_abstract_declarator'8
  | Prod'direct_abstract_declarator'7
  | Prod'direct_abstract_declarator'6
  | Prod'direct_abstract_declarator'5
  | Prod'direct_abstract_declarator'4
  | Prod'direct_abstract_declarator'3
  | Prod'direct_abstract_declarator'2
  | Prod'direct_abstract_declarator'1
  | Prod'direct_abstract_declarator'0
  | Prod'designator_list'1
  | Prod'designator_list'0
  | Prod'designator'1
  | Prod'designator'0
  | Prod'designation'0
  | Prod'declarator'1
  | Prod'declarator'0
  | Prod'declaration_specifiers'7
  | Prod'declaration_specifiers'6
  | Prod'declaration_specifiers'5
  | Prod'declaration_specifiers'4
  | Prod'declaration_specifiers'3
  | Prod'declaration_specifiers'2
  | Prod'declaration_specifiers'1
  | Prod'declaration_specifiers'0
  | Prod'declaration_list'1
  | Prod'declaration_list'0
  | Prod'declaration'1
  | Prod'declaration'0
  | Prod'constant_expression'0
  | Prod'conditional_expression'1
  | Prod'conditional_expression'0
  | Prod'compound_statement'1
  | Prod'compound_statement'0
  | Prod'cast_expression'1
  | Prod'cast_expression'0
  | Prod'c_initializer'2
  | Prod'c_initializer'1
  | Prod'c_initializer'0
  | Prod'block_item_list'1
  | Prod'block_item_list'0
  | Prod'block_item'2
  | Prod'block_item'1
  | Prod'block_item'0
  | Prod'attribute_specifier_list'1
  | Prod'attribute_specifier_list'0
  | Prod'attribute_specifier'3
  | Prod'attribute_specifier'2
  | Prod'attribute_specifier'1
  | Prod'attribute_specifier'0
  | Prod'assignment_operator'10
  | Prod'assignment_operator'9
  | Prod'assignment_operator'8
  | Prod'assignment_operator'7
  | Prod'assignment_operator'6
  | Prod'assignment_operator'5
  | Prod'assignment_operator'4
  | Prod'assignment_operator'3
  | Prod'assignment_operator'2
  | Prod'assignment_operator'1
  | Prod'assignment_operator'0
  | Prod'assignment_expression'1
  | Prod'assignment_expression'0
  | Prod'asm_statement'0
  | Prod'asm_operands_ne'1
  | Prod'asm_operands_ne'0
  | Prod'asm_operands'1
  | Prod'asm_operands'0
  | Prod'asm_operand'0
  | Prod'asm_op_name'1
  | Prod'asm_op_name'0
  | Prod'asm_flags'1
  | Prod'asm_flags'0
  | Prod'asm_attributes'2
  | Prod'asm_attributes'1
  | Prod'asm_attributes'0
  | Prod'asm_arguments'3
  | Prod'asm_arguments'2
  | Prod'asm_arguments'1
  | Prod'asm_arguments'0
  | Prod'argument_expression_list'1
  | Prod'argument_expression_list'0
  | Prod'additive_expression'2
  | Prod'additive_expression'1
  | Prod'additive_expression'0
  | Prod'abstract_declarator'2
  | Prod'abstract_declarator'1
  | Prod'abstract_declarator'0
  | Prod'AND_expression'1
  | Prod'AND_expression'0.
Definition production := production'.

Program Instance productionNum : Numbered production :=
  { inj := fun x => match x return _ with | Prod'unary_operator'5 => Int31.On | Prod'unary_operator'4 => Int31.In | Prod'unary_operator'3 => (twice Int31.In) | Prod'unary_operator'2 => (twice_plus_one Int31.In) | Prod'unary_operator'1 => (twice (twice Int31.In)) | Prod'unary_operator'0 => (twice_plus_one (twice Int31.In)) | Prod'unary_expression'7 => (twice (twice_plus_one Int31.In)) | Prod'unary_expression'6 => (twice_plus_one (twice_plus_one Int31.In)) | Prod'unary_expression'5 => (twice (twice (twice Int31.In))) | Prod'unary_expression'4 => (twice_plus_one (twice (twice Int31.In))) | Prod'unary_expression'3 => (twice (twice_plus_one (twice Int31.In))) | Prod'unary_expression'2 => (twice_plus_one (twice_plus_one (twice Int31.In))) | Prod'unary_expression'1 => (twice (twice (twice_plus_one Int31.In))) | Prod'unary_expression'0 => (twice_plus_one (twice (twice_plus_one Int31.In))) | Prod'type_specifier'12 => (twice (twice_plus_one (twice_plus_one Int31.In))) | Prod'type_specifier'11 => (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))) | Prod'type_specifier'10 => (twice (twice (twice (twice Int31.In)))) | Prod'type_specifier'9 => (twice_plus_one (twice (twice (twice Int31.In)))) | Prod'type_specifier'8 => (twice (twice_plus_one (twice (twice Int31.In)))) | Prod'type_specifier'7 => (twice_plus_one (twice_plus_one (twice (twice Int31.In)))) | Prod'type_specifier'6 => (twice (twice (twice_plus_one (twice Int31.In)))) | Prod'type_specifier'5 => (twice_plus_one (twice (twice_plus_one (twice Int31.In)))) | Prod'type_specifier'4 => (twice (twice_plus_one (twice_plus_one (twice Int31.In)))) | Prod'type_specifier'3 => (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In)))) | Prod'type_specifier'2 => (twice (twice (twice (twice_plus_one Int31.In)))) | Prod'type_specifier'1 => (twice_plus_one (twice (twice (twice_plus_one Int31.In)))) | Prod'type_specifier'0 => (twice (twice_plus_one (twice (twice_plus_one Int31.In)))) | Prod'type_qualifier_list'1 => (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In)))) | Prod'type_qualifier_list'0 => (twice (twice (twice_plus_one (twice_plus_one Int31.In)))) | Prod'type_qualifier'3 => (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In)))) | Prod'type_qualifier'2 => (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))) | Prod'type_qualifier'1 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))) | Prod'type_qualifier'0 => (twice (twice (twice (twice (twice Int31.In))))) | Prod'type_name'1 => (twice_plus_one (twice (twice (twice (twice Int31.In))))) | Prod'type_name'0 => (twice (twice_plus_one (twice (twice (twice Int31.In))))) | Prod'translation_unit_file'1 => (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In))))) | Prod'translation_unit_file'0 => (twice (twice (twice_plus_one (twice (twice Int31.In))))) | Prod'translation_unit'3 => (twice_plus_one (twice (twice_plus_one (twice (twice Int31.In))))) | Prod'translation_unit'2 => (twice (twice_plus_one (twice_plus_one (twice (twice Int31.In))))) | Prod'translation_unit'1 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice Int31.In))))) | Prod'translation_unit'0 => (twice (twice (twice (twice_plus_one (twice Int31.In))))) | Prod'struct_or_union_specifier'2 => (twice_plus_one (twice (twice (twice_plus_one (twice Int31.In))))) | Prod'struct_or_union_specifier'1 => (twice (twice_plus_one (twice (twice_plus_one (twice Int31.In))))) | Prod'struct_or_union_specifier'0 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice Int31.In))))) | Prod'struct_or_union'1 => (twice (twice (twice_plus_one (twice_plus_one (twice Int31.In))))) | Prod'struct_or_union'0 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice Int31.In))))) | Prod'struct_declarator_list'1 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In))))) | Prod'struct_declarator_list'0 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In))))) | Prod'struct_declarator'2 => (twice (twice (twice (twice (twice_plus_one Int31.In))))) | Prod'struct_declarator'1 => (twice_plus_one (twice (twice (twice (twice_plus_one Int31.In))))) | Prod'struct_declarator'0 => (twice (twice_plus_one (twice (twice (twice_plus_one Int31.In))))) | Prod'struct_declaration_list'1 => (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one Int31.In))))) | Prod'struct_declaration_list'0 => (twice (twice (twice_plus_one (twice (twice_plus_one Int31.In))))) | Prod'struct_declaration'1 => (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one Int31.In))))) | Prod'struct_declaration'0 => (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In))))) | Prod'storage_class_specifier'4 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In))))) | Prod'storage_class_specifier'3 => (twice (twice (twice (twice_plus_one (twice_plus_one Int31.In))))) | Prod'storage_class_specifier'2 => (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one Int31.In))))) | Prod'storage_class_specifier'1 => (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In))))) | Prod'storage_class_specifier'0 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In))))) | Prod'statement_safe'6 => (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))) | Prod'statement_safe'5 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))) | Prod'statement_safe'4 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))) | Prod'statement_safe'3 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))) | Prod'statement_safe'2 => (twice (twice (twice (twice (twice (twice Int31.In)))))) | Prod'statement_safe'1 => (twice_plus_one (twice (twice (twice (twice (twice Int31.In)))))) | Prod'statement_safe'0 => (twice (twice_plus_one (twice (twice (twice (twice Int31.In)))))) | Prod'statement_dangerous'6 => (twice_plus_one (twice_plus_one (twice (twice (twice (twice Int31.In)))))) | Prod'statement_dangerous'5 => (twice (twice (twice_plus_one (twice (twice (twice Int31.In)))))) | Prod'statement_dangerous'4 => (twice_plus_one (twice (twice_plus_one (twice (twice (twice Int31.In)))))) | Prod'statement_dangerous'3 => (twice (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In)))))) | Prod'statement_dangerous'2 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In)))))) | Prod'statement_dangerous'1 => (twice (twice (twice (twice_plus_one (twice (twice Int31.In)))))) | Prod'statement_dangerous'0 => (twice_plus_one (twice (twice (twice_plus_one (twice (twice Int31.In)))))) | Prod'specifier_qualifier_list'3 => (twice (twice_plus_one (twice (twice_plus_one (twice (twice Int31.In)))))) | Prod'specifier_qualifier_list'2 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice Int31.In)))))) | Prod'specifier_qualifier_list'1 => (twice (twice (twice_plus_one (twice_plus_one (twice (twice Int31.In)))))) | Prod'specifier_qualifier_list'0 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice Int31.In)))))) | Prod'shift_expression'2 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice Int31.In)))))) | Prod'shift_expression'1 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice Int31.In)))))) | Prod'shift_expression'0 => (twice (twice (twice (twice (twice_plus_one (twice Int31.In)))))) | Prod'selection_statement_safe'1 => (twice_plus_one (twice (twice (twice (twice_plus_one (twice Int31.In)))))) | Prod'selection_statement_safe'0 => (twice (twice_plus_one (twice (twice (twice_plus_one (twice Int31.In)))))) | Prod'selection_statement_dangerous'2 => (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice Int31.In)))))) | Prod'selection_statement_dangerous'1 => (twice (twice (twice_plus_one (twice (twice_plus_one (twice Int31.In)))))) | Prod'selection_statement_dangerous'0 => (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice Int31.In)))))) | Prod'relational_expression'4 => (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice Int31.In)))))) | Prod'relational_expression'3 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice Int31.In)))))) | Prod'relational_expression'2 => (twice (twice (twice (twice_plus_one (twice_plus_one (twice Int31.In)))))) | Prod'relational_expression'1 => (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice Int31.In)))))) | Prod'relational_expression'0 => (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice Int31.In)))))) | Prod'primary_expression'3 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice Int31.In)))))) | Prod'primary_expression'2 => (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In)))))) | Prod'primary_expression'1 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In)))))) | Prod'primary_expression'0 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In)))))) | Prod'postfix_expression'10 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In)))))) | Prod'postfix_expression'9 => (twice (twice (twice (twice (twice (twice_plus_one Int31.In)))))) | Prod'postfix_expression'8 => (twice_plus_one (twice (twice (twice (twice (twice_plus_one Int31.In)))))) | Prod'postfix_expression'7 => (twice (twice_plus_one (twice (twice (twice (twice_plus_one Int31.In)))))) | Prod'postfix_expression'6 => (twice_plus_one (twice_plus_one (twice (twice (twice (twice_plus_one Int31.In)))))) | Prod'postfix_expression'5 => (twice (twice (twice_plus_one (twice (twice (twice_plus_one Int31.In)))))) | Prod'postfix_expression'4 => (twice_plus_one (twice (twice_plus_one (twice (twice (twice_plus_one Int31.In)))))) | Prod'postfix_expression'3 => (twice (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one Int31.In)))))) | Prod'postfix_expression'2 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one Int31.In)))))) | Prod'postfix_expression'1 => (twice (twice (twice (twice_plus_one (twice (twice_plus_one Int31.In)))))) | Prod'postfix_expression'0 => (twice_plus_one (twice (twice (twice_plus_one (twice (twice_plus_one Int31.In)))))) | Prod'pointer'3 => (twice (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one Int31.In)))))) | Prod'pointer'2 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one Int31.In)))))) | Prod'pointer'1 => (twice (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In)))))) | Prod'pointer'0 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In)))))) | Prod'parameter_type_list'1 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In)))))) | Prod'parameter_type_list'0 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In)))))) | Prod'parameter_list'1 => (twice (twice (twice (twice (twice_plus_one (twice_plus_one Int31.In)))))) | Prod'parameter_list'0 => (twice_plus_one (twice (twice (twice (twice_plus_one (twice_plus_one Int31.In)))))) | Prod'parameter_declaration'2 => (twice (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one Int31.In)))))) | Prod'parameter_declaration'1 => (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one Int31.In)))))) | Prod'parameter_declaration'0 => (twice (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In)))))) | Prod'old_function_declarator'1 => (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In)))))) | Prod'old_function_declarator'0 => (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In)))))) | Prod'multiplicative_expression'3 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In)))))) | Prod'multiplicative_expression'2 => (twice (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))) | Prod'multiplicative_expression'1 => (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))) | Prod'multiplicative_expression'0 => (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))) | Prod'logical_OR_expression'1 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))) | Prod'logical_OR_expression'0 => (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))) | Prod'logical_AND_expression'1 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))) | Prod'logical_AND_expression'0 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))) | Prod'labeled_statement_statement_safe_'2 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))) | Prod'labeled_statement_statement_safe_'1 => (twice (twice (twice (twice (twice (twice (twice Int31.In))))))) | Prod'labeled_statement_statement_safe_'0 => (twice_plus_one (twice (twice (twice (twice (twice (twice Int31.In))))))) | Prod'labeled_statement_statement_dangerous_'2 => (twice (twice_plus_one (twice (twice (twice (twice (twice Int31.In))))))) | Prod'labeled_statement_statement_dangerous_'1 => (twice_plus_one (twice_plus_one (twice (twice (twice (twice (twice Int31.In))))))) | Prod'labeled_statement_statement_dangerous_'0 => (twice (twice (twice_plus_one (twice (twice (twice (twice Int31.In))))))) | Prod'jump_statement'4 => (twice_plus_one (twice (twice_plus_one (twice (twice (twice (twice Int31.In))))))) | Prod'jump_statement'3 => (twice (twice_plus_one (twice_plus_one (twice (twice (twice (twice Int31.In))))))) | Prod'jump_statement'2 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice (twice Int31.In))))))) | Prod'jump_statement'1 => (twice (twice (twice (twice_plus_one (twice (twice (twice Int31.In))))))) | Prod'jump_statement'0 => (twice_plus_one (twice (twice (twice_plus_one (twice (twice (twice Int31.In))))))) | Prod'iteration_statement_statement_safe_'13 => (twice (twice_plus_one (twice (twice_plus_one (twice (twice (twice Int31.In))))))) | Prod'iteration_statement_statement_safe_'12 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice (twice Int31.In))))))) | Prod'iteration_statement_statement_safe_'11 => (twice (twice (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In))))))) | Prod'iteration_statement_statement_safe_'10 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In))))))) | Prod'iteration_statement_statement_safe_'9 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In))))))) | Prod'iteration_statement_statement_safe_'8 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In))))))) | Prod'iteration_statement_statement_safe_'7 => (twice (twice (twice (twice (twice_plus_one (twice (twice Int31.In))))))) | Prod'iteration_statement_statement_safe_'6 => (twice_plus_one (twice (twice (twice (twice_plus_one (twice (twice Int31.In))))))) | Prod'iteration_statement_statement_safe_'5 => (twice (twice_plus_one (twice (twice (twice_plus_one (twice (twice Int31.In))))))) | Prod'iteration_statement_statement_safe_'4 => (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice (twice Int31.In))))))) | Prod'iteration_statement_statement_safe_'3 => (twice (twice (twice_plus_one (twice (twice_plus_one (twice (twice Int31.In))))))) | Prod'iteration_statement_statement_safe_'2 => (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice (twice Int31.In))))))) | Prod'iteration_statement_statement_safe_'1 => (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice Int31.In))))))) | Prod'iteration_statement_statement_safe_'0 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice Int31.In))))))) | Prod'iteration_statement_statement_dangerous_'13 => (twice (twice (twice (twice_plus_one (twice_plus_one (twice (twice Int31.In))))))) | Prod'iteration_statement_statement_dangerous_'12 => (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice (twice Int31.In))))))) | Prod'iteration_statement_statement_dangerous_'11 => (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice Int31.In))))))) | Prod'iteration_statement_statement_dangerous_'10 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice Int31.In))))))) | Prod'iteration_statement_statement_dangerous_'9 => (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice Int31.In))))))) | Prod'iteration_statement_statement_dangerous_'8 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice Int31.In))))))) | Prod'iteration_statement_statement_dangerous_'7 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice Int31.In))))))) | Prod'iteration_statement_statement_dangerous_'6 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice Int31.In))))))) | Prod'iteration_statement_statement_dangerous_'5 => (twice (twice (twice (twice (twice (twice_plus_one (twice Int31.In))))))) | Prod'iteration_statement_statement_dangerous_'4 => (twice_plus_one (twice (twice (twice (twice (twice_plus_one (twice Int31.In))))))) | Prod'iteration_statement_statement_dangerous_'3 => (twice (twice_plus_one (twice (twice (twice (twice_plus_one (twice Int31.In))))))) | Prod'iteration_statement_statement_dangerous_'2 => (twice_plus_one (twice_plus_one (twice (twice (twice (twice_plus_one (twice Int31.In))))))) | Prod'iteration_statement_statement_dangerous_'1 => (twice (twice (twice_plus_one (twice (twice (twice_plus_one (twice Int31.In))))))) | Prod'iteration_statement_statement_dangerous_'0 => (twice_plus_one (twice (twice_plus_one (twice (twice (twice_plus_one (twice Int31.In))))))) | Prod'initializer_list'3 => (twice (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice Int31.In))))))) | Prod'initializer_list'2 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice Int31.In))))))) | Prod'initializer_list'1 => (twice (twice (twice (twice_plus_one (twice (twice_plus_one (twice Int31.In))))))) | Prod'initializer_list'0 => (twice_plus_one (twice (twice (twice_plus_one (twice (twice_plus_one (twice Int31.In))))))) | Prod'init_declarator_list'1 => (twice (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice Int31.In))))))) | Prod'init_declarator_list'0 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice Int31.In))))))) | Prod'init_declarator'1 => (twice (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice Int31.In))))))) | Prod'init_declarator'0 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice Int31.In))))))) | Prod'inclusive_OR_expression'1 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice Int31.In))))))) | Prod'inclusive_OR_expression'0 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice Int31.In))))))) | Prod'identifier_list'1 => (twice (twice (twice (twice (twice_plus_one (twice_plus_one (twice Int31.In))))))) | Prod'identifier_list'0 => (twice_plus_one (twice (twice (twice (twice_plus_one (twice_plus_one (twice Int31.In))))))) | Prod'gcc_attribute_word'2 => (twice (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice Int31.In))))))) | Prod'gcc_attribute_word'1 => (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice Int31.In))))))) | Prod'gcc_attribute_word'0 => (twice (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice Int31.In))))))) | Prod'gcc_attribute_list'1 => (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice Int31.In))))))) | Prod'gcc_attribute_list'0 => (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice Int31.In))))))) | Prod'gcc_attribute'3 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice Int31.In))))))) | Prod'gcc_attribute'2 => (twice (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In))))))) | Prod'gcc_attribute'1 => (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In))))))) | Prod'gcc_attribute'0 => (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In))))))) | Prod'function_specifier'0 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In))))))) | Prod'function_definition'1 => (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In))))))) | Prod'function_definition'0 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In))))))) | Prod'external_declaration'2 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In))))))) | Prod'external_declaration'1 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In))))))) | Prod'external_declaration'0 => (twice (twice (twice (twice (twice (twice (twice_plus_one Int31.In))))))) | Prod'expression_statement'1 => (twice_plus_one (twice (twice (twice (twice (twice (twice_plus_one Int31.In))))))) | Prod'expression_statement'0 => (twice (twice_plus_one (twice (twice (twice (twice (twice_plus_one Int31.In))))))) | Prod'expression'1 => (twice_plus_one (twice_plus_one (twice (twice (twice (twice (twice_plus_one Int31.In))))))) | Prod'expression'0 => (twice (twice (twice_plus_one (twice (twice (twice (twice_plus_one Int31.In))))))) | Prod'exclusive_OR_expression'1 => (twice_plus_one (twice (twice_plus_one (twice (twice (twice (twice_plus_one Int31.In))))))) | Prod'exclusive_OR_expression'0 => (twice (twice_plus_one (twice_plus_one (twice (twice (twice (twice_plus_one Int31.In))))))) | Prod'equality_expression'2 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice (twice_plus_one Int31.In))))))) | Prod'equality_expression'1 => (twice (twice (twice (twice_plus_one (twice (twice (twice_plus_one Int31.In))))))) | Prod'equality_expression'0 => (twice_plus_one (twice (twice (twice_plus_one (twice (twice (twice_plus_one Int31.In))))))) | Prod'enumerator_list'1 => (twice (twice_plus_one (twice (twice_plus_one (twice (twice (twice_plus_one Int31.In))))))) | Prod'enumerator_list'0 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice (twice_plus_one Int31.In))))))) | Prod'enumerator'1 => (twice (twice (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one Int31.In))))))) | Prod'enumerator'0 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one Int31.In))))))) | Prod'enumeration_constant'0 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one Int31.In))))))) | Prod'enum_specifier'4 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one Int31.In))))))) | Prod'enum_specifier'3 => (twice (twice (twice (twice (twice_plus_one (twice (twice_plus_one Int31.In))))))) | Prod'enum_specifier'2 => (twice_plus_one (twice (twice (twice (twice_plus_one (twice (twice_plus_one Int31.In))))))) | Prod'enum_specifier'1 => (twice (twice_plus_one (twice (twice (twice_plus_one (twice (twice_plus_one Int31.In))))))) | Prod'enum_specifier'0 => (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice (twice_plus_one Int31.In))))))) | Prod'direct_old_function_declarator'0 => (twice (twice (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one Int31.In))))))) | Prod'direct_declarator'7 => (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one Int31.In))))))) | Prod'direct_declarator'6 => (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one Int31.In))))))) | Prod'direct_declarator'5 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one Int31.In))))))) | Prod'direct_declarator'4 => (twice (twice (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In))))))) | Prod'direct_declarator'3 => (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In))))))) | Prod'direct_declarator'2 => (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In))))))) | Prod'direct_declarator'1 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In))))))) | Prod'direct_declarator'0 => (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In))))))) | Prod'direct_abstract_declarator'12 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In))))))) | Prod'direct_abstract_declarator'11 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In))))))) | Prod'direct_abstract_declarator'10 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In))))))) | Prod'direct_abstract_declarator'9 => (twice (twice (twice (twice (twice (twice_plus_one (twice_plus_one Int31.In))))))) | Prod'direct_abstract_declarator'8 => (twice_plus_one (twice (twice (twice (twice (twice_plus_one (twice_plus_one Int31.In))))))) | Prod'direct_abstract_declarator'7 => (twice (twice_plus_one (twice (twice (twice (twice_plus_one (twice_plus_one Int31.In))))))) | Prod'direct_abstract_declarator'6 => (twice_plus_one (twice_plus_one (twice (twice (twice (twice_plus_one (twice_plus_one Int31.In))))))) | Prod'direct_abstract_declarator'5 => (twice (twice (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one Int31.In))))))) | Prod'direct_abstract_declarator'4 => (twice_plus_one (twice (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one Int31.In))))))) | Prod'direct_abstract_declarator'3 => (twice (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one Int31.In))))))) | Prod'direct_abstract_declarator'2 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one Int31.In))))))) | Prod'direct_abstract_declarator'1 => (twice (twice (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In))))))) | Prod'direct_abstract_declarator'0 => (twice_plus_one (twice (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In))))))) | Prod'designator_list'1 => (twice (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In))))))) | Prod'designator_list'0 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In))))))) | Prod'designator'1 => (twice (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In))))))) | Prod'designator'0 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In))))))) | Prod'designation'0 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In))))))) | Prod'declarator'1 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In))))))) | Prod'declarator'0 => (twice (twice (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))))) | Prod'declaration_specifiers'7 => (twice_plus_one (twice (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))))) | Prod'declaration_specifiers'6 => (twice (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))))) | Prod'declaration_specifiers'5 => (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))))) | Prod'declaration_specifiers'4 => (twice (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))))) | Prod'declaration_specifiers'3 => (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))))) | Prod'declaration_specifiers'2 => (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))))) | Prod'declaration_specifiers'1 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))))) | Prod'declaration_specifiers'0 => (twice (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))))) | Prod'declaration_list'1 => (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))))) | Prod'declaration_list'0 => (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))))) | Prod'declaration'1 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))))) | Prod'declaration'0 => (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))))) | Prod'constant_expression'0 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))))) | Prod'conditional_expression'1 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))))) | Prod'conditional_expression'0 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))))) | Prod'compound_statement'1 => (twice (twice (twice (twice (twice (twice (twice (twice Int31.In)))))))) | Prod'compound_statement'0 => (twice_plus_one (twice (twice (twice (twice (twice (twice (twice Int31.In)))))))) | Prod'cast_expression'1 => (twice (twice_plus_one (twice (twice (twice (twice (twice (twice Int31.In)))))))) | Prod'cast_expression'0 => (twice_plus_one (twice_plus_one (twice (twice (twice (twice (twice (twice Int31.In)))))))) | Prod'c_initializer'2 => (twice (twice (twice_plus_one (twice (twice (twice (twice (twice Int31.In)))))))) | Prod'c_initializer'1 => (twice_plus_one (twice (twice_plus_one (twice (twice (twice (twice (twice Int31.In)))))))) | Prod'c_initializer'0 => (twice (twice_plus_one (twice_plus_one (twice (twice (twice (twice (twice Int31.In)))))))) | Prod'block_item_list'1 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice (twice (twice Int31.In)))))))) | Prod'block_item_list'0 => (twice (twice (twice (twice_plus_one (twice (twice (twice (twice Int31.In)))))))) | Prod'block_item'2 => (twice_plus_one (twice (twice (twice_plus_one (twice (twice (twice (twice Int31.In)))))))) | Prod'block_item'1 => (twice (twice_plus_one (twice (twice_plus_one (twice (twice (twice (twice Int31.In)))))))) | Prod'block_item'0 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice (twice (twice Int31.In)))))))) | Prod'attribute_specifier_list'1 => (twice (twice (twice_plus_one (twice_plus_one (twice (twice (twice (twice Int31.In)))))))) | Prod'attribute_specifier_list'0 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice (twice (twice Int31.In)))))))) | Prod'attribute_specifier'3 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice (twice Int31.In)))))))) | Prod'attribute_specifier'2 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice (twice Int31.In)))))))) | Prod'attribute_specifier'1 => (twice (twice (twice (twice (twice_plus_one (twice (twice (twice Int31.In)))))))) | Prod'attribute_specifier'0 => (twice_plus_one (twice (twice (twice (twice_plus_one (twice (twice (twice Int31.In)))))))) | Prod'assignment_operator'10 => (twice (twice_plus_one (twice (twice (twice_plus_one (twice (twice (twice Int31.In)))))))) | Prod'assignment_operator'9 => (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice (twice (twice Int31.In)))))))) | Prod'assignment_operator'8 => (twice (twice (twice_plus_one (twice (twice_plus_one (twice (twice (twice Int31.In)))))))) | Prod'assignment_operator'7 => (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice (twice (twice Int31.In)))))))) | Prod'assignment_operator'6 => (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice (twice Int31.In)))))))) | Prod'assignment_operator'5 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice (twice Int31.In)))))))) | Prod'assignment_operator'4 => (twice (twice (twice (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In)))))))) | Prod'assignment_operator'3 => (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In)))))))) | Prod'assignment_operator'2 => (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In)))))))) | Prod'assignment_operator'1 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In)))))))) | Prod'assignment_operator'0 => (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In)))))))) | Prod'assignment_expression'1 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In)))))))) | Prod'assignment_expression'0 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In)))))))) | Prod'asm_statement'0 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In)))))))) | Prod'asm_operands_ne'1 => (twice (twice (twice (twice (twice (twice_plus_one (twice (twice Int31.In)))))))) | Prod'asm_operands_ne'0 => (twice_plus_one (twice (twice (twice (twice (twice_plus_one (twice (twice Int31.In)))))))) | Prod'asm_operands'1 => (twice (twice_plus_one (twice (twice (twice (twice_plus_one (twice (twice Int31.In)))))))) | Prod'asm_operands'0 => (twice_plus_one (twice_plus_one (twice (twice (twice (twice_plus_one (twice (twice Int31.In)))))))) | Prod'asm_operand'0 => (twice (twice (twice_plus_one (twice (twice (twice_plus_one (twice (twice Int31.In)))))))) | Prod'asm_op_name'1 => (twice_plus_one (twice (twice_plus_one (twice (twice (twice_plus_one (twice (twice Int31.In)))))))) | Prod'asm_op_name'0 => (twice (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice (twice Int31.In)))))))) | Prod'asm_flags'1 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice (twice Int31.In)))))))) | Prod'asm_flags'0 => (twice (twice (twice (twice_plus_one (twice (twice_plus_one (twice (twice Int31.In)))))))) | Prod'asm_attributes'2 => (twice_plus_one (twice (twice (twice_plus_one (twice (twice_plus_one (twice (twice Int31.In)))))))) | Prod'asm_attributes'1 => (twice (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice (twice Int31.In)))))))) | Prod'asm_attributes'0 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice (twice Int31.In)))))))) | Prod'asm_arguments'3 => (twice (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice Int31.In)))))))) | Prod'asm_arguments'2 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice Int31.In)))))))) | Prod'asm_arguments'1 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice Int31.In)))))))) | Prod'asm_arguments'0 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice Int31.In)))))))) | Prod'argument_expression_list'1 => (twice (twice (twice (twice (twice_plus_one (twice_plus_one (twice (twice Int31.In)))))))) | Prod'argument_expression_list'0 => (twice_plus_one (twice (twice (twice (twice_plus_one (twice_plus_one (twice (twice Int31.In)))))))) | Prod'additive_expression'2 => (twice (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice (twice Int31.In)))))))) | Prod'additive_expression'1 => (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice (twice Int31.In)))))))) | Prod'additive_expression'0 => (twice (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice Int31.In)))))))) | Prod'abstract_declarator'2 => (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice Int31.In)))))))) | Prod'abstract_declarator'1 => (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice Int31.In)))))))) | Prod'abstract_declarator'0 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice Int31.In)))))))) | Prod'AND_expression'1 => (twice (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice Int31.In)))))))) | Prod'AND_expression'0 => (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice Int31.In)))))))) end;
    surj := (fun n => match n return _ with | 0 => Prod'unary_operator'5 | 1 => Prod'unary_operator'4 | 2 => Prod'unary_operator'3 | 3 => Prod'unary_operator'2 | 4 => Prod'unary_operator'1 | 5 => Prod'unary_operator'0 | 6 => Prod'unary_expression'7 | 7 => Prod'unary_expression'6 | 8 => Prod'unary_expression'5 | 9 => Prod'unary_expression'4 | 10 => Prod'unary_expression'3 | 11 => Prod'unary_expression'2 | 12 => Prod'unary_expression'1 | 13 => Prod'unary_expression'0 | 14 => Prod'type_specifier'12 | 15 => Prod'type_specifier'11 | 16 => Prod'type_specifier'10 | 17 => Prod'type_specifier'9 | 18 => Prod'type_specifier'8 | 19 => Prod'type_specifier'7 | 20 => Prod'type_specifier'6 | 21 => Prod'type_specifier'5 | 22 => Prod'type_specifier'4 | 23 => Prod'type_specifier'3 | 24 => Prod'type_specifier'2 | 25 => Prod'type_specifier'1 | 26 => Prod'type_specifier'0 | 27 => Prod'type_qualifier_list'1 | 28 => Prod'type_qualifier_list'0 | 29 => Prod'type_qualifier'3 | 30 => Prod'type_qualifier'2 | 31 => Prod'type_qualifier'1 | 32 => Prod'type_qualifier'0 | 33 => Prod'type_name'1 | 34 => Prod'type_name'0 | 35 => Prod'translation_unit_file'1 | 36 => Prod'translation_unit_file'0 | 37 => Prod'translation_unit'3 | 38 => Prod'translation_unit'2 | 39 => Prod'translation_unit'1 | 40 => Prod'translation_unit'0 | 41 => Prod'struct_or_union_specifier'2 | 42 => Prod'struct_or_union_specifier'1 | 43 => Prod'struct_or_union_specifier'0 | 44 => Prod'struct_or_union'1 | 45 => Prod'struct_or_union'0 | 46 => Prod'struct_declarator_list'1 | 47 => Prod'struct_declarator_list'0 | 48 => Prod'struct_declarator'2 | 49 => Prod'struct_declarator'1 | 50 => Prod'struct_declarator'0 | 51 => Prod'struct_declaration_list'1 | 52 => Prod'struct_declaration_list'0 | 53 => Prod'struct_declaration'1 | 54 => Prod'struct_declaration'0 | 55 => Prod'storage_class_specifier'4 | 56 => Prod'storage_class_specifier'3 | 57 => Prod'storage_class_specifier'2 | 58 => Prod'storage_class_specifier'1 | 59 => Prod'storage_class_specifier'0 | 60 => Prod'statement_safe'6 | 61 => Prod'statement_safe'5 | 62 => Prod'statement_safe'4 | 63 => Prod'statement_safe'3 | 64 => Prod'statement_safe'2 | 65 => Prod'statement_safe'1 | 66 => Prod'statement_safe'0 | 67 => Prod'statement_dangerous'6 | 68 => Prod'statement_dangerous'5 | 69 => Prod'statement_dangerous'4 | 70 => Prod'statement_dangerous'3 | 71 => Prod'statement_dangerous'2 | 72 => Prod'statement_dangerous'1 | 73 => Prod'statement_dangerous'0 | 74 => Prod'specifier_qualifier_list'3 | 75 => Prod'specifier_qualifier_list'2 | 76 => Prod'specifier_qualifier_list'1 | 77 => Prod'specifier_qualifier_list'0 | 78 => Prod'shift_expression'2 | 79 => Prod'shift_expression'1 | 80 => Prod'shift_expression'0 | 81 => Prod'selection_statement_safe'1 | 82 => Prod'selection_statement_safe'0 | 83 => Prod'selection_statement_dangerous'2 | 84 => Prod'selection_statement_dangerous'1 | 85 => Prod'selection_statement_dangerous'0 | 86 => Prod'relational_expression'4 | 87 => Prod'relational_expression'3 | 88 => Prod'relational_expression'2 | 89 => Prod'relational_expression'1 | 90 => Prod'relational_expression'0 | 91 => Prod'primary_expression'3 | 92 => Prod'primary_expression'2 | 93 => Prod'primary_expression'1 | 94 => Prod'primary_expression'0 | 95 => Prod'postfix_expression'10 | 96 => Prod'postfix_expression'9 | 97 => Prod'postfix_expression'8 | 98 => Prod'postfix_expression'7 | 99 => Prod'postfix_expression'6 | 100 => Prod'postfix_expression'5 | 101 => Prod'postfix_expression'4 | 102 => Prod'postfix_expression'3 | 103 => Prod'postfix_expression'2 | 104 => Prod'postfix_expression'1 | 105 => Prod'postfix_expression'0 | 106 => Prod'pointer'3 | 107 => Prod'pointer'2 | 108 => Prod'pointer'1 | 109 => Prod'pointer'0 | 110 => Prod'parameter_type_list'1 | 111 => Prod'parameter_type_list'0 | 112 => Prod'parameter_list'1 | 113 => Prod'parameter_list'0 | 114 => Prod'parameter_declaration'2 | 115 => Prod'parameter_declaration'1 | 116 => Prod'parameter_declaration'0 | 117 => Prod'old_function_declarator'1 | 118 => Prod'old_function_declarator'0 | 119 => Prod'multiplicative_expression'3 | 120 => Prod'multiplicative_expression'2 | 121 => Prod'multiplicative_expression'1 | 122 => Prod'multiplicative_expression'0 | 123 => Prod'logical_OR_expression'1 | 124 => Prod'logical_OR_expression'0 | 125 => Prod'logical_AND_expression'1 | 126 => Prod'logical_AND_expression'0 | 127 => Prod'labeled_statement_statement_safe_'2 | 128 => Prod'labeled_statement_statement_safe_'1 | 129 => Prod'labeled_statement_statement_safe_'0 | 130 => Prod'labeled_statement_statement_dangerous_'2 | 131 => Prod'labeled_statement_statement_dangerous_'1 | 132 => Prod'labeled_statement_statement_dangerous_'0 | 133 => Prod'jump_statement'4 | 134 => Prod'jump_statement'3 | 135 => Prod'jump_statement'2 | 136 => Prod'jump_statement'1 | 137 => Prod'jump_statement'0 | 138 => Prod'iteration_statement_statement_safe_'13 | 139 => Prod'iteration_statement_statement_safe_'12 | 140 => Prod'iteration_statement_statement_safe_'11 | 141 => Prod'iteration_statement_statement_safe_'10 | 142 => Prod'iteration_statement_statement_safe_'9 | 143 => Prod'iteration_statement_statement_safe_'8 | 144 => Prod'iteration_statement_statement_safe_'7 | 145 => Prod'iteration_statement_statement_safe_'6 | 146 => Prod'iteration_statement_statement_safe_'5 | 147 => Prod'iteration_statement_statement_safe_'4 | 148 => Prod'iteration_statement_statement_safe_'3 | 149 => Prod'iteration_statement_statement_safe_'2 | 150 => Prod'iteration_statement_statement_safe_'1 | 151 => Prod'iteration_statement_statement_safe_'0 | 152 => Prod'iteration_statement_statement_dangerous_'13 | 153 => Prod'iteration_statement_statement_dangerous_'12 | 154 => Prod'iteration_statement_statement_dangerous_'11 | 155 => Prod'iteration_statement_statement_dangerous_'10 | 156 => Prod'iteration_statement_statement_dangerous_'9 | 157 => Prod'iteration_statement_statement_dangerous_'8 | 158 => Prod'iteration_statement_statement_dangerous_'7 | 159 => Prod'iteration_statement_statement_dangerous_'6 | 160 => Prod'iteration_statement_statement_dangerous_'5 | 161 => Prod'iteration_statement_statement_dangerous_'4 | 162 => Prod'iteration_statement_statement_dangerous_'3 | 163 => Prod'iteration_statement_statement_dangerous_'2 | 164 => Prod'iteration_statement_statement_dangerous_'1 | 165 => Prod'iteration_statement_statement_dangerous_'0 | 166 => Prod'initializer_list'3 | 167 => Prod'initializer_list'2 | 168 => Prod'initializer_list'1 | 169 => Prod'initializer_list'0 | 170 => Prod'init_declarator_list'1 | 171 => Prod'init_declarator_list'0 | 172 => Prod'init_declarator'1 | 173 => Prod'init_declarator'0 | 174 => Prod'inclusive_OR_expression'1 | 175 => Prod'inclusive_OR_expression'0 | 176 => Prod'identifier_list'1 | 177 => Prod'identifier_list'0 | 178 => Prod'gcc_attribute_word'2 | 179 => Prod'gcc_attribute_word'1 | 180 => Prod'gcc_attribute_word'0 | 181 => Prod'gcc_attribute_list'1 | 182 => Prod'gcc_attribute_list'0 | 183 => Prod'gcc_attribute'3 | 184 => Prod'gcc_attribute'2 | 185 => Prod'gcc_attribute'1 | 186 => Prod'gcc_attribute'0 | 187 => Prod'function_specifier'0 | 188 => Prod'function_definition'1 | 189 => Prod'function_definition'0 | 190 => Prod'external_declaration'2 | 191 => Prod'external_declaration'1 | 192 => Prod'external_declaration'0 | 193 => Prod'expression_statement'1 | 194 => Prod'expression_statement'0 | 195 => Prod'expression'1 | 196 => Prod'expression'0 | 197 => Prod'exclusive_OR_expression'1 | 198 => Prod'exclusive_OR_expression'0 | 199 => Prod'equality_expression'2 | 200 => Prod'equality_expression'1 | 201 => Prod'equality_expression'0 | 202 => Prod'enumerator_list'1 | 203 => Prod'enumerator_list'0 | 204 => Prod'enumerator'1 | 205 => Prod'enumerator'0 | 206 => Prod'enumeration_constant'0 | 207 => Prod'enum_specifier'4 | 208 => Prod'enum_specifier'3 | 209 => Prod'enum_specifier'2 | 210 => Prod'enum_specifier'1 | 211 => Prod'enum_specifier'0 | 212 => Prod'direct_old_function_declarator'0 | 213 => Prod'direct_declarator'7 | 214 => Prod'direct_declarator'6 | 215 => Prod'direct_declarator'5 | 216 => Prod'direct_declarator'4 | 217 => Prod'direct_declarator'3 | 218 => Prod'direct_declarator'2 | 219 => Prod'direct_declarator'1 | 220 => Prod'direct_declarator'0 | 221 => Prod'direct_abstract_declarator'12 | 222 => Prod'direct_abstract_declarator'11 | 223 => Prod'direct_abstract_declarator'10 | 224 => Prod'direct_abstract_declarator'9 | 225 => Prod'direct_abstract_declarator'8 | 226 => Prod'direct_abstract_declarator'7 | 227 => Prod'direct_abstract_declarator'6 | 228 => Prod'direct_abstract_declarator'5 | 229 => Prod'direct_abstract_declarator'4 | 230 => Prod'direct_abstract_declarator'3 | 231 => Prod'direct_abstract_declarator'2 | 232 => Prod'direct_abstract_declarator'1 | 233 => Prod'direct_abstract_declarator'0 | 234 => Prod'designator_list'1 | 235 => Prod'designator_list'0 | 236 => Prod'designator'1 | 237 => Prod'designator'0 | 238 => Prod'designation'0 | 239 => Prod'declarator'1 | 240 => Prod'declarator'0 | 241 => Prod'declaration_specifiers'7 | 242 => Prod'declaration_specifiers'6 | 243 => Prod'declaration_specifiers'5 | 244 => Prod'declaration_specifiers'4 | 245 => Prod'declaration_specifiers'3 | 246 => Prod'declaration_specifiers'2 | 247 => Prod'declaration_specifiers'1 | 248 => Prod'declaration_specifiers'0 | 249 => Prod'declaration_list'1 | 250 => Prod'declaration_list'0 | 251 => Prod'declaration'1 | 252 => Prod'declaration'0 | 253 => Prod'constant_expression'0 | 254 => Prod'conditional_expression'1 | 255 => Prod'conditional_expression'0 | 256 => Prod'compound_statement'1 | 257 => Prod'compound_statement'0 | 258 => Prod'cast_expression'1 | 259 => Prod'cast_expression'0 | 260 => Prod'c_initializer'2 | 261 => Prod'c_initializer'1 | 262 => Prod'c_initializer'0 | 263 => Prod'block_item_list'1 | 264 => Prod'block_item_list'0 | 265 => Prod'block_item'2 | 266 => Prod'block_item'1 | 267 => Prod'block_item'0 | 268 => Prod'attribute_specifier_list'1 | 269 => Prod'attribute_specifier_list'0 | 270 => Prod'attribute_specifier'3 | 271 => Prod'attribute_specifier'2 | 272 => Prod'attribute_specifier'1 | 273 => Prod'attribute_specifier'0 | 274 => Prod'assignment_operator'10 | 275 => Prod'assignment_operator'9 | 276 => Prod'assignment_operator'8 | 277 => Prod'assignment_operator'7 | 278 => Prod'assignment_operator'6 | 279 => Prod'assignment_operator'5 | 280 => Prod'assignment_operator'4 | 281 => Prod'assignment_operator'3 | 282 => Prod'assignment_operator'2 | 283 => Prod'assignment_operator'1 | 284 => Prod'assignment_operator'0 | 285 => Prod'assignment_expression'1 | 286 => Prod'assignment_expression'0 | 287 => Prod'asm_statement'0 | 288 => Prod'asm_operands_ne'1 | 289 => Prod'asm_operands_ne'0 | 290 => Prod'asm_operands'1 | 291 => Prod'asm_operands'0 | 292 => Prod'asm_operand'0 | 293 => Prod'asm_op_name'1 | 294 => Prod'asm_op_name'0 | 295 => Prod'asm_flags'1 | 296 => Prod'asm_flags'0 | 297 => Prod'asm_attributes'2 | 298 => Prod'asm_attributes'1 | 299 => Prod'asm_attributes'0 | 300 => Prod'asm_arguments'3 | 301 => Prod'asm_arguments'2 | 302 => Prod'asm_arguments'1 | 303 => Prod'asm_arguments'0 | 304 => Prod'argument_expression_list'1 | 305 => Prod'argument_expression_list'0 | 306 => Prod'additive_expression'2 | 307 => Prod'additive_expression'1 | 308 => Prod'additive_expression'0 | 309 => Prod'abstract_declarator'2 | 310 => Prod'abstract_declarator'1 | 311 => Prod'abstract_declarator'0 | 312 => Prod'AND_expression'1 | 313 => Prod'AND_expression'0 | _ => Prod'unary_operator'5 end)%int31;
  inj_bound := 314%int31 }.
Solve Obligations using (intro x; case x; reflexivity).

Instance ProductionAlph : Alphabet production := _.

Definition prod_contents (p:production) :
  { p:nonterminal * list symbol &
    arrows_left (map symbol_semantic_type (rev (snd p)))
                (symbol_semantic_type (NT (fst p))) }
 :=
  let box := existT (fun p =>
    arrows_left (map symbol_semantic_type (rev (snd p)))
                (symbol_semantic_type (NT (fst p))))
  in
  match p with
    | Prod'AND_expression'0 => box
      (AND_expression'nt, [NT equality_expression'nt])
      (fun expr =>
 expr 
)
    | Prod'AND_expression'1 => box
      (AND_expression'nt, [NT equality_expression'nt; T AND't; NT AND_expression'nt])
      (fun expr2 _2 expr1 =>
 (BINARY BAND (fst expr1) (fst expr2), snd expr1) 
)
    | Prod'abstract_declarator'0 => box
      (abstract_declarator'nt, [NT pointer'nt])
      (fun pt =>
 (fst pt) JUSTBASE 
)
    | Prod'abstract_declarator'1 => box
      (abstract_declarator'nt, [NT direct_abstract_declarator'nt; NT pointer'nt])
      (fun typ pt =>
 (fst pt) typ 
)
    | Prod'abstract_declarator'2 => box
      (abstract_declarator'nt, [NT direct_abstract_declarator'nt])
      (fun typ =>
 typ 
)
    | Prod'additive_expression'0 => box
      (additive_expression'nt, [NT multiplicative_expression'nt])
      (fun expr =>
 expr 
)
    | Prod'additive_expression'1 => box
      (additive_expression'nt, [NT multiplicative_expression'nt; T PLUS't; NT additive_expression'nt])
      (fun expr2 _2 expr1 =>
 (BINARY ADD (fst expr1) (fst expr2), snd expr1) 
)
    | Prod'additive_expression'2 => box
      (additive_expression'nt, [NT multiplicative_expression'nt; T MINUS't; NT additive_expression'nt])
      (fun expr2 _2 expr1 =>
 (BINARY SUB (fst expr1) (fst expr2), snd expr1) 
)
    | Prod'argument_expression_list'0 => box
      (argument_expression_list'nt, [NT assignment_expression'nt])
      (fun expr =>
 [fst expr] 
)
    | Prod'argument_expression_list'1 => box
      (argument_expression_list'nt, [NT assignment_expression'nt; T COMMA't; NT argument_expression_list'nt])
      (fun exprt _2 exprq =>
 fst exprt::exprq 
)
    | Prod'asm_arguments'0 => box
      (asm_arguments'nt, [])
      (
 ([], [], []) 
)
    | Prod'asm_arguments'1 => box
      (asm_arguments'nt, [NT asm_operands'nt; T COLON't])
      (fun o _1 =>
 (o, [], []) 
)
    | Prod'asm_arguments'2 => box
      (asm_arguments'nt, [NT asm_operands'nt; T COLON't; NT asm_operands'nt; T COLON't])
      (fun i _3 o _1 =>
 (o, i, []) 
)
    | Prod'asm_arguments'3 => box
      (asm_arguments'nt, [NT asm_flags'nt; T COLON't; NT asm_operands'nt; T COLON't; NT asm_operands'nt; T COLON't])
      (fun f _5 i _3 o _1 =>
 (o, i, f) 
)
    | Prod'asm_attributes'0 => box
      (asm_attributes'nt, [])
      (
 [] 
)
    | Prod'asm_attributes'1 => box
      (asm_attributes'nt, [NT asm_attributes'nt; T CONST't])
      (fun attr _1 =>
 CV_CONST :: attr 
)
    | Prod'asm_attributes'2 => box
      (asm_attributes'nt, [NT asm_attributes'nt; T VOLATILE't])
      (fun attr _1 =>
 CV_VOLATILE :: attr 
)
    | Prod'asm_flags'0 => box
      (asm_flags'nt, [T STRING_LITERAL't])
      (fun f =>
 let '(wide, s, loc) := f in (wide, s) :: nil 
)
    | Prod'asm_flags'1 => box
      (asm_flags'nt, [NT asm_flags'nt; T COMMA't; T STRING_LITERAL't])
      (fun fl _2 f =>
 let '(wide, s, loc) := f in (wide, s) :: fl 
)
    | Prod'asm_op_name'0 => box
      (asm_op_name'nt, [])
      (
 None 
)
    | Prod'asm_op_name'1 => box
      (asm_op_name'nt, [T RBRACK't; T OTHER_NAME't; T LBRACK't])
      (fun _3 n _1 =>
 Some (fst n) 
)
    | Prod'asm_operand'0 => box
      (asm_operand'nt, [T RPAREN't; NT expression'nt; T LPAREN't; T STRING_LITERAL't; NT asm_op_name'nt])
      (fun _5 e _3 cstr n =>
 let '(wide, s, loc) := cstr in ASMOPERAND n wide s (fst e) 
)
    | Prod'asm_operands'0 => box
      (asm_operands'nt, [])
      (
 [] 
)
    | Prod'asm_operands'1 => box
      (asm_operands'nt, [NT asm_operands_ne'nt])
      (fun ol =>
 rev' ol 
)
    | Prod'asm_operands_ne'0 => box
      (asm_operands_ne'nt, [NT asm_operand'nt; T COMMA't; NT asm_operands_ne'nt])
      (fun o _2 ol =>
 o :: ol 
)
    | Prod'asm_operands_ne'1 => box
      (asm_operands_ne'nt, [NT asm_operand'nt])
      (fun o =>
 [o] 
)
    | Prod'asm_statement'0 => box
      (asm_statement'nt, [T SEMICOLON't; T RPAREN't; NT asm_arguments'nt; T STRING_LITERAL't; T LPAREN't; NT asm_attributes'nt; T ASM't])
      (fun _7 _6 args template _3 attr loc =>
 let '(wide, chars, _) := template in
      let '(outputs, inputs, flags) := args in
      ASM attr wide chars outputs inputs flags loc 
)
    | Prod'assignment_expression'0 => box
      (assignment_expression'nt, [NT conditional_expression'nt])
      (fun expr =>
 expr 
)
    | Prod'assignment_expression'1 => box
      (assignment_expression'nt, [NT assignment_expression'nt; NT assignment_operator'nt; NT unary_expression'nt])
      (fun expr2 op expr1 =>
 (BINARY op (fst expr1) (fst expr2), snd expr1) 
)
    | Prod'assignment_operator'0 => box
      (assignment_operator'nt, [T EQ't])
      (fun _1 =>
 ASSIGN  
)
    | Prod'assignment_operator'1 => box
      (assignment_operator'nt, [T MUL_ASSIGN't])
      (fun _1 =>
 MUL_ASSIGN 
)
    | Prod'assignment_operator'2 => box
      (assignment_operator'nt, [T DIV_ASSIGN't])
      (fun _1 =>
 DIV_ASSIGN 
)
    | Prod'assignment_operator'3 => box
      (assignment_operator'nt, [T MOD_ASSIGN't])
      (fun _1 =>
 MOD_ASSIGN 
)
    | Prod'assignment_operator'4 => box
      (assignment_operator'nt, [T ADD_ASSIGN't])
      (fun _1 =>
 ADD_ASSIGN 
)
    | Prod'assignment_operator'5 => box
      (assignment_operator'nt, [T SUB_ASSIGN't])
      (fun _1 =>
 SUB_ASSIGN 
)
    | Prod'assignment_operator'6 => box
      (assignment_operator'nt, [T LEFT_ASSIGN't])
      (fun _1 =>
 SHL_ASSIGN 
)
    | Prod'assignment_operator'7 => box
      (assignment_operator'nt, [T RIGHT_ASSIGN't])
      (fun _1 =>
 SHR_ASSIGN 
)
    | Prod'assignment_operator'8 => box
      (assignment_operator'nt, [T XOR_ASSIGN't])
      (fun _1 =>
 XOR_ASSIGN 
)
    | Prod'assignment_operator'9 => box
      (assignment_operator'nt, [T OR_ASSIGN't])
      (fun _1 =>
 BOR_ASSIGN 
)
    | Prod'assignment_operator'10 => box
      (assignment_operator'nt, [T AND_ASSIGN't])
      (fun _1 =>
 BAND_ASSIGN 
)
    | Prod'attribute_specifier'0 => box
      (attribute_specifier'nt, [T RPAREN't; T RPAREN't; NT gcc_attribute_list'nt; T LPAREN't; T LPAREN't; T ATTRIBUTE't])
      (fun _6 _5 attr _3 _2 loc =>
 (GCC_ATTR (rev' attr) loc, loc) 
)
    | Prod'attribute_specifier'1 => box
      (attribute_specifier'nt, [T RPAREN't; NT argument_expression_list'nt; T LPAREN't; T PACKED't])
      (fun _4 args _2 loc =>
 (PACKED_ATTR (rev' args) loc, loc) 
)
    | Prod'attribute_specifier'2 => box
      (attribute_specifier'nt, [T RPAREN't; NT argument_expression_list'nt; T LPAREN't; T ALIGNAS't])
      (fun _4 args _2 loc =>
 (ALIGNAS_ATTR (rev' args) loc, loc) 
)
    | Prod'attribute_specifier'3 => box
      (attribute_specifier'nt, [T RPAREN't; NT type_name'nt; T LPAREN't; T ALIGNAS't])
      (fun _4 typ _2 loc =>
 (ALIGNAS_ATTR [TYPE_ALIGNOF typ] loc, loc) 
)
    | Prod'attribute_specifier_list'0 => box
      (attribute_specifier_list'nt, [])
      (
 [] 
)
    | Prod'attribute_specifier_list'1 => box
      (attribute_specifier_list'nt, [NT attribute_specifier'nt; NT attribute_specifier_list'nt])
      (fun attr attrs =>
 fst attr :: attrs 
)
    | Prod'block_item'0 => box
      (block_item'nt, [NT declaration'nt])
      (fun decl =>
 DEFINITION decl 
)
    | Prod'block_item'1 => box
      (block_item'nt, [NT statement_dangerous'nt])
      (fun stmt =>
 stmt 
)
    | Prod'block_item'2 => box
      (block_item'nt, [T PRAGMA't])
      (fun p =>
 DEFINITION (PRAGMA (fst p) (snd p)) 
)
    | Prod'block_item_list'0 => box
      (block_item_list'nt, [NT block_item'nt])
      (fun stmt =>
 [stmt] 
)
    | Prod'block_item_list'1 => box
      (block_item_list'nt, [NT block_item'nt; NT block_item_list'nt])
      (fun stmtt stmtq =>
 stmtt::stmtq 
)
    | Prod'c_initializer'0 => box
      (c_initializer'nt, [NT assignment_expression'nt])
      (fun expr =>
 SINGLE_INIT (fst expr) 
)
    | Prod'c_initializer'1 => box
      (c_initializer'nt, [T RBRACE't; NT initializer_list'nt; T LBRACE't])
      (fun _3 init _1 =>
 COMPOUND_INIT (rev' init) 
)
    | Prod'c_initializer'2 => box
      (c_initializer'nt, [T RBRACE't; T COMMA't; NT initializer_list'nt; T LBRACE't])
      (fun _4 _3 init _1 =>
 COMPOUND_INIT (rev' init) 
)
    | Prod'cast_expression'0 => box
      (cast_expression'nt, [NT unary_expression'nt])
      (fun expr =>
 expr 
)
    | Prod'cast_expression'1 => box
      (cast_expression'nt, [NT cast_expression'nt; T RPAREN't; NT type_name'nt; T LPAREN't])
      (fun expr _3 typ loc =>
 (CAST typ (SINGLE_INIT (fst expr)), loc) 
)
    | Prod'compound_statement'0 => box
      (compound_statement'nt, [T RBRACE't; NT block_item_list'nt; T LBRACE't])
      (fun _3 lst loc =>
 BLOCK (rev' lst) loc 
)
    | Prod'compound_statement'1 => box
      (compound_statement'nt, [T RBRACE't; T LBRACE't])
      (fun _2 loc =>
 BLOCK [] loc 
)
    | Prod'conditional_expression'0 => box
      (conditional_expression'nt, [NT logical_OR_expression'nt])
      (fun expr =>
 expr 
)
    | Prod'conditional_expression'1 => box
      (conditional_expression'nt, [NT conditional_expression'nt; T COLON't; NT expression'nt; T QUESTION't; NT logical_OR_expression'nt])
      (fun expr3 _4 expr2 _2 expr1 =>
 (QUESTION (fst expr1) (fst expr2) (fst expr3), snd expr1) 
)
    | Prod'constant_expression'0 => box
      (constant_expression'nt, [NT conditional_expression'nt])
      (fun expr =>
 expr 
)
    | Prod'declaration'0 => box
      (declaration'nt, [T SEMICOLON't; NT init_declarator_list'nt; NT declaration_specifiers'nt])
      (fun _3 decls decspec =>
 DECDEF (fst decspec, rev' decls) (snd decspec) 
)
    | Prod'declaration'1 => box
      (declaration'nt, [T SEMICOLON't; NT declaration_specifiers'nt])
      (fun _2 decspec =>
 DECDEF (fst decspec, []) (snd decspec) 
)
    | Prod'declaration_list'0 => box
      (declaration_list'nt, [])
      (
 [] 
)
    | Prod'declaration_list'1 => box
      (declaration_list'nt, [NT declaration'nt; NT declaration_list'nt])
      (fun d dl =>
 d :: dl 
)
    | Prod'declaration_specifiers'0 => box
      (declaration_specifiers'nt, [NT declaration_specifiers'nt; NT storage_class_specifier'nt])
      (fun rest storage =>
 (SpecStorage (fst storage)::fst rest, snd storage) 
)
    | Prod'declaration_specifiers'1 => box
      (declaration_specifiers'nt, [NT storage_class_specifier'nt])
      (fun storage =>
 ([SpecStorage (fst storage)], snd storage) 
)
    | Prod'declaration_specifiers'2 => box
      (declaration_specifiers'nt, [NT declaration_specifiers'nt; NT type_specifier'nt])
      (fun rest typ =>
 (SpecType (fst typ)::fst rest, snd typ) 
)
    | Prod'declaration_specifiers'3 => box
      (declaration_specifiers'nt, [NT type_specifier'nt])
      (fun typ =>
 ([SpecType (fst typ)], snd typ) 
)
    | Prod'declaration_specifiers'4 => box
      (declaration_specifiers'nt, [NT declaration_specifiers'nt; NT type_qualifier'nt])
      (fun rest qual =>
 (SpecCV (fst qual)::fst rest, snd qual) 
)
    | Prod'declaration_specifiers'5 => box
      (declaration_specifiers'nt, [NT type_qualifier'nt])
      (fun qual =>
 ([SpecCV (fst qual)], snd qual) 
)
    | Prod'declaration_specifiers'6 => box
      (declaration_specifiers'nt, [NT declaration_specifiers'nt; NT function_specifier'nt])
      (fun rest loc =>
 (SpecInline::fst rest, loc) 
)
    | Prod'declaration_specifiers'7 => box
      (declaration_specifiers'nt, [NT function_specifier'nt])
      (fun loc =>
 ([SpecInline], loc) 
)
    | Prod'declarator'0 => box
      (declarator'nt, [NT attribute_specifier_list'nt; NT direct_declarator'nt])
      (fun attrs decl =>
 match decl with Name name typ attr loc =>
        Name name typ (List.app attr attrs) loc end 
)
    | Prod'declarator'1 => box
      (declarator'nt, [NT attribute_specifier_list'nt; NT direct_declarator'nt; NT pointer'nt])
      (fun attrs decl pt =>
 match decl with Name name typ attr _ =>
        Name name ((fst pt) typ) (List.app attr attrs) (snd pt) end 
)
    | Prod'designation'0 => box
      (designation'nt, [T EQ't; NT designator_list'nt])
      (fun _2 design =>
 rev' design 
)
    | Prod'designator'0 => box
      (designator'nt, [T RBRACK't; NT constant_expression'nt; T LBRACK't])
      (fun _3 expr _1 =>
 ATINDEX_INIT (fst expr) 
)
    | Prod'designator'1 => box
      (designator'nt, [T OTHER_NAME't; T DOT't])
      (fun id _1 =>
 INFIELD_INIT (fst id) 
)
    | Prod'designator_list'0 => box
      (designator_list'nt, [NT designator'nt])
      (fun design =>
 [design] 
)
    | Prod'designator_list'1 => box
      (designator_list'nt, [NT designator'nt; NT designator_list'nt])
      (fun designt designq =>
 designt::designq 
)
    | Prod'direct_abstract_declarator'0 => box
      (direct_abstract_declarator'nt, [T RPAREN't; NT abstract_declarator'nt; T LPAREN't])
      (fun _3 typ _1 =>
 typ 
)
    | Prod'direct_abstract_declarator'1 => box
      (direct_abstract_declarator'nt, [T RBRACK't; NT assignment_expression'nt; NT type_qualifier_list'nt; T LBRACK't; NT direct_abstract_declarator'nt])
      (fun _5 expr cvspec _2 typ =>
 ARRAY typ cvspec (Some (fst expr)) 
)
    | Prod'direct_abstract_declarator'2 => box
      (direct_abstract_declarator'nt, [T RBRACK't; NT assignment_expression'nt; NT type_qualifier_list'nt; T LBRACK't])
      (fun _4 expr cvspec _1 =>
 ARRAY JUSTBASE cvspec (Some (fst expr)) 
)
    | Prod'direct_abstract_declarator'3 => box
      (direct_abstract_declarator'nt, [T RBRACK't; NT assignment_expression'nt; T LBRACK't; NT direct_abstract_declarator'nt])
      (fun _4 expr _2 typ =>
 ARRAY typ [] (Some (fst expr)) 
)
    | Prod'direct_abstract_declarator'4 => box
      (direct_abstract_declarator'nt, [T RBRACK't; NT assignment_expression'nt; T LBRACK't])
      (fun _3 expr _1 =>
 ARRAY JUSTBASE [] (Some (fst expr)) 
)
    | Prod'direct_abstract_declarator'5 => box
      (direct_abstract_declarator'nt, [T RBRACK't; NT type_qualifier_list'nt; T LBRACK't; NT direct_abstract_declarator'nt])
      (fun _4 cvspec _2 typ =>
 ARRAY typ cvspec None 
)
    | Prod'direct_abstract_declarator'6 => box
      (direct_abstract_declarator'nt, [T RBRACK't; NT type_qualifier_list'nt; T LBRACK't])
      (fun _3 cvspec _1 =>
 ARRAY JUSTBASE cvspec None 
)
    | Prod'direct_abstract_declarator'7 => box
      (direct_abstract_declarator'nt, [T RBRACK't; T LBRACK't; NT direct_abstract_declarator'nt])
      (fun _3 _2 typ =>
 ARRAY typ [] None 
)
    | Prod'direct_abstract_declarator'8 => box
      (direct_abstract_declarator'nt, [T RBRACK't; T LBRACK't])
      (fun _2 _1 =>
 ARRAY JUSTBASE [] None 
)
    | Prod'direct_abstract_declarator'9 => box
      (direct_abstract_declarator'nt, [T RPAREN't; NT parameter_type_list'nt; T LPAREN't; NT direct_abstract_declarator'nt])
      (fun _4 params _2 typ =>
 PROTO typ params 
)
    | Prod'direct_abstract_declarator'10 => box
      (direct_abstract_declarator'nt, [T RPAREN't; NT parameter_type_list'nt; T LPAREN't])
      (fun _3 params _1 =>
 PROTO JUSTBASE params 
)
    | Prod'direct_abstract_declarator'11 => box
      (direct_abstract_declarator'nt, [T RPAREN't; T LPAREN't; NT direct_abstract_declarator'nt])
      (fun _3 _2 typ =>
 PROTO typ ([], false) 
)
    | Prod'direct_abstract_declarator'12 => box
      (direct_abstract_declarator'nt, [T RPAREN't; T LPAREN't])
      (fun _2 _1 =>
 PROTO JUSTBASE ([], false) 
)
    | Prod'direct_declarator'0 => box
      (direct_declarator'nt, [T VAR_NAME't])
      (fun id =>
 Name (fst id) JUSTBASE [] (snd id) 
)
    | Prod'direct_declarator'1 => box
      (direct_declarator'nt, [T RPAREN't; NT declarator'nt; T LPAREN't])
      (fun _3 decl _1 =>
 decl 
)
    | Prod'direct_declarator'2 => box
      (direct_declarator'nt, [T RBRACK't; NT assignment_expression'nt; NT type_qualifier_list'nt; T LBRACK't; NT direct_declarator'nt])
      (fun _5 expr quallst _2 decl =>
 match decl with Name name typ attr loc =>
        Name name (ARRAY typ (rev' quallst) (Some (fst expr))) attr loc end 
)
    | Prod'direct_declarator'3 => box
      (direct_declarator'nt, [T RBRACK't; NT assignment_expression'nt; T LBRACK't; NT direct_declarator'nt])
      (fun _4 expr _2 decl =>
 match decl with Name name typ attr loc =>
        Name name (ARRAY typ [] (Some (fst expr))) attr loc end 
)
    | Prod'direct_declarator'4 => box
      (direct_declarator'nt, [T RBRACK't; NT type_qualifier_list'nt; T LBRACK't; NT direct_declarator'nt])
      (fun _4 quallst _2 decl =>
 match decl with Name name typ attr loc =>
        Name name (ARRAY typ (rev' quallst) None) attr loc end 
)
    | Prod'direct_declarator'5 => box
      (direct_declarator'nt, [T RBRACK't; T LBRACK't; NT direct_declarator'nt])
      (fun _3 _2 decl =>
 match decl with Name name typ attr loc =>
        Name name (ARRAY typ [] None) attr loc end 
)
    | Prod'direct_declarator'6 => box
      (direct_declarator'nt, [T RPAREN't; NT parameter_type_list'nt; T LPAREN't; NT direct_declarator'nt])
      (fun _4 params _2 decl =>
 match decl with Name name typ attr loc =>
        Name name (PROTO typ params) attr loc end 
)
    | Prod'direct_declarator'7 => box
      (direct_declarator'nt, [T RPAREN't; T LPAREN't; NT direct_declarator'nt])
      (fun _3 _2 decl =>
 match decl with Name name typ attr loc =>
        Name name (PROTO typ ([], false)) attr loc end 
)
    | Prod'direct_old_function_declarator'0 => box
      (direct_old_function_declarator'nt, [T RPAREN't; NT identifier_list'nt; T LPAREN't; NT direct_declarator'nt])
      (fun _4 params _2 decl =>
 (decl, List.rev' params) 
)
    | Prod'enum_specifier'0 => box
      (enum_specifier'nt, [T RBRACE't; NT enumerator_list'nt; T LBRACE't; T OTHER_NAME't; NT attribute_specifier_list'nt; T ENUM't])
      (fun _6 enum_list _4 name attrs loc =>
 (Tenum (Some (fst name)) (Some (rev' enum_list)) (rev' attrs), loc) 
)
    | Prod'enum_specifier'1 => box
      (enum_specifier'nt, [T RBRACE't; NT enumerator_list'nt; T LBRACE't; NT attribute_specifier_list'nt; T ENUM't])
      (fun _5 enum_list _3 attrs loc =>
 (Tenum None (Some (rev' enum_list)) (rev' attrs), loc) 
)
    | Prod'enum_specifier'2 => box
      (enum_specifier'nt, [T RBRACE't; T COMMA't; NT enumerator_list'nt; T LBRACE't; T OTHER_NAME't; NT attribute_specifier_list'nt; T ENUM't])
      (fun _7 _6 enum_list _4 name attrs loc =>
 (Tenum (Some (fst name)) (Some (rev' enum_list)) (rev' attrs), loc) 
)
    | Prod'enum_specifier'3 => box
      (enum_specifier'nt, [T RBRACE't; T COMMA't; NT enumerator_list'nt; T LBRACE't; NT attribute_specifier_list'nt; T ENUM't])
      (fun _6 _5 enum_list _3 attrs loc =>
 (Tenum None (Some (rev' enum_list)) (rev' attrs), loc) 
)
    | Prod'enum_specifier'4 => box
      (enum_specifier'nt, [T OTHER_NAME't; NT attribute_specifier_list'nt; T ENUM't])
      (fun name attrs loc =>
 (Tenum (Some (fst name)) None (rev' attrs), loc) 
)
    | Prod'enumeration_constant'0 => box
      (enumeration_constant'nt, [T VAR_NAME't])
      (fun cst =>
 cst 
)
    | Prod'enumerator'0 => box
      (enumerator'nt, [NT enumeration_constant'nt])
      (fun cst =>
 (fst cst, None, snd cst) 
)
    | Prod'enumerator'1 => box
      (enumerator'nt, [NT constant_expression'nt; T EQ't; NT enumeration_constant'nt])
      (fun expr _2 cst =>
 (fst cst, Some (fst expr), snd cst) 
)
    | Prod'enumerator_list'0 => box
      (enumerator_list'nt, [NT enumerator'nt])
      (fun enum =>
 [enum] 
)
    | Prod'enumerator_list'1 => box
      (enumerator_list'nt, [NT enumerator'nt; T COMMA't; NT enumerator_list'nt])
      (fun enumst _2 enumsq =>
 enumst::enumsq 
)
    | Prod'equality_expression'0 => box
      (equality_expression'nt, [NT relational_expression'nt])
      (fun expr =>
 expr 
)
    | Prod'equality_expression'1 => box
      (equality_expression'nt, [NT relational_expression'nt; T EQEQ't; NT equality_expression'nt])
      (fun expr2 _2 expr1 =>
 (BINARY EQ (fst expr1) (fst expr2), snd expr1) 
)
    | Prod'equality_expression'2 => box
      (equality_expression'nt, [NT relational_expression'nt; T NEQ't; NT equality_expression'nt])
      (fun expr2 _2 expr1 =>
 (BINARY NE (fst expr1) (fst expr2), snd expr1) 
)
    | Prod'exclusive_OR_expression'0 => box
      (exclusive_OR_expression'nt, [NT AND_expression'nt])
      (fun expr =>
 expr 
)
    | Prod'exclusive_OR_expression'1 => box
      (exclusive_OR_expression'nt, [NT AND_expression'nt; T HAT't; NT exclusive_OR_expression'nt])
      (fun expr2 _2 expr1 =>
 (BINARY XOR (fst expr1) (fst expr2), snd expr1) 
)
    | Prod'expression'0 => box
      (expression'nt, [NT assignment_expression'nt])
      (fun expr =>
 expr 
)
    | Prod'expression'1 => box
      (expression'nt, [NT assignment_expression'nt; T COMMA't; NT expression'nt])
      (fun expr2 _2 expr1 =>
 (BINARY COMMA (fst expr1) (fst expr2), snd expr1) 
)
    | Prod'expression_statement'0 => box
      (expression_statement'nt, [T SEMICOLON't; NT expression'nt])
      (fun _2 expr =>
 COMPUTATION (fst expr) (snd expr) 
)
    | Prod'expression_statement'1 => box
      (expression_statement'nt, [T SEMICOLON't])
      (fun loc =>
 NOP loc 
)
    | Prod'external_declaration'0 => box
      (external_declaration'nt, [NT function_definition'nt])
      (fun def =>
 def 
)
    | Prod'external_declaration'1 => box
      (external_declaration'nt, [NT declaration'nt])
      (fun def =>
 def 
)
    | Prod'external_declaration'2 => box
      (external_declaration'nt, [T PRAGMA't])
      (fun p =>
 PRAGMA (fst p) (snd p) 
)
    | Prod'function_definition'0 => box
      (function_definition'nt, [NT compound_statement'nt; NT declarator'nt; NT declaration_specifiers'nt])
      (fun stmt decl specs =>
 FUNDEF (fst specs) decl stmt (snd specs) 
)
    | Prod'function_definition'1 => box
      (function_definition'nt, [NT compound_statement'nt; NT declaration_list'nt; NT old_function_declarator'nt; NT declaration_specifiers'nt])
      (fun stmt dlist decl specs =>
 KRFUNDEF (fst specs) (fst decl) (snd decl) (List.rev' dlist) stmt (snd specs) 
)
    | Prod'function_specifier'0 => box
      (function_specifier'nt, [T INLINE't])
      (fun loc =>
 loc 
)
    | Prod'gcc_attribute'0 => box
      (gcc_attribute'nt, [])
      (
 GCC_ATTR_EMPTY 
)
    | Prod'gcc_attribute'1 => box
      (gcc_attribute'nt, [NT gcc_attribute_word'nt])
      (fun w =>
 GCC_ATTR_NOARGS w 
)
    | Prod'gcc_attribute'2 => box
      (gcc_attribute'nt, [T RPAREN't; T LPAREN't; NT gcc_attribute_word'nt])
      (fun _3 _2 w =>
 GCC_ATTR_ARGS w [] 
)
    | Prod'gcc_attribute'3 => box
      (gcc_attribute'nt, [T RPAREN't; NT argument_expression_list'nt; T LPAREN't; NT gcc_attribute_word'nt])
      (fun _4 args _2 w =>
 GCC_ATTR_ARGS w args 
)
    | Prod'gcc_attribute_list'0 => box
      (gcc_attribute_list'nt, [NT gcc_attribute'nt])
      (fun a =>
 [a] 
)
    | Prod'gcc_attribute_list'1 => box
      (gcc_attribute_list'nt, [NT gcc_attribute'nt; T COMMA't; NT gcc_attribute_list'nt])
      (fun t _2 q =>
 t::q 
)
    | Prod'gcc_attribute_word'0 => box
      (gcc_attribute_word'nt, [T OTHER_NAME't])
      (fun i =>
 GCC_ATTR_IDENT (fst i) 
)
    | Prod'gcc_attribute_word'1 => box
      (gcc_attribute_word'nt, [T CONST't])
      (fun _1 =>
 GCC_ATTR_CONST 
)
    | Prod'gcc_attribute_word'2 => box
      (gcc_attribute_word'nt, [T PACKED't])
      (fun _1 =>
 GCC_ATTR_PACKED 
)
    | Prod'identifier_list'0 => box
      (identifier_list'nt, [T VAR_NAME't])
      (fun id =>
 [fst id] 
)
    | Prod'identifier_list'1 => box
      (identifier_list'nt, [T VAR_NAME't; T COMMA't; NT identifier_list'nt])
      (fun id _2 idl =>
 fst id :: idl 
)
    | Prod'inclusive_OR_expression'0 => box
      (inclusive_OR_expression'nt, [NT exclusive_OR_expression'nt])
      (fun expr =>
 expr 
)
    | Prod'inclusive_OR_expression'1 => box
      (inclusive_OR_expression'nt, [NT exclusive_OR_expression'nt; T BAR't; NT inclusive_OR_expression'nt])
      (fun expr2 _2 expr1 =>
 (BINARY BOR (fst expr1) (fst expr2), snd expr1) 
)
    | Prod'init_declarator'0 => box
      (init_declarator'nt, [NT declarator'nt])
      (fun name =>
 Init_name name NO_INIT 
)
    | Prod'init_declarator'1 => box
      (init_declarator'nt, [NT c_initializer'nt; T EQ't; NT declarator'nt])
      (fun init _2 name =>
 Init_name name init 
)
    | Prod'init_declarator_list'0 => box
      (init_declarator_list'nt, [NT init_declarator'nt])
      (fun init =>
 [init] 
)
    | Prod'init_declarator_list'1 => box
      (init_declarator_list'nt, [NT init_declarator'nt; T COMMA't; NT init_declarator_list'nt])
      (fun initt _2 initq =>
 initt::initq 
)
    | Prod'initializer_list'0 => box
      (initializer_list'nt, [NT c_initializer'nt; NT designation'nt])
      (fun init design =>
 [(design, init)] 
)
    | Prod'initializer_list'1 => box
      (initializer_list'nt, [NT c_initializer'nt])
      (fun init =>
 [([], init)] 
)
    | Prod'initializer_list'2 => box
      (initializer_list'nt, [NT c_initializer'nt; NT designation'nt; T COMMA't; NT initializer_list'nt])
      (fun init design _2 initq =>
 (design, init)::initq 
)
    | Prod'initializer_list'3 => box
      (initializer_list'nt, [NT c_initializer'nt; T COMMA't; NT initializer_list'nt])
      (fun init _2 initq =>
 ([], init)::initq 
)
    | Prod'iteration_statement_statement_dangerous_'0 => box
      (iteration_statement_statement_dangerous_'nt, [NT statement_dangerous'nt; T RPAREN't; NT expression'nt; T LPAREN't; T WHILE't])
      (fun stmt _4 expr _2 loc =>
 WHILE (fst expr) stmt loc 
)
    | Prod'iteration_statement_statement_dangerous_'1 => box
      (iteration_statement_statement_dangerous_'nt, [T SEMICOLON't; T RPAREN't; NT expression'nt; T LPAREN't; T WHILE't; NT statement_dangerous'nt; T DO't])
      (fun _7 _6 expr _4 _3 stmt loc =>
 DOWHILE (fst expr) stmt loc 
)
    | Prod'iteration_statement_statement_dangerous_'2 => box
      (iteration_statement_statement_dangerous_'nt, [NT statement_dangerous'nt; T RPAREN't; NT expression'nt; T SEMICOLON't; NT expression'nt; T SEMICOLON't; NT expression'nt; T LPAREN't; T FOR't])
      (fun stmt _8 expr3 _6 expr2 _4 expr1 _2 loc =>
 FOR (Some (FC_EXP (fst expr1))) (Some (fst expr2)) (Some (fst expr3)) stmt loc 
)
    | Prod'iteration_statement_statement_dangerous_'3 => box
      (iteration_statement_statement_dangerous_'nt, [NT statement_dangerous'nt; T RPAREN't; NT expression'nt; T SEMICOLON't; NT expression'nt; NT declaration'nt; T LPAREN't; T FOR't])
      (fun stmt _7 expr3 _5 expr2 decl1 _2 loc =>
 FOR (Some (FC_DECL decl1)) (Some (fst expr2)) (Some (fst expr3)) stmt loc 
)
    | Prod'iteration_statement_statement_dangerous_'4 => box
      (iteration_statement_statement_dangerous_'nt, [NT statement_dangerous'nt; T RPAREN't; NT expression'nt; T SEMICOLON't; NT expression'nt; T SEMICOLON't; T LPAREN't; T FOR't])
      (fun stmt _7 expr3 _5 expr2 _3 _2 loc =>
 FOR None (Some (fst expr2)) (Some (fst expr3)) stmt loc 
)
    | Prod'iteration_statement_statement_dangerous_'5 => box
      (iteration_statement_statement_dangerous_'nt, [NT statement_dangerous'nt; T RPAREN't; NT expression'nt; T SEMICOLON't; T SEMICOLON't; NT expression'nt; T LPAREN't; T FOR't])
      (fun stmt _7 expr3 _5 _4 expr1 _2 loc =>
 FOR (Some (FC_EXP (fst expr1))) None (Some (fst expr3)) stmt loc 
)
    | Prod'iteration_statement_statement_dangerous_'6 => box
      (iteration_statement_statement_dangerous_'nt, [NT statement_dangerous'nt; T RPAREN't; NT expression'nt; T SEMICOLON't; NT declaration'nt; T LPAREN't; T FOR't])
      (fun stmt _6 expr3 _4 decl1 _2 loc =>
 FOR (Some (FC_DECL decl1)) None (Some (fst expr3)) stmt loc 
)
    | Prod'iteration_statement_statement_dangerous_'7 => box
      (iteration_statement_statement_dangerous_'nt, [NT statement_dangerous'nt; T RPAREN't; NT expression'nt; T SEMICOLON't; T SEMICOLON't; T LPAREN't; T FOR't])
      (fun stmt _6 expr3 _4 _3 _2 loc =>
 FOR None None (Some (fst expr3)) stmt loc 
)
    | Prod'iteration_statement_statement_dangerous_'8 => box
      (iteration_statement_statement_dangerous_'nt, [NT statement_dangerous'nt; T RPAREN't; T SEMICOLON't; NT expression'nt; T SEMICOLON't; NT expression'nt; T LPAREN't; T FOR't])
      (fun stmt _7 _6 expr2 _4 expr1 _2 loc =>
 FOR (Some (FC_EXP (fst expr1))) (Some (fst expr2)) None stmt loc 
)
    | Prod'iteration_statement_statement_dangerous_'9 => box
      (iteration_statement_statement_dangerous_'nt, [NT statement_dangerous'nt; T RPAREN't; T SEMICOLON't; NT expression'nt; NT declaration'nt; T LPAREN't; T FOR't])
      (fun stmt _6 _5 expr2 decl1 _2 loc =>
 FOR (Some (FC_DECL decl1)) (Some (fst expr2)) None stmt loc 
)
    | Prod'iteration_statement_statement_dangerous_'10 => box
      (iteration_statement_statement_dangerous_'nt, [NT statement_dangerous'nt; T RPAREN't; T SEMICOLON't; NT expression'nt; T SEMICOLON't; T LPAREN't; T FOR't])
      (fun stmt _6 _5 expr2 _3 _2 loc =>
 FOR None (Some (fst expr2)) None stmt loc 
)
    | Prod'iteration_statement_statement_dangerous_'11 => box
      (iteration_statement_statement_dangerous_'nt, [NT statement_dangerous'nt; T RPAREN't; T SEMICOLON't; T SEMICOLON't; NT expression'nt; T LPAREN't; T FOR't])
      (fun stmt _6 _5 _4 expr1 _2 loc =>
 FOR (Some (FC_EXP (fst expr1))) None None stmt loc 
)
    | Prod'iteration_statement_statement_dangerous_'12 => box
      (iteration_statement_statement_dangerous_'nt, [NT statement_dangerous'nt; T RPAREN't; T SEMICOLON't; NT declaration'nt; T LPAREN't; T FOR't])
      (fun stmt _5 _4 decl1 _2 loc =>
 FOR (Some (FC_DECL decl1)) None None stmt loc 
)
    | Prod'iteration_statement_statement_dangerous_'13 => box
      (iteration_statement_statement_dangerous_'nt, [NT statement_dangerous'nt; T RPAREN't; T SEMICOLON't; T SEMICOLON't; T LPAREN't; T FOR't])
      (fun stmt _5 _4 _3 _2 loc =>
 FOR None None None stmt loc 
)
    | Prod'iteration_statement_statement_safe_'0 => box
      (iteration_statement_statement_safe_'nt, [NT statement_safe'nt; T RPAREN't; NT expression'nt; T LPAREN't; T WHILE't])
      (fun stmt _4 expr _2 loc =>
 WHILE (fst expr) stmt loc 
)
    | Prod'iteration_statement_statement_safe_'1 => box
      (iteration_statement_statement_safe_'nt, [T SEMICOLON't; T RPAREN't; NT expression'nt; T LPAREN't; T WHILE't; NT statement_dangerous'nt; T DO't])
      (fun _7 _6 expr _4 _3 stmt loc =>
 DOWHILE (fst expr) stmt loc 
)
    | Prod'iteration_statement_statement_safe_'2 => box
      (iteration_statement_statement_safe_'nt, [NT statement_safe'nt; T RPAREN't; NT expression'nt; T SEMICOLON't; NT expression'nt; T SEMICOLON't; NT expression'nt; T LPAREN't; T FOR't])
      (fun stmt _8 expr3 _6 expr2 _4 expr1 _2 loc =>
 FOR (Some (FC_EXP (fst expr1))) (Some (fst expr2)) (Some (fst expr3)) stmt loc 
)
    | Prod'iteration_statement_statement_safe_'3 => box
      (iteration_statement_statement_safe_'nt, [NT statement_safe'nt; T RPAREN't; NT expression'nt; T SEMICOLON't; NT expression'nt; NT declaration'nt; T LPAREN't; T FOR't])
      (fun stmt _7 expr3 _5 expr2 decl1 _2 loc =>
 FOR (Some (FC_DECL decl1)) (Some (fst expr2)) (Some (fst expr3)) stmt loc 
)
    | Prod'iteration_statement_statement_safe_'4 => box
      (iteration_statement_statement_safe_'nt, [NT statement_safe'nt; T RPAREN't; NT expression'nt; T SEMICOLON't; NT expression'nt; T SEMICOLON't; T LPAREN't; T FOR't])
      (fun stmt _7 expr3 _5 expr2 _3 _2 loc =>
 FOR None (Some (fst expr2)) (Some (fst expr3)) stmt loc 
)
    | Prod'iteration_statement_statement_safe_'5 => box
      (iteration_statement_statement_safe_'nt, [NT statement_safe'nt; T RPAREN't; NT expression'nt; T SEMICOLON't; T SEMICOLON't; NT expression'nt; T LPAREN't; T FOR't])
      (fun stmt _7 expr3 _5 _4 expr1 _2 loc =>
 FOR (Some (FC_EXP (fst expr1))) None (Some (fst expr3)) stmt loc 
)
    | Prod'iteration_statement_statement_safe_'6 => box
      (iteration_statement_statement_safe_'nt, [NT statement_safe'nt; T RPAREN't; NT expression'nt; T SEMICOLON't; NT declaration'nt; T LPAREN't; T FOR't])
      (fun stmt _6 expr3 _4 decl1 _2 loc =>
 FOR (Some (FC_DECL decl1)) None (Some (fst expr3)) stmt loc 
)
    | Prod'iteration_statement_statement_safe_'7 => box
      (iteration_statement_statement_safe_'nt, [NT statement_safe'nt; T RPAREN't; NT expression'nt; T SEMICOLON't; T SEMICOLON't; T LPAREN't; T FOR't])
      (fun stmt _6 expr3 _4 _3 _2 loc =>
 FOR None None (Some (fst expr3)) stmt loc 
)
    | Prod'iteration_statement_statement_safe_'8 => box
      (iteration_statement_statement_safe_'nt, [NT statement_safe'nt; T RPAREN't; T SEMICOLON't; NT expression'nt; T SEMICOLON't; NT expression'nt; T LPAREN't; T FOR't])
      (fun stmt _7 _6 expr2 _4 expr1 _2 loc =>
 FOR (Some (FC_EXP (fst expr1))) (Some (fst expr2)) None stmt loc 
)
    | Prod'iteration_statement_statement_safe_'9 => box
      (iteration_statement_statement_safe_'nt, [NT statement_safe'nt; T RPAREN't; T SEMICOLON't; NT expression'nt; NT declaration'nt; T LPAREN't; T FOR't])
      (fun stmt _6 _5 expr2 decl1 _2 loc =>
 FOR (Some (FC_DECL decl1)) (Some (fst expr2)) None stmt loc 
)
    | Prod'iteration_statement_statement_safe_'10 => box
      (iteration_statement_statement_safe_'nt, [NT statement_safe'nt; T RPAREN't; T SEMICOLON't; NT expression'nt; T SEMICOLON't; T LPAREN't; T FOR't])
      (fun stmt _6 _5 expr2 _3 _2 loc =>
 FOR None (Some (fst expr2)) None stmt loc 
)
    | Prod'iteration_statement_statement_safe_'11 => box
      (iteration_statement_statement_safe_'nt, [NT statement_safe'nt; T RPAREN't; T SEMICOLON't; T SEMICOLON't; NT expression'nt; T LPAREN't; T FOR't])
      (fun stmt _6 _5 _4 expr1 _2 loc =>
 FOR (Some (FC_EXP (fst expr1))) None None stmt loc 
)
    | Prod'iteration_statement_statement_safe_'12 => box
      (iteration_statement_statement_safe_'nt, [NT statement_safe'nt; T RPAREN't; T SEMICOLON't; NT declaration'nt; T LPAREN't; T FOR't])
      (fun stmt _5 _4 decl1 _2 loc =>
 FOR (Some (FC_DECL decl1)) None None stmt loc 
)
    | Prod'iteration_statement_statement_safe_'13 => box
      (iteration_statement_statement_safe_'nt, [NT statement_safe'nt; T RPAREN't; T SEMICOLON't; T SEMICOLON't; T LPAREN't; T FOR't])
      (fun stmt _5 _4 _3 _2 loc =>
 FOR None None None stmt loc 
)
    | Prod'jump_statement'0 => box
      (jump_statement'nt, [T SEMICOLON't; T OTHER_NAME't; T GOTO't])
      (fun _3 id loc =>
 GOTO (fst id) loc 
)
    | Prod'jump_statement'1 => box
      (jump_statement'nt, [T SEMICOLON't; T CONTINUE't])
      (fun _2 loc =>
 CONTINUE loc 
)
    | Prod'jump_statement'2 => box
      (jump_statement'nt, [T SEMICOLON't; T BREAK't])
      (fun _2 loc =>
 BREAK loc 
)
    | Prod'jump_statement'3 => box
      (jump_statement'nt, [T SEMICOLON't; NT expression'nt; T RETURN't])
      (fun _3 expr loc =>
 RETURN (Some (fst expr)) loc 
)
    | Prod'jump_statement'4 => box
      (jump_statement'nt, [T SEMICOLON't; T RETURN't])
      (fun _2 loc =>
 RETURN None loc 
)
    | Prod'labeled_statement_statement_dangerous_'0 => box
      (labeled_statement_statement_dangerous_'nt, [NT statement_dangerous'nt; T COLON't; T OTHER_NAME't])
      (fun stmt _2 lbl =>
 LABEL (fst lbl) stmt (snd lbl) 
)
    | Prod'labeled_statement_statement_dangerous_'1 => box
      (labeled_statement_statement_dangerous_'nt, [NT statement_dangerous'nt; T COLON't; NT constant_expression'nt; T CASE't])
      (fun stmt _3 expr loc =>
 CASE (fst expr) stmt loc 
)
    | Prod'labeled_statement_statement_dangerous_'2 => box
      (labeled_statement_statement_dangerous_'nt, [NT statement_dangerous'nt; T COLON't; T DEFAULT't])
      (fun stmt _2 loc =>
 DEFAULT stmt loc 
)
    | Prod'labeled_statement_statement_safe_'0 => box
      (labeled_statement_statement_safe_'nt, [NT statement_safe'nt; T COLON't; T OTHER_NAME't])
      (fun stmt _2 lbl =>
 LABEL (fst lbl) stmt (snd lbl) 
)
    | Prod'labeled_statement_statement_safe_'1 => box
      (labeled_statement_statement_safe_'nt, [NT statement_safe'nt; T COLON't; NT constant_expression'nt; T CASE't])
      (fun stmt _3 expr loc =>
 CASE (fst expr) stmt loc 
)
    | Prod'labeled_statement_statement_safe_'2 => box
      (labeled_statement_statement_safe_'nt, [NT statement_safe'nt; T COLON't; T DEFAULT't])
      (fun stmt _2 loc =>
 DEFAULT stmt loc 
)
    | Prod'logical_AND_expression'0 => box
      (logical_AND_expression'nt, [NT inclusive_OR_expression'nt])
      (fun expr =>
 expr 
)
    | Prod'logical_AND_expression'1 => box
      (logical_AND_expression'nt, [NT inclusive_OR_expression'nt; T ANDAND't; NT logical_AND_expression'nt])
      (fun expr2 _2 expr1 =>
 (BINARY AND (fst expr1) (fst expr2), snd expr1) 
)
    | Prod'logical_OR_expression'0 => box
      (logical_OR_expression'nt, [NT logical_AND_expression'nt])
      (fun expr =>
 expr 
)
    | Prod'logical_OR_expression'1 => box
      (logical_OR_expression'nt, [NT logical_AND_expression'nt; T BARBAR't; NT logical_OR_expression'nt])
      (fun expr2 _2 expr1 =>
 (BINARY OR (fst expr1) (fst expr2), snd expr1) 
)
    | Prod'multiplicative_expression'0 => box
      (multiplicative_expression'nt, [NT cast_expression'nt])
      (fun expr =>
 expr 
)
    | Prod'multiplicative_expression'1 => box
      (multiplicative_expression'nt, [NT cast_expression'nt; T STAR't; NT multiplicative_expression'nt])
      (fun expr2 _2 expr1 =>
 (BINARY MUL (fst expr1) (fst expr2), snd expr1) 
)
    | Prod'multiplicative_expression'2 => box
      (multiplicative_expression'nt, [NT cast_expression'nt; T SLASH't; NT multiplicative_expression'nt])
      (fun expr2 _2 expr1 =>
 (BINARY DIV (fst expr1) (fst expr2), snd expr1) 
)
    | Prod'multiplicative_expression'3 => box
      (multiplicative_expression'nt, [NT cast_expression'nt; T PERCENT't; NT multiplicative_expression'nt])
      (fun expr2 _2 expr1 =>
 (BINARY MOD (fst expr1) (fst expr2), snd expr1) 
)
    | Prod'old_function_declarator'0 => box
      (old_function_declarator'nt, [NT direct_old_function_declarator'nt])
      (fun decl =>
 decl 
)
    | Prod'old_function_declarator'1 => box
      (old_function_declarator'nt, [NT direct_old_function_declarator'nt; NT pointer'nt])
      (fun decl pt =>
 match decl with (Name name typ attr _, params) =>
        (Name name ((fst pt) typ) attr (snd pt), params) end 
)
    | Prod'parameter_declaration'0 => box
      (parameter_declaration'nt, [NT declarator'nt; NT declaration_specifiers'nt])
      (fun decl specs =>
 match decl with Name name typ attr _ =>
        PARAM (fst specs) (Some name) typ attr (snd specs) end 
)
    | Prod'parameter_declaration'1 => box
      (parameter_declaration'nt, [NT abstract_declarator'nt; NT declaration_specifiers'nt])
      (fun decl specs =>
 PARAM (fst specs) None decl [] (snd specs) 
)
    | Prod'parameter_declaration'2 => box
      (parameter_declaration'nt, [NT declaration_specifiers'nt])
      (fun specs =>
 PARAM (fst specs) None JUSTBASE [] (snd specs) 
)
    | Prod'parameter_list'0 => box
      (parameter_list'nt, [NT parameter_declaration'nt])
      (fun param =>
 [param] 
)
    | Prod'parameter_list'1 => box
      (parameter_list'nt, [NT parameter_declaration'nt; T COMMA't; NT parameter_list'nt])
      (fun paramt _2 paramq =>
 paramt::paramq 
)
    | Prod'parameter_type_list'0 => box
      (parameter_type_list'nt, [NT parameter_list'nt])
      (fun lst =>
 (rev' lst, false) 
)
    | Prod'parameter_type_list'1 => box
      (parameter_type_list'nt, [T ELLIPSIS't; T COMMA't; NT parameter_list'nt])
      (fun _3 _2 lst =>
 (rev' lst, true) 
)
    | Prod'pointer'0 => box
      (pointer'nt, [T STAR't])
      (fun loc =>
 (fun typ => PTR [] typ, loc) 
)
    | Prod'pointer'1 => box
      (pointer'nt, [NT type_qualifier_list'nt; T STAR't])
      (fun quallst loc =>
 (fun typ => PTR (rev' quallst) typ, loc) 
)
    | Prod'pointer'2 => box
      (pointer'nt, [NT pointer'nt; T STAR't])
      (fun pt loc =>
 (fun typ => PTR [] ((fst pt) typ), loc) 
)
    | Prod'pointer'3 => box
      (pointer'nt, [NT pointer'nt; NT type_qualifier_list'nt; T STAR't])
      (fun pt quallst loc =>
 (fun typ => PTR (rev' quallst) ((fst pt) typ), loc) 
)
    | Prod'postfix_expression'0 => box
      (postfix_expression'nt, [NT primary_expression'nt])
      (fun expr =>
 expr 
)
    | Prod'postfix_expression'1 => box
      (postfix_expression'nt, [T RBRACK't; NT expression'nt; T LBRACK't; NT postfix_expression'nt])
      (fun _4 index _2 expr =>
 (INDEX (fst expr) (fst index), snd expr) 
)
    | Prod'postfix_expression'2 => box
      (postfix_expression'nt, [T RPAREN't; NT argument_expression_list'nt; T LPAREN't; NT postfix_expression'nt])
      (fun _4 args _2 expr =>
 (CALL (fst expr) (rev' args), snd expr) 
)
    | Prod'postfix_expression'3 => box
      (postfix_expression'nt, [T RPAREN't; T LPAREN't; NT postfix_expression'nt])
      (fun _3 _2 expr =>
 (CALL (fst expr) [], snd expr) 
)
    | Prod'postfix_expression'4 => box
      (postfix_expression'nt, [T RPAREN't; NT type_name'nt; T COMMA't; NT assignment_expression'nt; T LPAREN't; T BUILTIN_VA_ARG't])
      (fun _6 ty _4 expr _2 loc =>
 (BUILTIN_VA_ARG (fst expr) ty, loc) 
)
    | Prod'postfix_expression'5 => box
      (postfix_expression'nt, [T OTHER_NAME't; T DOT't; NT postfix_expression'nt])
      (fun mem _2 expr =>
 (MEMBEROF (fst expr) (fst mem), snd expr) 
)
    | Prod'postfix_expression'6 => box
      (postfix_expression'nt, [T OTHER_NAME't; T PTR't; NT postfix_expression'nt])
      (fun mem _2 expr =>
 (MEMBEROFPTR (fst expr) (fst mem), snd expr) 
)
    | Prod'postfix_expression'7 => box
      (postfix_expression'nt, [T INC't; NT postfix_expression'nt])
      (fun _2 expr =>
 (UNARY POSINCR (fst expr), snd expr) 
)
    | Prod'postfix_expression'8 => box
      (postfix_expression'nt, [T DEC't; NT postfix_expression'nt])
      (fun _2 expr =>
 (UNARY POSDECR (fst expr), snd expr) 
)
    | Prod'postfix_expression'9 => box
      (postfix_expression'nt, [T RBRACE't; NT initializer_list'nt; T LBRACE't; T RPAREN't; NT type_name'nt; T LPAREN't])
      (fun _6 init _4 _3 typ loc =>
 (CAST typ (COMPOUND_INIT (rev' init)), loc) 
)
    | Prod'postfix_expression'10 => box
      (postfix_expression'nt, [T RBRACE't; T COMMA't; NT initializer_list'nt; T LBRACE't; T RPAREN't; NT type_name'nt; T LPAREN't])
      (fun _7 _6 init _4 _3 typ loc =>
 (CAST typ (COMPOUND_INIT (rev' init)), loc) 
)
    | Prod'primary_expression'0 => box
      (primary_expression'nt, [T VAR_NAME't])
      (fun var =>
 (VARIABLE (fst var), snd var) 
)
    | Prod'primary_expression'1 => box
      (primary_expression'nt, [T CONSTANT't])
      (fun cst =>
 (CONSTANT (fst cst), snd cst) 
)
    | Prod'primary_expression'2 => box
      (primary_expression'nt, [T STRING_LITERAL't])
      (fun str =>
 let '((wide, chars), loc) := str in
      (CONSTANT (CONST_STRING wide chars), loc) 
)
    | Prod'primary_expression'3 => box
      (primary_expression'nt, [T RPAREN't; NT expression'nt; T LPAREN't])
      (fun _3 expr loc =>
 (fst expr, loc)
)
    | Prod'relational_expression'0 => box
      (relational_expression'nt, [NT shift_expression'nt])
      (fun expr =>
 expr 
)
    | Prod'relational_expression'1 => box
      (relational_expression'nt, [NT shift_expression'nt; T LT't; NT relational_expression'nt])
      (fun expr2 _2 expr1 =>
 (BINARY LT (fst expr1) (fst expr2), snd expr1) 
)
    | Prod'relational_expression'2 => box
      (relational_expression'nt, [NT shift_expression'nt; T GT't; NT relational_expression'nt])
      (fun expr2 _2 expr1 =>
 (BINARY GT (fst expr1) (fst expr2), snd expr1) 
)
    | Prod'relational_expression'3 => box
      (relational_expression'nt, [NT shift_expression'nt; T LEQ't; NT relational_expression'nt])
      (fun expr2 _2 expr1 =>
 (BINARY LE (fst expr1) (fst expr2), snd expr1) 
)
    | Prod'relational_expression'4 => box
      (relational_expression'nt, [NT shift_expression'nt; T GEQ't; NT relational_expression'nt])
      (fun expr2 _2 expr1 =>
 (BINARY GE (fst expr1) (fst expr2), snd expr1) 
)
    | Prod'selection_statement_dangerous'0 => box
      (selection_statement_dangerous'nt, [NT statement_dangerous'nt; T RPAREN't; NT expression'nt; T LPAREN't; T IF't])
      (fun stmt _4 expr _2 loc =>
 If (fst expr) stmt None loc 
)
    | Prod'selection_statement_dangerous'1 => box
      (selection_statement_dangerous'nt, [NT statement_dangerous'nt; T ELSE't; NT statement_safe'nt; T RPAREN't; NT expression'nt; T LPAREN't; T IF't])
      (fun stmt2 _6 stmt1 _4 expr _2 loc =>
 If (fst expr) stmt1 (Some stmt2) loc 
)
    | Prod'selection_statement_dangerous'2 => box
      (selection_statement_dangerous'nt, [NT statement_dangerous'nt; T RPAREN't; NT expression'nt; T LPAREN't; T SWITCH't])
      (fun stmt _4 expr _2 loc =>
 SWITCH (fst expr) stmt loc 
)
    | Prod'selection_statement_safe'0 => box
      (selection_statement_safe'nt, [NT statement_safe'nt; T ELSE't; NT statement_safe'nt; T RPAREN't; NT expression'nt; T LPAREN't; T IF't])
      (fun stmt2 _6 stmt1 _4 expr _2 loc =>
 If (fst expr) stmt1 (Some stmt2) loc 
)
    | Prod'selection_statement_safe'1 => box
      (selection_statement_safe'nt, [NT statement_safe'nt; T RPAREN't; NT expression'nt; T LPAREN't; T SWITCH't])
      (fun stmt _4 expr _2 loc =>
 SWITCH (fst expr) stmt loc 
)
    | Prod'shift_expression'0 => box
      (shift_expression'nt, [NT additive_expression'nt])
      (fun expr =>
 expr 
)
    | Prod'shift_expression'1 => box
      (shift_expression'nt, [NT additive_expression'nt; T LEFT't; NT shift_expression'nt])
      (fun expr2 _2 expr1 =>
 (BINARY SHL (fst expr1) (fst expr2), snd expr1) 
)
    | Prod'shift_expression'2 => box
      (shift_expression'nt, [NT additive_expression'nt; T RIGHT't; NT shift_expression'nt])
      (fun expr2 _2 expr1 =>
 (BINARY SHR (fst expr1) (fst expr2), snd expr1) 
)
    | Prod'specifier_qualifier_list'0 => box
      (specifier_qualifier_list'nt, [NT specifier_qualifier_list'nt; NT type_specifier'nt])
      (fun rest typ =>
 (SpecType (fst typ)::fst rest, snd typ) 
)
    | Prod'specifier_qualifier_list'1 => box
      (specifier_qualifier_list'nt, [NT type_specifier'nt])
      (fun typ =>
 ([SpecType (fst typ)], snd typ) 
)
    | Prod'specifier_qualifier_list'2 => box
      (specifier_qualifier_list'nt, [NT specifier_qualifier_list'nt; NT type_qualifier'nt])
      (fun rest qual =>
 (SpecCV (fst qual)::fst rest, snd qual) 
)
    | Prod'specifier_qualifier_list'3 => box
      (specifier_qualifier_list'nt, [NT type_qualifier'nt])
      (fun qual =>
 ([SpecCV (fst qual)], snd qual) 
)
    | Prod'statement_dangerous'0 => box
      (statement_dangerous'nt, [NT labeled_statement_statement_dangerous_'nt])
      (fun stmt =>
 stmt 
)
    | Prod'statement_dangerous'1 => box
      (statement_dangerous'nt, [NT compound_statement'nt])
      (fun stmt =>
 stmt 
)
    | Prod'statement_dangerous'2 => box
      (statement_dangerous'nt, [NT expression_statement'nt])
      (fun stmt =>
 stmt 
)
    | Prod'statement_dangerous'3 => box
      (statement_dangerous'nt, [NT selection_statement_dangerous'nt])
      (fun stmt =>
 stmt 
)
    | Prod'statement_dangerous'4 => box
      (statement_dangerous'nt, [NT iteration_statement_statement_dangerous_'nt])
      (fun stmt =>
 stmt 
)
    | Prod'statement_dangerous'5 => box
      (statement_dangerous'nt, [NT jump_statement'nt])
      (fun stmt =>
 stmt 
)
    | Prod'statement_dangerous'6 => box
      (statement_dangerous'nt, [NT asm_statement'nt])
      (fun stmt =>
 stmt 
)
    | Prod'statement_safe'0 => box
      (statement_safe'nt, [NT labeled_statement_statement_safe_'nt])
      (fun stmt =>
 stmt 
)
    | Prod'statement_safe'1 => box
      (statement_safe'nt, [NT compound_statement'nt])
      (fun stmt =>
 stmt 
)
    | Prod'statement_safe'2 => box
      (statement_safe'nt, [NT expression_statement'nt])
      (fun stmt =>
 stmt 
)
    | Prod'statement_safe'3 => box
      (statement_safe'nt, [NT selection_statement_safe'nt])
      (fun stmt =>
 stmt 
)
    | Prod'statement_safe'4 => box
      (statement_safe'nt, [NT iteration_statement_statement_safe_'nt])
      (fun stmt =>
 stmt 
)
    | Prod'statement_safe'5 => box
      (statement_safe'nt, [NT jump_statement'nt])
      (fun stmt =>
 stmt 
)
    | Prod'statement_safe'6 => box
      (statement_safe'nt, [NT asm_statement'nt])
      (fun stmt =>
 stmt 
)
    | Prod'storage_class_specifier'0 => box
      (storage_class_specifier'nt, [T TYPEDEF't])
      (fun loc =>
 (TYPEDEF, loc) 
)
    | Prod'storage_class_specifier'1 => box
      (storage_class_specifier'nt, [T EXTERN't])
      (fun loc =>
 (EXTERN, loc) 
)
    | Prod'storage_class_specifier'2 => box
      (storage_class_specifier'nt, [T STATIC't])
      (fun loc =>
 (STATIC, loc) 
)
    | Prod'storage_class_specifier'3 => box
      (storage_class_specifier'nt, [T AUTO't])
      (fun loc =>
 (AUTO, loc) 
)
    | Prod'storage_class_specifier'4 => box
      (storage_class_specifier'nt, [T REGISTER't])
      (fun loc =>
 (REGISTER, loc) 
)
    | Prod'struct_declaration'0 => box
      (struct_declaration'nt, [T SEMICOLON't; NT struct_declarator_list'nt; NT specifier_qualifier_list'nt])
      (fun _3 decls decspec =>
 Field_group (fst decspec) (rev' decls) (snd decspec) 
)
    | Prod'struct_declaration'1 => box
      (struct_declaration'nt, [T SEMICOLON't; NT specifier_qualifier_list'nt])
      (fun _2 decspec =>
 Field_group (fst decspec) [] (snd decspec) 
)
    | Prod'struct_declaration_list'0 => box
      (struct_declaration_list'nt, [])
      (
 nil 
)
    | Prod'struct_declaration_list'1 => box
      (struct_declaration_list'nt, [NT struct_declaration'nt; NT struct_declaration_list'nt])
      (fun tdecls qdecls =>
 tdecls::qdecls 
)
    | Prod'struct_declarator'0 => box
      (struct_declarator'nt, [NT declarator'nt])
      (fun decl =>
 (Some decl, None) 
)
    | Prod'struct_declarator'1 => box
      (struct_declarator'nt, [NT constant_expression'nt; T COLON't; NT declarator'nt])
      (fun expr _2 decl =>
 (Some decl, Some (fst expr)) 
)
    | Prod'struct_declarator'2 => box
      (struct_declarator'nt, [NT constant_expression'nt; T COLON't])
      (fun expr _1 =>
 (None, Some (fst expr)) 
)
    | Prod'struct_declarator_list'0 => box
      (struct_declarator_list'nt, [NT struct_declarator'nt])
      (fun decl =>
 [decl] 
)
    | Prod'struct_declarator_list'1 => box
      (struct_declarator_list'nt, [NT struct_declarator'nt; T COMMA't; NT struct_declarator_list'nt])
      (fun declt _2 declq =>
 declt::declq 
)
    | Prod'struct_or_union'0 => box
      (struct_or_union'nt, [T STRUCT't])
      (fun loc =>
 (STRUCT, loc) 
)
    | Prod'struct_or_union'1 => box
      (struct_or_union'nt, [T UNION't])
      (fun loc =>
 (UNION, loc) 
)
    | Prod'struct_or_union_specifier'0 => box
      (struct_or_union_specifier'nt, [T RBRACE't; NT struct_declaration_list'nt; T LBRACE't; T OTHER_NAME't; NT attribute_specifier_list'nt; NT struct_or_union'nt])
      (fun _6 decls _4 id attrs str_uni =>
 (Tstruct_union (fst str_uni) (Some (fst id)) (Some (rev' decls)) (rev' attrs), snd str_uni) 
)
    | Prod'struct_or_union_specifier'1 => box
      (struct_or_union_specifier'nt, [T RBRACE't; NT struct_declaration_list'nt; T LBRACE't; NT attribute_specifier_list'nt; NT struct_or_union'nt])
      (fun _5 decls _3 attrs str_uni =>
 (Tstruct_union (fst str_uni) None (Some (rev' decls)) (rev' attrs),            snd str_uni) 
)
    | Prod'struct_or_union_specifier'2 => box
      (struct_or_union_specifier'nt, [T OTHER_NAME't; NT attribute_specifier_list'nt; NT struct_or_union'nt])
      (fun id attrs str_uni =>
 (Tstruct_union (fst str_uni) (Some (fst id)) None (rev' attrs),         snd str_uni) 
)
    | Prod'translation_unit'0 => box
      (translation_unit'nt, [NT external_declaration'nt])
      (fun def =>
 [def] 
)
    | Prod'translation_unit'1 => box
      (translation_unit'nt, [NT external_declaration'nt; NT translation_unit'nt])
      (fun deft defq =>
 deft::defq 
)
    | Prod'translation_unit'2 => box
      (translation_unit'nt, [T SEMICOLON't; NT translation_unit'nt])
      (fun _2 tu =>
 tu 
)
    | Prod'translation_unit'3 => box
      (translation_unit'nt, [T SEMICOLON't])
      (fun _1 =>
 [] 
)
    | Prod'translation_unit_file'0 => box
      (translation_unit_file'nt, [T EOF't; NT translation_unit'nt])
      (fun _2 lst =>
 rev' lst 
)
    | Prod'translation_unit_file'1 => box
      (translation_unit_file'nt, [T EOF't])
      (fun _1 =>
 [] 
)
    | Prod'type_name'0 => box
      (type_name'nt, [NT specifier_qualifier_list'nt])
      (fun specqual =>
 (fst specqual, JUSTBASE) 
)
    | Prod'type_name'1 => box
      (type_name'nt, [NT abstract_declarator'nt; NT specifier_qualifier_list'nt])
      (fun typ specqual =>
 (fst specqual, typ) 
)
    | Prod'type_qualifier'0 => box
      (type_qualifier'nt, [T CONST't])
      (fun loc =>
 (CV_CONST, loc) 
)
    | Prod'type_qualifier'1 => box
      (type_qualifier'nt, [T RESTRICT't])
      (fun loc =>
 (CV_RESTRICT, loc) 
)
    | Prod'type_qualifier'2 => box
      (type_qualifier'nt, [T VOLATILE't])
      (fun loc =>
 (CV_VOLATILE, loc) 
)
    | Prod'type_qualifier'3 => box
      (type_qualifier'nt, [NT attribute_specifier'nt])
      (fun attr =>
 (CV_ATTR (fst attr), snd attr) 
)
    | Prod'type_qualifier_list'0 => box
      (type_qualifier_list'nt, [NT type_qualifier'nt])
      (fun qual =>
 [fst qual] 
)
    | Prod'type_qualifier_list'1 => box
      (type_qualifier_list'nt, [NT type_qualifier'nt; NT type_qualifier_list'nt])
      (fun qualt qualq =>
 fst qualt::qualq 
)
    | Prod'type_specifier'0 => box
      (type_specifier'nt, [T VOID't])
      (fun loc =>
 (Tvoid, loc) 
)
    | Prod'type_specifier'1 => box
      (type_specifier'nt, [T CHAR't])
      (fun loc =>
 (Tchar, loc) 
)
    | Prod'type_specifier'2 => box
      (type_specifier'nt, [T SHORT't])
      (fun loc =>
 (Tshort, loc) 
)
    | Prod'type_specifier'3 => box
      (type_specifier'nt, [T INT't])
      (fun loc =>
 (Tint, loc) 
)
    | Prod'type_specifier'4 => box
      (type_specifier'nt, [T LONG't])
      (fun loc =>
 (Tlong, loc) 
)
    | Prod'type_specifier'5 => box
      (type_specifier'nt, [T FLOAT't])
      (fun loc =>
 (Tfloat, loc) 
)
    | Prod'type_specifier'6 => box
      (type_specifier'nt, [T DOUBLE't])
      (fun loc =>
 (Tdouble, loc) 
)
    | Prod'type_specifier'7 => box
      (type_specifier'nt, [T SIGNED't])
      (fun loc =>
 (Tsigned, loc) 
)
    | Prod'type_specifier'8 => box
      (type_specifier'nt, [T UNSIGNED't])
      (fun loc =>
 (Tunsigned, loc) 
)
    | Prod'type_specifier'9 => box
      (type_specifier'nt, [T UNDERSCORE_BOOL't])
      (fun loc =>
 (T_Bool, loc) 
)
    | Prod'type_specifier'10 => box
      (type_specifier'nt, [NT struct_or_union_specifier'nt])
      (fun spec =>
 spec 
)
    | Prod'type_specifier'11 => box
      (type_specifier'nt, [NT enum_specifier'nt])
      (fun spec =>
 spec 
)
    | Prod'type_specifier'12 => box
      (type_specifier'nt, [T TYPEDEF_NAME't])
      (fun id =>
 (Tnamed (fst id), snd id) 
)
    | Prod'unary_expression'0 => box
      (unary_expression'nt, [NT postfix_expression'nt])
      (fun expr =>
 expr 
)
    | Prod'unary_expression'1 => box
      (unary_expression'nt, [NT unary_expression'nt; T INC't])
      (fun expr loc =>
 (UNARY PREINCR (fst expr), loc) 
)
    | Prod'unary_expression'2 => box
      (unary_expression'nt, [NT unary_expression'nt; T DEC't])
      (fun expr loc =>
 (UNARY PREDECR (fst expr), loc) 
)
    | Prod'unary_expression'3 => box
      (unary_expression'nt, [NT cast_expression'nt; NT unary_operator'nt])
      (fun expr op =>
 (UNARY (fst op) (fst expr), snd op) 
)
    | Prod'unary_expression'4 => box
      (unary_expression'nt, [NT unary_expression'nt; T SIZEOF't])
      (fun expr loc =>
 (EXPR_SIZEOF (fst expr), loc) 
)
    | Prod'unary_expression'5 => box
      (unary_expression'nt, [T RPAREN't; NT type_name'nt; T LPAREN't; T SIZEOF't])
      (fun _4 typ _2 loc =>
 (TYPE_SIZEOF typ, loc) 
)
    | Prod'unary_expression'6 => box
      (unary_expression'nt, [NT unary_expression'nt; T ALIGNOF't])
      (fun expr loc =>
 (EXPR_ALIGNOF (fst expr), loc) 
)
    | Prod'unary_expression'7 => box
      (unary_expression'nt, [T RPAREN't; NT type_name'nt; T LPAREN't; T ALIGNOF't])
      (fun _4 typ _2 loc =>
 (TYPE_ALIGNOF typ, loc) 
)
    | Prod'unary_operator'0 => box
      (unary_operator'nt, [T AND't])
      (fun loc =>
 (ADDROF, loc) 
)
    | Prod'unary_operator'1 => box
      (unary_operator'nt, [T STAR't])
      (fun loc =>
 (MEMOF, loc) 
)
    | Prod'unary_operator'2 => box
      (unary_operator'nt, [T PLUS't])
      (fun loc =>
 (PLUS, loc) 
)
    | Prod'unary_operator'3 => box
      (unary_operator'nt, [T MINUS't])
      (fun loc =>
 (MINUS, loc) 
)
    | Prod'unary_operator'4 => box
      (unary_operator'nt, [T TILDE't])
      (fun loc =>
 (BNOT, loc) 
)
    | Prod'unary_operator'5 => box
      (unary_operator'nt, [T BANG't])
      (fun loc =>
 (NOT, loc) 
)
  end.

Definition prod_lhs (p:production) :=
  fst (projT1 (prod_contents p)).
Definition prod_rhs_rev (p:production) :=
  snd (projT1 (prod_contents p)).
Definition prod_action (p:production) :=
  projT2 (prod_contents p).

Include Grammar.Defs.

End Gram.

Module Aut <: Automaton.T.

Module Gram := Gram.
Module GramDefs := Gram.

Definition nullable_nterm (nt:nonterminal) : bool :=
  match nt with
    | unary_operator'nt => false
    | unary_expression'nt => false
    | type_specifier'nt => false
    | type_qualifier_list'nt => false
    | type_qualifier'nt => false
    | type_name'nt => false
    | translation_unit_file'nt => false
    | translation_unit'nt => false
    | struct_or_union_specifier'nt => false
    | struct_or_union'nt => false
    | struct_declarator_list'nt => false
    | struct_declarator'nt => false
    | struct_declaration_list'nt => true
    | struct_declaration'nt => false
    | storage_class_specifier'nt => false
    | statement_safe'nt => false
    | statement_dangerous'nt => false
    | specifier_qualifier_list'nt => false
    | shift_expression'nt => false
    | selection_statement_safe'nt => false
    | selection_statement_dangerous'nt => false
    | relational_expression'nt => false
    | primary_expression'nt => false
    | postfix_expression'nt => false
    | pointer'nt => false
    | parameter_type_list'nt => false
    | parameter_list'nt => false
    | parameter_declaration'nt => false
    | old_function_declarator'nt => false
    | multiplicative_expression'nt => false
    | logical_OR_expression'nt => false
    | logical_AND_expression'nt => false
    | labeled_statement_statement_safe_'nt => false
    | labeled_statement_statement_dangerous_'nt => false
    | jump_statement'nt => false
    | iteration_statement_statement_safe_'nt => false
    | iteration_statement_statement_dangerous_'nt => false
    | initializer_list'nt => false
    | init_declarator_list'nt => false
    | init_declarator'nt => false
    | inclusive_OR_expression'nt => false
    | identifier_list'nt => false
    | gcc_attribute_word'nt => false
    | gcc_attribute_list'nt => true
    | gcc_attribute'nt => true
    | function_specifier'nt => false
    | function_definition'nt => false
    | external_declaration'nt => false
    | expression_statement'nt => false
    | expression'nt => false
    | exclusive_OR_expression'nt => false
    | equality_expression'nt => false
    | enumerator_list'nt => false
    | enumerator'nt => false
    | enumeration_constant'nt => false
    | enum_specifier'nt => false
    | direct_old_function_declarator'nt => false
    | direct_declarator'nt => false
    | direct_abstract_declarator'nt => false
    | designator_list'nt => false
    | designator'nt => false
    | designation'nt => false
    | declarator'nt => false
    | declaration_specifiers'nt => false
    | declaration_list'nt => true
    | declaration'nt => false
    | constant_expression'nt => false
    | conditional_expression'nt => false
    | compound_statement'nt => false
    | cast_expression'nt => false
    | c_initializer'nt => false
    | block_item_list'nt => false
    | block_item'nt => false
    | attribute_specifier_list'nt => true
    | attribute_specifier'nt => false
    | assignment_operator'nt => false
    | assignment_expression'nt => false
    | asm_statement'nt => false
    | asm_operands_ne'nt => false
    | asm_operands'nt => true
    | asm_operand'nt => false
    | asm_op_name'nt => true
    | asm_flags'nt => false
    | asm_attributes'nt => true
    | asm_arguments'nt => true
    | argument_expression_list'nt => false
    | additive_expression'nt => false
    | abstract_declarator'nt => false
    | AND_expression'nt => false
  end.

Definition first_nterm (nt:nonterminal) : list terminal :=
  match nt with
    | unary_operator'nt => [TILDE't; STAR't; PLUS't; MINUS't; BANG't; AND't]
    | unary_expression'nt => [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't]
    | type_specifier'nt => [VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; SIGNED't; SHORT't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CHAR't]
    | type_qualifier_list'nt => [VOLATILE't; RESTRICT't; PACKED't; CONST't; ATTRIBUTE't; ALIGNAS't]
    | type_qualifier'nt => [VOLATILE't; RESTRICT't; PACKED't; CONST't; ATTRIBUTE't; ALIGNAS't]
    | type_name'nt => [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; SIGNED't; SHORT't; RESTRICT't; PACKED't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't]
    | translation_unit_file'nt => [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't]
    | translation_unit'nt => [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't]
    | struct_or_union_specifier'nt => [UNION't; STRUCT't]
    | struct_or_union'nt => [UNION't; STRUCT't]
    | struct_declarator_list'nt => [VAR_NAME't; STAR't; LPAREN't; COLON't]
    | struct_declarator'nt => [VAR_NAME't; STAR't; LPAREN't; COLON't]
    | struct_declaration_list'nt => [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; SIGNED't; SHORT't; RESTRICT't; PACKED't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't]
    | struct_declaration'nt => [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; SIGNED't; SHORT't; RESTRICT't; PACKED't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't]
    | storage_class_specifier'nt => [TYPEDEF't; STATIC't; REGISTER't; EXTERN't; AUTO't]
    | statement_safe'nt => [WHILE't; VAR_NAME't; TILDE't; SWITCH't; STRING_LITERAL't; STAR't; SIZEOF't; SEMICOLON't; RETURN't; PLUS't; OTHER_NAME't; MINUS't; LPAREN't; LBRACE't; INC't; IF't; GOTO't; FOR't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; ASM't; AND't; ALIGNOF't]
    | statement_dangerous'nt => [WHILE't; VAR_NAME't; TILDE't; SWITCH't; STRING_LITERAL't; STAR't; SIZEOF't; SEMICOLON't; RETURN't; PLUS't; OTHER_NAME't; MINUS't; LPAREN't; LBRACE't; INC't; IF't; GOTO't; FOR't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; ASM't; AND't; ALIGNOF't]
    | specifier_qualifier_list'nt => [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; SIGNED't; SHORT't; RESTRICT't; PACKED't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't]
    | shift_expression'nt => [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't]
    | selection_statement_safe'nt => [SWITCH't; IF't]
    | selection_statement_dangerous'nt => [SWITCH't; IF't]
    | relational_expression'nt => [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't]
    | primary_expression'nt => [VAR_NAME't; STRING_LITERAL't; LPAREN't; CONSTANT't]
    | postfix_expression'nt => [VAR_NAME't; STRING_LITERAL't; LPAREN't; CONSTANT't; BUILTIN_VA_ARG't]
    | pointer'nt => [STAR't]
    | parameter_type_list'nt => [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't]
    | parameter_list'nt => [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't]
    | parameter_declaration'nt => [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't]
    | old_function_declarator'nt => [VAR_NAME't; STAR't; LPAREN't]
    | multiplicative_expression'nt => [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't]
    | logical_OR_expression'nt => [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't]
    | logical_AND_expression'nt => [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't]
    | labeled_statement_statement_safe_'nt => [OTHER_NAME't; DEFAULT't; CASE't]
    | labeled_statement_statement_dangerous_'nt => [OTHER_NAME't; DEFAULT't; CASE't]
    | jump_statement'nt => [RETURN't; GOTO't; CONTINUE't; BREAK't]
    | iteration_statement_statement_safe_'nt => [WHILE't; FOR't; DO't]
    | iteration_statement_statement_dangerous_'nt => [WHILE't; FOR't; DO't]
    | initializer_list'nt => [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; LBRACK't; LBRACE't; INC't; DOT't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't]
    | init_declarator_list'nt => [VAR_NAME't; STAR't; LPAREN't]
    | init_declarator'nt => [VAR_NAME't; STAR't; LPAREN't]
    | inclusive_OR_expression'nt => [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't]
    | identifier_list'nt => [VAR_NAME't]
    | gcc_attribute_word'nt => [PACKED't; OTHER_NAME't; CONST't]
    | gcc_attribute_list'nt => [PACKED't; OTHER_NAME't; CONST't; COMMA't]
    | gcc_attribute'nt => [PACKED't; OTHER_NAME't; CONST't]
    | function_specifier'nt => [INLINE't]
    | function_definition'nt => [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't]
    | external_declaration'nt => [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't]
    | expression_statement'nt => [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; SEMICOLON't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't]
    | expression'nt => [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't]
    | exclusive_OR_expression'nt => [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't]
    | equality_expression'nt => [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't]
    | enumerator_list'nt => [VAR_NAME't]
    | enumerator'nt => [VAR_NAME't]
    | enumeration_constant'nt => [VAR_NAME't]
    | enum_specifier'nt => [ENUM't]
    | direct_old_function_declarator'nt => [VAR_NAME't; LPAREN't]
    | direct_declarator'nt => [VAR_NAME't; LPAREN't]
    | direct_abstract_declarator'nt => [LPAREN't; LBRACK't]
    | designator_list'nt => [LBRACK't; DOT't]
    | designator'nt => [LBRACK't; DOT't]
    | designation'nt => [LBRACK't; DOT't]
    | declarator'nt => [VAR_NAME't; STAR't; LPAREN't]
    | declaration_specifiers'nt => [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't]
    | declaration_list'nt => [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't]
    | declaration'nt => [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't]
    | constant_expression'nt => [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't]
    | conditional_expression'nt => [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't]
    | compound_statement'nt => [LBRACE't]
    | cast_expression'nt => [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't]
    | c_initializer'nt => [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; LBRACE't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't]
    | block_item_list'nt => [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't]
    | block_item'nt => [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't]
    | attribute_specifier_list'nt => [PACKED't; ATTRIBUTE't; ALIGNAS't]
    | attribute_specifier'nt => [PACKED't; ATTRIBUTE't; ALIGNAS't]
    | assignment_operator'nt => [XOR_ASSIGN't; SUB_ASSIGN't; RIGHT_ASSIGN't; OR_ASSIGN't; MUL_ASSIGN't; MOD_ASSIGN't; LEFT_ASSIGN't; EQ't; DIV_ASSIGN't; AND_ASSIGN't; ADD_ASSIGN't]
    | assignment_expression'nt => [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't]
    | asm_statement'nt => [ASM't]
    | asm_operands_ne'nt => [STRING_LITERAL't; LBRACK't]
    | asm_operands'nt => [STRING_LITERAL't; LBRACK't]
    | asm_operand'nt => [STRING_LITERAL't; LBRACK't]
    | asm_op_name'nt => [LBRACK't]
    | asm_flags'nt => [STRING_LITERAL't]
    | asm_attributes'nt => [VOLATILE't; CONST't]
    | asm_arguments'nt => [COLON't]
    | argument_expression_list'nt => [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't]
    | additive_expression'nt => [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't]
    | abstract_declarator'nt => [STAR't; LPAREN't; LBRACK't]
    | AND_expression'nt => [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't]
  end.

Inductive noninitstate' : Set :=
  | Nis'596
  | Nis'595
  | Nis'594
  | Nis'593
  | Nis'592
  | Nis'591
  | Nis'590
  | Nis'589
  | Nis'588
  | Nis'587
  | Nis'586
  | Nis'585
  | Nis'584
  | Nis'583
  | Nis'582
  | Nis'581
  | Nis'580
  | Nis'579
  | Nis'578
  | Nis'577
  | Nis'576
  | Nis'575
  | Nis'574
  | Nis'573
  | Nis'572
  | Nis'571
  | Nis'570
  | Nis'569
  | Nis'568
  | Nis'567
  | Nis'566
  | Nis'565
  | Nis'564
  | Nis'563
  | Nis'562
  | Nis'561
  | Nis'560
  | Nis'559
  | Nis'558
  | Nis'557
  | Nis'556
  | Nis'555
  | Nis'554
  | Nis'553
  | Nis'552
  | Nis'551
  | Nis'550
  | Nis'549
  | Nis'548
  | Nis'547
  | Nis'546
  | Nis'545
  | Nis'544
  | Nis'543
  | Nis'542
  | Nis'541
  | Nis'540
  | Nis'539
  | Nis'538
  | Nis'537
  | Nis'536
  | Nis'535
  | Nis'534
  | Nis'533
  | Nis'532
  | Nis'531
  | Nis'530
  | Nis'529
  | Nis'528
  | Nis'527
  | Nis'526
  | Nis'525
  | Nis'524
  | Nis'523
  | Nis'522
  | Nis'521
  | Nis'520
  | Nis'519
  | Nis'518
  | Nis'517
  | Nis'516
  | Nis'515
  | Nis'514
  | Nis'513
  | Nis'512
  | Nis'511
  | Nis'510
  | Nis'509
  | Nis'508
  | Nis'507
  | Nis'506
  | Nis'505
  | Nis'504
  | Nis'503
  | Nis'502
  | Nis'501
  | Nis'500
  | Nis'499
  | Nis'498
  | Nis'497
  | Nis'496
  | Nis'495
  | Nis'494
  | Nis'493
  | Nis'492
  | Nis'491
  | Nis'490
  | Nis'489
  | Nis'488
  | Nis'487
  | Nis'486
  | Nis'485
  | Nis'484
  | Nis'483
  | Nis'482
  | Nis'481
  | Nis'480
  | Nis'479
  | Nis'478
  | Nis'477
  | Nis'476
  | Nis'475
  | Nis'474
  | Nis'473
  | Nis'472
  | Nis'471
  | Nis'470
  | Nis'469
  | Nis'468
  | Nis'467
  | Nis'466
  | Nis'465
  | Nis'464
  | Nis'463
  | Nis'462
  | Nis'461
  | Nis'460
  | Nis'459
  | Nis'458
  | Nis'457
  | Nis'456
  | Nis'455
  | Nis'454
  | Nis'453
  | Nis'452
  | Nis'451
  | Nis'450
  | Nis'449
  | Nis'448
  | Nis'447
  | Nis'446
  | Nis'445
  | Nis'444
  | Nis'443
  | Nis'442
  | Nis'441
  | Nis'440
  | Nis'439
  | Nis'438
  | Nis'437
  | Nis'436
  | Nis'435
  | Nis'434
  | Nis'433
  | Nis'432
  | Nis'431
  | Nis'430
  | Nis'429
  | Nis'428
  | Nis'427
  | Nis'426
  | Nis'425
  | Nis'424
  | Nis'423
  | Nis'422
  | Nis'421
  | Nis'420
  | Nis'419
  | Nis'418
  | Nis'417
  | Nis'416
  | Nis'415
  | Nis'414
  | Nis'413
  | Nis'412
  | Nis'411
  | Nis'410
  | Nis'409
  | Nis'408
  | Nis'407
  | Nis'406
  | Nis'405
  | Nis'404
  | Nis'403
  | Nis'402
  | Nis'401
  | Nis'400
  | Nis'399
  | Nis'398
  | Nis'397
  | Nis'396
  | Nis'395
  | Nis'394
  | Nis'393
  | Nis'392
  | Nis'391
  | Nis'390
  | Nis'389
  | Nis'388
  | Nis'387
  | Nis'386
  | Nis'385
  | Nis'384
  | Nis'383
  | Nis'382
  | Nis'381
  | Nis'380
  | Nis'379
  | Nis'378
  | Nis'377
  | Nis'376
  | Nis'375
  | Nis'374
  | Nis'373
  | Nis'372
  | Nis'371
  | Nis'370
  | Nis'369
  | Nis'368
  | Nis'367
  | Nis'366
  | Nis'365
  | Nis'364
  | Nis'363
  | Nis'362
  | Nis'361
  | Nis'360
  | Nis'359
  | Nis'358
  | Nis'357
  | Nis'356
  | Nis'355
  | Nis'354
  | Nis'353
  | Nis'352
  | Nis'351
  | Nis'350
  | Nis'349
  | Nis'348
  | Nis'347
  | Nis'346
  | Nis'345
  | Nis'344
  | Nis'343
  | Nis'342
  | Nis'341
  | Nis'340
  | Nis'339
  | Nis'338
  | Nis'337
  | Nis'336
  | Nis'335
  | Nis'334
  | Nis'332
  | Nis'331
  | Nis'330
  | Nis'329
  | Nis'328
  | Nis'327
  | Nis'326
  | Nis'325
  | Nis'324
  | Nis'323
  | Nis'322
  | Nis'321
  | Nis'320
  | Nis'319
  | Nis'318
  | Nis'317
  | Nis'316
  | Nis'315
  | Nis'314
  | Nis'313
  | Nis'312
  | Nis'311
  | Nis'310
  | Nis'309
  | Nis'308
  | Nis'307
  | Nis'306
  | Nis'305
  | Nis'304
  | Nis'303
  | Nis'302
  | Nis'301
  | Nis'300
  | Nis'299
  | Nis'298
  | Nis'297
  | Nis'296
  | Nis'295
  | Nis'294
  | Nis'293
  | Nis'292
  | Nis'291
  | Nis'290
  | Nis'289
  | Nis'288
  | Nis'287
  | Nis'286
  | Nis'285
  | Nis'284
  | Nis'283
  | Nis'282
  | Nis'281
  | Nis'280
  | Nis'279
  | Nis'278
  | Nis'277
  | Nis'276
  | Nis'275
  | Nis'274
  | Nis'273
  | Nis'272
  | Nis'271
  | Nis'270
  | Nis'269
  | Nis'268
  | Nis'267
  | Nis'266
  | Nis'265
  | Nis'264
  | Nis'263
  | Nis'262
  | Nis'261
  | Nis'260
  | Nis'259
  | Nis'258
  | Nis'257
  | Nis'256
  | Nis'255
  | Nis'254
  | Nis'253
  | Nis'252
  | Nis'251
  | Nis'250
  | Nis'249
  | Nis'248
  | Nis'247
  | Nis'246
  | Nis'245
  | Nis'244
  | Nis'243
  | Nis'242
  | Nis'241
  | Nis'240
  | Nis'239
  | Nis'238
  | Nis'237
  | Nis'236
  | Nis'235
  | Nis'234
  | Nis'233
  | Nis'232
  | Nis'231
  | Nis'230
  | Nis'229
  | Nis'228
  | Nis'227
  | Nis'226
  | Nis'225
  | Nis'224
  | Nis'223
  | Nis'222
  | Nis'221
  | Nis'220
  | Nis'219
  | Nis'218
  | Nis'217
  | Nis'216
  | Nis'215
  | Nis'214
  | Nis'213
  | Nis'212
  | Nis'211
  | Nis'210
  | Nis'209
  | Nis'208
  | Nis'207
  | Nis'206
  | Nis'205
  | Nis'204
  | Nis'203
  | Nis'202
  | Nis'201
  | Nis'200
  | Nis'199
  | Nis'198
  | Nis'197
  | Nis'196
  | Nis'195
  | Nis'194
  | Nis'193
  | Nis'192
  | Nis'191
  | Nis'190
  | Nis'189
  | Nis'188
  | Nis'187
  | Nis'186
  | Nis'185
  | Nis'184
  | Nis'183
  | Nis'182
  | Nis'181
  | Nis'180
  | Nis'179
  | Nis'178
  | Nis'177
  | Nis'176
  | Nis'175
  | Nis'174
  | Nis'173
  | Nis'172
  | Nis'171
  | Nis'170
  | Nis'169
  | Nis'168
  | Nis'167
  | Nis'166
  | Nis'165
  | Nis'164
  | Nis'163
  | Nis'162
  | Nis'161
  | Nis'160
  | Nis'159
  | Nis'158
  | Nis'157
  | Nis'156
  | Nis'155
  | Nis'154
  | Nis'153
  | Nis'152
  | Nis'151
  | Nis'150
  | Nis'149
  | Nis'148
  | Nis'147
  | Nis'146
  | Nis'145
  | Nis'144
  | Nis'143
  | Nis'142
  | Nis'141
  | Nis'140
  | Nis'139
  | Nis'138
  | Nis'137
  | Nis'136
  | Nis'135
  | Nis'134
  | Nis'133
  | Nis'132
  | Nis'131
  | Nis'130
  | Nis'129
  | Nis'128
  | Nis'127
  | Nis'126
  | Nis'125
  | Nis'124
  | Nis'123
  | Nis'122
  | Nis'121
  | Nis'120
  | Nis'119
  | Nis'118
  | Nis'117
  | Nis'116
  | Nis'115
  | Nis'114
  | Nis'113
  | Nis'112
  | Nis'111
  | Nis'110
  | Nis'109
  | Nis'108
  | Nis'107
  | Nis'106
  | Nis'105
  | Nis'104
  | Nis'103
  | Nis'102
  | Nis'101
  | Nis'100
  | Nis'99
  | Nis'98
  | Nis'97
  | Nis'96
  | Nis'95
  | Nis'94
  | Nis'93
  | Nis'92
  | Nis'91
  | Nis'90
  | Nis'89
  | Nis'88
  | Nis'87
  | Nis'86
  | Nis'85
  | Nis'84
  | Nis'83
  | Nis'82
  | Nis'81
  | Nis'80
  | Nis'79
  | Nis'78
  | Nis'77
  | Nis'76
  | Nis'75
  | Nis'74
  | Nis'73
  | Nis'72
  | Nis'71
  | Nis'70
  | Nis'69
  | Nis'68
  | Nis'67
  | Nis'66
  | Nis'65
  | Nis'64
  | Nis'63
  | Nis'62
  | Nis'61
  | Nis'60
  | Nis'59
  | Nis'58
  | Nis'57
  | Nis'56
  | Nis'55
  | Nis'54
  | Nis'53
  | Nis'52
  | Nis'51
  | Nis'50
  | Nis'49
  | Nis'48
  | Nis'47
  | Nis'46
  | Nis'45
  | Nis'44
  | Nis'43
  | Nis'42
  | Nis'41
  | Nis'40
  | Nis'39
  | Nis'38
  | Nis'37
  | Nis'36
  | Nis'35
  | Nis'34
  | Nis'33
  | Nis'32
  | Nis'31
  | Nis'30
  | Nis'29
  | Nis'28
  | Nis'27
  | Nis'26
  | Nis'25
  | Nis'24
  | Nis'23
  | Nis'22
  | Nis'21
  | Nis'20
  | Nis'19
  | Nis'18
  | Nis'17
  | Nis'16
  | Nis'15
  | Nis'14
  | Nis'13
  | Nis'12
  | Nis'11
  | Nis'10
  | Nis'9
  | Nis'8
  | Nis'7
  | Nis'6
  | Nis'5
  | Nis'4
  | Nis'3
  | Nis'2
  | Nis'1.
Definition noninitstate := noninitstate'.

Program Instance noninitstateNum : Numbered noninitstate :=
  { inj := fun x => match x return _ with | Nis'596 => Int31.On | Nis'595 => Int31.In | Nis'594 => (twice Int31.In) | Nis'593 => (twice_plus_one Int31.In) | Nis'592 => (twice (twice Int31.In)) | Nis'591 => (twice_plus_one (twice Int31.In)) | Nis'590 => (twice (twice_plus_one Int31.In)) | Nis'589 => (twice_plus_one (twice_plus_one Int31.In)) | Nis'588 => (twice (twice (twice Int31.In))) | Nis'587 => (twice_plus_one (twice (twice Int31.In))) | Nis'586 => (twice (twice_plus_one (twice Int31.In))) | Nis'585 => (twice_plus_one (twice_plus_one (twice Int31.In))) | Nis'584 => (twice (twice (twice_plus_one Int31.In))) | Nis'583 => (twice_plus_one (twice (twice_plus_one Int31.In))) | Nis'582 => (twice (twice_plus_one (twice_plus_one Int31.In))) | Nis'581 => (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))) | Nis'580 => (twice (twice (twice (twice Int31.In)))) | Nis'579 => (twice_plus_one (twice (twice (twice Int31.In)))) | Nis'578 => (twice (twice_plus_one (twice (twice Int31.In)))) | Nis'577 => (twice_plus_one (twice_plus_one (twice (twice Int31.In)))) | Nis'576 => (twice (twice (twice_plus_one (twice Int31.In)))) | Nis'575 => (twice_plus_one (twice (twice_plus_one (twice Int31.In)))) | Nis'574 => (twice (twice_plus_one (twice_plus_one (twice Int31.In)))) | Nis'573 => (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In)))) | Nis'572 => (twice (twice (twice (twice_plus_one Int31.In)))) | Nis'571 => (twice_plus_one (twice (twice (twice_plus_one Int31.In)))) | Nis'570 => (twice (twice_plus_one (twice (twice_plus_one Int31.In)))) | Nis'569 => (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In)))) | Nis'568 => (twice (twice (twice_plus_one (twice_plus_one Int31.In)))) | Nis'567 => (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In)))) | Nis'566 => (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))) | Nis'565 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))) | Nis'564 => (twice (twice (twice (twice (twice Int31.In))))) | Nis'563 => (twice_plus_one (twice (twice (twice (twice Int31.In))))) | Nis'562 => (twice (twice_plus_one (twice (twice (twice Int31.In))))) | Nis'561 => (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In))))) | Nis'560 => (twice (twice (twice_plus_one (twice (twice Int31.In))))) | Nis'559 => (twice_plus_one (twice (twice_plus_one (twice (twice Int31.In))))) | Nis'558 => (twice (twice_plus_one (twice_plus_one (twice (twice Int31.In))))) | Nis'557 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice Int31.In))))) | Nis'556 => (twice (twice (twice (twice_plus_one (twice Int31.In))))) | Nis'555 => (twice_plus_one (twice (twice (twice_plus_one (twice Int31.In))))) | Nis'554 => (twice (twice_plus_one (twice (twice_plus_one (twice Int31.In))))) | Nis'553 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice Int31.In))))) | Nis'552 => (twice (twice (twice_plus_one (twice_plus_one (twice Int31.In))))) | Nis'551 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice Int31.In))))) | Nis'550 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In))))) | Nis'549 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In))))) | Nis'548 => (twice (twice (twice (twice (twice_plus_one Int31.In))))) | Nis'547 => (twice_plus_one (twice (twice (twice (twice_plus_one Int31.In))))) | Nis'546 => (twice (twice_plus_one (twice (twice (twice_plus_one Int31.In))))) | Nis'545 => (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one Int31.In))))) | Nis'544 => (twice (twice (twice_plus_one (twice (twice_plus_one Int31.In))))) | Nis'543 => (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one Int31.In))))) | Nis'542 => (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In))))) | Nis'541 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In))))) | Nis'540 => (twice (twice (twice (twice_plus_one (twice_plus_one Int31.In))))) | Nis'539 => (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one Int31.In))))) | Nis'538 => (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In))))) | Nis'537 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In))))) | Nis'536 => (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))) | Nis'535 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))) | Nis'534 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))) | Nis'533 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))) | Nis'532 => (twice (twice (twice (twice (twice (twice Int31.In)))))) | Nis'531 => (twice_plus_one (twice (twice (twice (twice (twice Int31.In)))))) | Nis'530 => (twice (twice_plus_one (twice (twice (twice (twice Int31.In)))))) | Nis'529 => (twice_plus_one (twice_plus_one (twice (twice (twice (twice Int31.In)))))) | Nis'528 => (twice (twice (twice_plus_one (twice (twice (twice Int31.In)))))) | Nis'527 => (twice_plus_one (twice (twice_plus_one (twice (twice (twice Int31.In)))))) | Nis'526 => (twice (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In)))))) | Nis'525 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In)))))) | Nis'524 => (twice (twice (twice (twice_plus_one (twice (twice Int31.In)))))) | Nis'523 => (twice_plus_one (twice (twice (twice_plus_one (twice (twice Int31.In)))))) | Nis'522 => (twice (twice_plus_one (twice (twice_plus_one (twice (twice Int31.In)))))) | Nis'521 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice Int31.In)))))) | Nis'520 => (twice (twice (twice_plus_one (twice_plus_one (twice (twice Int31.In)))))) | Nis'519 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice Int31.In)))))) | Nis'518 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice Int31.In)))))) | Nis'517 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice Int31.In)))))) | Nis'516 => (twice (twice (twice (twice (twice_plus_one (twice Int31.In)))))) | Nis'515 => (twice_plus_one (twice (twice (twice (twice_plus_one (twice Int31.In)))))) | Nis'514 => (twice (twice_plus_one (twice (twice (twice_plus_one (twice Int31.In)))))) | Nis'513 => (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice Int31.In)))))) | Nis'512 => (twice (twice (twice_plus_one (twice (twice_plus_one (twice Int31.In)))))) | Nis'511 => (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice Int31.In)))))) | Nis'510 => (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice Int31.In)))))) | Nis'509 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice Int31.In)))))) | Nis'508 => (twice (twice (twice (twice_plus_one (twice_plus_one (twice Int31.In)))))) | Nis'507 => (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice Int31.In)))))) | Nis'506 => (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice Int31.In)))))) | Nis'505 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice Int31.In)))))) | Nis'504 => (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In)))))) | Nis'503 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In)))))) | Nis'502 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In)))))) | Nis'501 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In)))))) | Nis'500 => (twice (twice (twice (twice (twice (twice_plus_one Int31.In)))))) | Nis'499 => (twice_plus_one (twice (twice (twice (twice (twice_plus_one Int31.In)))))) | Nis'498 => (twice (twice_plus_one (twice (twice (twice (twice_plus_one Int31.In)))))) | Nis'497 => (twice_plus_one (twice_plus_one (twice (twice (twice (twice_plus_one Int31.In)))))) | Nis'496 => (twice (twice (twice_plus_one (twice (twice (twice_plus_one Int31.In)))))) | Nis'495 => (twice_plus_one (twice (twice_plus_one (twice (twice (twice_plus_one Int31.In)))))) | Nis'494 => (twice (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one Int31.In)))))) | Nis'493 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one Int31.In)))))) | Nis'492 => (twice (twice (twice (twice_plus_one (twice (twice_plus_one Int31.In)))))) | Nis'491 => (twice_plus_one (twice (twice (twice_plus_one (twice (twice_plus_one Int31.In)))))) | Nis'490 => (twice (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one Int31.In)))))) | Nis'489 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one Int31.In)))))) | Nis'488 => (twice (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In)))))) | Nis'487 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In)))))) | Nis'486 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In)))))) | Nis'485 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In)))))) | Nis'484 => (twice (twice (twice (twice (twice_plus_one (twice_plus_one Int31.In)))))) | Nis'483 => (twice_plus_one (twice (twice (twice (twice_plus_one (twice_plus_one Int31.In)))))) | Nis'482 => (twice (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one Int31.In)))))) | Nis'481 => (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one Int31.In)))))) | Nis'480 => (twice (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In)))))) | Nis'479 => (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In)))))) | Nis'478 => (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In)))))) | Nis'477 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In)))))) | Nis'476 => (twice (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))) | Nis'475 => (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))) | Nis'474 => (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))) | Nis'473 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))) | Nis'472 => (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))) | Nis'471 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))) | Nis'470 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))) | Nis'469 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))) | Nis'468 => (twice (twice (twice (twice (twice (twice (twice Int31.In))))))) | Nis'467 => (twice_plus_one (twice (twice (twice (twice (twice (twice Int31.In))))))) | Nis'466 => (twice (twice_plus_one (twice (twice (twice (twice (twice Int31.In))))))) | Nis'465 => (twice_plus_one (twice_plus_one (twice (twice (twice (twice (twice Int31.In))))))) | Nis'464 => (twice (twice (twice_plus_one (twice (twice (twice (twice Int31.In))))))) | Nis'463 => (twice_plus_one (twice (twice_plus_one (twice (twice (twice (twice Int31.In))))))) | Nis'462 => (twice (twice_plus_one (twice_plus_one (twice (twice (twice (twice Int31.In))))))) | Nis'461 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice (twice Int31.In))))))) | Nis'460 => (twice (twice (twice (twice_plus_one (twice (twice (twice Int31.In))))))) | Nis'459 => (twice_plus_one (twice (twice (twice_plus_one (twice (twice (twice Int31.In))))))) | Nis'458 => (twice (twice_plus_one (twice (twice_plus_one (twice (twice (twice Int31.In))))))) | Nis'457 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice (twice Int31.In))))))) | Nis'456 => (twice (twice (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In))))))) | Nis'455 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In))))))) | Nis'454 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In))))))) | Nis'453 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In))))))) | Nis'452 => (twice (twice (twice (twice (twice_plus_one (twice (twice Int31.In))))))) | Nis'451 => (twice_plus_one (twice (twice (twice (twice_plus_one (twice (twice Int31.In))))))) | Nis'450 => (twice (twice_plus_one (twice (twice (twice_plus_one (twice (twice Int31.In))))))) | Nis'449 => (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice (twice Int31.In))))))) | Nis'448 => (twice (twice (twice_plus_one (twice (twice_plus_one (twice (twice Int31.In))))))) | Nis'447 => (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice (twice Int31.In))))))) | Nis'446 => (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice Int31.In))))))) | Nis'445 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice Int31.In))))))) | Nis'444 => (twice (twice (twice (twice_plus_one (twice_plus_one (twice (twice Int31.In))))))) | Nis'443 => (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice (twice Int31.In))))))) | Nis'442 => (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice Int31.In))))))) | Nis'441 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice Int31.In))))))) | Nis'440 => (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice Int31.In))))))) | Nis'439 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice Int31.In))))))) | Nis'438 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice Int31.In))))))) | Nis'437 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice Int31.In))))))) | Nis'436 => (twice (twice (twice (twice (twice (twice_plus_one (twice Int31.In))))))) | Nis'435 => (twice_plus_one (twice (twice (twice (twice (twice_plus_one (twice Int31.In))))))) | Nis'434 => (twice (twice_plus_one (twice (twice (twice (twice_plus_one (twice Int31.In))))))) | Nis'433 => (twice_plus_one (twice_plus_one (twice (twice (twice (twice_plus_one (twice Int31.In))))))) | Nis'432 => (twice (twice (twice_plus_one (twice (twice (twice_plus_one (twice Int31.In))))))) | Nis'431 => (twice_plus_one (twice (twice_plus_one (twice (twice (twice_plus_one (twice Int31.In))))))) | Nis'430 => (twice (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice Int31.In))))))) | Nis'429 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice Int31.In))))))) | Nis'428 => (twice (twice (twice (twice_plus_one (twice (twice_plus_one (twice Int31.In))))))) | Nis'427 => (twice_plus_one (twice (twice (twice_plus_one (twice (twice_plus_one (twice Int31.In))))))) | Nis'426 => (twice (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice Int31.In))))))) | Nis'425 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice Int31.In))))))) | Nis'424 => (twice (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice Int31.In))))))) | Nis'423 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice Int31.In))))))) | Nis'422 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice Int31.In))))))) | Nis'421 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice Int31.In))))))) | Nis'420 => (twice (twice (twice (twice (twice_plus_one (twice_plus_one (twice Int31.In))))))) | Nis'419 => (twice_plus_one (twice (twice (twice (twice_plus_one (twice_plus_one (twice Int31.In))))))) | Nis'418 => (twice (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice Int31.In))))))) | Nis'417 => (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice Int31.In))))))) | Nis'416 => (twice (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice Int31.In))))))) | Nis'415 => (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice Int31.In))))))) | Nis'414 => (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice Int31.In))))))) | Nis'413 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice Int31.In))))))) | Nis'412 => (twice (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In))))))) | Nis'411 => (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In))))))) | Nis'410 => (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In))))))) | Nis'409 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In))))))) | Nis'408 => (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In))))))) | Nis'407 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In))))))) | Nis'406 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In))))))) | Nis'405 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In))))))) | Nis'404 => (twice (twice (twice (twice (twice (twice (twice_plus_one Int31.In))))))) | Nis'403 => (twice_plus_one (twice (twice (twice (twice (twice (twice_plus_one Int31.In))))))) | Nis'402 => (twice (twice_plus_one (twice (twice (twice (twice (twice_plus_one Int31.In))))))) | Nis'401 => (twice_plus_one (twice_plus_one (twice (twice (twice (twice (twice_plus_one Int31.In))))))) | Nis'400 => (twice (twice (twice_plus_one (twice (twice (twice (twice_plus_one Int31.In))))))) | Nis'399 => (twice_plus_one (twice (twice_plus_one (twice (twice (twice (twice_plus_one Int31.In))))))) | Nis'398 => (twice (twice_plus_one (twice_plus_one (twice (twice (twice (twice_plus_one Int31.In))))))) | Nis'397 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice (twice_plus_one Int31.In))))))) | Nis'396 => (twice (twice (twice (twice_plus_one (twice (twice (twice_plus_one Int31.In))))))) | Nis'395 => (twice_plus_one (twice (twice (twice_plus_one (twice (twice (twice_plus_one Int31.In))))))) | Nis'394 => (twice (twice_plus_one (twice (twice_plus_one (twice (twice (twice_plus_one Int31.In))))))) | Nis'393 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice (twice_plus_one Int31.In))))))) | Nis'392 => (twice (twice (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one Int31.In))))))) | Nis'391 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one Int31.In))))))) | Nis'390 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one Int31.In))))))) | Nis'389 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one Int31.In))))))) | Nis'388 => (twice (twice (twice (twice (twice_plus_one (twice (twice_plus_one Int31.In))))))) | Nis'387 => (twice_plus_one (twice (twice (twice (twice_plus_one (twice (twice_plus_one Int31.In))))))) | Nis'386 => (twice (twice_plus_one (twice (twice (twice_plus_one (twice (twice_plus_one Int31.In))))))) | Nis'385 => (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice (twice_plus_one Int31.In))))))) | Nis'384 => (twice (twice (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one Int31.In))))))) | Nis'383 => (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one Int31.In))))))) | Nis'382 => (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one Int31.In))))))) | Nis'381 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one Int31.In))))))) | Nis'380 => (twice (twice (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In))))))) | Nis'379 => (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In))))))) | Nis'378 => (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In))))))) | Nis'377 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In))))))) | Nis'376 => (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In))))))) | Nis'375 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In))))))) | Nis'374 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In))))))) | Nis'373 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In))))))) | Nis'372 => (twice (twice (twice (twice (twice (twice_plus_one (twice_plus_one Int31.In))))))) | Nis'371 => (twice_plus_one (twice (twice (twice (twice (twice_plus_one (twice_plus_one Int31.In))))))) | Nis'370 => (twice (twice_plus_one (twice (twice (twice (twice_plus_one (twice_plus_one Int31.In))))))) | Nis'369 => (twice_plus_one (twice_plus_one (twice (twice (twice (twice_plus_one (twice_plus_one Int31.In))))))) | Nis'368 => (twice (twice (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one Int31.In))))))) | Nis'367 => (twice_plus_one (twice (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one Int31.In))))))) | Nis'366 => (twice (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one Int31.In))))))) | Nis'365 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one Int31.In))))))) | Nis'364 => (twice (twice (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In))))))) | Nis'363 => (twice_plus_one (twice (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In))))))) | Nis'362 => (twice (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In))))))) | Nis'361 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In))))))) | Nis'360 => (twice (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In))))))) | Nis'359 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In))))))) | Nis'358 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In))))))) | Nis'357 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In))))))) | Nis'356 => (twice (twice (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))))) | Nis'355 => (twice_plus_one (twice (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))))) | Nis'354 => (twice (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))))) | Nis'353 => (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))))) | Nis'352 => (twice (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))))) | Nis'351 => (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))))) | Nis'350 => (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))))) | Nis'349 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))))) | Nis'348 => (twice (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))))) | Nis'347 => (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))))) | Nis'346 => (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))))) | Nis'345 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))))) | Nis'344 => (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))))) | Nis'343 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))))) | Nis'342 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))))) | Nis'341 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In))))))) | Nis'340 => (twice (twice (twice (twice (twice (twice (twice (twice Int31.In)))))))) | Nis'339 => (twice_plus_one (twice (twice (twice (twice (twice (twice (twice Int31.In)))))))) | Nis'338 => (twice (twice_plus_one (twice (twice (twice (twice (twice (twice Int31.In)))))))) | Nis'337 => (twice_plus_one (twice_plus_one (twice (twice (twice (twice (twice (twice Int31.In)))))))) | Nis'336 => (twice (twice (twice_plus_one (twice (twice (twice (twice (twice Int31.In)))))))) | Nis'335 => (twice_plus_one (twice (twice_plus_one (twice (twice (twice (twice (twice Int31.In)))))))) | Nis'334 => (twice (twice_plus_one (twice_plus_one (twice (twice (twice (twice (twice Int31.In)))))))) | Nis'332 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice (twice (twice Int31.In)))))))) | Nis'331 => (twice (twice (twice (twice_plus_one (twice (twice (twice (twice Int31.In)))))))) | Nis'330 => (twice_plus_one (twice (twice (twice_plus_one (twice (twice (twice (twice Int31.In)))))))) | Nis'329 => (twice (twice_plus_one (twice (twice_plus_one (twice (twice (twice (twice Int31.In)))))))) | Nis'328 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice (twice (twice Int31.In)))))))) | Nis'327 => (twice (twice (twice_plus_one (twice_plus_one (twice (twice (twice (twice Int31.In)))))))) | Nis'326 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice (twice (twice Int31.In)))))))) | Nis'325 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice (twice Int31.In)))))))) | Nis'324 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice (twice Int31.In)))))))) | Nis'323 => (twice (twice (twice (twice (twice_plus_one (twice (twice (twice Int31.In)))))))) | Nis'322 => (twice_plus_one (twice (twice (twice (twice_plus_one (twice (twice (twice Int31.In)))))))) | Nis'321 => (twice (twice_plus_one (twice (twice (twice_plus_one (twice (twice (twice Int31.In)))))))) | Nis'320 => (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice (twice (twice Int31.In)))))))) | Nis'319 => (twice (twice (twice_plus_one (twice (twice_plus_one (twice (twice (twice Int31.In)))))))) | Nis'318 => (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice (twice (twice Int31.In)))))))) | Nis'317 => (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice (twice Int31.In)))))))) | Nis'316 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice (twice Int31.In)))))))) | Nis'315 => (twice (twice (twice (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In)))))))) | Nis'314 => (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In)))))))) | Nis'313 => (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In)))))))) | Nis'312 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In)))))))) | Nis'311 => (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In)))))))) | Nis'310 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In)))))))) | Nis'309 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In)))))))) | Nis'308 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In)))))))) | Nis'307 => (twice (twice (twice (twice (twice (twice_plus_one (twice (twice Int31.In)))))))) | Nis'306 => (twice_plus_one (twice (twice (twice (twice (twice_plus_one (twice (twice Int31.In)))))))) | Nis'305 => (twice (twice_plus_one (twice (twice (twice (twice_plus_one (twice (twice Int31.In)))))))) | Nis'304 => (twice_plus_one (twice_plus_one (twice (twice (twice (twice_plus_one (twice (twice Int31.In)))))))) | Nis'303 => (twice (twice (twice_plus_one (twice (twice (twice_plus_one (twice (twice Int31.In)))))))) | Nis'302 => (twice_plus_one (twice (twice_plus_one (twice (twice (twice_plus_one (twice (twice Int31.In)))))))) | Nis'301 => (twice (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice (twice Int31.In)))))))) | Nis'300 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice (twice Int31.In)))))))) | Nis'299 => (twice (twice (twice (twice_plus_one (twice (twice_plus_one (twice (twice Int31.In)))))))) | Nis'298 => (twice_plus_one (twice (twice (twice_plus_one (twice (twice_plus_one (twice (twice Int31.In)))))))) | Nis'297 => (twice (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice (twice Int31.In)))))))) | Nis'296 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice (twice Int31.In)))))))) | Nis'295 => (twice (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice Int31.In)))))))) | Nis'294 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice Int31.In)))))))) | Nis'293 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice Int31.In)))))))) | Nis'292 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice Int31.In)))))))) | Nis'291 => (twice (twice (twice (twice (twice_plus_one (twice_plus_one (twice (twice Int31.In)))))))) | Nis'290 => (twice_plus_one (twice (twice (twice (twice_plus_one (twice_plus_one (twice (twice Int31.In)))))))) | Nis'289 => (twice (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice (twice Int31.In)))))))) | Nis'288 => (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice (twice Int31.In)))))))) | Nis'287 => (twice (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice Int31.In)))))))) | Nis'286 => (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice Int31.In)))))))) | Nis'285 => (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice Int31.In)))))))) | Nis'284 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice Int31.In)))))))) | Nis'283 => (twice (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice Int31.In)))))))) | Nis'282 => (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice Int31.In)))))))) | Nis'281 => (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice Int31.In)))))))) | Nis'280 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice Int31.In)))))))) | Nis'279 => (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice Int31.In)))))))) | Nis'278 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice Int31.In)))))))) | Nis'277 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice Int31.In)))))))) | Nis'276 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice Int31.In)))))))) | Nis'275 => (twice (twice (twice (twice (twice (twice (twice_plus_one (twice Int31.In)))))))) | Nis'274 => (twice_plus_one (twice (twice (twice (twice (twice (twice_plus_one (twice Int31.In)))))))) | Nis'273 => (twice (twice_plus_one (twice (twice (twice (twice (twice_plus_one (twice Int31.In)))))))) | Nis'272 => (twice_plus_one (twice_plus_one (twice (twice (twice (twice (twice_plus_one (twice Int31.In)))))))) | Nis'271 => (twice (twice (twice_plus_one (twice (twice (twice (twice_plus_one (twice Int31.In)))))))) | Nis'270 => (twice_plus_one (twice (twice_plus_one (twice (twice (twice (twice_plus_one (twice Int31.In)))))))) | Nis'269 => (twice (twice_plus_one (twice_plus_one (twice (twice (twice (twice_plus_one (twice Int31.In)))))))) | Nis'268 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice (twice_plus_one (twice Int31.In)))))))) | Nis'267 => (twice (twice (twice (twice_plus_one (twice (twice (twice_plus_one (twice Int31.In)))))))) | Nis'266 => (twice_plus_one (twice (twice (twice_plus_one (twice (twice (twice_plus_one (twice Int31.In)))))))) | Nis'265 => (twice (twice_plus_one (twice (twice_plus_one (twice (twice (twice_plus_one (twice Int31.In)))))))) | Nis'264 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice (twice_plus_one (twice Int31.In)))))))) | Nis'263 => (twice (twice (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice Int31.In)))))))) | Nis'262 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice Int31.In)))))))) | Nis'261 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice Int31.In)))))))) | Nis'260 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice Int31.In)))))))) | Nis'259 => (twice (twice (twice (twice (twice_plus_one (twice (twice_plus_one (twice Int31.In)))))))) | Nis'258 => (twice_plus_one (twice (twice (twice (twice_plus_one (twice (twice_plus_one (twice Int31.In)))))))) | Nis'257 => (twice (twice_plus_one (twice (twice (twice_plus_one (twice (twice_plus_one (twice Int31.In)))))))) | Nis'256 => (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice (twice_plus_one (twice Int31.In)))))))) | Nis'255 => (twice (twice (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice Int31.In)))))))) | Nis'254 => (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice Int31.In)))))))) | Nis'253 => (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice Int31.In)))))))) | Nis'252 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice Int31.In)))))))) | Nis'251 => (twice (twice (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice Int31.In)))))))) | Nis'250 => (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice Int31.In)))))))) | Nis'249 => (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice Int31.In)))))))) | Nis'248 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice Int31.In)))))))) | Nis'247 => (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice Int31.In)))))))) | Nis'246 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice Int31.In)))))))) | Nis'245 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice Int31.In)))))))) | Nis'244 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice Int31.In)))))))) | Nis'243 => (twice (twice (twice (twice (twice (twice_plus_one (twice_plus_one (twice Int31.In)))))))) | Nis'242 => (twice_plus_one (twice (twice (twice (twice (twice_plus_one (twice_plus_one (twice Int31.In)))))))) | Nis'241 => (twice (twice_plus_one (twice (twice (twice (twice_plus_one (twice_plus_one (twice Int31.In)))))))) | Nis'240 => (twice_plus_one (twice_plus_one (twice (twice (twice (twice_plus_one (twice_plus_one (twice Int31.In)))))))) | Nis'239 => (twice (twice (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice Int31.In)))))))) | Nis'238 => (twice_plus_one (twice (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice Int31.In)))))))) | Nis'237 => (twice (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice Int31.In)))))))) | Nis'236 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice Int31.In)))))))) | Nis'235 => (twice (twice (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice Int31.In)))))))) | Nis'234 => (twice_plus_one (twice (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice Int31.In)))))))) | Nis'233 => (twice (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice Int31.In)))))))) | Nis'232 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice Int31.In)))))))) | Nis'231 => (twice (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice Int31.In)))))))) | Nis'230 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice Int31.In)))))))) | Nis'229 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice Int31.In)))))))) | Nis'228 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice Int31.In)))))))) | Nis'227 => (twice (twice (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In)))))))) | Nis'226 => (twice_plus_one (twice (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In)))))))) | Nis'225 => (twice (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In)))))))) | Nis'224 => (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In)))))))) | Nis'223 => (twice (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In)))))))) | Nis'222 => (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In)))))))) | Nis'221 => (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In)))))))) | Nis'220 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In)))))))) | Nis'219 => (twice (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In)))))))) | Nis'218 => (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In)))))))) | Nis'217 => (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In)))))))) | Nis'216 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In)))))))) | Nis'215 => (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In)))))))) | Nis'214 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In)))))))) | Nis'213 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In)))))))) | Nis'212 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice Int31.In)))))))) | Nis'211 => (twice (twice (twice (twice (twice (twice (twice (twice_plus_one Int31.In)))))))) | Nis'210 => (twice_plus_one (twice (twice (twice (twice (twice (twice (twice_plus_one Int31.In)))))))) | Nis'209 => (twice (twice_plus_one (twice (twice (twice (twice (twice (twice_plus_one Int31.In)))))))) | Nis'208 => (twice_plus_one (twice_plus_one (twice (twice (twice (twice (twice (twice_plus_one Int31.In)))))))) | Nis'207 => (twice (twice (twice_plus_one (twice (twice (twice (twice (twice_plus_one Int31.In)))))))) | Nis'206 => (twice_plus_one (twice (twice_plus_one (twice (twice (twice (twice (twice_plus_one Int31.In)))))))) | Nis'205 => (twice (twice_plus_one (twice_plus_one (twice (twice (twice (twice (twice_plus_one Int31.In)))))))) | Nis'204 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice (twice (twice_plus_one Int31.In)))))))) | Nis'203 => (twice (twice (twice (twice_plus_one (twice (twice (twice (twice_plus_one Int31.In)))))))) | Nis'202 => (twice_plus_one (twice (twice (twice_plus_one (twice (twice (twice (twice_plus_one Int31.In)))))))) | Nis'201 => (twice (twice_plus_one (twice (twice_plus_one (twice (twice (twice (twice_plus_one Int31.In)))))))) | Nis'200 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice (twice (twice_plus_one Int31.In)))))))) | Nis'199 => (twice (twice (twice_plus_one (twice_plus_one (twice (twice (twice (twice_plus_one Int31.In)))))))) | Nis'198 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice (twice (twice_plus_one Int31.In)))))))) | Nis'197 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice (twice_plus_one Int31.In)))))))) | Nis'196 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice (twice_plus_one Int31.In)))))))) | Nis'195 => (twice (twice (twice (twice (twice_plus_one (twice (twice (twice_plus_one Int31.In)))))))) | Nis'194 => (twice_plus_one (twice (twice (twice (twice_plus_one (twice (twice (twice_plus_one Int31.In)))))))) | Nis'193 => (twice (twice_plus_one (twice (twice (twice_plus_one (twice (twice (twice_plus_one Int31.In)))))))) | Nis'192 => (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice (twice (twice_plus_one Int31.In)))))))) | Nis'191 => (twice (twice (twice_plus_one (twice (twice_plus_one (twice (twice (twice_plus_one Int31.In)))))))) | Nis'190 => (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice (twice (twice_plus_one Int31.In)))))))) | Nis'189 => (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice (twice_plus_one Int31.In)))))))) | Nis'188 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice (twice_plus_one Int31.In)))))))) | Nis'187 => (twice (twice (twice (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one Int31.In)))))))) | Nis'186 => (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one Int31.In)))))))) | Nis'185 => (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one Int31.In)))))))) | Nis'184 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one Int31.In)))))))) | Nis'183 => (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one Int31.In)))))))) | Nis'182 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one Int31.In)))))))) | Nis'181 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one Int31.In)))))))) | Nis'180 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one Int31.In)))))))) | Nis'179 => (twice (twice (twice (twice (twice (twice_plus_one (twice (twice_plus_one Int31.In)))))))) | Nis'178 => (twice_plus_one (twice (twice (twice (twice (twice_plus_one (twice (twice_plus_one Int31.In)))))))) | Nis'177 => (twice (twice_plus_one (twice (twice (twice (twice_plus_one (twice (twice_plus_one Int31.In)))))))) | Nis'176 => (twice_plus_one (twice_plus_one (twice (twice (twice (twice_plus_one (twice (twice_plus_one Int31.In)))))))) | Nis'175 => (twice (twice (twice_plus_one (twice (twice (twice_plus_one (twice (twice_plus_one Int31.In)))))))) | Nis'174 => (twice_plus_one (twice (twice_plus_one (twice (twice (twice_plus_one (twice (twice_plus_one Int31.In)))))))) | Nis'173 => (twice (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice (twice_plus_one Int31.In)))))))) | Nis'172 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice (twice_plus_one Int31.In)))))))) | Nis'171 => (twice (twice (twice (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one Int31.In)))))))) | Nis'170 => (twice_plus_one (twice (twice (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one Int31.In)))))))) | Nis'169 => (twice (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one Int31.In)))))))) | Nis'168 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one Int31.In)))))))) | Nis'167 => (twice (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one Int31.In)))))))) | Nis'166 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one Int31.In)))))))) | Nis'165 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one Int31.In)))))))) | Nis'164 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one Int31.In)))))))) | Nis'163 => (twice (twice (twice (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In)))))))) | Nis'162 => (twice_plus_one (twice (twice (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In)))))))) | Nis'161 => (twice (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In)))))))) | Nis'160 => (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In)))))))) | Nis'159 => (twice (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In)))))))) | Nis'158 => (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In)))))))) | Nis'157 => (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In)))))))) | Nis'156 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In)))))))) | Nis'155 => (twice (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In)))))))) | Nis'154 => (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In)))))))) | Nis'153 => (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In)))))))) | Nis'152 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In)))))))) | Nis'151 => (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In)))))))) | Nis'150 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In)))))))) | Nis'149 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In)))))))) | Nis'148 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one Int31.In)))))))) | Nis'147 => (twice (twice (twice (twice (twice (twice (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'146 => (twice_plus_one (twice (twice (twice (twice (twice (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'145 => (twice (twice_plus_one (twice (twice (twice (twice (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'144 => (twice_plus_one (twice_plus_one (twice (twice (twice (twice (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'143 => (twice (twice (twice_plus_one (twice (twice (twice (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'142 => (twice_plus_one (twice (twice_plus_one (twice (twice (twice (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'141 => (twice (twice_plus_one (twice_plus_one (twice (twice (twice (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'140 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'139 => (twice (twice (twice (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'138 => (twice_plus_one (twice (twice (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'137 => (twice (twice_plus_one (twice (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'136 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'135 => (twice (twice (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'134 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'133 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'132 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'131 => (twice (twice (twice (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'130 => (twice_plus_one (twice (twice (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'129 => (twice (twice_plus_one (twice (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'128 => (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'127 => (twice (twice (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'126 => (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'125 => (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'124 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'123 => (twice (twice (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'122 => (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'121 => (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'120 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'119 => (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'118 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'117 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'116 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'115 => (twice (twice (twice (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'114 => (twice_plus_one (twice (twice (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'113 => (twice (twice_plus_one (twice (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'112 => (twice_plus_one (twice_plus_one (twice (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'111 => (twice (twice (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'110 => (twice_plus_one (twice (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'109 => (twice (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'108 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'107 => (twice (twice (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'106 => (twice_plus_one (twice (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'105 => (twice (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'104 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'103 => (twice (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'102 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'101 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'100 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'99 => (twice (twice (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'98 => (twice_plus_one (twice (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'97 => (twice (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'96 => (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'95 => (twice (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'94 => (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'93 => (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'92 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'91 => (twice (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'90 => (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'89 => (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'88 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'87 => (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'86 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'85 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'84 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one Int31.In)))))))) | Nis'83 => (twice (twice (twice (twice (twice (twice (twice (twice (twice Int31.In))))))))) | Nis'82 => (twice_plus_one (twice (twice (twice (twice (twice (twice (twice (twice Int31.In))))))))) | Nis'81 => (twice (twice_plus_one (twice (twice (twice (twice (twice (twice (twice Int31.In))))))))) | Nis'80 => (twice_plus_one (twice_plus_one (twice (twice (twice (twice (twice (twice (twice Int31.In))))))))) | Nis'79 => (twice (twice (twice_plus_one (twice (twice (twice (twice (twice (twice Int31.In))))))))) | Nis'78 => (twice_plus_one (twice (twice_plus_one (twice (twice (twice (twice (twice (twice Int31.In))))))))) | Nis'77 => (twice (twice_plus_one (twice_plus_one (twice (twice (twice (twice (twice (twice Int31.In))))))))) | Nis'76 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice (twice (twice (twice Int31.In))))))))) | Nis'75 => (twice (twice (twice (twice_plus_one (twice (twice (twice (twice (twice Int31.In))))))))) | Nis'74 => (twice_plus_one (twice (twice (twice_plus_one (twice (twice (twice (twice (twice Int31.In))))))))) | Nis'73 => (twice (twice_plus_one (twice (twice_plus_one (twice (twice (twice (twice (twice Int31.In))))))))) | Nis'72 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice (twice (twice (twice Int31.In))))))))) | Nis'71 => (twice (twice (twice_plus_one (twice_plus_one (twice (twice (twice (twice (twice Int31.In))))))))) | Nis'70 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice (twice (twice (twice Int31.In))))))))) | Nis'69 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice (twice (twice Int31.In))))))))) | Nis'68 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice (twice (twice Int31.In))))))))) | Nis'67 => (twice (twice (twice (twice (twice_plus_one (twice (twice (twice (twice Int31.In))))))))) | Nis'66 => (twice_plus_one (twice (twice (twice (twice_plus_one (twice (twice (twice (twice Int31.In))))))))) | Nis'65 => (twice (twice_plus_one (twice (twice (twice_plus_one (twice (twice (twice (twice Int31.In))))))))) | Nis'64 => (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice (twice (twice (twice Int31.In))))))))) | Nis'63 => (twice (twice (twice_plus_one (twice (twice_plus_one (twice (twice (twice (twice Int31.In))))))))) | Nis'62 => (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice (twice (twice (twice Int31.In))))))))) | Nis'61 => (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice (twice (twice Int31.In))))))))) | Nis'60 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice (twice (twice Int31.In))))))))) | Nis'59 => (twice (twice (twice (twice_plus_one (twice_plus_one (twice (twice (twice (twice Int31.In))))))))) | Nis'58 => (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice (twice (twice (twice Int31.In))))))))) | Nis'57 => (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice (twice (twice Int31.In))))))))) | Nis'56 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice (twice (twice Int31.In))))))))) | Nis'55 => (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice (twice Int31.In))))))))) | Nis'54 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice (twice Int31.In))))))))) | Nis'53 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice (twice Int31.In))))))))) | Nis'52 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice (twice Int31.In))))))))) | Nis'51 => (twice (twice (twice (twice (twice (twice_plus_one (twice (twice (twice Int31.In))))))))) | Nis'50 => (twice_plus_one (twice (twice (twice (twice (twice_plus_one (twice (twice (twice Int31.In))))))))) | Nis'49 => (twice (twice_plus_one (twice (twice (twice (twice_plus_one (twice (twice (twice Int31.In))))))))) | Nis'48 => (twice_plus_one (twice_plus_one (twice (twice (twice (twice_plus_one (twice (twice (twice Int31.In))))))))) | Nis'47 => (twice (twice (twice_plus_one (twice (twice (twice_plus_one (twice (twice (twice Int31.In))))))))) | Nis'46 => (twice_plus_one (twice (twice_plus_one (twice (twice (twice_plus_one (twice (twice (twice Int31.In))))))))) | Nis'45 => (twice (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice (twice (twice Int31.In))))))))) | Nis'44 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice (twice (twice Int31.In))))))))) | Nis'43 => (twice (twice (twice (twice_plus_one (twice (twice_plus_one (twice (twice (twice Int31.In))))))))) | Nis'42 => (twice_plus_one (twice (twice (twice_plus_one (twice (twice_plus_one (twice (twice (twice Int31.In))))))))) | Nis'41 => (twice (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice (twice (twice Int31.In))))))))) | Nis'40 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice (twice (twice Int31.In))))))))) | Nis'39 => (twice (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice (twice Int31.In))))))))) | Nis'38 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice (twice Int31.In))))))))) | Nis'37 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice (twice Int31.In))))))))) | Nis'36 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice (twice Int31.In))))))))) | Nis'35 => (twice (twice (twice (twice (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In))))))))) | Nis'34 => (twice_plus_one (twice (twice (twice (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In))))))))) | Nis'33 => (twice (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In))))))))) | Nis'32 => (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In))))))))) | Nis'31 => (twice (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In))))))))) | Nis'30 => (twice_plus_one (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In))))))))) | Nis'29 => (twice (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In))))))))) | Nis'28 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In))))))))) | Nis'27 => (twice (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In))))))))) | Nis'26 => (twice_plus_one (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In))))))))) | Nis'25 => (twice (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In))))))))) | Nis'24 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In))))))))) | Nis'23 => (twice (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In))))))))) | Nis'22 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In))))))))) | Nis'21 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In))))))))) | Nis'20 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice Int31.In))))))))) | Nis'19 => (twice (twice (twice (twice (twice (twice (twice_plus_one (twice (twice Int31.In))))))))) | Nis'18 => (twice_plus_one (twice (twice (twice (twice (twice (twice_plus_one (twice (twice Int31.In))))))))) | Nis'17 => (twice (twice_plus_one (twice (twice (twice (twice (twice_plus_one (twice (twice Int31.In))))))))) | Nis'16 => (twice_plus_one (twice_plus_one (twice (twice (twice (twice (twice_plus_one (twice (twice Int31.In))))))))) | Nis'15 => (twice (twice (twice_plus_one (twice (twice (twice (twice_plus_one (twice (twice Int31.In))))))))) | Nis'14 => (twice_plus_one (twice (twice_plus_one (twice (twice (twice (twice_plus_one (twice (twice Int31.In))))))))) | Nis'13 => (twice (twice_plus_one (twice_plus_one (twice (twice (twice (twice_plus_one (twice (twice Int31.In))))))))) | Nis'12 => (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice (twice_plus_one (twice (twice Int31.In))))))))) | Nis'11 => (twice (twice (twice (twice_plus_one (twice (twice (twice_plus_one (twice (twice Int31.In))))))))) | Nis'10 => (twice_plus_one (twice (twice (twice_plus_one (twice (twice (twice_plus_one (twice (twice Int31.In))))))))) | Nis'9 => (twice (twice_plus_one (twice (twice_plus_one (twice (twice (twice_plus_one (twice (twice Int31.In))))))))) | Nis'8 => (twice_plus_one (twice_plus_one (twice (twice_plus_one (twice (twice (twice_plus_one (twice (twice Int31.In))))))))) | Nis'7 => (twice (twice (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice (twice Int31.In))))))))) | Nis'6 => (twice_plus_one (twice (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice (twice Int31.In))))))))) | Nis'5 => (twice (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice (twice Int31.In))))))))) | Nis'4 => (twice_plus_one (twice_plus_one (twice_plus_one (twice_plus_one (twice (twice (twice_plus_one (twice (twice Int31.In))))))))) | Nis'3 => (twice (twice (twice (twice (twice_plus_one (twice (twice_plus_one (twice (twice Int31.In))))))))) | Nis'2 => (twice_plus_one (twice (twice (twice (twice_plus_one (twice (twice_plus_one (twice (twice Int31.In))))))))) | Nis'1 => (twice (twice_plus_one (twice (twice (twice_plus_one (twice (twice_plus_one (twice (twice Int31.In))))))))) end;
    surj := (fun n => match n return _ with | 0 => Nis'596 | 1 => Nis'595 | 2 => Nis'594 | 3 => Nis'593 | 4 => Nis'592 | 5 => Nis'591 | 6 => Nis'590 | 7 => Nis'589 | 8 => Nis'588 | 9 => Nis'587 | 10 => Nis'586 | 11 => Nis'585 | 12 => Nis'584 | 13 => Nis'583 | 14 => Nis'582 | 15 => Nis'581 | 16 => Nis'580 | 17 => Nis'579 | 18 => Nis'578 | 19 => Nis'577 | 20 => Nis'576 | 21 => Nis'575 | 22 => Nis'574 | 23 => Nis'573 | 24 => Nis'572 | 25 => Nis'571 | 26 => Nis'570 | 27 => Nis'569 | 28 => Nis'568 | 29 => Nis'567 | 30 => Nis'566 | 31 => Nis'565 | 32 => Nis'564 | 33 => Nis'563 | 34 => Nis'562 | 35 => Nis'561 | 36 => Nis'560 | 37 => Nis'559 | 38 => Nis'558 | 39 => Nis'557 | 40 => Nis'556 | 41 => Nis'555 | 42 => Nis'554 | 43 => Nis'553 | 44 => Nis'552 | 45 => Nis'551 | 46 => Nis'550 | 47 => Nis'549 | 48 => Nis'548 | 49 => Nis'547 | 50 => Nis'546 | 51 => Nis'545 | 52 => Nis'544 | 53 => Nis'543 | 54 => Nis'542 | 55 => Nis'541 | 56 => Nis'540 | 57 => Nis'539 | 58 => Nis'538 | 59 => Nis'537 | 60 => Nis'536 | 61 => Nis'535 | 62 => Nis'534 | 63 => Nis'533 | 64 => Nis'532 | 65 => Nis'531 | 66 => Nis'530 | 67 => Nis'529 | 68 => Nis'528 | 69 => Nis'527 | 70 => Nis'526 | 71 => Nis'525 | 72 => Nis'524 | 73 => Nis'523 | 74 => Nis'522 | 75 => Nis'521 | 76 => Nis'520 | 77 => Nis'519 | 78 => Nis'518 | 79 => Nis'517 | 80 => Nis'516 | 81 => Nis'515 | 82 => Nis'514 | 83 => Nis'513 | 84 => Nis'512 | 85 => Nis'511 | 86 => Nis'510 | 87 => Nis'509 | 88 => Nis'508 | 89 => Nis'507 | 90 => Nis'506 | 91 => Nis'505 | 92 => Nis'504 | 93 => Nis'503 | 94 => Nis'502 | 95 => Nis'501 | 96 => Nis'500 | 97 => Nis'499 | 98 => Nis'498 | 99 => Nis'497 | 100 => Nis'496 | 101 => Nis'495 | 102 => Nis'494 | 103 => Nis'493 | 104 => Nis'492 | 105 => Nis'491 | 106 => Nis'490 | 107 => Nis'489 | 108 => Nis'488 | 109 => Nis'487 | 110 => Nis'486 | 111 => Nis'485 | 112 => Nis'484 | 113 => Nis'483 | 114 => Nis'482 | 115 => Nis'481 | 116 => Nis'480 | 117 => Nis'479 | 118 => Nis'478 | 119 => Nis'477 | 120 => Nis'476 | 121 => Nis'475 | 122 => Nis'474 | 123 => Nis'473 | 124 => Nis'472 | 125 => Nis'471 | 126 => Nis'470 | 127 => Nis'469 | 128 => Nis'468 | 129 => Nis'467 | 130 => Nis'466 | 131 => Nis'465 | 132 => Nis'464 | 133 => Nis'463 | 134 => Nis'462 | 135 => Nis'461 | 136 => Nis'460 | 137 => Nis'459 | 138 => Nis'458 | 139 => Nis'457 | 140 => Nis'456 | 141 => Nis'455 | 142 => Nis'454 | 143 => Nis'453 | 144 => Nis'452 | 145 => Nis'451 | 146 => Nis'450 | 147 => Nis'449 | 148 => Nis'448 | 149 => Nis'447 | 150 => Nis'446 | 151 => Nis'445 | 152 => Nis'444 | 153 => Nis'443 | 154 => Nis'442 | 155 => Nis'441 | 156 => Nis'440 | 157 => Nis'439 | 158 => Nis'438 | 159 => Nis'437 | 160 => Nis'436 | 161 => Nis'435 | 162 => Nis'434 | 163 => Nis'433 | 164 => Nis'432 | 165 => Nis'431 | 166 => Nis'430 | 167 => Nis'429 | 168 => Nis'428 | 169 => Nis'427 | 170 => Nis'426 | 171 => Nis'425 | 172 => Nis'424 | 173 => Nis'423 | 174 => Nis'422 | 175 => Nis'421 | 176 => Nis'420 | 177 => Nis'419 | 178 => Nis'418 | 179 => Nis'417 | 180 => Nis'416 | 181 => Nis'415 | 182 => Nis'414 | 183 => Nis'413 | 184 => Nis'412 | 185 => Nis'411 | 186 => Nis'410 | 187 => Nis'409 | 188 => Nis'408 | 189 => Nis'407 | 190 => Nis'406 | 191 => Nis'405 | 192 => Nis'404 | 193 => Nis'403 | 194 => Nis'402 | 195 => Nis'401 | 196 => Nis'400 | 197 => Nis'399 | 198 => Nis'398 | 199 => Nis'397 | 200 => Nis'396 | 201 => Nis'395 | 202 => Nis'394 | 203 => Nis'393 | 204 => Nis'392 | 205 => Nis'391 | 206 => Nis'390 | 207 => Nis'389 | 208 => Nis'388 | 209 => Nis'387 | 210 => Nis'386 | 211 => Nis'385 | 212 => Nis'384 | 213 => Nis'383 | 214 => Nis'382 | 215 => Nis'381 | 216 => Nis'380 | 217 => Nis'379 | 218 => Nis'378 | 219 => Nis'377 | 220 => Nis'376 | 221 => Nis'375 | 222 => Nis'374 | 223 => Nis'373 | 224 => Nis'372 | 225 => Nis'371 | 226 => Nis'370 | 227 => Nis'369 | 228 => Nis'368 | 229 => Nis'367 | 230 => Nis'366 | 231 => Nis'365 | 232 => Nis'364 | 233 => Nis'363 | 234 => Nis'362 | 235 => Nis'361 | 236 => Nis'360 | 237 => Nis'359 | 238 => Nis'358 | 239 => Nis'357 | 240 => Nis'356 | 241 => Nis'355 | 242 => Nis'354 | 243 => Nis'353 | 244 => Nis'352 | 245 => Nis'351 | 246 => Nis'350 | 247 => Nis'349 | 248 => Nis'348 | 249 => Nis'347 | 250 => Nis'346 | 251 => Nis'345 | 252 => Nis'344 | 253 => Nis'343 | 254 => Nis'342 | 255 => Nis'341 | 256 => Nis'340 | 257 => Nis'339 | 258 => Nis'338 | 259 => Nis'337 | 260 => Nis'336 | 261 => Nis'335 | 262 => Nis'334 | 263 => Nis'332 | 264 => Nis'331 | 265 => Nis'330 | 266 => Nis'329 | 267 => Nis'328 | 268 => Nis'327 | 269 => Nis'326 | 270 => Nis'325 | 271 => Nis'324 | 272 => Nis'323 | 273 => Nis'322 | 274 => Nis'321 | 275 => Nis'320 | 276 => Nis'319 | 277 => Nis'318 | 278 => Nis'317 | 279 => Nis'316 | 280 => Nis'315 | 281 => Nis'314 | 282 => Nis'313 | 283 => Nis'312 | 284 => Nis'311 | 285 => Nis'310 | 286 => Nis'309 | 287 => Nis'308 | 288 => Nis'307 | 289 => Nis'306 | 290 => Nis'305 | 291 => Nis'304 | 292 => Nis'303 | 293 => Nis'302 | 294 => Nis'301 | 295 => Nis'300 | 296 => Nis'299 | 297 => Nis'298 | 298 => Nis'297 | 299 => Nis'296 | 300 => Nis'295 | 301 => Nis'294 | 302 => Nis'293 | 303 => Nis'292 | 304 => Nis'291 | 305 => Nis'290 | 306 => Nis'289 | 307 => Nis'288 | 308 => Nis'287 | 309 => Nis'286 | 310 => Nis'285 | 311 => Nis'284 | 312 => Nis'283 | 313 => Nis'282 | 314 => Nis'281 | 315 => Nis'280 | 316 => Nis'279 | 317 => Nis'278 | 318 => Nis'277 | 319 => Nis'276 | 320 => Nis'275 | 321 => Nis'274 | 322 => Nis'273 | 323 => Nis'272 | 324 => Nis'271 | 325 => Nis'270 | 326 => Nis'269 | 327 => Nis'268 | 328 => Nis'267 | 329 => Nis'266 | 330 => Nis'265 | 331 => Nis'264 | 332 => Nis'263 | 333 => Nis'262 | 334 => Nis'261 | 335 => Nis'260 | 336 => Nis'259 | 337 => Nis'258 | 338 => Nis'257 | 339 => Nis'256 | 340 => Nis'255 | 341 => Nis'254 | 342 => Nis'253 | 343 => Nis'252 | 344 => Nis'251 | 345 => Nis'250 | 346 => Nis'249 | 347 => Nis'248 | 348 => Nis'247 | 349 => Nis'246 | 350 => Nis'245 | 351 => Nis'244 | 352 => Nis'243 | 353 => Nis'242 | 354 => Nis'241 | 355 => Nis'240 | 356 => Nis'239 | 357 => Nis'238 | 358 => Nis'237 | 359 => Nis'236 | 360 => Nis'235 | 361 => Nis'234 | 362 => Nis'233 | 363 => Nis'232 | 364 => Nis'231 | 365 => Nis'230 | 366 => Nis'229 | 367 => Nis'228 | 368 => Nis'227 | 369 => Nis'226 | 370 => Nis'225 | 371 => Nis'224 | 372 => Nis'223 | 373 => Nis'222 | 374 => Nis'221 | 375 => Nis'220 | 376 => Nis'219 | 377 => Nis'218 | 378 => Nis'217 | 379 => Nis'216 | 380 => Nis'215 | 381 => Nis'214 | 382 => Nis'213 | 383 => Nis'212 | 384 => Nis'211 | 385 => Nis'210 | 386 => Nis'209 | 387 => Nis'208 | 388 => Nis'207 | 389 => Nis'206 | 390 => Nis'205 | 391 => Nis'204 | 392 => Nis'203 | 393 => Nis'202 | 394 => Nis'201 | 395 => Nis'200 | 396 => Nis'199 | 397 => Nis'198 | 398 => Nis'197 | 399 => Nis'196 | 400 => Nis'195 | 401 => Nis'194 | 402 => Nis'193 | 403 => Nis'192 | 404 => Nis'191 | 405 => Nis'190 | 406 => Nis'189 | 407 => Nis'188 | 408 => Nis'187 | 409 => Nis'186 | 410 => Nis'185 | 411 => Nis'184 | 412 => Nis'183 | 413 => Nis'182 | 414 => Nis'181 | 415 => Nis'180 | 416 => Nis'179 | 417 => Nis'178 | 418 => Nis'177 | 419 => Nis'176 | 420 => Nis'175 | 421 => Nis'174 | 422 => Nis'173 | 423 => Nis'172 | 424 => Nis'171 | 425 => Nis'170 | 426 => Nis'169 | 427 => Nis'168 | 428 => Nis'167 | 429 => Nis'166 | 430 => Nis'165 | 431 => Nis'164 | 432 => Nis'163 | 433 => Nis'162 | 434 => Nis'161 | 435 => Nis'160 | 436 => Nis'159 | 437 => Nis'158 | 438 => Nis'157 | 439 => Nis'156 | 440 => Nis'155 | 441 => Nis'154 | 442 => Nis'153 | 443 => Nis'152 | 444 => Nis'151 | 445 => Nis'150 | 446 => Nis'149 | 447 => Nis'148 | 448 => Nis'147 | 449 => Nis'146 | 450 => Nis'145 | 451 => Nis'144 | 452 => Nis'143 | 453 => Nis'142 | 454 => Nis'141 | 455 => Nis'140 | 456 => Nis'139 | 457 => Nis'138 | 458 => Nis'137 | 459 => Nis'136 | 460 => Nis'135 | 461 => Nis'134 | 462 => Nis'133 | 463 => Nis'132 | 464 => Nis'131 | 465 => Nis'130 | 466 => Nis'129 | 467 => Nis'128 | 468 => Nis'127 | 469 => Nis'126 | 470 => Nis'125 | 471 => Nis'124 | 472 => Nis'123 | 473 => Nis'122 | 474 => Nis'121 | 475 => Nis'120 | 476 => Nis'119 | 477 => Nis'118 | 478 => Nis'117 | 479 => Nis'116 | 480 => Nis'115 | 481 => Nis'114 | 482 => Nis'113 | 483 => Nis'112 | 484 => Nis'111 | 485 => Nis'110 | 486 => Nis'109 | 487 => Nis'108 | 488 => Nis'107 | 489 => Nis'106 | 490 => Nis'105 | 491 => Nis'104 | 492 => Nis'103 | 493 => Nis'102 | 494 => Nis'101 | 495 => Nis'100 | 496 => Nis'99 | 497 => Nis'98 | 498 => Nis'97 | 499 => Nis'96 | 500 => Nis'95 | 501 => Nis'94 | 502 => Nis'93 | 503 => Nis'92 | 504 => Nis'91 | 505 => Nis'90 | 506 => Nis'89 | 507 => Nis'88 | 508 => Nis'87 | 509 => Nis'86 | 510 => Nis'85 | 511 => Nis'84 | 512 => Nis'83 | 513 => Nis'82 | 514 => Nis'81 | 515 => Nis'80 | 516 => Nis'79 | 517 => Nis'78 | 518 => Nis'77 | 519 => Nis'76 | 520 => Nis'75 | 521 => Nis'74 | 522 => Nis'73 | 523 => Nis'72 | 524 => Nis'71 | 525 => Nis'70 | 526 => Nis'69 | 527 => Nis'68 | 528 => Nis'67 | 529 => Nis'66 | 530 => Nis'65 | 531 => Nis'64 | 532 => Nis'63 | 533 => Nis'62 | 534 => Nis'61 | 535 => Nis'60 | 536 => Nis'59 | 537 => Nis'58 | 538 => Nis'57 | 539 => Nis'56 | 540 => Nis'55 | 541 => Nis'54 | 542 => Nis'53 | 543 => Nis'52 | 544 => Nis'51 | 545 => Nis'50 | 546 => Nis'49 | 547 => Nis'48 | 548 => Nis'47 | 549 => Nis'46 | 550 => Nis'45 | 551 => Nis'44 | 552 => Nis'43 | 553 => Nis'42 | 554 => Nis'41 | 555 => Nis'40 | 556 => Nis'39 | 557 => Nis'38 | 558 => Nis'37 | 559 => Nis'36 | 560 => Nis'35 | 561 => Nis'34 | 562 => Nis'33 | 563 => Nis'32 | 564 => Nis'31 | 565 => Nis'30 | 566 => Nis'29 | 567 => Nis'28 | 568 => Nis'27 | 569 => Nis'26 | 570 => Nis'25 | 571 => Nis'24 | 572 => Nis'23 | 573 => Nis'22 | 574 => Nis'21 | 575 => Nis'20 | 576 => Nis'19 | 577 => Nis'18 | 578 => Nis'17 | 579 => Nis'16 | 580 => Nis'15 | 581 => Nis'14 | 582 => Nis'13 | 583 => Nis'12 | 584 => Nis'11 | 585 => Nis'10 | 586 => Nis'9 | 587 => Nis'8 | 588 => Nis'7 | 589 => Nis'6 | 590 => Nis'5 | 591 => Nis'4 | 592 => Nis'3 | 593 => Nis'2 | 594 => Nis'1 | _ => Nis'596 end)%int31;
  inj_bound := 595%int31 }.
Solve Obligations using (intro x; case x; reflexivity).

Instance NonInitStateAlph : Alphabet noninitstate := _.

Definition last_symb_of_non_init_state (noninitstate:noninitstate) : symbol :=
  match noninitstate with
    | Nis'1 => T VOLATILE't
    | Nis'2 => T VOID't
    | Nis'3 => T UNSIGNED't
    | Nis'4 => T UNION't
    | Nis'5 => T UNDERSCORE_BOOL't
    | Nis'6 => T TYPEDEF_NAME't
    | Nis'7 => T TYPEDEF't
    | Nis'8 => T STRUCT't
    | Nis'9 => T STATIC't
    | Nis'10 => T SIGNED't
    | Nis'11 => T SHORT't
    | Nis'12 => T SEMICOLON't
    | Nis'13 => T RESTRICT't
    | Nis'14 => T REGISTER't
    | Nis'15 => T PRAGMA't
    | Nis'16 => T PACKED't
    | Nis'17 => T LPAREN't
    | Nis'18 => T VAR_NAME't
    | Nis'19 => T TILDE't
    | Nis'20 => T STRING_LITERAL't
    | Nis'21 => T STAR't
    | Nis'22 => T SIZEOF't
    | Nis'23 => T PLUS't
    | Nis'24 => T MINUS't
    | Nis'25 => T LPAREN't
    | Nis'26 => T LPAREN't
    | Nis'27 => T LONG't
    | Nis'28 => T INT't
    | Nis'29 => T INC't
    | Nis'30 => T LPAREN't
    | Nis'31 => T FLOAT't
    | Nis'32 => T ENUM't
    | Nis'33 => NT attribute_specifier_list'nt
    | Nis'34 => T OTHER_NAME't
    | Nis'35 => T LBRACE't
    | Nis'36 => T VAR_NAME't
    | Nis'37 => NT enumerator_list'nt
    | Nis'38 => T RBRACE't
    | Nis'39 => T COMMA't
    | Nis'40 => T RBRACE't
    | Nis'41 => NT enumerator'nt
    | Nis'42 => NT enumeration_constant'nt
    | Nis'43 => T EQ't
    | Nis'44 => T DEC't
    | Nis'45 => T CONSTANT't
    | Nis'46 => T BUILTIN_VA_ARG't
    | Nis'47 => T LPAREN't
    | Nis'48 => T BANG't
    | Nis'49 => T AND't
    | Nis'50 => T ALIGNOF't
    | Nis'51 => T LPAREN't
    | Nis'52 => T DOUBLE't
    | Nis'53 => T CONST't
    | Nis'54 => T CHAR't
    | Nis'55 => T ATTRIBUTE't
    | Nis'56 => T LPAREN't
    | Nis'57 => T LPAREN't
    | Nis'58 => T PACKED't
    | Nis'59 => T OTHER_NAME't
    | Nis'60 => T CONST't
    | Nis'61 => NT gcc_attribute_word'nt
    | Nis'62 => T LPAREN't
    | Nis'63 => T RPAREN't
    | Nis'64 => NT unary_operator'nt
    | Nis'65 => NT unary_expression'nt
    | Nis'66 => NT primary_expression'nt
    | Nis'67 => NT postfix_expression'nt
    | Nis'68 => T PTR't
    | Nis'69 => T OTHER_NAME't
    | Nis'70 => T LPAREN't
    | Nis'71 => T RPAREN't
    | Nis'72 => NT unary_expression'nt
    | Nis'73 => T XOR_ASSIGN't
    | Nis'74 => T SUB_ASSIGN't
    | Nis'75 => T RIGHT_ASSIGN't
    | Nis'76 => T OR_ASSIGN't
    | Nis'77 => T MUL_ASSIGN't
    | Nis'78 => T MOD_ASSIGN't
    | Nis'79 => T LEFT_ASSIGN't
    | Nis'80 => T EQ't
    | Nis'81 => T DIV_ASSIGN't
    | Nis'82 => T AND_ASSIGN't
    | Nis'83 => T ADD_ASSIGN't
    | Nis'84 => NT assignment_operator'nt
    | Nis'85 => NT shift_expression'nt
    | Nis'86 => T RIGHT't
    | Nis'87 => NT multiplicative_expression'nt
    | Nis'88 => T STAR't
    | Nis'89 => NT cast_expression'nt
    | Nis'90 => T SLASH't
    | Nis'91 => NT cast_expression'nt
    | Nis'92 => T PERCENT't
    | Nis'93 => NT cast_expression'nt
    | Nis'94 => NT cast_expression'nt
    | Nis'95 => NT additive_expression'nt
    | Nis'96 => T PLUS't
    | Nis'97 => NT multiplicative_expression'nt
    | Nis'98 => T MINUS't
    | Nis'99 => NT multiplicative_expression'nt
    | Nis'100 => T LEFT't
    | Nis'101 => NT additive_expression'nt
    | Nis'102 => NT relational_expression'nt
    | Nis'103 => T LT't
    | Nis'104 => NT shift_expression'nt
    | Nis'105 => NT additive_expression'nt
    | Nis'106 => T LEQ't
    | Nis'107 => NT shift_expression'nt
    | Nis'108 => T GT't
    | Nis'109 => NT shift_expression'nt
    | Nis'110 => T GEQ't
    | Nis'111 => NT shift_expression'nt
    | Nis'112 => NT logical_OR_expression'nt
    | Nis'113 => T QUESTION't
    | Nis'114 => NT logical_AND_expression'nt
    | Nis'115 => T ANDAND't
    | Nis'116 => NT inclusive_OR_expression'nt
    | Nis'117 => T BAR't
    | Nis'118 => NT exclusive_OR_expression'nt
    | Nis'119 => T HAT't
    | Nis'120 => NT equality_expression'nt
    | Nis'121 => T NEQ't
    | Nis'122 => NT relational_expression'nt
    | Nis'123 => T EQEQ't
    | Nis'124 => NT relational_expression'nt
    | Nis'125 => NT AND_expression'nt
    | Nis'126 => T AND't
    | Nis'127 => NT equality_expression'nt
    | Nis'128 => NT AND_expression'nt
    | Nis'129 => NT exclusive_OR_expression'nt
    | Nis'130 => NT inclusive_OR_expression'nt
    | Nis'131 => NT expression'nt
    | Nis'132 => T COMMA't
    | Nis'133 => NT conditional_expression'nt
    | Nis'134 => NT assignment_expression'nt
    | Nis'135 => T COLON't
    | Nis'136 => NT conditional_expression'nt
    | Nis'137 => NT assignment_expression'nt
    | Nis'138 => T BARBAR't
    | Nis'139 => NT logical_AND_expression'nt
    | Nis'140 => NT assignment_expression'nt
    | Nis'141 => NT assignment_expression'nt
    | Nis'142 => NT argument_expression_list'nt
    | Nis'143 => T RPAREN't
    | Nis'144 => T COMMA't
    | Nis'145 => NT assignment_expression'nt
    | Nis'146 => T LBRACK't
    | Nis'147 => NT expression'nt
    | Nis'148 => T RBRACK't
    | Nis'149 => T INC't
    | Nis'150 => T DOT't
    | Nis'151 => T OTHER_NAME't
    | Nis'152 => T DEC't
    | Nis'153 => NT cast_expression'nt
    | Nis'154 => NT argument_expression_list'nt
    | Nis'155 => T RPAREN't
    | Nis'156 => NT gcc_attribute_list'nt
    | Nis'157 => T RPAREN't
    | Nis'158 => T RPAREN't
    | Nis'159 => T COMMA't
    | Nis'160 => NT gcc_attribute'nt
    | Nis'161 => NT gcc_attribute'nt
    | Nis'162 => T ALIGNAS't
    | Nis'163 => T LPAREN't
    | Nis'164 => NT type_specifier'nt
    | Nis'165 => NT type_qualifier'nt
    | Nis'166 => NT struct_or_union_specifier'nt
    | Nis'167 => NT struct_or_union'nt
    | Nis'168 => NT attribute_specifier_list'nt
    | Nis'169 => T OTHER_NAME't
    | Nis'170 => T LBRACE't
    | Nis'171 => NT struct_declaration_list'nt
    | Nis'172 => T RBRACE't
    | Nis'173 => NT struct_declaration'nt
    | Nis'174 => NT specifier_qualifier_list'nt
    | Nis'175 => T VAR_NAME't
    | Nis'176 => T STAR't
    | Nis'177 => NT type_qualifier_list'nt
    | Nis'178 => NT type_qualifier'nt
    | Nis'179 => NT pointer'nt
    | Nis'180 => NT attribute_specifier'nt
    | Nis'181 => NT type_qualifier'nt
    | Nis'182 => NT pointer'nt
    | Nis'183 => T SEMICOLON't
    | Nis'184 => T LPAREN't
    | Nis'185 => NT pointer'nt
    | Nis'186 => NT direct_declarator'nt
    | Nis'187 => T LPAREN't
    | Nis'188 => T RPAREN't
    | Nis'189 => T INLINE't
    | Nis'190 => T EXTERN't
    | Nis'191 => T AUTO't
    | Nis'192 => NT type_specifier'nt
    | Nis'193 => NT type_qualifier'nt
    | Nis'194 => NT storage_class_specifier'nt
    | Nis'195 => NT function_specifier'nt
    | Nis'196 => NT enum_specifier'nt
    | Nis'197 => NT declaration_specifiers'nt
    | Nis'198 => NT declaration_specifiers'nt
    | Nis'199 => NT declaration_specifiers'nt
    | Nis'200 => NT declaration_specifiers'nt
    | Nis'201 => NT parameter_type_list'nt
    | Nis'202 => T RPAREN't
    | Nis'203 => NT parameter_list'nt
    | Nis'204 => T COMMA't
    | Nis'205 => T ELLIPSIS't
    | Nis'206 => NT parameter_declaration'nt
    | Nis'207 => NT declaration_specifiers'nt
    | Nis'208 => T LPAREN't
    | Nis'209 => T RPAREN't
    | Nis'210 => T LBRACK't
    | Nis'211 => T RBRACK't
    | Nis'212 => NT type_qualifier_list'nt
    | Nis'213 => T RBRACK't
    | Nis'214 => NT assignment_expression'nt
    | Nis'215 => T RBRACK't
    | Nis'216 => NT assignment_expression'nt
    | Nis'217 => T RBRACK't
    | Nis'218 => NT pointer'nt
    | Nis'219 => NT direct_abstract_declarator'nt
    | Nis'220 => T LPAREN't
    | Nis'221 => T RPAREN't
    | Nis'222 => NT parameter_type_list'nt
    | Nis'223 => T RPAREN't
    | Nis'224 => NT parameter_declaration'nt
    | Nis'225 => T LBRACK't
    | Nis'226 => T RBRACK't
    | Nis'227 => NT type_qualifier_list'nt
    | Nis'228 => T RBRACK't
    | Nis'229 => NT assignment_expression'nt
    | Nis'230 => T RBRACK't
    | Nis'231 => NT assignment_expression'nt
    | Nis'232 => T RBRACK't
    | Nis'233 => NT parameter_type_list'nt
    | Nis'234 => T RPAREN't
    | Nis'235 => NT direct_declarator'nt
    | Nis'236 => T LBRACK't
    | Nis'237 => T RBRACK't
    | Nis'238 => NT type_qualifier_list'nt
    | Nis'239 => T RBRACK't
    | Nis'240 => NT assignment_expression'nt
    | Nis'241 => T RBRACK't
    | Nis'242 => NT assignment_expression'nt
    | Nis'243 => T RBRACK't
    | Nis'244 => NT attribute_specifier_list'nt
    | Nis'245 => NT attribute_specifier'nt
    | Nis'246 => NT direct_abstract_declarator'nt
    | Nis'247 => NT declarator'nt
    | Nis'248 => T RPAREN't
    | Nis'249 => NT abstract_declarator'nt
    | Nis'250 => T RPAREN't
    | Nis'251 => NT declarator'nt
    | Nis'252 => NT abstract_declarator'nt
    | Nis'253 => NT attribute_specifier_list'nt
    | Nis'254 => T COLON't
    | Nis'255 => NT constant_expression'nt
    | Nis'256 => NT conditional_expression'nt
    | Nis'257 => NT struct_declarator_list'nt
    | Nis'258 => T SEMICOLON't
    | Nis'259 => T COMMA't
    | Nis'260 => NT struct_declarator'nt
    | Nis'261 => NT declarator'nt
    | Nis'262 => T COLON't
    | Nis'263 => NT constant_expression'nt
    | Nis'264 => NT struct_declarator'nt
    | Nis'265 => T LBRACE't
    | Nis'266 => NT struct_declaration_list'nt
    | Nis'267 => T RBRACE't
    | Nis'268 => NT specifier_qualifier_list'nt
    | Nis'269 => NT specifier_qualifier_list'nt
    | Nis'270 => NT type_name'nt
    | Nis'271 => T RPAREN't
    | Nis'272 => NT specifier_qualifier_list'nt
    | Nis'273 => T LPAREN't
    | Nis'274 => NT pointer'nt
    | Nis'275 => NT abstract_declarator'nt
    | Nis'276 => NT argument_expression_list'nt
    | Nis'277 => T RPAREN't
    | Nis'278 => NT type_name'nt
    | Nis'279 => T RPAREN't
    | Nis'280 => T LBRACE't
    | Nis'281 => T LBRACK't
    | Nis'282 => NT constant_expression'nt
    | Nis'283 => T RBRACK't
    | Nis'284 => T LBRACE't
    | Nis'285 => T DOT't
    | Nis'286 => T OTHER_NAME't
    | Nis'287 => NT initializer_list'nt
    | Nis'288 => T RBRACE't
    | Nis'289 => T COMMA't
    | Nis'290 => T RBRACE't
    | Nis'291 => NT designator_list'nt
    | Nis'292 => T EQ't
    | Nis'293 => NT designator'nt
    | Nis'294 => NT designator'nt
    | Nis'295 => NT designation'nt
    | Nis'296 => NT c_initializer'nt
    | Nis'297 => NT assignment_expression'nt
    | Nis'298 => NT c_initializer'nt
    | Nis'299 => NT designation'nt
    | Nis'300 => NT c_initializer'nt
    | Nis'301 => NT c_initializer'nt
    | Nis'302 => NT initializer_list'nt
    | Nis'303 => T RBRACE't
    | Nis'304 => T COMMA't
    | Nis'305 => T RBRACE't
    | Nis'306 => NT expression'nt
    | Nis'307 => T RPAREN't
    | Nis'308 => NT unary_expression'nt
    | Nis'309 => NT assignment_expression'nt
    | Nis'310 => T COMMA't
    | Nis'311 => NT type_name'nt
    | Nis'312 => T RPAREN't
    | Nis'313 => NT unary_expression'nt
    | Nis'314 => NT constant_expression'nt
    | Nis'315 => NT enumerator'nt
    | Nis'316 => T LBRACE't
    | Nis'317 => NT enumerator_list'nt
    | Nis'318 => T RBRACE't
    | Nis'319 => T COMMA't
    | Nis'320 => T RBRACE't
    | Nis'321 => NT type_name'nt
    | Nis'322 => T RPAREN't
    | Nis'323 => NT unary_expression'nt
    | Nis'324 => NT type_name'nt
    | Nis'325 => T RPAREN't
    | Nis'326 => NT cast_expression'nt
    | Nis'327 => NT type_name'nt
    | Nis'328 => T RPAREN't
    | Nis'329 => NT unary_expression'nt
    | Nis'330 => NT argument_expression_list'nt
    | Nis'331 => T RPAREN't
    | Nis'332 => T EOF't
    | Nis'334 => NT translation_unit'nt
    | Nis'335 => T SEMICOLON't
    | Nis'336 => T EOF't
    | Nis'337 => NT function_definition'nt
    | Nis'338 => NT external_declaration'nt
    | Nis'339 => NT declaration_specifiers'nt
    | Nis'340 => T SEMICOLON't
    | Nis'341 => NT pointer'nt
    | Nis'342 => NT direct_old_function_declarator'nt
    | Nis'343 => NT direct_declarator'nt
    | Nis'344 => T LPAREN't
    | Nis'345 => T VAR_NAME't
    | Nis'346 => NT identifier_list'nt
    | Nis'347 => T RPAREN't
    | Nis'348 => T COMMA't
    | Nis'349 => T VAR_NAME't
    | Nis'350 => NT old_function_declarator'nt
    | Nis'351 => NT declaration_list'nt
    | Nis'352 => T LBRACE't
    | Nis'353 => T WHILE't
    | Nis'354 => T LPAREN't
    | Nis'355 => NT expression'nt
    | Nis'356 => T RPAREN't
    | Nis'357 => T SWITCH't
    | Nis'358 => T LPAREN't
    | Nis'359 => NT expression'nt
    | Nis'360 => T RPAREN't
    | Nis'361 => T SEMICOLON't
    | Nis'362 => T RETURN't
    | Nis'363 => T SEMICOLON't
    | Nis'364 => NT expression'nt
    | Nis'365 => T SEMICOLON't
    | Nis'366 => T OTHER_NAME't
    | Nis'367 => T COLON't
    | Nis'368 => T IF't
    | Nis'369 => T LPAREN't
    | Nis'370 => NT expression'nt
    | Nis'371 => T RPAREN't
    | Nis'372 => T WHILE't
    | Nis'373 => T LPAREN't
    | Nis'374 => NT expression'nt
    | Nis'375 => T RPAREN't
    | Nis'376 => T SWITCH't
    | Nis'377 => T LPAREN't
    | Nis'378 => NT expression'nt
    | Nis'379 => T RPAREN't
    | Nis'380 => T OTHER_NAME't
    | Nis'381 => T COLON't
    | Nis'382 => T IF't
    | Nis'383 => T LPAREN't
    | Nis'384 => NT expression'nt
    | Nis'385 => T RPAREN't
    | Nis'386 => T GOTO't
    | Nis'387 => T OTHER_NAME't
    | Nis'388 => T SEMICOLON't
    | Nis'389 => T FOR't
    | Nis'390 => T LPAREN't
    | Nis'391 => T SEMICOLON't
    | Nis'392 => T SEMICOLON't
    | Nis'393 => T RPAREN't
    | Nis'394 => T DO't
    | Nis'395 => T FOR't
    | Nis'396 => T LPAREN't
    | Nis'397 => T SEMICOLON't
    | Nis'398 => T SEMICOLON't
    | Nis'399 => T RPAREN't
    | Nis'400 => T DO't
    | Nis'401 => T DEFAULT't
    | Nis'402 => T COLON't
    | Nis'403 => T CONTINUE't
    | Nis'404 => T SEMICOLON't
    | Nis'405 => T CASE't
    | Nis'406 => NT constant_expression'nt
    | Nis'407 => T COLON't
    | Nis'408 => T BREAK't
    | Nis'409 => T SEMICOLON't
    | Nis'410 => T ASM't
    | Nis'411 => T VOLATILE't
    | Nis'412 => T CONST't
    | Nis'413 => NT asm_attributes'nt
    | Nis'414 => NT asm_attributes'nt
    | Nis'415 => NT asm_attributes'nt
    | Nis'416 => T LPAREN't
    | Nis'417 => T STRING_LITERAL't
    | Nis'418 => T COLON't
    | Nis'419 => T LBRACK't
    | Nis'420 => T OTHER_NAME't
    | Nis'421 => T RBRACK't
    | Nis'422 => NT asm_operands_ne'nt
    | Nis'423 => T COMMA't
    | Nis'424 => NT asm_operand'nt
    | Nis'425 => NT asm_op_name'nt
    | Nis'426 => T STRING_LITERAL't
    | Nis'427 => T LPAREN't
    | Nis'428 => NT expression'nt
    | Nis'429 => T RPAREN't
    | Nis'430 => NT asm_operands'nt
    | Nis'431 => T COLON't
    | Nis'432 => NT asm_operands'nt
    | Nis'433 => T COLON't
    | Nis'434 => T STRING_LITERAL't
    | Nis'435 => T COMMA't
    | Nis'436 => NT asm_flags'nt
    | Nis'437 => NT asm_flags'nt
    | Nis'438 => NT asm_operand'nt
    | Nis'439 => NT asm_arguments'nt
    | Nis'440 => T RPAREN't
    | Nis'441 => T SEMICOLON't
    | Nis'442 => NT statement_dangerous'nt
    | Nis'443 => NT selection_statement_dangerous'nt
    | Nis'444 => NT labeled_statement_statement_dangerous_'nt
    | Nis'445 => NT jump_statement'nt
    | Nis'446 => NT iteration_statement_statement_dangerous_'nt
    | Nis'447 => NT expression_statement'nt
    | Nis'448 => NT expression'nt
    | Nis'449 => T SEMICOLON't
    | Nis'450 => NT compound_statement'nt
    | Nis'451 => NT asm_statement'nt
    | Nis'452 => NT statement_dangerous'nt
    | Nis'453 => NT statement_dangerous'nt
    | Nis'454 => T WHILE't
    | Nis'455 => T LPAREN't
    | Nis'456 => NT expression'nt
    | Nis'457 => T RPAREN't
    | Nis'458 => T SEMICOLON't
    | Nis'459 => NT statement_dangerous'nt
    | Nis'460 => NT expression'nt
    | Nis'461 => T RPAREN't
    | Nis'462 => NT statement_dangerous'nt
    | Nis'463 => NT expression'nt
    | Nis'464 => T SEMICOLON't
    | Nis'465 => T RPAREN't
    | Nis'466 => NT statement_dangerous'nt
    | Nis'467 => NT expression'nt
    | Nis'468 => T RPAREN't
    | Nis'469 => NT statement_dangerous'nt
    | Nis'470 => NT expression'nt
    | Nis'471 => T SEMICOLON't
    | Nis'472 => T SEMICOLON't
    | Nis'473 => T RPAREN't
    | Nis'474 => NT statement_dangerous'nt
    | Nis'475 => NT expression'nt
    | Nis'476 => T RPAREN't
    | Nis'477 => NT statement_dangerous'nt
    | Nis'478 => NT expression'nt
    | Nis'479 => T SEMICOLON't
    | Nis'480 => T RPAREN't
    | Nis'481 => NT statement_dangerous'nt
    | Nis'482 => NT expression'nt
    | Nis'483 => T RPAREN't
    | Nis'484 => NT statement_dangerous'nt
    | Nis'485 => NT declaration_specifiers'nt
    | Nis'486 => NT init_declarator_list'nt
    | Nis'487 => T SEMICOLON't
    | Nis'488 => T COMMA't
    | Nis'489 => NT init_declarator'nt
    | Nis'490 => NT declarator'nt
    | Nis'491 => T EQ't
    | Nis'492 => NT c_initializer'nt
    | Nis'493 => NT init_declarator'nt
    | Nis'494 => NT declaration'nt
    | Nis'495 => T SEMICOLON't
    | Nis'496 => T RPAREN't
    | Nis'497 => NT statement_dangerous'nt
    | Nis'498 => NT expression'nt
    | Nis'499 => T RPAREN't
    | Nis'500 => NT statement_dangerous'nt
    | Nis'501 => NT expression'nt
    | Nis'502 => T SEMICOLON't
    | Nis'503 => T RPAREN't
    | Nis'504 => NT statement_dangerous'nt
    | Nis'505 => NT expression'nt
    | Nis'506 => T RPAREN't
    | Nis'507 => NT statement_dangerous'nt
    | Nis'508 => NT statement_dangerous'nt
    | Nis'509 => T WHILE't
    | Nis'510 => T LPAREN't
    | Nis'511 => NT expression'nt
    | Nis'512 => T RPAREN't
    | Nis'513 => T SEMICOLON't
    | Nis'514 => T DEFAULT't
    | Nis'515 => T COLON't
    | Nis'516 => T CASE't
    | Nis'517 => NT constant_expression'nt
    | Nis'518 => T COLON't
    | Nis'519 => NT statement_safe'nt
    | Nis'520 => NT selection_statement_safe'nt
    | Nis'521 => NT labeled_statement_statement_safe_'nt
    | Nis'522 => NT jump_statement'nt
    | Nis'523 => NT iteration_statement_statement_safe_'nt
    | Nis'524 => NT expression_statement'nt
    | Nis'525 => NT compound_statement'nt
    | Nis'526 => NT asm_statement'nt
    | Nis'527 => NT statement_safe'nt
    | Nis'528 => NT statement_safe'nt
    | Nis'529 => NT expression'nt
    | Nis'530 => T RPAREN't
    | Nis'531 => NT statement_safe'nt
    | Nis'532 => NT expression'nt
    | Nis'533 => T SEMICOLON't
    | Nis'534 => T RPAREN't
    | Nis'535 => NT statement_safe'nt
    | Nis'536 => NT expression'nt
    | Nis'537 => T RPAREN't
    | Nis'538 => NT statement_safe'nt
    | Nis'539 => NT expression'nt
    | Nis'540 => T SEMICOLON't
    | Nis'541 => T SEMICOLON't
    | Nis'542 => T RPAREN't
    | Nis'543 => NT statement_safe'nt
    | Nis'544 => NT expression'nt
    | Nis'545 => T RPAREN't
    | Nis'546 => NT statement_safe'nt
    | Nis'547 => NT expression'nt
    | Nis'548 => T SEMICOLON't
    | Nis'549 => T RPAREN't
    | Nis'550 => NT statement_safe'nt
    | Nis'551 => NT expression'nt
    | Nis'552 => T RPAREN't
    | Nis'553 => NT statement_safe'nt
    | Nis'554 => NT declaration'nt
    | Nis'555 => T SEMICOLON't
    | Nis'556 => T RPAREN't
    | Nis'557 => NT statement_safe'nt
    | Nis'558 => NT expression'nt
    | Nis'559 => T RPAREN't
    | Nis'560 => NT statement_safe'nt
    | Nis'561 => NT expression'nt
    | Nis'562 => T SEMICOLON't
    | Nis'563 => T RPAREN't
    | Nis'564 => NT statement_safe'nt
    | Nis'565 => NT expression'nt
    | Nis'566 => T RPAREN't
    | Nis'567 => NT statement_safe'nt
    | Nis'568 => NT statement_safe'nt
    | Nis'569 => T ELSE't
    | Nis'570 => NT statement_safe'nt
    | Nis'571 => NT statement_dangerous'nt
    | Nis'572 => NT statement_dangerous'nt
    | Nis'573 => NT statement_safe'nt
    | Nis'574 => NT statement_dangerous'nt
    | Nis'575 => NT statement_safe'nt
    | Nis'576 => NT statement_dangerous'nt
    | Nis'577 => NT statement_safe'nt
    | Nis'578 => NT statement_dangerous'nt
    | Nis'579 => NT statement_safe'nt
    | Nis'580 => T ELSE't
    | Nis'581 => T RBRACE't
    | Nis'582 => T PRAGMA't
    | Nis'583 => NT statement_dangerous'nt
    | Nis'584 => NT declaration'nt
    | Nis'585 => NT block_item_list'nt
    | Nis'586 => T RBRACE't
    | Nis'587 => NT block_item'nt
    | Nis'588 => NT block_item'nt
    | Nis'589 => NT declaration'nt
    | Nis'590 => NT compound_statement'nt
    | Nis'591 => NT direct_old_function_declarator'nt
    | Nis'592 => NT direct_declarator'nt
    | Nis'593 => NT declarator'nt
    | Nis'594 => NT compound_statement'nt
    | Nis'595 => NT declaration'nt
    | Nis'596 => NT external_declaration'nt
  end.

Inductive initstate' : Set :=
  | Init'0.
Definition initstate := initstate'.

Program Instance initstateNum : Numbered initstate :=
  { inj := fun x => match x return _ with | Init'0 => Int31.On end;
    surj := (fun n => match n return _ with | 0 => Init'0 | _ => Init'0 end)%int31;
  inj_bound := 1%int31 }.
Solve Obligations using (intro x; case x; reflexivity).

Instance InitStateAlph : Alphabet initstate := _.

Include Automaton.Types.

Definition start_nt (init:initstate) : nonterminal :=
  match init with
    | Init'0 => translation_unit_file'nt
  end.

Definition action_table (state:state) : action :=
  match state with
    | Init Init'0 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VOLATILE't => Shift_act Nis'1 (eq_refl _)
        | VOID't => Shift_act Nis'2 (eq_refl _)
        | UNSIGNED't => Shift_act Nis'3 (eq_refl _)
        | UNION't => Shift_act Nis'4 (eq_refl _)
        | UNDERSCORE_BOOL't => Shift_act Nis'5 (eq_refl _)
        | TYPEDEF_NAME't => Shift_act Nis'6 (eq_refl _)
        | TYPEDEF't => Shift_act Nis'7 (eq_refl _)
        | STRUCT't => Shift_act Nis'8 (eq_refl _)
        | STATIC't => Shift_act Nis'9 (eq_refl _)
        | SIGNED't => Shift_act Nis'10 (eq_refl _)
        | SHORT't => Shift_act Nis'11 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'12 (eq_refl _)
        | RESTRICT't => Shift_act Nis'13 (eq_refl _)
        | REGISTER't => Shift_act Nis'14 (eq_refl _)
        | PRAGMA't => Shift_act Nis'15 (eq_refl _)
        | PACKED't => Shift_act Nis'16 (eq_refl _)
        | LONG't => Shift_act Nis'27 (eq_refl _)
        | INT't => Shift_act Nis'28 (eq_refl _)
        | INLINE't => Shift_act Nis'189 (eq_refl _)
        | FLOAT't => Shift_act Nis'31 (eq_refl _)
        | EXTERN't => Shift_act Nis'190 (eq_refl _)
        | EOF't => Shift_act Nis'332 (eq_refl _)
        | ENUM't => Shift_act Nis'32 (eq_refl _)
        | DOUBLE't => Shift_act Nis'52 (eq_refl _)
        | CONST't => Shift_act Nis'53 (eq_refl _)
        | CHAR't => Shift_act Nis'54 (eq_refl _)
        | AUTO't => Shift_act Nis'191 (eq_refl _)
        | ATTRIBUTE't => Shift_act Nis'55 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'162 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'1 => Default_reduce_act Prod'type_qualifier'2
    | Ninit Nis'2 => Default_reduce_act Prod'type_specifier'0
    | Ninit Nis'3 => Default_reduce_act Prod'type_specifier'8
    | Ninit Nis'4 => Default_reduce_act Prod'struct_or_union'1
    | Ninit Nis'5 => Default_reduce_act Prod'type_specifier'9
    | Ninit Nis'6 => Default_reduce_act Prod'type_specifier'12
    | Ninit Nis'7 => Default_reduce_act Prod'storage_class_specifier'0
    | Ninit Nis'8 => Default_reduce_act Prod'struct_or_union'0
    | Ninit Nis'9 => Default_reduce_act Prod'storage_class_specifier'2
    | Ninit Nis'10 => Default_reduce_act Prod'type_specifier'7
    | Ninit Nis'11 => Default_reduce_act Prod'type_specifier'2
    | Ninit Nis'12 => Default_reduce_act Prod'translation_unit'3
    | Ninit Nis'13 => Default_reduce_act Prod'type_qualifier'1
    | Ninit Nis'14 => Default_reduce_act Prod'storage_class_specifier'4
    | Ninit Nis'15 => Default_reduce_act Prod'external_declaration'2
    | Ninit Nis'16 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | LPAREN't => Shift_act Nis'17 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'17 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'18 => Default_reduce_act Prod'primary_expression'0
    | Ninit Nis'19 => Default_reduce_act Prod'unary_operator'4
    | Ninit Nis'20 => Default_reduce_act Prod'primary_expression'2
    | Ninit Nis'21 => Default_reduce_act Prod'unary_operator'1
    | Ninit Nis'22 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'25 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'23 => Default_reduce_act Prod'unary_operator'2
    | Ninit Nis'24 => Default_reduce_act Prod'unary_operator'3
    | Ninit Nis'25 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VOLATILE't => Shift_act Nis'1 (eq_refl _)
        | VOID't => Shift_act Nis'2 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | UNSIGNED't => Shift_act Nis'3 (eq_refl _)
        | UNION't => Shift_act Nis'4 (eq_refl _)
        | UNDERSCORE_BOOL't => Shift_act Nis'5 (eq_refl _)
        | TYPEDEF_NAME't => Shift_act Nis'6 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRUCT't => Shift_act Nis'8 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | SIGNED't => Shift_act Nis'10 (eq_refl _)
        | SHORT't => Shift_act Nis'11 (eq_refl _)
        | RESTRICT't => Shift_act Nis'13 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | PACKED't => Shift_act Nis'16 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | LONG't => Shift_act Nis'27 (eq_refl _)
        | INT't => Shift_act Nis'28 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | FLOAT't => Shift_act Nis'31 (eq_refl _)
        | ENUM't => Shift_act Nis'32 (eq_refl _)
        | DOUBLE't => Shift_act Nis'52 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | CONST't => Shift_act Nis'53 (eq_refl _)
        | CHAR't => Shift_act Nis'54 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | ATTRIBUTE't => Shift_act Nis'55 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'162 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'26 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VOLATILE't => Shift_act Nis'1 (eq_refl _)
        | VOID't => Shift_act Nis'2 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | UNSIGNED't => Shift_act Nis'3 (eq_refl _)
        | UNION't => Shift_act Nis'4 (eq_refl _)
        | UNDERSCORE_BOOL't => Shift_act Nis'5 (eq_refl _)
        | TYPEDEF_NAME't => Shift_act Nis'6 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRUCT't => Shift_act Nis'8 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | SIGNED't => Shift_act Nis'10 (eq_refl _)
        | SHORT't => Shift_act Nis'11 (eq_refl _)
        | RESTRICT't => Shift_act Nis'13 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | PACKED't => Shift_act Nis'16 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | LONG't => Shift_act Nis'27 (eq_refl _)
        | INT't => Shift_act Nis'28 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | FLOAT't => Shift_act Nis'31 (eq_refl _)
        | ENUM't => Shift_act Nis'32 (eq_refl _)
        | DOUBLE't => Shift_act Nis'52 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | CONST't => Shift_act Nis'53 (eq_refl _)
        | CHAR't => Shift_act Nis'54 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | ATTRIBUTE't => Shift_act Nis'55 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'162 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'27 => Default_reduce_act Prod'type_specifier'4
    | Ninit Nis'28 => Default_reduce_act Prod'type_specifier'3
    | Ninit Nis'29 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'30 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'30 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VOLATILE't => Shift_act Nis'1 (eq_refl _)
        | VOID't => Shift_act Nis'2 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | UNSIGNED't => Shift_act Nis'3 (eq_refl _)
        | UNION't => Shift_act Nis'4 (eq_refl _)
        | UNDERSCORE_BOOL't => Shift_act Nis'5 (eq_refl _)
        | TYPEDEF_NAME't => Shift_act Nis'6 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRUCT't => Shift_act Nis'8 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | SIGNED't => Shift_act Nis'10 (eq_refl _)
        | SHORT't => Shift_act Nis'11 (eq_refl _)
        | RESTRICT't => Shift_act Nis'13 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | PACKED't => Shift_act Nis'16 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | LONG't => Shift_act Nis'27 (eq_refl _)
        | INT't => Shift_act Nis'28 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | FLOAT't => Shift_act Nis'31 (eq_refl _)
        | ENUM't => Shift_act Nis'32 (eq_refl _)
        | DOUBLE't => Shift_act Nis'52 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | CONST't => Shift_act Nis'53 (eq_refl _)
        | CHAR't => Shift_act Nis'54 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | ATTRIBUTE't => Shift_act Nis'55 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'162 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'31 => Default_reduce_act Prod'type_specifier'5
    | Ninit Nis'32 => Default_reduce_act Prod'attribute_specifier_list'0
    | Ninit Nis'33 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | PACKED't => Shift_act Nis'16 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'34 (eq_refl _)
        | LBRACE't => Shift_act Nis'316 (eq_refl _)
        | ATTRIBUTE't => Shift_act Nis'55 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'162 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'34 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VOLATILE't => Reduce_act Prod'enum_specifier'4
        | VOID't => Reduce_act Prod'enum_specifier'4
        | VAR_NAME't => Reduce_act Prod'enum_specifier'4
        | UNSIGNED't => Reduce_act Prod'enum_specifier'4
        | UNION't => Reduce_act Prod'enum_specifier'4
        | UNDERSCORE_BOOL't => Reduce_act Prod'enum_specifier'4
        | TYPEDEF_NAME't => Reduce_act Prod'enum_specifier'4
        | TYPEDEF't => Reduce_act Prod'enum_specifier'4
        | STRUCT't => Reduce_act Prod'enum_specifier'4
        | STATIC't => Reduce_act Prod'enum_specifier'4
        | STAR't => Reduce_act Prod'enum_specifier'4
        | SIGNED't => Reduce_act Prod'enum_specifier'4
        | SHORT't => Reduce_act Prod'enum_specifier'4
        | SEMICOLON't => Reduce_act Prod'enum_specifier'4
        | RPAREN't => Reduce_act Prod'enum_specifier'4
        | RESTRICT't => Reduce_act Prod'enum_specifier'4
        | REGISTER't => Reduce_act Prod'enum_specifier'4
        | PACKED't => Reduce_act Prod'enum_specifier'4
        | LPAREN't => Reduce_act Prod'enum_specifier'4
        | LONG't => Reduce_act Prod'enum_specifier'4
        | LBRACK't => Reduce_act Prod'enum_specifier'4
        | LBRACE't => Shift_act Nis'35 (eq_refl _)
        | INT't => Reduce_act Prod'enum_specifier'4
        | INLINE't => Reduce_act Prod'enum_specifier'4
        | FLOAT't => Reduce_act Prod'enum_specifier'4
        | EXTERN't => Reduce_act Prod'enum_specifier'4
        | ENUM't => Reduce_act Prod'enum_specifier'4
        | DOUBLE't => Reduce_act Prod'enum_specifier'4
        | CONST't => Reduce_act Prod'enum_specifier'4
        | COMMA't => Reduce_act Prod'enum_specifier'4
        | COLON't => Reduce_act Prod'enum_specifier'4
        | CHAR't => Reduce_act Prod'enum_specifier'4
        | AUTO't => Reduce_act Prod'enum_specifier'4
        | ATTRIBUTE't => Reduce_act Prod'enum_specifier'4
        | ALIGNAS't => Reduce_act Prod'enum_specifier'4
        | _ => Fail_act
      end)
    | Ninit Nis'35 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'36 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'36 => Default_reduce_act Prod'enumeration_constant'0
    | Ninit Nis'37 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RBRACE't => Shift_act Nis'38 (eq_refl _)
        | COMMA't => Shift_act Nis'39 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'38 => Default_reduce_act Prod'enum_specifier'0
    | Ninit Nis'39 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'36 (eq_refl _)
        | RBRACE't => Shift_act Nis'40 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'40 => Default_reduce_act Prod'enum_specifier'2
    | Ninit Nis'41 => Default_reduce_act Prod'enumerator_list'1
    | Ninit Nis'42 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RBRACE't => Reduce_act Prod'enumerator'0
        | EQ't => Shift_act Nis'43 (eq_refl _)
        | COMMA't => Reduce_act Prod'enumerator'0
        | _ => Fail_act
      end)
    | Ninit Nis'43 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'44 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'30 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'45 => Default_reduce_act Prod'primary_expression'1
    | Ninit Nis'46 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | LPAREN't => Shift_act Nis'47 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'47 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'48 => Default_reduce_act Prod'unary_operator'5
    | Ninit Nis'49 => Default_reduce_act Prod'unary_operator'0
    | Ninit Nis'50 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'51 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'51 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VOLATILE't => Shift_act Nis'1 (eq_refl _)
        | VOID't => Shift_act Nis'2 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | UNSIGNED't => Shift_act Nis'3 (eq_refl _)
        | UNION't => Shift_act Nis'4 (eq_refl _)
        | UNDERSCORE_BOOL't => Shift_act Nis'5 (eq_refl _)
        | TYPEDEF_NAME't => Shift_act Nis'6 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRUCT't => Shift_act Nis'8 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | SIGNED't => Shift_act Nis'10 (eq_refl _)
        | SHORT't => Shift_act Nis'11 (eq_refl _)
        | RESTRICT't => Shift_act Nis'13 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | PACKED't => Shift_act Nis'16 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | LONG't => Shift_act Nis'27 (eq_refl _)
        | INT't => Shift_act Nis'28 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | FLOAT't => Shift_act Nis'31 (eq_refl _)
        | ENUM't => Shift_act Nis'32 (eq_refl _)
        | DOUBLE't => Shift_act Nis'52 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | CONST't => Shift_act Nis'53 (eq_refl _)
        | CHAR't => Shift_act Nis'54 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | ATTRIBUTE't => Shift_act Nis'55 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'162 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'52 => Default_reduce_act Prod'type_specifier'6
    | Ninit Nis'53 => Default_reduce_act Prod'type_qualifier'0
    | Ninit Nis'54 => Default_reduce_act Prod'type_specifier'1
    | Ninit Nis'55 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | LPAREN't => Shift_act Nis'56 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'56 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | LPAREN't => Shift_act Nis'57 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'57 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Reduce_act Prod'gcc_attribute'0
        | PACKED't => Shift_act Nis'58 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'59 (eq_refl _)
        | CONST't => Shift_act Nis'60 (eq_refl _)
        | COMMA't => Reduce_act Prod'gcc_attribute'0
        | _ => Fail_act
      end)
    | Ninit Nis'58 => Default_reduce_act Prod'gcc_attribute_word'2
    | Ninit Nis'59 => Default_reduce_act Prod'gcc_attribute_word'0
    | Ninit Nis'60 => Default_reduce_act Prod'gcc_attribute_word'1
    | Ninit Nis'61 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Reduce_act Prod'gcc_attribute'1
        | LPAREN't => Shift_act Nis'62 (eq_refl _)
        | COMMA't => Reduce_act Prod'gcc_attribute'1
        | _ => Fail_act
      end)
    | Ninit Nis'62 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | RPAREN't => Shift_act Nis'63 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'63 => Default_reduce_act Prod'gcc_attribute'2
    | Ninit Nis'64 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'65 => Default_reduce_act Prod'cast_expression'0
    | Ninit Nis'66 => Default_reduce_act Prod'postfix_expression'0
    | Ninit Nis'67 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | XOR_ASSIGN't => Reduce_act Prod'unary_expression'0
        | SUB_ASSIGN't => Reduce_act Prod'unary_expression'0
        | STAR't => Reduce_act Prod'unary_expression'0
        | SLASH't => Reduce_act Prod'unary_expression'0
        | SEMICOLON't => Reduce_act Prod'unary_expression'0
        | RPAREN't => Reduce_act Prod'unary_expression'0
        | RIGHT_ASSIGN't => Reduce_act Prod'unary_expression'0
        | RIGHT't => Reduce_act Prod'unary_expression'0
        | RBRACK't => Reduce_act Prod'unary_expression'0
        | RBRACE't => Reduce_act Prod'unary_expression'0
        | QUESTION't => Reduce_act Prod'unary_expression'0
        | PTR't => Shift_act Nis'68 (eq_refl _)
        | PLUS't => Reduce_act Prod'unary_expression'0
        | PERCENT't => Reduce_act Prod'unary_expression'0
        | OR_ASSIGN't => Reduce_act Prod'unary_expression'0
        | NEQ't => Reduce_act Prod'unary_expression'0
        | MUL_ASSIGN't => Reduce_act Prod'unary_expression'0
        | MOD_ASSIGN't => Reduce_act Prod'unary_expression'0
        | MINUS't => Reduce_act Prod'unary_expression'0
        | LT't => Reduce_act Prod'unary_expression'0
        | LPAREN't => Shift_act Nis'70 (eq_refl _)
        | LEQ't => Reduce_act Prod'unary_expression'0
        | LEFT_ASSIGN't => Reduce_act Prod'unary_expression'0
        | LEFT't => Reduce_act Prod'unary_expression'0
        | LBRACK't => Shift_act Nis'146 (eq_refl _)
        | INC't => Shift_act Nis'149 (eq_refl _)
        | HAT't => Reduce_act Prod'unary_expression'0
        | GT't => Reduce_act Prod'unary_expression'0
        | GEQ't => Reduce_act Prod'unary_expression'0
        | EQEQ't => Reduce_act Prod'unary_expression'0
        | EQ't => Reduce_act Prod'unary_expression'0
        | DOT't => Shift_act Nis'150 (eq_refl _)
        | DIV_ASSIGN't => Reduce_act Prod'unary_expression'0
        | DEC't => Shift_act Nis'152 (eq_refl _)
        | COMMA't => Reduce_act Prod'unary_expression'0
        | COLON't => Reduce_act Prod'unary_expression'0
        | BARBAR't => Reduce_act Prod'unary_expression'0
        | BAR't => Reduce_act Prod'unary_expression'0
        | AND_ASSIGN't => Reduce_act Prod'unary_expression'0
        | ANDAND't => Reduce_act Prod'unary_expression'0
        | AND't => Reduce_act Prod'unary_expression'0
        | ADD_ASSIGN't => Reduce_act Prod'unary_expression'0
        | _ => Fail_act
      end)
    | Ninit Nis'68 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | OTHER_NAME't => Shift_act Nis'69 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'69 => Default_reduce_act Prod'postfix_expression'6
    | Ninit Nis'70 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | RPAREN't => Shift_act Nis'71 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'71 => Default_reduce_act Prod'postfix_expression'3
    | Ninit Nis'72 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | XOR_ASSIGN't => Shift_act Nis'73 (eq_refl _)
        | SUB_ASSIGN't => Shift_act Nis'74 (eq_refl _)
        | STAR't => Reduce_act Prod'cast_expression'0
        | SLASH't => Reduce_act Prod'cast_expression'0
        | SEMICOLON't => Reduce_act Prod'cast_expression'0
        | RPAREN't => Reduce_act Prod'cast_expression'0
        | RIGHT_ASSIGN't => Shift_act Nis'75 (eq_refl _)
        | RIGHT't => Reduce_act Prod'cast_expression'0
        | RBRACK't => Reduce_act Prod'cast_expression'0
        | RBRACE't => Reduce_act Prod'cast_expression'0
        | QUESTION't => Reduce_act Prod'cast_expression'0
        | PLUS't => Reduce_act Prod'cast_expression'0
        | PERCENT't => Reduce_act Prod'cast_expression'0
        | OR_ASSIGN't => Shift_act Nis'76 (eq_refl _)
        | NEQ't => Reduce_act Prod'cast_expression'0
        | MUL_ASSIGN't => Shift_act Nis'77 (eq_refl _)
        | MOD_ASSIGN't => Shift_act Nis'78 (eq_refl _)
        | MINUS't => Reduce_act Prod'cast_expression'0
        | LT't => Reduce_act Prod'cast_expression'0
        | LEQ't => Reduce_act Prod'cast_expression'0
        | LEFT_ASSIGN't => Shift_act Nis'79 (eq_refl _)
        | LEFT't => Reduce_act Prod'cast_expression'0
        | HAT't => Reduce_act Prod'cast_expression'0
        | GT't => Reduce_act Prod'cast_expression'0
        | GEQ't => Reduce_act Prod'cast_expression'0
        | EQEQ't => Reduce_act Prod'cast_expression'0
        | EQ't => Shift_act Nis'80 (eq_refl _)
        | DIV_ASSIGN't => Shift_act Nis'81 (eq_refl _)
        | COMMA't => Reduce_act Prod'cast_expression'0
        | COLON't => Reduce_act Prod'cast_expression'0
        | BARBAR't => Reduce_act Prod'cast_expression'0
        | BAR't => Reduce_act Prod'cast_expression'0
        | AND_ASSIGN't => Shift_act Nis'82 (eq_refl _)
        | ANDAND't => Reduce_act Prod'cast_expression'0
        | AND't => Reduce_act Prod'cast_expression'0
        | ADD_ASSIGN't => Shift_act Nis'83 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'73 => Default_reduce_act Prod'assignment_operator'8
    | Ninit Nis'74 => Default_reduce_act Prod'assignment_operator'5
    | Ninit Nis'75 => Default_reduce_act Prod'assignment_operator'7
    | Ninit Nis'76 => Default_reduce_act Prod'assignment_operator'9
    | Ninit Nis'77 => Default_reduce_act Prod'assignment_operator'1
    | Ninit Nis'78 => Default_reduce_act Prod'assignment_operator'3
    | Ninit Nis'79 => Default_reduce_act Prod'assignment_operator'6
    | Ninit Nis'80 => Default_reduce_act Prod'assignment_operator'0
    | Ninit Nis'81 => Default_reduce_act Prod'assignment_operator'2
    | Ninit Nis'82 => Default_reduce_act Prod'assignment_operator'10
    | Ninit Nis'83 => Default_reduce_act Prod'assignment_operator'4
    | Ninit Nis'84 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'85 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Reduce_act Prod'relational_expression'0
        | RPAREN't => Reduce_act Prod'relational_expression'0
        | RIGHT't => Shift_act Nis'86 (eq_refl _)
        | RBRACK't => Reduce_act Prod'relational_expression'0
        | RBRACE't => Reduce_act Prod'relational_expression'0
        | QUESTION't => Reduce_act Prod'relational_expression'0
        | NEQ't => Reduce_act Prod'relational_expression'0
        | LT't => Reduce_act Prod'relational_expression'0
        | LEQ't => Reduce_act Prod'relational_expression'0
        | LEFT't => Shift_act Nis'100 (eq_refl _)
        | HAT't => Reduce_act Prod'relational_expression'0
        | GT't => Reduce_act Prod'relational_expression'0
        | GEQ't => Reduce_act Prod'relational_expression'0
        | EQEQ't => Reduce_act Prod'relational_expression'0
        | COMMA't => Reduce_act Prod'relational_expression'0
        | COLON't => Reduce_act Prod'relational_expression'0
        | BARBAR't => Reduce_act Prod'relational_expression'0
        | BAR't => Reduce_act Prod'relational_expression'0
        | ANDAND't => Reduce_act Prod'relational_expression'0
        | AND't => Reduce_act Prod'relational_expression'0
        | _ => Fail_act
      end)
    | Ninit Nis'86 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'87 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | STAR't => Shift_act Nis'88 (eq_refl _)
        | SLASH't => Shift_act Nis'90 (eq_refl _)
        | SEMICOLON't => Reduce_act Prod'additive_expression'0
        | RPAREN't => Reduce_act Prod'additive_expression'0
        | RIGHT't => Reduce_act Prod'additive_expression'0
        | RBRACK't => Reduce_act Prod'additive_expression'0
        | RBRACE't => Reduce_act Prod'additive_expression'0
        | QUESTION't => Reduce_act Prod'additive_expression'0
        | PLUS't => Reduce_act Prod'additive_expression'0
        | PERCENT't => Shift_act Nis'92 (eq_refl _)
        | NEQ't => Reduce_act Prod'additive_expression'0
        | MINUS't => Reduce_act Prod'additive_expression'0
        | LT't => Reduce_act Prod'additive_expression'0
        | LEQ't => Reduce_act Prod'additive_expression'0
        | LEFT't => Reduce_act Prod'additive_expression'0
        | HAT't => Reduce_act Prod'additive_expression'0
        | GT't => Reduce_act Prod'additive_expression'0
        | GEQ't => Reduce_act Prod'additive_expression'0
        | EQEQ't => Reduce_act Prod'additive_expression'0
        | COMMA't => Reduce_act Prod'additive_expression'0
        | COLON't => Reduce_act Prod'additive_expression'0
        | BARBAR't => Reduce_act Prod'additive_expression'0
        | BAR't => Reduce_act Prod'additive_expression'0
        | ANDAND't => Reduce_act Prod'additive_expression'0
        | AND't => Reduce_act Prod'additive_expression'0
        | _ => Fail_act
      end)
    | Ninit Nis'88 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'89 => Default_reduce_act Prod'multiplicative_expression'1
    | Ninit Nis'90 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'91 => Default_reduce_act Prod'multiplicative_expression'2
    | Ninit Nis'92 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'93 => Default_reduce_act Prod'multiplicative_expression'3
    | Ninit Nis'94 => Default_reduce_act Prod'multiplicative_expression'0
    | Ninit Nis'95 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Reduce_act Prod'shift_expression'2
        | RPAREN't => Reduce_act Prod'shift_expression'2
        | RIGHT't => Reduce_act Prod'shift_expression'2
        | RBRACK't => Reduce_act Prod'shift_expression'2
        | RBRACE't => Reduce_act Prod'shift_expression'2
        | QUESTION't => Reduce_act Prod'shift_expression'2
        | PLUS't => Shift_act Nis'96 (eq_refl _)
        | NEQ't => Reduce_act Prod'shift_expression'2
        | MINUS't => Shift_act Nis'98 (eq_refl _)
        | LT't => Reduce_act Prod'shift_expression'2
        | LEQ't => Reduce_act Prod'shift_expression'2
        | LEFT't => Reduce_act Prod'shift_expression'2
        | HAT't => Reduce_act Prod'shift_expression'2
        | GT't => Reduce_act Prod'shift_expression'2
        | GEQ't => Reduce_act Prod'shift_expression'2
        | EQEQ't => Reduce_act Prod'shift_expression'2
        | COMMA't => Reduce_act Prod'shift_expression'2
        | COLON't => Reduce_act Prod'shift_expression'2
        | BARBAR't => Reduce_act Prod'shift_expression'2
        | BAR't => Reduce_act Prod'shift_expression'2
        | ANDAND't => Reduce_act Prod'shift_expression'2
        | AND't => Reduce_act Prod'shift_expression'2
        | _ => Fail_act
      end)
    | Ninit Nis'96 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'97 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | STAR't => Shift_act Nis'88 (eq_refl _)
        | SLASH't => Shift_act Nis'90 (eq_refl _)
        | SEMICOLON't => Reduce_act Prod'additive_expression'1
        | RPAREN't => Reduce_act Prod'additive_expression'1
        | RIGHT't => Reduce_act Prod'additive_expression'1
        | RBRACK't => Reduce_act Prod'additive_expression'1
        | RBRACE't => Reduce_act Prod'additive_expression'1
        | QUESTION't => Reduce_act Prod'additive_expression'1
        | PLUS't => Reduce_act Prod'additive_expression'1
        | PERCENT't => Shift_act Nis'92 (eq_refl _)
        | NEQ't => Reduce_act Prod'additive_expression'1
        | MINUS't => Reduce_act Prod'additive_expression'1
        | LT't => Reduce_act Prod'additive_expression'1
        | LEQ't => Reduce_act Prod'additive_expression'1
        | LEFT't => Reduce_act Prod'additive_expression'1
        | HAT't => Reduce_act Prod'additive_expression'1
        | GT't => Reduce_act Prod'additive_expression'1
        | GEQ't => Reduce_act Prod'additive_expression'1
        | EQEQ't => Reduce_act Prod'additive_expression'1
        | COMMA't => Reduce_act Prod'additive_expression'1
        | COLON't => Reduce_act Prod'additive_expression'1
        | BARBAR't => Reduce_act Prod'additive_expression'1
        | BAR't => Reduce_act Prod'additive_expression'1
        | ANDAND't => Reduce_act Prod'additive_expression'1
        | AND't => Reduce_act Prod'additive_expression'1
        | _ => Fail_act
      end)
    | Ninit Nis'98 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'99 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | STAR't => Shift_act Nis'88 (eq_refl _)
        | SLASH't => Shift_act Nis'90 (eq_refl _)
        | SEMICOLON't => Reduce_act Prod'additive_expression'2
        | RPAREN't => Reduce_act Prod'additive_expression'2
        | RIGHT't => Reduce_act Prod'additive_expression'2
        | RBRACK't => Reduce_act Prod'additive_expression'2
        | RBRACE't => Reduce_act Prod'additive_expression'2
        | QUESTION't => Reduce_act Prod'additive_expression'2
        | PLUS't => Reduce_act Prod'additive_expression'2
        | PERCENT't => Shift_act Nis'92 (eq_refl _)
        | NEQ't => Reduce_act Prod'additive_expression'2
        | MINUS't => Reduce_act Prod'additive_expression'2
        | LT't => Reduce_act Prod'additive_expression'2
        | LEQ't => Reduce_act Prod'additive_expression'2
        | LEFT't => Reduce_act Prod'additive_expression'2
        | HAT't => Reduce_act Prod'additive_expression'2
        | GT't => Reduce_act Prod'additive_expression'2
        | GEQ't => Reduce_act Prod'additive_expression'2
        | EQEQ't => Reduce_act Prod'additive_expression'2
        | COMMA't => Reduce_act Prod'additive_expression'2
        | COLON't => Reduce_act Prod'additive_expression'2
        | BARBAR't => Reduce_act Prod'additive_expression'2
        | BAR't => Reduce_act Prod'additive_expression'2
        | ANDAND't => Reduce_act Prod'additive_expression'2
        | AND't => Reduce_act Prod'additive_expression'2
        | _ => Fail_act
      end)
    | Ninit Nis'100 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'101 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Reduce_act Prod'shift_expression'1
        | RPAREN't => Reduce_act Prod'shift_expression'1
        | RIGHT't => Reduce_act Prod'shift_expression'1
        | RBRACK't => Reduce_act Prod'shift_expression'1
        | RBRACE't => Reduce_act Prod'shift_expression'1
        | QUESTION't => Reduce_act Prod'shift_expression'1
        | PLUS't => Shift_act Nis'96 (eq_refl _)
        | NEQ't => Reduce_act Prod'shift_expression'1
        | MINUS't => Shift_act Nis'98 (eq_refl _)
        | LT't => Reduce_act Prod'shift_expression'1
        | LEQ't => Reduce_act Prod'shift_expression'1
        | LEFT't => Reduce_act Prod'shift_expression'1
        | HAT't => Reduce_act Prod'shift_expression'1
        | GT't => Reduce_act Prod'shift_expression'1
        | GEQ't => Reduce_act Prod'shift_expression'1
        | EQEQ't => Reduce_act Prod'shift_expression'1
        | COMMA't => Reduce_act Prod'shift_expression'1
        | COLON't => Reduce_act Prod'shift_expression'1
        | BARBAR't => Reduce_act Prod'shift_expression'1
        | BAR't => Reduce_act Prod'shift_expression'1
        | ANDAND't => Reduce_act Prod'shift_expression'1
        | AND't => Reduce_act Prod'shift_expression'1
        | _ => Fail_act
      end)
    | Ninit Nis'102 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Reduce_act Prod'equality_expression'0
        | RPAREN't => Reduce_act Prod'equality_expression'0
        | RBRACK't => Reduce_act Prod'equality_expression'0
        | RBRACE't => Reduce_act Prod'equality_expression'0
        | QUESTION't => Reduce_act Prod'equality_expression'0
        | NEQ't => Reduce_act Prod'equality_expression'0
        | LT't => Shift_act Nis'103 (eq_refl _)
        | LEQ't => Shift_act Nis'106 (eq_refl _)
        | HAT't => Reduce_act Prod'equality_expression'0
        | GT't => Shift_act Nis'108 (eq_refl _)
        | GEQ't => Shift_act Nis'110 (eq_refl _)
        | EQEQ't => Reduce_act Prod'equality_expression'0
        | COMMA't => Reduce_act Prod'equality_expression'0
        | COLON't => Reduce_act Prod'equality_expression'0
        | BARBAR't => Reduce_act Prod'equality_expression'0
        | BAR't => Reduce_act Prod'equality_expression'0
        | ANDAND't => Reduce_act Prod'equality_expression'0
        | AND't => Reduce_act Prod'equality_expression'0
        | _ => Fail_act
      end)
    | Ninit Nis'103 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'104 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Reduce_act Prod'relational_expression'1
        | RPAREN't => Reduce_act Prod'relational_expression'1
        | RIGHT't => Shift_act Nis'86 (eq_refl _)
        | RBRACK't => Reduce_act Prod'relational_expression'1
        | RBRACE't => Reduce_act Prod'relational_expression'1
        | QUESTION't => Reduce_act Prod'relational_expression'1
        | NEQ't => Reduce_act Prod'relational_expression'1
        | LT't => Reduce_act Prod'relational_expression'1
        | LEQ't => Reduce_act Prod'relational_expression'1
        | LEFT't => Shift_act Nis'100 (eq_refl _)
        | HAT't => Reduce_act Prod'relational_expression'1
        | GT't => Reduce_act Prod'relational_expression'1
        | GEQ't => Reduce_act Prod'relational_expression'1
        | EQEQ't => Reduce_act Prod'relational_expression'1
        | COMMA't => Reduce_act Prod'relational_expression'1
        | COLON't => Reduce_act Prod'relational_expression'1
        | BARBAR't => Reduce_act Prod'relational_expression'1
        | BAR't => Reduce_act Prod'relational_expression'1
        | ANDAND't => Reduce_act Prod'relational_expression'1
        | AND't => Reduce_act Prod'relational_expression'1
        | _ => Fail_act
      end)
    | Ninit Nis'105 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Reduce_act Prod'shift_expression'0
        | RPAREN't => Reduce_act Prod'shift_expression'0
        | RIGHT't => Reduce_act Prod'shift_expression'0
        | RBRACK't => Reduce_act Prod'shift_expression'0
        | RBRACE't => Reduce_act Prod'shift_expression'0
        | QUESTION't => Reduce_act Prod'shift_expression'0
        | PLUS't => Shift_act Nis'96 (eq_refl _)
        | NEQ't => Reduce_act Prod'shift_expression'0
        | MINUS't => Shift_act Nis'98 (eq_refl _)
        | LT't => Reduce_act Prod'shift_expression'0
        | LEQ't => Reduce_act Prod'shift_expression'0
        | LEFT't => Reduce_act Prod'shift_expression'0
        | HAT't => Reduce_act Prod'shift_expression'0
        | GT't => Reduce_act Prod'shift_expression'0
        | GEQ't => Reduce_act Prod'shift_expression'0
        | EQEQ't => Reduce_act Prod'shift_expression'0
        | COMMA't => Reduce_act Prod'shift_expression'0
        | COLON't => Reduce_act Prod'shift_expression'0
        | BARBAR't => Reduce_act Prod'shift_expression'0
        | BAR't => Reduce_act Prod'shift_expression'0
        | ANDAND't => Reduce_act Prod'shift_expression'0
        | AND't => Reduce_act Prod'shift_expression'0
        | _ => Fail_act
      end)
    | Ninit Nis'106 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'107 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Reduce_act Prod'relational_expression'3
        | RPAREN't => Reduce_act Prod'relational_expression'3
        | RIGHT't => Shift_act Nis'86 (eq_refl _)
        | RBRACK't => Reduce_act Prod'relational_expression'3
        | RBRACE't => Reduce_act Prod'relational_expression'3
        | QUESTION't => Reduce_act Prod'relational_expression'3
        | NEQ't => Reduce_act Prod'relational_expression'3
        | LT't => Reduce_act Prod'relational_expression'3
        | LEQ't => Reduce_act Prod'relational_expression'3
        | LEFT't => Shift_act Nis'100 (eq_refl _)
        | HAT't => Reduce_act Prod'relational_expression'3
        | GT't => Reduce_act Prod'relational_expression'3
        | GEQ't => Reduce_act Prod'relational_expression'3
        | EQEQ't => Reduce_act Prod'relational_expression'3
        | COMMA't => Reduce_act Prod'relational_expression'3
        | COLON't => Reduce_act Prod'relational_expression'3
        | BARBAR't => Reduce_act Prod'relational_expression'3
        | BAR't => Reduce_act Prod'relational_expression'3
        | ANDAND't => Reduce_act Prod'relational_expression'3
        | AND't => Reduce_act Prod'relational_expression'3
        | _ => Fail_act
      end)
    | Ninit Nis'108 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'109 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Reduce_act Prod'relational_expression'2
        | RPAREN't => Reduce_act Prod'relational_expression'2
        | RIGHT't => Shift_act Nis'86 (eq_refl _)
        | RBRACK't => Reduce_act Prod'relational_expression'2
        | RBRACE't => Reduce_act Prod'relational_expression'2
        | QUESTION't => Reduce_act Prod'relational_expression'2
        | NEQ't => Reduce_act Prod'relational_expression'2
        | LT't => Reduce_act Prod'relational_expression'2
        | LEQ't => Reduce_act Prod'relational_expression'2
        | LEFT't => Shift_act Nis'100 (eq_refl _)
        | HAT't => Reduce_act Prod'relational_expression'2
        | GT't => Reduce_act Prod'relational_expression'2
        | GEQ't => Reduce_act Prod'relational_expression'2
        | EQEQ't => Reduce_act Prod'relational_expression'2
        | COMMA't => Reduce_act Prod'relational_expression'2
        | COLON't => Reduce_act Prod'relational_expression'2
        | BARBAR't => Reduce_act Prod'relational_expression'2
        | BAR't => Reduce_act Prod'relational_expression'2
        | ANDAND't => Reduce_act Prod'relational_expression'2
        | AND't => Reduce_act Prod'relational_expression'2
        | _ => Fail_act
      end)
    | Ninit Nis'110 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'111 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Reduce_act Prod'relational_expression'4
        | RPAREN't => Reduce_act Prod'relational_expression'4
        | RIGHT't => Shift_act Nis'86 (eq_refl _)
        | RBRACK't => Reduce_act Prod'relational_expression'4
        | RBRACE't => Reduce_act Prod'relational_expression'4
        | QUESTION't => Reduce_act Prod'relational_expression'4
        | NEQ't => Reduce_act Prod'relational_expression'4
        | LT't => Reduce_act Prod'relational_expression'4
        | LEQ't => Reduce_act Prod'relational_expression'4
        | LEFT't => Shift_act Nis'100 (eq_refl _)
        | HAT't => Reduce_act Prod'relational_expression'4
        | GT't => Reduce_act Prod'relational_expression'4
        | GEQ't => Reduce_act Prod'relational_expression'4
        | EQEQ't => Reduce_act Prod'relational_expression'4
        | COMMA't => Reduce_act Prod'relational_expression'4
        | COLON't => Reduce_act Prod'relational_expression'4
        | BARBAR't => Reduce_act Prod'relational_expression'4
        | BAR't => Reduce_act Prod'relational_expression'4
        | ANDAND't => Reduce_act Prod'relational_expression'4
        | AND't => Reduce_act Prod'relational_expression'4
        | _ => Fail_act
      end)
    | Ninit Nis'112 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Reduce_act Prod'conditional_expression'0
        | RPAREN't => Reduce_act Prod'conditional_expression'0
        | RBRACK't => Reduce_act Prod'conditional_expression'0
        | RBRACE't => Reduce_act Prod'conditional_expression'0
        | QUESTION't => Shift_act Nis'113 (eq_refl _)
        | COMMA't => Reduce_act Prod'conditional_expression'0
        | COLON't => Reduce_act Prod'conditional_expression'0
        | BARBAR't => Shift_act Nis'138 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'113 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'114 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Reduce_act Prod'logical_OR_expression'0
        | RPAREN't => Reduce_act Prod'logical_OR_expression'0
        | RBRACK't => Reduce_act Prod'logical_OR_expression'0
        | RBRACE't => Reduce_act Prod'logical_OR_expression'0
        | QUESTION't => Reduce_act Prod'logical_OR_expression'0
        | COMMA't => Reduce_act Prod'logical_OR_expression'0
        | COLON't => Reduce_act Prod'logical_OR_expression'0
        | BARBAR't => Reduce_act Prod'logical_OR_expression'0
        | ANDAND't => Shift_act Nis'115 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'115 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'116 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Reduce_act Prod'logical_AND_expression'1
        | RPAREN't => Reduce_act Prod'logical_AND_expression'1
        | RBRACK't => Reduce_act Prod'logical_AND_expression'1
        | RBRACE't => Reduce_act Prod'logical_AND_expression'1
        | QUESTION't => Reduce_act Prod'logical_AND_expression'1
        | COMMA't => Reduce_act Prod'logical_AND_expression'1
        | COLON't => Reduce_act Prod'logical_AND_expression'1
        | BARBAR't => Reduce_act Prod'logical_AND_expression'1
        | BAR't => Shift_act Nis'117 (eq_refl _)
        | ANDAND't => Reduce_act Prod'logical_AND_expression'1
        | _ => Fail_act
      end)
    | Ninit Nis'117 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'118 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Reduce_act Prod'inclusive_OR_expression'1
        | RPAREN't => Reduce_act Prod'inclusive_OR_expression'1
        | RBRACK't => Reduce_act Prod'inclusive_OR_expression'1
        | RBRACE't => Reduce_act Prod'inclusive_OR_expression'1
        | QUESTION't => Reduce_act Prod'inclusive_OR_expression'1
        | HAT't => Shift_act Nis'119 (eq_refl _)
        | COMMA't => Reduce_act Prod'inclusive_OR_expression'1
        | COLON't => Reduce_act Prod'inclusive_OR_expression'1
        | BARBAR't => Reduce_act Prod'inclusive_OR_expression'1
        | BAR't => Reduce_act Prod'inclusive_OR_expression'1
        | ANDAND't => Reduce_act Prod'inclusive_OR_expression'1
        | _ => Fail_act
      end)
    | Ninit Nis'119 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'120 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Reduce_act Prod'AND_expression'0
        | RPAREN't => Reduce_act Prod'AND_expression'0
        | RBRACK't => Reduce_act Prod'AND_expression'0
        | RBRACE't => Reduce_act Prod'AND_expression'0
        | QUESTION't => Reduce_act Prod'AND_expression'0
        | NEQ't => Shift_act Nis'121 (eq_refl _)
        | HAT't => Reduce_act Prod'AND_expression'0
        | EQEQ't => Shift_act Nis'123 (eq_refl _)
        | COMMA't => Reduce_act Prod'AND_expression'0
        | COLON't => Reduce_act Prod'AND_expression'0
        | BARBAR't => Reduce_act Prod'AND_expression'0
        | BAR't => Reduce_act Prod'AND_expression'0
        | ANDAND't => Reduce_act Prod'AND_expression'0
        | AND't => Reduce_act Prod'AND_expression'0
        | _ => Fail_act
      end)
    | Ninit Nis'121 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'122 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Reduce_act Prod'equality_expression'2
        | RPAREN't => Reduce_act Prod'equality_expression'2
        | RBRACK't => Reduce_act Prod'equality_expression'2
        | RBRACE't => Reduce_act Prod'equality_expression'2
        | QUESTION't => Reduce_act Prod'equality_expression'2
        | NEQ't => Reduce_act Prod'equality_expression'2
        | LT't => Shift_act Nis'103 (eq_refl _)
        | LEQ't => Shift_act Nis'106 (eq_refl _)
        | HAT't => Reduce_act Prod'equality_expression'2
        | GT't => Shift_act Nis'108 (eq_refl _)
        | GEQ't => Shift_act Nis'110 (eq_refl _)
        | EQEQ't => Reduce_act Prod'equality_expression'2
        | COMMA't => Reduce_act Prod'equality_expression'2
        | COLON't => Reduce_act Prod'equality_expression'2
        | BARBAR't => Reduce_act Prod'equality_expression'2
        | BAR't => Reduce_act Prod'equality_expression'2
        | ANDAND't => Reduce_act Prod'equality_expression'2
        | AND't => Reduce_act Prod'equality_expression'2
        | _ => Fail_act
      end)
    | Ninit Nis'123 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'124 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Reduce_act Prod'equality_expression'1
        | RPAREN't => Reduce_act Prod'equality_expression'1
        | RBRACK't => Reduce_act Prod'equality_expression'1
        | RBRACE't => Reduce_act Prod'equality_expression'1
        | QUESTION't => Reduce_act Prod'equality_expression'1
        | NEQ't => Reduce_act Prod'equality_expression'1
        | LT't => Shift_act Nis'103 (eq_refl _)
        | LEQ't => Shift_act Nis'106 (eq_refl _)
        | HAT't => Reduce_act Prod'equality_expression'1
        | GT't => Shift_act Nis'108 (eq_refl _)
        | GEQ't => Shift_act Nis'110 (eq_refl _)
        | EQEQ't => Reduce_act Prod'equality_expression'1
        | COMMA't => Reduce_act Prod'equality_expression'1
        | COLON't => Reduce_act Prod'equality_expression'1
        | BARBAR't => Reduce_act Prod'equality_expression'1
        | BAR't => Reduce_act Prod'equality_expression'1
        | ANDAND't => Reduce_act Prod'equality_expression'1
        | AND't => Reduce_act Prod'equality_expression'1
        | _ => Fail_act
      end)
    | Ninit Nis'125 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Reduce_act Prod'exclusive_OR_expression'1
        | RPAREN't => Reduce_act Prod'exclusive_OR_expression'1
        | RBRACK't => Reduce_act Prod'exclusive_OR_expression'1
        | RBRACE't => Reduce_act Prod'exclusive_OR_expression'1
        | QUESTION't => Reduce_act Prod'exclusive_OR_expression'1
        | HAT't => Reduce_act Prod'exclusive_OR_expression'1
        | COMMA't => Reduce_act Prod'exclusive_OR_expression'1
        | COLON't => Reduce_act Prod'exclusive_OR_expression'1
        | BARBAR't => Reduce_act Prod'exclusive_OR_expression'1
        | BAR't => Reduce_act Prod'exclusive_OR_expression'1
        | ANDAND't => Reduce_act Prod'exclusive_OR_expression'1
        | AND't => Shift_act Nis'126 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'126 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'127 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Reduce_act Prod'AND_expression'1
        | RPAREN't => Reduce_act Prod'AND_expression'1
        | RBRACK't => Reduce_act Prod'AND_expression'1
        | RBRACE't => Reduce_act Prod'AND_expression'1
        | QUESTION't => Reduce_act Prod'AND_expression'1
        | NEQ't => Shift_act Nis'121 (eq_refl _)
        | HAT't => Reduce_act Prod'AND_expression'1
        | EQEQ't => Shift_act Nis'123 (eq_refl _)
        | COMMA't => Reduce_act Prod'AND_expression'1
        | COLON't => Reduce_act Prod'AND_expression'1
        | BARBAR't => Reduce_act Prod'AND_expression'1
        | BAR't => Reduce_act Prod'AND_expression'1
        | ANDAND't => Reduce_act Prod'AND_expression'1
        | AND't => Reduce_act Prod'AND_expression'1
        | _ => Fail_act
      end)
    | Ninit Nis'128 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Reduce_act Prod'exclusive_OR_expression'0
        | RPAREN't => Reduce_act Prod'exclusive_OR_expression'0
        | RBRACK't => Reduce_act Prod'exclusive_OR_expression'0
        | RBRACE't => Reduce_act Prod'exclusive_OR_expression'0
        | QUESTION't => Reduce_act Prod'exclusive_OR_expression'0
        | HAT't => Reduce_act Prod'exclusive_OR_expression'0
        | COMMA't => Reduce_act Prod'exclusive_OR_expression'0
        | COLON't => Reduce_act Prod'exclusive_OR_expression'0
        | BARBAR't => Reduce_act Prod'exclusive_OR_expression'0
        | BAR't => Reduce_act Prod'exclusive_OR_expression'0
        | ANDAND't => Reduce_act Prod'exclusive_OR_expression'0
        | AND't => Shift_act Nis'126 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'129 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Reduce_act Prod'inclusive_OR_expression'0
        | RPAREN't => Reduce_act Prod'inclusive_OR_expression'0
        | RBRACK't => Reduce_act Prod'inclusive_OR_expression'0
        | RBRACE't => Reduce_act Prod'inclusive_OR_expression'0
        | QUESTION't => Reduce_act Prod'inclusive_OR_expression'0
        | HAT't => Shift_act Nis'119 (eq_refl _)
        | COMMA't => Reduce_act Prod'inclusive_OR_expression'0
        | COLON't => Reduce_act Prod'inclusive_OR_expression'0
        | BARBAR't => Reduce_act Prod'inclusive_OR_expression'0
        | BAR't => Reduce_act Prod'inclusive_OR_expression'0
        | ANDAND't => Reduce_act Prod'inclusive_OR_expression'0
        | _ => Fail_act
      end)
    | Ninit Nis'130 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Reduce_act Prod'logical_AND_expression'0
        | RPAREN't => Reduce_act Prod'logical_AND_expression'0
        | RBRACK't => Reduce_act Prod'logical_AND_expression'0
        | RBRACE't => Reduce_act Prod'logical_AND_expression'0
        | QUESTION't => Reduce_act Prod'logical_AND_expression'0
        | COMMA't => Reduce_act Prod'logical_AND_expression'0
        | COLON't => Reduce_act Prod'logical_AND_expression'0
        | BARBAR't => Reduce_act Prod'logical_AND_expression'0
        | BAR't => Shift_act Nis'117 (eq_refl _)
        | ANDAND't => Reduce_act Prod'logical_AND_expression'0
        | _ => Fail_act
      end)
    | Ninit Nis'131 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | COMMA't => Shift_act Nis'132 (eq_refl _)
        | COLON't => Shift_act Nis'135 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'132 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'133 => Default_reduce_act Prod'assignment_expression'0
    | Ninit Nis'134 => Default_reduce_act Prod'expression'1
    | Ninit Nis'135 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'136 => Default_reduce_act Prod'conditional_expression'1
    | Ninit Nis'137 => Default_reduce_act Prod'expression'0
    | Ninit Nis'138 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'139 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Reduce_act Prod'logical_OR_expression'1
        | RPAREN't => Reduce_act Prod'logical_OR_expression'1
        | RBRACK't => Reduce_act Prod'logical_OR_expression'1
        | RBRACE't => Reduce_act Prod'logical_OR_expression'1
        | QUESTION't => Reduce_act Prod'logical_OR_expression'1
        | COMMA't => Reduce_act Prod'logical_OR_expression'1
        | COLON't => Reduce_act Prod'logical_OR_expression'1
        | BARBAR't => Reduce_act Prod'logical_OR_expression'1
        | ANDAND't => Shift_act Nis'115 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'140 => Default_reduce_act Prod'assignment_expression'1
    | Ninit Nis'141 => Default_reduce_act Prod'argument_expression_list'0
    | Ninit Nis'142 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'143 (eq_refl _)
        | COMMA't => Shift_act Nis'144 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'143 => Default_reduce_act Prod'postfix_expression'2
    | Ninit Nis'144 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'145 => Default_reduce_act Prod'argument_expression_list'1
    | Ninit Nis'146 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'147 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RBRACK't => Shift_act Nis'148 (eq_refl _)
        | COMMA't => Shift_act Nis'132 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'148 => Default_reduce_act Prod'postfix_expression'1
    | Ninit Nis'149 => Default_reduce_act Prod'postfix_expression'7
    | Ninit Nis'150 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | OTHER_NAME't => Shift_act Nis'151 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'151 => Default_reduce_act Prod'postfix_expression'5
    | Ninit Nis'152 => Default_reduce_act Prod'postfix_expression'8
    | Ninit Nis'153 => Default_reduce_act Prod'unary_expression'3
    | Ninit Nis'154 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'155 (eq_refl _)
        | COMMA't => Shift_act Nis'144 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'155 => Default_reduce_act Prod'gcc_attribute'3
    | Ninit Nis'156 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'157 (eq_refl _)
        | COMMA't => Shift_act Nis'159 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'157 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'158 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'158 => Default_reduce_act Prod'attribute_specifier'0
    | Ninit Nis'159 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Reduce_act Prod'gcc_attribute'0
        | PACKED't => Shift_act Nis'58 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'59 (eq_refl _)
        | CONST't => Shift_act Nis'60 (eq_refl _)
        | COMMA't => Reduce_act Prod'gcc_attribute'0
        | _ => Fail_act
      end)
    | Ninit Nis'160 => Default_reduce_act Prod'gcc_attribute_list'1
    | Ninit Nis'161 => Default_reduce_act Prod'gcc_attribute_list'0
    | Ninit Nis'162 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | LPAREN't => Shift_act Nis'163 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'163 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VOLATILE't => Shift_act Nis'1 (eq_refl _)
        | VOID't => Shift_act Nis'2 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | UNSIGNED't => Shift_act Nis'3 (eq_refl _)
        | UNION't => Shift_act Nis'4 (eq_refl _)
        | UNDERSCORE_BOOL't => Shift_act Nis'5 (eq_refl _)
        | TYPEDEF_NAME't => Shift_act Nis'6 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRUCT't => Shift_act Nis'8 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | SIGNED't => Shift_act Nis'10 (eq_refl _)
        | SHORT't => Shift_act Nis'11 (eq_refl _)
        | RESTRICT't => Shift_act Nis'13 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | PACKED't => Shift_act Nis'16 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | LONG't => Shift_act Nis'27 (eq_refl _)
        | INT't => Shift_act Nis'28 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | FLOAT't => Shift_act Nis'31 (eq_refl _)
        | ENUM't => Shift_act Nis'32 (eq_refl _)
        | DOUBLE't => Shift_act Nis'52 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | CONST't => Shift_act Nis'53 (eq_refl _)
        | CHAR't => Shift_act Nis'54 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | ATTRIBUTE't => Shift_act Nis'55 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'162 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'164 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VOLATILE't => Shift_act Nis'1 (eq_refl _)
        | VOID't => Shift_act Nis'2 (eq_refl _)
        | VAR_NAME't => Reduce_act Prod'specifier_qualifier_list'1
        | UNSIGNED't => Shift_act Nis'3 (eq_refl _)
        | UNION't => Shift_act Nis'4 (eq_refl _)
        | UNDERSCORE_BOOL't => Shift_act Nis'5 (eq_refl _)
        | TYPEDEF_NAME't => Shift_act Nis'6 (eq_refl _)
        | STRUCT't => Shift_act Nis'8 (eq_refl _)
        | STAR't => Reduce_act Prod'specifier_qualifier_list'1
        | SIGNED't => Shift_act Nis'10 (eq_refl _)
        | SHORT't => Shift_act Nis'11 (eq_refl _)
        | SEMICOLON't => Reduce_act Prod'specifier_qualifier_list'1
        | RPAREN't => Reduce_act Prod'specifier_qualifier_list'1
        | RESTRICT't => Shift_act Nis'13 (eq_refl _)
        | PACKED't => Shift_act Nis'16 (eq_refl _)
        | LPAREN't => Reduce_act Prod'specifier_qualifier_list'1
        | LONG't => Shift_act Nis'27 (eq_refl _)
        | LBRACK't => Reduce_act Prod'specifier_qualifier_list'1
        | INT't => Shift_act Nis'28 (eq_refl _)
        | FLOAT't => Shift_act Nis'31 (eq_refl _)
        | ENUM't => Shift_act Nis'32 (eq_refl _)
        | DOUBLE't => Shift_act Nis'52 (eq_refl _)
        | CONST't => Shift_act Nis'53 (eq_refl _)
        | COLON't => Reduce_act Prod'specifier_qualifier_list'1
        | CHAR't => Shift_act Nis'54 (eq_refl _)
        | ATTRIBUTE't => Shift_act Nis'55 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'162 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'165 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VOLATILE't => Shift_act Nis'1 (eq_refl _)
        | VOID't => Shift_act Nis'2 (eq_refl _)
        | VAR_NAME't => Reduce_act Prod'specifier_qualifier_list'3
        | UNSIGNED't => Shift_act Nis'3 (eq_refl _)
        | UNION't => Shift_act Nis'4 (eq_refl _)
        | UNDERSCORE_BOOL't => Shift_act Nis'5 (eq_refl _)
        | TYPEDEF_NAME't => Shift_act Nis'6 (eq_refl _)
        | STRUCT't => Shift_act Nis'8 (eq_refl _)
        | STAR't => Reduce_act Prod'specifier_qualifier_list'3
        | SIGNED't => Shift_act Nis'10 (eq_refl _)
        | SHORT't => Shift_act Nis'11 (eq_refl _)
        | SEMICOLON't => Reduce_act Prod'specifier_qualifier_list'3
        | RPAREN't => Reduce_act Prod'specifier_qualifier_list'3
        | RESTRICT't => Shift_act Nis'13 (eq_refl _)
        | PACKED't => Shift_act Nis'16 (eq_refl _)
        | LPAREN't => Reduce_act Prod'specifier_qualifier_list'3
        | LONG't => Shift_act Nis'27 (eq_refl _)
        | LBRACK't => Reduce_act Prod'specifier_qualifier_list'3
        | INT't => Shift_act Nis'28 (eq_refl _)
        | FLOAT't => Shift_act Nis'31 (eq_refl _)
        | ENUM't => Shift_act Nis'32 (eq_refl _)
        | DOUBLE't => Shift_act Nis'52 (eq_refl _)
        | CONST't => Shift_act Nis'53 (eq_refl _)
        | COLON't => Reduce_act Prod'specifier_qualifier_list'3
        | CHAR't => Shift_act Nis'54 (eq_refl _)
        | ATTRIBUTE't => Shift_act Nis'55 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'162 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'166 => Default_reduce_act Prod'type_specifier'10
    | Ninit Nis'167 => Default_reduce_act Prod'attribute_specifier_list'0
    | Ninit Nis'168 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | PACKED't => Shift_act Nis'16 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'169 (eq_refl _)
        | LBRACE't => Shift_act Nis'265 (eq_refl _)
        | ATTRIBUTE't => Shift_act Nis'55 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'162 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'169 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VOLATILE't => Reduce_act Prod'struct_or_union_specifier'2
        | VOID't => Reduce_act Prod'struct_or_union_specifier'2
        | VAR_NAME't => Reduce_act Prod'struct_or_union_specifier'2
        | UNSIGNED't => Reduce_act Prod'struct_or_union_specifier'2
        | UNION't => Reduce_act Prod'struct_or_union_specifier'2
        | UNDERSCORE_BOOL't => Reduce_act Prod'struct_or_union_specifier'2
        | TYPEDEF_NAME't => Reduce_act Prod'struct_or_union_specifier'2
        | TYPEDEF't => Reduce_act Prod'struct_or_union_specifier'2
        | STRUCT't => Reduce_act Prod'struct_or_union_specifier'2
        | STATIC't => Reduce_act Prod'struct_or_union_specifier'2
        | STAR't => Reduce_act Prod'struct_or_union_specifier'2
        | SIGNED't => Reduce_act Prod'struct_or_union_specifier'2
        | SHORT't => Reduce_act Prod'struct_or_union_specifier'2
        | SEMICOLON't => Reduce_act Prod'struct_or_union_specifier'2
        | RPAREN't => Reduce_act Prod'struct_or_union_specifier'2
        | RESTRICT't => Reduce_act Prod'struct_or_union_specifier'2
        | REGISTER't => Reduce_act Prod'struct_or_union_specifier'2
        | PACKED't => Reduce_act Prod'struct_or_union_specifier'2
        | LPAREN't => Reduce_act Prod'struct_or_union_specifier'2
        | LONG't => Reduce_act Prod'struct_or_union_specifier'2
        | LBRACK't => Reduce_act Prod'struct_or_union_specifier'2
        | LBRACE't => Shift_act Nis'170 (eq_refl _)
        | INT't => Reduce_act Prod'struct_or_union_specifier'2
        | INLINE't => Reduce_act Prod'struct_or_union_specifier'2
        | FLOAT't => Reduce_act Prod'struct_or_union_specifier'2
        | EXTERN't => Reduce_act Prod'struct_or_union_specifier'2
        | ENUM't => Reduce_act Prod'struct_or_union_specifier'2
        | DOUBLE't => Reduce_act Prod'struct_or_union_specifier'2
        | CONST't => Reduce_act Prod'struct_or_union_specifier'2
        | COMMA't => Reduce_act Prod'struct_or_union_specifier'2
        | COLON't => Reduce_act Prod'struct_or_union_specifier'2
        | CHAR't => Reduce_act Prod'struct_or_union_specifier'2
        | AUTO't => Reduce_act Prod'struct_or_union_specifier'2
        | ATTRIBUTE't => Reduce_act Prod'struct_or_union_specifier'2
        | ALIGNAS't => Reduce_act Prod'struct_or_union_specifier'2
        | _ => Fail_act
      end)
    | Ninit Nis'170 => Default_reduce_act Prod'struct_declaration_list'0
    | Ninit Nis'171 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VOLATILE't => Shift_act Nis'1 (eq_refl _)
        | VOID't => Shift_act Nis'2 (eq_refl _)
        | UNSIGNED't => Shift_act Nis'3 (eq_refl _)
        | UNION't => Shift_act Nis'4 (eq_refl _)
        | UNDERSCORE_BOOL't => Shift_act Nis'5 (eq_refl _)
        | TYPEDEF_NAME't => Shift_act Nis'6 (eq_refl _)
        | STRUCT't => Shift_act Nis'8 (eq_refl _)
        | SIGNED't => Shift_act Nis'10 (eq_refl _)
        | SHORT't => Shift_act Nis'11 (eq_refl _)
        | RESTRICT't => Shift_act Nis'13 (eq_refl _)
        | RBRACE't => Shift_act Nis'172 (eq_refl _)
        | PACKED't => Shift_act Nis'16 (eq_refl _)
        | LONG't => Shift_act Nis'27 (eq_refl _)
        | INT't => Shift_act Nis'28 (eq_refl _)
        | FLOAT't => Shift_act Nis'31 (eq_refl _)
        | ENUM't => Shift_act Nis'32 (eq_refl _)
        | DOUBLE't => Shift_act Nis'52 (eq_refl _)
        | CONST't => Shift_act Nis'53 (eq_refl _)
        | CHAR't => Shift_act Nis'54 (eq_refl _)
        | ATTRIBUTE't => Shift_act Nis'55 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'162 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'172 => Default_reduce_act Prod'struct_or_union_specifier'0
    | Ninit Nis'173 => Default_reduce_act Prod'struct_declaration_list'1
    | Ninit Nis'174 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'175 (eq_refl _)
        | STAR't => Shift_act Nis'176 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'183 (eq_refl _)
        | LPAREN't => Shift_act Nis'184 (eq_refl _)
        | COLON't => Shift_act Nis'254 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'175 => Default_reduce_act Prod'direct_declarator'0
    | Ninit Nis'176 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VOLATILE't => Shift_act Nis'1 (eq_refl _)
        | VAR_NAME't => Reduce_act Prod'pointer'0
        | STAR't => Shift_act Nis'176 (eq_refl _)
        | RPAREN't => Reduce_act Prod'pointer'0
        | RESTRICT't => Shift_act Nis'13 (eq_refl _)
        | PACKED't => Shift_act Nis'16 (eq_refl _)
        | LPAREN't => Reduce_act Prod'pointer'0
        | LBRACK't => Reduce_act Prod'pointer'0
        | CONST't => Shift_act Nis'53 (eq_refl _)
        | COMMA't => Reduce_act Prod'pointer'0
        | ATTRIBUTE't => Shift_act Nis'55 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'162 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'177 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VOLATILE't => Shift_act Nis'1 (eq_refl _)
        | VAR_NAME't => Reduce_act Prod'pointer'1
        | STAR't => Shift_act Nis'176 (eq_refl _)
        | RPAREN't => Reduce_act Prod'pointer'1
        | RESTRICT't => Shift_act Nis'13 (eq_refl _)
        | PACKED't => Shift_act Nis'16 (eq_refl _)
        | LPAREN't => Reduce_act Prod'pointer'1
        | LBRACK't => Reduce_act Prod'pointer'1
        | CONST't => Shift_act Nis'53 (eq_refl _)
        | COMMA't => Reduce_act Prod'pointer'1
        | ATTRIBUTE't => Shift_act Nis'55 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'162 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'178 => Default_reduce_act Prod'type_qualifier_list'1
    | Ninit Nis'179 => Default_reduce_act Prod'pointer'3
    | Ninit Nis'180 => Default_reduce_act Prod'type_qualifier'3
    | Ninit Nis'181 => Default_reduce_act Prod'type_qualifier_list'0
    | Ninit Nis'182 => Default_reduce_act Prod'pointer'2
    | Ninit Nis'183 => Default_reduce_act Prod'struct_declaration'1
    | Ninit Nis'184 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'175 (eq_refl _)
        | STAR't => Shift_act Nis'176 (eq_refl _)
        | LPAREN't => Shift_act Nis'184 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'185 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'175 (eq_refl _)
        | LPAREN't => Shift_act Nis'184 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'186 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Reduce_act Prod'attribute_specifier_list'0
        | RPAREN't => Reduce_act Prod'attribute_specifier_list'0
        | PACKED't => Reduce_act Prod'attribute_specifier_list'0
        | LPAREN't => Shift_act Nis'187 (eq_refl _)
        | LBRACK't => Shift_act Nis'236 (eq_refl _)
        | EQ't => Reduce_act Prod'attribute_specifier_list'0
        | COMMA't => Reduce_act Prod'attribute_specifier_list'0
        | COLON't => Reduce_act Prod'attribute_specifier_list'0
        | ATTRIBUTE't => Reduce_act Prod'attribute_specifier_list'0
        | ALIGNAS't => Reduce_act Prod'attribute_specifier_list'0
        | _ => Fail_act
      end)
    | Ninit Nis'187 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VOLATILE't => Shift_act Nis'1 (eq_refl _)
        | VOID't => Shift_act Nis'2 (eq_refl _)
        | UNSIGNED't => Shift_act Nis'3 (eq_refl _)
        | UNION't => Shift_act Nis'4 (eq_refl _)
        | UNDERSCORE_BOOL't => Shift_act Nis'5 (eq_refl _)
        | TYPEDEF_NAME't => Shift_act Nis'6 (eq_refl _)
        | TYPEDEF't => Shift_act Nis'7 (eq_refl _)
        | STRUCT't => Shift_act Nis'8 (eq_refl _)
        | STATIC't => Shift_act Nis'9 (eq_refl _)
        | SIGNED't => Shift_act Nis'10 (eq_refl _)
        | SHORT't => Shift_act Nis'11 (eq_refl _)
        | RPAREN't => Shift_act Nis'188 (eq_refl _)
        | RESTRICT't => Shift_act Nis'13 (eq_refl _)
        | REGISTER't => Shift_act Nis'14 (eq_refl _)
        | PACKED't => Shift_act Nis'16 (eq_refl _)
        | LONG't => Shift_act Nis'27 (eq_refl _)
        | INT't => Shift_act Nis'28 (eq_refl _)
        | INLINE't => Shift_act Nis'189 (eq_refl _)
        | FLOAT't => Shift_act Nis'31 (eq_refl _)
        | EXTERN't => Shift_act Nis'190 (eq_refl _)
        | ENUM't => Shift_act Nis'32 (eq_refl _)
        | DOUBLE't => Shift_act Nis'52 (eq_refl _)
        | CONST't => Shift_act Nis'53 (eq_refl _)
        | CHAR't => Shift_act Nis'54 (eq_refl _)
        | AUTO't => Shift_act Nis'191 (eq_refl _)
        | ATTRIBUTE't => Shift_act Nis'55 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'162 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'188 => Default_reduce_act Prod'direct_declarator'7
    | Ninit Nis'189 => Default_reduce_act Prod'function_specifier'0
    | Ninit Nis'190 => Default_reduce_act Prod'storage_class_specifier'1
    | Ninit Nis'191 => Default_reduce_act Prod'storage_class_specifier'3
    | Ninit Nis'192 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VOLATILE't => Shift_act Nis'1 (eq_refl _)
        | VOID't => Shift_act Nis'2 (eq_refl _)
        | VAR_NAME't => Reduce_act Prod'declaration_specifiers'3
        | UNSIGNED't => Shift_act Nis'3 (eq_refl _)
        | UNION't => Shift_act Nis'4 (eq_refl _)
        | UNDERSCORE_BOOL't => Shift_act Nis'5 (eq_refl _)
        | TYPEDEF_NAME't => Shift_act Nis'6 (eq_refl _)
        | TYPEDEF't => Shift_act Nis'7 (eq_refl _)
        | STRUCT't => Shift_act Nis'8 (eq_refl _)
        | STATIC't => Shift_act Nis'9 (eq_refl _)
        | STAR't => Reduce_act Prod'declaration_specifiers'3
        | SIGNED't => Shift_act Nis'10 (eq_refl _)
        | SHORT't => Shift_act Nis'11 (eq_refl _)
        | SEMICOLON't => Reduce_act Prod'declaration_specifiers'3
        | RPAREN't => Reduce_act Prod'declaration_specifiers'3
        | RESTRICT't => Shift_act Nis'13 (eq_refl _)
        | REGISTER't => Shift_act Nis'14 (eq_refl _)
        | PACKED't => Shift_act Nis'16 (eq_refl _)
        | LPAREN't => Reduce_act Prod'declaration_specifiers'3
        | LONG't => Shift_act Nis'27 (eq_refl _)
        | LBRACK't => Reduce_act Prod'declaration_specifiers'3
        | INT't => Shift_act Nis'28 (eq_refl _)
        | INLINE't => Shift_act Nis'189 (eq_refl _)
        | FLOAT't => Shift_act Nis'31 (eq_refl _)
        | EXTERN't => Shift_act Nis'190 (eq_refl _)
        | ENUM't => Shift_act Nis'32 (eq_refl _)
        | DOUBLE't => Shift_act Nis'52 (eq_refl _)
        | CONST't => Shift_act Nis'53 (eq_refl _)
        | COMMA't => Reduce_act Prod'declaration_specifiers'3
        | CHAR't => Shift_act Nis'54 (eq_refl _)
        | AUTO't => Shift_act Nis'191 (eq_refl _)
        | ATTRIBUTE't => Shift_act Nis'55 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'162 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'193 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VOLATILE't => Shift_act Nis'1 (eq_refl _)
        | VOID't => Shift_act Nis'2 (eq_refl _)
        | VAR_NAME't => Reduce_act Prod'declaration_specifiers'5
        | UNSIGNED't => Shift_act Nis'3 (eq_refl _)
        | UNION't => Shift_act Nis'4 (eq_refl _)
        | UNDERSCORE_BOOL't => Shift_act Nis'5 (eq_refl _)
        | TYPEDEF_NAME't => Shift_act Nis'6 (eq_refl _)
        | TYPEDEF't => Shift_act Nis'7 (eq_refl _)
        | STRUCT't => Shift_act Nis'8 (eq_refl _)
        | STATIC't => Shift_act Nis'9 (eq_refl _)
        | STAR't => Reduce_act Prod'declaration_specifiers'5
        | SIGNED't => Shift_act Nis'10 (eq_refl _)
        | SHORT't => Shift_act Nis'11 (eq_refl _)
        | SEMICOLON't => Reduce_act Prod'declaration_specifiers'5
        | RPAREN't => Reduce_act Prod'declaration_specifiers'5
        | RESTRICT't => Shift_act Nis'13 (eq_refl _)
        | REGISTER't => Shift_act Nis'14 (eq_refl _)
        | PACKED't => Shift_act Nis'16 (eq_refl _)
        | LPAREN't => Reduce_act Prod'declaration_specifiers'5
        | LONG't => Shift_act Nis'27 (eq_refl _)
        | LBRACK't => Reduce_act Prod'declaration_specifiers'5
        | INT't => Shift_act Nis'28 (eq_refl _)
        | INLINE't => Shift_act Nis'189 (eq_refl _)
        | FLOAT't => Shift_act Nis'31 (eq_refl _)
        | EXTERN't => Shift_act Nis'190 (eq_refl _)
        | ENUM't => Shift_act Nis'32 (eq_refl _)
        | DOUBLE't => Shift_act Nis'52 (eq_refl _)
        | CONST't => Shift_act Nis'53 (eq_refl _)
        | COMMA't => Reduce_act Prod'declaration_specifiers'5
        | CHAR't => Shift_act Nis'54 (eq_refl _)
        | AUTO't => Shift_act Nis'191 (eq_refl _)
        | ATTRIBUTE't => Shift_act Nis'55 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'162 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'194 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VOLATILE't => Shift_act Nis'1 (eq_refl _)
        | VOID't => Shift_act Nis'2 (eq_refl _)
        | VAR_NAME't => Reduce_act Prod'declaration_specifiers'1
        | UNSIGNED't => Shift_act Nis'3 (eq_refl _)
        | UNION't => Shift_act Nis'4 (eq_refl _)
        | UNDERSCORE_BOOL't => Shift_act Nis'5 (eq_refl _)
        | TYPEDEF_NAME't => Shift_act Nis'6 (eq_refl _)
        | TYPEDEF't => Shift_act Nis'7 (eq_refl _)
        | STRUCT't => Shift_act Nis'8 (eq_refl _)
        | STATIC't => Shift_act Nis'9 (eq_refl _)
        | STAR't => Reduce_act Prod'declaration_specifiers'1
        | SIGNED't => Shift_act Nis'10 (eq_refl _)
        | SHORT't => Shift_act Nis'11 (eq_refl _)
        | SEMICOLON't => Reduce_act Prod'declaration_specifiers'1
        | RPAREN't => Reduce_act Prod'declaration_specifiers'1
        | RESTRICT't => Shift_act Nis'13 (eq_refl _)
        | REGISTER't => Shift_act Nis'14 (eq_refl _)
        | PACKED't => Shift_act Nis'16 (eq_refl _)
        | LPAREN't => Reduce_act Prod'declaration_specifiers'1
        | LONG't => Shift_act Nis'27 (eq_refl _)
        | LBRACK't => Reduce_act Prod'declaration_specifiers'1
        | INT't => Shift_act Nis'28 (eq_refl _)
        | INLINE't => Shift_act Nis'189 (eq_refl _)
        | FLOAT't => Shift_act Nis'31 (eq_refl _)
        | EXTERN't => Shift_act Nis'190 (eq_refl _)
        | ENUM't => Shift_act Nis'32 (eq_refl _)
        | DOUBLE't => Shift_act Nis'52 (eq_refl _)
        | CONST't => Shift_act Nis'53 (eq_refl _)
        | COMMA't => Reduce_act Prod'declaration_specifiers'1
        | CHAR't => Shift_act Nis'54 (eq_refl _)
        | AUTO't => Shift_act Nis'191 (eq_refl _)
        | ATTRIBUTE't => Shift_act Nis'55 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'162 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'195 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VOLATILE't => Shift_act Nis'1 (eq_refl _)
        | VOID't => Shift_act Nis'2 (eq_refl _)
        | VAR_NAME't => Reduce_act Prod'declaration_specifiers'7
        | UNSIGNED't => Shift_act Nis'3 (eq_refl _)
        | UNION't => Shift_act Nis'4 (eq_refl _)
        | UNDERSCORE_BOOL't => Shift_act Nis'5 (eq_refl _)
        | TYPEDEF_NAME't => Shift_act Nis'6 (eq_refl _)
        | TYPEDEF't => Shift_act Nis'7 (eq_refl _)
        | STRUCT't => Shift_act Nis'8 (eq_refl _)
        | STATIC't => Shift_act Nis'9 (eq_refl _)
        | STAR't => Reduce_act Prod'declaration_specifiers'7
        | SIGNED't => Shift_act Nis'10 (eq_refl _)
        | SHORT't => Shift_act Nis'11 (eq_refl _)
        | SEMICOLON't => Reduce_act Prod'declaration_specifiers'7
        | RPAREN't => Reduce_act Prod'declaration_specifiers'7
        | RESTRICT't => Shift_act Nis'13 (eq_refl _)
        | REGISTER't => Shift_act Nis'14 (eq_refl _)
        | PACKED't => Shift_act Nis'16 (eq_refl _)
        | LPAREN't => Reduce_act Prod'declaration_specifiers'7
        | LONG't => Shift_act Nis'27 (eq_refl _)
        | LBRACK't => Reduce_act Prod'declaration_specifiers'7
        | INT't => Shift_act Nis'28 (eq_refl _)
        | INLINE't => Shift_act Nis'189 (eq_refl _)
        | FLOAT't => Shift_act Nis'31 (eq_refl _)
        | EXTERN't => Shift_act Nis'190 (eq_refl _)
        | ENUM't => Shift_act Nis'32 (eq_refl _)
        | DOUBLE't => Shift_act Nis'52 (eq_refl _)
        | CONST't => Shift_act Nis'53 (eq_refl _)
        | COMMA't => Reduce_act Prod'declaration_specifiers'7
        | CHAR't => Shift_act Nis'54 (eq_refl _)
        | AUTO't => Shift_act Nis'191 (eq_refl _)
        | ATTRIBUTE't => Shift_act Nis'55 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'162 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'196 => Default_reduce_act Prod'type_specifier'11
    | Ninit Nis'197 => Default_reduce_act Prod'declaration_specifiers'6
    | Ninit Nis'198 => Default_reduce_act Prod'declaration_specifiers'0
    | Ninit Nis'199 => Default_reduce_act Prod'declaration_specifiers'4
    | Ninit Nis'200 => Default_reduce_act Prod'declaration_specifiers'2
    | Ninit Nis'201 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'202 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'202 => Default_reduce_act Prod'direct_declarator'6
    | Ninit Nis'203 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Reduce_act Prod'parameter_type_list'0
        | COMMA't => Shift_act Nis'204 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'204 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VOLATILE't => Shift_act Nis'1 (eq_refl _)
        | VOID't => Shift_act Nis'2 (eq_refl _)
        | UNSIGNED't => Shift_act Nis'3 (eq_refl _)
        | UNION't => Shift_act Nis'4 (eq_refl _)
        | UNDERSCORE_BOOL't => Shift_act Nis'5 (eq_refl _)
        | TYPEDEF_NAME't => Shift_act Nis'6 (eq_refl _)
        | TYPEDEF't => Shift_act Nis'7 (eq_refl _)
        | STRUCT't => Shift_act Nis'8 (eq_refl _)
        | STATIC't => Shift_act Nis'9 (eq_refl _)
        | SIGNED't => Shift_act Nis'10 (eq_refl _)
        | SHORT't => Shift_act Nis'11 (eq_refl _)
        | RESTRICT't => Shift_act Nis'13 (eq_refl _)
        | REGISTER't => Shift_act Nis'14 (eq_refl _)
        | PACKED't => Shift_act Nis'16 (eq_refl _)
        | LONG't => Shift_act Nis'27 (eq_refl _)
        | INT't => Shift_act Nis'28 (eq_refl _)
        | INLINE't => Shift_act Nis'189 (eq_refl _)
        | FLOAT't => Shift_act Nis'31 (eq_refl _)
        | EXTERN't => Shift_act Nis'190 (eq_refl _)
        | ENUM't => Shift_act Nis'32 (eq_refl _)
        | ELLIPSIS't => Shift_act Nis'205 (eq_refl _)
        | DOUBLE't => Shift_act Nis'52 (eq_refl _)
        | CONST't => Shift_act Nis'53 (eq_refl _)
        | CHAR't => Shift_act Nis'54 (eq_refl _)
        | AUTO't => Shift_act Nis'191 (eq_refl _)
        | ATTRIBUTE't => Shift_act Nis'55 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'162 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'205 => Default_reduce_act Prod'parameter_type_list'1
    | Ninit Nis'206 => Default_reduce_act Prod'parameter_list'1
    | Ninit Nis'207 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'175 (eq_refl _)
        | STAR't => Shift_act Nis'176 (eq_refl _)
        | RPAREN't => Reduce_act Prod'parameter_declaration'2
        | LPAREN't => Shift_act Nis'208 (eq_refl _)
        | LBRACK't => Shift_act Nis'210 (eq_refl _)
        | COMMA't => Reduce_act Prod'parameter_declaration'2
        | _ => Fail_act
      end)
    | Ninit Nis'208 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VOLATILE't => Shift_act Nis'1 (eq_refl _)
        | VOID't => Shift_act Nis'2 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'175 (eq_refl _)
        | UNSIGNED't => Shift_act Nis'3 (eq_refl _)
        | UNION't => Shift_act Nis'4 (eq_refl _)
        | UNDERSCORE_BOOL't => Shift_act Nis'5 (eq_refl _)
        | TYPEDEF_NAME't => Shift_act Nis'6 (eq_refl _)
        | TYPEDEF't => Shift_act Nis'7 (eq_refl _)
        | STRUCT't => Shift_act Nis'8 (eq_refl _)
        | STATIC't => Shift_act Nis'9 (eq_refl _)
        | STAR't => Shift_act Nis'176 (eq_refl _)
        | SIGNED't => Shift_act Nis'10 (eq_refl _)
        | SHORT't => Shift_act Nis'11 (eq_refl _)
        | RPAREN't => Shift_act Nis'209 (eq_refl _)
        | RESTRICT't => Shift_act Nis'13 (eq_refl _)
        | REGISTER't => Shift_act Nis'14 (eq_refl _)
        | PACKED't => Shift_act Nis'16 (eq_refl _)
        | LPAREN't => Shift_act Nis'208 (eq_refl _)
        | LONG't => Shift_act Nis'27 (eq_refl _)
        | LBRACK't => Shift_act Nis'210 (eq_refl _)
        | INT't => Shift_act Nis'28 (eq_refl _)
        | INLINE't => Shift_act Nis'189 (eq_refl _)
        | FLOAT't => Shift_act Nis'31 (eq_refl _)
        | EXTERN't => Shift_act Nis'190 (eq_refl _)
        | ENUM't => Shift_act Nis'32 (eq_refl _)
        | DOUBLE't => Shift_act Nis'52 (eq_refl _)
        | CONST't => Shift_act Nis'53 (eq_refl _)
        | CHAR't => Shift_act Nis'54 (eq_refl _)
        | AUTO't => Shift_act Nis'191 (eq_refl _)
        | ATTRIBUTE't => Shift_act Nis'55 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'162 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'209 => Default_reduce_act Prod'direct_abstract_declarator'12
    | Ninit Nis'210 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VOLATILE't => Shift_act Nis'1 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | RESTRICT't => Shift_act Nis'13 (eq_refl _)
        | RBRACK't => Shift_act Nis'211 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | PACKED't => Shift_act Nis'16 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | CONST't => Shift_act Nis'53 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | ATTRIBUTE't => Shift_act Nis'55 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'162 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'211 => Default_reduce_act Prod'direct_abstract_declarator'8
    | Ninit Nis'212 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VOLATILE't => Shift_act Nis'1 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | RESTRICT't => Shift_act Nis'13 (eq_refl _)
        | RBRACK't => Shift_act Nis'213 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | PACKED't => Shift_act Nis'16 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | CONST't => Shift_act Nis'53 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | ATTRIBUTE't => Shift_act Nis'55 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'162 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'213 => Default_reduce_act Prod'direct_abstract_declarator'6
    | Ninit Nis'214 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RBRACK't => Shift_act Nis'215 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'215 => Default_reduce_act Prod'direct_abstract_declarator'2
    | Ninit Nis'216 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RBRACK't => Shift_act Nis'217 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'217 => Default_reduce_act Prod'direct_abstract_declarator'4
    | Ninit Nis'218 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'175 (eq_refl _)
        | RPAREN't => Reduce_act Prod'abstract_declarator'0
        | LPAREN't => Shift_act Nis'208 (eq_refl _)
        | LBRACK't => Shift_act Nis'210 (eq_refl _)
        | COMMA't => Reduce_act Prod'abstract_declarator'0
        | _ => Fail_act
      end)
    | Ninit Nis'219 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Reduce_act Prod'abstract_declarator'1
        | LPAREN't => Shift_act Nis'220 (eq_refl _)
        | LBRACK't => Shift_act Nis'225 (eq_refl _)
        | COMMA't => Reduce_act Prod'abstract_declarator'1
        | _ => Fail_act
      end)
    | Ninit Nis'220 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VOLATILE't => Shift_act Nis'1 (eq_refl _)
        | VOID't => Shift_act Nis'2 (eq_refl _)
        | UNSIGNED't => Shift_act Nis'3 (eq_refl _)
        | UNION't => Shift_act Nis'4 (eq_refl _)
        | UNDERSCORE_BOOL't => Shift_act Nis'5 (eq_refl _)
        | TYPEDEF_NAME't => Shift_act Nis'6 (eq_refl _)
        | TYPEDEF't => Shift_act Nis'7 (eq_refl _)
        | STRUCT't => Shift_act Nis'8 (eq_refl _)
        | STATIC't => Shift_act Nis'9 (eq_refl _)
        | SIGNED't => Shift_act Nis'10 (eq_refl _)
        | SHORT't => Shift_act Nis'11 (eq_refl _)
        | RPAREN't => Shift_act Nis'221 (eq_refl _)
        | RESTRICT't => Shift_act Nis'13 (eq_refl _)
        | REGISTER't => Shift_act Nis'14 (eq_refl _)
        | PACKED't => Shift_act Nis'16 (eq_refl _)
        | LONG't => Shift_act Nis'27 (eq_refl _)
        | INT't => Shift_act Nis'28 (eq_refl _)
        | INLINE't => Shift_act Nis'189 (eq_refl _)
        | FLOAT't => Shift_act Nis'31 (eq_refl _)
        | EXTERN't => Shift_act Nis'190 (eq_refl _)
        | ENUM't => Shift_act Nis'32 (eq_refl _)
        | DOUBLE't => Shift_act Nis'52 (eq_refl _)
        | CONST't => Shift_act Nis'53 (eq_refl _)
        | CHAR't => Shift_act Nis'54 (eq_refl _)
        | AUTO't => Shift_act Nis'191 (eq_refl _)
        | ATTRIBUTE't => Shift_act Nis'55 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'162 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'221 => Default_reduce_act Prod'direct_abstract_declarator'11
    | Ninit Nis'222 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'223 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'223 => Default_reduce_act Prod'direct_abstract_declarator'9
    | Ninit Nis'224 => Default_reduce_act Prod'parameter_list'0
    | Ninit Nis'225 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VOLATILE't => Shift_act Nis'1 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | RESTRICT't => Shift_act Nis'13 (eq_refl _)
        | RBRACK't => Shift_act Nis'226 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | PACKED't => Shift_act Nis'16 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | CONST't => Shift_act Nis'53 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | ATTRIBUTE't => Shift_act Nis'55 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'162 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'226 => Default_reduce_act Prod'direct_abstract_declarator'7
    | Ninit Nis'227 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VOLATILE't => Shift_act Nis'1 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | RESTRICT't => Shift_act Nis'13 (eq_refl _)
        | RBRACK't => Shift_act Nis'228 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | PACKED't => Shift_act Nis'16 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | CONST't => Shift_act Nis'53 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | ATTRIBUTE't => Shift_act Nis'55 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'162 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'228 => Default_reduce_act Prod'direct_abstract_declarator'5
    | Ninit Nis'229 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RBRACK't => Shift_act Nis'230 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'230 => Default_reduce_act Prod'direct_abstract_declarator'1
    | Ninit Nis'231 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RBRACK't => Shift_act Nis'232 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'232 => Default_reduce_act Prod'direct_abstract_declarator'3
    | Ninit Nis'233 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'234 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'234 => Default_reduce_act Prod'direct_abstract_declarator'10
    | Ninit Nis'235 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Reduce_act Prod'attribute_specifier_list'0
        | RPAREN't => Reduce_act Prod'attribute_specifier_list'0
        | PACKED't => Reduce_act Prod'attribute_specifier_list'0
        | LPAREN't => Shift_act Nis'187 (eq_refl _)
        | LBRACK't => Shift_act Nis'236 (eq_refl _)
        | EQ't => Reduce_act Prod'attribute_specifier_list'0
        | COMMA't => Reduce_act Prod'attribute_specifier_list'0
        | COLON't => Reduce_act Prod'attribute_specifier_list'0
        | ATTRIBUTE't => Reduce_act Prod'attribute_specifier_list'0
        | ALIGNAS't => Reduce_act Prod'attribute_specifier_list'0
        | _ => Fail_act
      end)
    | Ninit Nis'236 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VOLATILE't => Shift_act Nis'1 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | RESTRICT't => Shift_act Nis'13 (eq_refl _)
        | RBRACK't => Shift_act Nis'237 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | PACKED't => Shift_act Nis'16 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | CONST't => Shift_act Nis'53 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | ATTRIBUTE't => Shift_act Nis'55 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'162 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'237 => Default_reduce_act Prod'direct_declarator'5
    | Ninit Nis'238 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VOLATILE't => Shift_act Nis'1 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | RESTRICT't => Shift_act Nis'13 (eq_refl _)
        | RBRACK't => Shift_act Nis'239 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | PACKED't => Shift_act Nis'16 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | CONST't => Shift_act Nis'53 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | ATTRIBUTE't => Shift_act Nis'55 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'162 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'239 => Default_reduce_act Prod'direct_declarator'4
    | Ninit Nis'240 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RBRACK't => Shift_act Nis'241 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'241 => Default_reduce_act Prod'direct_declarator'2
    | Ninit Nis'242 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RBRACK't => Shift_act Nis'243 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'243 => Default_reduce_act Prod'direct_declarator'3
    | Ninit Nis'244 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Reduce_act Prod'declarator'0
        | RPAREN't => Reduce_act Prod'declarator'0
        | PACKED't => Shift_act Nis'16 (eq_refl _)
        | LBRACE't => Reduce_act Prod'declarator'0
        | EQ't => Reduce_act Prod'declarator'0
        | COMMA't => Reduce_act Prod'declarator'0
        | COLON't => Reduce_act Prod'declarator'0
        | ATTRIBUTE't => Shift_act Nis'55 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'162 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'245 => Default_reduce_act Prod'attribute_specifier_list'1
    | Ninit Nis'246 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Reduce_act Prod'abstract_declarator'2
        | LPAREN't => Shift_act Nis'220 (eq_refl _)
        | LBRACK't => Shift_act Nis'225 (eq_refl _)
        | COMMA't => Reduce_act Prod'abstract_declarator'2
        | _ => Fail_act
      end)
    | Ninit Nis'247 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'248 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'248 => Default_reduce_act Prod'direct_declarator'1
    | Ninit Nis'249 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'250 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'250 => Default_reduce_act Prod'direct_abstract_declarator'0
    | Ninit Nis'251 => Default_reduce_act Prod'parameter_declaration'0
    | Ninit Nis'252 => Default_reduce_act Prod'parameter_declaration'1
    | Ninit Nis'253 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Reduce_act Prod'declarator'1
        | RPAREN't => Reduce_act Prod'declarator'1
        | PACKED't => Shift_act Nis'16 (eq_refl _)
        | LBRACE't => Reduce_act Prod'declarator'1
        | EQ't => Reduce_act Prod'declarator'1
        | COMMA't => Reduce_act Prod'declarator'1
        | COLON't => Reduce_act Prod'declarator'1
        | ATTRIBUTE't => Shift_act Nis'55 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'162 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'254 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'255 => Default_reduce_act Prod'struct_declarator'2
    | Ninit Nis'256 => Default_reduce_act Prod'constant_expression'0
    | Ninit Nis'257 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Shift_act Nis'258 (eq_refl _)
        | COMMA't => Shift_act Nis'259 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'258 => Default_reduce_act Prod'struct_declaration'0
    | Ninit Nis'259 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'175 (eq_refl _)
        | STAR't => Shift_act Nis'176 (eq_refl _)
        | LPAREN't => Shift_act Nis'184 (eq_refl _)
        | COLON't => Shift_act Nis'254 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'260 => Default_reduce_act Prod'struct_declarator_list'1
    | Ninit Nis'261 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Reduce_act Prod'struct_declarator'0
        | COMMA't => Reduce_act Prod'struct_declarator'0
        | COLON't => Shift_act Nis'262 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'262 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'263 => Default_reduce_act Prod'struct_declarator'1
    | Ninit Nis'264 => Default_reduce_act Prod'struct_declarator_list'0
    | Ninit Nis'265 => Default_reduce_act Prod'struct_declaration_list'0
    | Ninit Nis'266 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VOLATILE't => Shift_act Nis'1 (eq_refl _)
        | VOID't => Shift_act Nis'2 (eq_refl _)
        | UNSIGNED't => Shift_act Nis'3 (eq_refl _)
        | UNION't => Shift_act Nis'4 (eq_refl _)
        | UNDERSCORE_BOOL't => Shift_act Nis'5 (eq_refl _)
        | TYPEDEF_NAME't => Shift_act Nis'6 (eq_refl _)
        | STRUCT't => Shift_act Nis'8 (eq_refl _)
        | SIGNED't => Shift_act Nis'10 (eq_refl _)
        | SHORT't => Shift_act Nis'11 (eq_refl _)
        | RESTRICT't => Shift_act Nis'13 (eq_refl _)
        | RBRACE't => Shift_act Nis'267 (eq_refl _)
        | PACKED't => Shift_act Nis'16 (eq_refl _)
        | LONG't => Shift_act Nis'27 (eq_refl _)
        | INT't => Shift_act Nis'28 (eq_refl _)
        | FLOAT't => Shift_act Nis'31 (eq_refl _)
        | ENUM't => Shift_act Nis'32 (eq_refl _)
        | DOUBLE't => Shift_act Nis'52 (eq_refl _)
        | CONST't => Shift_act Nis'53 (eq_refl _)
        | CHAR't => Shift_act Nis'54 (eq_refl _)
        | ATTRIBUTE't => Shift_act Nis'55 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'162 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'267 => Default_reduce_act Prod'struct_or_union_specifier'1
    | Ninit Nis'268 => Default_reduce_act Prod'specifier_qualifier_list'2
    | Ninit Nis'269 => Default_reduce_act Prod'specifier_qualifier_list'0
    | Ninit Nis'270 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'271 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'271 => Default_reduce_act Prod'attribute_specifier'3
    | Ninit Nis'272 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | STAR't => Shift_act Nis'176 (eq_refl _)
        | RPAREN't => Reduce_act Prod'type_name'0
        | LPAREN't => Shift_act Nis'273 (eq_refl _)
        | LBRACK't => Shift_act Nis'210 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'273 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VOLATILE't => Shift_act Nis'1 (eq_refl _)
        | VOID't => Shift_act Nis'2 (eq_refl _)
        | UNSIGNED't => Shift_act Nis'3 (eq_refl _)
        | UNION't => Shift_act Nis'4 (eq_refl _)
        | UNDERSCORE_BOOL't => Shift_act Nis'5 (eq_refl _)
        | TYPEDEF_NAME't => Shift_act Nis'6 (eq_refl _)
        | TYPEDEF't => Shift_act Nis'7 (eq_refl _)
        | STRUCT't => Shift_act Nis'8 (eq_refl _)
        | STATIC't => Shift_act Nis'9 (eq_refl _)
        | STAR't => Shift_act Nis'176 (eq_refl _)
        | SIGNED't => Shift_act Nis'10 (eq_refl _)
        | SHORT't => Shift_act Nis'11 (eq_refl _)
        | RPAREN't => Shift_act Nis'209 (eq_refl _)
        | RESTRICT't => Shift_act Nis'13 (eq_refl _)
        | REGISTER't => Shift_act Nis'14 (eq_refl _)
        | PACKED't => Shift_act Nis'16 (eq_refl _)
        | LPAREN't => Shift_act Nis'273 (eq_refl _)
        | LONG't => Shift_act Nis'27 (eq_refl _)
        | LBRACK't => Shift_act Nis'210 (eq_refl _)
        | INT't => Shift_act Nis'28 (eq_refl _)
        | INLINE't => Shift_act Nis'189 (eq_refl _)
        | FLOAT't => Shift_act Nis'31 (eq_refl _)
        | EXTERN't => Shift_act Nis'190 (eq_refl _)
        | ENUM't => Shift_act Nis'32 (eq_refl _)
        | DOUBLE't => Shift_act Nis'52 (eq_refl _)
        | CONST't => Shift_act Nis'53 (eq_refl _)
        | CHAR't => Shift_act Nis'54 (eq_refl _)
        | AUTO't => Shift_act Nis'191 (eq_refl _)
        | ATTRIBUTE't => Shift_act Nis'55 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'162 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'274 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Reduce_act Prod'abstract_declarator'0
        | LPAREN't => Shift_act Nis'273 (eq_refl _)
        | LBRACK't => Shift_act Nis'210 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'275 => Default_reduce_act Prod'type_name'1
    | Ninit Nis'276 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'277 (eq_refl _)
        | COMMA't => Shift_act Nis'144 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'277 => Default_reduce_act Prod'attribute_specifier'2
    | Ninit Nis'278 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'279 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'279 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | XOR_ASSIGN't => Reduce_act Prod'unary_expression'7
        | SUB_ASSIGN't => Reduce_act Prod'unary_expression'7
        | STAR't => Reduce_act Prod'unary_expression'7
        | SLASH't => Reduce_act Prod'unary_expression'7
        | SEMICOLON't => Reduce_act Prod'unary_expression'7
        | RPAREN't => Reduce_act Prod'unary_expression'7
        | RIGHT_ASSIGN't => Reduce_act Prod'unary_expression'7
        | RIGHT't => Reduce_act Prod'unary_expression'7
        | RBRACK't => Reduce_act Prod'unary_expression'7
        | RBRACE't => Reduce_act Prod'unary_expression'7
        | QUESTION't => Reduce_act Prod'unary_expression'7
        | PLUS't => Reduce_act Prod'unary_expression'7
        | PERCENT't => Reduce_act Prod'unary_expression'7
        | OR_ASSIGN't => Reduce_act Prod'unary_expression'7
        | NEQ't => Reduce_act Prod'unary_expression'7
        | MUL_ASSIGN't => Reduce_act Prod'unary_expression'7
        | MOD_ASSIGN't => Reduce_act Prod'unary_expression'7
        | MINUS't => Reduce_act Prod'unary_expression'7
        | LT't => Reduce_act Prod'unary_expression'7
        | LEQ't => Reduce_act Prod'unary_expression'7
        | LEFT_ASSIGN't => Reduce_act Prod'unary_expression'7
        | LEFT't => Reduce_act Prod'unary_expression'7
        | LBRACE't => Shift_act Nis'280 (eq_refl _)
        | HAT't => Reduce_act Prod'unary_expression'7
        | GT't => Reduce_act Prod'unary_expression'7
        | GEQ't => Reduce_act Prod'unary_expression'7
        | EQEQ't => Reduce_act Prod'unary_expression'7
        | EQ't => Reduce_act Prod'unary_expression'7
        | DIV_ASSIGN't => Reduce_act Prod'unary_expression'7
        | COMMA't => Reduce_act Prod'unary_expression'7
        | COLON't => Reduce_act Prod'unary_expression'7
        | BARBAR't => Reduce_act Prod'unary_expression'7
        | BAR't => Reduce_act Prod'unary_expression'7
        | AND_ASSIGN't => Reduce_act Prod'unary_expression'7
        | ANDAND't => Reduce_act Prod'unary_expression'7
        | AND't => Reduce_act Prod'unary_expression'7
        | ADD_ASSIGN't => Reduce_act Prod'unary_expression'7
        | _ => Fail_act
      end)
    | Ninit Nis'280 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | LBRACK't => Shift_act Nis'281 (eq_refl _)
        | LBRACE't => Shift_act Nis'284 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DOT't => Shift_act Nis'285 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'281 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'282 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RBRACK't => Shift_act Nis'283 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'283 => Default_reduce_act Prod'designator'0
    | Ninit Nis'284 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | LBRACK't => Shift_act Nis'281 (eq_refl _)
        | LBRACE't => Shift_act Nis'284 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DOT't => Shift_act Nis'285 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'285 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | OTHER_NAME't => Shift_act Nis'286 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'286 => Default_reduce_act Prod'designator'1
    | Ninit Nis'287 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RBRACE't => Shift_act Nis'288 (eq_refl _)
        | COMMA't => Shift_act Nis'289 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'288 => Default_reduce_act Prod'c_initializer'1
    | Ninit Nis'289 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | RBRACE't => Shift_act Nis'290 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | LBRACK't => Shift_act Nis'281 (eq_refl _)
        | LBRACE't => Shift_act Nis'284 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DOT't => Shift_act Nis'285 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'290 => Default_reduce_act Prod'c_initializer'2
    | Ninit Nis'291 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | LBRACK't => Shift_act Nis'281 (eq_refl _)
        | EQ't => Shift_act Nis'292 (eq_refl _)
        | DOT't => Shift_act Nis'285 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'292 => Default_reduce_act Prod'designation'0
    | Ninit Nis'293 => Default_reduce_act Prod'designator_list'1
    | Ninit Nis'294 => Default_reduce_act Prod'designator_list'0
    | Ninit Nis'295 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | LBRACE't => Shift_act Nis'284 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'296 => Default_reduce_act Prod'initializer_list'2
    | Ninit Nis'297 => Default_reduce_act Prod'c_initializer'0
    | Ninit Nis'298 => Default_reduce_act Prod'initializer_list'3
    | Ninit Nis'299 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | LBRACE't => Shift_act Nis'284 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'300 => Default_reduce_act Prod'initializer_list'0
    | Ninit Nis'301 => Default_reduce_act Prod'initializer_list'1
    | Ninit Nis'302 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RBRACE't => Shift_act Nis'303 (eq_refl _)
        | COMMA't => Shift_act Nis'304 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'303 => Default_reduce_act Prod'postfix_expression'9
    | Ninit Nis'304 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | RBRACE't => Shift_act Nis'305 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | LBRACK't => Shift_act Nis'281 (eq_refl _)
        | LBRACE't => Shift_act Nis'284 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DOT't => Shift_act Nis'285 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'305 => Default_reduce_act Prod'postfix_expression'10
    | Ninit Nis'306 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'307 (eq_refl _)
        | COMMA't => Shift_act Nis'132 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'307 => Default_reduce_act Prod'primary_expression'3
    | Ninit Nis'308 => Default_reduce_act Prod'unary_expression'6
    | Ninit Nis'309 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | COMMA't => Shift_act Nis'310 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'310 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VOLATILE't => Shift_act Nis'1 (eq_refl _)
        | VOID't => Shift_act Nis'2 (eq_refl _)
        | UNSIGNED't => Shift_act Nis'3 (eq_refl _)
        | UNION't => Shift_act Nis'4 (eq_refl _)
        | UNDERSCORE_BOOL't => Shift_act Nis'5 (eq_refl _)
        | TYPEDEF_NAME't => Shift_act Nis'6 (eq_refl _)
        | STRUCT't => Shift_act Nis'8 (eq_refl _)
        | SIGNED't => Shift_act Nis'10 (eq_refl _)
        | SHORT't => Shift_act Nis'11 (eq_refl _)
        | RESTRICT't => Shift_act Nis'13 (eq_refl _)
        | PACKED't => Shift_act Nis'16 (eq_refl _)
        | LONG't => Shift_act Nis'27 (eq_refl _)
        | INT't => Shift_act Nis'28 (eq_refl _)
        | FLOAT't => Shift_act Nis'31 (eq_refl _)
        | ENUM't => Shift_act Nis'32 (eq_refl _)
        | DOUBLE't => Shift_act Nis'52 (eq_refl _)
        | CONST't => Shift_act Nis'53 (eq_refl _)
        | CHAR't => Shift_act Nis'54 (eq_refl _)
        | ATTRIBUTE't => Shift_act Nis'55 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'162 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'311 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'312 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'312 => Default_reduce_act Prod'postfix_expression'4
    | Ninit Nis'313 => Default_reduce_act Prod'unary_expression'2
    | Ninit Nis'314 => Default_reduce_act Prod'enumerator'1
    | Ninit Nis'315 => Default_reduce_act Prod'enumerator_list'0
    | Ninit Nis'316 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'36 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'317 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RBRACE't => Shift_act Nis'318 (eq_refl _)
        | COMMA't => Shift_act Nis'319 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'318 => Default_reduce_act Prod'enum_specifier'1
    | Ninit Nis'319 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'36 (eq_refl _)
        | RBRACE't => Shift_act Nis'320 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'320 => Default_reduce_act Prod'enum_specifier'3
    | Ninit Nis'321 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'322 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'322 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | LBRACE't => Shift_act Nis'280 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'323 => Default_reduce_act Prod'unary_expression'1
    | Ninit Nis'324 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'325 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'325 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | LBRACE't => Shift_act Nis'280 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'326 => Default_reduce_act Prod'cast_expression'1
    | Ninit Nis'327 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'328 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'328 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | XOR_ASSIGN't => Reduce_act Prod'unary_expression'5
        | SUB_ASSIGN't => Reduce_act Prod'unary_expression'5
        | STAR't => Reduce_act Prod'unary_expression'5
        | SLASH't => Reduce_act Prod'unary_expression'5
        | SEMICOLON't => Reduce_act Prod'unary_expression'5
        | RPAREN't => Reduce_act Prod'unary_expression'5
        | RIGHT_ASSIGN't => Reduce_act Prod'unary_expression'5
        | RIGHT't => Reduce_act Prod'unary_expression'5
        | RBRACK't => Reduce_act Prod'unary_expression'5
        | RBRACE't => Reduce_act Prod'unary_expression'5
        | QUESTION't => Reduce_act Prod'unary_expression'5
        | PLUS't => Reduce_act Prod'unary_expression'5
        | PERCENT't => Reduce_act Prod'unary_expression'5
        | OR_ASSIGN't => Reduce_act Prod'unary_expression'5
        | NEQ't => Reduce_act Prod'unary_expression'5
        | MUL_ASSIGN't => Reduce_act Prod'unary_expression'5
        | MOD_ASSIGN't => Reduce_act Prod'unary_expression'5
        | MINUS't => Reduce_act Prod'unary_expression'5
        | LT't => Reduce_act Prod'unary_expression'5
        | LEQ't => Reduce_act Prod'unary_expression'5
        | LEFT_ASSIGN't => Reduce_act Prod'unary_expression'5
        | LEFT't => Reduce_act Prod'unary_expression'5
        | LBRACE't => Shift_act Nis'280 (eq_refl _)
        | HAT't => Reduce_act Prod'unary_expression'5
        | GT't => Reduce_act Prod'unary_expression'5
        | GEQ't => Reduce_act Prod'unary_expression'5
        | EQEQ't => Reduce_act Prod'unary_expression'5
        | EQ't => Reduce_act Prod'unary_expression'5
        | DIV_ASSIGN't => Reduce_act Prod'unary_expression'5
        | COMMA't => Reduce_act Prod'unary_expression'5
        | COLON't => Reduce_act Prod'unary_expression'5
        | BARBAR't => Reduce_act Prod'unary_expression'5
        | BAR't => Reduce_act Prod'unary_expression'5
        | AND_ASSIGN't => Reduce_act Prod'unary_expression'5
        | ANDAND't => Reduce_act Prod'unary_expression'5
        | AND't => Reduce_act Prod'unary_expression'5
        | ADD_ASSIGN't => Reduce_act Prod'unary_expression'5
        | _ => Fail_act
      end)
    | Ninit Nis'329 => Default_reduce_act Prod'unary_expression'4
    | Ninit Nis'330 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'331 (eq_refl _)
        | COMMA't => Shift_act Nis'144 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'331 => Default_reduce_act Prod'attribute_specifier'1
    | Ninit Nis'332 => Default_reduce_act Prod'translation_unit_file'1
    | Ninit Nis'334 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VOLATILE't => Shift_act Nis'1 (eq_refl _)
        | VOID't => Shift_act Nis'2 (eq_refl _)
        | UNSIGNED't => Shift_act Nis'3 (eq_refl _)
        | UNION't => Shift_act Nis'4 (eq_refl _)
        | UNDERSCORE_BOOL't => Shift_act Nis'5 (eq_refl _)
        | TYPEDEF_NAME't => Shift_act Nis'6 (eq_refl _)
        | TYPEDEF't => Shift_act Nis'7 (eq_refl _)
        | STRUCT't => Shift_act Nis'8 (eq_refl _)
        | STATIC't => Shift_act Nis'9 (eq_refl _)
        | SIGNED't => Shift_act Nis'10 (eq_refl _)
        | SHORT't => Shift_act Nis'11 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'335 (eq_refl _)
        | RESTRICT't => Shift_act Nis'13 (eq_refl _)
        | REGISTER't => Shift_act Nis'14 (eq_refl _)
        | PRAGMA't => Shift_act Nis'15 (eq_refl _)
        | PACKED't => Shift_act Nis'16 (eq_refl _)
        | LONG't => Shift_act Nis'27 (eq_refl _)
        | INT't => Shift_act Nis'28 (eq_refl _)
        | INLINE't => Shift_act Nis'189 (eq_refl _)
        | FLOAT't => Shift_act Nis'31 (eq_refl _)
        | EXTERN't => Shift_act Nis'190 (eq_refl _)
        | EOF't => Shift_act Nis'336 (eq_refl _)
        | ENUM't => Shift_act Nis'32 (eq_refl _)
        | DOUBLE't => Shift_act Nis'52 (eq_refl _)
        | CONST't => Shift_act Nis'53 (eq_refl _)
        | CHAR't => Shift_act Nis'54 (eq_refl _)
        | AUTO't => Shift_act Nis'191 (eq_refl _)
        | ATTRIBUTE't => Shift_act Nis'55 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'162 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'335 => Default_reduce_act Prod'translation_unit'2
    | Ninit Nis'336 => Default_reduce_act Prod'translation_unit_file'0
    | Ninit Nis'337 => Default_reduce_act Prod'external_declaration'0
    | Ninit Nis'338 => Default_reduce_act Prod'translation_unit'1
    | Ninit Nis'339 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'175 (eq_refl _)
        | STAR't => Shift_act Nis'176 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'340 (eq_refl _)
        | LPAREN't => Shift_act Nis'184 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'340 => Default_reduce_act Prod'declaration'1
    | Ninit Nis'341 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'175 (eq_refl _)
        | LPAREN't => Shift_act Nis'184 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'342 => Default_reduce_act Prod'old_function_declarator'1
    | Ninit Nis'343 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Reduce_act Prod'attribute_specifier_list'0
        | PACKED't => Reduce_act Prod'attribute_specifier_list'0
        | LPAREN't => Shift_act Nis'344 (eq_refl _)
        | LBRACK't => Shift_act Nis'236 (eq_refl _)
        | LBRACE't => Reduce_act Prod'attribute_specifier_list'0
        | EQ't => Reduce_act Prod'attribute_specifier_list'0
        | COMMA't => Reduce_act Prod'attribute_specifier_list'0
        | ATTRIBUTE't => Reduce_act Prod'attribute_specifier_list'0
        | ALIGNAS't => Reduce_act Prod'attribute_specifier_list'0
        | _ => Fail_act
      end)
    | Ninit Nis'344 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VOLATILE't => Shift_act Nis'1 (eq_refl _)
        | VOID't => Shift_act Nis'2 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'345 (eq_refl _)
        | UNSIGNED't => Shift_act Nis'3 (eq_refl _)
        | UNION't => Shift_act Nis'4 (eq_refl _)
        | UNDERSCORE_BOOL't => Shift_act Nis'5 (eq_refl _)
        | TYPEDEF_NAME't => Shift_act Nis'6 (eq_refl _)
        | TYPEDEF't => Shift_act Nis'7 (eq_refl _)
        | STRUCT't => Shift_act Nis'8 (eq_refl _)
        | STATIC't => Shift_act Nis'9 (eq_refl _)
        | SIGNED't => Shift_act Nis'10 (eq_refl _)
        | SHORT't => Shift_act Nis'11 (eq_refl _)
        | RPAREN't => Shift_act Nis'188 (eq_refl _)
        | RESTRICT't => Shift_act Nis'13 (eq_refl _)
        | REGISTER't => Shift_act Nis'14 (eq_refl _)
        | PACKED't => Shift_act Nis'16 (eq_refl _)
        | LONG't => Shift_act Nis'27 (eq_refl _)
        | INT't => Shift_act Nis'28 (eq_refl _)
        | INLINE't => Shift_act Nis'189 (eq_refl _)
        | FLOAT't => Shift_act Nis'31 (eq_refl _)
        | EXTERN't => Shift_act Nis'190 (eq_refl _)
        | ENUM't => Shift_act Nis'32 (eq_refl _)
        | DOUBLE't => Shift_act Nis'52 (eq_refl _)
        | CONST't => Shift_act Nis'53 (eq_refl _)
        | CHAR't => Shift_act Nis'54 (eq_refl _)
        | AUTO't => Shift_act Nis'191 (eq_refl _)
        | ATTRIBUTE't => Shift_act Nis'55 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'162 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'345 => Default_reduce_act Prod'identifier_list'0
    | Ninit Nis'346 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'347 (eq_refl _)
        | COMMA't => Shift_act Nis'348 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'347 => Default_reduce_act Prod'direct_old_function_declarator'0
    | Ninit Nis'348 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'349 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'349 => Default_reduce_act Prod'identifier_list'1
    | Ninit Nis'350 => Default_reduce_act Prod'declaration_list'0
    | Ninit Nis'351 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VOLATILE't => Shift_act Nis'1 (eq_refl _)
        | VOID't => Shift_act Nis'2 (eq_refl _)
        | UNSIGNED't => Shift_act Nis'3 (eq_refl _)
        | UNION't => Shift_act Nis'4 (eq_refl _)
        | UNDERSCORE_BOOL't => Shift_act Nis'5 (eq_refl _)
        | TYPEDEF_NAME't => Shift_act Nis'6 (eq_refl _)
        | TYPEDEF't => Shift_act Nis'7 (eq_refl _)
        | STRUCT't => Shift_act Nis'8 (eq_refl _)
        | STATIC't => Shift_act Nis'9 (eq_refl _)
        | SIGNED't => Shift_act Nis'10 (eq_refl _)
        | SHORT't => Shift_act Nis'11 (eq_refl _)
        | RESTRICT't => Shift_act Nis'13 (eq_refl _)
        | REGISTER't => Shift_act Nis'14 (eq_refl _)
        | PACKED't => Shift_act Nis'16 (eq_refl _)
        | LONG't => Shift_act Nis'27 (eq_refl _)
        | LBRACE't => Shift_act Nis'352 (eq_refl _)
        | INT't => Shift_act Nis'28 (eq_refl _)
        | INLINE't => Shift_act Nis'189 (eq_refl _)
        | FLOAT't => Shift_act Nis'31 (eq_refl _)
        | EXTERN't => Shift_act Nis'190 (eq_refl _)
        | ENUM't => Shift_act Nis'32 (eq_refl _)
        | DOUBLE't => Shift_act Nis'52 (eq_refl _)
        | CONST't => Shift_act Nis'53 (eq_refl _)
        | CHAR't => Shift_act Nis'54 (eq_refl _)
        | AUTO't => Shift_act Nis'191 (eq_refl _)
        | ATTRIBUTE't => Shift_act Nis'55 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'162 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'352 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'353 (eq_refl _)
        | VOLATILE't => Shift_act Nis'1 (eq_refl _)
        | VOID't => Shift_act Nis'2 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | UNSIGNED't => Shift_act Nis'3 (eq_refl _)
        | UNION't => Shift_act Nis'4 (eq_refl _)
        | UNDERSCORE_BOOL't => Shift_act Nis'5 (eq_refl _)
        | TYPEDEF_NAME't => Shift_act Nis'6 (eq_refl _)
        | TYPEDEF't => Shift_act Nis'7 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | SWITCH't => Shift_act Nis'357 (eq_refl _)
        | STRUCT't => Shift_act Nis'8 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STATIC't => Shift_act Nis'9 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | SIGNED't => Shift_act Nis'10 (eq_refl _)
        | SHORT't => Shift_act Nis'11 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'361 (eq_refl _)
        | RETURN't => Shift_act Nis'362 (eq_refl _)
        | RESTRICT't => Shift_act Nis'13 (eq_refl _)
        | REGISTER't => Shift_act Nis'14 (eq_refl _)
        | RBRACE't => Shift_act Nis'581 (eq_refl _)
        | PRAGMA't => Shift_act Nis'582 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | PACKED't => Shift_act Nis'16 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'366 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | LONG't => Shift_act Nis'27 (eq_refl _)
        | LBRACE't => Shift_act Nis'352 (eq_refl _)
        | INT't => Shift_act Nis'28 (eq_refl _)
        | INLINE't => Shift_act Nis'189 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | IF't => Shift_act Nis'368 (eq_refl _)
        | GOTO't => Shift_act Nis'386 (eq_refl _)
        | FOR't => Shift_act Nis'395 (eq_refl _)
        | FLOAT't => Shift_act Nis'31 (eq_refl _)
        | EXTERN't => Shift_act Nis'190 (eq_refl _)
        | ENUM't => Shift_act Nis'32 (eq_refl _)
        | DOUBLE't => Shift_act Nis'52 (eq_refl _)
        | DO't => Shift_act Nis'400 (eq_refl _)
        | DEFAULT't => Shift_act Nis'401 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONTINUE't => Shift_act Nis'403 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | CONST't => Shift_act Nis'53 (eq_refl _)
        | CHAR't => Shift_act Nis'54 (eq_refl _)
        | CASE't => Shift_act Nis'405 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BREAK't => Shift_act Nis'408 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AUTO't => Shift_act Nis'191 (eq_refl _)
        | ATTRIBUTE't => Shift_act Nis'55 (eq_refl _)
        | ASM't => Shift_act Nis'410 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'162 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'353 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | LPAREN't => Shift_act Nis'354 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'354 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'355 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'356 (eq_refl _)
        | COMMA't => Shift_act Nis'132 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'356 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'353 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | SWITCH't => Shift_act Nis'357 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'361 (eq_refl _)
        | RETURN't => Shift_act Nis'362 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'366 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | LBRACE't => Shift_act Nis'352 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | IF't => Shift_act Nis'368 (eq_refl _)
        | GOTO't => Shift_act Nis'386 (eq_refl _)
        | FOR't => Shift_act Nis'395 (eq_refl _)
        | DO't => Shift_act Nis'400 (eq_refl _)
        | DEFAULT't => Shift_act Nis'401 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONTINUE't => Shift_act Nis'403 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | CASE't => Shift_act Nis'405 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BREAK't => Shift_act Nis'408 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | ASM't => Shift_act Nis'410 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'357 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | LPAREN't => Shift_act Nis'358 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'358 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'359 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'360 (eq_refl _)
        | COMMA't => Shift_act Nis'132 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'360 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'353 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | SWITCH't => Shift_act Nis'357 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'361 (eq_refl _)
        | RETURN't => Shift_act Nis'362 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'366 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | LBRACE't => Shift_act Nis'352 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | IF't => Shift_act Nis'368 (eq_refl _)
        | GOTO't => Shift_act Nis'386 (eq_refl _)
        | FOR't => Shift_act Nis'395 (eq_refl _)
        | DO't => Shift_act Nis'400 (eq_refl _)
        | DEFAULT't => Shift_act Nis'401 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONTINUE't => Shift_act Nis'403 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | CASE't => Shift_act Nis'405 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BREAK't => Shift_act Nis'408 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | ASM't => Shift_act Nis'410 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'361 => Default_reduce_act Prod'expression_statement'1
    | Ninit Nis'362 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'363 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'363 => Default_reduce_act Prod'jump_statement'4
    | Ninit Nis'364 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Shift_act Nis'365 (eq_refl _)
        | COMMA't => Shift_act Nis'132 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'365 => Default_reduce_act Prod'jump_statement'3
    | Ninit Nis'366 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | COLON't => Shift_act Nis'367 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'367 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'353 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | SWITCH't => Shift_act Nis'357 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'361 (eq_refl _)
        | RETURN't => Shift_act Nis'362 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'366 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | LBRACE't => Shift_act Nis'352 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | IF't => Shift_act Nis'368 (eq_refl _)
        | GOTO't => Shift_act Nis'386 (eq_refl _)
        | FOR't => Shift_act Nis'395 (eq_refl _)
        | DO't => Shift_act Nis'400 (eq_refl _)
        | DEFAULT't => Shift_act Nis'401 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONTINUE't => Shift_act Nis'403 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | CASE't => Shift_act Nis'405 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BREAK't => Shift_act Nis'408 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | ASM't => Shift_act Nis'410 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'368 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | LPAREN't => Shift_act Nis'369 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'369 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'370 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'371 (eq_refl _)
        | COMMA't => Shift_act Nis'132 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'371 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'372 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | SWITCH't => Shift_act Nis'376 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'361 (eq_refl _)
        | RETURN't => Shift_act Nis'362 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'380 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | LBRACE't => Shift_act Nis'352 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | IF't => Shift_act Nis'382 (eq_refl _)
        | GOTO't => Shift_act Nis'386 (eq_refl _)
        | FOR't => Shift_act Nis'389 (eq_refl _)
        | DO't => Shift_act Nis'394 (eq_refl _)
        | DEFAULT't => Shift_act Nis'514 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONTINUE't => Shift_act Nis'403 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | CASE't => Shift_act Nis'516 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BREAK't => Shift_act Nis'408 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | ASM't => Shift_act Nis'410 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'372 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | LPAREN't => Shift_act Nis'373 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'373 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'374 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'375 (eq_refl _)
        | COMMA't => Shift_act Nis'132 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'375 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'372 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | SWITCH't => Shift_act Nis'376 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'361 (eq_refl _)
        | RETURN't => Shift_act Nis'362 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'380 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | LBRACE't => Shift_act Nis'352 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | IF't => Shift_act Nis'382 (eq_refl _)
        | GOTO't => Shift_act Nis'386 (eq_refl _)
        | FOR't => Shift_act Nis'389 (eq_refl _)
        | DO't => Shift_act Nis'394 (eq_refl _)
        | DEFAULT't => Shift_act Nis'514 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONTINUE't => Shift_act Nis'403 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | CASE't => Shift_act Nis'516 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BREAK't => Shift_act Nis'408 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | ASM't => Shift_act Nis'410 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'376 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | LPAREN't => Shift_act Nis'377 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'377 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'378 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'379 (eq_refl _)
        | COMMA't => Shift_act Nis'132 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'379 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'372 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | SWITCH't => Shift_act Nis'376 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'361 (eq_refl _)
        | RETURN't => Shift_act Nis'362 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'380 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | LBRACE't => Shift_act Nis'352 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | IF't => Shift_act Nis'382 (eq_refl _)
        | GOTO't => Shift_act Nis'386 (eq_refl _)
        | FOR't => Shift_act Nis'389 (eq_refl _)
        | DO't => Shift_act Nis'394 (eq_refl _)
        | DEFAULT't => Shift_act Nis'514 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONTINUE't => Shift_act Nis'403 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | CASE't => Shift_act Nis'516 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BREAK't => Shift_act Nis'408 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | ASM't => Shift_act Nis'410 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'380 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | COLON't => Shift_act Nis'381 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'381 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'372 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | SWITCH't => Shift_act Nis'376 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'361 (eq_refl _)
        | RETURN't => Shift_act Nis'362 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'380 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | LBRACE't => Shift_act Nis'352 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | IF't => Shift_act Nis'382 (eq_refl _)
        | GOTO't => Shift_act Nis'386 (eq_refl _)
        | FOR't => Shift_act Nis'389 (eq_refl _)
        | DO't => Shift_act Nis'394 (eq_refl _)
        | DEFAULT't => Shift_act Nis'514 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONTINUE't => Shift_act Nis'403 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | CASE't => Shift_act Nis'516 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BREAK't => Shift_act Nis'408 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | ASM't => Shift_act Nis'410 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'382 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | LPAREN't => Shift_act Nis'383 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'383 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'384 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'385 (eq_refl _)
        | COMMA't => Shift_act Nis'132 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'385 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'372 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | SWITCH't => Shift_act Nis'376 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'361 (eq_refl _)
        | RETURN't => Shift_act Nis'362 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'380 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | LBRACE't => Shift_act Nis'352 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | IF't => Shift_act Nis'382 (eq_refl _)
        | GOTO't => Shift_act Nis'386 (eq_refl _)
        | FOR't => Shift_act Nis'389 (eq_refl _)
        | DO't => Shift_act Nis'394 (eq_refl _)
        | DEFAULT't => Shift_act Nis'514 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONTINUE't => Shift_act Nis'403 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | CASE't => Shift_act Nis'516 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BREAK't => Shift_act Nis'408 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | ASM't => Shift_act Nis'410 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'386 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | OTHER_NAME't => Shift_act Nis'387 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'387 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Shift_act Nis'388 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'388 => Default_reduce_act Prod'jump_statement'0
    | Ninit Nis'389 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | LPAREN't => Shift_act Nis'390 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'390 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VOLATILE't => Shift_act Nis'1 (eq_refl _)
        | VOID't => Shift_act Nis'2 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | UNSIGNED't => Shift_act Nis'3 (eq_refl _)
        | UNION't => Shift_act Nis'4 (eq_refl _)
        | UNDERSCORE_BOOL't => Shift_act Nis'5 (eq_refl _)
        | TYPEDEF_NAME't => Shift_act Nis'6 (eq_refl _)
        | TYPEDEF't => Shift_act Nis'7 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRUCT't => Shift_act Nis'8 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STATIC't => Shift_act Nis'9 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | SIGNED't => Shift_act Nis'10 (eq_refl _)
        | SHORT't => Shift_act Nis'11 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'391 (eq_refl _)
        | RESTRICT't => Shift_act Nis'13 (eq_refl _)
        | REGISTER't => Shift_act Nis'14 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | PACKED't => Shift_act Nis'16 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | LONG't => Shift_act Nis'27 (eq_refl _)
        | INT't => Shift_act Nis'28 (eq_refl _)
        | INLINE't => Shift_act Nis'189 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | FLOAT't => Shift_act Nis'31 (eq_refl _)
        | EXTERN't => Shift_act Nis'190 (eq_refl _)
        | ENUM't => Shift_act Nis'32 (eq_refl _)
        | DOUBLE't => Shift_act Nis'52 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | CONST't => Shift_act Nis'53 (eq_refl _)
        | CHAR't => Shift_act Nis'54 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AUTO't => Shift_act Nis'191 (eq_refl _)
        | ATTRIBUTE't => Shift_act Nis'55 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'162 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'391 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'392 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'392 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | RPAREN't => Shift_act Nis'393 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'393 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'372 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | SWITCH't => Shift_act Nis'376 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'361 (eq_refl _)
        | RETURN't => Shift_act Nis'362 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'380 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | LBRACE't => Shift_act Nis'352 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | IF't => Shift_act Nis'382 (eq_refl _)
        | GOTO't => Shift_act Nis'386 (eq_refl _)
        | FOR't => Shift_act Nis'389 (eq_refl _)
        | DO't => Shift_act Nis'394 (eq_refl _)
        | DEFAULT't => Shift_act Nis'514 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONTINUE't => Shift_act Nis'403 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | CASE't => Shift_act Nis'516 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BREAK't => Shift_act Nis'408 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | ASM't => Shift_act Nis'410 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'394 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'353 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | SWITCH't => Shift_act Nis'357 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'361 (eq_refl _)
        | RETURN't => Shift_act Nis'362 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'366 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | LBRACE't => Shift_act Nis'352 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | IF't => Shift_act Nis'368 (eq_refl _)
        | GOTO't => Shift_act Nis'386 (eq_refl _)
        | FOR't => Shift_act Nis'395 (eq_refl _)
        | DO't => Shift_act Nis'400 (eq_refl _)
        | DEFAULT't => Shift_act Nis'401 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONTINUE't => Shift_act Nis'403 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | CASE't => Shift_act Nis'405 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BREAK't => Shift_act Nis'408 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | ASM't => Shift_act Nis'410 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'395 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | LPAREN't => Shift_act Nis'396 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'396 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VOLATILE't => Shift_act Nis'1 (eq_refl _)
        | VOID't => Shift_act Nis'2 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | UNSIGNED't => Shift_act Nis'3 (eq_refl _)
        | UNION't => Shift_act Nis'4 (eq_refl _)
        | UNDERSCORE_BOOL't => Shift_act Nis'5 (eq_refl _)
        | TYPEDEF_NAME't => Shift_act Nis'6 (eq_refl _)
        | TYPEDEF't => Shift_act Nis'7 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRUCT't => Shift_act Nis'8 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STATIC't => Shift_act Nis'9 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | SIGNED't => Shift_act Nis'10 (eq_refl _)
        | SHORT't => Shift_act Nis'11 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'397 (eq_refl _)
        | RESTRICT't => Shift_act Nis'13 (eq_refl _)
        | REGISTER't => Shift_act Nis'14 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | PACKED't => Shift_act Nis'16 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | LONG't => Shift_act Nis'27 (eq_refl _)
        | INT't => Shift_act Nis'28 (eq_refl _)
        | INLINE't => Shift_act Nis'189 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | FLOAT't => Shift_act Nis'31 (eq_refl _)
        | EXTERN't => Shift_act Nis'190 (eq_refl _)
        | ENUM't => Shift_act Nis'32 (eq_refl _)
        | DOUBLE't => Shift_act Nis'52 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | CONST't => Shift_act Nis'53 (eq_refl _)
        | CHAR't => Shift_act Nis'54 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AUTO't => Shift_act Nis'191 (eq_refl _)
        | ATTRIBUTE't => Shift_act Nis'55 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'162 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'397 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'398 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'398 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | RPAREN't => Shift_act Nis'399 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'399 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'353 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | SWITCH't => Shift_act Nis'357 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'361 (eq_refl _)
        | RETURN't => Shift_act Nis'362 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'366 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | LBRACE't => Shift_act Nis'352 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | IF't => Shift_act Nis'368 (eq_refl _)
        | GOTO't => Shift_act Nis'386 (eq_refl _)
        | FOR't => Shift_act Nis'395 (eq_refl _)
        | DO't => Shift_act Nis'400 (eq_refl _)
        | DEFAULT't => Shift_act Nis'401 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONTINUE't => Shift_act Nis'403 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | CASE't => Shift_act Nis'405 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BREAK't => Shift_act Nis'408 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | ASM't => Shift_act Nis'410 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'400 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'353 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | SWITCH't => Shift_act Nis'357 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'361 (eq_refl _)
        | RETURN't => Shift_act Nis'362 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'366 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | LBRACE't => Shift_act Nis'352 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | IF't => Shift_act Nis'368 (eq_refl _)
        | GOTO't => Shift_act Nis'386 (eq_refl _)
        | FOR't => Shift_act Nis'395 (eq_refl _)
        | DO't => Shift_act Nis'400 (eq_refl _)
        | DEFAULT't => Shift_act Nis'401 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONTINUE't => Shift_act Nis'403 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | CASE't => Shift_act Nis'405 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BREAK't => Shift_act Nis'408 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | ASM't => Shift_act Nis'410 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'401 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | COLON't => Shift_act Nis'402 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'402 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'353 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | SWITCH't => Shift_act Nis'357 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'361 (eq_refl _)
        | RETURN't => Shift_act Nis'362 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'366 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | LBRACE't => Shift_act Nis'352 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | IF't => Shift_act Nis'368 (eq_refl _)
        | GOTO't => Shift_act Nis'386 (eq_refl _)
        | FOR't => Shift_act Nis'395 (eq_refl _)
        | DO't => Shift_act Nis'400 (eq_refl _)
        | DEFAULT't => Shift_act Nis'401 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONTINUE't => Shift_act Nis'403 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | CASE't => Shift_act Nis'405 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BREAK't => Shift_act Nis'408 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | ASM't => Shift_act Nis'410 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'403 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Shift_act Nis'404 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'404 => Default_reduce_act Prod'jump_statement'1
    | Ninit Nis'405 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'406 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | COLON't => Shift_act Nis'407 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'407 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'353 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | SWITCH't => Shift_act Nis'357 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'361 (eq_refl _)
        | RETURN't => Shift_act Nis'362 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'366 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | LBRACE't => Shift_act Nis'352 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | IF't => Shift_act Nis'368 (eq_refl _)
        | GOTO't => Shift_act Nis'386 (eq_refl _)
        | FOR't => Shift_act Nis'395 (eq_refl _)
        | DO't => Shift_act Nis'400 (eq_refl _)
        | DEFAULT't => Shift_act Nis'401 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONTINUE't => Shift_act Nis'403 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | CASE't => Shift_act Nis'405 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BREAK't => Shift_act Nis'408 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | ASM't => Shift_act Nis'410 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'408 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Shift_act Nis'409 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'409 => Default_reduce_act Prod'jump_statement'2
    | Ninit Nis'410 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VOLATILE't => Shift_act Nis'411 (eq_refl _)
        | LPAREN't => Reduce_act Prod'asm_attributes'0
        | CONST't => Shift_act Nis'412 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'411 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VOLATILE't => Shift_act Nis'411 (eq_refl _)
        | LPAREN't => Reduce_act Prod'asm_attributes'0
        | CONST't => Shift_act Nis'412 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'412 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VOLATILE't => Shift_act Nis'411 (eq_refl _)
        | LPAREN't => Reduce_act Prod'asm_attributes'0
        | CONST't => Shift_act Nis'412 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'413 => Default_reduce_act Prod'asm_attributes'1
    | Ninit Nis'414 => Default_reduce_act Prod'asm_attributes'2
    | Ninit Nis'415 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | LPAREN't => Shift_act Nis'416 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'416 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | STRING_LITERAL't => Shift_act Nis'417 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'417 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Reduce_act Prod'asm_arguments'0
        | COLON't => Shift_act Nis'418 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'418 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | STRING_LITERAL't => Reduce_act Prod'asm_op_name'0
        | RPAREN't => Reduce_act Prod'asm_operands'0
        | LBRACK't => Shift_act Nis'419 (eq_refl _)
        | COLON't => Reduce_act Prod'asm_operands'0
        | _ => Fail_act
      end)
    | Ninit Nis'419 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | OTHER_NAME't => Shift_act Nis'420 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'420 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RBRACK't => Shift_act Nis'421 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'421 => Default_reduce_act Prod'asm_op_name'1
    | Ninit Nis'422 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Reduce_act Prod'asm_operands'1
        | COMMA't => Shift_act Nis'423 (eq_refl _)
        | COLON't => Reduce_act Prod'asm_operands'1
        | _ => Fail_act
      end)
    | Ninit Nis'423 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | STRING_LITERAL't => Reduce_act Prod'asm_op_name'0
        | LBRACK't => Shift_act Nis'419 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'424 => Default_reduce_act Prod'asm_operands_ne'0
    | Ninit Nis'425 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | STRING_LITERAL't => Shift_act Nis'426 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'426 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | LPAREN't => Shift_act Nis'427 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'427 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'428 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'429 (eq_refl _)
        | COMMA't => Shift_act Nis'132 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'429 => Default_reduce_act Prod'asm_operand'0
    | Ninit Nis'430 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Reduce_act Prod'asm_arguments'1
        | COLON't => Shift_act Nis'431 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'431 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | STRING_LITERAL't => Reduce_act Prod'asm_op_name'0
        | RPAREN't => Reduce_act Prod'asm_operands'0
        | LBRACK't => Shift_act Nis'419 (eq_refl _)
        | COLON't => Reduce_act Prod'asm_operands'0
        | _ => Fail_act
      end)
    | Ninit Nis'432 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Reduce_act Prod'asm_arguments'2
        | COLON't => Shift_act Nis'433 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'433 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | STRING_LITERAL't => Shift_act Nis'434 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'434 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Reduce_act Prod'asm_flags'0
        | COMMA't => Shift_act Nis'435 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'435 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | STRING_LITERAL't => Shift_act Nis'434 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'436 => Default_reduce_act Prod'asm_flags'1
    | Ninit Nis'437 => Default_reduce_act Prod'asm_arguments'3
    | Ninit Nis'438 => Default_reduce_act Prod'asm_operands_ne'1
    | Ninit Nis'439 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'440 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'440 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Shift_act Nis'441 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'441 => Default_reduce_act Prod'asm_statement'0
    | Ninit Nis'442 => Default_reduce_act Prod'labeled_statement_statement_dangerous_'1
    | Ninit Nis'443 => Default_reduce_act Prod'statement_dangerous'3
    | Ninit Nis'444 => Default_reduce_act Prod'statement_dangerous'0
    | Ninit Nis'445 => Default_reduce_act Prod'statement_dangerous'5
    | Ninit Nis'446 => Default_reduce_act Prod'statement_dangerous'4
    | Ninit Nis'447 => Default_reduce_act Prod'statement_dangerous'2
    | Ninit Nis'448 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Shift_act Nis'449 (eq_refl _)
        | COMMA't => Shift_act Nis'132 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'449 => Default_reduce_act Prod'expression_statement'0
    | Ninit Nis'450 => Default_reduce_act Prod'statement_dangerous'1
    | Ninit Nis'451 => Default_reduce_act Prod'statement_dangerous'6
    | Ninit Nis'452 => Default_reduce_act Prod'labeled_statement_statement_dangerous_'2
    | Ninit Nis'453 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'454 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'454 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | LPAREN't => Shift_act Nis'455 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'455 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'456 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'457 (eq_refl _)
        | COMMA't => Shift_act Nis'132 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'457 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Shift_act Nis'458 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'458 => Default_reduce_act Prod'iteration_statement_statement_dangerous_'1
    | Ninit Nis'459 => Default_reduce_act Prod'iteration_statement_statement_dangerous_'13
    | Ninit Nis'460 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'461 (eq_refl _)
        | COMMA't => Shift_act Nis'132 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'461 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'353 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | SWITCH't => Shift_act Nis'357 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'361 (eq_refl _)
        | RETURN't => Shift_act Nis'362 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'366 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | LBRACE't => Shift_act Nis'352 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | IF't => Shift_act Nis'368 (eq_refl _)
        | GOTO't => Shift_act Nis'386 (eq_refl _)
        | FOR't => Shift_act Nis'395 (eq_refl _)
        | DO't => Shift_act Nis'400 (eq_refl _)
        | DEFAULT't => Shift_act Nis'401 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONTINUE't => Shift_act Nis'403 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | CASE't => Shift_act Nis'405 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BREAK't => Shift_act Nis'408 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | ASM't => Shift_act Nis'410 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'462 => Default_reduce_act Prod'iteration_statement_statement_dangerous_'7
    | Ninit Nis'463 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Shift_act Nis'464 (eq_refl _)
        | COMMA't => Shift_act Nis'132 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'464 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | RPAREN't => Shift_act Nis'465 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'465 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'353 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | SWITCH't => Shift_act Nis'357 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'361 (eq_refl _)
        | RETURN't => Shift_act Nis'362 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'366 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | LBRACE't => Shift_act Nis'352 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | IF't => Shift_act Nis'368 (eq_refl _)
        | GOTO't => Shift_act Nis'386 (eq_refl _)
        | FOR't => Shift_act Nis'395 (eq_refl _)
        | DO't => Shift_act Nis'400 (eq_refl _)
        | DEFAULT't => Shift_act Nis'401 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONTINUE't => Shift_act Nis'403 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | CASE't => Shift_act Nis'405 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BREAK't => Shift_act Nis'408 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | ASM't => Shift_act Nis'410 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'466 => Default_reduce_act Prod'iteration_statement_statement_dangerous_'10
    | Ninit Nis'467 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'468 (eq_refl _)
        | COMMA't => Shift_act Nis'132 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'468 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'353 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | SWITCH't => Shift_act Nis'357 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'361 (eq_refl _)
        | RETURN't => Shift_act Nis'362 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'366 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | LBRACE't => Shift_act Nis'352 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | IF't => Shift_act Nis'368 (eq_refl _)
        | GOTO't => Shift_act Nis'386 (eq_refl _)
        | FOR't => Shift_act Nis'395 (eq_refl _)
        | DO't => Shift_act Nis'400 (eq_refl _)
        | DEFAULT't => Shift_act Nis'401 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONTINUE't => Shift_act Nis'403 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | CASE't => Shift_act Nis'405 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BREAK't => Shift_act Nis'408 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | ASM't => Shift_act Nis'410 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'469 => Default_reduce_act Prod'iteration_statement_statement_dangerous_'4
    | Ninit Nis'470 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Shift_act Nis'471 (eq_refl _)
        | COMMA't => Shift_act Nis'132 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'471 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'472 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'472 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | RPAREN't => Shift_act Nis'473 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'473 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'353 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | SWITCH't => Shift_act Nis'357 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'361 (eq_refl _)
        | RETURN't => Shift_act Nis'362 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'366 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | LBRACE't => Shift_act Nis'352 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | IF't => Shift_act Nis'368 (eq_refl _)
        | GOTO't => Shift_act Nis'386 (eq_refl _)
        | FOR't => Shift_act Nis'395 (eq_refl _)
        | DO't => Shift_act Nis'400 (eq_refl _)
        | DEFAULT't => Shift_act Nis'401 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONTINUE't => Shift_act Nis'403 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | CASE't => Shift_act Nis'405 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BREAK't => Shift_act Nis'408 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | ASM't => Shift_act Nis'410 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'474 => Default_reduce_act Prod'iteration_statement_statement_dangerous_'11
    | Ninit Nis'475 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'476 (eq_refl _)
        | COMMA't => Shift_act Nis'132 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'476 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'353 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | SWITCH't => Shift_act Nis'357 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'361 (eq_refl _)
        | RETURN't => Shift_act Nis'362 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'366 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | LBRACE't => Shift_act Nis'352 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | IF't => Shift_act Nis'368 (eq_refl _)
        | GOTO't => Shift_act Nis'386 (eq_refl _)
        | FOR't => Shift_act Nis'395 (eq_refl _)
        | DO't => Shift_act Nis'400 (eq_refl _)
        | DEFAULT't => Shift_act Nis'401 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONTINUE't => Shift_act Nis'403 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | CASE't => Shift_act Nis'405 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BREAK't => Shift_act Nis'408 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | ASM't => Shift_act Nis'410 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'477 => Default_reduce_act Prod'iteration_statement_statement_dangerous_'5
    | Ninit Nis'478 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Shift_act Nis'479 (eq_refl _)
        | COMMA't => Shift_act Nis'132 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'479 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | RPAREN't => Shift_act Nis'480 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'480 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'353 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | SWITCH't => Shift_act Nis'357 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'361 (eq_refl _)
        | RETURN't => Shift_act Nis'362 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'366 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | LBRACE't => Shift_act Nis'352 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | IF't => Shift_act Nis'368 (eq_refl _)
        | GOTO't => Shift_act Nis'386 (eq_refl _)
        | FOR't => Shift_act Nis'395 (eq_refl _)
        | DO't => Shift_act Nis'400 (eq_refl _)
        | DEFAULT't => Shift_act Nis'401 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONTINUE't => Shift_act Nis'403 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | CASE't => Shift_act Nis'405 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BREAK't => Shift_act Nis'408 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | ASM't => Shift_act Nis'410 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'481 => Default_reduce_act Prod'iteration_statement_statement_dangerous_'8
    | Ninit Nis'482 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'483 (eq_refl _)
        | COMMA't => Shift_act Nis'132 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'483 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'353 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | SWITCH't => Shift_act Nis'357 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'361 (eq_refl _)
        | RETURN't => Shift_act Nis'362 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'366 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | LBRACE't => Shift_act Nis'352 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | IF't => Shift_act Nis'368 (eq_refl _)
        | GOTO't => Shift_act Nis'386 (eq_refl _)
        | FOR't => Shift_act Nis'395 (eq_refl _)
        | DO't => Shift_act Nis'400 (eq_refl _)
        | DEFAULT't => Shift_act Nis'401 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONTINUE't => Shift_act Nis'403 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | CASE't => Shift_act Nis'405 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BREAK't => Shift_act Nis'408 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | ASM't => Shift_act Nis'410 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'484 => Default_reduce_act Prod'iteration_statement_statement_dangerous_'2
    | Ninit Nis'485 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'175 (eq_refl _)
        | STAR't => Shift_act Nis'176 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'340 (eq_refl _)
        | LPAREN't => Shift_act Nis'184 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'486 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Shift_act Nis'487 (eq_refl _)
        | COMMA't => Shift_act Nis'488 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'487 => Default_reduce_act Prod'declaration'0
    | Ninit Nis'488 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'175 (eq_refl _)
        | STAR't => Shift_act Nis'176 (eq_refl _)
        | LPAREN't => Shift_act Nis'184 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'489 => Default_reduce_act Prod'init_declarator_list'1
    | Ninit Nis'490 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Reduce_act Prod'init_declarator'0
        | EQ't => Shift_act Nis'491 (eq_refl _)
        | COMMA't => Reduce_act Prod'init_declarator'0
        | _ => Fail_act
      end)
    | Ninit Nis'491 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | LBRACE't => Shift_act Nis'284 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'492 => Default_reduce_act Prod'init_declarator'1
    | Ninit Nis'493 => Default_reduce_act Prod'init_declarator_list'0
    | Ninit Nis'494 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'495 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'495 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | RPAREN't => Shift_act Nis'496 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'496 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'353 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | SWITCH't => Shift_act Nis'357 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'361 (eq_refl _)
        | RETURN't => Shift_act Nis'362 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'366 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | LBRACE't => Shift_act Nis'352 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | IF't => Shift_act Nis'368 (eq_refl _)
        | GOTO't => Shift_act Nis'386 (eq_refl _)
        | FOR't => Shift_act Nis'395 (eq_refl _)
        | DO't => Shift_act Nis'400 (eq_refl _)
        | DEFAULT't => Shift_act Nis'401 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONTINUE't => Shift_act Nis'403 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | CASE't => Shift_act Nis'405 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BREAK't => Shift_act Nis'408 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | ASM't => Shift_act Nis'410 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'497 => Default_reduce_act Prod'iteration_statement_statement_dangerous_'12
    | Ninit Nis'498 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'499 (eq_refl _)
        | COMMA't => Shift_act Nis'132 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'499 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'353 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | SWITCH't => Shift_act Nis'357 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'361 (eq_refl _)
        | RETURN't => Shift_act Nis'362 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'366 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | LBRACE't => Shift_act Nis'352 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | IF't => Shift_act Nis'368 (eq_refl _)
        | GOTO't => Shift_act Nis'386 (eq_refl _)
        | FOR't => Shift_act Nis'395 (eq_refl _)
        | DO't => Shift_act Nis'400 (eq_refl _)
        | DEFAULT't => Shift_act Nis'401 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONTINUE't => Shift_act Nis'403 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | CASE't => Shift_act Nis'405 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BREAK't => Shift_act Nis'408 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | ASM't => Shift_act Nis'410 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'500 => Default_reduce_act Prod'iteration_statement_statement_dangerous_'6
    | Ninit Nis'501 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Shift_act Nis'502 (eq_refl _)
        | COMMA't => Shift_act Nis'132 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'502 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | RPAREN't => Shift_act Nis'503 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'503 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'353 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | SWITCH't => Shift_act Nis'357 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'361 (eq_refl _)
        | RETURN't => Shift_act Nis'362 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'366 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | LBRACE't => Shift_act Nis'352 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | IF't => Shift_act Nis'368 (eq_refl _)
        | GOTO't => Shift_act Nis'386 (eq_refl _)
        | FOR't => Shift_act Nis'395 (eq_refl _)
        | DO't => Shift_act Nis'400 (eq_refl _)
        | DEFAULT't => Shift_act Nis'401 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONTINUE't => Shift_act Nis'403 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | CASE't => Shift_act Nis'405 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BREAK't => Shift_act Nis'408 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | ASM't => Shift_act Nis'410 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'504 => Default_reduce_act Prod'iteration_statement_statement_dangerous_'9
    | Ninit Nis'505 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'506 (eq_refl _)
        | COMMA't => Shift_act Nis'132 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'506 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'353 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | SWITCH't => Shift_act Nis'357 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'361 (eq_refl _)
        | RETURN't => Shift_act Nis'362 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'366 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | LBRACE't => Shift_act Nis'352 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | IF't => Shift_act Nis'368 (eq_refl _)
        | GOTO't => Shift_act Nis'386 (eq_refl _)
        | FOR't => Shift_act Nis'395 (eq_refl _)
        | DO't => Shift_act Nis'400 (eq_refl _)
        | DEFAULT't => Shift_act Nis'401 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONTINUE't => Shift_act Nis'403 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | CASE't => Shift_act Nis'405 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BREAK't => Shift_act Nis'408 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | ASM't => Shift_act Nis'410 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'507 => Default_reduce_act Prod'iteration_statement_statement_dangerous_'3
    | Ninit Nis'508 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'509 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'509 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | LPAREN't => Shift_act Nis'510 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'510 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'511 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'512 (eq_refl _)
        | COMMA't => Shift_act Nis'132 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'512 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Shift_act Nis'513 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'513 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | VOLATILE't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | VOID't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | VAR_NAME't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | UNSIGNED't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | UNION't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | UNDERSCORE_BOOL't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | TYPEDEF_NAME't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | TYPEDEF't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | TILDE't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | SWITCH't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | STRUCT't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | STRING_LITERAL't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | STATIC't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | STAR't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | SIZEOF't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | SIGNED't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | SHORT't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | SEMICOLON't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | RETURN't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | RESTRICT't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | REGISTER't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | RBRACE't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | PRAGMA't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | PLUS't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | PACKED't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | OTHER_NAME't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | MINUS't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | LPAREN't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | LONG't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | LBRACE't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | INT't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | INLINE't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | INC't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | IF't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | GOTO't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | FOR't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | FLOAT't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | EXTERN't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | ENUM't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | ELSE't => Reduce_act Prod'iteration_statement_statement_safe_'1
        | DOUBLE't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | DO't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | DEFAULT't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | DEC't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | CONTINUE't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | CONSTANT't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | CONST't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | CHAR't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | CASE't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | BUILTIN_VA_ARG't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | BREAK't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | BANG't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | AUTO't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | ATTRIBUTE't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | ASM't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | AND't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | ALIGNOF't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | ALIGNAS't => Reduce_act Prod'iteration_statement_statement_dangerous_'1
        | _ => Fail_act
      end)
    | Ninit Nis'514 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | COLON't => Shift_act Nis'515 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'515 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'372 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | SWITCH't => Shift_act Nis'376 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'361 (eq_refl _)
        | RETURN't => Shift_act Nis'362 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'380 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | LBRACE't => Shift_act Nis'352 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | IF't => Shift_act Nis'382 (eq_refl _)
        | GOTO't => Shift_act Nis'386 (eq_refl _)
        | FOR't => Shift_act Nis'389 (eq_refl _)
        | DO't => Shift_act Nis'394 (eq_refl _)
        | DEFAULT't => Shift_act Nis'514 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONTINUE't => Shift_act Nis'403 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | CASE't => Shift_act Nis'516 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BREAK't => Shift_act Nis'408 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | ASM't => Shift_act Nis'410 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'516 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'517 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | COLON't => Shift_act Nis'518 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'518 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'372 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | SWITCH't => Shift_act Nis'376 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'361 (eq_refl _)
        | RETURN't => Shift_act Nis'362 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'380 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | LBRACE't => Shift_act Nis'352 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | IF't => Shift_act Nis'382 (eq_refl _)
        | GOTO't => Shift_act Nis'386 (eq_refl _)
        | FOR't => Shift_act Nis'389 (eq_refl _)
        | DO't => Shift_act Nis'394 (eq_refl _)
        | DEFAULT't => Shift_act Nis'514 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONTINUE't => Shift_act Nis'403 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | CASE't => Shift_act Nis'516 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BREAK't => Shift_act Nis'408 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | ASM't => Shift_act Nis'410 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'519 => Default_reduce_act Prod'labeled_statement_statement_safe_'1
    | Ninit Nis'520 => Default_reduce_act Prod'statement_safe'3
    | Ninit Nis'521 => Default_reduce_act Prod'statement_safe'0
    | Ninit Nis'522 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Reduce_act Prod'statement_dangerous'5
        | VOLATILE't => Reduce_act Prod'statement_dangerous'5
        | VOID't => Reduce_act Prod'statement_dangerous'5
        | VAR_NAME't => Reduce_act Prod'statement_dangerous'5
        | UNSIGNED't => Reduce_act Prod'statement_dangerous'5
        | UNION't => Reduce_act Prod'statement_dangerous'5
        | UNDERSCORE_BOOL't => Reduce_act Prod'statement_dangerous'5
        | TYPEDEF_NAME't => Reduce_act Prod'statement_dangerous'5
        | TYPEDEF't => Reduce_act Prod'statement_dangerous'5
        | TILDE't => Reduce_act Prod'statement_dangerous'5
        | SWITCH't => Reduce_act Prod'statement_dangerous'5
        | STRUCT't => Reduce_act Prod'statement_dangerous'5
        | STRING_LITERAL't => Reduce_act Prod'statement_dangerous'5
        | STATIC't => Reduce_act Prod'statement_dangerous'5
        | STAR't => Reduce_act Prod'statement_dangerous'5
        | SIZEOF't => Reduce_act Prod'statement_dangerous'5
        | SIGNED't => Reduce_act Prod'statement_dangerous'5
        | SHORT't => Reduce_act Prod'statement_dangerous'5
        | SEMICOLON't => Reduce_act Prod'statement_dangerous'5
        | RETURN't => Reduce_act Prod'statement_dangerous'5
        | RESTRICT't => Reduce_act Prod'statement_dangerous'5
        | REGISTER't => Reduce_act Prod'statement_dangerous'5
        | RBRACE't => Reduce_act Prod'statement_dangerous'5
        | PRAGMA't => Reduce_act Prod'statement_dangerous'5
        | PLUS't => Reduce_act Prod'statement_dangerous'5
        | PACKED't => Reduce_act Prod'statement_dangerous'5
        | OTHER_NAME't => Reduce_act Prod'statement_dangerous'5
        | MINUS't => Reduce_act Prod'statement_dangerous'5
        | LPAREN't => Reduce_act Prod'statement_dangerous'5
        | LONG't => Reduce_act Prod'statement_dangerous'5
        | LBRACE't => Reduce_act Prod'statement_dangerous'5
        | INT't => Reduce_act Prod'statement_dangerous'5
        | INLINE't => Reduce_act Prod'statement_dangerous'5
        | INC't => Reduce_act Prod'statement_dangerous'5
        | IF't => Reduce_act Prod'statement_dangerous'5
        | GOTO't => Reduce_act Prod'statement_dangerous'5
        | FOR't => Reduce_act Prod'statement_dangerous'5
        | FLOAT't => Reduce_act Prod'statement_dangerous'5
        | EXTERN't => Reduce_act Prod'statement_dangerous'5
        | ENUM't => Reduce_act Prod'statement_dangerous'5
        | ELSE't => Reduce_act Prod'statement_safe'5
        | DOUBLE't => Reduce_act Prod'statement_dangerous'5
        | DO't => Reduce_act Prod'statement_dangerous'5
        | DEFAULT't => Reduce_act Prod'statement_dangerous'5
        | DEC't => Reduce_act Prod'statement_dangerous'5
        | CONTINUE't => Reduce_act Prod'statement_dangerous'5
        | CONSTANT't => Reduce_act Prod'statement_dangerous'5
        | CONST't => Reduce_act Prod'statement_dangerous'5
        | CHAR't => Reduce_act Prod'statement_dangerous'5
        | CASE't => Reduce_act Prod'statement_dangerous'5
        | BUILTIN_VA_ARG't => Reduce_act Prod'statement_dangerous'5
        | BREAK't => Reduce_act Prod'statement_dangerous'5
        | BANG't => Reduce_act Prod'statement_dangerous'5
        | AUTO't => Reduce_act Prod'statement_dangerous'5
        | ATTRIBUTE't => Reduce_act Prod'statement_dangerous'5
        | ASM't => Reduce_act Prod'statement_dangerous'5
        | AND't => Reduce_act Prod'statement_dangerous'5
        | ALIGNOF't => Reduce_act Prod'statement_dangerous'5
        | ALIGNAS't => Reduce_act Prod'statement_dangerous'5
        | _ => Fail_act
      end)
    | Ninit Nis'523 => Default_reduce_act Prod'statement_safe'4
    | Ninit Nis'524 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Reduce_act Prod'statement_dangerous'2
        | VOLATILE't => Reduce_act Prod'statement_dangerous'2
        | VOID't => Reduce_act Prod'statement_dangerous'2
        | VAR_NAME't => Reduce_act Prod'statement_dangerous'2
        | UNSIGNED't => Reduce_act Prod'statement_dangerous'2
        | UNION't => Reduce_act Prod'statement_dangerous'2
        | UNDERSCORE_BOOL't => Reduce_act Prod'statement_dangerous'2
        | TYPEDEF_NAME't => Reduce_act Prod'statement_dangerous'2
        | TYPEDEF't => Reduce_act Prod'statement_dangerous'2
        | TILDE't => Reduce_act Prod'statement_dangerous'2
        | SWITCH't => Reduce_act Prod'statement_dangerous'2
        | STRUCT't => Reduce_act Prod'statement_dangerous'2
        | STRING_LITERAL't => Reduce_act Prod'statement_dangerous'2
        | STATIC't => Reduce_act Prod'statement_dangerous'2
        | STAR't => Reduce_act Prod'statement_dangerous'2
        | SIZEOF't => Reduce_act Prod'statement_dangerous'2
        | SIGNED't => Reduce_act Prod'statement_dangerous'2
        | SHORT't => Reduce_act Prod'statement_dangerous'2
        | SEMICOLON't => Reduce_act Prod'statement_dangerous'2
        | RETURN't => Reduce_act Prod'statement_dangerous'2
        | RESTRICT't => Reduce_act Prod'statement_dangerous'2
        | REGISTER't => Reduce_act Prod'statement_dangerous'2
        | RBRACE't => Reduce_act Prod'statement_dangerous'2
        | PRAGMA't => Reduce_act Prod'statement_dangerous'2
        | PLUS't => Reduce_act Prod'statement_dangerous'2
        | PACKED't => Reduce_act Prod'statement_dangerous'2
        | OTHER_NAME't => Reduce_act Prod'statement_dangerous'2
        | MINUS't => Reduce_act Prod'statement_dangerous'2
        | LPAREN't => Reduce_act Prod'statement_dangerous'2
        | LONG't => Reduce_act Prod'statement_dangerous'2
        | LBRACE't => Reduce_act Prod'statement_dangerous'2
        | INT't => Reduce_act Prod'statement_dangerous'2
        | INLINE't => Reduce_act Prod'statement_dangerous'2
        | INC't => Reduce_act Prod'statement_dangerous'2
        | IF't => Reduce_act Prod'statement_dangerous'2
        | GOTO't => Reduce_act Prod'statement_dangerous'2
        | FOR't => Reduce_act Prod'statement_dangerous'2
        | FLOAT't => Reduce_act Prod'statement_dangerous'2
        | EXTERN't => Reduce_act Prod'statement_dangerous'2
        | ENUM't => Reduce_act Prod'statement_dangerous'2
        | ELSE't => Reduce_act Prod'statement_safe'2
        | DOUBLE't => Reduce_act Prod'statement_dangerous'2
        | DO't => Reduce_act Prod'statement_dangerous'2
        | DEFAULT't => Reduce_act Prod'statement_dangerous'2
        | DEC't => Reduce_act Prod'statement_dangerous'2
        | CONTINUE't => Reduce_act Prod'statement_dangerous'2
        | CONSTANT't => Reduce_act Prod'statement_dangerous'2
        | CONST't => Reduce_act Prod'statement_dangerous'2
        | CHAR't => Reduce_act Prod'statement_dangerous'2
        | CASE't => Reduce_act Prod'statement_dangerous'2
        | BUILTIN_VA_ARG't => Reduce_act Prod'statement_dangerous'2
        | BREAK't => Reduce_act Prod'statement_dangerous'2
        | BANG't => Reduce_act Prod'statement_dangerous'2
        | AUTO't => Reduce_act Prod'statement_dangerous'2
        | ATTRIBUTE't => Reduce_act Prod'statement_dangerous'2
        | ASM't => Reduce_act Prod'statement_dangerous'2
        | AND't => Reduce_act Prod'statement_dangerous'2
        | ALIGNOF't => Reduce_act Prod'statement_dangerous'2
        | ALIGNAS't => Reduce_act Prod'statement_dangerous'2
        | _ => Fail_act
      end)
    | Ninit Nis'525 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Reduce_act Prod'statement_dangerous'1
        | VOLATILE't => Reduce_act Prod'statement_dangerous'1
        | VOID't => Reduce_act Prod'statement_dangerous'1
        | VAR_NAME't => Reduce_act Prod'statement_dangerous'1
        | UNSIGNED't => Reduce_act Prod'statement_dangerous'1
        | UNION't => Reduce_act Prod'statement_dangerous'1
        | UNDERSCORE_BOOL't => Reduce_act Prod'statement_dangerous'1
        | TYPEDEF_NAME't => Reduce_act Prod'statement_dangerous'1
        | TYPEDEF't => Reduce_act Prod'statement_dangerous'1
        | TILDE't => Reduce_act Prod'statement_dangerous'1
        | SWITCH't => Reduce_act Prod'statement_dangerous'1
        | STRUCT't => Reduce_act Prod'statement_dangerous'1
        | STRING_LITERAL't => Reduce_act Prod'statement_dangerous'1
        | STATIC't => Reduce_act Prod'statement_dangerous'1
        | STAR't => Reduce_act Prod'statement_dangerous'1
        | SIZEOF't => Reduce_act Prod'statement_dangerous'1
        | SIGNED't => Reduce_act Prod'statement_dangerous'1
        | SHORT't => Reduce_act Prod'statement_dangerous'1
        | SEMICOLON't => Reduce_act Prod'statement_dangerous'1
        | RETURN't => Reduce_act Prod'statement_dangerous'1
        | RESTRICT't => Reduce_act Prod'statement_dangerous'1
        | REGISTER't => Reduce_act Prod'statement_dangerous'1
        | RBRACE't => Reduce_act Prod'statement_dangerous'1
        | PRAGMA't => Reduce_act Prod'statement_dangerous'1
        | PLUS't => Reduce_act Prod'statement_dangerous'1
        | PACKED't => Reduce_act Prod'statement_dangerous'1
        | OTHER_NAME't => Reduce_act Prod'statement_dangerous'1
        | MINUS't => Reduce_act Prod'statement_dangerous'1
        | LPAREN't => Reduce_act Prod'statement_dangerous'1
        | LONG't => Reduce_act Prod'statement_dangerous'1
        | LBRACE't => Reduce_act Prod'statement_dangerous'1
        | INT't => Reduce_act Prod'statement_dangerous'1
        | INLINE't => Reduce_act Prod'statement_dangerous'1
        | INC't => Reduce_act Prod'statement_dangerous'1
        | IF't => Reduce_act Prod'statement_dangerous'1
        | GOTO't => Reduce_act Prod'statement_dangerous'1
        | FOR't => Reduce_act Prod'statement_dangerous'1
        | FLOAT't => Reduce_act Prod'statement_dangerous'1
        | EXTERN't => Reduce_act Prod'statement_dangerous'1
        | ENUM't => Reduce_act Prod'statement_dangerous'1
        | ELSE't => Reduce_act Prod'statement_safe'1
        | DOUBLE't => Reduce_act Prod'statement_dangerous'1
        | DO't => Reduce_act Prod'statement_dangerous'1
        | DEFAULT't => Reduce_act Prod'statement_dangerous'1
        | DEC't => Reduce_act Prod'statement_dangerous'1
        | CONTINUE't => Reduce_act Prod'statement_dangerous'1
        | CONSTANT't => Reduce_act Prod'statement_dangerous'1
        | CONST't => Reduce_act Prod'statement_dangerous'1
        | CHAR't => Reduce_act Prod'statement_dangerous'1
        | CASE't => Reduce_act Prod'statement_dangerous'1
        | BUILTIN_VA_ARG't => Reduce_act Prod'statement_dangerous'1
        | BREAK't => Reduce_act Prod'statement_dangerous'1
        | BANG't => Reduce_act Prod'statement_dangerous'1
        | AUTO't => Reduce_act Prod'statement_dangerous'1
        | ATTRIBUTE't => Reduce_act Prod'statement_dangerous'1
        | ASM't => Reduce_act Prod'statement_dangerous'1
        | AND't => Reduce_act Prod'statement_dangerous'1
        | ALIGNOF't => Reduce_act Prod'statement_dangerous'1
        | ALIGNAS't => Reduce_act Prod'statement_dangerous'1
        | _ => Fail_act
      end)
    | Ninit Nis'526 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Reduce_act Prod'statement_dangerous'6
        | VOLATILE't => Reduce_act Prod'statement_dangerous'6
        | VOID't => Reduce_act Prod'statement_dangerous'6
        | VAR_NAME't => Reduce_act Prod'statement_dangerous'6
        | UNSIGNED't => Reduce_act Prod'statement_dangerous'6
        | UNION't => Reduce_act Prod'statement_dangerous'6
        | UNDERSCORE_BOOL't => Reduce_act Prod'statement_dangerous'6
        | TYPEDEF_NAME't => Reduce_act Prod'statement_dangerous'6
        | TYPEDEF't => Reduce_act Prod'statement_dangerous'6
        | TILDE't => Reduce_act Prod'statement_dangerous'6
        | SWITCH't => Reduce_act Prod'statement_dangerous'6
        | STRUCT't => Reduce_act Prod'statement_dangerous'6
        | STRING_LITERAL't => Reduce_act Prod'statement_dangerous'6
        | STATIC't => Reduce_act Prod'statement_dangerous'6
        | STAR't => Reduce_act Prod'statement_dangerous'6
        | SIZEOF't => Reduce_act Prod'statement_dangerous'6
        | SIGNED't => Reduce_act Prod'statement_dangerous'6
        | SHORT't => Reduce_act Prod'statement_dangerous'6
        | SEMICOLON't => Reduce_act Prod'statement_dangerous'6
        | RETURN't => Reduce_act Prod'statement_dangerous'6
        | RESTRICT't => Reduce_act Prod'statement_dangerous'6
        | REGISTER't => Reduce_act Prod'statement_dangerous'6
        | RBRACE't => Reduce_act Prod'statement_dangerous'6
        | PRAGMA't => Reduce_act Prod'statement_dangerous'6
        | PLUS't => Reduce_act Prod'statement_dangerous'6
        | PACKED't => Reduce_act Prod'statement_dangerous'6
        | OTHER_NAME't => Reduce_act Prod'statement_dangerous'6
        | MINUS't => Reduce_act Prod'statement_dangerous'6
        | LPAREN't => Reduce_act Prod'statement_dangerous'6
        | LONG't => Reduce_act Prod'statement_dangerous'6
        | LBRACE't => Reduce_act Prod'statement_dangerous'6
        | INT't => Reduce_act Prod'statement_dangerous'6
        | INLINE't => Reduce_act Prod'statement_dangerous'6
        | INC't => Reduce_act Prod'statement_dangerous'6
        | IF't => Reduce_act Prod'statement_dangerous'6
        | GOTO't => Reduce_act Prod'statement_dangerous'6
        | FOR't => Reduce_act Prod'statement_dangerous'6
        | FLOAT't => Reduce_act Prod'statement_dangerous'6
        | EXTERN't => Reduce_act Prod'statement_dangerous'6
        | ENUM't => Reduce_act Prod'statement_dangerous'6
        | ELSE't => Reduce_act Prod'statement_safe'6
        | DOUBLE't => Reduce_act Prod'statement_dangerous'6
        | DO't => Reduce_act Prod'statement_dangerous'6
        | DEFAULT't => Reduce_act Prod'statement_dangerous'6
        | DEC't => Reduce_act Prod'statement_dangerous'6
        | CONTINUE't => Reduce_act Prod'statement_dangerous'6
        | CONSTANT't => Reduce_act Prod'statement_dangerous'6
        | CONST't => Reduce_act Prod'statement_dangerous'6
        | CHAR't => Reduce_act Prod'statement_dangerous'6
        | CASE't => Reduce_act Prod'statement_dangerous'6
        | BUILTIN_VA_ARG't => Reduce_act Prod'statement_dangerous'6
        | BREAK't => Reduce_act Prod'statement_dangerous'6
        | BANG't => Reduce_act Prod'statement_dangerous'6
        | AUTO't => Reduce_act Prod'statement_dangerous'6
        | ATTRIBUTE't => Reduce_act Prod'statement_dangerous'6
        | ASM't => Reduce_act Prod'statement_dangerous'6
        | AND't => Reduce_act Prod'statement_dangerous'6
        | ALIGNOF't => Reduce_act Prod'statement_dangerous'6
        | ALIGNAS't => Reduce_act Prod'statement_dangerous'6
        | _ => Fail_act
      end)
    | Ninit Nis'527 => Default_reduce_act Prod'labeled_statement_statement_safe_'2
    | Ninit Nis'528 => Default_reduce_act Prod'iteration_statement_statement_safe_'13
    | Ninit Nis'529 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'530 (eq_refl _)
        | COMMA't => Shift_act Nis'132 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'530 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'372 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | SWITCH't => Shift_act Nis'376 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'361 (eq_refl _)
        | RETURN't => Shift_act Nis'362 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'380 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | LBRACE't => Shift_act Nis'352 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | IF't => Shift_act Nis'382 (eq_refl _)
        | GOTO't => Shift_act Nis'386 (eq_refl _)
        | FOR't => Shift_act Nis'389 (eq_refl _)
        | DO't => Shift_act Nis'394 (eq_refl _)
        | DEFAULT't => Shift_act Nis'514 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONTINUE't => Shift_act Nis'403 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | CASE't => Shift_act Nis'516 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BREAK't => Shift_act Nis'408 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | ASM't => Shift_act Nis'410 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'531 => Default_reduce_act Prod'iteration_statement_statement_safe_'7
    | Ninit Nis'532 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Shift_act Nis'533 (eq_refl _)
        | COMMA't => Shift_act Nis'132 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'533 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | RPAREN't => Shift_act Nis'534 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'534 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'372 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | SWITCH't => Shift_act Nis'376 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'361 (eq_refl _)
        | RETURN't => Shift_act Nis'362 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'380 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | LBRACE't => Shift_act Nis'352 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | IF't => Shift_act Nis'382 (eq_refl _)
        | GOTO't => Shift_act Nis'386 (eq_refl _)
        | FOR't => Shift_act Nis'389 (eq_refl _)
        | DO't => Shift_act Nis'394 (eq_refl _)
        | DEFAULT't => Shift_act Nis'514 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONTINUE't => Shift_act Nis'403 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | CASE't => Shift_act Nis'516 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BREAK't => Shift_act Nis'408 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | ASM't => Shift_act Nis'410 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'535 => Default_reduce_act Prod'iteration_statement_statement_safe_'10
    | Ninit Nis'536 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'537 (eq_refl _)
        | COMMA't => Shift_act Nis'132 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'537 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'372 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | SWITCH't => Shift_act Nis'376 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'361 (eq_refl _)
        | RETURN't => Shift_act Nis'362 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'380 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | LBRACE't => Shift_act Nis'352 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | IF't => Shift_act Nis'382 (eq_refl _)
        | GOTO't => Shift_act Nis'386 (eq_refl _)
        | FOR't => Shift_act Nis'389 (eq_refl _)
        | DO't => Shift_act Nis'394 (eq_refl _)
        | DEFAULT't => Shift_act Nis'514 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONTINUE't => Shift_act Nis'403 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | CASE't => Shift_act Nis'516 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BREAK't => Shift_act Nis'408 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | ASM't => Shift_act Nis'410 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'538 => Default_reduce_act Prod'iteration_statement_statement_safe_'4
    | Ninit Nis'539 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Shift_act Nis'540 (eq_refl _)
        | COMMA't => Shift_act Nis'132 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'540 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'541 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'541 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | RPAREN't => Shift_act Nis'542 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'542 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'372 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | SWITCH't => Shift_act Nis'376 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'361 (eq_refl _)
        | RETURN't => Shift_act Nis'362 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'380 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | LBRACE't => Shift_act Nis'352 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | IF't => Shift_act Nis'382 (eq_refl _)
        | GOTO't => Shift_act Nis'386 (eq_refl _)
        | FOR't => Shift_act Nis'389 (eq_refl _)
        | DO't => Shift_act Nis'394 (eq_refl _)
        | DEFAULT't => Shift_act Nis'514 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONTINUE't => Shift_act Nis'403 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | CASE't => Shift_act Nis'516 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BREAK't => Shift_act Nis'408 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | ASM't => Shift_act Nis'410 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'543 => Default_reduce_act Prod'iteration_statement_statement_safe_'11
    | Ninit Nis'544 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'545 (eq_refl _)
        | COMMA't => Shift_act Nis'132 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'545 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'372 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | SWITCH't => Shift_act Nis'376 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'361 (eq_refl _)
        | RETURN't => Shift_act Nis'362 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'380 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | LBRACE't => Shift_act Nis'352 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | IF't => Shift_act Nis'382 (eq_refl _)
        | GOTO't => Shift_act Nis'386 (eq_refl _)
        | FOR't => Shift_act Nis'389 (eq_refl _)
        | DO't => Shift_act Nis'394 (eq_refl _)
        | DEFAULT't => Shift_act Nis'514 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONTINUE't => Shift_act Nis'403 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | CASE't => Shift_act Nis'516 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BREAK't => Shift_act Nis'408 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | ASM't => Shift_act Nis'410 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'546 => Default_reduce_act Prod'iteration_statement_statement_safe_'5
    | Ninit Nis'547 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Shift_act Nis'548 (eq_refl _)
        | COMMA't => Shift_act Nis'132 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'548 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | RPAREN't => Shift_act Nis'549 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'549 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'372 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | SWITCH't => Shift_act Nis'376 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'361 (eq_refl _)
        | RETURN't => Shift_act Nis'362 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'380 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | LBRACE't => Shift_act Nis'352 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | IF't => Shift_act Nis'382 (eq_refl _)
        | GOTO't => Shift_act Nis'386 (eq_refl _)
        | FOR't => Shift_act Nis'389 (eq_refl _)
        | DO't => Shift_act Nis'394 (eq_refl _)
        | DEFAULT't => Shift_act Nis'514 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONTINUE't => Shift_act Nis'403 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | CASE't => Shift_act Nis'516 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BREAK't => Shift_act Nis'408 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | ASM't => Shift_act Nis'410 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'550 => Default_reduce_act Prod'iteration_statement_statement_safe_'8
    | Ninit Nis'551 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'552 (eq_refl _)
        | COMMA't => Shift_act Nis'132 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'552 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'372 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | SWITCH't => Shift_act Nis'376 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'361 (eq_refl _)
        | RETURN't => Shift_act Nis'362 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'380 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | LBRACE't => Shift_act Nis'352 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | IF't => Shift_act Nis'382 (eq_refl _)
        | GOTO't => Shift_act Nis'386 (eq_refl _)
        | FOR't => Shift_act Nis'389 (eq_refl _)
        | DO't => Shift_act Nis'394 (eq_refl _)
        | DEFAULT't => Shift_act Nis'514 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONTINUE't => Shift_act Nis'403 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | CASE't => Shift_act Nis'516 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BREAK't => Shift_act Nis'408 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | ASM't => Shift_act Nis'410 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'553 => Default_reduce_act Prod'iteration_statement_statement_safe_'2
    | Ninit Nis'554 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'555 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'555 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | RPAREN't => Shift_act Nis'556 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'556 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'372 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | SWITCH't => Shift_act Nis'376 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'361 (eq_refl _)
        | RETURN't => Shift_act Nis'362 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'380 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | LBRACE't => Shift_act Nis'352 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | IF't => Shift_act Nis'382 (eq_refl _)
        | GOTO't => Shift_act Nis'386 (eq_refl _)
        | FOR't => Shift_act Nis'389 (eq_refl _)
        | DO't => Shift_act Nis'394 (eq_refl _)
        | DEFAULT't => Shift_act Nis'514 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONTINUE't => Shift_act Nis'403 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | CASE't => Shift_act Nis'516 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BREAK't => Shift_act Nis'408 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | ASM't => Shift_act Nis'410 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'557 => Default_reduce_act Prod'iteration_statement_statement_safe_'12
    | Ninit Nis'558 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'559 (eq_refl _)
        | COMMA't => Shift_act Nis'132 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'559 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'372 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | SWITCH't => Shift_act Nis'376 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'361 (eq_refl _)
        | RETURN't => Shift_act Nis'362 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'380 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | LBRACE't => Shift_act Nis'352 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | IF't => Shift_act Nis'382 (eq_refl _)
        | GOTO't => Shift_act Nis'386 (eq_refl _)
        | FOR't => Shift_act Nis'389 (eq_refl _)
        | DO't => Shift_act Nis'394 (eq_refl _)
        | DEFAULT't => Shift_act Nis'514 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONTINUE't => Shift_act Nis'403 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | CASE't => Shift_act Nis'516 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BREAK't => Shift_act Nis'408 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | ASM't => Shift_act Nis'410 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'560 => Default_reduce_act Prod'iteration_statement_statement_safe_'6
    | Ninit Nis'561 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Shift_act Nis'562 (eq_refl _)
        | COMMA't => Shift_act Nis'132 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'562 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | RPAREN't => Shift_act Nis'563 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'563 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'372 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | SWITCH't => Shift_act Nis'376 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'361 (eq_refl _)
        | RETURN't => Shift_act Nis'362 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'380 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | LBRACE't => Shift_act Nis'352 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | IF't => Shift_act Nis'382 (eq_refl _)
        | GOTO't => Shift_act Nis'386 (eq_refl _)
        | FOR't => Shift_act Nis'389 (eq_refl _)
        | DO't => Shift_act Nis'394 (eq_refl _)
        | DEFAULT't => Shift_act Nis'514 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONTINUE't => Shift_act Nis'403 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | CASE't => Shift_act Nis'516 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BREAK't => Shift_act Nis'408 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | ASM't => Shift_act Nis'410 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'564 => Default_reduce_act Prod'iteration_statement_statement_safe_'9
    | Ninit Nis'565 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | RPAREN't => Shift_act Nis'566 (eq_refl _)
        | COMMA't => Shift_act Nis'132 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'566 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'372 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | SWITCH't => Shift_act Nis'376 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'361 (eq_refl _)
        | RETURN't => Shift_act Nis'362 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'380 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | LBRACE't => Shift_act Nis'352 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | IF't => Shift_act Nis'382 (eq_refl _)
        | GOTO't => Shift_act Nis'386 (eq_refl _)
        | FOR't => Shift_act Nis'389 (eq_refl _)
        | DO't => Shift_act Nis'394 (eq_refl _)
        | DEFAULT't => Shift_act Nis'514 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONTINUE't => Shift_act Nis'403 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | CASE't => Shift_act Nis'516 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BREAK't => Shift_act Nis'408 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | ASM't => Shift_act Nis'410 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'567 => Default_reduce_act Prod'iteration_statement_statement_safe_'3
    | Ninit Nis'568 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | ELSE't => Shift_act Nis'569 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'569 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'372 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | SWITCH't => Shift_act Nis'376 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'361 (eq_refl _)
        | RETURN't => Shift_act Nis'362 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'380 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | LBRACE't => Shift_act Nis'352 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | IF't => Shift_act Nis'382 (eq_refl _)
        | GOTO't => Shift_act Nis'386 (eq_refl _)
        | FOR't => Shift_act Nis'389 (eq_refl _)
        | DO't => Shift_act Nis'394 (eq_refl _)
        | DEFAULT't => Shift_act Nis'514 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONTINUE't => Shift_act Nis'403 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | CASE't => Shift_act Nis'516 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BREAK't => Shift_act Nis'408 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | ASM't => Shift_act Nis'410 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'570 => Default_reduce_act Prod'selection_statement_safe'0
    | Ninit Nis'571 => Default_reduce_act Prod'selection_statement_dangerous'1
    | Ninit Nis'572 => Default_reduce_act Prod'selection_statement_dangerous'0
    | Ninit Nis'573 => Default_reduce_act Prod'labeled_statement_statement_safe_'0
    | Ninit Nis'574 => Default_reduce_act Prod'labeled_statement_statement_dangerous_'0
    | Ninit Nis'575 => Default_reduce_act Prod'selection_statement_safe'1
    | Ninit Nis'576 => Default_reduce_act Prod'selection_statement_dangerous'2
    | Ninit Nis'577 => Default_reduce_act Prod'iteration_statement_statement_safe_'0
    | Ninit Nis'578 => Default_reduce_act Prod'iteration_statement_statement_dangerous_'0
    | Ninit Nis'579 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | ELSE't => Shift_act Nis'580 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'580 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'353 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | SWITCH't => Shift_act Nis'357 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'361 (eq_refl _)
        | RETURN't => Shift_act Nis'362 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'366 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | LBRACE't => Shift_act Nis'352 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | IF't => Shift_act Nis'368 (eq_refl _)
        | GOTO't => Shift_act Nis'386 (eq_refl _)
        | FOR't => Shift_act Nis'395 (eq_refl _)
        | DO't => Shift_act Nis'400 (eq_refl _)
        | DEFAULT't => Shift_act Nis'401 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONTINUE't => Shift_act Nis'403 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | CASE't => Shift_act Nis'405 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BREAK't => Shift_act Nis'408 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | ASM't => Shift_act Nis'410 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'581 => Default_reduce_act Prod'compound_statement'1
    | Ninit Nis'582 => Default_reduce_act Prod'block_item'2
    | Ninit Nis'583 => Default_reduce_act Prod'block_item'1
    | Ninit Nis'584 => Default_reduce_act Prod'block_item'0
    | Ninit Nis'585 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | WHILE't => Shift_act Nis'353 (eq_refl _)
        | VOLATILE't => Shift_act Nis'1 (eq_refl _)
        | VOID't => Shift_act Nis'2 (eq_refl _)
        | VAR_NAME't => Shift_act Nis'18 (eq_refl _)
        | UNSIGNED't => Shift_act Nis'3 (eq_refl _)
        | UNION't => Shift_act Nis'4 (eq_refl _)
        | UNDERSCORE_BOOL't => Shift_act Nis'5 (eq_refl _)
        | TYPEDEF_NAME't => Shift_act Nis'6 (eq_refl _)
        | TYPEDEF't => Shift_act Nis'7 (eq_refl _)
        | TILDE't => Shift_act Nis'19 (eq_refl _)
        | SWITCH't => Shift_act Nis'357 (eq_refl _)
        | STRUCT't => Shift_act Nis'8 (eq_refl _)
        | STRING_LITERAL't => Shift_act Nis'20 (eq_refl _)
        | STATIC't => Shift_act Nis'9 (eq_refl _)
        | STAR't => Shift_act Nis'21 (eq_refl _)
        | SIZEOF't => Shift_act Nis'22 (eq_refl _)
        | SIGNED't => Shift_act Nis'10 (eq_refl _)
        | SHORT't => Shift_act Nis'11 (eq_refl _)
        | SEMICOLON't => Shift_act Nis'361 (eq_refl _)
        | RETURN't => Shift_act Nis'362 (eq_refl _)
        | RESTRICT't => Shift_act Nis'13 (eq_refl _)
        | REGISTER't => Shift_act Nis'14 (eq_refl _)
        | RBRACE't => Shift_act Nis'586 (eq_refl _)
        | PRAGMA't => Shift_act Nis'582 (eq_refl _)
        | PLUS't => Shift_act Nis'23 (eq_refl _)
        | PACKED't => Shift_act Nis'16 (eq_refl _)
        | OTHER_NAME't => Shift_act Nis'366 (eq_refl _)
        | MINUS't => Shift_act Nis'24 (eq_refl _)
        | LPAREN't => Shift_act Nis'26 (eq_refl _)
        | LONG't => Shift_act Nis'27 (eq_refl _)
        | LBRACE't => Shift_act Nis'352 (eq_refl _)
        | INT't => Shift_act Nis'28 (eq_refl _)
        | INLINE't => Shift_act Nis'189 (eq_refl _)
        | INC't => Shift_act Nis'29 (eq_refl _)
        | IF't => Shift_act Nis'368 (eq_refl _)
        | GOTO't => Shift_act Nis'386 (eq_refl _)
        | FOR't => Shift_act Nis'395 (eq_refl _)
        | FLOAT't => Shift_act Nis'31 (eq_refl _)
        | EXTERN't => Shift_act Nis'190 (eq_refl _)
        | ENUM't => Shift_act Nis'32 (eq_refl _)
        | DOUBLE't => Shift_act Nis'52 (eq_refl _)
        | DO't => Shift_act Nis'400 (eq_refl _)
        | DEFAULT't => Shift_act Nis'401 (eq_refl _)
        | DEC't => Shift_act Nis'44 (eq_refl _)
        | CONTINUE't => Shift_act Nis'403 (eq_refl _)
        | CONSTANT't => Shift_act Nis'45 (eq_refl _)
        | CONST't => Shift_act Nis'53 (eq_refl _)
        | CHAR't => Shift_act Nis'54 (eq_refl _)
        | CASE't => Shift_act Nis'405 (eq_refl _)
        | BUILTIN_VA_ARG't => Shift_act Nis'46 (eq_refl _)
        | BREAK't => Shift_act Nis'408 (eq_refl _)
        | BANG't => Shift_act Nis'48 (eq_refl _)
        | AUTO't => Shift_act Nis'191 (eq_refl _)
        | ATTRIBUTE't => Shift_act Nis'55 (eq_refl _)
        | ASM't => Shift_act Nis'410 (eq_refl _)
        | AND't => Shift_act Nis'49 (eq_refl _)
        | ALIGNOF't => Shift_act Nis'50 (eq_refl _)
        | ALIGNAS't => Shift_act Nis'162 (eq_refl _)
        | _ => Fail_act
      end)
    | Ninit Nis'586 => Default_reduce_act Prod'compound_statement'0
    | Ninit Nis'587 => Default_reduce_act Prod'block_item_list'1
    | Ninit Nis'588 => Default_reduce_act Prod'block_item_list'0
    | Ninit Nis'589 => Default_reduce_act Prod'declaration_list'1
    | Ninit Nis'590 => Default_reduce_act Prod'function_definition'1
    | Ninit Nis'591 => Default_reduce_act Prod'old_function_declarator'0
    | Ninit Nis'592 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Reduce_act Prod'attribute_specifier_list'0
        | PACKED't => Reduce_act Prod'attribute_specifier_list'0
        | LPAREN't => Shift_act Nis'344 (eq_refl _)
        | LBRACK't => Shift_act Nis'236 (eq_refl _)
        | LBRACE't => Reduce_act Prod'attribute_specifier_list'0
        | EQ't => Reduce_act Prod'attribute_specifier_list'0
        | COMMA't => Reduce_act Prod'attribute_specifier_list'0
        | ATTRIBUTE't => Reduce_act Prod'attribute_specifier_list'0
        | ALIGNAS't => Reduce_act Prod'attribute_specifier_list'0
        | _ => Fail_act
      end)
    | Ninit Nis'593 => Lookahead_act (fun terminal:terminal =>
      match terminal return lookahead_action terminal with
        | SEMICOLON't => Reduce_act Prod'init_declarator'0
        | LBRACE't => Shift_act Nis'352 (eq_refl _)
        | EQ't => Shift_act Nis'491 (eq_refl _)
        | COMMA't => Reduce_act Prod'init_declarator'0
        | _ => Fail_act
      end)
    | Ninit Nis'594 => Default_reduce_act Prod'function_definition'0
    | Ninit Nis'595 => Default_reduce_act Prod'external_declaration'1
    | Ninit Nis'596 => Default_reduce_act Prod'translation_unit'0
  end.

Definition goto_table (state:state) (nt:nonterminal) :=
  match state, nt return option { s:noninitstate | NT nt = last_symb_of_non_init_state s } with
    | Init Init'0, type_specifier'nt => Some (exist _ Nis'192 (eq_refl _))
    | Init Init'0, type_qualifier'nt => Some (exist _ Nis'193 (eq_refl _))
    | Init Init'0, translation_unit_file'nt => None    | Init Init'0, translation_unit'nt => Some (exist _ Nis'334 (eq_refl _))
    | Init Init'0, struct_or_union_specifier'nt => Some (exist _ Nis'166 (eq_refl _))
    | Init Init'0, struct_or_union'nt => Some (exist _ Nis'167 (eq_refl _))
    | Init Init'0, storage_class_specifier'nt => Some (exist _ Nis'194 (eq_refl _))
    | Init Init'0, function_specifier'nt => Some (exist _ Nis'195 (eq_refl _))
    | Init Init'0, function_definition'nt => Some (exist _ Nis'337 (eq_refl _))
    | Init Init'0, external_declaration'nt => Some (exist _ Nis'596 (eq_refl _))
    | Init Init'0, enum_specifier'nt => Some (exist _ Nis'196 (eq_refl _))
    | Init Init'0, declaration_specifiers'nt => Some (exist _ Nis'339 (eq_refl _))
    | Init Init'0, declaration'nt => Some (exist _ Nis'595 (eq_refl _))
    | Init Init'0, attribute_specifier'nt => Some (exist _ Nis'180 (eq_refl _))
    | Ninit Nis'17, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'17, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'17, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'17, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'17, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'17, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'17, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'17, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'17, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'17, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'17, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'17, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'17, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'17, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'17, assignment_expression'nt => Some (exist _ Nis'141 (eq_refl _))
    | Ninit Nis'17, argument_expression_list'nt => Some (exist _ Nis'330 (eq_refl _))
    | Ninit Nis'17, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'17, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'22, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'22, unary_expression'nt => Some (exist _ Nis'329 (eq_refl _))
    | Ninit Nis'22, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'22, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'25, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'25, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'25, type_specifier'nt => Some (exist _ Nis'164 (eq_refl _))
    | Ninit Nis'25, type_qualifier'nt => Some (exist _ Nis'165 (eq_refl _))
    | Ninit Nis'25, type_name'nt => Some (exist _ Nis'327 (eq_refl _))
    | Ninit Nis'25, struct_or_union_specifier'nt => Some (exist _ Nis'166 (eq_refl _))
    | Ninit Nis'25, struct_or_union'nt => Some (exist _ Nis'167 (eq_refl _))
    | Ninit Nis'25, specifier_qualifier_list'nt => Some (exist _ Nis'272 (eq_refl _))
    | Ninit Nis'25, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'25, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'25, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'25, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'25, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'25, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'25, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'25, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'25, expression'nt => Some (exist _ Nis'306 (eq_refl _))
    | Ninit Nis'25, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'25, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'25, enum_specifier'nt => Some (exist _ Nis'196 (eq_refl _))
    | Ninit Nis'25, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'25, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'25, attribute_specifier'nt => Some (exist _ Nis'180 (eq_refl _))
    | Ninit Nis'25, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'25, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'25, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'26, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'26, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'26, type_specifier'nt => Some (exist _ Nis'164 (eq_refl _))
    | Ninit Nis'26, type_qualifier'nt => Some (exist _ Nis'165 (eq_refl _))
    | Ninit Nis'26, type_name'nt => Some (exist _ Nis'324 (eq_refl _))
    | Ninit Nis'26, struct_or_union_specifier'nt => Some (exist _ Nis'166 (eq_refl _))
    | Ninit Nis'26, struct_or_union'nt => Some (exist _ Nis'167 (eq_refl _))
    | Ninit Nis'26, specifier_qualifier_list'nt => Some (exist _ Nis'272 (eq_refl _))
    | Ninit Nis'26, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'26, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'26, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'26, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'26, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'26, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'26, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'26, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'26, expression'nt => Some (exist _ Nis'306 (eq_refl _))
    | Ninit Nis'26, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'26, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'26, enum_specifier'nt => Some (exist _ Nis'196 (eq_refl _))
    | Ninit Nis'26, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'26, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'26, attribute_specifier'nt => Some (exist _ Nis'180 (eq_refl _))
    | Ninit Nis'26, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'26, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'26, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'29, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'29, unary_expression'nt => Some (exist _ Nis'323 (eq_refl _))
    | Ninit Nis'29, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'29, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'30, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'30, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'30, type_specifier'nt => Some (exist _ Nis'164 (eq_refl _))
    | Ninit Nis'30, type_qualifier'nt => Some (exist _ Nis'165 (eq_refl _))
    | Ninit Nis'30, type_name'nt => Some (exist _ Nis'321 (eq_refl _))
    | Ninit Nis'30, struct_or_union_specifier'nt => Some (exist _ Nis'166 (eq_refl _))
    | Ninit Nis'30, struct_or_union'nt => Some (exist _ Nis'167 (eq_refl _))
    | Ninit Nis'30, specifier_qualifier_list'nt => Some (exist _ Nis'272 (eq_refl _))
    | Ninit Nis'30, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'30, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'30, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'30, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'30, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'30, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'30, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'30, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'30, expression'nt => Some (exist _ Nis'306 (eq_refl _))
    | Ninit Nis'30, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'30, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'30, enum_specifier'nt => Some (exist _ Nis'196 (eq_refl _))
    | Ninit Nis'30, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'30, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'30, attribute_specifier'nt => Some (exist _ Nis'180 (eq_refl _))
    | Ninit Nis'30, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'30, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'30, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'32, attribute_specifier_list'nt => Some (exist _ Nis'33 (eq_refl _))
    | Ninit Nis'33, attribute_specifier'nt => Some (exist _ Nis'245 (eq_refl _))
    | Ninit Nis'35, enumerator_list'nt => Some (exist _ Nis'37 (eq_refl _))
    | Ninit Nis'35, enumerator'nt => Some (exist _ Nis'315 (eq_refl _))
    | Ninit Nis'35, enumeration_constant'nt => Some (exist _ Nis'42 (eq_refl _))
    | Ninit Nis'39, enumerator'nt => Some (exist _ Nis'41 (eq_refl _))
    | Ninit Nis'39, enumeration_constant'nt => Some (exist _ Nis'42 (eq_refl _))
    | Ninit Nis'43, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'43, unary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'43, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'43, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'43, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'43, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'43, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'43, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'43, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'43, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'43, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'43, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'43, constant_expression'nt => Some (exist _ Nis'314 (eq_refl _))
    | Ninit Nis'43, conditional_expression'nt => Some (exist _ Nis'256 (eq_refl _))
    | Ninit Nis'43, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'43, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'43, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'44, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'44, unary_expression'nt => Some (exist _ Nis'313 (eq_refl _))
    | Ninit Nis'44, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'44, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'47, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'47, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'47, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'47, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'47, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'47, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'47, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'47, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'47, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'47, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'47, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'47, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'47, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'47, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'47, assignment_expression'nt => Some (exist _ Nis'309 (eq_refl _))
    | Ninit Nis'47, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'47, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'50, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'50, unary_expression'nt => Some (exist _ Nis'308 (eq_refl _))
    | Ninit Nis'50, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'50, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'51, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'51, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'51, type_specifier'nt => Some (exist _ Nis'164 (eq_refl _))
    | Ninit Nis'51, type_qualifier'nt => Some (exist _ Nis'165 (eq_refl _))
    | Ninit Nis'51, type_name'nt => Some (exist _ Nis'278 (eq_refl _))
    | Ninit Nis'51, struct_or_union_specifier'nt => Some (exist _ Nis'166 (eq_refl _))
    | Ninit Nis'51, struct_or_union'nt => Some (exist _ Nis'167 (eq_refl _))
    | Ninit Nis'51, specifier_qualifier_list'nt => Some (exist _ Nis'272 (eq_refl _))
    | Ninit Nis'51, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'51, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'51, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'51, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'51, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'51, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'51, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'51, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'51, expression'nt => Some (exist _ Nis'306 (eq_refl _))
    | Ninit Nis'51, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'51, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'51, enum_specifier'nt => Some (exist _ Nis'196 (eq_refl _))
    | Ninit Nis'51, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'51, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'51, attribute_specifier'nt => Some (exist _ Nis'180 (eq_refl _))
    | Ninit Nis'51, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'51, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'51, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'57, gcc_attribute_word'nt => Some (exist _ Nis'61 (eq_refl _))
    | Ninit Nis'57, gcc_attribute_list'nt => Some (exist _ Nis'156 (eq_refl _))
    | Ninit Nis'57, gcc_attribute'nt => Some (exist _ Nis'161 (eq_refl _))
    | Ninit Nis'62, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'62, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'62, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'62, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'62, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'62, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'62, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'62, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'62, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'62, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'62, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'62, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'62, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'62, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'62, assignment_expression'nt => Some (exist _ Nis'141 (eq_refl _))
    | Ninit Nis'62, argument_expression_list'nt => Some (exist _ Nis'154 (eq_refl _))
    | Ninit Nis'62, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'62, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'64, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'64, unary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'64, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'64, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'64, cast_expression'nt => Some (exist _ Nis'153 (eq_refl _))
    | Ninit Nis'70, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'70, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'70, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'70, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'70, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'70, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'70, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'70, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'70, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'70, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'70, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'70, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'70, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'70, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'70, assignment_expression'nt => Some (exist _ Nis'141 (eq_refl _))
    | Ninit Nis'70, argument_expression_list'nt => Some (exist _ Nis'142 (eq_refl _))
    | Ninit Nis'70, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'70, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'72, assignment_operator'nt => Some (exist _ Nis'84 (eq_refl _))
    | Ninit Nis'84, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'84, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'84, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'84, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'84, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'84, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'84, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'84, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'84, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'84, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'84, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'84, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'84, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'84, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'84, assignment_expression'nt => Some (exist _ Nis'140 (eq_refl _))
    | Ninit Nis'84, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'84, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'86, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'86, unary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'86, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'86, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'86, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'86, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'86, additive_expression'nt => Some (exist _ Nis'95 (eq_refl _))
    | Ninit Nis'88, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'88, unary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'88, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'88, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'88, cast_expression'nt => Some (exist _ Nis'89 (eq_refl _))
    | Ninit Nis'90, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'90, unary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'90, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'90, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'90, cast_expression'nt => Some (exist _ Nis'91 (eq_refl _))
    | Ninit Nis'92, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'92, unary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'92, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'92, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'92, cast_expression'nt => Some (exist _ Nis'93 (eq_refl _))
    | Ninit Nis'96, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'96, unary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'96, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'96, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'96, multiplicative_expression'nt => Some (exist _ Nis'97 (eq_refl _))
    | Ninit Nis'96, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'98, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'98, unary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'98, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'98, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'98, multiplicative_expression'nt => Some (exist _ Nis'99 (eq_refl _))
    | Ninit Nis'98, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'100, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'100, unary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'100, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'100, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'100, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'100, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'100, additive_expression'nt => Some (exist _ Nis'101 (eq_refl _))
    | Ninit Nis'103, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'103, unary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'103, shift_expression'nt => Some (exist _ Nis'104 (eq_refl _))
    | Ninit Nis'103, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'103, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'103, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'103, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'103, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'106, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'106, unary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'106, shift_expression'nt => Some (exist _ Nis'107 (eq_refl _))
    | Ninit Nis'106, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'106, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'106, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'106, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'106, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'108, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'108, unary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'108, shift_expression'nt => Some (exist _ Nis'109 (eq_refl _))
    | Ninit Nis'108, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'108, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'108, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'108, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'108, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'110, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'110, unary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'110, shift_expression'nt => Some (exist _ Nis'111 (eq_refl _))
    | Ninit Nis'110, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'110, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'110, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'110, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'110, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'113, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'113, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'113, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'113, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'113, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'113, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'113, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'113, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'113, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'113, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'113, expression'nt => Some (exist _ Nis'131 (eq_refl _))
    | Ninit Nis'113, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'113, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'113, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'113, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'113, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'113, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'113, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'115, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'115, unary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'115, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'115, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'115, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'115, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'115, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'115, inclusive_OR_expression'nt => Some (exist _ Nis'116 (eq_refl _))
    | Ninit Nis'115, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'115, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'115, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'115, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'115, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'117, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'117, unary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'117, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'117, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'117, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'117, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'117, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'117, exclusive_OR_expression'nt => Some (exist _ Nis'118 (eq_refl _))
    | Ninit Nis'117, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'117, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'117, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'117, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'119, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'119, unary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'119, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'119, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'119, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'119, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'119, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'119, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'119, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'119, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'119, AND_expression'nt => Some (exist _ Nis'125 (eq_refl _))
    | Ninit Nis'121, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'121, unary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'121, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'121, relational_expression'nt => Some (exist _ Nis'122 (eq_refl _))
    | Ninit Nis'121, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'121, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'121, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'121, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'121, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'123, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'123, unary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'123, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'123, relational_expression'nt => Some (exist _ Nis'124 (eq_refl _))
    | Ninit Nis'123, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'123, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'123, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'123, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'123, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'126, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'126, unary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'126, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'126, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'126, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'126, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'126, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'126, equality_expression'nt => Some (exist _ Nis'127 (eq_refl _))
    | Ninit Nis'126, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'126, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'132, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'132, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'132, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'132, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'132, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'132, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'132, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'132, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'132, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'132, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'132, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'132, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'132, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'132, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'132, assignment_expression'nt => Some (exist _ Nis'134 (eq_refl _))
    | Ninit Nis'132, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'132, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'135, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'135, unary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'135, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'135, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'135, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'135, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'135, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'135, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'135, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'135, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'135, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'135, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'135, conditional_expression'nt => Some (exist _ Nis'136 (eq_refl _))
    | Ninit Nis'135, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'135, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'135, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'138, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'138, unary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'138, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'138, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'138, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'138, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'138, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'138, logical_AND_expression'nt => Some (exist _ Nis'139 (eq_refl _))
    | Ninit Nis'138, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'138, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'138, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'138, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'138, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'138, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'144, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'144, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'144, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'144, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'144, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'144, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'144, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'144, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'144, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'144, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'144, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'144, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'144, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'144, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'144, assignment_expression'nt => Some (exist _ Nis'145 (eq_refl _))
    | Ninit Nis'144, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'144, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'146, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'146, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'146, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'146, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'146, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'146, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'146, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'146, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'146, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'146, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'146, expression'nt => Some (exist _ Nis'147 (eq_refl _))
    | Ninit Nis'146, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'146, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'146, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'146, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'146, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'146, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'146, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'159, gcc_attribute_word'nt => Some (exist _ Nis'61 (eq_refl _))
    | Ninit Nis'159, gcc_attribute'nt => Some (exist _ Nis'160 (eq_refl _))
    | Ninit Nis'163, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'163, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'163, type_specifier'nt => Some (exist _ Nis'164 (eq_refl _))
    | Ninit Nis'163, type_qualifier'nt => Some (exist _ Nis'165 (eq_refl _))
    | Ninit Nis'163, type_name'nt => Some (exist _ Nis'270 (eq_refl _))
    | Ninit Nis'163, struct_or_union_specifier'nt => Some (exist _ Nis'166 (eq_refl _))
    | Ninit Nis'163, struct_or_union'nt => Some (exist _ Nis'167 (eq_refl _))
    | Ninit Nis'163, specifier_qualifier_list'nt => Some (exist _ Nis'272 (eq_refl _))
    | Ninit Nis'163, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'163, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'163, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'163, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'163, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'163, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'163, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'163, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'163, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'163, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'163, enum_specifier'nt => Some (exist _ Nis'196 (eq_refl _))
    | Ninit Nis'163, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'163, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'163, attribute_specifier'nt => Some (exist _ Nis'180 (eq_refl _))
    | Ninit Nis'163, assignment_expression'nt => Some (exist _ Nis'141 (eq_refl _))
    | Ninit Nis'163, argument_expression_list'nt => Some (exist _ Nis'276 (eq_refl _))
    | Ninit Nis'163, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'163, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'164, type_specifier'nt => Some (exist _ Nis'164 (eq_refl _))
    | Ninit Nis'164, type_qualifier'nt => Some (exist _ Nis'165 (eq_refl _))
    | Ninit Nis'164, struct_or_union_specifier'nt => Some (exist _ Nis'166 (eq_refl _))
    | Ninit Nis'164, struct_or_union'nt => Some (exist _ Nis'167 (eq_refl _))
    | Ninit Nis'164, specifier_qualifier_list'nt => Some (exist _ Nis'269 (eq_refl _))
    | Ninit Nis'164, enum_specifier'nt => Some (exist _ Nis'196 (eq_refl _))
    | Ninit Nis'164, attribute_specifier'nt => Some (exist _ Nis'180 (eq_refl _))
    | Ninit Nis'165, type_specifier'nt => Some (exist _ Nis'164 (eq_refl _))
    | Ninit Nis'165, type_qualifier'nt => Some (exist _ Nis'165 (eq_refl _))
    | Ninit Nis'165, struct_or_union_specifier'nt => Some (exist _ Nis'166 (eq_refl _))
    | Ninit Nis'165, struct_or_union'nt => Some (exist _ Nis'167 (eq_refl _))
    | Ninit Nis'165, specifier_qualifier_list'nt => Some (exist _ Nis'268 (eq_refl _))
    | Ninit Nis'165, enum_specifier'nt => Some (exist _ Nis'196 (eq_refl _))
    | Ninit Nis'165, attribute_specifier'nt => Some (exist _ Nis'180 (eq_refl _))
    | Ninit Nis'167, attribute_specifier_list'nt => Some (exist _ Nis'168 (eq_refl _))
    | Ninit Nis'168, attribute_specifier'nt => Some (exist _ Nis'245 (eq_refl _))
    | Ninit Nis'170, struct_declaration_list'nt => Some (exist _ Nis'171 (eq_refl _))
    | Ninit Nis'171, type_specifier'nt => Some (exist _ Nis'164 (eq_refl _))
    | Ninit Nis'171, type_qualifier'nt => Some (exist _ Nis'165 (eq_refl _))
    | Ninit Nis'171, struct_or_union_specifier'nt => Some (exist _ Nis'166 (eq_refl _))
    | Ninit Nis'171, struct_or_union'nt => Some (exist _ Nis'167 (eq_refl _))
    | Ninit Nis'171, struct_declaration'nt => Some (exist _ Nis'173 (eq_refl _))
    | Ninit Nis'171, specifier_qualifier_list'nt => Some (exist _ Nis'174 (eq_refl _))
    | Ninit Nis'171, enum_specifier'nt => Some (exist _ Nis'196 (eq_refl _))
    | Ninit Nis'171, attribute_specifier'nt => Some (exist _ Nis'180 (eq_refl _))
    | Ninit Nis'174, struct_declarator_list'nt => Some (exist _ Nis'257 (eq_refl _))
    | Ninit Nis'174, struct_declarator'nt => Some (exist _ Nis'264 (eq_refl _))
    | Ninit Nis'174, pointer'nt => Some (exist _ Nis'185 (eq_refl _))
    | Ninit Nis'174, direct_declarator'nt => Some (exist _ Nis'235 (eq_refl _))
    | Ninit Nis'174, declarator'nt => Some (exist _ Nis'261 (eq_refl _))
    | Ninit Nis'176, type_qualifier_list'nt => Some (exist _ Nis'177 (eq_refl _))
    | Ninit Nis'176, type_qualifier'nt => Some (exist _ Nis'181 (eq_refl _))
    | Ninit Nis'176, pointer'nt => Some (exist _ Nis'182 (eq_refl _))
    | Ninit Nis'176, attribute_specifier'nt => Some (exist _ Nis'180 (eq_refl _))
    | Ninit Nis'177, type_qualifier'nt => Some (exist _ Nis'178 (eq_refl _))
    | Ninit Nis'177, pointer'nt => Some (exist _ Nis'179 (eq_refl _))
    | Ninit Nis'177, attribute_specifier'nt => Some (exist _ Nis'180 (eq_refl _))
    | Ninit Nis'184, pointer'nt => Some (exist _ Nis'185 (eq_refl _))
    | Ninit Nis'184, direct_declarator'nt => Some (exist _ Nis'235 (eq_refl _))
    | Ninit Nis'184, declarator'nt => Some (exist _ Nis'247 (eq_refl _))
    | Ninit Nis'185, direct_declarator'nt => Some (exist _ Nis'186 (eq_refl _))
    | Ninit Nis'186, attribute_specifier_list'nt => Some (exist _ Nis'253 (eq_refl _))
    | Ninit Nis'187, type_specifier'nt => Some (exist _ Nis'192 (eq_refl _))
    | Ninit Nis'187, type_qualifier'nt => Some (exist _ Nis'193 (eq_refl _))
    | Ninit Nis'187, struct_or_union_specifier'nt => Some (exist _ Nis'166 (eq_refl _))
    | Ninit Nis'187, struct_or_union'nt => Some (exist _ Nis'167 (eq_refl _))
    | Ninit Nis'187, storage_class_specifier'nt => Some (exist _ Nis'194 (eq_refl _))
    | Ninit Nis'187, parameter_type_list'nt => Some (exist _ Nis'201 (eq_refl _))
    | Ninit Nis'187, parameter_list'nt => Some (exist _ Nis'203 (eq_refl _))
    | Ninit Nis'187, parameter_declaration'nt => Some (exist _ Nis'224 (eq_refl _))
    | Ninit Nis'187, function_specifier'nt => Some (exist _ Nis'195 (eq_refl _))
    | Ninit Nis'187, enum_specifier'nt => Some (exist _ Nis'196 (eq_refl _))
    | Ninit Nis'187, declaration_specifiers'nt => Some (exist _ Nis'207 (eq_refl _))
    | Ninit Nis'187, attribute_specifier'nt => Some (exist _ Nis'180 (eq_refl _))
    | Ninit Nis'192, type_specifier'nt => Some (exist _ Nis'192 (eq_refl _))
    | Ninit Nis'192, type_qualifier'nt => Some (exist _ Nis'193 (eq_refl _))
    | Ninit Nis'192, struct_or_union_specifier'nt => Some (exist _ Nis'166 (eq_refl _))
    | Ninit Nis'192, struct_or_union'nt => Some (exist _ Nis'167 (eq_refl _))
    | Ninit Nis'192, storage_class_specifier'nt => Some (exist _ Nis'194 (eq_refl _))
    | Ninit Nis'192, function_specifier'nt => Some (exist _ Nis'195 (eq_refl _))
    | Ninit Nis'192, enum_specifier'nt => Some (exist _ Nis'196 (eq_refl _))
    | Ninit Nis'192, declaration_specifiers'nt => Some (exist _ Nis'200 (eq_refl _))
    | Ninit Nis'192, attribute_specifier'nt => Some (exist _ Nis'180 (eq_refl _))
    | Ninit Nis'193, type_specifier'nt => Some (exist _ Nis'192 (eq_refl _))
    | Ninit Nis'193, type_qualifier'nt => Some (exist _ Nis'193 (eq_refl _))
    | Ninit Nis'193, struct_or_union_specifier'nt => Some (exist _ Nis'166 (eq_refl _))
    | Ninit Nis'193, struct_or_union'nt => Some (exist _ Nis'167 (eq_refl _))
    | Ninit Nis'193, storage_class_specifier'nt => Some (exist _ Nis'194 (eq_refl _))
    | Ninit Nis'193, function_specifier'nt => Some (exist _ Nis'195 (eq_refl _))
    | Ninit Nis'193, enum_specifier'nt => Some (exist _ Nis'196 (eq_refl _))
    | Ninit Nis'193, declaration_specifiers'nt => Some (exist _ Nis'199 (eq_refl _))
    | Ninit Nis'193, attribute_specifier'nt => Some (exist _ Nis'180 (eq_refl _))
    | Ninit Nis'194, type_specifier'nt => Some (exist _ Nis'192 (eq_refl _))
    | Ninit Nis'194, type_qualifier'nt => Some (exist _ Nis'193 (eq_refl _))
    | Ninit Nis'194, struct_or_union_specifier'nt => Some (exist _ Nis'166 (eq_refl _))
    | Ninit Nis'194, struct_or_union'nt => Some (exist _ Nis'167 (eq_refl _))
    | Ninit Nis'194, storage_class_specifier'nt => Some (exist _ Nis'194 (eq_refl _))
    | Ninit Nis'194, function_specifier'nt => Some (exist _ Nis'195 (eq_refl _))
    | Ninit Nis'194, enum_specifier'nt => Some (exist _ Nis'196 (eq_refl _))
    | Ninit Nis'194, declaration_specifiers'nt => Some (exist _ Nis'198 (eq_refl _))
    | Ninit Nis'194, attribute_specifier'nt => Some (exist _ Nis'180 (eq_refl _))
    | Ninit Nis'195, type_specifier'nt => Some (exist _ Nis'192 (eq_refl _))
    | Ninit Nis'195, type_qualifier'nt => Some (exist _ Nis'193 (eq_refl _))
    | Ninit Nis'195, struct_or_union_specifier'nt => Some (exist _ Nis'166 (eq_refl _))
    | Ninit Nis'195, struct_or_union'nt => Some (exist _ Nis'167 (eq_refl _))
    | Ninit Nis'195, storage_class_specifier'nt => Some (exist _ Nis'194 (eq_refl _))
    | Ninit Nis'195, function_specifier'nt => Some (exist _ Nis'195 (eq_refl _))
    | Ninit Nis'195, enum_specifier'nt => Some (exist _ Nis'196 (eq_refl _))
    | Ninit Nis'195, declaration_specifiers'nt => Some (exist _ Nis'197 (eq_refl _))
    | Ninit Nis'195, attribute_specifier'nt => Some (exist _ Nis'180 (eq_refl _))
    | Ninit Nis'204, type_specifier'nt => Some (exist _ Nis'192 (eq_refl _))
    | Ninit Nis'204, type_qualifier'nt => Some (exist _ Nis'193 (eq_refl _))
    | Ninit Nis'204, struct_or_union_specifier'nt => Some (exist _ Nis'166 (eq_refl _))
    | Ninit Nis'204, struct_or_union'nt => Some (exist _ Nis'167 (eq_refl _))
    | Ninit Nis'204, storage_class_specifier'nt => Some (exist _ Nis'194 (eq_refl _))
    | Ninit Nis'204, parameter_declaration'nt => Some (exist _ Nis'206 (eq_refl _))
    | Ninit Nis'204, function_specifier'nt => Some (exist _ Nis'195 (eq_refl _))
    | Ninit Nis'204, enum_specifier'nt => Some (exist _ Nis'196 (eq_refl _))
    | Ninit Nis'204, declaration_specifiers'nt => Some (exist _ Nis'207 (eq_refl _))
    | Ninit Nis'204, attribute_specifier'nt => Some (exist _ Nis'180 (eq_refl _))
    | Ninit Nis'207, pointer'nt => Some (exist _ Nis'218 (eq_refl _))
    | Ninit Nis'207, direct_declarator'nt => Some (exist _ Nis'235 (eq_refl _))
    | Ninit Nis'207, direct_abstract_declarator'nt => Some (exist _ Nis'246 (eq_refl _))
    | Ninit Nis'207, declarator'nt => Some (exist _ Nis'251 (eq_refl _))
    | Ninit Nis'207, abstract_declarator'nt => Some (exist _ Nis'252 (eq_refl _))
    | Ninit Nis'208, type_specifier'nt => Some (exist _ Nis'192 (eq_refl _))
    | Ninit Nis'208, type_qualifier'nt => Some (exist _ Nis'193 (eq_refl _))
    | Ninit Nis'208, struct_or_union_specifier'nt => Some (exist _ Nis'166 (eq_refl _))
    | Ninit Nis'208, struct_or_union'nt => Some (exist _ Nis'167 (eq_refl _))
    | Ninit Nis'208, storage_class_specifier'nt => Some (exist _ Nis'194 (eq_refl _))
    | Ninit Nis'208, pointer'nt => Some (exist _ Nis'218 (eq_refl _))
    | Ninit Nis'208, parameter_type_list'nt => Some (exist _ Nis'233 (eq_refl _))
    | Ninit Nis'208, parameter_list'nt => Some (exist _ Nis'203 (eq_refl _))
    | Ninit Nis'208, parameter_declaration'nt => Some (exist _ Nis'224 (eq_refl _))
    | Ninit Nis'208, function_specifier'nt => Some (exist _ Nis'195 (eq_refl _))
    | Ninit Nis'208, enum_specifier'nt => Some (exist _ Nis'196 (eq_refl _))
    | Ninit Nis'208, direct_declarator'nt => Some (exist _ Nis'235 (eq_refl _))
    | Ninit Nis'208, direct_abstract_declarator'nt => Some (exist _ Nis'246 (eq_refl _))
    | Ninit Nis'208, declarator'nt => Some (exist _ Nis'247 (eq_refl _))
    | Ninit Nis'208, declaration_specifiers'nt => Some (exist _ Nis'207 (eq_refl _))
    | Ninit Nis'208, attribute_specifier'nt => Some (exist _ Nis'180 (eq_refl _))
    | Ninit Nis'208, abstract_declarator'nt => Some (exist _ Nis'249 (eq_refl _))
    | Ninit Nis'210, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'210, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'210, type_qualifier_list'nt => Some (exist _ Nis'212 (eq_refl _))
    | Ninit Nis'210, type_qualifier'nt => Some (exist _ Nis'181 (eq_refl _))
    | Ninit Nis'210, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'210, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'210, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'210, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'210, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'210, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'210, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'210, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'210, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'210, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'210, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'210, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'210, attribute_specifier'nt => Some (exist _ Nis'180 (eq_refl _))
    | Ninit Nis'210, assignment_expression'nt => Some (exist _ Nis'216 (eq_refl _))
    | Ninit Nis'210, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'210, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'212, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'212, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'212, type_qualifier'nt => Some (exist _ Nis'178 (eq_refl _))
    | Ninit Nis'212, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'212, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'212, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'212, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'212, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'212, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'212, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'212, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'212, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'212, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'212, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'212, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'212, attribute_specifier'nt => Some (exist _ Nis'180 (eq_refl _))
    | Ninit Nis'212, assignment_expression'nt => Some (exist _ Nis'214 (eq_refl _))
    | Ninit Nis'212, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'212, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'218, direct_declarator'nt => Some (exist _ Nis'186 (eq_refl _))
    | Ninit Nis'218, direct_abstract_declarator'nt => Some (exist _ Nis'219 (eq_refl _))
    | Ninit Nis'220, type_specifier'nt => Some (exist _ Nis'192 (eq_refl _))
    | Ninit Nis'220, type_qualifier'nt => Some (exist _ Nis'193 (eq_refl _))
    | Ninit Nis'220, struct_or_union_specifier'nt => Some (exist _ Nis'166 (eq_refl _))
    | Ninit Nis'220, struct_or_union'nt => Some (exist _ Nis'167 (eq_refl _))
    | Ninit Nis'220, storage_class_specifier'nt => Some (exist _ Nis'194 (eq_refl _))
    | Ninit Nis'220, parameter_type_list'nt => Some (exist _ Nis'222 (eq_refl _))
    | Ninit Nis'220, parameter_list'nt => Some (exist _ Nis'203 (eq_refl _))
    | Ninit Nis'220, parameter_declaration'nt => Some (exist _ Nis'224 (eq_refl _))
    | Ninit Nis'220, function_specifier'nt => Some (exist _ Nis'195 (eq_refl _))
    | Ninit Nis'220, enum_specifier'nt => Some (exist _ Nis'196 (eq_refl _))
    | Ninit Nis'220, declaration_specifiers'nt => Some (exist _ Nis'207 (eq_refl _))
    | Ninit Nis'220, attribute_specifier'nt => Some (exist _ Nis'180 (eq_refl _))
    | Ninit Nis'225, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'225, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'225, type_qualifier_list'nt => Some (exist _ Nis'227 (eq_refl _))
    | Ninit Nis'225, type_qualifier'nt => Some (exist _ Nis'181 (eq_refl _))
    | Ninit Nis'225, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'225, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'225, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'225, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'225, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'225, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'225, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'225, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'225, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'225, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'225, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'225, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'225, attribute_specifier'nt => Some (exist _ Nis'180 (eq_refl _))
    | Ninit Nis'225, assignment_expression'nt => Some (exist _ Nis'231 (eq_refl _))
    | Ninit Nis'225, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'225, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'227, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'227, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'227, type_qualifier'nt => Some (exist _ Nis'178 (eq_refl _))
    | Ninit Nis'227, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'227, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'227, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'227, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'227, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'227, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'227, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'227, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'227, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'227, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'227, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'227, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'227, attribute_specifier'nt => Some (exist _ Nis'180 (eq_refl _))
    | Ninit Nis'227, assignment_expression'nt => Some (exist _ Nis'229 (eq_refl _))
    | Ninit Nis'227, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'227, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'235, attribute_specifier_list'nt => Some (exist _ Nis'244 (eq_refl _))
    | Ninit Nis'236, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'236, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'236, type_qualifier_list'nt => Some (exist _ Nis'238 (eq_refl _))
    | Ninit Nis'236, type_qualifier'nt => Some (exist _ Nis'181 (eq_refl _))
    | Ninit Nis'236, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'236, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'236, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'236, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'236, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'236, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'236, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'236, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'236, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'236, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'236, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'236, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'236, attribute_specifier'nt => Some (exist _ Nis'180 (eq_refl _))
    | Ninit Nis'236, assignment_expression'nt => Some (exist _ Nis'242 (eq_refl _))
    | Ninit Nis'236, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'236, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'238, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'238, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'238, type_qualifier'nt => Some (exist _ Nis'178 (eq_refl _))
    | Ninit Nis'238, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'238, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'238, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'238, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'238, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'238, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'238, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'238, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'238, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'238, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'238, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'238, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'238, attribute_specifier'nt => Some (exist _ Nis'180 (eq_refl _))
    | Ninit Nis'238, assignment_expression'nt => Some (exist _ Nis'240 (eq_refl _))
    | Ninit Nis'238, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'238, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'244, attribute_specifier'nt => Some (exist _ Nis'245 (eq_refl _))
    | Ninit Nis'253, attribute_specifier'nt => Some (exist _ Nis'245 (eq_refl _))
    | Ninit Nis'254, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'254, unary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'254, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'254, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'254, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'254, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'254, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'254, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'254, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'254, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'254, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'254, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'254, constant_expression'nt => Some (exist _ Nis'255 (eq_refl _))
    | Ninit Nis'254, conditional_expression'nt => Some (exist _ Nis'256 (eq_refl _))
    | Ninit Nis'254, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'254, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'254, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'259, struct_declarator'nt => Some (exist _ Nis'260 (eq_refl _))
    | Ninit Nis'259, pointer'nt => Some (exist _ Nis'185 (eq_refl _))
    | Ninit Nis'259, direct_declarator'nt => Some (exist _ Nis'235 (eq_refl _))
    | Ninit Nis'259, declarator'nt => Some (exist _ Nis'261 (eq_refl _))
    | Ninit Nis'262, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'262, unary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'262, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'262, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'262, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'262, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'262, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'262, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'262, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'262, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'262, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'262, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'262, constant_expression'nt => Some (exist _ Nis'263 (eq_refl _))
    | Ninit Nis'262, conditional_expression'nt => Some (exist _ Nis'256 (eq_refl _))
    | Ninit Nis'262, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'262, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'262, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'265, struct_declaration_list'nt => Some (exist _ Nis'266 (eq_refl _))
    | Ninit Nis'266, type_specifier'nt => Some (exist _ Nis'164 (eq_refl _))
    | Ninit Nis'266, type_qualifier'nt => Some (exist _ Nis'165 (eq_refl _))
    | Ninit Nis'266, struct_or_union_specifier'nt => Some (exist _ Nis'166 (eq_refl _))
    | Ninit Nis'266, struct_or_union'nt => Some (exist _ Nis'167 (eq_refl _))
    | Ninit Nis'266, struct_declaration'nt => Some (exist _ Nis'173 (eq_refl _))
    | Ninit Nis'266, specifier_qualifier_list'nt => Some (exist _ Nis'174 (eq_refl _))
    | Ninit Nis'266, enum_specifier'nt => Some (exist _ Nis'196 (eq_refl _))
    | Ninit Nis'266, attribute_specifier'nt => Some (exist _ Nis'180 (eq_refl _))
    | Ninit Nis'272, pointer'nt => Some (exist _ Nis'274 (eq_refl _))
    | Ninit Nis'272, direct_abstract_declarator'nt => Some (exist _ Nis'246 (eq_refl _))
    | Ninit Nis'272, abstract_declarator'nt => Some (exist _ Nis'275 (eq_refl _))
    | Ninit Nis'273, type_specifier'nt => Some (exist _ Nis'192 (eq_refl _))
    | Ninit Nis'273, type_qualifier'nt => Some (exist _ Nis'193 (eq_refl _))
    | Ninit Nis'273, struct_or_union_specifier'nt => Some (exist _ Nis'166 (eq_refl _))
    | Ninit Nis'273, struct_or_union'nt => Some (exist _ Nis'167 (eq_refl _))
    | Ninit Nis'273, storage_class_specifier'nt => Some (exist _ Nis'194 (eq_refl _))
    | Ninit Nis'273, pointer'nt => Some (exist _ Nis'274 (eq_refl _))
    | Ninit Nis'273, parameter_type_list'nt => Some (exist _ Nis'233 (eq_refl _))
    | Ninit Nis'273, parameter_list'nt => Some (exist _ Nis'203 (eq_refl _))
    | Ninit Nis'273, parameter_declaration'nt => Some (exist _ Nis'224 (eq_refl _))
    | Ninit Nis'273, function_specifier'nt => Some (exist _ Nis'195 (eq_refl _))
    | Ninit Nis'273, enum_specifier'nt => Some (exist _ Nis'196 (eq_refl _))
    | Ninit Nis'273, direct_abstract_declarator'nt => Some (exist _ Nis'246 (eq_refl _))
    | Ninit Nis'273, declaration_specifiers'nt => Some (exist _ Nis'207 (eq_refl _))
    | Ninit Nis'273, attribute_specifier'nt => Some (exist _ Nis'180 (eq_refl _))
    | Ninit Nis'273, abstract_declarator'nt => Some (exist _ Nis'249 (eq_refl _))
    | Ninit Nis'274, direct_abstract_declarator'nt => Some (exist _ Nis'219 (eq_refl _))
    | Ninit Nis'280, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'280, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'280, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'280, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'280, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'280, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'280, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'280, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'280, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'280, initializer_list'nt => Some (exist _ Nis'302 (eq_refl _))
    | Ninit Nis'280, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'280, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'280, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'280, designator_list'nt => Some (exist _ Nis'291 (eq_refl _))
    | Ninit Nis'280, designator'nt => Some (exist _ Nis'294 (eq_refl _))
    | Ninit Nis'280, designation'nt => Some (exist _ Nis'299 (eq_refl _))
    | Ninit Nis'280, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'280, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'280, c_initializer'nt => Some (exist _ Nis'301 (eq_refl _))
    | Ninit Nis'280, assignment_expression'nt => Some (exist _ Nis'297 (eq_refl _))
    | Ninit Nis'280, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'280, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'281, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'281, unary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'281, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'281, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'281, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'281, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'281, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'281, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'281, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'281, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'281, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'281, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'281, constant_expression'nt => Some (exist _ Nis'282 (eq_refl _))
    | Ninit Nis'281, conditional_expression'nt => Some (exist _ Nis'256 (eq_refl _))
    | Ninit Nis'281, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'281, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'281, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'284, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'284, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'284, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'284, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'284, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'284, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'284, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'284, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'284, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'284, initializer_list'nt => Some (exist _ Nis'287 (eq_refl _))
    | Ninit Nis'284, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'284, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'284, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'284, designator_list'nt => Some (exist _ Nis'291 (eq_refl _))
    | Ninit Nis'284, designator'nt => Some (exist _ Nis'294 (eq_refl _))
    | Ninit Nis'284, designation'nt => Some (exist _ Nis'299 (eq_refl _))
    | Ninit Nis'284, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'284, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'284, c_initializer'nt => Some (exist _ Nis'301 (eq_refl _))
    | Ninit Nis'284, assignment_expression'nt => Some (exist _ Nis'297 (eq_refl _))
    | Ninit Nis'284, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'284, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'289, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'289, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'289, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'289, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'289, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'289, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'289, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'289, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'289, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'289, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'289, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'289, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'289, designator_list'nt => Some (exist _ Nis'291 (eq_refl _))
    | Ninit Nis'289, designator'nt => Some (exist _ Nis'294 (eq_refl _))
    | Ninit Nis'289, designation'nt => Some (exist _ Nis'295 (eq_refl _))
    | Ninit Nis'289, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'289, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'289, c_initializer'nt => Some (exist _ Nis'298 (eq_refl _))
    | Ninit Nis'289, assignment_expression'nt => Some (exist _ Nis'297 (eq_refl _))
    | Ninit Nis'289, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'289, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'291, designator'nt => Some (exist _ Nis'293 (eq_refl _))
    | Ninit Nis'295, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'295, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'295, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'295, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'295, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'295, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'295, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'295, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'295, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'295, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'295, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'295, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'295, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'295, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'295, c_initializer'nt => Some (exist _ Nis'296 (eq_refl _))
    | Ninit Nis'295, assignment_expression'nt => Some (exist _ Nis'297 (eq_refl _))
    | Ninit Nis'295, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'295, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'299, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'299, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'299, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'299, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'299, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'299, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'299, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'299, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'299, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'299, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'299, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'299, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'299, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'299, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'299, c_initializer'nt => Some (exist _ Nis'300 (eq_refl _))
    | Ninit Nis'299, assignment_expression'nt => Some (exist _ Nis'297 (eq_refl _))
    | Ninit Nis'299, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'299, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'304, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'304, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'304, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'304, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'304, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'304, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'304, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'304, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'304, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'304, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'304, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'304, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'304, designator_list'nt => Some (exist _ Nis'291 (eq_refl _))
    | Ninit Nis'304, designator'nt => Some (exist _ Nis'294 (eq_refl _))
    | Ninit Nis'304, designation'nt => Some (exist _ Nis'295 (eq_refl _))
    | Ninit Nis'304, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'304, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'304, c_initializer'nt => Some (exist _ Nis'298 (eq_refl _))
    | Ninit Nis'304, assignment_expression'nt => Some (exist _ Nis'297 (eq_refl _))
    | Ninit Nis'304, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'304, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'310, type_specifier'nt => Some (exist _ Nis'164 (eq_refl _))
    | Ninit Nis'310, type_qualifier'nt => Some (exist _ Nis'165 (eq_refl _))
    | Ninit Nis'310, type_name'nt => Some (exist _ Nis'311 (eq_refl _))
    | Ninit Nis'310, struct_or_union_specifier'nt => Some (exist _ Nis'166 (eq_refl _))
    | Ninit Nis'310, struct_or_union'nt => Some (exist _ Nis'167 (eq_refl _))
    | Ninit Nis'310, specifier_qualifier_list'nt => Some (exist _ Nis'272 (eq_refl _))
    | Ninit Nis'310, enum_specifier'nt => Some (exist _ Nis'196 (eq_refl _))
    | Ninit Nis'310, attribute_specifier'nt => Some (exist _ Nis'180 (eq_refl _))
    | Ninit Nis'316, enumerator_list'nt => Some (exist _ Nis'317 (eq_refl _))
    | Ninit Nis'316, enumerator'nt => Some (exist _ Nis'315 (eq_refl _))
    | Ninit Nis'316, enumeration_constant'nt => Some (exist _ Nis'42 (eq_refl _))
    | Ninit Nis'319, enumerator'nt => Some (exist _ Nis'41 (eq_refl _))
    | Ninit Nis'319, enumeration_constant'nt => Some (exist _ Nis'42 (eq_refl _))
    | Ninit Nis'325, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'325, unary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'325, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'325, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'325, cast_expression'nt => Some (exist _ Nis'326 (eq_refl _))
    | Ninit Nis'334, type_specifier'nt => Some (exist _ Nis'192 (eq_refl _))
    | Ninit Nis'334, type_qualifier'nt => Some (exist _ Nis'193 (eq_refl _))
    | Ninit Nis'334, struct_or_union_specifier'nt => Some (exist _ Nis'166 (eq_refl _))
    | Ninit Nis'334, struct_or_union'nt => Some (exist _ Nis'167 (eq_refl _))
    | Ninit Nis'334, storage_class_specifier'nt => Some (exist _ Nis'194 (eq_refl _))
    | Ninit Nis'334, function_specifier'nt => Some (exist _ Nis'195 (eq_refl _))
    | Ninit Nis'334, function_definition'nt => Some (exist _ Nis'337 (eq_refl _))
    | Ninit Nis'334, external_declaration'nt => Some (exist _ Nis'338 (eq_refl _))
    | Ninit Nis'334, enum_specifier'nt => Some (exist _ Nis'196 (eq_refl _))
    | Ninit Nis'334, declaration_specifiers'nt => Some (exist _ Nis'339 (eq_refl _))
    | Ninit Nis'334, declaration'nt => Some (exist _ Nis'595 (eq_refl _))
    | Ninit Nis'334, attribute_specifier'nt => Some (exist _ Nis'180 (eq_refl _))
    | Ninit Nis'339, pointer'nt => Some (exist _ Nis'341 (eq_refl _))
    | Ninit Nis'339, old_function_declarator'nt => Some (exist _ Nis'350 (eq_refl _))
    | Ninit Nis'339, init_declarator_list'nt => Some (exist _ Nis'486 (eq_refl _))
    | Ninit Nis'339, init_declarator'nt => Some (exist _ Nis'493 (eq_refl _))
    | Ninit Nis'339, direct_old_function_declarator'nt => Some (exist _ Nis'591 (eq_refl _))
    | Ninit Nis'339, direct_declarator'nt => Some (exist _ Nis'592 (eq_refl _))
    | Ninit Nis'339, declarator'nt => Some (exist _ Nis'593 (eq_refl _))
    | Ninit Nis'341, direct_old_function_declarator'nt => Some (exist _ Nis'342 (eq_refl _))
    | Ninit Nis'341, direct_declarator'nt => Some (exist _ Nis'343 (eq_refl _))
    | Ninit Nis'343, attribute_specifier_list'nt => Some (exist _ Nis'253 (eq_refl _))
    | Ninit Nis'344, type_specifier'nt => Some (exist _ Nis'192 (eq_refl _))
    | Ninit Nis'344, type_qualifier'nt => Some (exist _ Nis'193 (eq_refl _))
    | Ninit Nis'344, struct_or_union_specifier'nt => Some (exist _ Nis'166 (eq_refl _))
    | Ninit Nis'344, struct_or_union'nt => Some (exist _ Nis'167 (eq_refl _))
    | Ninit Nis'344, storage_class_specifier'nt => Some (exist _ Nis'194 (eq_refl _))
    | Ninit Nis'344, parameter_type_list'nt => Some (exist _ Nis'201 (eq_refl _))
    | Ninit Nis'344, parameter_list'nt => Some (exist _ Nis'203 (eq_refl _))
    | Ninit Nis'344, parameter_declaration'nt => Some (exist _ Nis'224 (eq_refl _))
    | Ninit Nis'344, identifier_list'nt => Some (exist _ Nis'346 (eq_refl _))
    | Ninit Nis'344, function_specifier'nt => Some (exist _ Nis'195 (eq_refl _))
    | Ninit Nis'344, enum_specifier'nt => Some (exist _ Nis'196 (eq_refl _))
    | Ninit Nis'344, declaration_specifiers'nt => Some (exist _ Nis'207 (eq_refl _))
    | Ninit Nis'344, attribute_specifier'nt => Some (exist _ Nis'180 (eq_refl _))
    | Ninit Nis'350, declaration_list'nt => Some (exist _ Nis'351 (eq_refl _))
    | Ninit Nis'351, type_specifier'nt => Some (exist _ Nis'192 (eq_refl _))
    | Ninit Nis'351, type_qualifier'nt => Some (exist _ Nis'193 (eq_refl _))
    | Ninit Nis'351, struct_or_union_specifier'nt => Some (exist _ Nis'166 (eq_refl _))
    | Ninit Nis'351, struct_or_union'nt => Some (exist _ Nis'167 (eq_refl _))
    | Ninit Nis'351, storage_class_specifier'nt => Some (exist _ Nis'194 (eq_refl _))
    | Ninit Nis'351, function_specifier'nt => Some (exist _ Nis'195 (eq_refl _))
    | Ninit Nis'351, enum_specifier'nt => Some (exist _ Nis'196 (eq_refl _))
    | Ninit Nis'351, declaration_specifiers'nt => Some (exist _ Nis'485 (eq_refl _))
    | Ninit Nis'351, declaration'nt => Some (exist _ Nis'589 (eq_refl _))
    | Ninit Nis'351, compound_statement'nt => Some (exist _ Nis'590 (eq_refl _))
    | Ninit Nis'351, attribute_specifier'nt => Some (exist _ Nis'180 (eq_refl _))
    | Ninit Nis'352, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'352, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'352, type_specifier'nt => Some (exist _ Nis'192 (eq_refl _))
    | Ninit Nis'352, type_qualifier'nt => Some (exist _ Nis'193 (eq_refl _))
    | Ninit Nis'352, struct_or_union_specifier'nt => Some (exist _ Nis'166 (eq_refl _))
    | Ninit Nis'352, struct_or_union'nt => Some (exist _ Nis'167 (eq_refl _))
    | Ninit Nis'352, storage_class_specifier'nt => Some (exist _ Nis'194 (eq_refl _))
    | Ninit Nis'352, statement_dangerous'nt => Some (exist _ Nis'583 (eq_refl _))
    | Ninit Nis'352, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'352, selection_statement_dangerous'nt => Some (exist _ Nis'443 (eq_refl _))
    | Ninit Nis'352, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'352, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'352, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'352, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'352, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'352, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'352, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'444 (eq_refl _))
    | Ninit Nis'352, jump_statement'nt => Some (exist _ Nis'445 (eq_refl _))
    | Ninit Nis'352, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'446 (eq_refl _))
    | Ninit Nis'352, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'352, function_specifier'nt => Some (exist _ Nis'195 (eq_refl _))
    | Ninit Nis'352, expression_statement'nt => Some (exist _ Nis'447 (eq_refl _))
    | Ninit Nis'352, expression'nt => Some (exist _ Nis'448 (eq_refl _))
    | Ninit Nis'352, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'352, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'352, enum_specifier'nt => Some (exist _ Nis'196 (eq_refl _))
    | Ninit Nis'352, declaration_specifiers'nt => Some (exist _ Nis'485 (eq_refl _))
    | Ninit Nis'352, declaration'nt => Some (exist _ Nis'584 (eq_refl _))
    | Ninit Nis'352, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'352, compound_statement'nt => Some (exist _ Nis'450 (eq_refl _))
    | Ninit Nis'352, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'352, block_item_list'nt => Some (exist _ Nis'585 (eq_refl _))
    | Ninit Nis'352, block_item'nt => Some (exist _ Nis'588 (eq_refl _))
    | Ninit Nis'352, attribute_specifier'nt => Some (exist _ Nis'180 (eq_refl _))
    | Ninit Nis'352, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'352, asm_statement'nt => Some (exist _ Nis'451 (eq_refl _))
    | Ninit Nis'352, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'352, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'354, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'354, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'354, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'354, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'354, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'354, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'354, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'354, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'354, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'354, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'354, expression'nt => Some (exist _ Nis'355 (eq_refl _))
    | Ninit Nis'354, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'354, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'354, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'354, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'354, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'354, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'354, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'356, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'356, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'356, statement_dangerous'nt => Some (exist _ Nis'578 (eq_refl _))
    | Ninit Nis'356, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'356, selection_statement_dangerous'nt => Some (exist _ Nis'443 (eq_refl _))
    | Ninit Nis'356, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'356, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'356, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'356, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'356, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'356, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'356, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'444 (eq_refl _))
    | Ninit Nis'356, jump_statement'nt => Some (exist _ Nis'445 (eq_refl _))
    | Ninit Nis'356, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'446 (eq_refl _))
    | Ninit Nis'356, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'356, expression_statement'nt => Some (exist _ Nis'447 (eq_refl _))
    | Ninit Nis'356, expression'nt => Some (exist _ Nis'448 (eq_refl _))
    | Ninit Nis'356, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'356, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'356, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'356, compound_statement'nt => Some (exist _ Nis'450 (eq_refl _))
    | Ninit Nis'356, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'356, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'356, asm_statement'nt => Some (exist _ Nis'451 (eq_refl _))
    | Ninit Nis'356, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'356, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'358, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'358, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'358, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'358, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'358, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'358, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'358, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'358, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'358, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'358, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'358, expression'nt => Some (exist _ Nis'359 (eq_refl _))
    | Ninit Nis'358, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'358, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'358, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'358, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'358, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'358, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'358, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'360, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'360, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'360, statement_dangerous'nt => Some (exist _ Nis'576 (eq_refl _))
    | Ninit Nis'360, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'360, selection_statement_dangerous'nt => Some (exist _ Nis'443 (eq_refl _))
    | Ninit Nis'360, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'360, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'360, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'360, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'360, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'360, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'360, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'444 (eq_refl _))
    | Ninit Nis'360, jump_statement'nt => Some (exist _ Nis'445 (eq_refl _))
    | Ninit Nis'360, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'446 (eq_refl _))
    | Ninit Nis'360, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'360, expression_statement'nt => Some (exist _ Nis'447 (eq_refl _))
    | Ninit Nis'360, expression'nt => Some (exist _ Nis'448 (eq_refl _))
    | Ninit Nis'360, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'360, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'360, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'360, compound_statement'nt => Some (exist _ Nis'450 (eq_refl _))
    | Ninit Nis'360, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'360, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'360, asm_statement'nt => Some (exist _ Nis'451 (eq_refl _))
    | Ninit Nis'360, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'360, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'362, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'362, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'362, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'362, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'362, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'362, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'362, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'362, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'362, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'362, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'362, expression'nt => Some (exist _ Nis'364 (eq_refl _))
    | Ninit Nis'362, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'362, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'362, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'362, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'362, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'362, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'362, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'367, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'367, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'367, statement_dangerous'nt => Some (exist _ Nis'574 (eq_refl _))
    | Ninit Nis'367, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'367, selection_statement_dangerous'nt => Some (exist _ Nis'443 (eq_refl _))
    | Ninit Nis'367, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'367, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'367, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'367, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'367, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'367, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'367, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'444 (eq_refl _))
    | Ninit Nis'367, jump_statement'nt => Some (exist _ Nis'445 (eq_refl _))
    | Ninit Nis'367, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'446 (eq_refl _))
    | Ninit Nis'367, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'367, expression_statement'nt => Some (exist _ Nis'447 (eq_refl _))
    | Ninit Nis'367, expression'nt => Some (exist _ Nis'448 (eq_refl _))
    | Ninit Nis'367, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'367, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'367, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'367, compound_statement'nt => Some (exist _ Nis'450 (eq_refl _))
    | Ninit Nis'367, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'367, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'367, asm_statement'nt => Some (exist _ Nis'451 (eq_refl _))
    | Ninit Nis'367, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'367, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'369, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'369, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'369, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'369, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'369, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'369, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'369, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'369, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'369, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'369, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'369, expression'nt => Some (exist _ Nis'370 (eq_refl _))
    | Ninit Nis'369, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'369, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'369, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'369, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'369, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'369, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'369, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'371, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'371, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'371, statement_safe'nt => Some (exist _ Nis'579 (eq_refl _))
    | Ninit Nis'371, statement_dangerous'nt => Some (exist _ Nis'572 (eq_refl _))
    | Ninit Nis'371, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'371, selection_statement_safe'nt => Some (exist _ Nis'520 (eq_refl _))
    | Ninit Nis'371, selection_statement_dangerous'nt => Some (exist _ Nis'443 (eq_refl _))
    | Ninit Nis'371, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'371, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'371, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'371, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'371, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'371, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'371, labeled_statement_statement_safe_'nt => Some (exist _ Nis'521 (eq_refl _))
    | Ninit Nis'371, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'444 (eq_refl _))
    | Ninit Nis'371, jump_statement'nt => Some (exist _ Nis'522 (eq_refl _))
    | Ninit Nis'371, iteration_statement_statement_safe_'nt => Some (exist _ Nis'523 (eq_refl _))
    | Ninit Nis'371, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'446 (eq_refl _))
    | Ninit Nis'371, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'371, expression_statement'nt => Some (exist _ Nis'524 (eq_refl _))
    | Ninit Nis'371, expression'nt => Some (exist _ Nis'448 (eq_refl _))
    | Ninit Nis'371, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'371, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'371, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'371, compound_statement'nt => Some (exist _ Nis'525 (eq_refl _))
    | Ninit Nis'371, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'371, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'371, asm_statement'nt => Some (exist _ Nis'526 (eq_refl _))
    | Ninit Nis'371, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'371, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'373, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'373, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'373, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'373, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'373, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'373, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'373, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'373, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'373, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'373, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'373, expression'nt => Some (exist _ Nis'374 (eq_refl _))
    | Ninit Nis'373, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'373, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'373, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'373, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'373, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'373, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'373, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'375, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'375, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'375, statement_safe'nt => Some (exist _ Nis'577 (eq_refl _))
    | Ninit Nis'375, statement_dangerous'nt => Some (exist _ Nis'578 (eq_refl _))
    | Ninit Nis'375, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'375, selection_statement_safe'nt => Some (exist _ Nis'520 (eq_refl _))
    | Ninit Nis'375, selection_statement_dangerous'nt => Some (exist _ Nis'443 (eq_refl _))
    | Ninit Nis'375, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'375, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'375, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'375, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'375, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'375, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'375, labeled_statement_statement_safe_'nt => Some (exist _ Nis'521 (eq_refl _))
    | Ninit Nis'375, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'444 (eq_refl _))
    | Ninit Nis'375, jump_statement'nt => Some (exist _ Nis'522 (eq_refl _))
    | Ninit Nis'375, iteration_statement_statement_safe_'nt => Some (exist _ Nis'523 (eq_refl _))
    | Ninit Nis'375, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'446 (eq_refl _))
    | Ninit Nis'375, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'375, expression_statement'nt => Some (exist _ Nis'524 (eq_refl _))
    | Ninit Nis'375, expression'nt => Some (exist _ Nis'448 (eq_refl _))
    | Ninit Nis'375, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'375, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'375, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'375, compound_statement'nt => Some (exist _ Nis'525 (eq_refl _))
    | Ninit Nis'375, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'375, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'375, asm_statement'nt => Some (exist _ Nis'526 (eq_refl _))
    | Ninit Nis'375, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'375, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'377, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'377, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'377, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'377, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'377, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'377, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'377, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'377, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'377, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'377, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'377, expression'nt => Some (exist _ Nis'378 (eq_refl _))
    | Ninit Nis'377, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'377, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'377, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'377, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'377, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'377, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'377, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'379, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'379, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'379, statement_safe'nt => Some (exist _ Nis'575 (eq_refl _))
    | Ninit Nis'379, statement_dangerous'nt => Some (exist _ Nis'576 (eq_refl _))
    | Ninit Nis'379, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'379, selection_statement_safe'nt => Some (exist _ Nis'520 (eq_refl _))
    | Ninit Nis'379, selection_statement_dangerous'nt => Some (exist _ Nis'443 (eq_refl _))
    | Ninit Nis'379, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'379, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'379, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'379, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'379, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'379, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'379, labeled_statement_statement_safe_'nt => Some (exist _ Nis'521 (eq_refl _))
    | Ninit Nis'379, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'444 (eq_refl _))
    | Ninit Nis'379, jump_statement'nt => Some (exist _ Nis'522 (eq_refl _))
    | Ninit Nis'379, iteration_statement_statement_safe_'nt => Some (exist _ Nis'523 (eq_refl _))
    | Ninit Nis'379, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'446 (eq_refl _))
    | Ninit Nis'379, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'379, expression_statement'nt => Some (exist _ Nis'524 (eq_refl _))
    | Ninit Nis'379, expression'nt => Some (exist _ Nis'448 (eq_refl _))
    | Ninit Nis'379, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'379, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'379, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'379, compound_statement'nt => Some (exist _ Nis'525 (eq_refl _))
    | Ninit Nis'379, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'379, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'379, asm_statement'nt => Some (exist _ Nis'526 (eq_refl _))
    | Ninit Nis'379, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'379, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'381, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'381, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'381, statement_safe'nt => Some (exist _ Nis'573 (eq_refl _))
    | Ninit Nis'381, statement_dangerous'nt => Some (exist _ Nis'574 (eq_refl _))
    | Ninit Nis'381, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'381, selection_statement_safe'nt => Some (exist _ Nis'520 (eq_refl _))
    | Ninit Nis'381, selection_statement_dangerous'nt => Some (exist _ Nis'443 (eq_refl _))
    | Ninit Nis'381, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'381, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'381, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'381, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'381, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'381, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'381, labeled_statement_statement_safe_'nt => Some (exist _ Nis'521 (eq_refl _))
    | Ninit Nis'381, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'444 (eq_refl _))
    | Ninit Nis'381, jump_statement'nt => Some (exist _ Nis'522 (eq_refl _))
    | Ninit Nis'381, iteration_statement_statement_safe_'nt => Some (exist _ Nis'523 (eq_refl _))
    | Ninit Nis'381, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'446 (eq_refl _))
    | Ninit Nis'381, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'381, expression_statement'nt => Some (exist _ Nis'524 (eq_refl _))
    | Ninit Nis'381, expression'nt => Some (exist _ Nis'448 (eq_refl _))
    | Ninit Nis'381, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'381, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'381, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'381, compound_statement'nt => Some (exist _ Nis'525 (eq_refl _))
    | Ninit Nis'381, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'381, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'381, asm_statement'nt => Some (exist _ Nis'526 (eq_refl _))
    | Ninit Nis'381, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'381, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'383, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'383, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'383, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'383, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'383, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'383, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'383, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'383, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'383, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'383, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'383, expression'nt => Some (exist _ Nis'384 (eq_refl _))
    | Ninit Nis'383, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'383, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'383, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'383, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'383, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'383, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'383, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'385, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'385, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'385, statement_safe'nt => Some (exist _ Nis'568 (eq_refl _))
    | Ninit Nis'385, statement_dangerous'nt => Some (exist _ Nis'572 (eq_refl _))
    | Ninit Nis'385, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'385, selection_statement_safe'nt => Some (exist _ Nis'520 (eq_refl _))
    | Ninit Nis'385, selection_statement_dangerous'nt => Some (exist _ Nis'443 (eq_refl _))
    | Ninit Nis'385, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'385, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'385, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'385, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'385, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'385, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'385, labeled_statement_statement_safe_'nt => Some (exist _ Nis'521 (eq_refl _))
    | Ninit Nis'385, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'444 (eq_refl _))
    | Ninit Nis'385, jump_statement'nt => Some (exist _ Nis'522 (eq_refl _))
    | Ninit Nis'385, iteration_statement_statement_safe_'nt => Some (exist _ Nis'523 (eq_refl _))
    | Ninit Nis'385, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'446 (eq_refl _))
    | Ninit Nis'385, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'385, expression_statement'nt => Some (exist _ Nis'524 (eq_refl _))
    | Ninit Nis'385, expression'nt => Some (exist _ Nis'448 (eq_refl _))
    | Ninit Nis'385, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'385, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'385, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'385, compound_statement'nt => Some (exist _ Nis'525 (eq_refl _))
    | Ninit Nis'385, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'385, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'385, asm_statement'nt => Some (exist _ Nis'526 (eq_refl _))
    | Ninit Nis'385, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'385, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'390, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'390, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'390, type_specifier'nt => Some (exist _ Nis'192 (eq_refl _))
    | Ninit Nis'390, type_qualifier'nt => Some (exist _ Nis'193 (eq_refl _))
    | Ninit Nis'390, struct_or_union_specifier'nt => Some (exist _ Nis'166 (eq_refl _))
    | Ninit Nis'390, struct_or_union'nt => Some (exist _ Nis'167 (eq_refl _))
    | Ninit Nis'390, storage_class_specifier'nt => Some (exist _ Nis'194 (eq_refl _))
    | Ninit Nis'390, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'390, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'390, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'390, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'390, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'390, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'390, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'390, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'390, function_specifier'nt => Some (exist _ Nis'195 (eq_refl _))
    | Ninit Nis'390, expression'nt => Some (exist _ Nis'539 (eq_refl _))
    | Ninit Nis'390, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'390, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'390, enum_specifier'nt => Some (exist _ Nis'196 (eq_refl _))
    | Ninit Nis'390, declaration_specifiers'nt => Some (exist _ Nis'485 (eq_refl _))
    | Ninit Nis'390, declaration'nt => Some (exist _ Nis'554 (eq_refl _))
    | Ninit Nis'390, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'390, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'390, attribute_specifier'nt => Some (exist _ Nis'180 (eq_refl _))
    | Ninit Nis'390, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'390, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'390, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'391, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'391, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'391, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'391, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'391, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'391, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'391, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'391, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'391, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'391, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'391, expression'nt => Some (exist _ Nis'532 (eq_refl _))
    | Ninit Nis'391, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'391, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'391, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'391, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'391, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'391, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'391, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'392, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'392, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'392, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'392, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'392, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'392, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'392, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'392, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'392, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'392, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'392, expression'nt => Some (exist _ Nis'529 (eq_refl _))
    | Ninit Nis'392, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'392, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'392, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'392, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'392, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'392, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'392, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'393, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'393, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'393, statement_safe'nt => Some (exist _ Nis'528 (eq_refl _))
    | Ninit Nis'393, statement_dangerous'nt => Some (exist _ Nis'459 (eq_refl _))
    | Ninit Nis'393, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'393, selection_statement_safe'nt => Some (exist _ Nis'520 (eq_refl _))
    | Ninit Nis'393, selection_statement_dangerous'nt => Some (exist _ Nis'443 (eq_refl _))
    | Ninit Nis'393, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'393, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'393, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'393, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'393, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'393, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'393, labeled_statement_statement_safe_'nt => Some (exist _ Nis'521 (eq_refl _))
    | Ninit Nis'393, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'444 (eq_refl _))
    | Ninit Nis'393, jump_statement'nt => Some (exist _ Nis'522 (eq_refl _))
    | Ninit Nis'393, iteration_statement_statement_safe_'nt => Some (exist _ Nis'523 (eq_refl _))
    | Ninit Nis'393, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'446 (eq_refl _))
    | Ninit Nis'393, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'393, expression_statement'nt => Some (exist _ Nis'524 (eq_refl _))
    | Ninit Nis'393, expression'nt => Some (exist _ Nis'448 (eq_refl _))
    | Ninit Nis'393, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'393, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'393, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'393, compound_statement'nt => Some (exist _ Nis'525 (eq_refl _))
    | Ninit Nis'393, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'393, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'393, asm_statement'nt => Some (exist _ Nis'526 (eq_refl _))
    | Ninit Nis'393, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'393, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'394, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'394, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'394, statement_dangerous'nt => Some (exist _ Nis'508 (eq_refl _))
    | Ninit Nis'394, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'394, selection_statement_dangerous'nt => Some (exist _ Nis'443 (eq_refl _))
    | Ninit Nis'394, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'394, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'394, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'394, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'394, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'394, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'394, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'444 (eq_refl _))
    | Ninit Nis'394, jump_statement'nt => Some (exist _ Nis'445 (eq_refl _))
    | Ninit Nis'394, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'446 (eq_refl _))
    | Ninit Nis'394, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'394, expression_statement'nt => Some (exist _ Nis'447 (eq_refl _))
    | Ninit Nis'394, expression'nt => Some (exist _ Nis'448 (eq_refl _))
    | Ninit Nis'394, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'394, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'394, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'394, compound_statement'nt => Some (exist _ Nis'450 (eq_refl _))
    | Ninit Nis'394, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'394, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'394, asm_statement'nt => Some (exist _ Nis'451 (eq_refl _))
    | Ninit Nis'394, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'394, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'396, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'396, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'396, type_specifier'nt => Some (exist _ Nis'192 (eq_refl _))
    | Ninit Nis'396, type_qualifier'nt => Some (exist _ Nis'193 (eq_refl _))
    | Ninit Nis'396, struct_or_union_specifier'nt => Some (exist _ Nis'166 (eq_refl _))
    | Ninit Nis'396, struct_or_union'nt => Some (exist _ Nis'167 (eq_refl _))
    | Ninit Nis'396, storage_class_specifier'nt => Some (exist _ Nis'194 (eq_refl _))
    | Ninit Nis'396, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'396, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'396, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'396, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'396, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'396, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'396, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'396, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'396, function_specifier'nt => Some (exist _ Nis'195 (eq_refl _))
    | Ninit Nis'396, expression'nt => Some (exist _ Nis'470 (eq_refl _))
    | Ninit Nis'396, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'396, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'396, enum_specifier'nt => Some (exist _ Nis'196 (eq_refl _))
    | Ninit Nis'396, declaration_specifiers'nt => Some (exist _ Nis'485 (eq_refl _))
    | Ninit Nis'396, declaration'nt => Some (exist _ Nis'494 (eq_refl _))
    | Ninit Nis'396, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'396, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'396, attribute_specifier'nt => Some (exist _ Nis'180 (eq_refl _))
    | Ninit Nis'396, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'396, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'396, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'397, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'397, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'397, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'397, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'397, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'397, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'397, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'397, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'397, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'397, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'397, expression'nt => Some (exist _ Nis'463 (eq_refl _))
    | Ninit Nis'397, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'397, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'397, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'397, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'397, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'397, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'397, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'398, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'398, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'398, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'398, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'398, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'398, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'398, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'398, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'398, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'398, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'398, expression'nt => Some (exist _ Nis'460 (eq_refl _))
    | Ninit Nis'398, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'398, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'398, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'398, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'398, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'398, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'398, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'399, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'399, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'399, statement_dangerous'nt => Some (exist _ Nis'459 (eq_refl _))
    | Ninit Nis'399, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'399, selection_statement_dangerous'nt => Some (exist _ Nis'443 (eq_refl _))
    | Ninit Nis'399, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'399, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'399, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'399, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'399, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'399, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'399, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'444 (eq_refl _))
    | Ninit Nis'399, jump_statement'nt => Some (exist _ Nis'445 (eq_refl _))
    | Ninit Nis'399, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'446 (eq_refl _))
    | Ninit Nis'399, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'399, expression_statement'nt => Some (exist _ Nis'447 (eq_refl _))
    | Ninit Nis'399, expression'nt => Some (exist _ Nis'448 (eq_refl _))
    | Ninit Nis'399, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'399, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'399, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'399, compound_statement'nt => Some (exist _ Nis'450 (eq_refl _))
    | Ninit Nis'399, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'399, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'399, asm_statement'nt => Some (exist _ Nis'451 (eq_refl _))
    | Ninit Nis'399, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'399, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'400, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'400, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'400, statement_dangerous'nt => Some (exist _ Nis'453 (eq_refl _))
    | Ninit Nis'400, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'400, selection_statement_dangerous'nt => Some (exist _ Nis'443 (eq_refl _))
    | Ninit Nis'400, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'400, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'400, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'400, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'400, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'400, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'400, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'444 (eq_refl _))
    | Ninit Nis'400, jump_statement'nt => Some (exist _ Nis'445 (eq_refl _))
    | Ninit Nis'400, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'446 (eq_refl _))
    | Ninit Nis'400, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'400, expression_statement'nt => Some (exist _ Nis'447 (eq_refl _))
    | Ninit Nis'400, expression'nt => Some (exist _ Nis'448 (eq_refl _))
    | Ninit Nis'400, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'400, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'400, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'400, compound_statement'nt => Some (exist _ Nis'450 (eq_refl _))
    | Ninit Nis'400, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'400, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'400, asm_statement'nt => Some (exist _ Nis'451 (eq_refl _))
    | Ninit Nis'400, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'400, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'402, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'402, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'402, statement_dangerous'nt => Some (exist _ Nis'452 (eq_refl _))
    | Ninit Nis'402, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'402, selection_statement_dangerous'nt => Some (exist _ Nis'443 (eq_refl _))
    | Ninit Nis'402, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'402, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'402, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'402, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'402, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'402, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'402, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'444 (eq_refl _))
    | Ninit Nis'402, jump_statement'nt => Some (exist _ Nis'445 (eq_refl _))
    | Ninit Nis'402, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'446 (eq_refl _))
    | Ninit Nis'402, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'402, expression_statement'nt => Some (exist _ Nis'447 (eq_refl _))
    | Ninit Nis'402, expression'nt => Some (exist _ Nis'448 (eq_refl _))
    | Ninit Nis'402, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'402, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'402, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'402, compound_statement'nt => Some (exist _ Nis'450 (eq_refl _))
    | Ninit Nis'402, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'402, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'402, asm_statement'nt => Some (exist _ Nis'451 (eq_refl _))
    | Ninit Nis'402, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'402, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'405, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'405, unary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'405, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'405, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'405, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'405, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'405, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'405, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'405, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'405, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'405, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'405, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'405, constant_expression'nt => Some (exist _ Nis'406 (eq_refl _))
    | Ninit Nis'405, conditional_expression'nt => Some (exist _ Nis'256 (eq_refl _))
    | Ninit Nis'405, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'405, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'405, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'407, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'407, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'407, statement_dangerous'nt => Some (exist _ Nis'442 (eq_refl _))
    | Ninit Nis'407, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'407, selection_statement_dangerous'nt => Some (exist _ Nis'443 (eq_refl _))
    | Ninit Nis'407, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'407, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'407, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'407, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'407, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'407, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'407, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'444 (eq_refl _))
    | Ninit Nis'407, jump_statement'nt => Some (exist _ Nis'445 (eq_refl _))
    | Ninit Nis'407, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'446 (eq_refl _))
    | Ninit Nis'407, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'407, expression_statement'nt => Some (exist _ Nis'447 (eq_refl _))
    | Ninit Nis'407, expression'nt => Some (exist _ Nis'448 (eq_refl _))
    | Ninit Nis'407, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'407, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'407, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'407, compound_statement'nt => Some (exist _ Nis'450 (eq_refl _))
    | Ninit Nis'407, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'407, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'407, asm_statement'nt => Some (exist _ Nis'451 (eq_refl _))
    | Ninit Nis'407, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'407, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'410, asm_attributes'nt => Some (exist _ Nis'415 (eq_refl _))
    | Ninit Nis'411, asm_attributes'nt => Some (exist _ Nis'414 (eq_refl _))
    | Ninit Nis'412, asm_attributes'nt => Some (exist _ Nis'413 (eq_refl _))
    | Ninit Nis'417, asm_arguments'nt => Some (exist _ Nis'439 (eq_refl _))
    | Ninit Nis'418, asm_operands_ne'nt => Some (exist _ Nis'422 (eq_refl _))
    | Ninit Nis'418, asm_operands'nt => Some (exist _ Nis'430 (eq_refl _))
    | Ninit Nis'418, asm_operand'nt => Some (exist _ Nis'438 (eq_refl _))
    | Ninit Nis'418, asm_op_name'nt => Some (exist _ Nis'425 (eq_refl _))
    | Ninit Nis'423, asm_operand'nt => Some (exist _ Nis'424 (eq_refl _))
    | Ninit Nis'423, asm_op_name'nt => Some (exist _ Nis'425 (eq_refl _))
    | Ninit Nis'427, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'427, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'427, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'427, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'427, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'427, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'427, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'427, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'427, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'427, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'427, expression'nt => Some (exist _ Nis'428 (eq_refl _))
    | Ninit Nis'427, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'427, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'427, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'427, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'427, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'427, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'427, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'431, asm_operands_ne'nt => Some (exist _ Nis'422 (eq_refl _))
    | Ninit Nis'431, asm_operands'nt => Some (exist _ Nis'432 (eq_refl _))
    | Ninit Nis'431, asm_operand'nt => Some (exist _ Nis'438 (eq_refl _))
    | Ninit Nis'431, asm_op_name'nt => Some (exist _ Nis'425 (eq_refl _))
    | Ninit Nis'433, asm_flags'nt => Some (exist _ Nis'437 (eq_refl _))
    | Ninit Nis'435, asm_flags'nt => Some (exist _ Nis'436 (eq_refl _))
    | Ninit Nis'455, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'455, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'455, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'455, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'455, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'455, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'455, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'455, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'455, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'455, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'455, expression'nt => Some (exist _ Nis'456 (eq_refl _))
    | Ninit Nis'455, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'455, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'455, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'455, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'455, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'455, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'455, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'461, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'461, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'461, statement_dangerous'nt => Some (exist _ Nis'462 (eq_refl _))
    | Ninit Nis'461, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'461, selection_statement_dangerous'nt => Some (exist _ Nis'443 (eq_refl _))
    | Ninit Nis'461, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'461, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'461, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'461, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'461, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'461, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'461, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'444 (eq_refl _))
    | Ninit Nis'461, jump_statement'nt => Some (exist _ Nis'445 (eq_refl _))
    | Ninit Nis'461, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'446 (eq_refl _))
    | Ninit Nis'461, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'461, expression_statement'nt => Some (exist _ Nis'447 (eq_refl _))
    | Ninit Nis'461, expression'nt => Some (exist _ Nis'448 (eq_refl _))
    | Ninit Nis'461, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'461, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'461, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'461, compound_statement'nt => Some (exist _ Nis'450 (eq_refl _))
    | Ninit Nis'461, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'461, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'461, asm_statement'nt => Some (exist _ Nis'451 (eq_refl _))
    | Ninit Nis'461, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'461, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'464, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'464, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'464, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'464, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'464, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'464, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'464, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'464, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'464, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'464, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'464, expression'nt => Some (exist _ Nis'467 (eq_refl _))
    | Ninit Nis'464, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'464, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'464, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'464, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'464, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'464, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'464, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'465, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'465, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'465, statement_dangerous'nt => Some (exist _ Nis'466 (eq_refl _))
    | Ninit Nis'465, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'465, selection_statement_dangerous'nt => Some (exist _ Nis'443 (eq_refl _))
    | Ninit Nis'465, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'465, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'465, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'465, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'465, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'465, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'465, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'444 (eq_refl _))
    | Ninit Nis'465, jump_statement'nt => Some (exist _ Nis'445 (eq_refl _))
    | Ninit Nis'465, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'446 (eq_refl _))
    | Ninit Nis'465, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'465, expression_statement'nt => Some (exist _ Nis'447 (eq_refl _))
    | Ninit Nis'465, expression'nt => Some (exist _ Nis'448 (eq_refl _))
    | Ninit Nis'465, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'465, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'465, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'465, compound_statement'nt => Some (exist _ Nis'450 (eq_refl _))
    | Ninit Nis'465, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'465, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'465, asm_statement'nt => Some (exist _ Nis'451 (eq_refl _))
    | Ninit Nis'465, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'465, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'468, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'468, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'468, statement_dangerous'nt => Some (exist _ Nis'469 (eq_refl _))
    | Ninit Nis'468, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'468, selection_statement_dangerous'nt => Some (exist _ Nis'443 (eq_refl _))
    | Ninit Nis'468, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'468, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'468, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'468, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'468, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'468, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'468, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'444 (eq_refl _))
    | Ninit Nis'468, jump_statement'nt => Some (exist _ Nis'445 (eq_refl _))
    | Ninit Nis'468, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'446 (eq_refl _))
    | Ninit Nis'468, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'468, expression_statement'nt => Some (exist _ Nis'447 (eq_refl _))
    | Ninit Nis'468, expression'nt => Some (exist _ Nis'448 (eq_refl _))
    | Ninit Nis'468, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'468, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'468, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'468, compound_statement'nt => Some (exist _ Nis'450 (eq_refl _))
    | Ninit Nis'468, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'468, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'468, asm_statement'nt => Some (exist _ Nis'451 (eq_refl _))
    | Ninit Nis'468, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'468, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'471, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'471, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'471, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'471, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'471, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'471, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'471, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'471, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'471, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'471, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'471, expression'nt => Some (exist _ Nis'478 (eq_refl _))
    | Ninit Nis'471, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'471, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'471, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'471, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'471, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'471, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'471, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'472, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'472, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'472, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'472, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'472, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'472, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'472, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'472, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'472, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'472, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'472, expression'nt => Some (exist _ Nis'475 (eq_refl _))
    | Ninit Nis'472, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'472, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'472, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'472, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'472, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'472, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'472, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'473, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'473, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'473, statement_dangerous'nt => Some (exist _ Nis'474 (eq_refl _))
    | Ninit Nis'473, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'473, selection_statement_dangerous'nt => Some (exist _ Nis'443 (eq_refl _))
    | Ninit Nis'473, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'473, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'473, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'473, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'473, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'473, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'473, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'444 (eq_refl _))
    | Ninit Nis'473, jump_statement'nt => Some (exist _ Nis'445 (eq_refl _))
    | Ninit Nis'473, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'446 (eq_refl _))
    | Ninit Nis'473, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'473, expression_statement'nt => Some (exist _ Nis'447 (eq_refl _))
    | Ninit Nis'473, expression'nt => Some (exist _ Nis'448 (eq_refl _))
    | Ninit Nis'473, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'473, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'473, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'473, compound_statement'nt => Some (exist _ Nis'450 (eq_refl _))
    | Ninit Nis'473, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'473, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'473, asm_statement'nt => Some (exist _ Nis'451 (eq_refl _))
    | Ninit Nis'473, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'473, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'476, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'476, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'476, statement_dangerous'nt => Some (exist _ Nis'477 (eq_refl _))
    | Ninit Nis'476, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'476, selection_statement_dangerous'nt => Some (exist _ Nis'443 (eq_refl _))
    | Ninit Nis'476, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'476, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'476, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'476, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'476, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'476, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'476, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'444 (eq_refl _))
    | Ninit Nis'476, jump_statement'nt => Some (exist _ Nis'445 (eq_refl _))
    | Ninit Nis'476, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'446 (eq_refl _))
    | Ninit Nis'476, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'476, expression_statement'nt => Some (exist _ Nis'447 (eq_refl _))
    | Ninit Nis'476, expression'nt => Some (exist _ Nis'448 (eq_refl _))
    | Ninit Nis'476, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'476, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'476, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'476, compound_statement'nt => Some (exist _ Nis'450 (eq_refl _))
    | Ninit Nis'476, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'476, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'476, asm_statement'nt => Some (exist _ Nis'451 (eq_refl _))
    | Ninit Nis'476, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'476, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'479, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'479, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'479, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'479, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'479, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'479, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'479, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'479, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'479, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'479, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'479, expression'nt => Some (exist _ Nis'482 (eq_refl _))
    | Ninit Nis'479, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'479, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'479, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'479, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'479, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'479, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'479, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'480, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'480, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'480, statement_dangerous'nt => Some (exist _ Nis'481 (eq_refl _))
    | Ninit Nis'480, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'480, selection_statement_dangerous'nt => Some (exist _ Nis'443 (eq_refl _))
    | Ninit Nis'480, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'480, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'480, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'480, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'480, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'480, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'480, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'444 (eq_refl _))
    | Ninit Nis'480, jump_statement'nt => Some (exist _ Nis'445 (eq_refl _))
    | Ninit Nis'480, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'446 (eq_refl _))
    | Ninit Nis'480, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'480, expression_statement'nt => Some (exist _ Nis'447 (eq_refl _))
    | Ninit Nis'480, expression'nt => Some (exist _ Nis'448 (eq_refl _))
    | Ninit Nis'480, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'480, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'480, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'480, compound_statement'nt => Some (exist _ Nis'450 (eq_refl _))
    | Ninit Nis'480, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'480, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'480, asm_statement'nt => Some (exist _ Nis'451 (eq_refl _))
    | Ninit Nis'480, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'480, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'483, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'483, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'483, statement_dangerous'nt => Some (exist _ Nis'484 (eq_refl _))
    | Ninit Nis'483, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'483, selection_statement_dangerous'nt => Some (exist _ Nis'443 (eq_refl _))
    | Ninit Nis'483, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'483, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'483, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'483, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'483, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'483, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'483, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'444 (eq_refl _))
    | Ninit Nis'483, jump_statement'nt => Some (exist _ Nis'445 (eq_refl _))
    | Ninit Nis'483, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'446 (eq_refl _))
    | Ninit Nis'483, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'483, expression_statement'nt => Some (exist _ Nis'447 (eq_refl _))
    | Ninit Nis'483, expression'nt => Some (exist _ Nis'448 (eq_refl _))
    | Ninit Nis'483, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'483, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'483, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'483, compound_statement'nt => Some (exist _ Nis'450 (eq_refl _))
    | Ninit Nis'483, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'483, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'483, asm_statement'nt => Some (exist _ Nis'451 (eq_refl _))
    | Ninit Nis'483, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'483, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'485, pointer'nt => Some (exist _ Nis'185 (eq_refl _))
    | Ninit Nis'485, init_declarator_list'nt => Some (exist _ Nis'486 (eq_refl _))
    | Ninit Nis'485, init_declarator'nt => Some (exist _ Nis'493 (eq_refl _))
    | Ninit Nis'485, direct_declarator'nt => Some (exist _ Nis'235 (eq_refl _))
    | Ninit Nis'485, declarator'nt => Some (exist _ Nis'490 (eq_refl _))
    | Ninit Nis'488, pointer'nt => Some (exist _ Nis'185 (eq_refl _))
    | Ninit Nis'488, init_declarator'nt => Some (exist _ Nis'489 (eq_refl _))
    | Ninit Nis'488, direct_declarator'nt => Some (exist _ Nis'235 (eq_refl _))
    | Ninit Nis'488, declarator'nt => Some (exist _ Nis'490 (eq_refl _))
    | Ninit Nis'491, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'491, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'491, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'491, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'491, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'491, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'491, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'491, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'491, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'491, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'491, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'491, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'491, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'491, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'491, c_initializer'nt => Some (exist _ Nis'492 (eq_refl _))
    | Ninit Nis'491, assignment_expression'nt => Some (exist _ Nis'297 (eq_refl _))
    | Ninit Nis'491, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'491, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'494, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'494, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'494, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'494, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'494, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'494, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'494, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'494, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'494, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'494, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'494, expression'nt => Some (exist _ Nis'501 (eq_refl _))
    | Ninit Nis'494, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'494, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'494, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'494, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'494, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'494, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'494, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'495, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'495, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'495, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'495, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'495, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'495, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'495, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'495, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'495, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'495, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'495, expression'nt => Some (exist _ Nis'498 (eq_refl _))
    | Ninit Nis'495, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'495, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'495, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'495, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'495, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'495, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'495, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'496, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'496, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'496, statement_dangerous'nt => Some (exist _ Nis'497 (eq_refl _))
    | Ninit Nis'496, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'496, selection_statement_dangerous'nt => Some (exist _ Nis'443 (eq_refl _))
    | Ninit Nis'496, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'496, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'496, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'496, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'496, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'496, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'496, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'444 (eq_refl _))
    | Ninit Nis'496, jump_statement'nt => Some (exist _ Nis'445 (eq_refl _))
    | Ninit Nis'496, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'446 (eq_refl _))
    | Ninit Nis'496, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'496, expression_statement'nt => Some (exist _ Nis'447 (eq_refl _))
    | Ninit Nis'496, expression'nt => Some (exist _ Nis'448 (eq_refl _))
    | Ninit Nis'496, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'496, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'496, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'496, compound_statement'nt => Some (exist _ Nis'450 (eq_refl _))
    | Ninit Nis'496, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'496, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'496, asm_statement'nt => Some (exist _ Nis'451 (eq_refl _))
    | Ninit Nis'496, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'496, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'499, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'499, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'499, statement_dangerous'nt => Some (exist _ Nis'500 (eq_refl _))
    | Ninit Nis'499, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'499, selection_statement_dangerous'nt => Some (exist _ Nis'443 (eq_refl _))
    | Ninit Nis'499, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'499, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'499, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'499, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'499, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'499, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'499, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'444 (eq_refl _))
    | Ninit Nis'499, jump_statement'nt => Some (exist _ Nis'445 (eq_refl _))
    | Ninit Nis'499, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'446 (eq_refl _))
    | Ninit Nis'499, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'499, expression_statement'nt => Some (exist _ Nis'447 (eq_refl _))
    | Ninit Nis'499, expression'nt => Some (exist _ Nis'448 (eq_refl _))
    | Ninit Nis'499, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'499, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'499, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'499, compound_statement'nt => Some (exist _ Nis'450 (eq_refl _))
    | Ninit Nis'499, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'499, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'499, asm_statement'nt => Some (exist _ Nis'451 (eq_refl _))
    | Ninit Nis'499, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'499, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'502, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'502, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'502, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'502, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'502, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'502, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'502, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'502, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'502, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'502, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'502, expression'nt => Some (exist _ Nis'505 (eq_refl _))
    | Ninit Nis'502, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'502, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'502, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'502, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'502, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'502, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'502, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'503, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'503, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'503, statement_dangerous'nt => Some (exist _ Nis'504 (eq_refl _))
    | Ninit Nis'503, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'503, selection_statement_dangerous'nt => Some (exist _ Nis'443 (eq_refl _))
    | Ninit Nis'503, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'503, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'503, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'503, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'503, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'503, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'503, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'444 (eq_refl _))
    | Ninit Nis'503, jump_statement'nt => Some (exist _ Nis'445 (eq_refl _))
    | Ninit Nis'503, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'446 (eq_refl _))
    | Ninit Nis'503, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'503, expression_statement'nt => Some (exist _ Nis'447 (eq_refl _))
    | Ninit Nis'503, expression'nt => Some (exist _ Nis'448 (eq_refl _))
    | Ninit Nis'503, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'503, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'503, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'503, compound_statement'nt => Some (exist _ Nis'450 (eq_refl _))
    | Ninit Nis'503, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'503, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'503, asm_statement'nt => Some (exist _ Nis'451 (eq_refl _))
    | Ninit Nis'503, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'503, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'506, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'506, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'506, statement_dangerous'nt => Some (exist _ Nis'507 (eq_refl _))
    | Ninit Nis'506, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'506, selection_statement_dangerous'nt => Some (exist _ Nis'443 (eq_refl _))
    | Ninit Nis'506, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'506, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'506, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'506, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'506, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'506, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'506, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'444 (eq_refl _))
    | Ninit Nis'506, jump_statement'nt => Some (exist _ Nis'445 (eq_refl _))
    | Ninit Nis'506, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'446 (eq_refl _))
    | Ninit Nis'506, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'506, expression_statement'nt => Some (exist _ Nis'447 (eq_refl _))
    | Ninit Nis'506, expression'nt => Some (exist _ Nis'448 (eq_refl _))
    | Ninit Nis'506, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'506, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'506, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'506, compound_statement'nt => Some (exist _ Nis'450 (eq_refl _))
    | Ninit Nis'506, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'506, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'506, asm_statement'nt => Some (exist _ Nis'451 (eq_refl _))
    | Ninit Nis'506, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'506, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'510, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'510, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'510, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'510, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'510, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'510, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'510, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'510, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'510, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'510, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'510, expression'nt => Some (exist _ Nis'511 (eq_refl _))
    | Ninit Nis'510, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'510, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'510, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'510, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'510, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'510, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'510, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'515, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'515, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'515, statement_safe'nt => Some (exist _ Nis'527 (eq_refl _))
    | Ninit Nis'515, statement_dangerous'nt => Some (exist _ Nis'452 (eq_refl _))
    | Ninit Nis'515, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'515, selection_statement_safe'nt => Some (exist _ Nis'520 (eq_refl _))
    | Ninit Nis'515, selection_statement_dangerous'nt => Some (exist _ Nis'443 (eq_refl _))
    | Ninit Nis'515, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'515, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'515, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'515, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'515, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'515, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'515, labeled_statement_statement_safe_'nt => Some (exist _ Nis'521 (eq_refl _))
    | Ninit Nis'515, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'444 (eq_refl _))
    | Ninit Nis'515, jump_statement'nt => Some (exist _ Nis'522 (eq_refl _))
    | Ninit Nis'515, iteration_statement_statement_safe_'nt => Some (exist _ Nis'523 (eq_refl _))
    | Ninit Nis'515, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'446 (eq_refl _))
    | Ninit Nis'515, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'515, expression_statement'nt => Some (exist _ Nis'524 (eq_refl _))
    | Ninit Nis'515, expression'nt => Some (exist _ Nis'448 (eq_refl _))
    | Ninit Nis'515, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'515, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'515, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'515, compound_statement'nt => Some (exist _ Nis'525 (eq_refl _))
    | Ninit Nis'515, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'515, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'515, asm_statement'nt => Some (exist _ Nis'526 (eq_refl _))
    | Ninit Nis'515, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'515, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'516, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'516, unary_expression'nt => Some (exist _ Nis'65 (eq_refl _))
    | Ninit Nis'516, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'516, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'516, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'516, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'516, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'516, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'516, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'516, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'516, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'516, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'516, constant_expression'nt => Some (exist _ Nis'517 (eq_refl _))
    | Ninit Nis'516, conditional_expression'nt => Some (exist _ Nis'256 (eq_refl _))
    | Ninit Nis'516, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'516, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'516, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'518, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'518, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'518, statement_safe'nt => Some (exist _ Nis'519 (eq_refl _))
    | Ninit Nis'518, statement_dangerous'nt => Some (exist _ Nis'442 (eq_refl _))
    | Ninit Nis'518, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'518, selection_statement_safe'nt => Some (exist _ Nis'520 (eq_refl _))
    | Ninit Nis'518, selection_statement_dangerous'nt => Some (exist _ Nis'443 (eq_refl _))
    | Ninit Nis'518, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'518, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'518, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'518, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'518, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'518, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'518, labeled_statement_statement_safe_'nt => Some (exist _ Nis'521 (eq_refl _))
    | Ninit Nis'518, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'444 (eq_refl _))
    | Ninit Nis'518, jump_statement'nt => Some (exist _ Nis'522 (eq_refl _))
    | Ninit Nis'518, iteration_statement_statement_safe_'nt => Some (exist _ Nis'523 (eq_refl _))
    | Ninit Nis'518, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'446 (eq_refl _))
    | Ninit Nis'518, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'518, expression_statement'nt => Some (exist _ Nis'524 (eq_refl _))
    | Ninit Nis'518, expression'nt => Some (exist _ Nis'448 (eq_refl _))
    | Ninit Nis'518, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'518, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'518, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'518, compound_statement'nt => Some (exist _ Nis'525 (eq_refl _))
    | Ninit Nis'518, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'518, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'518, asm_statement'nt => Some (exist _ Nis'526 (eq_refl _))
    | Ninit Nis'518, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'518, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'530, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'530, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'530, statement_safe'nt => Some (exist _ Nis'531 (eq_refl _))
    | Ninit Nis'530, statement_dangerous'nt => Some (exist _ Nis'462 (eq_refl _))
    | Ninit Nis'530, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'530, selection_statement_safe'nt => Some (exist _ Nis'520 (eq_refl _))
    | Ninit Nis'530, selection_statement_dangerous'nt => Some (exist _ Nis'443 (eq_refl _))
    | Ninit Nis'530, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'530, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'530, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'530, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'530, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'530, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'530, labeled_statement_statement_safe_'nt => Some (exist _ Nis'521 (eq_refl _))
    | Ninit Nis'530, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'444 (eq_refl _))
    | Ninit Nis'530, jump_statement'nt => Some (exist _ Nis'522 (eq_refl _))
    | Ninit Nis'530, iteration_statement_statement_safe_'nt => Some (exist _ Nis'523 (eq_refl _))
    | Ninit Nis'530, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'446 (eq_refl _))
    | Ninit Nis'530, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'530, expression_statement'nt => Some (exist _ Nis'524 (eq_refl _))
    | Ninit Nis'530, expression'nt => Some (exist _ Nis'448 (eq_refl _))
    | Ninit Nis'530, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'530, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'530, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'530, compound_statement'nt => Some (exist _ Nis'525 (eq_refl _))
    | Ninit Nis'530, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'530, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'530, asm_statement'nt => Some (exist _ Nis'526 (eq_refl _))
    | Ninit Nis'530, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'530, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'533, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'533, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'533, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'533, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'533, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'533, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'533, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'533, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'533, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'533, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'533, expression'nt => Some (exist _ Nis'536 (eq_refl _))
    | Ninit Nis'533, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'533, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'533, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'533, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'533, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'533, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'533, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'534, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'534, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'534, statement_safe'nt => Some (exist _ Nis'535 (eq_refl _))
    | Ninit Nis'534, statement_dangerous'nt => Some (exist _ Nis'466 (eq_refl _))
    | Ninit Nis'534, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'534, selection_statement_safe'nt => Some (exist _ Nis'520 (eq_refl _))
    | Ninit Nis'534, selection_statement_dangerous'nt => Some (exist _ Nis'443 (eq_refl _))
    | Ninit Nis'534, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'534, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'534, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'534, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'534, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'534, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'534, labeled_statement_statement_safe_'nt => Some (exist _ Nis'521 (eq_refl _))
    | Ninit Nis'534, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'444 (eq_refl _))
    | Ninit Nis'534, jump_statement'nt => Some (exist _ Nis'522 (eq_refl _))
    | Ninit Nis'534, iteration_statement_statement_safe_'nt => Some (exist _ Nis'523 (eq_refl _))
    | Ninit Nis'534, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'446 (eq_refl _))
    | Ninit Nis'534, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'534, expression_statement'nt => Some (exist _ Nis'524 (eq_refl _))
    | Ninit Nis'534, expression'nt => Some (exist _ Nis'448 (eq_refl _))
    | Ninit Nis'534, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'534, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'534, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'534, compound_statement'nt => Some (exist _ Nis'525 (eq_refl _))
    | Ninit Nis'534, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'534, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'534, asm_statement'nt => Some (exist _ Nis'526 (eq_refl _))
    | Ninit Nis'534, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'534, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'537, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'537, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'537, statement_safe'nt => Some (exist _ Nis'538 (eq_refl _))
    | Ninit Nis'537, statement_dangerous'nt => Some (exist _ Nis'469 (eq_refl _))
    | Ninit Nis'537, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'537, selection_statement_safe'nt => Some (exist _ Nis'520 (eq_refl _))
    | Ninit Nis'537, selection_statement_dangerous'nt => Some (exist _ Nis'443 (eq_refl _))
    | Ninit Nis'537, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'537, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'537, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'537, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'537, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'537, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'537, labeled_statement_statement_safe_'nt => Some (exist _ Nis'521 (eq_refl _))
    | Ninit Nis'537, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'444 (eq_refl _))
    | Ninit Nis'537, jump_statement'nt => Some (exist _ Nis'522 (eq_refl _))
    | Ninit Nis'537, iteration_statement_statement_safe_'nt => Some (exist _ Nis'523 (eq_refl _))
    | Ninit Nis'537, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'446 (eq_refl _))
    | Ninit Nis'537, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'537, expression_statement'nt => Some (exist _ Nis'524 (eq_refl _))
    | Ninit Nis'537, expression'nt => Some (exist _ Nis'448 (eq_refl _))
    | Ninit Nis'537, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'537, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'537, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'537, compound_statement'nt => Some (exist _ Nis'525 (eq_refl _))
    | Ninit Nis'537, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'537, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'537, asm_statement'nt => Some (exist _ Nis'526 (eq_refl _))
    | Ninit Nis'537, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'537, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'540, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'540, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'540, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'540, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'540, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'540, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'540, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'540, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'540, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'540, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'540, expression'nt => Some (exist _ Nis'547 (eq_refl _))
    | Ninit Nis'540, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'540, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'540, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'540, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'540, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'540, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'540, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'541, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'541, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'541, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'541, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'541, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'541, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'541, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'541, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'541, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'541, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'541, expression'nt => Some (exist _ Nis'544 (eq_refl _))
    | Ninit Nis'541, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'541, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'541, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'541, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'541, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'541, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'541, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'542, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'542, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'542, statement_safe'nt => Some (exist _ Nis'543 (eq_refl _))
    | Ninit Nis'542, statement_dangerous'nt => Some (exist _ Nis'474 (eq_refl _))
    | Ninit Nis'542, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'542, selection_statement_safe'nt => Some (exist _ Nis'520 (eq_refl _))
    | Ninit Nis'542, selection_statement_dangerous'nt => Some (exist _ Nis'443 (eq_refl _))
    | Ninit Nis'542, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'542, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'542, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'542, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'542, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'542, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'542, labeled_statement_statement_safe_'nt => Some (exist _ Nis'521 (eq_refl _))
    | Ninit Nis'542, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'444 (eq_refl _))
    | Ninit Nis'542, jump_statement'nt => Some (exist _ Nis'522 (eq_refl _))
    | Ninit Nis'542, iteration_statement_statement_safe_'nt => Some (exist _ Nis'523 (eq_refl _))
    | Ninit Nis'542, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'446 (eq_refl _))
    | Ninit Nis'542, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'542, expression_statement'nt => Some (exist _ Nis'524 (eq_refl _))
    | Ninit Nis'542, expression'nt => Some (exist _ Nis'448 (eq_refl _))
    | Ninit Nis'542, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'542, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'542, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'542, compound_statement'nt => Some (exist _ Nis'525 (eq_refl _))
    | Ninit Nis'542, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'542, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'542, asm_statement'nt => Some (exist _ Nis'526 (eq_refl _))
    | Ninit Nis'542, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'542, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'545, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'545, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'545, statement_safe'nt => Some (exist _ Nis'546 (eq_refl _))
    | Ninit Nis'545, statement_dangerous'nt => Some (exist _ Nis'477 (eq_refl _))
    | Ninit Nis'545, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'545, selection_statement_safe'nt => Some (exist _ Nis'520 (eq_refl _))
    | Ninit Nis'545, selection_statement_dangerous'nt => Some (exist _ Nis'443 (eq_refl _))
    | Ninit Nis'545, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'545, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'545, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'545, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'545, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'545, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'545, labeled_statement_statement_safe_'nt => Some (exist _ Nis'521 (eq_refl _))
    | Ninit Nis'545, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'444 (eq_refl _))
    | Ninit Nis'545, jump_statement'nt => Some (exist _ Nis'522 (eq_refl _))
    | Ninit Nis'545, iteration_statement_statement_safe_'nt => Some (exist _ Nis'523 (eq_refl _))
    | Ninit Nis'545, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'446 (eq_refl _))
    | Ninit Nis'545, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'545, expression_statement'nt => Some (exist _ Nis'524 (eq_refl _))
    | Ninit Nis'545, expression'nt => Some (exist _ Nis'448 (eq_refl _))
    | Ninit Nis'545, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'545, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'545, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'545, compound_statement'nt => Some (exist _ Nis'525 (eq_refl _))
    | Ninit Nis'545, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'545, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'545, asm_statement'nt => Some (exist _ Nis'526 (eq_refl _))
    | Ninit Nis'545, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'545, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'548, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'548, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'548, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'548, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'548, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'548, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'548, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'548, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'548, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'548, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'548, expression'nt => Some (exist _ Nis'551 (eq_refl _))
    | Ninit Nis'548, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'548, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'548, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'548, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'548, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'548, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'548, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'549, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'549, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'549, statement_safe'nt => Some (exist _ Nis'550 (eq_refl _))
    | Ninit Nis'549, statement_dangerous'nt => Some (exist _ Nis'481 (eq_refl _))
    | Ninit Nis'549, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'549, selection_statement_safe'nt => Some (exist _ Nis'520 (eq_refl _))
    | Ninit Nis'549, selection_statement_dangerous'nt => Some (exist _ Nis'443 (eq_refl _))
    | Ninit Nis'549, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'549, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'549, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'549, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'549, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'549, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'549, labeled_statement_statement_safe_'nt => Some (exist _ Nis'521 (eq_refl _))
    | Ninit Nis'549, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'444 (eq_refl _))
    | Ninit Nis'549, jump_statement'nt => Some (exist _ Nis'522 (eq_refl _))
    | Ninit Nis'549, iteration_statement_statement_safe_'nt => Some (exist _ Nis'523 (eq_refl _))
    | Ninit Nis'549, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'446 (eq_refl _))
    | Ninit Nis'549, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'549, expression_statement'nt => Some (exist _ Nis'524 (eq_refl _))
    | Ninit Nis'549, expression'nt => Some (exist _ Nis'448 (eq_refl _))
    | Ninit Nis'549, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'549, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'549, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'549, compound_statement'nt => Some (exist _ Nis'525 (eq_refl _))
    | Ninit Nis'549, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'549, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'549, asm_statement'nt => Some (exist _ Nis'526 (eq_refl _))
    | Ninit Nis'549, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'549, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'552, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'552, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'552, statement_safe'nt => Some (exist _ Nis'553 (eq_refl _))
    | Ninit Nis'552, statement_dangerous'nt => Some (exist _ Nis'484 (eq_refl _))
    | Ninit Nis'552, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'552, selection_statement_safe'nt => Some (exist _ Nis'520 (eq_refl _))
    | Ninit Nis'552, selection_statement_dangerous'nt => Some (exist _ Nis'443 (eq_refl _))
    | Ninit Nis'552, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'552, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'552, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'552, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'552, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'552, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'552, labeled_statement_statement_safe_'nt => Some (exist _ Nis'521 (eq_refl _))
    | Ninit Nis'552, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'444 (eq_refl _))
    | Ninit Nis'552, jump_statement'nt => Some (exist _ Nis'522 (eq_refl _))
    | Ninit Nis'552, iteration_statement_statement_safe_'nt => Some (exist _ Nis'523 (eq_refl _))
    | Ninit Nis'552, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'446 (eq_refl _))
    | Ninit Nis'552, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'552, expression_statement'nt => Some (exist _ Nis'524 (eq_refl _))
    | Ninit Nis'552, expression'nt => Some (exist _ Nis'448 (eq_refl _))
    | Ninit Nis'552, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'552, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'552, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'552, compound_statement'nt => Some (exist _ Nis'525 (eq_refl _))
    | Ninit Nis'552, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'552, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'552, asm_statement'nt => Some (exist _ Nis'526 (eq_refl _))
    | Ninit Nis'552, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'552, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'554, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'554, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'554, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'554, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'554, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'554, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'554, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'554, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'554, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'554, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'554, expression'nt => Some (exist _ Nis'561 (eq_refl _))
    | Ninit Nis'554, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'554, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'554, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'554, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'554, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'554, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'554, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'555, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'555, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'555, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'555, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'555, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'555, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'555, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'555, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'555, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'555, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'555, expression'nt => Some (exist _ Nis'558 (eq_refl _))
    | Ninit Nis'555, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'555, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'555, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'555, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'555, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'555, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'555, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'556, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'556, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'556, statement_safe'nt => Some (exist _ Nis'557 (eq_refl _))
    | Ninit Nis'556, statement_dangerous'nt => Some (exist _ Nis'497 (eq_refl _))
    | Ninit Nis'556, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'556, selection_statement_safe'nt => Some (exist _ Nis'520 (eq_refl _))
    | Ninit Nis'556, selection_statement_dangerous'nt => Some (exist _ Nis'443 (eq_refl _))
    | Ninit Nis'556, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'556, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'556, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'556, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'556, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'556, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'556, labeled_statement_statement_safe_'nt => Some (exist _ Nis'521 (eq_refl _))
    | Ninit Nis'556, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'444 (eq_refl _))
    | Ninit Nis'556, jump_statement'nt => Some (exist _ Nis'522 (eq_refl _))
    | Ninit Nis'556, iteration_statement_statement_safe_'nt => Some (exist _ Nis'523 (eq_refl _))
    | Ninit Nis'556, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'446 (eq_refl _))
    | Ninit Nis'556, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'556, expression_statement'nt => Some (exist _ Nis'524 (eq_refl _))
    | Ninit Nis'556, expression'nt => Some (exist _ Nis'448 (eq_refl _))
    | Ninit Nis'556, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'556, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'556, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'556, compound_statement'nt => Some (exist _ Nis'525 (eq_refl _))
    | Ninit Nis'556, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'556, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'556, asm_statement'nt => Some (exist _ Nis'526 (eq_refl _))
    | Ninit Nis'556, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'556, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'559, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'559, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'559, statement_safe'nt => Some (exist _ Nis'560 (eq_refl _))
    | Ninit Nis'559, statement_dangerous'nt => Some (exist _ Nis'500 (eq_refl _))
    | Ninit Nis'559, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'559, selection_statement_safe'nt => Some (exist _ Nis'520 (eq_refl _))
    | Ninit Nis'559, selection_statement_dangerous'nt => Some (exist _ Nis'443 (eq_refl _))
    | Ninit Nis'559, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'559, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'559, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'559, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'559, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'559, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'559, labeled_statement_statement_safe_'nt => Some (exist _ Nis'521 (eq_refl _))
    | Ninit Nis'559, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'444 (eq_refl _))
    | Ninit Nis'559, jump_statement'nt => Some (exist _ Nis'522 (eq_refl _))
    | Ninit Nis'559, iteration_statement_statement_safe_'nt => Some (exist _ Nis'523 (eq_refl _))
    | Ninit Nis'559, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'446 (eq_refl _))
    | Ninit Nis'559, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'559, expression_statement'nt => Some (exist _ Nis'524 (eq_refl _))
    | Ninit Nis'559, expression'nt => Some (exist _ Nis'448 (eq_refl _))
    | Ninit Nis'559, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'559, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'559, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'559, compound_statement'nt => Some (exist _ Nis'525 (eq_refl _))
    | Ninit Nis'559, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'559, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'559, asm_statement'nt => Some (exist _ Nis'526 (eq_refl _))
    | Ninit Nis'559, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'559, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'562, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'562, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'562, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'562, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'562, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'562, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'562, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'562, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'562, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'562, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'562, expression'nt => Some (exist _ Nis'565 (eq_refl _))
    | Ninit Nis'562, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'562, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'562, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'562, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'562, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'562, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'562, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'563, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'563, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'563, statement_safe'nt => Some (exist _ Nis'564 (eq_refl _))
    | Ninit Nis'563, statement_dangerous'nt => Some (exist _ Nis'504 (eq_refl _))
    | Ninit Nis'563, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'563, selection_statement_safe'nt => Some (exist _ Nis'520 (eq_refl _))
    | Ninit Nis'563, selection_statement_dangerous'nt => Some (exist _ Nis'443 (eq_refl _))
    | Ninit Nis'563, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'563, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'563, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'563, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'563, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'563, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'563, labeled_statement_statement_safe_'nt => Some (exist _ Nis'521 (eq_refl _))
    | Ninit Nis'563, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'444 (eq_refl _))
    | Ninit Nis'563, jump_statement'nt => Some (exist _ Nis'522 (eq_refl _))
    | Ninit Nis'563, iteration_statement_statement_safe_'nt => Some (exist _ Nis'523 (eq_refl _))
    | Ninit Nis'563, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'446 (eq_refl _))
    | Ninit Nis'563, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'563, expression_statement'nt => Some (exist _ Nis'524 (eq_refl _))
    | Ninit Nis'563, expression'nt => Some (exist _ Nis'448 (eq_refl _))
    | Ninit Nis'563, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'563, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'563, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'563, compound_statement'nt => Some (exist _ Nis'525 (eq_refl _))
    | Ninit Nis'563, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'563, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'563, asm_statement'nt => Some (exist _ Nis'526 (eq_refl _))
    | Ninit Nis'563, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'563, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'566, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'566, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'566, statement_safe'nt => Some (exist _ Nis'567 (eq_refl _))
    | Ninit Nis'566, statement_dangerous'nt => Some (exist _ Nis'507 (eq_refl _))
    | Ninit Nis'566, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'566, selection_statement_safe'nt => Some (exist _ Nis'520 (eq_refl _))
    | Ninit Nis'566, selection_statement_dangerous'nt => Some (exist _ Nis'443 (eq_refl _))
    | Ninit Nis'566, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'566, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'566, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'566, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'566, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'566, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'566, labeled_statement_statement_safe_'nt => Some (exist _ Nis'521 (eq_refl _))
    | Ninit Nis'566, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'444 (eq_refl _))
    | Ninit Nis'566, jump_statement'nt => Some (exist _ Nis'522 (eq_refl _))
    | Ninit Nis'566, iteration_statement_statement_safe_'nt => Some (exist _ Nis'523 (eq_refl _))
    | Ninit Nis'566, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'446 (eq_refl _))
    | Ninit Nis'566, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'566, expression_statement'nt => Some (exist _ Nis'524 (eq_refl _))
    | Ninit Nis'566, expression'nt => Some (exist _ Nis'448 (eq_refl _))
    | Ninit Nis'566, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'566, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'566, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'566, compound_statement'nt => Some (exist _ Nis'525 (eq_refl _))
    | Ninit Nis'566, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'566, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'566, asm_statement'nt => Some (exist _ Nis'526 (eq_refl _))
    | Ninit Nis'566, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'566, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'569, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'569, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'569, statement_safe'nt => Some (exist _ Nis'570 (eq_refl _))
    | Ninit Nis'569, statement_dangerous'nt => Some (exist _ Nis'571 (eq_refl _))
    | Ninit Nis'569, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'569, selection_statement_safe'nt => Some (exist _ Nis'520 (eq_refl _))
    | Ninit Nis'569, selection_statement_dangerous'nt => Some (exist _ Nis'443 (eq_refl _))
    | Ninit Nis'569, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'569, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'569, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'569, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'569, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'569, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'569, labeled_statement_statement_safe_'nt => Some (exist _ Nis'521 (eq_refl _))
    | Ninit Nis'569, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'444 (eq_refl _))
    | Ninit Nis'569, jump_statement'nt => Some (exist _ Nis'522 (eq_refl _))
    | Ninit Nis'569, iteration_statement_statement_safe_'nt => Some (exist _ Nis'523 (eq_refl _))
    | Ninit Nis'569, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'446 (eq_refl _))
    | Ninit Nis'569, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'569, expression_statement'nt => Some (exist _ Nis'524 (eq_refl _))
    | Ninit Nis'569, expression'nt => Some (exist _ Nis'448 (eq_refl _))
    | Ninit Nis'569, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'569, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'569, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'569, compound_statement'nt => Some (exist _ Nis'525 (eq_refl _))
    | Ninit Nis'569, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'569, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'569, asm_statement'nt => Some (exist _ Nis'526 (eq_refl _))
    | Ninit Nis'569, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'569, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'580, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'580, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'580, statement_dangerous'nt => Some (exist _ Nis'571 (eq_refl _))
    | Ninit Nis'580, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'580, selection_statement_dangerous'nt => Some (exist _ Nis'443 (eq_refl _))
    | Ninit Nis'580, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'580, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'580, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'580, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'580, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'580, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'580, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'444 (eq_refl _))
    | Ninit Nis'580, jump_statement'nt => Some (exist _ Nis'445 (eq_refl _))
    | Ninit Nis'580, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'446 (eq_refl _))
    | Ninit Nis'580, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'580, expression_statement'nt => Some (exist _ Nis'447 (eq_refl _))
    | Ninit Nis'580, expression'nt => Some (exist _ Nis'448 (eq_refl _))
    | Ninit Nis'580, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'580, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'580, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'580, compound_statement'nt => Some (exist _ Nis'450 (eq_refl _))
    | Ninit Nis'580, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'580, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'580, asm_statement'nt => Some (exist _ Nis'451 (eq_refl _))
    | Ninit Nis'580, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'580, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'585, unary_operator'nt => Some (exist _ Nis'64 (eq_refl _))
    | Ninit Nis'585, unary_expression'nt => Some (exist _ Nis'72 (eq_refl _))
    | Ninit Nis'585, type_specifier'nt => Some (exist _ Nis'192 (eq_refl _))
    | Ninit Nis'585, type_qualifier'nt => Some (exist _ Nis'193 (eq_refl _))
    | Ninit Nis'585, struct_or_union_specifier'nt => Some (exist _ Nis'166 (eq_refl _))
    | Ninit Nis'585, struct_or_union'nt => Some (exist _ Nis'167 (eq_refl _))
    | Ninit Nis'585, storage_class_specifier'nt => Some (exist _ Nis'194 (eq_refl _))
    | Ninit Nis'585, statement_dangerous'nt => Some (exist _ Nis'583 (eq_refl _))
    | Ninit Nis'585, shift_expression'nt => Some (exist _ Nis'85 (eq_refl _))
    | Ninit Nis'585, selection_statement_dangerous'nt => Some (exist _ Nis'443 (eq_refl _))
    | Ninit Nis'585, relational_expression'nt => Some (exist _ Nis'102 (eq_refl _))
    | Ninit Nis'585, primary_expression'nt => Some (exist _ Nis'66 (eq_refl _))
    | Ninit Nis'585, postfix_expression'nt => Some (exist _ Nis'67 (eq_refl _))
    | Ninit Nis'585, multiplicative_expression'nt => Some (exist _ Nis'87 (eq_refl _))
    | Ninit Nis'585, logical_OR_expression'nt => Some (exist _ Nis'112 (eq_refl _))
    | Ninit Nis'585, logical_AND_expression'nt => Some (exist _ Nis'114 (eq_refl _))
    | Ninit Nis'585, labeled_statement_statement_dangerous_'nt => Some (exist _ Nis'444 (eq_refl _))
    | Ninit Nis'585, jump_statement'nt => Some (exist _ Nis'445 (eq_refl _))
    | Ninit Nis'585, iteration_statement_statement_dangerous_'nt => Some (exist _ Nis'446 (eq_refl _))
    | Ninit Nis'585, inclusive_OR_expression'nt => Some (exist _ Nis'130 (eq_refl _))
    | Ninit Nis'585, function_specifier'nt => Some (exist _ Nis'195 (eq_refl _))
    | Ninit Nis'585, expression_statement'nt => Some (exist _ Nis'447 (eq_refl _))
    | Ninit Nis'585, expression'nt => Some (exist _ Nis'448 (eq_refl _))
    | Ninit Nis'585, exclusive_OR_expression'nt => Some (exist _ Nis'129 (eq_refl _))
    | Ninit Nis'585, equality_expression'nt => Some (exist _ Nis'120 (eq_refl _))
    | Ninit Nis'585, enum_specifier'nt => Some (exist _ Nis'196 (eq_refl _))
    | Ninit Nis'585, declaration_specifiers'nt => Some (exist _ Nis'485 (eq_refl _))
    | Ninit Nis'585, declaration'nt => Some (exist _ Nis'584 (eq_refl _))
    | Ninit Nis'585, conditional_expression'nt => Some (exist _ Nis'133 (eq_refl _))
    | Ninit Nis'585, compound_statement'nt => Some (exist _ Nis'450 (eq_refl _))
    | Ninit Nis'585, cast_expression'nt => Some (exist _ Nis'94 (eq_refl _))
    | Ninit Nis'585, block_item'nt => Some (exist _ Nis'587 (eq_refl _))
    | Ninit Nis'585, attribute_specifier'nt => Some (exist _ Nis'180 (eq_refl _))
    | Ninit Nis'585, assignment_expression'nt => Some (exist _ Nis'137 (eq_refl _))
    | Ninit Nis'585, asm_statement'nt => Some (exist _ Nis'451 (eq_refl _))
    | Ninit Nis'585, additive_expression'nt => Some (exist _ Nis'105 (eq_refl _))
    | Ninit Nis'585, AND_expression'nt => Some (exist _ Nis'128 (eq_refl _))
    | Ninit Nis'592, attribute_specifier_list'nt => Some (exist _ Nis'244 (eq_refl _))
    | Ninit Nis'593, compound_statement'nt => Some (exist _ Nis'594 (eq_refl _))
    | _, _ => None
  end.

Definition past_symb_of_non_init_state (noninitstate:noninitstate) : list symbol :=
  match noninitstate with
    | Nis'1 => []
    | Nis'2 => []
    | Nis'3 => []
    | Nis'4 => []
    | Nis'5 => []
    | Nis'6 => []
    | Nis'7 => []
    | Nis'8 => []
    | Nis'9 => []
    | Nis'10 => []
    | Nis'11 => []
    | Nis'12 => []
    | Nis'13 => []
    | Nis'14 => []
    | Nis'15 => []
    | Nis'16 => []
    | Nis'17 => [T PACKED't]
    | Nis'18 => []
    | Nis'19 => []
    | Nis'20 => []
    | Nis'21 => []
    | Nis'22 => []
    | Nis'23 => []
    | Nis'24 => []
    | Nis'25 => [T SIZEOF't]
    | Nis'26 => []
    | Nis'27 => []
    | Nis'28 => []
    | Nis'29 => []
    | Nis'30 => []
    | Nis'31 => []
    | Nis'32 => []
    | Nis'33 => [T ENUM't]
    | Nis'34 => [NT attribute_specifier_list'nt; T ENUM't]
    | Nis'35 => [T OTHER_NAME't; NT attribute_specifier_list'nt; T ENUM't]
    | Nis'36 => []
    | Nis'37 => [T LBRACE't; T OTHER_NAME't; NT attribute_specifier_list'nt; T ENUM't]
    | Nis'38 => [NT enumerator_list'nt; T LBRACE't; T OTHER_NAME't; NT attribute_specifier_list'nt; T ENUM't]
    | Nis'39 => [NT enumerator_list'nt; T LBRACE't; T OTHER_NAME't; NT attribute_specifier_list'nt; T ENUM't]
    | Nis'40 => [T COMMA't; NT enumerator_list'nt; T LBRACE't; T OTHER_NAME't; NT attribute_specifier_list'nt; T ENUM't]
    | Nis'41 => [T COMMA't; NT enumerator_list'nt]
    | Nis'42 => []
    | Nis'43 => [NT enumeration_constant'nt]
    | Nis'44 => []
    | Nis'45 => []
    | Nis'46 => []
    | Nis'47 => [T BUILTIN_VA_ARG't]
    | Nis'48 => []
    | Nis'49 => []
    | Nis'50 => []
    | Nis'51 => [T ALIGNOF't]
    | Nis'52 => []
    | Nis'53 => []
    | Nis'54 => []
    | Nis'55 => []
    | Nis'56 => [T ATTRIBUTE't]
    | Nis'57 => [T LPAREN't; T ATTRIBUTE't]
    | Nis'58 => []
    | Nis'59 => []
    | Nis'60 => []
    | Nis'61 => []
    | Nis'62 => [NT gcc_attribute_word'nt]
    | Nis'63 => [T LPAREN't; NT gcc_attribute_word'nt]
    | Nis'64 => []
    | Nis'65 => []
    | Nis'66 => []
    | Nis'67 => []
    | Nis'68 => [NT postfix_expression'nt]
    | Nis'69 => [T PTR't; NT postfix_expression'nt]
    | Nis'70 => [NT postfix_expression'nt]
    | Nis'71 => [T LPAREN't; NT postfix_expression'nt]
    | Nis'72 => []
    | Nis'73 => []
    | Nis'74 => []
    | Nis'75 => []
    | Nis'76 => []
    | Nis'77 => []
    | Nis'78 => []
    | Nis'79 => []
    | Nis'80 => []
    | Nis'81 => []
    | Nis'82 => []
    | Nis'83 => []
    | Nis'84 => [NT unary_expression'nt]
    | Nis'85 => []
    | Nis'86 => [NT shift_expression'nt]
    | Nis'87 => []
    | Nis'88 => [NT multiplicative_expression'nt]
    | Nis'89 => [T STAR't; NT multiplicative_expression'nt]
    | Nis'90 => [NT multiplicative_expression'nt]
    | Nis'91 => [T SLASH't; NT multiplicative_expression'nt]
    | Nis'92 => [NT multiplicative_expression'nt]
    | Nis'93 => [T PERCENT't; NT multiplicative_expression'nt]
    | Nis'94 => []
    | Nis'95 => [T RIGHT't; NT shift_expression'nt]
    | Nis'96 => [NT additive_expression'nt]
    | Nis'97 => [T PLUS't; NT additive_expression'nt]
    | Nis'98 => [NT additive_expression'nt]
    | Nis'99 => [T MINUS't; NT additive_expression'nt]
    | Nis'100 => [NT shift_expression'nt]
    | Nis'101 => [T LEFT't; NT shift_expression'nt]
    | Nis'102 => []
    | Nis'103 => [NT relational_expression'nt]
    | Nis'104 => [T LT't; NT relational_expression'nt]
    | Nis'105 => []
    | Nis'106 => [NT relational_expression'nt]
    | Nis'107 => [T LEQ't; NT relational_expression'nt]
    | Nis'108 => [NT relational_expression'nt]
    | Nis'109 => [T GT't; NT relational_expression'nt]
    | Nis'110 => [NT relational_expression'nt]
    | Nis'111 => [T GEQ't; NT relational_expression'nt]
    | Nis'112 => []
    | Nis'113 => [NT logical_OR_expression'nt]
    | Nis'114 => []
    | Nis'115 => [NT logical_AND_expression'nt]
    | Nis'116 => [T ANDAND't; NT logical_AND_expression'nt]
    | Nis'117 => [NT inclusive_OR_expression'nt]
    | Nis'118 => [T BAR't; NT inclusive_OR_expression'nt]
    | Nis'119 => [NT exclusive_OR_expression'nt]
    | Nis'120 => []
    | Nis'121 => [NT equality_expression'nt]
    | Nis'122 => [T NEQ't; NT equality_expression'nt]
    | Nis'123 => [NT equality_expression'nt]
    | Nis'124 => [T EQEQ't; NT equality_expression'nt]
    | Nis'125 => [T HAT't; NT exclusive_OR_expression'nt]
    | Nis'126 => [NT AND_expression'nt]
    | Nis'127 => [T AND't; NT AND_expression'nt]
    | Nis'128 => []
    | Nis'129 => []
    | Nis'130 => []
    | Nis'131 => [T QUESTION't; NT logical_OR_expression'nt]
    | Nis'132 => [NT expression'nt]
    | Nis'133 => []
    | Nis'134 => [T COMMA't; NT expression'nt]
    | Nis'135 => [NT expression'nt; T QUESTION't; NT logical_OR_expression'nt]
    | Nis'136 => [T COLON't; NT expression'nt; T QUESTION't; NT logical_OR_expression'nt]
    | Nis'137 => []
    | Nis'138 => [NT logical_OR_expression'nt]
    | Nis'139 => [T BARBAR't; NT logical_OR_expression'nt]
    | Nis'140 => [NT assignment_operator'nt; NT unary_expression'nt]
    | Nis'141 => []
    | Nis'142 => [T LPAREN't; NT postfix_expression'nt]
    | Nis'143 => [NT argument_expression_list'nt; T LPAREN't; NT postfix_expression'nt]
    | Nis'144 => [NT argument_expression_list'nt]
    | Nis'145 => [T COMMA't; NT argument_expression_list'nt]
    | Nis'146 => [NT postfix_expression'nt]
    | Nis'147 => [T LBRACK't; NT postfix_expression'nt]
    | Nis'148 => [NT expression'nt; T LBRACK't; NT postfix_expression'nt]
    | Nis'149 => [NT postfix_expression'nt]
    | Nis'150 => [NT postfix_expression'nt]
    | Nis'151 => [T DOT't; NT postfix_expression'nt]
    | Nis'152 => [NT postfix_expression'nt]
    | Nis'153 => [NT unary_operator'nt]
    | Nis'154 => [T LPAREN't; NT gcc_attribute_word'nt]
    | Nis'155 => [NT argument_expression_list'nt; T LPAREN't; NT gcc_attribute_word'nt]
    | Nis'156 => [T LPAREN't; T LPAREN't; T ATTRIBUTE't]
    | Nis'157 => [NT gcc_attribute_list'nt; T LPAREN't; T LPAREN't; T ATTRIBUTE't]
    | Nis'158 => [T RPAREN't; NT gcc_attribute_list'nt; T LPAREN't; T LPAREN't; T ATTRIBUTE't]
    | Nis'159 => [NT gcc_attribute_list'nt]
    | Nis'160 => [T COMMA't; NT gcc_attribute_list'nt]
    | Nis'161 => []
    | Nis'162 => []
    | Nis'163 => [T ALIGNAS't]
    | Nis'164 => []
    | Nis'165 => []
    | Nis'166 => []
    | Nis'167 => []
    | Nis'168 => [NT struct_or_union'nt]
    | Nis'169 => [NT attribute_specifier_list'nt; NT struct_or_union'nt]
    | Nis'170 => [T OTHER_NAME't; NT attribute_specifier_list'nt; NT struct_or_union'nt]
    | Nis'171 => [T LBRACE't; T OTHER_NAME't; NT attribute_specifier_list'nt; NT struct_or_union'nt]
    | Nis'172 => [NT struct_declaration_list'nt; T LBRACE't; T OTHER_NAME't; NT attribute_specifier_list'nt; NT struct_or_union'nt]
    | Nis'173 => [NT struct_declaration_list'nt]
    | Nis'174 => []
    | Nis'175 => []
    | Nis'176 => []
    | Nis'177 => [T STAR't]
    | Nis'178 => [NT type_qualifier_list'nt]
    | Nis'179 => [NT type_qualifier_list'nt; T STAR't]
    | Nis'180 => []
    | Nis'181 => []
    | Nis'182 => [T STAR't]
    | Nis'183 => [NT specifier_qualifier_list'nt]
    | Nis'184 => []
    | Nis'185 => []
    | Nis'186 => [NT pointer'nt]
    | Nis'187 => [NT direct_declarator'nt]
    | Nis'188 => [T LPAREN't; NT direct_declarator'nt]
    | Nis'189 => []
    | Nis'190 => []
    | Nis'191 => []
    | Nis'192 => []
    | Nis'193 => []
    | Nis'194 => []
    | Nis'195 => []
    | Nis'196 => []
    | Nis'197 => [NT function_specifier'nt]
    | Nis'198 => [NT storage_class_specifier'nt]
    | Nis'199 => [NT type_qualifier'nt]
    | Nis'200 => [NT type_specifier'nt]
    | Nis'201 => [T LPAREN't; NT direct_declarator'nt]
    | Nis'202 => [NT parameter_type_list'nt; T LPAREN't; NT direct_declarator'nt]
    | Nis'203 => []
    | Nis'204 => [NT parameter_list'nt]
    | Nis'205 => [T COMMA't; NT parameter_list'nt]
    | Nis'206 => [T COMMA't; NT parameter_list'nt]
    | Nis'207 => []
    | Nis'208 => []
    | Nis'209 => [T LPAREN't]
    | Nis'210 => []
    | Nis'211 => [T LBRACK't]
    | Nis'212 => [T LBRACK't]
    | Nis'213 => [NT type_qualifier_list'nt; T LBRACK't]
    | Nis'214 => [NT type_qualifier_list'nt; T LBRACK't]
    | Nis'215 => [NT assignment_expression'nt; NT type_qualifier_list'nt; T LBRACK't]
    | Nis'216 => [T LBRACK't]
    | Nis'217 => [NT assignment_expression'nt; T LBRACK't]
    | Nis'218 => []
    | Nis'219 => [NT pointer'nt]
    | Nis'220 => [NT direct_abstract_declarator'nt]
    | Nis'221 => [T LPAREN't; NT direct_abstract_declarator'nt]
    | Nis'222 => [T LPAREN't; NT direct_abstract_declarator'nt]
    | Nis'223 => [NT parameter_type_list'nt; T LPAREN't; NT direct_abstract_declarator'nt]
    | Nis'224 => []
    | Nis'225 => [NT direct_abstract_declarator'nt]
    | Nis'226 => [T LBRACK't; NT direct_abstract_declarator'nt]
    | Nis'227 => [T LBRACK't; NT direct_abstract_declarator'nt]
    | Nis'228 => [NT type_qualifier_list'nt; T LBRACK't; NT direct_abstract_declarator'nt]
    | Nis'229 => [NT type_qualifier_list'nt; T LBRACK't; NT direct_abstract_declarator'nt]
    | Nis'230 => [NT assignment_expression'nt; NT type_qualifier_list'nt; T LBRACK't; NT direct_abstract_declarator'nt]
    | Nis'231 => [T LBRACK't; NT direct_abstract_declarator'nt]
    | Nis'232 => [NT assignment_expression'nt; T LBRACK't; NT direct_abstract_declarator'nt]
    | Nis'233 => [T LPAREN't]
    | Nis'234 => [NT parameter_type_list'nt; T LPAREN't]
    | Nis'235 => []
    | Nis'236 => [NT direct_declarator'nt]
    | Nis'237 => [T LBRACK't; NT direct_declarator'nt]
    | Nis'238 => [T LBRACK't; NT direct_declarator'nt]
    | Nis'239 => [NT type_qualifier_list'nt; T LBRACK't; NT direct_declarator'nt]
    | Nis'240 => [NT type_qualifier_list'nt; T LBRACK't; NT direct_declarator'nt]
    | Nis'241 => [NT assignment_expression'nt; NT type_qualifier_list'nt; T LBRACK't; NT direct_declarator'nt]
    | Nis'242 => [T LBRACK't; NT direct_declarator'nt]
    | Nis'243 => [NT assignment_expression'nt; T LBRACK't; NT direct_declarator'nt]
    | Nis'244 => [NT direct_declarator'nt]
    | Nis'245 => [NT attribute_specifier_list'nt]
    | Nis'246 => []
    | Nis'247 => [T LPAREN't]
    | Nis'248 => [NT declarator'nt; T LPAREN't]
    | Nis'249 => [T LPAREN't]
    | Nis'250 => [NT abstract_declarator'nt; T LPAREN't]
    | Nis'251 => [NT declaration_specifiers'nt]
    | Nis'252 => [NT declaration_specifiers'nt]
    | Nis'253 => [NT direct_declarator'nt; NT pointer'nt]
    | Nis'254 => []
    | Nis'255 => [T COLON't]
    | Nis'256 => []
    | Nis'257 => [NT specifier_qualifier_list'nt]
    | Nis'258 => [NT struct_declarator_list'nt; NT specifier_qualifier_list'nt]
    | Nis'259 => [NT struct_declarator_list'nt]
    | Nis'260 => [T COMMA't; NT struct_declarator_list'nt]
    | Nis'261 => []
    | Nis'262 => [NT declarator'nt]
    | Nis'263 => [T COLON't; NT declarator'nt]
    | Nis'264 => []
    | Nis'265 => [NT attribute_specifier_list'nt; NT struct_or_union'nt]
    | Nis'266 => [T LBRACE't; NT attribute_specifier_list'nt; NT struct_or_union'nt]
    | Nis'267 => [NT struct_declaration_list'nt; T LBRACE't; NT attribute_specifier_list'nt; NT struct_or_union'nt]
    | Nis'268 => [NT type_qualifier'nt]
    | Nis'269 => [NT type_specifier'nt]
    | Nis'270 => [T LPAREN't; T ALIGNAS't]
    | Nis'271 => [NT type_name'nt; T LPAREN't; T ALIGNAS't]
    | Nis'272 => []
    | Nis'273 => []
    | Nis'274 => []
    | Nis'275 => [NT specifier_qualifier_list'nt]
    | Nis'276 => [T LPAREN't; T ALIGNAS't]
    | Nis'277 => [NT argument_expression_list'nt; T LPAREN't; T ALIGNAS't]
    | Nis'278 => [T LPAREN't; T ALIGNOF't]
    | Nis'279 => [NT type_name'nt; T LPAREN't; T ALIGNOF't]
    | Nis'280 => [T RPAREN't; NT type_name'nt; T LPAREN't]
    | Nis'281 => []
    | Nis'282 => [T LBRACK't]
    | Nis'283 => [NT constant_expression'nt; T LBRACK't]
    | Nis'284 => []
    | Nis'285 => []
    | Nis'286 => [T DOT't]
    | Nis'287 => [T LBRACE't]
    | Nis'288 => [NT initializer_list'nt; T LBRACE't]
    | Nis'289 => [NT initializer_list'nt; T LBRACE't]
    | Nis'290 => [T COMMA't; NT initializer_list'nt; T LBRACE't]
    | Nis'291 => []
    | Nis'292 => [NT designator_list'nt]
    | Nis'293 => [NT designator_list'nt]
    | Nis'294 => []
    | Nis'295 => [T COMMA't; NT initializer_list'nt]
    | Nis'296 => [NT designation'nt; T COMMA't; NT initializer_list'nt]
    | Nis'297 => []
    | Nis'298 => [T COMMA't; NT initializer_list'nt]
    | Nis'299 => []
    | Nis'300 => [NT designation'nt]
    | Nis'301 => []
    | Nis'302 => [T LBRACE't; T RPAREN't; NT type_name'nt; T LPAREN't]
    | Nis'303 => [NT initializer_list'nt; T LBRACE't; T RPAREN't; NT type_name'nt; T LPAREN't]
    | Nis'304 => [NT initializer_list'nt; T LBRACE't; T RPAREN't; NT type_name'nt; T LPAREN't]
    | Nis'305 => [T COMMA't; NT initializer_list'nt; T LBRACE't; T RPAREN't; NT type_name'nt; T LPAREN't]
    | Nis'306 => [T LPAREN't]
    | Nis'307 => [NT expression'nt; T LPAREN't]
    | Nis'308 => [T ALIGNOF't]
    | Nis'309 => [T LPAREN't; T BUILTIN_VA_ARG't]
    | Nis'310 => [NT assignment_expression'nt; T LPAREN't; T BUILTIN_VA_ARG't]
    | Nis'311 => [T COMMA't; NT assignment_expression'nt; T LPAREN't; T BUILTIN_VA_ARG't]
    | Nis'312 => [NT type_name'nt; T COMMA't; NT assignment_expression'nt; T LPAREN't; T BUILTIN_VA_ARG't]
    | Nis'313 => [T DEC't]
    | Nis'314 => [T EQ't; NT enumeration_constant'nt]
    | Nis'315 => []
    | Nis'316 => [NT attribute_specifier_list'nt; T ENUM't]
    | Nis'317 => [T LBRACE't; NT attribute_specifier_list'nt; T ENUM't]
    | Nis'318 => [NT enumerator_list'nt; T LBRACE't; NT attribute_specifier_list'nt; T ENUM't]
    | Nis'319 => [NT enumerator_list'nt; T LBRACE't; NT attribute_specifier_list'nt; T ENUM't]
    | Nis'320 => [T COMMA't; NT enumerator_list'nt; T LBRACE't; NT attribute_specifier_list'nt; T ENUM't]
    | Nis'321 => [T LPAREN't]
    | Nis'322 => [NT type_name'nt; T LPAREN't]
    | Nis'323 => [T INC't]
    | Nis'324 => [T LPAREN't]
    | Nis'325 => [NT type_name'nt; T LPAREN't]
    | Nis'326 => [T RPAREN't; NT type_name'nt; T LPAREN't]
    | Nis'327 => [T LPAREN't; T SIZEOF't]
    | Nis'328 => [NT type_name'nt; T LPAREN't; T SIZEOF't]
    | Nis'329 => [T SIZEOF't]
    | Nis'330 => [T LPAREN't; T PACKED't]
    | Nis'331 => [NT argument_expression_list'nt; T LPAREN't; T PACKED't]
    | Nis'332 => []
    | Nis'334 => []
    | Nis'335 => [NT translation_unit'nt]
    | Nis'336 => [NT translation_unit'nt]
    | Nis'337 => []
    | Nis'338 => [NT translation_unit'nt]
    | Nis'339 => []
    | Nis'340 => [NT declaration_specifiers'nt]
    | Nis'341 => []
    | Nis'342 => [NT pointer'nt]
    | Nis'343 => [NT pointer'nt]
    | Nis'344 => [NT direct_declarator'nt]
    | Nis'345 => []
    | Nis'346 => [T LPAREN't; NT direct_declarator'nt]
    | Nis'347 => [NT identifier_list'nt; T LPAREN't; NT direct_declarator'nt]
    | Nis'348 => [NT identifier_list'nt]
    | Nis'349 => [T COMMA't; NT identifier_list'nt]
    | Nis'350 => [NT declaration_specifiers'nt]
    | Nis'351 => [NT old_function_declarator'nt; NT declaration_specifiers'nt]
    | Nis'352 => []
    | Nis'353 => []
    | Nis'354 => [T WHILE't]
    | Nis'355 => [T LPAREN't; T WHILE't]
    | Nis'356 => [NT expression'nt; T LPAREN't; T WHILE't]
    | Nis'357 => []
    | Nis'358 => [T SWITCH't]
    | Nis'359 => [T LPAREN't; T SWITCH't]
    | Nis'360 => [NT expression'nt; T LPAREN't; T SWITCH't]
    | Nis'361 => []
    | Nis'362 => []
    | Nis'363 => [T RETURN't]
    | Nis'364 => [T RETURN't]
    | Nis'365 => [NT expression'nt; T RETURN't]
    | Nis'366 => []
    | Nis'367 => [T OTHER_NAME't]
    | Nis'368 => []
    | Nis'369 => [T IF't]
    | Nis'370 => [T LPAREN't; T IF't]
    | Nis'371 => [NT expression'nt; T LPAREN't; T IF't]
    | Nis'372 => []
    | Nis'373 => [T WHILE't]
    | Nis'374 => [T LPAREN't; T WHILE't]
    | Nis'375 => [NT expression'nt; T LPAREN't; T WHILE't]
    | Nis'376 => []
    | Nis'377 => [T SWITCH't]
    | Nis'378 => [T LPAREN't; T SWITCH't]
    | Nis'379 => [NT expression'nt; T LPAREN't; T SWITCH't]
    | Nis'380 => []
    | Nis'381 => [T OTHER_NAME't]
    | Nis'382 => []
    | Nis'383 => [T IF't]
    | Nis'384 => [T LPAREN't; T IF't]
    | Nis'385 => [NT expression'nt; T LPAREN't; T IF't]
    | Nis'386 => []
    | Nis'387 => [T GOTO't]
    | Nis'388 => [T OTHER_NAME't; T GOTO't]
    | Nis'389 => []
    | Nis'390 => [T FOR't]
    | Nis'391 => [T LPAREN't; T FOR't]
    | Nis'392 => [T SEMICOLON't; T LPAREN't; T FOR't]
    | Nis'393 => [T SEMICOLON't; T SEMICOLON't; T LPAREN't; T FOR't]
    | Nis'394 => []
    | Nis'395 => []
    | Nis'396 => [T FOR't]
    | Nis'397 => [T LPAREN't; T FOR't]
    | Nis'398 => [T SEMICOLON't; T LPAREN't; T FOR't]
    | Nis'399 => [T SEMICOLON't; T SEMICOLON't; T LPAREN't; T FOR't]
    | Nis'400 => []
    | Nis'401 => []
    | Nis'402 => [T DEFAULT't]
    | Nis'403 => []
    | Nis'404 => [T CONTINUE't]
    | Nis'405 => []
    | Nis'406 => [T CASE't]
    | Nis'407 => [NT constant_expression'nt; T CASE't]
    | Nis'408 => []
    | Nis'409 => [T BREAK't]
    | Nis'410 => []
    | Nis'411 => []
    | Nis'412 => []
    | Nis'413 => [T CONST't]
    | Nis'414 => [T VOLATILE't]
    | Nis'415 => [T ASM't]
    | Nis'416 => [NT asm_attributes'nt; T ASM't]
    | Nis'417 => [T LPAREN't; NT asm_attributes'nt; T ASM't]
    | Nis'418 => []
    | Nis'419 => []
    | Nis'420 => [T LBRACK't]
    | Nis'421 => [T OTHER_NAME't; T LBRACK't]
    | Nis'422 => []
    | Nis'423 => [NT asm_operands_ne'nt]
    | Nis'424 => [T COMMA't; NT asm_operands_ne'nt]
    | Nis'425 => []
    | Nis'426 => [NT asm_op_name'nt]
    | Nis'427 => [T STRING_LITERAL't; NT asm_op_name'nt]
    | Nis'428 => [T LPAREN't; T STRING_LITERAL't; NT asm_op_name'nt]
    | Nis'429 => [NT expression'nt; T LPAREN't; T STRING_LITERAL't; NT asm_op_name'nt]
    | Nis'430 => [T COLON't]
    | Nis'431 => [NT asm_operands'nt; T COLON't]
    | Nis'432 => [T COLON't; NT asm_operands'nt; T COLON't]
    | Nis'433 => [NT asm_operands'nt; T COLON't; NT asm_operands'nt; T COLON't]
    | Nis'434 => []
    | Nis'435 => [T STRING_LITERAL't]
    | Nis'436 => [T COMMA't; T STRING_LITERAL't]
    | Nis'437 => [T COLON't; NT asm_operands'nt; T COLON't; NT asm_operands'nt; T COLON't]
    | Nis'438 => []
    | Nis'439 => [T STRING_LITERAL't; T LPAREN't; NT asm_attributes'nt; T ASM't]
    | Nis'440 => [NT asm_arguments'nt; T STRING_LITERAL't; T LPAREN't; NT asm_attributes'nt; T ASM't]
    | Nis'441 => [T RPAREN't; NT asm_arguments'nt; T STRING_LITERAL't; T LPAREN't; NT asm_attributes'nt; T ASM't]
    | Nis'442 => [T COLON't; NT constant_expression'nt; T CASE't]
    | Nis'443 => []
    | Nis'444 => []
    | Nis'445 => []
    | Nis'446 => []
    | Nis'447 => []
    | Nis'448 => []
    | Nis'449 => [NT expression'nt]
    | Nis'450 => []
    | Nis'451 => []
    | Nis'452 => [T COLON't; T DEFAULT't]
    | Nis'453 => [T DO't]
    | Nis'454 => [NT statement_dangerous'nt; T DO't]
    | Nis'455 => [T WHILE't; NT statement_dangerous'nt; T DO't]
    | Nis'456 => [T LPAREN't; T WHILE't; NT statement_dangerous'nt; T DO't]
    | Nis'457 => [NT expression'nt; T LPAREN't; T WHILE't; NT statement_dangerous'nt; T DO't]
    | Nis'458 => [T RPAREN't; NT expression'nt; T LPAREN't; T WHILE't; NT statement_dangerous'nt; T DO't]
    | Nis'459 => [T RPAREN't; T SEMICOLON't; T SEMICOLON't; T LPAREN't; T FOR't]
    | Nis'460 => [T SEMICOLON't; T SEMICOLON't; T LPAREN't; T FOR't]
    | Nis'461 => [NT expression'nt; T SEMICOLON't; T SEMICOLON't; T LPAREN't; T FOR't]
    | Nis'462 => [T RPAREN't; NT expression'nt; T SEMICOLON't; T SEMICOLON't; T LPAREN't; T FOR't]
    | Nis'463 => [T SEMICOLON't; T LPAREN't; T FOR't]
    | Nis'464 => [NT expression'nt; T SEMICOLON't; T LPAREN't; T FOR't]
    | Nis'465 => [T SEMICOLON't; NT expression'nt; T SEMICOLON't; T LPAREN't; T FOR't]
    | Nis'466 => [T RPAREN't; T SEMICOLON't; NT expression'nt; T SEMICOLON't; T LPAREN't; T FOR't]
    | Nis'467 => [T SEMICOLON't; NT expression'nt; T SEMICOLON't; T LPAREN't; T FOR't]
    | Nis'468 => [NT expression'nt; T SEMICOLON't; NT expression'nt; T SEMICOLON't; T LPAREN't; T FOR't]
    | Nis'469 => [T RPAREN't; NT expression'nt; T SEMICOLON't; NT expression'nt; T SEMICOLON't; T LPAREN't; T FOR't]
    | Nis'470 => [T LPAREN't; T FOR't]
    | Nis'471 => [NT expression'nt; T LPAREN't; T FOR't]
    | Nis'472 => [T SEMICOLON't; NT expression'nt; T LPAREN't; T FOR't]
    | Nis'473 => [T SEMICOLON't; T SEMICOLON't; NT expression'nt; T LPAREN't; T FOR't]
    | Nis'474 => [T RPAREN't; T SEMICOLON't; T SEMICOLON't; NT expression'nt; T LPAREN't; T FOR't]
    | Nis'475 => [T SEMICOLON't; T SEMICOLON't; NT expression'nt; T LPAREN't; T FOR't]
    | Nis'476 => [NT expression'nt; T SEMICOLON't; T SEMICOLON't; NT expression'nt; T LPAREN't; T FOR't]
    | Nis'477 => [T RPAREN't; NT expression'nt; T SEMICOLON't; T SEMICOLON't; NT expression'nt; T LPAREN't; T FOR't]
    | Nis'478 => [T SEMICOLON't; NT expression'nt; T LPAREN't; T FOR't]
    | Nis'479 => [NT expression'nt; T SEMICOLON't; NT expression'nt; T LPAREN't; T FOR't]
    | Nis'480 => [T SEMICOLON't; NT expression'nt; T SEMICOLON't; NT expression'nt; T LPAREN't; T FOR't]
    | Nis'481 => [T RPAREN't; T SEMICOLON't; NT expression'nt; T SEMICOLON't; NT expression'nt; T LPAREN't; T FOR't]
    | Nis'482 => [T SEMICOLON't; NT expression'nt; T SEMICOLON't; NT expression'nt; T LPAREN't; T FOR't]
    | Nis'483 => [NT expression'nt; T SEMICOLON't; NT expression'nt; T SEMICOLON't; NT expression'nt; T LPAREN't; T FOR't]
    | Nis'484 => [T RPAREN't; NT expression'nt; T SEMICOLON't; NT expression'nt; T SEMICOLON't; NT expression'nt; T LPAREN't; T FOR't]
    | Nis'485 => []
    | Nis'486 => [NT declaration_specifiers'nt]
    | Nis'487 => [NT init_declarator_list'nt; NT declaration_specifiers'nt]
    | Nis'488 => [NT init_declarator_list'nt]
    | Nis'489 => [T COMMA't; NT init_declarator_list'nt]
    | Nis'490 => []
    | Nis'491 => [NT declarator'nt]
    | Nis'492 => [T EQ't; NT declarator'nt]
    | Nis'493 => []
    | Nis'494 => [T LPAREN't; T FOR't]
    | Nis'495 => [NT declaration'nt; T LPAREN't; T FOR't]
    | Nis'496 => [T SEMICOLON't; NT declaration'nt; T LPAREN't; T FOR't]
    | Nis'497 => [T RPAREN't; T SEMICOLON't; NT declaration'nt; T LPAREN't; T FOR't]
    | Nis'498 => [T SEMICOLON't; NT declaration'nt; T LPAREN't; T FOR't]
    | Nis'499 => [NT expression'nt; T SEMICOLON't; NT declaration'nt; T LPAREN't; T FOR't]
    | Nis'500 => [T RPAREN't; NT expression'nt; T SEMICOLON't; NT declaration'nt; T LPAREN't; T FOR't]
    | Nis'501 => [NT declaration'nt; T LPAREN't; T FOR't]
    | Nis'502 => [NT expression'nt; NT declaration'nt; T LPAREN't; T FOR't]
    | Nis'503 => [T SEMICOLON't; NT expression'nt; NT declaration'nt; T LPAREN't; T FOR't]
    | Nis'504 => [T RPAREN't; T SEMICOLON't; NT expression'nt; NT declaration'nt; T LPAREN't; T FOR't]
    | Nis'505 => [T SEMICOLON't; NT expression'nt; NT declaration'nt; T LPAREN't; T FOR't]
    | Nis'506 => [NT expression'nt; T SEMICOLON't; NT expression'nt; NT declaration'nt; T LPAREN't; T FOR't]
    | Nis'507 => [T RPAREN't; NT expression'nt; T SEMICOLON't; NT expression'nt; NT declaration'nt; T LPAREN't; T FOR't]
    | Nis'508 => [T DO't]
    | Nis'509 => [NT statement_dangerous'nt; T DO't]
    | Nis'510 => [T WHILE't; NT statement_dangerous'nt; T DO't]
    | Nis'511 => [T LPAREN't; T WHILE't; NT statement_dangerous'nt; T DO't]
    | Nis'512 => [NT expression'nt; T LPAREN't; T WHILE't; NT statement_dangerous'nt; T DO't]
    | Nis'513 => [T RPAREN't; NT expression'nt; T LPAREN't; T WHILE't; NT statement_dangerous'nt; T DO't]
    | Nis'514 => []
    | Nis'515 => [T DEFAULT't]
    | Nis'516 => []
    | Nis'517 => [T CASE't]
    | Nis'518 => [NT constant_expression'nt; T CASE't]
    | Nis'519 => [T COLON't; NT constant_expression'nt; T CASE't]
    | Nis'520 => []
    | Nis'521 => []
    | Nis'522 => []
    | Nis'523 => []
    | Nis'524 => []
    | Nis'525 => []
    | Nis'526 => []
    | Nis'527 => [T COLON't; T DEFAULT't]
    | Nis'528 => [T RPAREN't; T SEMICOLON't; T SEMICOLON't; T LPAREN't; T FOR't]
    | Nis'529 => [T SEMICOLON't; T SEMICOLON't; T LPAREN't; T FOR't]
    | Nis'530 => [NT expression'nt; T SEMICOLON't; T SEMICOLON't; T LPAREN't; T FOR't]
    | Nis'531 => [T RPAREN't; NT expression'nt; T SEMICOLON't; T SEMICOLON't; T LPAREN't; T FOR't]
    | Nis'532 => [T SEMICOLON't; T LPAREN't; T FOR't]
    | Nis'533 => [NT expression'nt; T SEMICOLON't; T LPAREN't; T FOR't]
    | Nis'534 => [T SEMICOLON't; NT expression'nt; T SEMICOLON't; T LPAREN't; T FOR't]
    | Nis'535 => [T RPAREN't; T SEMICOLON't; NT expression'nt; T SEMICOLON't; T LPAREN't; T FOR't]
    | Nis'536 => [T SEMICOLON't; NT expression'nt; T SEMICOLON't; T LPAREN't; T FOR't]
    | Nis'537 => [NT expression'nt; T SEMICOLON't; NT expression'nt; T SEMICOLON't; T LPAREN't; T FOR't]
    | Nis'538 => [T RPAREN't; NT expression'nt; T SEMICOLON't; NT expression'nt; T SEMICOLON't; T LPAREN't; T FOR't]
    | Nis'539 => [T LPAREN't; T FOR't]
    | Nis'540 => [NT expression'nt; T LPAREN't; T FOR't]
    | Nis'541 => [T SEMICOLON't; NT expression'nt; T LPAREN't; T FOR't]
    | Nis'542 => [T SEMICOLON't; T SEMICOLON't; NT expression'nt; T LPAREN't; T FOR't]
    | Nis'543 => [T RPAREN't; T SEMICOLON't; T SEMICOLON't; NT expression'nt; T LPAREN't; T FOR't]
    | Nis'544 => [T SEMICOLON't; T SEMICOLON't; NT expression'nt; T LPAREN't; T FOR't]
    | Nis'545 => [NT expression'nt; T SEMICOLON't; T SEMICOLON't; NT expression'nt; T LPAREN't; T FOR't]
    | Nis'546 => [T RPAREN't; NT expression'nt; T SEMICOLON't; T SEMICOLON't; NT expression'nt; T LPAREN't; T FOR't]
    | Nis'547 => [T SEMICOLON't; NT expression'nt; T LPAREN't; T FOR't]
    | Nis'548 => [NT expression'nt; T SEMICOLON't; NT expression'nt; T LPAREN't; T FOR't]
    | Nis'549 => [T SEMICOLON't; NT expression'nt; T SEMICOLON't; NT expression'nt; T LPAREN't; T FOR't]
    | Nis'550 => [T RPAREN't; T SEMICOLON't; NT expression'nt; T SEMICOLON't; NT expression'nt; T LPAREN't; T FOR't]
    | Nis'551 => [T SEMICOLON't; NT expression'nt; T SEMICOLON't; NT expression'nt; T LPAREN't; T FOR't]
    | Nis'552 => [NT expression'nt; T SEMICOLON't; NT expression'nt; T SEMICOLON't; NT expression'nt; T LPAREN't; T FOR't]
    | Nis'553 => [T RPAREN't; NT expression'nt; T SEMICOLON't; NT expression'nt; T SEMICOLON't; NT expression'nt; T LPAREN't; T FOR't]
    | Nis'554 => [T LPAREN't; T FOR't]
    | Nis'555 => [NT declaration'nt; T LPAREN't; T FOR't]
    | Nis'556 => [T SEMICOLON't; NT declaration'nt; T LPAREN't; T FOR't]
    | Nis'557 => [T RPAREN't; T SEMICOLON't; NT declaration'nt; T LPAREN't; T FOR't]
    | Nis'558 => [T SEMICOLON't; NT declaration'nt; T LPAREN't; T FOR't]
    | Nis'559 => [NT expression'nt; T SEMICOLON't; NT declaration'nt; T LPAREN't; T FOR't]
    | Nis'560 => [T RPAREN't; NT expression'nt; T SEMICOLON't; NT declaration'nt; T LPAREN't; T FOR't]
    | Nis'561 => [NT declaration'nt; T LPAREN't; T FOR't]
    | Nis'562 => [NT expression'nt; NT declaration'nt; T LPAREN't; T FOR't]
    | Nis'563 => [T SEMICOLON't; NT expression'nt; NT declaration'nt; T LPAREN't; T FOR't]
    | Nis'564 => [T RPAREN't; T SEMICOLON't; NT expression'nt; NT declaration'nt; T LPAREN't; T FOR't]
    | Nis'565 => [T SEMICOLON't; NT expression'nt; NT declaration'nt; T LPAREN't; T FOR't]
    | Nis'566 => [NT expression'nt; T SEMICOLON't; NT expression'nt; NT declaration'nt; T LPAREN't; T FOR't]
    | Nis'567 => [T RPAREN't; NT expression'nt; T SEMICOLON't; NT expression'nt; NT declaration'nt; T LPAREN't; T FOR't]
    | Nis'568 => [T RPAREN't; NT expression'nt; T LPAREN't; T IF't]
    | Nis'569 => [NT statement_safe'nt; T RPAREN't; NT expression'nt; T LPAREN't; T IF't]
    | Nis'570 => [T ELSE't; NT statement_safe'nt; T RPAREN't; NT expression'nt; T LPAREN't; T IF't]
    | Nis'571 => [T ELSE't; NT statement_safe'nt; T RPAREN't; NT expression'nt; T LPAREN't; T IF't]
    | Nis'572 => [T RPAREN't; NT expression'nt; T LPAREN't; T IF't]
    | Nis'573 => [T COLON't; T OTHER_NAME't]
    | Nis'574 => [T COLON't; T OTHER_NAME't]
    | Nis'575 => [T RPAREN't; NT expression'nt; T LPAREN't; T SWITCH't]
    | Nis'576 => [T RPAREN't; NT expression'nt; T LPAREN't; T SWITCH't]
    | Nis'577 => [T RPAREN't; NT expression'nt; T LPAREN't; T WHILE't]
    | Nis'578 => [T RPAREN't; NT expression'nt; T LPAREN't; T WHILE't]
    | Nis'579 => [T RPAREN't; NT expression'nt; T LPAREN't; T IF't]
    | Nis'580 => [NT statement_safe'nt; T RPAREN't; NT expression'nt; T LPAREN't; T IF't]
    | Nis'581 => [T LBRACE't]
    | Nis'582 => []
    | Nis'583 => []
    | Nis'584 => []
    | Nis'585 => [T LBRACE't]
    | Nis'586 => [NT block_item_list'nt; T LBRACE't]
    | Nis'587 => [NT block_item_list'nt]
    | Nis'588 => []
    | Nis'589 => [NT declaration_list'nt]
    | Nis'590 => [NT declaration_list'nt; NT old_function_declarator'nt; NT declaration_specifiers'nt]
    | Nis'591 => []
    | Nis'592 => []
    | Nis'593 => [NT declaration_specifiers'nt]
    | Nis'594 => [NT declarator'nt; NT declaration_specifiers'nt]
    | Nis'595 => []
    | Nis'596 => []
  end.
Extract Constant past_symb_of_non_init_state => "fun _ -> assert false".

Definition past_state_of_non_init_state (s:noninitstate) : list (state -> bool) :=
  match s with
    | Nis'1 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'51 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'165 | Ninit Nis'171 | Ninit Nis'176 | Ninit Nis'177 | Ninit Nis'187 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'195 | Ninit Nis'204 | Ninit Nis'208 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'220 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'266 | Ninit Nis'273 | Ninit Nis'310 | Ninit Nis'334 | Ninit Nis'344 | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'390 | Ninit Nis'396 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'2 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'51 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'165 | Ninit Nis'171 | Ninit Nis'187 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'195 | Ninit Nis'204 | Ninit Nis'208 | Ninit Nis'220 | Ninit Nis'266 | Ninit Nis'273 | Ninit Nis'310 | Ninit Nis'334 | Ninit Nis'344 | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'390 | Ninit Nis'396 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'3 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'51 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'165 | Ninit Nis'171 | Ninit Nis'187 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'195 | Ninit Nis'204 | Ninit Nis'208 | Ninit Nis'220 | Ninit Nis'266 | Ninit Nis'273 | Ninit Nis'310 | Ninit Nis'334 | Ninit Nis'344 | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'390 | Ninit Nis'396 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'4 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'51 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'165 | Ninit Nis'171 | Ninit Nis'187 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'195 | Ninit Nis'204 | Ninit Nis'208 | Ninit Nis'220 | Ninit Nis'266 | Ninit Nis'273 | Ninit Nis'310 | Ninit Nis'334 | Ninit Nis'344 | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'390 | Ninit Nis'396 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'5 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'51 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'165 | Ninit Nis'171 | Ninit Nis'187 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'195 | Ninit Nis'204 | Ninit Nis'208 | Ninit Nis'220 | Ninit Nis'266 | Ninit Nis'273 | Ninit Nis'310 | Ninit Nis'334 | Ninit Nis'344 | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'390 | Ninit Nis'396 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'6 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'51 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'165 | Ninit Nis'171 | Ninit Nis'187 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'195 | Ninit Nis'204 | Ninit Nis'208 | Ninit Nis'220 | Ninit Nis'266 | Ninit Nis'273 | Ninit Nis'310 | Ninit Nis'334 | Ninit Nis'344 | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'390 | Ninit Nis'396 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'7 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'187 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'195 | Ninit Nis'204 | Ninit Nis'208 | Ninit Nis'220 | Ninit Nis'273 | Ninit Nis'334 | Ninit Nis'344 | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'390 | Ninit Nis'396 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'8 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'51 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'165 | Ninit Nis'171 | Ninit Nis'187 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'195 | Ninit Nis'204 | Ninit Nis'208 | Ninit Nis'220 | Ninit Nis'266 | Ninit Nis'273 | Ninit Nis'310 | Ninit Nis'334 | Ninit Nis'344 | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'390 | Ninit Nis'396 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'9 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'187 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'195 | Ninit Nis'204 | Ninit Nis'208 | Ninit Nis'220 | Ninit Nis'273 | Ninit Nis'334 | Ninit Nis'344 | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'390 | Ninit Nis'396 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'10 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'51 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'165 | Ninit Nis'171 | Ninit Nis'187 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'195 | Ninit Nis'204 | Ninit Nis'208 | Ninit Nis'220 | Ninit Nis'266 | Ninit Nis'273 | Ninit Nis'310 | Ninit Nis'334 | Ninit Nis'344 | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'390 | Ninit Nis'396 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'11 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'51 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'165 | Ninit Nis'171 | Ninit Nis'187 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'195 | Ninit Nis'204 | Ninit Nis'208 | Ninit Nis'220 | Ninit Nis'266 | Ninit Nis'273 | Ninit Nis'310 | Ninit Nis'334 | Ninit Nis'344 | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'390 | Ninit Nis'396 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'12 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 => true
            | _ => false
          end ]
    | Nis'13 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'51 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'165 | Ninit Nis'171 | Ninit Nis'176 | Ninit Nis'177 | Ninit Nis'187 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'195 | Ninit Nis'204 | Ninit Nis'208 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'220 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'266 | Ninit Nis'273 | Ninit Nis'310 | Ninit Nis'334 | Ninit Nis'344 | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'390 | Ninit Nis'396 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'14 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'187 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'195 | Ninit Nis'204 | Ninit Nis'208 | Ninit Nis'220 | Ninit Nis'273 | Ninit Nis'334 | Ninit Nis'344 | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'390 | Ninit Nis'396 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'15 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'334 => true
            | _ => false
          end ]
    | Nis'16 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'33 | Ninit Nis'51 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'165 | Ninit Nis'168 | Ninit Nis'171 | Ninit Nis'176 | Ninit Nis'177 | Ninit Nis'187 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'195 | Ninit Nis'204 | Ninit Nis'208 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'220 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'244 | Ninit Nis'253 | Ninit Nis'266 | Ninit Nis'273 | Ninit Nis'310 | Ninit Nis'334 | Ninit Nis'344 | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'390 | Ninit Nis'396 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'17 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'16 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'33 | Ninit Nis'51 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'165 | Ninit Nis'168 | Ninit Nis'171 | Ninit Nis'176 | Ninit Nis'177 | Ninit Nis'187 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'195 | Ninit Nis'204 | Ninit Nis'208 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'220 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'244 | Ninit Nis'253 | Ninit Nis'266 | Ninit Nis'273 | Ninit Nis'310 | Ninit Nis'334 | Ninit Nis'344 | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'390 | Ninit Nis'396 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'18 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'22 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'29 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'44 | Ninit Nis'47 | Ninit Nis'50 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'64 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'86 | Ninit Nis'88 | Ninit Nis'90 | Ninit Nis'92 | Ninit Nis'96 | Ninit Nis'98 | Ninit Nis'100 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'325 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'19 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'22 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'29 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'44 | Ninit Nis'47 | Ninit Nis'50 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'64 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'86 | Ninit Nis'88 | Ninit Nis'90 | Ninit Nis'92 | Ninit Nis'96 | Ninit Nis'98 | Ninit Nis'100 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'325 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'20 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'22 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'29 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'44 | Ninit Nis'47 | Ninit Nis'50 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'64 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'86 | Ninit Nis'88 | Ninit Nis'90 | Ninit Nis'92 | Ninit Nis'96 | Ninit Nis'98 | Ninit Nis'100 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'325 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'21 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'22 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'29 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'44 | Ninit Nis'47 | Ninit Nis'50 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'64 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'86 | Ninit Nis'88 | Ninit Nis'90 | Ninit Nis'92 | Ninit Nis'96 | Ninit Nis'98 | Ninit Nis'100 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'325 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'22 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'22 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'29 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'44 | Ninit Nis'47 | Ninit Nis'50 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'64 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'86 | Ninit Nis'88 | Ninit Nis'90 | Ninit Nis'92 | Ninit Nis'96 | Ninit Nis'98 | Ninit Nis'100 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'325 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'23 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'22 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'29 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'44 | Ninit Nis'47 | Ninit Nis'50 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'64 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'86 | Ninit Nis'88 | Ninit Nis'90 | Ninit Nis'92 | Ninit Nis'96 | Ninit Nis'98 | Ninit Nis'100 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'325 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'24 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'22 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'29 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'44 | Ninit Nis'47 | Ninit Nis'50 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'64 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'86 | Ninit Nis'88 | Ninit Nis'90 | Ninit Nis'92 | Ninit Nis'96 | Ninit Nis'98 | Ninit Nis'100 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'325 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'25 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'22 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'22 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'29 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'44 | Ninit Nis'47 | Ninit Nis'50 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'64 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'86 | Ninit Nis'88 | Ninit Nis'90 | Ninit Nis'92 | Ninit Nis'96 | Ninit Nis'98 | Ninit Nis'100 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'325 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'26 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'47 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'64 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'86 | Ninit Nis'88 | Ninit Nis'90 | Ninit Nis'92 | Ninit Nis'96 | Ninit Nis'98 | Ninit Nis'100 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'325 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'27 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'51 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'165 | Ninit Nis'171 | Ninit Nis'187 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'195 | Ninit Nis'204 | Ninit Nis'208 | Ninit Nis'220 | Ninit Nis'266 | Ninit Nis'273 | Ninit Nis'310 | Ninit Nis'334 | Ninit Nis'344 | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'390 | Ninit Nis'396 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'28 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'51 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'165 | Ninit Nis'171 | Ninit Nis'187 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'195 | Ninit Nis'204 | Ninit Nis'208 | Ninit Nis'220 | Ninit Nis'266 | Ninit Nis'273 | Ninit Nis'310 | Ninit Nis'334 | Ninit Nis'344 | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'390 | Ninit Nis'396 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'29 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'22 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'29 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'44 | Ninit Nis'47 | Ninit Nis'50 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'64 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'86 | Ninit Nis'88 | Ninit Nis'90 | Ninit Nis'92 | Ninit Nis'96 | Ninit Nis'98 | Ninit Nis'100 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'325 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'30 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'29 | Ninit Nis'44 => true
            | _ => false
          end ]
    | Nis'31 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'51 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'165 | Ninit Nis'171 | Ninit Nis'187 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'195 | Ninit Nis'204 | Ninit Nis'208 | Ninit Nis'220 | Ninit Nis'266 | Ninit Nis'273 | Ninit Nis'310 | Ninit Nis'334 | Ninit Nis'344 | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'390 | Ninit Nis'396 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'32 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'51 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'165 | Ninit Nis'171 | Ninit Nis'187 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'195 | Ninit Nis'204 | Ninit Nis'208 | Ninit Nis'220 | Ninit Nis'266 | Ninit Nis'273 | Ninit Nis'310 | Ninit Nis'334 | Ninit Nis'344 | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'390 | Ninit Nis'396 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'33 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'32 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'51 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'165 | Ninit Nis'171 | Ninit Nis'187 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'195 | Ninit Nis'204 | Ninit Nis'208 | Ninit Nis'220 | Ninit Nis'266 | Ninit Nis'273 | Ninit Nis'310 | Ninit Nis'334 | Ninit Nis'344 | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'390 | Ninit Nis'396 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'34 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'33 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'32 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'51 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'165 | Ninit Nis'171 | Ninit Nis'187 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'195 | Ninit Nis'204 | Ninit Nis'208 | Ninit Nis'220 | Ninit Nis'266 | Ninit Nis'273 | Ninit Nis'310 | Ninit Nis'334 | Ninit Nis'344 | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'390 | Ninit Nis'396 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'35 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'34 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'33 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'32 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'51 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'165 | Ninit Nis'171 | Ninit Nis'187 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'195 | Ninit Nis'204 | Ninit Nis'208 | Ninit Nis'220 | Ninit Nis'266 | Ninit Nis'273 | Ninit Nis'310 | Ninit Nis'334 | Ninit Nis'344 | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'390 | Ninit Nis'396 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'36 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'35 | Ninit Nis'39 | Ninit Nis'316 | Ninit Nis'319 => true
            | _ => false
          end ]
    | Nis'37 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'35 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'34 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'33 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'32 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'51 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'165 | Ninit Nis'171 | Ninit Nis'187 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'195 | Ninit Nis'204 | Ninit Nis'208 | Ninit Nis'220 | Ninit Nis'266 | Ninit Nis'273 | Ninit Nis'310 | Ninit Nis'334 | Ninit Nis'344 | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'390 | Ninit Nis'396 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'38 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'37 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'35 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'34 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'33 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'32 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'51 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'165 | Ninit Nis'171 | Ninit Nis'187 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'195 | Ninit Nis'204 | Ninit Nis'208 | Ninit Nis'220 | Ninit Nis'266 | Ninit Nis'273 | Ninit Nis'310 | Ninit Nis'334 | Ninit Nis'344 | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'390 | Ninit Nis'396 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'39 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'37 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'35 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'34 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'33 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'32 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'51 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'165 | Ninit Nis'171 | Ninit Nis'187 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'195 | Ninit Nis'204 | Ninit Nis'208 | Ninit Nis'220 | Ninit Nis'266 | Ninit Nis'273 | Ninit Nis'310 | Ninit Nis'334 | Ninit Nis'344 | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'390 | Ninit Nis'396 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'40 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'39 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'37 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'35 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'34 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'33 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'32 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'51 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'165 | Ninit Nis'171 | Ninit Nis'187 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'195 | Ninit Nis'204 | Ninit Nis'208 | Ninit Nis'220 | Ninit Nis'266 | Ninit Nis'273 | Ninit Nis'310 | Ninit Nis'334 | Ninit Nis'344 | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'390 | Ninit Nis'396 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'41 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'39 | Ninit Nis'319 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'37 | Ninit Nis'317 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'35 | Ninit Nis'316 => true
            | _ => false
          end ]
    | Nis'42 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'35 | Ninit Nis'39 | Ninit Nis'316 | Ninit Nis'319 => true
            | _ => false
          end ]
    | Nis'43 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'42 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'35 | Ninit Nis'39 | Ninit Nis'316 | Ninit Nis'319 => true
            | _ => false
          end ]
    | Nis'44 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'22 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'29 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'44 | Ninit Nis'47 | Ninit Nis'50 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'64 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'86 | Ninit Nis'88 | Ninit Nis'90 | Ninit Nis'92 | Ninit Nis'96 | Ninit Nis'98 | Ninit Nis'100 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'325 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'45 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'22 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'29 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'44 | Ninit Nis'47 | Ninit Nis'50 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'64 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'86 | Ninit Nis'88 | Ninit Nis'90 | Ninit Nis'92 | Ninit Nis'96 | Ninit Nis'98 | Ninit Nis'100 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'325 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'46 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'22 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'29 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'44 | Ninit Nis'47 | Ninit Nis'50 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'64 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'86 | Ninit Nis'88 | Ninit Nis'90 | Ninit Nis'92 | Ninit Nis'96 | Ninit Nis'98 | Ninit Nis'100 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'325 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'47 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'46 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'22 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'29 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'44 | Ninit Nis'47 | Ninit Nis'50 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'64 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'86 | Ninit Nis'88 | Ninit Nis'90 | Ninit Nis'92 | Ninit Nis'96 | Ninit Nis'98 | Ninit Nis'100 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'325 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'48 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'22 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'29 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'44 | Ninit Nis'47 | Ninit Nis'50 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'64 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'86 | Ninit Nis'88 | Ninit Nis'90 | Ninit Nis'92 | Ninit Nis'96 | Ninit Nis'98 | Ninit Nis'100 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'325 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'49 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'22 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'29 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'44 | Ninit Nis'47 | Ninit Nis'50 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'64 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'86 | Ninit Nis'88 | Ninit Nis'90 | Ninit Nis'92 | Ninit Nis'96 | Ninit Nis'98 | Ninit Nis'100 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'325 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'50 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'22 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'29 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'44 | Ninit Nis'47 | Ninit Nis'50 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'64 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'86 | Ninit Nis'88 | Ninit Nis'90 | Ninit Nis'92 | Ninit Nis'96 | Ninit Nis'98 | Ninit Nis'100 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'325 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'51 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'50 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'22 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'29 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'44 | Ninit Nis'47 | Ninit Nis'50 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'64 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'86 | Ninit Nis'88 | Ninit Nis'90 | Ninit Nis'92 | Ninit Nis'96 | Ninit Nis'98 | Ninit Nis'100 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'325 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'52 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'51 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'165 | Ninit Nis'171 | Ninit Nis'187 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'195 | Ninit Nis'204 | Ninit Nis'208 | Ninit Nis'220 | Ninit Nis'266 | Ninit Nis'273 | Ninit Nis'310 | Ninit Nis'334 | Ninit Nis'344 | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'390 | Ninit Nis'396 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'53 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'51 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'165 | Ninit Nis'171 | Ninit Nis'176 | Ninit Nis'177 | Ninit Nis'187 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'195 | Ninit Nis'204 | Ninit Nis'208 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'220 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'266 | Ninit Nis'273 | Ninit Nis'310 | Ninit Nis'334 | Ninit Nis'344 | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'390 | Ninit Nis'396 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'54 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'51 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'165 | Ninit Nis'171 | Ninit Nis'187 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'195 | Ninit Nis'204 | Ninit Nis'208 | Ninit Nis'220 | Ninit Nis'266 | Ninit Nis'273 | Ninit Nis'310 | Ninit Nis'334 | Ninit Nis'344 | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'390 | Ninit Nis'396 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'55 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'33 | Ninit Nis'51 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'165 | Ninit Nis'168 | Ninit Nis'171 | Ninit Nis'176 | Ninit Nis'177 | Ninit Nis'187 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'195 | Ninit Nis'204 | Ninit Nis'208 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'220 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'244 | Ninit Nis'253 | Ninit Nis'266 | Ninit Nis'273 | Ninit Nis'310 | Ninit Nis'334 | Ninit Nis'344 | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'390 | Ninit Nis'396 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'56 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'55 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'33 | Ninit Nis'51 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'165 | Ninit Nis'168 | Ninit Nis'171 | Ninit Nis'176 | Ninit Nis'177 | Ninit Nis'187 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'195 | Ninit Nis'204 | Ninit Nis'208 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'220 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'244 | Ninit Nis'253 | Ninit Nis'266 | Ninit Nis'273 | Ninit Nis'310 | Ninit Nis'334 | Ninit Nis'344 | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'390 | Ninit Nis'396 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'57 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'56 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'55 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'33 | Ninit Nis'51 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'165 | Ninit Nis'168 | Ninit Nis'171 | Ninit Nis'176 | Ninit Nis'177 | Ninit Nis'187 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'195 | Ninit Nis'204 | Ninit Nis'208 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'220 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'244 | Ninit Nis'253 | Ninit Nis'266 | Ninit Nis'273 | Ninit Nis'310 | Ninit Nis'334 | Ninit Nis'344 | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'390 | Ninit Nis'396 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'58 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'57 | Ninit Nis'159 => true
            | _ => false
          end ]
    | Nis'59 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'57 | Ninit Nis'159 => true
            | _ => false
          end ]
    | Nis'60 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'57 | Ninit Nis'159 => true
            | _ => false
          end ]
    | Nis'61 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'57 | Ninit Nis'159 => true
            | _ => false
          end ]
    | Nis'62 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'61 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'57 | Ninit Nis'159 => true
            | _ => false
          end ]
    | Nis'63 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'62 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'61 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'57 | Ninit Nis'159 => true
            | _ => false
          end ]
    | Nis'64 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'22 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'29 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'44 | Ninit Nis'47 | Ninit Nis'50 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'64 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'86 | Ninit Nis'88 | Ninit Nis'90 | Ninit Nis'92 | Ninit Nis'96 | Ninit Nis'98 | Ninit Nis'100 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'325 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'65 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'43 | Ninit Nis'64 | Ninit Nis'86 | Ninit Nis'88 | Ninit Nis'90 | Ninit Nis'92 | Ninit Nis'96 | Ninit Nis'98 | Ninit Nis'100 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'281 | Ninit Nis'325 | Ninit Nis'405 | Ninit Nis'516 => true
            | _ => false
          end ]
    | Nis'66 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'22 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'29 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'44 | Ninit Nis'47 | Ninit Nis'50 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'64 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'86 | Ninit Nis'88 | Ninit Nis'90 | Ninit Nis'92 | Ninit Nis'96 | Ninit Nis'98 | Ninit Nis'100 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'325 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'67 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'22 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'29 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'44 | Ninit Nis'47 | Ninit Nis'50 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'64 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'86 | Ninit Nis'88 | Ninit Nis'90 | Ninit Nis'92 | Ninit Nis'96 | Ninit Nis'98 | Ninit Nis'100 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'325 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'68 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'67 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'22 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'29 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'44 | Ninit Nis'47 | Ninit Nis'50 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'64 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'86 | Ninit Nis'88 | Ninit Nis'90 | Ninit Nis'92 | Ninit Nis'96 | Ninit Nis'98 | Ninit Nis'100 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'325 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'69 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'68 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'67 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'22 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'29 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'44 | Ninit Nis'47 | Ninit Nis'50 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'64 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'86 | Ninit Nis'88 | Ninit Nis'90 | Ninit Nis'92 | Ninit Nis'96 | Ninit Nis'98 | Ninit Nis'100 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'325 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'70 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'67 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'22 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'29 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'44 | Ninit Nis'47 | Ninit Nis'50 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'64 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'86 | Ninit Nis'88 | Ninit Nis'90 | Ninit Nis'92 | Ninit Nis'96 | Ninit Nis'98 | Ninit Nis'100 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'325 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'71 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'70 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'67 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'22 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'29 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'44 | Ninit Nis'47 | Ninit Nis'50 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'64 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'86 | Ninit Nis'88 | Ninit Nis'90 | Ninit Nis'92 | Ninit Nis'96 | Ninit Nis'98 | Ninit Nis'100 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'325 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'72 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'47 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'113 | Ninit Nis'132 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'280 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'73 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'72 => true
            | _ => false
          end ]
    | Nis'74 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'72 => true
            | _ => false
          end ]
    | Nis'75 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'72 => true
            | _ => false
          end ]
    | Nis'76 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'72 => true
            | _ => false
          end ]
    | Nis'77 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'72 => true
            | _ => false
          end ]
    | Nis'78 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'72 => true
            | _ => false
          end ]
    | Nis'79 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'72 => true
            | _ => false
          end ]
    | Nis'80 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'72 => true
            | _ => false
          end ]
    | Nis'81 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'72 => true
            | _ => false
          end ]
    | Nis'82 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'72 => true
            | _ => false
          end ]
    | Nis'83 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'72 => true
            | _ => false
          end ]
    | Nis'84 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'72 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'47 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'113 | Ninit Nis'132 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'280 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'85 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'47 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'86 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'85 | Ninit Nis'104 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'111 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'47 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'87 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'47 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'86 | Ninit Nis'100 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'88 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'87 | Ninit Nis'97 | Ninit Nis'99 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'47 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'86 | Ninit Nis'96 | Ninit Nis'98 | Ninit Nis'100 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'89 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'88 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'87 | Ninit Nis'97 | Ninit Nis'99 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'47 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'86 | Ninit Nis'96 | Ninit Nis'98 | Ninit Nis'100 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'90 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'87 | Ninit Nis'97 | Ninit Nis'99 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'47 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'86 | Ninit Nis'96 | Ninit Nis'98 | Ninit Nis'100 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'91 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'90 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'87 | Ninit Nis'97 | Ninit Nis'99 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'47 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'86 | Ninit Nis'96 | Ninit Nis'98 | Ninit Nis'100 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'92 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'87 | Ninit Nis'97 | Ninit Nis'99 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'47 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'86 | Ninit Nis'96 | Ninit Nis'98 | Ninit Nis'100 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'93 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'92 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'87 | Ninit Nis'97 | Ninit Nis'99 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'47 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'86 | Ninit Nis'96 | Ninit Nis'98 | Ninit Nis'100 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'94 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'47 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'86 | Ninit Nis'96 | Ninit Nis'98 | Ninit Nis'100 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'95 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'86 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'85 | Ninit Nis'104 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'111 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'47 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'96 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'95 | Ninit Nis'101 | Ninit Nis'105 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'47 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'86 | Ninit Nis'100 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'97 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'96 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'95 | Ninit Nis'101 | Ninit Nis'105 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'47 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'86 | Ninit Nis'100 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'98 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'95 | Ninit Nis'101 | Ninit Nis'105 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'47 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'86 | Ninit Nis'100 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'99 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'98 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'95 | Ninit Nis'101 | Ninit Nis'105 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'47 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'86 | Ninit Nis'100 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'100 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'85 | Ninit Nis'104 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'111 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'47 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'101 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'100 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'85 | Ninit Nis'104 | Ninit Nis'107 | Ninit Nis'109 | Ninit Nis'111 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'47 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'102 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'47 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'103 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'102 | Ninit Nis'122 | Ninit Nis'124 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'47 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'104 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'103 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'102 | Ninit Nis'122 | Ninit Nis'124 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'47 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'105 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'47 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'106 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'102 | Ninit Nis'122 | Ninit Nis'124 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'47 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'107 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'106 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'102 | Ninit Nis'122 | Ninit Nis'124 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'47 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'108 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'102 | Ninit Nis'122 | Ninit Nis'124 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'47 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'109 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'108 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'102 | Ninit Nis'122 | Ninit Nis'124 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'47 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'110 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'102 | Ninit Nis'122 | Ninit Nis'124 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'47 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'111 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'110 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'102 | Ninit Nis'122 | Ninit Nis'124 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'47 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'112 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'47 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'113 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'113 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'112 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'47 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'113 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'114 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'47 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'113 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'115 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'114 | Ninit Nis'139 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'47 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'113 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'116 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'115 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'114 | Ninit Nis'139 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'47 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'113 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'117 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'116 | Ninit Nis'130 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'47 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'118 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'117 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'116 | Ninit Nis'130 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'47 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'119 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'118 | Ninit Nis'129 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'47 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'120 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'47 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'121 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'120 | Ninit Nis'127 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'47 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'122 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'121 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'120 | Ninit Nis'127 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'47 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'123 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'120 | Ninit Nis'127 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'47 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'124 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'123 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'120 | Ninit Nis'127 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'47 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'125 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'119 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'118 | Ninit Nis'129 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'47 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'126 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'125 | Ninit Nis'128 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'47 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'127 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'126 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'125 | Ninit Nis'128 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'47 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'128 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'47 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'129 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'47 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'130 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'47 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'113 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'131 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'113 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'112 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'47 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'113 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'132 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'131 | Ninit Nis'147 | Ninit Nis'306 | Ninit Nis'355 | Ninit Nis'359 | Ninit Nis'364 | Ninit Nis'370 | Ninit Nis'374 | Ninit Nis'378 | Ninit Nis'384 | Ninit Nis'428 | Ninit Nis'448 | Ninit Nis'456 | Ninit Nis'460 | Ninit Nis'463 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'475 | Ninit Nis'478 | Ninit Nis'482 | Ninit Nis'498 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'511 | Ninit Nis'529 | Ninit Nis'532 | Ninit Nis'536 | Ninit Nis'539 | Ninit Nis'544 | Ninit Nis'547 | Ninit Nis'551 | Ninit Nis'558 | Ninit Nis'561 | Ninit Nis'565 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'51 | Ninit Nis'113 | Ninit Nis'146 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'133 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'47 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'113 | Ninit Nis'132 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'280 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'134 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'132 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'131 | Ninit Nis'147 | Ninit Nis'306 | Ninit Nis'355 | Ninit Nis'359 | Ninit Nis'364 | Ninit Nis'370 | Ninit Nis'374 | Ninit Nis'378 | Ninit Nis'384 | Ninit Nis'428 | Ninit Nis'448 | Ninit Nis'456 | Ninit Nis'460 | Ninit Nis'463 | Ninit Nis'467 | Ninit Nis'470 | Ninit Nis'475 | Ninit Nis'478 | Ninit Nis'482 | Ninit Nis'498 | Ninit Nis'501 | Ninit Nis'505 | Ninit Nis'511 | Ninit Nis'529 | Ninit Nis'532 | Ninit Nis'536 | Ninit Nis'539 | Ninit Nis'544 | Ninit Nis'547 | Ninit Nis'551 | Ninit Nis'558 | Ninit Nis'561 | Ninit Nis'565 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'51 | Ninit Nis'113 | Ninit Nis'146 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'135 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'131 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'113 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'112 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'47 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'113 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'136 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'135 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'131 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'113 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'112 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'47 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'113 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'137 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'51 | Ninit Nis'113 | Ninit Nis'146 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'138 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'112 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'47 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'113 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'139 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'138 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'112 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'47 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'113 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'140 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'84 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'72 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'47 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'113 | Ninit Nis'132 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'280 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'141 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'62 | Ninit Nis'70 | Ninit Nis'163 => true
            | _ => false
          end ]
    | Nis'142 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'70 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'67 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'22 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'29 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'44 | Ninit Nis'47 | Ninit Nis'50 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'64 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'86 | Ninit Nis'88 | Ninit Nis'90 | Ninit Nis'92 | Ninit Nis'96 | Ninit Nis'98 | Ninit Nis'100 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'325 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'143 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'142 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'70 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'67 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'22 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'29 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'44 | Ninit Nis'47 | Ninit Nis'50 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'64 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'86 | Ninit Nis'88 | Ninit Nis'90 | Ninit Nis'92 | Ninit Nis'96 | Ninit Nis'98 | Ninit Nis'100 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'325 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'144 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'142 | Ninit Nis'154 | Ninit Nis'276 | Ninit Nis'330 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'62 | Ninit Nis'70 | Ninit Nis'163 => true
            | _ => false
          end ]
    | Nis'145 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'144 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'142 | Ninit Nis'154 | Ninit Nis'276 | Ninit Nis'330 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'62 | Ninit Nis'70 | Ninit Nis'163 => true
            | _ => false
          end ]
    | Nis'146 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'67 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'22 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'29 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'44 | Ninit Nis'47 | Ninit Nis'50 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'64 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'86 | Ninit Nis'88 | Ninit Nis'90 | Ninit Nis'92 | Ninit Nis'96 | Ninit Nis'98 | Ninit Nis'100 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'325 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'147 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'146 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'67 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'22 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'29 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'44 | Ninit Nis'47 | Ninit Nis'50 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'64 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'86 | Ninit Nis'88 | Ninit Nis'90 | Ninit Nis'92 | Ninit Nis'96 | Ninit Nis'98 | Ninit Nis'100 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'325 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'148 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'147 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'146 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'67 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'22 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'29 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'44 | Ninit Nis'47 | Ninit Nis'50 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'64 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'86 | Ninit Nis'88 | Ninit Nis'90 | Ninit Nis'92 | Ninit Nis'96 | Ninit Nis'98 | Ninit Nis'100 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'325 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'149 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'67 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'22 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'29 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'44 | Ninit Nis'47 | Ninit Nis'50 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'64 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'86 | Ninit Nis'88 | Ninit Nis'90 | Ninit Nis'92 | Ninit Nis'96 | Ninit Nis'98 | Ninit Nis'100 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'325 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'150 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'67 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'22 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'29 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'44 | Ninit Nis'47 | Ninit Nis'50 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'64 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'86 | Ninit Nis'88 | Ninit Nis'90 | Ninit Nis'92 | Ninit Nis'96 | Ninit Nis'98 | Ninit Nis'100 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'325 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'151 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'150 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'67 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'22 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'29 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'44 | Ninit Nis'47 | Ninit Nis'50 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'64 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'86 | Ninit Nis'88 | Ninit Nis'90 | Ninit Nis'92 | Ninit Nis'96 | Ninit Nis'98 | Ninit Nis'100 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'325 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'152 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'67 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'22 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'29 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'44 | Ninit Nis'47 | Ninit Nis'50 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'64 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'86 | Ninit Nis'88 | Ninit Nis'90 | Ninit Nis'92 | Ninit Nis'96 | Ninit Nis'98 | Ninit Nis'100 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'325 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'153 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'64 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'22 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'29 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'44 | Ninit Nis'47 | Ninit Nis'50 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'64 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'86 | Ninit Nis'88 | Ninit Nis'90 | Ninit Nis'92 | Ninit Nis'96 | Ninit Nis'98 | Ninit Nis'100 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'325 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'154 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'62 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'61 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'57 | Ninit Nis'159 => true
            | _ => false
          end ]
    | Nis'155 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'154 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'62 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'61 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'57 | Ninit Nis'159 => true
            | _ => false
          end ]
    | Nis'156 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'57 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'56 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'55 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'33 | Ninit Nis'51 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'165 | Ninit Nis'168 | Ninit Nis'171 | Ninit Nis'176 | Ninit Nis'177 | Ninit Nis'187 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'195 | Ninit Nis'204 | Ninit Nis'208 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'220 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'244 | Ninit Nis'253 | Ninit Nis'266 | Ninit Nis'273 | Ninit Nis'310 | Ninit Nis'334 | Ninit Nis'344 | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'390 | Ninit Nis'396 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'157 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'156 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'57 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'56 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'55 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'33 | Ninit Nis'51 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'165 | Ninit Nis'168 | Ninit Nis'171 | Ninit Nis'176 | Ninit Nis'177 | Ninit Nis'187 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'195 | Ninit Nis'204 | Ninit Nis'208 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'220 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'244 | Ninit Nis'253 | Ninit Nis'266 | Ninit Nis'273 | Ninit Nis'310 | Ninit Nis'334 | Ninit Nis'344 | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'390 | Ninit Nis'396 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'158 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'157 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'156 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'57 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'56 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'55 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'33 | Ninit Nis'51 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'165 | Ninit Nis'168 | Ninit Nis'171 | Ninit Nis'176 | Ninit Nis'177 | Ninit Nis'187 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'195 | Ninit Nis'204 | Ninit Nis'208 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'220 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'244 | Ninit Nis'253 | Ninit Nis'266 | Ninit Nis'273 | Ninit Nis'310 | Ninit Nis'334 | Ninit Nis'344 | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'390 | Ninit Nis'396 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'159 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'156 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'57 => true
            | _ => false
          end ]
    | Nis'160 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'159 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'156 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'57 => true
            | _ => false
          end ]
    | Nis'161 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'57 => true
            | _ => false
          end ]
    | Nis'162 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'33 | Ninit Nis'51 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'165 | Ninit Nis'168 | Ninit Nis'171 | Ninit Nis'176 | Ninit Nis'177 | Ninit Nis'187 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'195 | Ninit Nis'204 | Ninit Nis'208 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'220 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'244 | Ninit Nis'253 | Ninit Nis'266 | Ninit Nis'273 | Ninit Nis'310 | Ninit Nis'334 | Ninit Nis'344 | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'390 | Ninit Nis'396 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'163 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'162 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'33 | Ninit Nis'51 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'165 | Ninit Nis'168 | Ninit Nis'171 | Ninit Nis'176 | Ninit Nis'177 | Ninit Nis'187 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'195 | Ninit Nis'204 | Ninit Nis'208 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'220 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'244 | Ninit Nis'253 | Ninit Nis'266 | Ninit Nis'273 | Ninit Nis'310 | Ninit Nis'334 | Ninit Nis'344 | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'390 | Ninit Nis'396 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'164 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'51 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'165 | Ninit Nis'171 | Ninit Nis'266 | Ninit Nis'310 => true
            | _ => false
          end ]
    | Nis'165 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'51 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'165 | Ninit Nis'171 | Ninit Nis'266 | Ninit Nis'310 => true
            | _ => false
          end ]
    | Nis'166 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'51 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'165 | Ninit Nis'171 | Ninit Nis'187 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'195 | Ninit Nis'204 | Ninit Nis'208 | Ninit Nis'220 | Ninit Nis'266 | Ninit Nis'273 | Ninit Nis'310 | Ninit Nis'334 | Ninit Nis'344 | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'390 | Ninit Nis'396 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'167 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'51 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'165 | Ninit Nis'171 | Ninit Nis'187 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'195 | Ninit Nis'204 | Ninit Nis'208 | Ninit Nis'220 | Ninit Nis'266 | Ninit Nis'273 | Ninit Nis'310 | Ninit Nis'334 | Ninit Nis'344 | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'390 | Ninit Nis'396 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'168 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'167 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'51 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'165 | Ninit Nis'171 | Ninit Nis'187 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'195 | Ninit Nis'204 | Ninit Nis'208 | Ninit Nis'220 | Ninit Nis'266 | Ninit Nis'273 | Ninit Nis'310 | Ninit Nis'334 | Ninit Nis'344 | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'390 | Ninit Nis'396 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'169 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'168 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'167 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'51 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'165 | Ninit Nis'171 | Ninit Nis'187 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'195 | Ninit Nis'204 | Ninit Nis'208 | Ninit Nis'220 | Ninit Nis'266 | Ninit Nis'273 | Ninit Nis'310 | Ninit Nis'334 | Ninit Nis'344 | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'390 | Ninit Nis'396 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'170 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'169 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'168 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'167 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'51 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'165 | Ninit Nis'171 | Ninit Nis'187 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'195 | Ninit Nis'204 | Ninit Nis'208 | Ninit Nis'220 | Ninit Nis'266 | Ninit Nis'273 | Ninit Nis'310 | Ninit Nis'334 | Ninit Nis'344 | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'390 | Ninit Nis'396 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'171 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'170 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'169 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'168 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'167 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'51 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'165 | Ninit Nis'171 | Ninit Nis'187 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'195 | Ninit Nis'204 | Ninit Nis'208 | Ninit Nis'220 | Ninit Nis'266 | Ninit Nis'273 | Ninit Nis'310 | Ninit Nis'334 | Ninit Nis'344 | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'390 | Ninit Nis'396 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'172 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'171 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'170 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'169 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'168 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'167 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'51 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'165 | Ninit Nis'171 | Ninit Nis'187 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'195 | Ninit Nis'204 | Ninit Nis'208 | Ninit Nis'220 | Ninit Nis'266 | Ninit Nis'273 | Ninit Nis'310 | Ninit Nis'334 | Ninit Nis'344 | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'390 | Ninit Nis'396 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'173 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'171 | Ninit Nis'266 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'170 | Ninit Nis'265 => true
            | _ => false
          end ]
    | Nis'174 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'171 | Ninit Nis'266 => true
            | _ => false
          end ]
    | Nis'175 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'174 | Ninit Nis'184 | Ninit Nis'185 | Ninit Nis'207 | Ninit Nis'208 | Ninit Nis'218 | Ninit Nis'259 | Ninit Nis'339 | Ninit Nis'341 | Ninit Nis'485 | Ninit Nis'488 => true
            | _ => false
          end ]
    | Nis'176 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'174 | Ninit Nis'176 | Ninit Nis'177 | Ninit Nis'184 | Ninit Nis'207 | Ninit Nis'208 | Ninit Nis'259 | Ninit Nis'272 | Ninit Nis'273 | Ninit Nis'339 | Ninit Nis'485 | Ninit Nis'488 => true
            | _ => false
          end ]
    | Nis'177 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'176 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'174 | Ninit Nis'176 | Ninit Nis'177 | Ninit Nis'184 | Ninit Nis'207 | Ninit Nis'208 | Ninit Nis'259 | Ninit Nis'272 | Ninit Nis'273 | Ninit Nis'339 | Ninit Nis'485 | Ninit Nis'488 => true
            | _ => false
          end ]
    | Nis'178 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'177 | Ninit Nis'212 | Ninit Nis'227 | Ninit Nis'238 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'176 | Ninit Nis'210 | Ninit Nis'225 | Ninit Nis'236 => true
            | _ => false
          end ]
    | Nis'179 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'177 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'176 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'174 | Ninit Nis'176 | Ninit Nis'177 | Ninit Nis'184 | Ninit Nis'207 | Ninit Nis'208 | Ninit Nis'259 | Ninit Nis'272 | Ninit Nis'273 | Ninit Nis'339 | Ninit Nis'485 | Ninit Nis'488 => true
            | _ => false
          end ]
    | Nis'180 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'51 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'165 | Ninit Nis'171 | Ninit Nis'176 | Ninit Nis'177 | Ninit Nis'187 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'195 | Ninit Nis'204 | Ninit Nis'208 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'220 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'266 | Ninit Nis'273 | Ninit Nis'310 | Ninit Nis'334 | Ninit Nis'344 | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'390 | Ninit Nis'396 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'181 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'176 | Ninit Nis'210 | Ninit Nis'225 | Ninit Nis'236 => true
            | _ => false
          end ]
    | Nis'182 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'176 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'174 | Ninit Nis'176 | Ninit Nis'177 | Ninit Nis'184 | Ninit Nis'207 | Ninit Nis'208 | Ninit Nis'259 | Ninit Nis'272 | Ninit Nis'273 | Ninit Nis'339 | Ninit Nis'485 | Ninit Nis'488 => true
            | _ => false
          end ]
    | Nis'183 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'174 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'171 | Ninit Nis'266 => true
            | _ => false
          end ]
    | Nis'184 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'174 | Ninit Nis'184 | Ninit Nis'185 | Ninit Nis'259 | Ninit Nis'339 | Ninit Nis'341 | Ninit Nis'485 | Ninit Nis'488 => true
            | _ => false
          end ]
    | Nis'185 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'174 | Ninit Nis'184 | Ninit Nis'259 | Ninit Nis'485 | Ninit Nis'488 => true
            | _ => false
          end ]
    | Nis'186 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'185 | Ninit Nis'218 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'174 | Ninit Nis'184 | Ninit Nis'207 | Ninit Nis'208 | Ninit Nis'259 | Ninit Nis'485 | Ninit Nis'488 => true
            | _ => false
          end ]
    | Nis'187 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'186 | Ninit Nis'235 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'174 | Ninit Nis'184 | Ninit Nis'185 | Ninit Nis'207 | Ninit Nis'208 | Ninit Nis'218 | Ninit Nis'259 | Ninit Nis'485 | Ninit Nis'488 => true
            | _ => false
          end ]
    | Nis'188 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'187 | Ninit Nis'344 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'186 | Ninit Nis'235 | Ninit Nis'343 | Ninit Nis'592 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'174 | Ninit Nis'184 | Ninit Nis'185 | Ninit Nis'207 | Ninit Nis'208 | Ninit Nis'218 | Ninit Nis'259 | Ninit Nis'339 | Ninit Nis'341 | Ninit Nis'485 | Ninit Nis'488 => true
            | _ => false
          end ]
    | Nis'189 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'187 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'195 | Ninit Nis'204 | Ninit Nis'208 | Ninit Nis'220 | Ninit Nis'273 | Ninit Nis'334 | Ninit Nis'344 | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'390 | Ninit Nis'396 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'190 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'187 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'195 | Ninit Nis'204 | Ninit Nis'208 | Ninit Nis'220 | Ninit Nis'273 | Ninit Nis'334 | Ninit Nis'344 | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'390 | Ninit Nis'396 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'191 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'187 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'195 | Ninit Nis'204 | Ninit Nis'208 | Ninit Nis'220 | Ninit Nis'273 | Ninit Nis'334 | Ninit Nis'344 | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'390 | Ninit Nis'396 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'192 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'187 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'195 | Ninit Nis'204 | Ninit Nis'208 | Ninit Nis'220 | Ninit Nis'273 | Ninit Nis'334 | Ninit Nis'344 | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'390 | Ninit Nis'396 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'193 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'187 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'195 | Ninit Nis'204 | Ninit Nis'208 | Ninit Nis'220 | Ninit Nis'273 | Ninit Nis'334 | Ninit Nis'344 | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'390 | Ninit Nis'396 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'194 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'187 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'195 | Ninit Nis'204 | Ninit Nis'208 | Ninit Nis'220 | Ninit Nis'273 | Ninit Nis'334 | Ninit Nis'344 | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'390 | Ninit Nis'396 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'195 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'187 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'195 | Ninit Nis'204 | Ninit Nis'208 | Ninit Nis'220 | Ninit Nis'273 | Ninit Nis'334 | Ninit Nis'344 | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'390 | Ninit Nis'396 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'196 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'51 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'165 | Ninit Nis'171 | Ninit Nis'187 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'195 | Ninit Nis'204 | Ninit Nis'208 | Ninit Nis'220 | Ninit Nis'266 | Ninit Nis'273 | Ninit Nis'310 | Ninit Nis'334 | Ninit Nis'344 | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'390 | Ninit Nis'396 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'197 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'195 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'187 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'195 | Ninit Nis'204 | Ninit Nis'208 | Ninit Nis'220 | Ninit Nis'273 | Ninit Nis'334 | Ninit Nis'344 | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'390 | Ninit Nis'396 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'198 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'194 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'187 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'195 | Ninit Nis'204 | Ninit Nis'208 | Ninit Nis'220 | Ninit Nis'273 | Ninit Nis'334 | Ninit Nis'344 | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'390 | Ninit Nis'396 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'199 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'193 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'187 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'195 | Ninit Nis'204 | Ninit Nis'208 | Ninit Nis'220 | Ninit Nis'273 | Ninit Nis'334 | Ninit Nis'344 | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'390 | Ninit Nis'396 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'200 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'192 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'187 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'195 | Ninit Nis'204 | Ninit Nis'208 | Ninit Nis'220 | Ninit Nis'273 | Ninit Nis'334 | Ninit Nis'344 | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'390 | Ninit Nis'396 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'201 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'187 | Ninit Nis'344 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'186 | Ninit Nis'235 | Ninit Nis'343 | Ninit Nis'592 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'174 | Ninit Nis'184 | Ninit Nis'185 | Ninit Nis'207 | Ninit Nis'208 | Ninit Nis'218 | Ninit Nis'259 | Ninit Nis'339 | Ninit Nis'341 | Ninit Nis'485 | Ninit Nis'488 => true
            | _ => false
          end ]
    | Nis'202 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'201 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'187 | Ninit Nis'344 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'186 | Ninit Nis'235 | Ninit Nis'343 | Ninit Nis'592 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'174 | Ninit Nis'184 | Ninit Nis'185 | Ninit Nis'207 | Ninit Nis'208 | Ninit Nis'218 | Ninit Nis'259 | Ninit Nis'339 | Ninit Nis'341 | Ninit Nis'485 | Ninit Nis'488 => true
            | _ => false
          end ]
    | Nis'203 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'187 | Ninit Nis'208 | Ninit Nis'220 | Ninit Nis'273 | Ninit Nis'344 => true
            | _ => false
          end ]
    | Nis'204 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'203 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'187 | Ninit Nis'208 | Ninit Nis'220 | Ninit Nis'273 | Ninit Nis'344 => true
            | _ => false
          end ]
    | Nis'205 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'204 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'203 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'187 | Ninit Nis'208 | Ninit Nis'220 | Ninit Nis'273 | Ninit Nis'344 => true
            | _ => false
          end ]
    | Nis'206 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'204 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'203 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'187 | Ninit Nis'208 | Ninit Nis'220 | Ninit Nis'273 | Ninit Nis'344 => true
            | _ => false
          end ]
    | Nis'207 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'187 | Ninit Nis'204 | Ninit Nis'208 | Ninit Nis'220 | Ninit Nis'273 | Ninit Nis'344 => true
            | _ => false
          end ]
    | Nis'208 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'207 | Ninit Nis'208 | Ninit Nis'218 => true
            | _ => false
          end ]
    | Nis'209 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'208 | Ninit Nis'273 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'207 | Ninit Nis'208 | Ninit Nis'218 | Ninit Nis'272 | Ninit Nis'273 | Ninit Nis'274 => true
            | _ => false
          end ]
    | Nis'210 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'207 | Ninit Nis'208 | Ninit Nis'218 | Ninit Nis'272 | Ninit Nis'273 | Ninit Nis'274 => true
            | _ => false
          end ]
    | Nis'211 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'210 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'207 | Ninit Nis'208 | Ninit Nis'218 | Ninit Nis'272 | Ninit Nis'273 | Ninit Nis'274 => true
            | _ => false
          end ]
    | Nis'212 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'210 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'207 | Ninit Nis'208 | Ninit Nis'218 | Ninit Nis'272 | Ninit Nis'273 | Ninit Nis'274 => true
            | _ => false
          end ]
    | Nis'213 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'212 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'210 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'207 | Ninit Nis'208 | Ninit Nis'218 | Ninit Nis'272 | Ninit Nis'273 | Ninit Nis'274 => true
            | _ => false
          end ]
    | Nis'214 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'212 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'210 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'207 | Ninit Nis'208 | Ninit Nis'218 | Ninit Nis'272 | Ninit Nis'273 | Ninit Nis'274 => true
            | _ => false
          end ]
    | Nis'215 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'214 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'212 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'210 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'207 | Ninit Nis'208 | Ninit Nis'218 | Ninit Nis'272 | Ninit Nis'273 | Ninit Nis'274 => true
            | _ => false
          end ]
    | Nis'216 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'210 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'207 | Ninit Nis'208 | Ninit Nis'218 | Ninit Nis'272 | Ninit Nis'273 | Ninit Nis'274 => true
            | _ => false
          end ]
    | Nis'217 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'216 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'210 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'207 | Ninit Nis'208 | Ninit Nis'218 | Ninit Nis'272 | Ninit Nis'273 | Ninit Nis'274 => true
            | _ => false
          end ]
    | Nis'218 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'207 | Ninit Nis'208 => true
            | _ => false
          end ]
    | Nis'219 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'218 | Ninit Nis'274 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'207 | Ninit Nis'208 | Ninit Nis'272 | Ninit Nis'273 => true
            | _ => false
          end ]
    | Nis'220 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'219 | Ninit Nis'246 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'207 | Ninit Nis'208 | Ninit Nis'218 | Ninit Nis'272 | Ninit Nis'273 | Ninit Nis'274 => true
            | _ => false
          end ]
    | Nis'221 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'220 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'219 | Ninit Nis'246 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'207 | Ninit Nis'208 | Ninit Nis'218 | Ninit Nis'272 | Ninit Nis'273 | Ninit Nis'274 => true
            | _ => false
          end ]
    | Nis'222 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'220 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'219 | Ninit Nis'246 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'207 | Ninit Nis'208 | Ninit Nis'218 | Ninit Nis'272 | Ninit Nis'273 | Ninit Nis'274 => true
            | _ => false
          end ]
    | Nis'223 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'222 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'220 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'219 | Ninit Nis'246 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'207 | Ninit Nis'208 | Ninit Nis'218 | Ninit Nis'272 | Ninit Nis'273 | Ninit Nis'274 => true
            | _ => false
          end ]
    | Nis'224 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'187 | Ninit Nis'208 | Ninit Nis'220 | Ninit Nis'273 | Ninit Nis'344 => true
            | _ => false
          end ]
    | Nis'225 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'219 | Ninit Nis'246 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'207 | Ninit Nis'208 | Ninit Nis'218 | Ninit Nis'272 | Ninit Nis'273 | Ninit Nis'274 => true
            | _ => false
          end ]
    | Nis'226 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'225 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'219 | Ninit Nis'246 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'207 | Ninit Nis'208 | Ninit Nis'218 | Ninit Nis'272 | Ninit Nis'273 | Ninit Nis'274 => true
            | _ => false
          end ]
    | Nis'227 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'225 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'219 | Ninit Nis'246 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'207 | Ninit Nis'208 | Ninit Nis'218 | Ninit Nis'272 | Ninit Nis'273 | Ninit Nis'274 => true
            | _ => false
          end ]
    | Nis'228 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'227 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'225 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'219 | Ninit Nis'246 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'207 | Ninit Nis'208 | Ninit Nis'218 | Ninit Nis'272 | Ninit Nis'273 | Ninit Nis'274 => true
            | _ => false
          end ]
    | Nis'229 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'227 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'225 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'219 | Ninit Nis'246 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'207 | Ninit Nis'208 | Ninit Nis'218 | Ninit Nis'272 | Ninit Nis'273 | Ninit Nis'274 => true
            | _ => false
          end ]
    | Nis'230 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'229 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'227 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'225 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'219 | Ninit Nis'246 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'207 | Ninit Nis'208 | Ninit Nis'218 | Ninit Nis'272 | Ninit Nis'273 | Ninit Nis'274 => true
            | _ => false
          end ]
    | Nis'231 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'225 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'219 | Ninit Nis'246 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'207 | Ninit Nis'208 | Ninit Nis'218 | Ninit Nis'272 | Ninit Nis'273 | Ninit Nis'274 => true
            | _ => false
          end ]
    | Nis'232 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'231 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'225 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'219 | Ninit Nis'246 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'207 | Ninit Nis'208 | Ninit Nis'218 | Ninit Nis'272 | Ninit Nis'273 | Ninit Nis'274 => true
            | _ => false
          end ]
    | Nis'233 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'208 | Ninit Nis'273 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'207 | Ninit Nis'208 | Ninit Nis'218 | Ninit Nis'272 | Ninit Nis'273 | Ninit Nis'274 => true
            | _ => false
          end ]
    | Nis'234 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'233 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'208 | Ninit Nis'273 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'207 | Ninit Nis'208 | Ninit Nis'218 | Ninit Nis'272 | Ninit Nis'273 | Ninit Nis'274 => true
            | _ => false
          end ]
    | Nis'235 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'174 | Ninit Nis'184 | Ninit Nis'207 | Ninit Nis'208 | Ninit Nis'259 | Ninit Nis'485 | Ninit Nis'488 => true
            | _ => false
          end ]
    | Nis'236 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'186 | Ninit Nis'235 | Ninit Nis'343 | Ninit Nis'592 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'174 | Ninit Nis'184 | Ninit Nis'185 | Ninit Nis'207 | Ninit Nis'208 | Ninit Nis'218 | Ninit Nis'259 | Ninit Nis'339 | Ninit Nis'341 | Ninit Nis'485 | Ninit Nis'488 => true
            | _ => false
          end ]
    | Nis'237 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'236 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'186 | Ninit Nis'235 | Ninit Nis'343 | Ninit Nis'592 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'174 | Ninit Nis'184 | Ninit Nis'185 | Ninit Nis'207 | Ninit Nis'208 | Ninit Nis'218 | Ninit Nis'259 | Ninit Nis'339 | Ninit Nis'341 | Ninit Nis'485 | Ninit Nis'488 => true
            | _ => false
          end ]
    | Nis'238 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'236 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'186 | Ninit Nis'235 | Ninit Nis'343 | Ninit Nis'592 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'174 | Ninit Nis'184 | Ninit Nis'185 | Ninit Nis'207 | Ninit Nis'208 | Ninit Nis'218 | Ninit Nis'259 | Ninit Nis'339 | Ninit Nis'341 | Ninit Nis'485 | Ninit Nis'488 => true
            | _ => false
          end ]
    | Nis'239 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'238 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'236 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'186 | Ninit Nis'235 | Ninit Nis'343 | Ninit Nis'592 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'174 | Ninit Nis'184 | Ninit Nis'185 | Ninit Nis'207 | Ninit Nis'208 | Ninit Nis'218 | Ninit Nis'259 | Ninit Nis'339 | Ninit Nis'341 | Ninit Nis'485 | Ninit Nis'488 => true
            | _ => false
          end ]
    | Nis'240 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'238 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'236 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'186 | Ninit Nis'235 | Ninit Nis'343 | Ninit Nis'592 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'174 | Ninit Nis'184 | Ninit Nis'185 | Ninit Nis'207 | Ninit Nis'208 | Ninit Nis'218 | Ninit Nis'259 | Ninit Nis'339 | Ninit Nis'341 | Ninit Nis'485 | Ninit Nis'488 => true
            | _ => false
          end ]
    | Nis'241 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'240 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'238 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'236 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'186 | Ninit Nis'235 | Ninit Nis'343 | Ninit Nis'592 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'174 | Ninit Nis'184 | Ninit Nis'185 | Ninit Nis'207 | Ninit Nis'208 | Ninit Nis'218 | Ninit Nis'259 | Ninit Nis'339 | Ninit Nis'341 | Ninit Nis'485 | Ninit Nis'488 => true
            | _ => false
          end ]
    | Nis'242 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'236 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'186 | Ninit Nis'235 | Ninit Nis'343 | Ninit Nis'592 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'174 | Ninit Nis'184 | Ninit Nis'185 | Ninit Nis'207 | Ninit Nis'208 | Ninit Nis'218 | Ninit Nis'259 | Ninit Nis'339 | Ninit Nis'341 | Ninit Nis'485 | Ninit Nis'488 => true
            | _ => false
          end ]
    | Nis'243 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'242 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'236 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'186 | Ninit Nis'235 | Ninit Nis'343 | Ninit Nis'592 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'174 | Ninit Nis'184 | Ninit Nis'185 | Ninit Nis'207 | Ninit Nis'208 | Ninit Nis'218 | Ninit Nis'259 | Ninit Nis'339 | Ninit Nis'341 | Ninit Nis'485 | Ninit Nis'488 => true
            | _ => false
          end ]
    | Nis'244 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'235 | Ninit Nis'592 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'174 | Ninit Nis'184 | Ninit Nis'207 | Ninit Nis'208 | Ninit Nis'259 | Ninit Nis'339 | Ninit Nis'485 | Ninit Nis'488 => true
            | _ => false
          end ]
    | Nis'245 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'33 | Ninit Nis'168 | Ninit Nis'244 | Ninit Nis'253 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'32 | Ninit Nis'167 | Ninit Nis'186 | Ninit Nis'235 | Ninit Nis'343 | Ninit Nis'592 => true
            | _ => false
          end ]
    | Nis'246 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'207 | Ninit Nis'208 | Ninit Nis'272 | Ninit Nis'273 => true
            | _ => false
          end ]
    | Nis'247 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'184 | Ninit Nis'208 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'174 | Ninit Nis'184 | Ninit Nis'185 | Ninit Nis'207 | Ninit Nis'208 | Ninit Nis'218 | Ninit Nis'259 | Ninit Nis'339 | Ninit Nis'341 | Ninit Nis'485 | Ninit Nis'488 => true
            | _ => false
          end ]
    | Nis'248 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'247 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'184 | Ninit Nis'208 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'174 | Ninit Nis'184 | Ninit Nis'185 | Ninit Nis'207 | Ninit Nis'208 | Ninit Nis'218 | Ninit Nis'259 | Ninit Nis'339 | Ninit Nis'341 | Ninit Nis'485 | Ninit Nis'488 => true
            | _ => false
          end ]
    | Nis'249 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'208 | Ninit Nis'273 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'207 | Ninit Nis'208 | Ninit Nis'218 | Ninit Nis'272 | Ninit Nis'273 | Ninit Nis'274 => true
            | _ => false
          end ]
    | Nis'250 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'249 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'208 | Ninit Nis'273 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'207 | Ninit Nis'208 | Ninit Nis'218 | Ninit Nis'272 | Ninit Nis'273 | Ninit Nis'274 => true
            | _ => false
          end ]
    | Nis'251 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'207 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'187 | Ninit Nis'204 | Ninit Nis'208 | Ninit Nis'220 | Ninit Nis'273 | Ninit Nis'344 => true
            | _ => false
          end ]
    | Nis'252 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'207 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'187 | Ninit Nis'204 | Ninit Nis'208 | Ninit Nis'220 | Ninit Nis'273 | Ninit Nis'344 => true
            | _ => false
          end ]
    | Nis'253 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'186 | Ninit Nis'343 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'185 | Ninit Nis'218 | Ninit Nis'341 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'174 | Ninit Nis'184 | Ninit Nis'207 | Ninit Nis'208 | Ninit Nis'259 | Ninit Nis'339 | Ninit Nis'485 | Ninit Nis'488 => true
            | _ => false
          end ]
    | Nis'254 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'174 | Ninit Nis'259 => true
            | _ => false
          end ]
    | Nis'255 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'254 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'174 | Ninit Nis'259 => true
            | _ => false
          end ]
    | Nis'256 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'43 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'281 | Ninit Nis'405 | Ninit Nis'516 => true
            | _ => false
          end ]
    | Nis'257 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'174 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'171 | Ninit Nis'266 => true
            | _ => false
          end ]
    | Nis'258 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'257 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'174 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'171 | Ninit Nis'266 => true
            | _ => false
          end ]
    | Nis'259 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'257 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'174 => true
            | _ => false
          end ]
    | Nis'260 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'259 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'257 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'174 => true
            | _ => false
          end ]
    | Nis'261 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'174 | Ninit Nis'259 => true
            | _ => false
          end ]
    | Nis'262 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'261 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'174 | Ninit Nis'259 => true
            | _ => false
          end ]
    | Nis'263 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'262 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'261 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'174 | Ninit Nis'259 => true
            | _ => false
          end ]
    | Nis'264 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'174 => true
            | _ => false
          end ]
    | Nis'265 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'168 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'167 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'51 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'165 | Ninit Nis'171 | Ninit Nis'187 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'195 | Ninit Nis'204 | Ninit Nis'208 | Ninit Nis'220 | Ninit Nis'266 | Ninit Nis'273 | Ninit Nis'310 | Ninit Nis'334 | Ninit Nis'344 | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'390 | Ninit Nis'396 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'266 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'265 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'168 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'167 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'51 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'165 | Ninit Nis'171 | Ninit Nis'187 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'195 | Ninit Nis'204 | Ninit Nis'208 | Ninit Nis'220 | Ninit Nis'266 | Ninit Nis'273 | Ninit Nis'310 | Ninit Nis'334 | Ninit Nis'344 | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'390 | Ninit Nis'396 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'267 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'266 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'265 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'168 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'167 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'51 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'165 | Ninit Nis'171 | Ninit Nis'187 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'195 | Ninit Nis'204 | Ninit Nis'208 | Ninit Nis'220 | Ninit Nis'266 | Ninit Nis'273 | Ninit Nis'310 | Ninit Nis'334 | Ninit Nis'344 | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'390 | Ninit Nis'396 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'268 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'165 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'51 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'165 | Ninit Nis'171 | Ninit Nis'266 | Ninit Nis'310 => true
            | _ => false
          end ]
    | Nis'269 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'164 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'51 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'165 | Ninit Nis'171 | Ninit Nis'266 | Ninit Nis'310 => true
            | _ => false
          end ]
    | Nis'270 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'163 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'162 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'33 | Ninit Nis'51 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'165 | Ninit Nis'168 | Ninit Nis'171 | Ninit Nis'176 | Ninit Nis'177 | Ninit Nis'187 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'195 | Ninit Nis'204 | Ninit Nis'208 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'220 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'244 | Ninit Nis'253 | Ninit Nis'266 | Ninit Nis'273 | Ninit Nis'310 | Ninit Nis'334 | Ninit Nis'344 | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'390 | Ninit Nis'396 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'271 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'270 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'163 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'162 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'33 | Ninit Nis'51 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'165 | Ninit Nis'168 | Ninit Nis'171 | Ninit Nis'176 | Ninit Nis'177 | Ninit Nis'187 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'195 | Ninit Nis'204 | Ninit Nis'208 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'220 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'244 | Ninit Nis'253 | Ninit Nis'266 | Ninit Nis'273 | Ninit Nis'310 | Ninit Nis'334 | Ninit Nis'344 | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'390 | Ninit Nis'396 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'272 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'51 | Ninit Nis'163 | Ninit Nis'310 => true
            | _ => false
          end ]
    | Nis'273 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'272 | Ninit Nis'273 | Ninit Nis'274 => true
            | _ => false
          end ]
    | Nis'274 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'272 | Ninit Nis'273 => true
            | _ => false
          end ]
    | Nis'275 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'272 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'51 | Ninit Nis'163 | Ninit Nis'310 => true
            | _ => false
          end ]
    | Nis'276 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'163 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'162 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'33 | Ninit Nis'51 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'165 | Ninit Nis'168 | Ninit Nis'171 | Ninit Nis'176 | Ninit Nis'177 | Ninit Nis'187 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'195 | Ninit Nis'204 | Ninit Nis'208 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'220 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'244 | Ninit Nis'253 | Ninit Nis'266 | Ninit Nis'273 | Ninit Nis'310 | Ninit Nis'334 | Ninit Nis'344 | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'390 | Ninit Nis'396 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'277 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'276 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'163 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'162 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'33 | Ninit Nis'51 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'165 | Ninit Nis'168 | Ninit Nis'171 | Ninit Nis'176 | Ninit Nis'177 | Ninit Nis'187 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'195 | Ninit Nis'204 | Ninit Nis'208 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'220 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'244 | Ninit Nis'253 | Ninit Nis'266 | Ninit Nis'273 | Ninit Nis'310 | Ninit Nis'334 | Ninit Nis'344 | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'390 | Ninit Nis'396 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'278 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'51 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'50 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'22 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'29 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'44 | Ninit Nis'47 | Ninit Nis'50 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'64 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'86 | Ninit Nis'88 | Ninit Nis'90 | Ninit Nis'92 | Ninit Nis'96 | Ninit Nis'98 | Ninit Nis'100 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'325 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'279 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'278 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'51 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'50 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'22 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'29 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'44 | Ninit Nis'47 | Ninit Nis'50 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'64 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'86 | Ninit Nis'88 | Ninit Nis'90 | Ninit Nis'92 | Ninit Nis'96 | Ninit Nis'98 | Ninit Nis'100 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'325 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'280 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'279 | Ninit Nis'322 | Ninit Nis'325 | Ninit Nis'328 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'278 | Ninit Nis'321 | Ninit Nis'324 | Ninit Nis'327 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'51 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'22 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'29 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'44 | Ninit Nis'47 | Ninit Nis'50 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'64 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'86 | Ninit Nis'88 | Ninit Nis'90 | Ninit Nis'92 | Ninit Nis'96 | Ninit Nis'98 | Ninit Nis'100 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'325 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'281 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'280 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'291 | Ninit Nis'304 => true
            | _ => false
          end ]
    | Nis'282 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'281 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'280 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'291 | Ninit Nis'304 => true
            | _ => false
          end ]
    | Nis'283 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'282 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'281 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'280 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'291 | Ninit Nis'304 => true
            | _ => false
          end ]
    | Nis'284 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'280 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'491 => true
            | _ => false
          end ]
    | Nis'285 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'280 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'291 | Ninit Nis'304 => true
            | _ => false
          end ]
    | Nis'286 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'285 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'280 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'291 | Ninit Nis'304 => true
            | _ => false
          end ]
    | Nis'287 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'284 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'280 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'491 => true
            | _ => false
          end ]
    | Nis'288 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'287 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'284 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'280 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'491 => true
            | _ => false
          end ]
    | Nis'289 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'287 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'284 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'280 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'491 => true
            | _ => false
          end ]
    | Nis'290 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'289 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'287 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'284 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'280 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'491 => true
            | _ => false
          end ]
    | Nis'291 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'280 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'304 => true
            | _ => false
          end ]
    | Nis'292 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'291 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'280 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'304 => true
            | _ => false
          end ]
    | Nis'293 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'291 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'280 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'304 => true
            | _ => false
          end ]
    | Nis'294 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'280 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'304 => true
            | _ => false
          end ]
    | Nis'295 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'289 | Ninit Nis'304 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'287 | Ninit Nis'302 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'280 | Ninit Nis'284 => true
            | _ => false
          end ]
    | Nis'296 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'295 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'289 | Ninit Nis'304 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'287 | Ninit Nis'302 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'280 | Ninit Nis'284 => true
            | _ => false
          end ]
    | Nis'297 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'280 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'491 => true
            | _ => false
          end ]
    | Nis'298 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'289 | Ninit Nis'304 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'287 | Ninit Nis'302 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'280 | Ninit Nis'284 => true
            | _ => false
          end ]
    | Nis'299 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'280 | Ninit Nis'284 => true
            | _ => false
          end ]
    | Nis'300 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'299 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'280 | Ninit Nis'284 => true
            | _ => false
          end ]
    | Nis'301 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'280 | Ninit Nis'284 => true
            | _ => false
          end ]
    | Nis'302 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'280 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'279 | Ninit Nis'322 | Ninit Nis'325 | Ninit Nis'328 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'278 | Ninit Nis'321 | Ninit Nis'324 | Ninit Nis'327 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'51 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'22 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'29 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'44 | Ninit Nis'47 | Ninit Nis'50 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'64 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'86 | Ninit Nis'88 | Ninit Nis'90 | Ninit Nis'92 | Ninit Nis'96 | Ninit Nis'98 | Ninit Nis'100 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'325 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'303 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'302 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'280 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'279 | Ninit Nis'322 | Ninit Nis'325 | Ninit Nis'328 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'278 | Ninit Nis'321 | Ninit Nis'324 | Ninit Nis'327 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'51 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'22 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'29 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'44 | Ninit Nis'47 | Ninit Nis'50 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'64 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'86 | Ninit Nis'88 | Ninit Nis'90 | Ninit Nis'92 | Ninit Nis'96 | Ninit Nis'98 | Ninit Nis'100 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'325 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'304 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'302 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'280 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'279 | Ninit Nis'322 | Ninit Nis'325 | Ninit Nis'328 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'278 | Ninit Nis'321 | Ninit Nis'324 | Ninit Nis'327 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'51 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'22 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'29 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'44 | Ninit Nis'47 | Ninit Nis'50 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'64 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'86 | Ninit Nis'88 | Ninit Nis'90 | Ninit Nis'92 | Ninit Nis'96 | Ninit Nis'98 | Ninit Nis'100 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'325 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'305 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'304 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'302 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'280 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'279 | Ninit Nis'322 | Ninit Nis'325 | Ninit Nis'328 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'278 | Ninit Nis'321 | Ninit Nis'324 | Ninit Nis'327 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'51 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'22 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'29 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'44 | Ninit Nis'47 | Ninit Nis'50 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'64 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'86 | Ninit Nis'88 | Ninit Nis'90 | Ninit Nis'92 | Ninit Nis'96 | Ninit Nis'98 | Ninit Nis'100 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'325 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'306 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'51 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'22 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'29 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'44 | Ninit Nis'47 | Ninit Nis'50 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'64 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'86 | Ninit Nis'88 | Ninit Nis'90 | Ninit Nis'92 | Ninit Nis'96 | Ninit Nis'98 | Ninit Nis'100 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'325 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'307 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'306 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'51 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'22 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'29 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'44 | Ninit Nis'47 | Ninit Nis'50 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'64 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'86 | Ninit Nis'88 | Ninit Nis'90 | Ninit Nis'92 | Ninit Nis'96 | Ninit Nis'98 | Ninit Nis'100 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'325 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'308 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'50 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'22 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'29 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'44 | Ninit Nis'47 | Ninit Nis'50 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'64 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'86 | Ninit Nis'88 | Ninit Nis'90 | Ninit Nis'92 | Ninit Nis'96 | Ninit Nis'98 | Ninit Nis'100 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'325 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'309 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'47 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'46 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'22 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'29 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'44 | Ninit Nis'47 | Ninit Nis'50 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'64 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'86 | Ninit Nis'88 | Ninit Nis'90 | Ninit Nis'92 | Ninit Nis'96 | Ninit Nis'98 | Ninit Nis'100 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'325 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'310 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'309 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'47 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'46 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'22 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'29 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'44 | Ninit Nis'47 | Ninit Nis'50 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'64 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'86 | Ninit Nis'88 | Ninit Nis'90 | Ninit Nis'92 | Ninit Nis'96 | Ninit Nis'98 | Ninit Nis'100 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'325 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'311 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'310 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'309 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'47 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'46 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'22 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'29 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'44 | Ninit Nis'47 | Ninit Nis'50 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'64 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'86 | Ninit Nis'88 | Ninit Nis'90 | Ninit Nis'92 | Ninit Nis'96 | Ninit Nis'98 | Ninit Nis'100 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'325 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'312 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'311 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'310 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'309 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'47 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'46 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'22 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'29 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'44 | Ninit Nis'47 | Ninit Nis'50 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'64 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'86 | Ninit Nis'88 | Ninit Nis'90 | Ninit Nis'92 | Ninit Nis'96 | Ninit Nis'98 | Ninit Nis'100 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'325 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'313 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'44 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'22 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'29 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'44 | Ninit Nis'47 | Ninit Nis'50 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'64 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'86 | Ninit Nis'88 | Ninit Nis'90 | Ninit Nis'92 | Ninit Nis'96 | Ninit Nis'98 | Ninit Nis'100 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'325 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'314 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'43 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'42 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'35 | Ninit Nis'39 | Ninit Nis'316 | Ninit Nis'319 => true
            | _ => false
          end ]
    | Nis'315 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'35 | Ninit Nis'316 => true
            | _ => false
          end ]
    | Nis'316 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'33 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'32 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'51 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'165 | Ninit Nis'171 | Ninit Nis'187 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'195 | Ninit Nis'204 | Ninit Nis'208 | Ninit Nis'220 | Ninit Nis'266 | Ninit Nis'273 | Ninit Nis'310 | Ninit Nis'334 | Ninit Nis'344 | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'390 | Ninit Nis'396 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'317 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'316 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'33 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'32 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'51 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'165 | Ninit Nis'171 | Ninit Nis'187 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'195 | Ninit Nis'204 | Ninit Nis'208 | Ninit Nis'220 | Ninit Nis'266 | Ninit Nis'273 | Ninit Nis'310 | Ninit Nis'334 | Ninit Nis'344 | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'390 | Ninit Nis'396 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'318 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'317 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'316 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'33 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'32 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'51 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'165 | Ninit Nis'171 | Ninit Nis'187 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'195 | Ninit Nis'204 | Ninit Nis'208 | Ninit Nis'220 | Ninit Nis'266 | Ninit Nis'273 | Ninit Nis'310 | Ninit Nis'334 | Ninit Nis'344 | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'390 | Ninit Nis'396 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'319 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'317 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'316 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'33 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'32 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'51 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'165 | Ninit Nis'171 | Ninit Nis'187 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'195 | Ninit Nis'204 | Ninit Nis'208 | Ninit Nis'220 | Ninit Nis'266 | Ninit Nis'273 | Ninit Nis'310 | Ninit Nis'334 | Ninit Nis'344 | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'390 | Ninit Nis'396 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'320 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'319 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'317 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'316 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'33 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'32 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'51 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'165 | Ninit Nis'171 | Ninit Nis'187 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'195 | Ninit Nis'204 | Ninit Nis'208 | Ninit Nis'220 | Ninit Nis'266 | Ninit Nis'273 | Ninit Nis'310 | Ninit Nis'334 | Ninit Nis'344 | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'390 | Ninit Nis'396 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'321 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'30 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'29 | Ninit Nis'44 => true
            | _ => false
          end ]
    | Nis'322 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'321 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'30 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'29 | Ninit Nis'44 => true
            | _ => false
          end ]
    | Nis'323 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'29 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'22 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'29 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'44 | Ninit Nis'47 | Ninit Nis'50 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'64 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'86 | Ninit Nis'88 | Ninit Nis'90 | Ninit Nis'92 | Ninit Nis'96 | Ninit Nis'98 | Ninit Nis'100 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'325 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'324 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'26 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'47 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'64 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'86 | Ninit Nis'88 | Ninit Nis'90 | Ninit Nis'92 | Ninit Nis'96 | Ninit Nis'98 | Ninit Nis'100 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'325 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'325 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'324 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'26 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'47 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'64 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'86 | Ninit Nis'88 | Ninit Nis'90 | Ninit Nis'92 | Ninit Nis'96 | Ninit Nis'98 | Ninit Nis'100 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'325 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'326 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'325 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'324 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'26 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'47 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'64 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'86 | Ninit Nis'88 | Ninit Nis'90 | Ninit Nis'92 | Ninit Nis'96 | Ninit Nis'98 | Ninit Nis'100 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'325 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'327 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'25 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'22 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'22 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'29 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'44 | Ninit Nis'47 | Ninit Nis'50 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'64 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'86 | Ninit Nis'88 | Ninit Nis'90 | Ninit Nis'92 | Ninit Nis'96 | Ninit Nis'98 | Ninit Nis'100 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'325 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'328 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'327 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'25 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'22 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'22 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'29 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'44 | Ninit Nis'47 | Ninit Nis'50 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'64 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'86 | Ninit Nis'88 | Ninit Nis'90 | Ninit Nis'92 | Ninit Nis'96 | Ninit Nis'98 | Ninit Nis'100 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'325 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'329 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'22 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 | Ninit Nis'22 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'29 | Ninit Nis'30 | Ninit Nis'43 | Ninit Nis'44 | Ninit Nis'47 | Ninit Nis'50 | Ninit Nis'51 | Ninit Nis'62 | Ninit Nis'64 | Ninit Nis'70 | Ninit Nis'84 | Ninit Nis'86 | Ninit Nis'88 | Ninit Nis'90 | Ninit Nis'92 | Ninit Nis'96 | Ninit Nis'98 | Ninit Nis'100 | Ninit Nis'103 | Ninit Nis'106 | Ninit Nis'108 | Ninit Nis'110 | Ninit Nis'113 | Ninit Nis'115 | Ninit Nis'117 | Ninit Nis'119 | Ninit Nis'121 | Ninit Nis'123 | Ninit Nis'126 | Ninit Nis'132 | Ninit Nis'135 | Ninit Nis'138 | Ninit Nis'144 | Ninit Nis'146 | Ninit Nis'163 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'254 | Ninit Nis'262 | Ninit Nis'280 | Ninit Nis'281 | Ninit Nis'284 | Ninit Nis'289 | Ninit Nis'295 | Ninit Nis'299 | Ninit Nis'304 | Ninit Nis'325 | Ninit Nis'352 | Ninit Nis'354 | Ninit Nis'356 | Ninit Nis'358 | Ninit Nis'360 | Ninit Nis'362 | Ninit Nis'367 | Ninit Nis'369 | Ninit Nis'371 | Ninit Nis'373 | Ninit Nis'375 | Ninit Nis'377 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'383 | Ninit Nis'385 | Ninit Nis'390 | Ninit Nis'391 | Ninit Nis'392 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'396 | Ninit Nis'397 | Ninit Nis'398 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'405 | Ninit Nis'407 | Ninit Nis'427 | Ninit Nis'455 | Ninit Nis'461 | Ninit Nis'464 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'471 | Ninit Nis'472 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'479 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'491 | Ninit Nis'494 | Ninit Nis'495 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'502 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'510 | Ninit Nis'515 | Ninit Nis'516 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'533 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'540 | Ninit Nis'541 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'548 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'554 | Ninit Nis'555 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'562 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'330 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'17 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'33 | Ninit Nis'51 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'165 | Ninit Nis'168 | Ninit Nis'171 | Ninit Nis'176 | Ninit Nis'177 | Ninit Nis'187 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'195 | Ninit Nis'204 | Ninit Nis'208 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'220 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'244 | Ninit Nis'253 | Ninit Nis'266 | Ninit Nis'273 | Ninit Nis'310 | Ninit Nis'334 | Ninit Nis'344 | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'390 | Ninit Nis'396 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'331 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'330 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'17 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'16 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'25 | Ninit Nis'26 | Ninit Nis'30 | Ninit Nis'33 | Ninit Nis'51 | Ninit Nis'163 | Ninit Nis'164 | Ninit Nis'165 | Ninit Nis'168 | Ninit Nis'171 | Ninit Nis'176 | Ninit Nis'177 | Ninit Nis'187 | Ninit Nis'192 | Ninit Nis'193 | Ninit Nis'194 | Ninit Nis'195 | Ninit Nis'204 | Ninit Nis'208 | Ninit Nis'210 | Ninit Nis'212 | Ninit Nis'220 | Ninit Nis'225 | Ninit Nis'227 | Ninit Nis'236 | Ninit Nis'238 | Ninit Nis'244 | Ninit Nis'253 | Ninit Nis'266 | Ninit Nis'273 | Ninit Nis'310 | Ninit Nis'334 | Ninit Nis'344 | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'390 | Ninit Nis'396 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'332 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 => true
            | _ => false
          end ]
    | Nis'334 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 => true
            | _ => false
          end ]
    | Nis'335 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'334 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 => true
            | _ => false
          end ]
    | Nis'336 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'334 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 => true
            | _ => false
          end ]
    | Nis'337 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'334 => true
            | _ => false
          end ]
    | Nis'338 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'334 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 => true
            | _ => false
          end ]
    | Nis'339 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'334 => true
            | _ => false
          end ]
    | Nis'340 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'339 | Ninit Nis'485 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'334 | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'390 | Ninit Nis'396 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'341 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'339 => true
            | _ => false
          end ]
    | Nis'342 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'341 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'339 => true
            | _ => false
          end ]
    | Nis'343 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'341 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'339 => true
            | _ => false
          end ]
    | Nis'344 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'343 | Ninit Nis'592 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'339 | Ninit Nis'341 => true
            | _ => false
          end ]
    | Nis'345 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'344 => true
            | _ => false
          end ]
    | Nis'346 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'344 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'343 | Ninit Nis'592 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'339 | Ninit Nis'341 => true
            | _ => false
          end ]
    | Nis'347 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'346 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'344 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'343 | Ninit Nis'592 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'339 | Ninit Nis'341 => true
            | _ => false
          end ]
    | Nis'348 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'346 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'344 => true
            | _ => false
          end ]
    | Nis'349 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'348 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'346 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'344 => true
            | _ => false
          end ]
    | Nis'350 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'339 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'334 => true
            | _ => false
          end ]
    | Nis'351 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'350 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'339 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'334 => true
            | _ => false
          end ]
    | Nis'352 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 | Ninit Nis'593 => true
            | _ => false
          end ]
    | Nis'353 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'354 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'353 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'355 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'354 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'353 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'356 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'355 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'354 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'353 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'357 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'358 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'357 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'359 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'358 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'357 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'360 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'359 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'358 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'357 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'361 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'362 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'363 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'362 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'364 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'362 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'365 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'364 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'362 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'366 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'367 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'366 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'368 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'369 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'368 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'370 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'369 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'368 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'371 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'370 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'368 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'372 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'373 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'372 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'374 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'373 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'372 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'375 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'374 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'373 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'372 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'376 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'377 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'376 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'378 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'377 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'376 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'379 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'378 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'377 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'376 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'380 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'381 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'380 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'382 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'383 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'382 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'384 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'383 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'382 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'385 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'384 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'383 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'382 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'386 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'387 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'386 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'388 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'387 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'386 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'389 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'390 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'389 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'391 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'390 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'389 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'392 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'391 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'390 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'389 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'393 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'392 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'391 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'390 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'389 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'394 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'395 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'396 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'395 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'397 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'396 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'395 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'398 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'397 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'396 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'395 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'399 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'398 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'397 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'396 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'395 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'400 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'401 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'402 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'401 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'403 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'404 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'403 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'405 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'406 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'405 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'407 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'406 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'405 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'408 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'409 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'408 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'410 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'411 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'410 | Ninit Nis'411 | Ninit Nis'412 => true
            | _ => false
          end ]
    | Nis'412 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'410 | Ninit Nis'411 | Ninit Nis'412 => true
            | _ => false
          end ]
    | Nis'413 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'412 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'410 | Ninit Nis'411 | Ninit Nis'412 => true
            | _ => false
          end ]
    | Nis'414 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'411 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'410 | Ninit Nis'411 | Ninit Nis'412 => true
            | _ => false
          end ]
    | Nis'415 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'410 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'416 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'415 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'410 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'417 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'416 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'415 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'410 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'418 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'417 => true
            | _ => false
          end ]
    | Nis'419 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'418 | Ninit Nis'423 | Ninit Nis'431 => true
            | _ => false
          end ]
    | Nis'420 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'419 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'418 | Ninit Nis'423 | Ninit Nis'431 => true
            | _ => false
          end ]
    | Nis'421 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'420 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'419 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'418 | Ninit Nis'423 | Ninit Nis'431 => true
            | _ => false
          end ]
    | Nis'422 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'418 | Ninit Nis'431 => true
            | _ => false
          end ]
    | Nis'423 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'422 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'418 | Ninit Nis'431 => true
            | _ => false
          end ]
    | Nis'424 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'423 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'422 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'418 | Ninit Nis'431 => true
            | _ => false
          end ]
    | Nis'425 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'418 | Ninit Nis'423 | Ninit Nis'431 => true
            | _ => false
          end ]
    | Nis'426 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'425 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'418 | Ninit Nis'423 | Ninit Nis'431 => true
            | _ => false
          end ]
    | Nis'427 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'426 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'425 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'418 | Ninit Nis'423 | Ninit Nis'431 => true
            | _ => false
          end ]
    | Nis'428 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'427 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'426 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'425 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'418 | Ninit Nis'423 | Ninit Nis'431 => true
            | _ => false
          end ]
    | Nis'429 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'428 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'427 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'426 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'425 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'418 | Ninit Nis'423 | Ninit Nis'431 => true
            | _ => false
          end ]
    | Nis'430 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'418 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'417 => true
            | _ => false
          end ]
    | Nis'431 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'430 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'418 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'417 => true
            | _ => false
          end ]
    | Nis'432 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'431 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'430 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'418 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'417 => true
            | _ => false
          end ]
    | Nis'433 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'432 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'431 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'430 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'418 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'417 => true
            | _ => false
          end ]
    | Nis'434 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'433 | Ninit Nis'435 => true
            | _ => false
          end ]
    | Nis'435 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'434 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'433 | Ninit Nis'435 => true
            | _ => false
          end ]
    | Nis'436 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'435 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'434 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'433 | Ninit Nis'435 => true
            | _ => false
          end ]
    | Nis'437 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'433 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'432 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'431 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'430 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'418 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'417 => true
            | _ => false
          end ]
    | Nis'438 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'418 | Ninit Nis'431 => true
            | _ => false
          end ]
    | Nis'439 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'417 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'416 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'415 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'410 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'440 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'439 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'417 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'416 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'415 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'410 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'441 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'440 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'439 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'417 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'416 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'415 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'410 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'442 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'407 | Ninit Nis'518 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'406 | Ninit Nis'517 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'405 | Ninit Nis'516 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'443 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'444 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'445 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'446 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'447 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'448 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'449 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'448 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'450 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'451 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'452 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'402 | Ninit Nis'515 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'401 | Ninit Nis'514 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'453 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'400 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'454 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'453 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'400 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'455 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'454 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'453 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'400 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'456 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'455 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'454 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'453 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'400 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'457 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'456 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'455 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'454 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'453 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'400 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'458 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'457 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'456 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'455 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'454 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'453 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'400 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'459 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'393 | Ninit Nis'399 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'392 | Ninit Nis'398 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'391 | Ninit Nis'397 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'390 | Ninit Nis'396 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'389 | Ninit Nis'395 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'460 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'398 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'397 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'396 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'395 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'461 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'460 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'398 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'397 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'396 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'395 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'462 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'461 | Ninit Nis'530 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'460 | Ninit Nis'529 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'392 | Ninit Nis'398 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'391 | Ninit Nis'397 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'390 | Ninit Nis'396 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'389 | Ninit Nis'395 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'463 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'397 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'396 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'395 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'464 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'463 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'397 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'396 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'395 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'465 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'464 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'463 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'397 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'396 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'395 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'466 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'465 | Ninit Nis'534 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'464 | Ninit Nis'533 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'463 | Ninit Nis'532 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'391 | Ninit Nis'397 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'390 | Ninit Nis'396 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'389 | Ninit Nis'395 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'467 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'464 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'463 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'397 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'396 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'395 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'468 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'467 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'464 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'463 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'397 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'396 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'395 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'469 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'468 | Ninit Nis'537 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'467 | Ninit Nis'536 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'464 | Ninit Nis'533 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'463 | Ninit Nis'532 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'391 | Ninit Nis'397 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'390 | Ninit Nis'396 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'389 | Ninit Nis'395 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'470 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'396 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'395 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'471 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'470 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'396 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'395 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'472 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'471 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'470 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'396 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'395 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'473 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'472 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'471 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'470 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'396 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'395 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'474 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'473 | Ninit Nis'542 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'472 | Ninit Nis'541 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'471 | Ninit Nis'540 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'470 | Ninit Nis'539 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'390 | Ninit Nis'396 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'389 | Ninit Nis'395 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'475 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'472 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'471 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'470 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'396 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'395 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'476 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'475 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'472 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'471 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'470 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'396 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'395 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'477 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'476 | Ninit Nis'545 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'475 | Ninit Nis'544 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'472 | Ninit Nis'541 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'471 | Ninit Nis'540 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'470 | Ninit Nis'539 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'390 | Ninit Nis'396 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'389 | Ninit Nis'395 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'478 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'471 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'470 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'396 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'395 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'479 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'478 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'471 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'470 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'396 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'395 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'480 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'479 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'478 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'471 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'470 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'396 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'395 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'481 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'480 | Ninit Nis'549 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'479 | Ninit Nis'548 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'478 | Ninit Nis'547 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'471 | Ninit Nis'540 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'470 | Ninit Nis'539 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'390 | Ninit Nis'396 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'389 | Ninit Nis'395 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'482 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'479 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'478 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'471 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'470 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'396 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'395 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'483 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'482 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'479 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'478 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'471 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'470 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'396 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'395 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'484 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'483 | Ninit Nis'552 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'482 | Ninit Nis'551 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'479 | Ninit Nis'548 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'478 | Ninit Nis'547 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'471 | Ninit Nis'540 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'470 | Ninit Nis'539 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'390 | Ninit Nis'396 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'389 | Ninit Nis'395 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'485 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'390 | Ninit Nis'396 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'486 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'339 | Ninit Nis'485 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'334 | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'390 | Ninit Nis'396 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'487 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'486 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'339 | Ninit Nis'485 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'334 | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'390 | Ninit Nis'396 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'488 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'486 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'339 | Ninit Nis'485 => true
            | _ => false
          end ]
    | Nis'489 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'488 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'486 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'339 | Ninit Nis'485 => true
            | _ => false
          end ]
    | Nis'490 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'485 | Ninit Nis'488 => true
            | _ => false
          end ]
    | Nis'491 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'490 | Ninit Nis'593 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'339 | Ninit Nis'485 | Ninit Nis'488 => true
            | _ => false
          end ]
    | Nis'492 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'491 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'490 | Ninit Nis'593 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'339 | Ninit Nis'485 | Ninit Nis'488 => true
            | _ => false
          end ]
    | Nis'493 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'339 | Ninit Nis'485 => true
            | _ => false
          end ]
    | Nis'494 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'396 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'395 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'495 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'494 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'396 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'395 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'496 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'495 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'494 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'396 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'395 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'497 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'496 | Ninit Nis'556 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'495 | Ninit Nis'555 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'494 | Ninit Nis'554 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'390 | Ninit Nis'396 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'389 | Ninit Nis'395 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'498 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'495 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'494 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'396 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'395 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'499 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'498 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'495 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'494 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'396 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'395 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'500 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'499 | Ninit Nis'559 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'498 | Ninit Nis'558 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'495 | Ninit Nis'555 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'494 | Ninit Nis'554 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'390 | Ninit Nis'396 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'389 | Ninit Nis'395 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'501 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'494 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'396 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'395 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'502 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'501 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'494 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'396 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'395 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'503 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'502 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'501 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'494 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'396 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'395 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'504 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'503 | Ninit Nis'563 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'502 | Ninit Nis'562 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'501 | Ninit Nis'561 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'494 | Ninit Nis'554 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'390 | Ninit Nis'396 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'389 | Ninit Nis'395 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'505 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'502 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'501 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'494 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'396 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'395 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'506 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'505 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'502 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'501 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'494 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'396 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'395 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'507 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'506 | Ninit Nis'566 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'505 | Ninit Nis'565 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'502 | Ninit Nis'562 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'501 | Ninit Nis'561 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'494 | Ninit Nis'554 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'390 | Ninit Nis'396 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'389 | Ninit Nis'395 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'508 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'394 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'509 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'508 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'394 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'510 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'509 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'508 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'394 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'511 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'510 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'509 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'508 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'394 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'512 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'511 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'510 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'509 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'508 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'394 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'513 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'512 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'511 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'510 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'509 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'508 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'394 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'514 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'515 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'514 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'516 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'517 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'516 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'518 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'517 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'516 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'519 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'518 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'517 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'516 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'520 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'521 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'522 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'523 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'524 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'525 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'526 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'527 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'515 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'514 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'528 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'393 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'392 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'391 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'390 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'389 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'529 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'392 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'391 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'390 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'389 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'530 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'529 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'392 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'391 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'390 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'389 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'531 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'530 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'529 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'392 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'391 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'390 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'389 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'532 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'391 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'390 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'389 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'533 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'532 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'391 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'390 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'389 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'534 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'533 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'532 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'391 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'390 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'389 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'535 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'534 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'533 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'532 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'391 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'390 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'389 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'536 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'533 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'532 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'391 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'390 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'389 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'537 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'536 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'533 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'532 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'391 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'390 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'389 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'538 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'537 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'536 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'533 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'532 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'391 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'390 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'389 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'539 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'390 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'389 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'540 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'539 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'390 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'389 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'541 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'540 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'539 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'390 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'389 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'542 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'541 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'540 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'539 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'390 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'389 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'543 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'542 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'541 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'540 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'539 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'390 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'389 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'544 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'541 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'540 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'539 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'390 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'389 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'545 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'544 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'541 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'540 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'539 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'390 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'389 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'546 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'545 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'544 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'541 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'540 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'539 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'390 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'389 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'547 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'540 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'539 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'390 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'389 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'548 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'547 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'540 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'539 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'390 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'389 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'549 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'548 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'547 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'540 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'539 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'390 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'389 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'550 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'549 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'548 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'547 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'540 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'539 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'390 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'389 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'551 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'548 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'547 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'540 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'539 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'390 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'389 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'552 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'551 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'548 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'547 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'540 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'539 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'390 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'389 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'553 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'552 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'551 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'548 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'547 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'540 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'539 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'390 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'389 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'554 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'390 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'389 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'555 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'554 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'390 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'389 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'556 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'555 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'554 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'390 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'389 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'557 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'556 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'555 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'554 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'390 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'389 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'558 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'555 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'554 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'390 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'389 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'559 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'558 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'555 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'554 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'390 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'389 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'560 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'559 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'558 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'555 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'554 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'390 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'389 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'561 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'554 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'390 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'389 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'562 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'561 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'554 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'390 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'389 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'563 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'562 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'561 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'554 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'390 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'389 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'564 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'563 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'562 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'561 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'554 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'390 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'389 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'565 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'562 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'561 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'554 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'390 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'389 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'566 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'565 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'562 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'561 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'554 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'390 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'389 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'567 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'566 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'565 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'562 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'561 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'554 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'390 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'389 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'568 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'385 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'384 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'383 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'382 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'569 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'568 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'385 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'384 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'383 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'382 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'570 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'569 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'568 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'385 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'384 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'383 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'382 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'571 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'569 | Ninit Nis'580 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'568 | Ninit Nis'579 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'385 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'370 | Ninit Nis'384 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'383 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'368 | Ninit Nis'382 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'572 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'385 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'370 | Ninit Nis'384 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 | Ninit Nis'383 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'368 | Ninit Nis'382 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'573 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'381 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'380 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'574 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'367 | Ninit Nis'381 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'366 | Ninit Nis'380 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'575 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'379 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'378 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'377 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'376 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'576 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'360 | Ninit Nis'379 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'359 | Ninit Nis'378 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'358 | Ninit Nis'377 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'357 | Ninit Nis'376 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'577 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'375 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'374 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'373 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'372 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 => true
            | _ => false
          end ]
    | Nis'578 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'356 | Ninit Nis'375 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'355 | Ninit Nis'374 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'354 | Ninit Nis'373 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'353 | Ninit Nis'372 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'579 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'371 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'370 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'368 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'580 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'579 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'371 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'370 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'369 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'368 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'580 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'581 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'352 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 | Ninit Nis'593 => true
            | _ => false
          end ]
    | Nis'582 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'583 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'584 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'352 | Ninit Nis'585 => true
            | _ => false
          end ]
    | Nis'585 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'352 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 | Ninit Nis'593 => true
            | _ => false
          end ]
    | Nis'586 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'585 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'351 | Ninit Nis'352 | Ninit Nis'356 | Ninit Nis'360 | Ninit Nis'367 | Ninit Nis'371 | Ninit Nis'375 | Ninit Nis'379 | Ninit Nis'381 | Ninit Nis'385 | Ninit Nis'393 | Ninit Nis'394 | Ninit Nis'399 | Ninit Nis'400 | Ninit Nis'402 | Ninit Nis'407 | Ninit Nis'461 | Ninit Nis'465 | Ninit Nis'468 | Ninit Nis'473 | Ninit Nis'476 | Ninit Nis'480 | Ninit Nis'483 | Ninit Nis'496 | Ninit Nis'499 | Ninit Nis'503 | Ninit Nis'506 | Ninit Nis'515 | Ninit Nis'518 | Ninit Nis'530 | Ninit Nis'534 | Ninit Nis'537 | Ninit Nis'542 | Ninit Nis'545 | Ninit Nis'549 | Ninit Nis'552 | Ninit Nis'556 | Ninit Nis'559 | Ninit Nis'563 | Ninit Nis'566 | Ninit Nis'569 | Ninit Nis'580 | Ninit Nis'585 | Ninit Nis'593 => true
            | _ => false
          end ]
    | Nis'587 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'585 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'352 => true
            | _ => false
          end ]
    | Nis'588 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'352 => true
            | _ => false
          end ]
    | Nis'589 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'351 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 => true
            | _ => false
          end ]
    | Nis'590 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'351 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'350 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'339 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'334 => true
            | _ => false
          end ]
    | Nis'591 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'339 => true
            | _ => false
          end ]
    | Nis'592 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'339 => true
            | _ => false
          end ]
    | Nis'593 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'339 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'334 => true
            | _ => false
          end ]
    | Nis'594 =>
      [ fun s:state =>
          match s return bool with
            | Ninit Nis'593 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Ninit Nis'339 => true
            | _ => false
          end;
        fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'334 => true
            | _ => false
          end ]
    | Nis'595 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 | Ninit Nis'334 => true
            | _ => false
          end ]
    | Nis'596 =>
      [ fun s:state =>
          match s return bool with
            | Init Init'0 => true
            | _ => false
          end ]
  end.

Extract Constant past_state_of_non_init_state => "fun _ -> assert false".

Definition items_of_state_0 : list item :=
  [ {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'declaration'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'declaration'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'declaration_specifiers'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'6;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'7;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'enum_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'external_declaration'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'external_declaration'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'external_declaration'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'function_definition'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'function_definition'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'function_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'0;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'1;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'translation_unit'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'translation_unit'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'translation_unit'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'translation_unit'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'translation_unit_file'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; SUB_ASSIGN't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SLASH't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RETURN't; RESTRICT't; REGISTER't; RBRACK't; RBRACE't; QUESTION't; PTR't; PRAGMA't; PLUS't; PERCENT't; PACKED't; OTHER_NAME't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LONG't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; LBRACE't; INT't; INLINE't; INC't; IF't; HAT't; GT't; GOTO't; GEQ't; FOR't; FLOAT't; EXTERN't; EQEQ't; EQ't; EOF't; ENUM't; ELSE't; ELLIPSIS't; DOUBLE't; DOT't; DO't; DIV_ASSIGN't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; COMMA't; COLON't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BARBAR't; BAR't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND_ASSIGN't; ANDAND't; AND't; ALIGNOF't; ALIGNAS't; ADD_ASSIGN't] |};
    {| prod_item := Prod'translation_unit_file'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; SUB_ASSIGN't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SLASH't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RETURN't; RESTRICT't; REGISTER't; RBRACK't; RBRACE't; QUESTION't; PTR't; PRAGMA't; PLUS't; PERCENT't; PACKED't; OTHER_NAME't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LONG't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; LBRACE't; INT't; INLINE't; INC't; IF't; HAT't; GT't; GOTO't; GEQ't; FOR't; FLOAT't; EXTERN't; EQEQ't; EQ't; EOF't; ENUM't; ELSE't; ELLIPSIS't; DOUBLE't; DOT't; DO't; DIV_ASSIGN't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; COMMA't; COLON't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BARBAR't; BAR't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND_ASSIGN't; ANDAND't; AND't; ALIGNOF't; ALIGNAS't; ADD_ASSIGN't] |};
    {| prod_item := Prod'type_qualifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'5;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'6;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'7;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'8;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'9;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'10;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'11;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'12;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_0 => "assert false".

Definition items_of_state_1 : list item :=
  [ {| prod_item := Prod'type_qualifier'2;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; INC't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DEC't; CONSTANT't; CONST't; COMMA't; COLON't; CHAR't; BUILTIN_VA_ARG't; BANG't; AUTO't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_1 => "assert false".

Definition items_of_state_2 : list item :=
  [ {| prod_item := Prod'type_specifier'0;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_2 => "assert false".

Definition items_of_state_3 : list item :=
  [ {| prod_item := Prod'type_specifier'8;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_3 => "assert false".

Definition items_of_state_4 : list item :=
  [ {| prod_item := Prod'struct_or_union'1;
      dot_pos_item := 1;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_4 => "assert false".

Definition items_of_state_5 : list item :=
  [ {| prod_item := Prod'type_specifier'9;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_5 => "assert false".

Definition items_of_state_6 : list item :=
  [ {| prod_item := Prod'type_specifier'12;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_6 => "assert false".

Definition items_of_state_7 : list item :=
  [ {| prod_item := Prod'storage_class_specifier'0;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_7 => "assert false".

Definition items_of_state_8 : list item :=
  [ {| prod_item := Prod'struct_or_union'0;
      dot_pos_item := 1;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_8 => "assert false".

Definition items_of_state_9 : list item :=
  [ {| prod_item := Prod'storage_class_specifier'2;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_9 => "assert false".

Definition items_of_state_10 : list item :=
  [ {| prod_item := Prod'type_specifier'7;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_10 => "assert false".

Definition items_of_state_11 : list item :=
  [ {| prod_item := Prod'type_specifier'2;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_11 => "assert false".

Definition items_of_state_12 : list item :=
  [ {| prod_item := Prod'translation_unit'3;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_12 => "assert false".

Definition items_of_state_13 : list item :=
  [ {| prod_item := Prod'type_qualifier'1;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; INC't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DEC't; CONSTANT't; CONST't; COMMA't; COLON't; CHAR't; BUILTIN_VA_ARG't; BANG't; AUTO't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_13 => "assert false".

Definition items_of_state_14 : list item :=
  [ {| prod_item := Prod'storage_class_specifier'4;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_14 => "assert false".

Definition items_of_state_15 : list item :=
  [ {| prod_item := Prod'external_declaration'2;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_15 => "assert false".

Definition items_of_state_16 : list item :=
  [ {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; RBRACK't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACK't; LBRACE't; INT't; INLINE't; INC't; FLOAT't; EXTERN't; EQ't; ENUM't; DOUBLE't; DEC't; CONSTANT't; CONST't; COMMA't; COLON't; CHAR't; BUILTIN_VA_ARG't; BANG't; AUTO't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_16 => "assert false".

Definition items_of_state_17 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'argument_expression_list'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'argument_expression_list'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 2;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; RBRACK't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACK't; LBRACE't; INT't; INLINE't; INC't; FLOAT't; EXTERN't; EQ't; ENUM't; DOUBLE't; DEC't; CONSTANT't; CONST't; COMMA't; COLON't; CHAR't; BUILTIN_VA_ARG't; BANG't; AUTO't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_17 => "assert false".

Definition items_of_state_18 : list item :=
  [ {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 1;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_18 => "assert false".

Definition items_of_state_19 : list item :=
  [ {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 1;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_19 => "assert false".

Definition items_of_state_20 : list item :=
  [ {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 1;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_20 => "assert false".

Definition items_of_state_21 : list item :=
  [ {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 1;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_21 => "assert false".

Definition items_of_state_22 : list item :=
  [ {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 1;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 1;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_22 => "assert false".

Definition items_of_state_23 : list item :=
  [ {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 1;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_23 => "assert false".

Definition items_of_state_24 : list item :=
  [ {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 1;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_24 => "assert false".

Definition items_of_state_25 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'enum_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 1;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 1;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 1;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'specifier_qualifier_list'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'specifier_qualifier_list'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'specifier_qualifier_list'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'specifier_qualifier_list'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'struct_or_union'0;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'1;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_name'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'type_name'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'type_qualifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'5;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'6;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'7;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'8;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'9;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'10;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'11;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'12;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 2;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_25 => "assert false".

Definition items_of_state_26 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 1;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'enum_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 1;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 1;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 1;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'specifier_qualifier_list'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'specifier_qualifier_list'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'specifier_qualifier_list'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'specifier_qualifier_list'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'struct_or_union'0;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'1;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_name'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'type_name'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'type_qualifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'5;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'6;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'7;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'8;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'9;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'10;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'11;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'12;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_26 => "assert false".

Definition items_of_state_27 : list item :=
  [ {| prod_item := Prod'type_specifier'4;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_27 => "assert false".

Definition items_of_state_28 : list item :=
  [ {| prod_item := Prod'type_specifier'3;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_28 => "assert false".

Definition items_of_state_29 : list item :=
  [ {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 1;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_29 => "assert false".

Definition items_of_state_30 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'enum_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 1;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 1;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 1;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'specifier_qualifier_list'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'specifier_qualifier_list'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'specifier_qualifier_list'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'specifier_qualifier_list'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'struct_or_union'0;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'1;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_name'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'type_name'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'type_qualifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'5;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'6;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'7;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'8;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'9;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'10;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'11;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'12;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_30 => "assert false".

Definition items_of_state_31 : list item :=
  [ {| prod_item := Prod'type_specifier'5;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_31 => "assert false".

Definition items_of_state_32 : list item :=
  [ {| prod_item := Prod'attribute_specifier_list'0;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier_list'1;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'0;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'1;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'2;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'3;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'4;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_32 => "assert false".

Definition items_of_state_33 : list item :=
  [ {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier_list'1;
      dot_pos_item := 1;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'0;
      dot_pos_item := 2;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'1;
      dot_pos_item := 2;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'2;
      dot_pos_item := 2;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'3;
      dot_pos_item := 2;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'4;
      dot_pos_item := 2;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_33 => "assert false".

Definition items_of_state_34 : list item :=
  [ {| prod_item := Prod'enum_specifier'0;
      dot_pos_item := 3;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'2;
      dot_pos_item := 3;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'4;
      dot_pos_item := 3;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_34 => "assert false".

Definition items_of_state_35 : list item :=
  [ {| prod_item := Prod'enum_specifier'0;
      dot_pos_item := 4;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'2;
      dot_pos_item := 4;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enumeration_constant'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; EQ't; COMMA't] |};
    {| prod_item := Prod'enumerator'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'enumerator'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'enumerator_list'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'enumerator_list'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |} ].
Extract Inlined Constant items_of_state_35 => "assert false".

Definition items_of_state_36 : list item :=
  [ {| prod_item := Prod'enumeration_constant'0;
      dot_pos_item := 1;
      lookaheads_item := [RBRACE't; EQ't; COMMA't] |} ].
Extract Inlined Constant items_of_state_36 => "assert false".

Definition items_of_state_37 : list item :=
  [ {| prod_item := Prod'enum_specifier'0;
      dot_pos_item := 5;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'2;
      dot_pos_item := 5;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enumerator_list'1;
      dot_pos_item := 1;
      lookaheads_item := [RBRACE't; COMMA't] |} ].
Extract Inlined Constant items_of_state_37 => "assert false".

Definition items_of_state_38 : list item :=
  [ {| prod_item := Prod'enum_specifier'0;
      dot_pos_item := 6;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_38 => "assert false".

Definition items_of_state_39 : list item :=
  [ {| prod_item := Prod'enum_specifier'2;
      dot_pos_item := 6;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enumeration_constant'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; EQ't; COMMA't] |};
    {| prod_item := Prod'enumerator'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'enumerator'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'enumerator_list'1;
      dot_pos_item := 2;
      lookaheads_item := [RBRACE't; COMMA't] |} ].
Extract Inlined Constant items_of_state_39 => "assert false".

Definition items_of_state_40 : list item :=
  [ {| prod_item := Prod'enum_specifier'2;
      dot_pos_item := 7;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_40 => "assert false".

Definition items_of_state_41 : list item :=
  [ {| prod_item := Prod'enumerator_list'1;
      dot_pos_item := 3;
      lookaheads_item := [RBRACE't; COMMA't] |} ].
Extract Inlined Constant items_of_state_41 => "assert false".

Definition items_of_state_42 : list item :=
  [ {| prod_item := Prod'enumerator'0;
      dot_pos_item := 1;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'enumerator'1;
      dot_pos_item := 1;
      lookaheads_item := [RBRACE't; COMMA't] |} ].
Extract Inlined Constant items_of_state_42 => "assert false".

Definition items_of_state_43 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'constant_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'enumerator'1;
      dot_pos_item := 2;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_43 => "assert false".

Definition items_of_state_44 : list item :=
  [ {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 1;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_44 => "assert false".

Definition items_of_state_45 : list item :=
  [ {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 1;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_45 => "assert false".

Definition items_of_state_46 : list item :=
  [ {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 1;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_46 => "assert false".

Definition items_of_state_47 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 2;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_47 => "assert false".

Definition items_of_state_48 : list item :=
  [ {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 1;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_48 => "assert false".

Definition items_of_state_49 : list item :=
  [ {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 1;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_49 => "assert false".

Definition items_of_state_50 : list item :=
  [ {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 1;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 1;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_50 => "assert false".

Definition items_of_state_51 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'enum_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 1;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 1;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 1;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'specifier_qualifier_list'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'specifier_qualifier_list'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'specifier_qualifier_list'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'specifier_qualifier_list'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'struct_or_union'0;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'1;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_name'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'type_name'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'type_qualifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'5;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'6;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'7;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'8;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'9;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'10;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'11;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'12;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 2;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_51 => "assert false".

Definition items_of_state_52 : list item :=
  [ {| prod_item := Prod'type_specifier'6;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_52 => "assert false".

Definition items_of_state_53 : list item :=
  [ {| prod_item := Prod'type_qualifier'0;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; INC't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DEC't; CONSTANT't; CONST't; COMMA't; COLON't; CHAR't; BUILTIN_VA_ARG't; BANG't; AUTO't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_53 => "assert false".

Definition items_of_state_54 : list item :=
  [ {| prod_item := Prod'type_specifier'1;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_54 => "assert false".

Definition items_of_state_55 : list item :=
  [ {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; RBRACK't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACK't; LBRACE't; INT't; INLINE't; INC't; FLOAT't; EXTERN't; EQ't; ENUM't; DOUBLE't; DEC't; CONSTANT't; CONST't; COMMA't; COLON't; CHAR't; BUILTIN_VA_ARG't; BANG't; AUTO't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_55 => "assert false".

Definition items_of_state_56 : list item :=
  [ {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 2;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; RBRACK't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACK't; LBRACE't; INT't; INLINE't; INC't; FLOAT't; EXTERN't; EQ't; ENUM't; DOUBLE't; DEC't; CONSTANT't; CONST't; COMMA't; COLON't; CHAR't; BUILTIN_VA_ARG't; BANG't; AUTO't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_56 => "assert false".

Definition items_of_state_57 : list item :=
  [ {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 3;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; RBRACK't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACK't; LBRACE't; INT't; INLINE't; INC't; FLOAT't; EXTERN't; EQ't; ENUM't; DOUBLE't; DEC't; CONSTANT't; CONST't; COMMA't; COLON't; CHAR't; BUILTIN_VA_ARG't; BANG't; AUTO't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'gcc_attribute'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'gcc_attribute'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'gcc_attribute'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'gcc_attribute'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'gcc_attribute_list'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'gcc_attribute_list'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'gcc_attribute_word'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; COMMA't] |};
    {| prod_item := Prod'gcc_attribute_word'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; COMMA't] |};
    {| prod_item := Prod'gcc_attribute_word'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; COMMA't] |} ].
Extract Inlined Constant items_of_state_57 => "assert false".

Definition items_of_state_58 : list item :=
  [ {| prod_item := Prod'gcc_attribute_word'2;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; LPAREN't; COMMA't] |} ].
Extract Inlined Constant items_of_state_58 => "assert false".

Definition items_of_state_59 : list item :=
  [ {| prod_item := Prod'gcc_attribute_word'0;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; LPAREN't; COMMA't] |} ].
Extract Inlined Constant items_of_state_59 => "assert false".

Definition items_of_state_60 : list item :=
  [ {| prod_item := Prod'gcc_attribute_word'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; LPAREN't; COMMA't] |} ].
Extract Inlined Constant items_of_state_60 => "assert false".

Definition items_of_state_61 : list item :=
  [ {| prod_item := Prod'gcc_attribute'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'gcc_attribute'2;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'gcc_attribute'3;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |} ].
Extract Inlined Constant items_of_state_61 => "assert false".

Definition items_of_state_62 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'argument_expression_list'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'argument_expression_list'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'gcc_attribute'2;
      dot_pos_item := 2;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'gcc_attribute'3;
      dot_pos_item := 2;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_62 => "assert false".

Definition items_of_state_63 : list item :=
  [ {| prod_item := Prod'gcc_attribute'2;
      dot_pos_item := 3;
      lookaheads_item := [RPAREN't; COMMA't] |} ].
Extract Inlined Constant items_of_state_63 => "assert false".

Definition items_of_state_64 : list item :=
  [ {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 1;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_64 => "assert false".

Definition items_of_state_65 : list item :=
  [ {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 1;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_65 => "assert false".

Definition items_of_state_66 : list item :=
  [ {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 1;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_66 => "assert false".

Definition items_of_state_67 : list item :=
  [ {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 1;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 1;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 1;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 1;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 1;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 1;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 1;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 1;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_67 => "assert false".

Definition items_of_state_68 : list item :=
  [ {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 2;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_68 => "assert false".

Definition items_of_state_69 : list item :=
  [ {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 3;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_69 => "assert false".

Definition items_of_state_70 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'argument_expression_list'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'argument_expression_list'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 2;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 2;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_70 => "assert false".

Definition items_of_state_71 : list item :=
  [ {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 3;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_71 => "assert false".

Definition items_of_state_72 : list item :=
  [ {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; COMMA't; COLON't] |};
    {| prod_item := Prod'assignment_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'assignment_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'assignment_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'assignment_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'assignment_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'assignment_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'assignment_operator'6;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'assignment_operator'7;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'assignment_operator'8;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'assignment_operator'9;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'assignment_operator'10;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 1;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |} ].
Extract Inlined Constant items_of_state_72 => "assert false".

Definition items_of_state_73 : list item :=
  [ {| prod_item := Prod'assignment_operator'8;
      dot_pos_item := 1;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_73 => "assert false".

Definition items_of_state_74 : list item :=
  [ {| prod_item := Prod'assignment_operator'5;
      dot_pos_item := 1;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_74 => "assert false".

Definition items_of_state_75 : list item :=
  [ {| prod_item := Prod'assignment_operator'7;
      dot_pos_item := 1;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_75 => "assert false".

Definition items_of_state_76 : list item :=
  [ {| prod_item := Prod'assignment_operator'9;
      dot_pos_item := 1;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_76 => "assert false".

Definition items_of_state_77 : list item :=
  [ {| prod_item := Prod'assignment_operator'1;
      dot_pos_item := 1;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_77 => "assert false".

Definition items_of_state_78 : list item :=
  [ {| prod_item := Prod'assignment_operator'3;
      dot_pos_item := 1;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_78 => "assert false".

Definition items_of_state_79 : list item :=
  [ {| prod_item := Prod'assignment_operator'6;
      dot_pos_item := 1;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_79 => "assert false".

Definition items_of_state_80 : list item :=
  [ {| prod_item := Prod'assignment_operator'0;
      dot_pos_item := 1;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_80 => "assert false".

Definition items_of_state_81 : list item :=
  [ {| prod_item := Prod'assignment_operator'2;
      dot_pos_item := 1;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_81 => "assert false".

Definition items_of_state_82 : list item :=
  [ {| prod_item := Prod'assignment_operator'10;
      dot_pos_item := 1;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_82 => "assert false".

Definition items_of_state_83 : list item :=
  [ {| prod_item := Prod'assignment_operator'4;
      dot_pos_item := 1;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_83 => "assert false".

Definition items_of_state_84 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; COMMA't; COLON't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; COMMA't; COLON't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 2;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; COMMA't; COLON't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; COMMA't; COLON't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; COMMA't; COLON't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; COMMA't; COLON't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; COMMA't; COLON't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; COMMA't; COLON't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; COMMA't; COLON't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_84 => "assert false".

Definition items_of_state_85 : list item :=
  [ {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |} ].
Extract Inlined Constant items_of_state_85 => "assert false".

Definition items_of_state_86 : list item :=
  [ {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 2;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_86 => "assert false".

Definition items_of_state_87 : list item :=
  [ {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 1;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 1;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 1;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |} ].
Extract Inlined Constant items_of_state_87 => "assert false".

Definition items_of_state_88 : list item :=
  [ {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 2;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_88 => "assert false".

Definition items_of_state_89 : list item :=
  [ {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 3;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |} ].
Extract Inlined Constant items_of_state_89 => "assert false".

Definition items_of_state_90 : list item :=
  [ {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 2;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_90 => "assert false".

Definition items_of_state_91 : list item :=
  [ {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 3;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |} ].
Extract Inlined Constant items_of_state_91 => "assert false".

Definition items_of_state_92 : list item :=
  [ {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 2;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_92 => "assert false".

Definition items_of_state_93 : list item :=
  [ {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 3;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |} ].
Extract Inlined Constant items_of_state_93 => "assert false".

Definition items_of_state_94 : list item :=
  [ {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 1;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |} ].
Extract Inlined Constant items_of_state_94 => "assert false".

Definition items_of_state_95 : list item :=
  [ {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 3;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |} ].
Extract Inlined Constant items_of_state_95 => "assert false".

Definition items_of_state_96 : list item :=
  [ {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 2;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_96 => "assert false".

Definition items_of_state_97 : list item :=
  [ {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 3;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 1;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 1;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 1;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |} ].
Extract Inlined Constant items_of_state_97 => "assert false".

Definition items_of_state_98 : list item :=
  [ {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 2;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_98 => "assert false".

Definition items_of_state_99 : list item :=
  [ {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 3;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 1;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 1;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 1;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |} ].
Extract Inlined Constant items_of_state_99 => "assert false".

Definition items_of_state_100 : list item :=
  [ {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 2;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_100 => "assert false".

Definition items_of_state_101 : list item :=
  [ {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 3;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |} ].
Extract Inlined Constant items_of_state_101 => "assert false".

Definition items_of_state_102 : list item :=
  [ {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |} ].
Extract Inlined Constant items_of_state_102 => "assert false".

Definition items_of_state_103 : list item :=
  [ {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 2;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_103 => "assert false".

Definition items_of_state_104 : list item :=
  [ {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 3;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |} ].
Extract Inlined Constant items_of_state_104 => "assert false".

Definition items_of_state_105 : list item :=
  [ {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |} ].
Extract Inlined Constant items_of_state_105 => "assert false".

Definition items_of_state_106 : list item :=
  [ {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 2;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_106 => "assert false".

Definition items_of_state_107 : list item :=
  [ {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 3;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |} ].
Extract Inlined Constant items_of_state_107 => "assert false".

Definition items_of_state_108 : list item :=
  [ {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 2;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_108 => "assert false".

Definition items_of_state_109 : list item :=
  [ {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 3;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |} ].
Extract Inlined Constant items_of_state_109 => "assert false".

Definition items_of_state_110 : list item :=
  [ {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 2;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_110 => "assert false".

Definition items_of_state_111 : list item :=
  [ {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 3;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |} ].
Extract Inlined Constant items_of_state_111 => "assert false".

Definition items_of_state_112 : list item :=
  [ {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; COMMA't; COLON't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; COMMA't; COLON't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; COMMA't; COLON't; BARBAR't] |} ].
Extract Inlined Constant items_of_state_112 => "assert false".

Definition items_of_state_113 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [COMMA't; COLON't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [COMMA't; COLON't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [COMMA't; COLON't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [COMMA't; COLON't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 2;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; COMMA't; COLON't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [COMMA't; COLON't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [COMMA't; COLON't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; COMMA't; COLON't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; COMMA't; COLON't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; COMMA't; COLON't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; COMMA't; COLON't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_113 => "assert false".

Definition items_of_state_114 : list item :=
  [ {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; COMMA't; COLON't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; COMMA't; COLON't; BARBAR't] |} ].
Extract Inlined Constant items_of_state_114 => "assert false".

Definition items_of_state_115 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 2;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; COMMA't; COLON't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_115 => "assert false".

Definition items_of_state_116 : list item :=
  [ {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 3;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; COMMA't; COLON't; BARBAR't; ANDAND't] |} ].
Extract Inlined Constant items_of_state_116 => "assert false".

Definition items_of_state_117 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 2;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_117 => "assert false".

Definition items_of_state_118 : list item :=
  [ {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 3;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't] |} ].
Extract Inlined Constant items_of_state_118 => "assert false".

Definition items_of_state_119 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 2;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_119 => "assert false".

Definition items_of_state_120 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |} ].
Extract Inlined Constant items_of_state_120 => "assert false".

Definition items_of_state_121 : list item :=
  [ {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 2;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_121 => "assert false".

Definition items_of_state_122 : list item :=
  [ {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 3;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |} ].
Extract Inlined Constant items_of_state_122 => "assert false".

Definition items_of_state_123 : list item :=
  [ {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 2;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_123 => "assert false".

Definition items_of_state_124 : list item :=
  [ {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 3;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |} ].
Extract Inlined Constant items_of_state_124 => "assert false".

Definition items_of_state_125 : list item :=
  [ {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 3;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't] |} ].
Extract Inlined Constant items_of_state_125 => "assert false".

Definition items_of_state_126 : list item :=
  [ {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 2;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_126 => "assert false".

Definition items_of_state_127 : list item :=
  [ {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 3;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |} ].
Extract Inlined Constant items_of_state_127 => "assert false".

Definition items_of_state_128 : list item :=
  [ {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't] |} ].
Extract Inlined Constant items_of_state_128 => "assert false".

Definition items_of_state_129 : list item :=
  [ {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't] |} ].
Extract Inlined Constant items_of_state_129 => "assert false".

Definition items_of_state_130 : list item :=
  [ {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; COMMA't; COLON't; BARBAR't; ANDAND't] |} ].
Extract Inlined Constant items_of_state_130 => "assert false".

Definition items_of_state_131 : list item :=
  [ {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 3;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; COMMA't; COLON't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 1;
      lookaheads_item := [COMMA't; COLON't] |} ].
Extract Inlined Constant items_of_state_131 => "assert false".

Definition items_of_state_132 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; COMMA't; COLON't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; COMMA't; COLON't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; COMMA't; COLON't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; COMMA't; COLON't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 2;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; COMMA't; COLON't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; QUESTION't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; QUESTION't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; QUESTION't; COMMA't; COLON't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; QUESTION't; COMMA't; COLON't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; QUESTION't; COMMA't; COLON't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; QUESTION't; COMMA't; COLON't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_132 => "assert false".

Definition items_of_state_133 : list item :=
  [ {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; COMMA't; COLON't] |} ].
Extract Inlined Constant items_of_state_133 => "assert false".

Definition items_of_state_134 : list item :=
  [ {| prod_item := Prod'expression'1;
      dot_pos_item := 3;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; COMMA't; COLON't] |} ].
Extract Inlined Constant items_of_state_134 => "assert false".

Definition items_of_state_135 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; COMMA't; COLON't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; COMMA't; COLON't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 4;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; COMMA't; COLON't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; COMMA't; COLON't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; COMMA't; COLON't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; COMMA't; COLON't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; COMMA't; COLON't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_135 => "assert false".

Definition items_of_state_136 : list item :=
  [ {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 5;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; COMMA't; COLON't] |} ].
Extract Inlined Constant items_of_state_136 => "assert false".

Definition items_of_state_137 : list item :=
  [ {| prod_item := Prod'expression'0;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; COMMA't; COLON't] |} ].
Extract Inlined Constant items_of_state_137 => "assert false".

Definition items_of_state_138 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; HAT't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; COMMA't; COLON't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; COMMA't; COLON't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 2;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; COMMA't; COLON't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_138 => "assert false".

Definition items_of_state_139 : list item :=
  [ {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; COMMA't; COLON't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 3;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; QUESTION't; COMMA't; COLON't; BARBAR't] |} ].
Extract Inlined Constant items_of_state_139 => "assert false".

Definition items_of_state_140 : list item :=
  [ {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 3;
      lookaheads_item := [SEMICOLON't; RPAREN't; RBRACK't; RBRACE't; COMMA't; COLON't] |} ].
Extract Inlined Constant items_of_state_140 => "assert false".

Definition items_of_state_141 : list item :=
  [ {| prod_item := Prod'argument_expression_list'0;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |} ].
Extract Inlined Constant items_of_state_141 => "assert false".

Definition items_of_state_142 : list item :=
  [ {| prod_item := Prod'argument_expression_list'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 3;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_142 => "assert false".

Definition items_of_state_143 : list item :=
  [ {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 4;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_143 => "assert false".

Definition items_of_state_144 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'argument_expression_list'1;
      dot_pos_item := 2;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_144 => "assert false".

Definition items_of_state_145 : list item :=
  [ {| prod_item := Prod'argument_expression_list'1;
      dot_pos_item := 3;
      lookaheads_item := [RPAREN't; COMMA't] |} ].
Extract Inlined Constant items_of_state_145 => "assert false".

Definition items_of_state_146 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; COMMA't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 2;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_146 => "assert false".

Definition items_of_state_147 : list item :=
  [ {| prod_item := Prod'expression'1;
      dot_pos_item := 1;
      lookaheads_item := [RBRACK't; COMMA't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 3;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_147 => "assert false".

Definition items_of_state_148 : list item :=
  [ {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 4;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_148 => "assert false".

Definition items_of_state_149 : list item :=
  [ {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 2;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_149 => "assert false".

Definition items_of_state_150 : list item :=
  [ {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 2;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_150 => "assert false".

Definition items_of_state_151 : list item :=
  [ {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 3;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_151 => "assert false".

Definition items_of_state_152 : list item :=
  [ {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 2;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_152 => "assert false".

Definition items_of_state_153 : list item :=
  [ {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 2;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_153 => "assert false".

Definition items_of_state_154 : list item :=
  [ {| prod_item := Prod'argument_expression_list'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'gcc_attribute'3;
      dot_pos_item := 3;
      lookaheads_item := [RPAREN't; COMMA't] |} ].
Extract Inlined Constant items_of_state_154 => "assert false".

Definition items_of_state_155 : list item :=
  [ {| prod_item := Prod'gcc_attribute'3;
      dot_pos_item := 4;
      lookaheads_item := [RPAREN't; COMMA't] |} ].
Extract Inlined Constant items_of_state_155 => "assert false".

Definition items_of_state_156 : list item :=
  [ {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 4;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; RBRACK't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACK't; LBRACE't; INT't; INLINE't; INC't; FLOAT't; EXTERN't; EQ't; ENUM't; DOUBLE't; DEC't; CONSTANT't; CONST't; COMMA't; COLON't; CHAR't; BUILTIN_VA_ARG't; BANG't; AUTO't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'gcc_attribute_list'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |} ].
Extract Inlined Constant items_of_state_156 => "assert false".

Definition items_of_state_157 : list item :=
  [ {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 5;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; RBRACK't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACK't; LBRACE't; INT't; INLINE't; INC't; FLOAT't; EXTERN't; EQ't; ENUM't; DOUBLE't; DEC't; CONSTANT't; CONST't; COMMA't; COLON't; CHAR't; BUILTIN_VA_ARG't; BANG't; AUTO't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_157 => "assert false".

Definition items_of_state_158 : list item :=
  [ {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 6;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; RBRACK't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACK't; LBRACE't; INT't; INLINE't; INC't; FLOAT't; EXTERN't; EQ't; ENUM't; DOUBLE't; DEC't; CONSTANT't; CONST't; COMMA't; COLON't; CHAR't; BUILTIN_VA_ARG't; BANG't; AUTO't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_158 => "assert false".

Definition items_of_state_159 : list item :=
  [ {| prod_item := Prod'gcc_attribute'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'gcc_attribute'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'gcc_attribute'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'gcc_attribute'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'gcc_attribute_list'1;
      dot_pos_item := 2;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'gcc_attribute_word'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; COMMA't] |};
    {| prod_item := Prod'gcc_attribute_word'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; COMMA't] |};
    {| prod_item := Prod'gcc_attribute_word'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; COMMA't] |} ].
Extract Inlined Constant items_of_state_159 => "assert false".

Definition items_of_state_160 : list item :=
  [ {| prod_item := Prod'gcc_attribute_list'1;
      dot_pos_item := 3;
      lookaheads_item := [RPAREN't; COMMA't] |} ].
Extract Inlined Constant items_of_state_160 => "assert false".

Definition items_of_state_161 : list item :=
  [ {| prod_item := Prod'gcc_attribute_list'0;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |} ].
Extract Inlined Constant items_of_state_161 => "assert false".

Definition items_of_state_162 : list item :=
  [ {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; RBRACK't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACK't; LBRACE't; INT't; INLINE't; INC't; FLOAT't; EXTERN't; EQ't; ENUM't; DOUBLE't; DEC't; CONSTANT't; CONST't; COMMA't; COLON't; CHAR't; BUILTIN_VA_ARG't; BANG't; AUTO't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; RBRACK't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACK't; LBRACE't; INT't; INLINE't; INC't; FLOAT't; EXTERN't; EQ't; ENUM't; DOUBLE't; DEC't; CONSTANT't; CONST't; COMMA't; COLON't; CHAR't; BUILTIN_VA_ARG't; BANG't; AUTO't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_162 => "assert false".

Definition items_of_state_163 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'argument_expression_list'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'argument_expression_list'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 2;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; RBRACK't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACK't; LBRACE't; INT't; INLINE't; INC't; FLOAT't; EXTERN't; EQ't; ENUM't; DOUBLE't; DEC't; CONSTANT't; CONST't; COMMA't; COLON't; CHAR't; BUILTIN_VA_ARG't; BANG't; AUTO't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 2;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; RBRACK't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACK't; LBRACE't; INT't; INLINE't; INC't; FLOAT't; EXTERN't; EQ't; ENUM't; DOUBLE't; DEC't; CONSTANT't; CONST't; COMMA't; COLON't; CHAR't; BUILTIN_VA_ARG't; BANG't; AUTO't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'enum_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'specifier_qualifier_list'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'specifier_qualifier_list'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'specifier_qualifier_list'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'specifier_qualifier_list'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'struct_or_union'0;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'1;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_name'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'type_name'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'type_qualifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'5;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'6;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'7;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'8;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'9;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'10;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'11;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'12;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_163 => "assert false".

Definition items_of_state_164 : list item :=
  [ {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'specifier_qualifier_list'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COLON't] |};
    {| prod_item := Prod'specifier_qualifier_list'0;
      dot_pos_item := 1;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COLON't] |};
    {| prod_item := Prod'specifier_qualifier_list'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COLON't] |};
    {| prod_item := Prod'specifier_qualifier_list'1;
      dot_pos_item := 1;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COLON't] |};
    {| prod_item := Prod'specifier_qualifier_list'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COLON't] |};
    {| prod_item := Prod'specifier_qualifier_list'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COLON't] |};
    {| prod_item := Prod'struct_or_union'0;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'1;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'5;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'6;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'7;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'8;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'9;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'10;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'11;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'12;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_164 => "assert false".

Definition items_of_state_165 : list item :=
  [ {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'specifier_qualifier_list'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COLON't] |};
    {| prod_item := Prod'specifier_qualifier_list'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COLON't] |};
    {| prod_item := Prod'specifier_qualifier_list'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COLON't] |};
    {| prod_item := Prod'specifier_qualifier_list'2;
      dot_pos_item := 1;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COLON't] |};
    {| prod_item := Prod'specifier_qualifier_list'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COLON't] |};
    {| prod_item := Prod'specifier_qualifier_list'3;
      dot_pos_item := 1;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COLON't] |};
    {| prod_item := Prod'struct_or_union'0;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'1;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'5;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'6;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'7;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'8;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'9;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'10;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'11;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'12;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_165 => "assert false".

Definition items_of_state_166 : list item :=
  [ {| prod_item := Prod'type_specifier'10;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_166 => "assert false".

Definition items_of_state_167 : list item :=
  [ {| prod_item := Prod'attribute_specifier_list'0;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier_list'1;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'0;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'1;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'2;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_167 => "assert false".

Definition items_of_state_168 : list item :=
  [ {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier_list'1;
      dot_pos_item := 1;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'0;
      dot_pos_item := 2;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'1;
      dot_pos_item := 2;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'2;
      dot_pos_item := 2;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_168 => "assert false".

Definition items_of_state_169 : list item :=
  [ {| prod_item := Prod'struct_or_union_specifier'0;
      dot_pos_item := 3;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'2;
      dot_pos_item := 3;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_169 => "assert false".

Definition items_of_state_170 : list item :=
  [ {| prod_item := Prod'struct_declaration_list'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; SIGNED't; SHORT't; RESTRICT't; RBRACE't; PACKED't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_declaration_list'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; SIGNED't; SHORT't; RESTRICT't; RBRACE't; PACKED't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'0;
      dot_pos_item := 4;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_170 => "assert false".

Definition items_of_state_171 : list item :=
  [ {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'specifier_qualifier_list'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't; COLON't] |};
    {| prod_item := Prod'specifier_qualifier_list'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't; COLON't] |};
    {| prod_item := Prod'specifier_qualifier_list'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't; COLON't] |};
    {| prod_item := Prod'specifier_qualifier_list'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't; COLON't] |};
    {| prod_item := Prod'struct_declaration'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; SIGNED't; SHORT't; RESTRICT't; RBRACE't; PACKED't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_declaration'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; SIGNED't; SHORT't; RESTRICT't; RBRACE't; PACKED't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_declaration_list'1;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; SIGNED't; SHORT't; RESTRICT't; RBRACE't; PACKED't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'0;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'1;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'0;
      dot_pos_item := 5;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'5;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'6;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'7;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'8;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'9;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'10;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'11;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'12;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_171 => "assert false".

Definition items_of_state_172 : list item :=
  [ {| prod_item := Prod'struct_or_union_specifier'0;
      dot_pos_item := 6;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_172 => "assert false".

Definition items_of_state_173 : list item :=
  [ {| prod_item := Prod'struct_declaration_list'1;
      dot_pos_item := 2;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; SIGNED't; SHORT't; RESTRICT't; RBRACE't; PACKED't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_173 => "assert false".

Definition items_of_state_174 : list item :=
  [ {| prod_item := Prod'declarator'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't; COLON't] |};
    {| prod_item := Prod'declarator'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't; COLON't] |};
    {| prod_item := Prod'direct_declarator'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'5;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'6;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'7;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'pointer'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; LPAREN't] |};
    {| prod_item := Prod'pointer'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; LPAREN't] |};
    {| prod_item := Prod'pointer'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; LPAREN't] |};
    {| prod_item := Prod'pointer'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; LPAREN't] |};
    {| prod_item := Prod'struct_declaration'0;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; SIGNED't; SHORT't; RESTRICT't; RBRACE't; PACKED't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_declaration'1;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; SIGNED't; SHORT't; RESTRICT't; RBRACE't; PACKED't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_declarator'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'struct_declarator'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'struct_declarator'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'struct_declarator_list'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'struct_declarator_list'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |} ].
Extract Inlined Constant items_of_state_174 => "assert false".

Definition items_of_state_175 : list item :=
  [ {| prod_item := Prod'direct_declarator'0;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_175 => "assert false".

Definition items_of_state_176 : list item :=
  [ {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; STAR't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LBRACK't; CONST't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; STAR't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LBRACK't; CONST't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; STAR't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LBRACK't; CONST't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; STAR't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LBRACK't; CONST't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'pointer'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'pointer'0;
      dot_pos_item := 1;
      lookaheads_item := [VAR_NAME't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'pointer'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'pointer'1;
      dot_pos_item := 1;
      lookaheads_item := [VAR_NAME't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'pointer'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'pointer'2;
      dot_pos_item := 1;
      lookaheads_item := [VAR_NAME't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'pointer'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'pointer'3;
      dot_pos_item := 1;
      lookaheads_item := [VAR_NAME't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'type_qualifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; STAR't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LBRACK't; CONST't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; STAR't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LBRACK't; CONST't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; STAR't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LBRACK't; CONST't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; STAR't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LBRACK't; CONST't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier_list'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; STAR't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LBRACK't; CONST't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier_list'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; STAR't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LBRACK't; CONST't; COMMA't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_176 => "assert false".

Definition items_of_state_177 : list item :=
  [ {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; STAR't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LBRACK't; CONST't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; STAR't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LBRACK't; CONST't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; STAR't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LBRACK't; CONST't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; STAR't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LBRACK't; CONST't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'pointer'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'pointer'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'pointer'1;
      dot_pos_item := 2;
      lookaheads_item := [VAR_NAME't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'pointer'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'pointer'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'pointer'3;
      dot_pos_item := 2;
      lookaheads_item := [VAR_NAME't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'type_qualifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; STAR't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LBRACK't; CONST't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; STAR't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LBRACK't; CONST't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; STAR't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LBRACK't; CONST't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; STAR't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LBRACK't; CONST't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier_list'1;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VAR_NAME't; STAR't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LBRACK't; CONST't; COMMA't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_177 => "assert false".

Definition items_of_state_178 : list item :=
  [ {| prod_item := Prod'type_qualifier_list'1;
      dot_pos_item := 2;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RPAREN't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; LBRACK't; INC't; DEC't; CONSTANT't; CONST't; COMMA't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_178 => "assert false".

Definition items_of_state_179 : list item :=
  [ {| prod_item := Prod'pointer'3;
      dot_pos_item := 3;
      lookaheads_item := [VAR_NAME't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |} ].
Extract Inlined Constant items_of_state_179 => "assert false".

Definition items_of_state_180 : list item :=
  [ {| prod_item := Prod'type_qualifier'3;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; INC't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DEC't; CONSTANT't; CONST't; COMMA't; COLON't; CHAR't; BUILTIN_VA_ARG't; BANG't; AUTO't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_180 => "assert false".

Definition items_of_state_181 : list item :=
  [ {| prod_item := Prod'type_qualifier_list'0;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RPAREN't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; LBRACK't; INC't; DEC't; CONSTANT't; CONST't; COMMA't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_181 => "assert false".

Definition items_of_state_182 : list item :=
  [ {| prod_item := Prod'pointer'2;
      dot_pos_item := 2;
      lookaheads_item := [VAR_NAME't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |} ].
Extract Inlined Constant items_of_state_182 => "assert false".

Definition items_of_state_183 : list item :=
  [ {| prod_item := Prod'struct_declaration'1;
      dot_pos_item := 2;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; SIGNED't; SHORT't; RESTRICT't; RBRACE't; PACKED't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_183 => "assert false".

Definition items_of_state_184 : list item :=
  [ {| prod_item := Prod'declarator'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'declarator'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'direct_declarator'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; PACKED't; LPAREN't; LBRACK't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; PACKED't; LPAREN't; LBRACK't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; PACKED't; LPAREN't; LBRACK't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; PACKED't; LPAREN't; LBRACK't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; PACKED't; LPAREN't; LBRACK't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'5;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; PACKED't; LPAREN't; LBRACK't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'6;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; PACKED't; LPAREN't; LBRACK't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'7;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; PACKED't; LPAREN't; LBRACK't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'pointer'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; LPAREN't] |};
    {| prod_item := Prod'pointer'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; LPAREN't] |};
    {| prod_item := Prod'pointer'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; LPAREN't] |};
    {| prod_item := Prod'pointer'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; LPAREN't] |} ].
Extract Inlined Constant items_of_state_184 => "assert false".

Definition items_of_state_185 : list item :=
  [ {| prod_item := Prod'declarator'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; EQ't; COMMA't; COLON't] |};
    {| prod_item := Prod'direct_declarator'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'5;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'6;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'7;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_185 => "assert false".

Definition items_of_state_186 : list item :=
  [ {| prod_item := Prod'attribute_specifier_list'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier_list'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'declarator'1;
      dot_pos_item := 2;
      lookaheads_item := [SEMICOLON't; RPAREN't; EQ't; COMMA't; COLON't] |};
    {| prod_item := Prod'direct_declarator'2;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'3;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'4;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'5;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'6;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'7;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_186 => "assert false".

Definition items_of_state_187 : list item :=
  [ {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'declaration_specifiers'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'6;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'7;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_declarator'6;
      dot_pos_item := 2;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'7;
      dot_pos_item := 2;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'function_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'parameter_declaration'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'parameter_declaration'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'parameter_declaration'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'parameter_list'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'parameter_list'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'parameter_type_list'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'parameter_type_list'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'storage_class_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'0;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'1;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'5;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'6;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'7;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'8;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'9;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'10;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'11;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'12;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_187 => "assert false".

Definition items_of_state_188 : list item :=
  [ {| prod_item := Prod'direct_declarator'7;
      dot_pos_item := 3;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_188 => "assert false".

Definition items_of_state_189 : list item :=
  [ {| prod_item := Prod'function_specifier'0;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_189 => "assert false".

Definition items_of_state_190 : list item :=
  [ {| prod_item := Prod'storage_class_specifier'1;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_190 => "assert false".

Definition items_of_state_191 : list item :=
  [ {| prod_item := Prod'storage_class_specifier'3;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_191 => "assert false".

Definition items_of_state_192 : list item :=
  [ {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'declaration_specifiers'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'2;
      dot_pos_item := 1;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'3;
      dot_pos_item := 1;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'6;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'7;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'enum_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'function_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'0;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'1;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'5;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'6;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'7;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'8;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'9;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'10;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'11;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'12;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_192 => "assert false".

Definition items_of_state_193 : list item :=
  [ {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'declaration_specifiers'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'4;
      dot_pos_item := 1;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'5;
      dot_pos_item := 1;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'6;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'7;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'enum_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'function_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'0;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'1;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'5;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'6;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'7;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'8;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'9;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'10;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'11;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'12;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_193 => "assert false".

Definition items_of_state_194 : list item :=
  [ {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'declaration_specifiers'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'0;
      dot_pos_item := 1;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'1;
      dot_pos_item := 1;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'6;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'7;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'enum_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'function_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'0;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'1;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'5;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'6;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'7;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'8;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'9;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'10;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'11;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'12;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_194 => "assert false".

Definition items_of_state_195 : list item :=
  [ {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'declaration_specifiers'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'6;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'6;
      dot_pos_item := 1;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'7;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'7;
      dot_pos_item := 1;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'enum_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'function_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'0;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'1;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'5;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'6;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'7;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'8;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'9;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'10;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'11;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'12;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_195 => "assert false".

Definition items_of_state_196 : list item :=
  [ {| prod_item := Prod'type_specifier'11;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_196 => "assert false".

Definition items_of_state_197 : list item :=
  [ {| prod_item := Prod'declaration_specifiers'6;
      dot_pos_item := 2;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |} ].
Extract Inlined Constant items_of_state_197 => "assert false".

Definition items_of_state_198 : list item :=
  [ {| prod_item := Prod'declaration_specifiers'0;
      dot_pos_item := 2;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |} ].
Extract Inlined Constant items_of_state_198 => "assert false".

Definition items_of_state_199 : list item :=
  [ {| prod_item := Prod'declaration_specifiers'4;
      dot_pos_item := 2;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |} ].
Extract Inlined Constant items_of_state_199 => "assert false".

Definition items_of_state_200 : list item :=
  [ {| prod_item := Prod'declaration_specifiers'2;
      dot_pos_item := 2;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |} ].
Extract Inlined Constant items_of_state_200 => "assert false".

Definition items_of_state_201 : list item :=
  [ {| prod_item := Prod'direct_declarator'6;
      dot_pos_item := 3;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_201 => "assert false".

Definition items_of_state_202 : list item :=
  [ {| prod_item := Prod'direct_declarator'6;
      dot_pos_item := 4;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_202 => "assert false".

Definition items_of_state_203 : list item :=
  [ {| prod_item := Prod'parameter_list'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'parameter_type_list'0;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'parameter_type_list'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't] |} ].
Extract Inlined Constant items_of_state_203 => "assert false".

Definition items_of_state_204 : list item :=
  [ {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'declaration_specifiers'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'6;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'7;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'enum_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'function_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'parameter_declaration'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'parameter_declaration'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'parameter_declaration'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'parameter_list'1;
      dot_pos_item := 2;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'parameter_type_list'1;
      dot_pos_item := 2;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'storage_class_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'0;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'1;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'5;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'6;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'7;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'8;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'9;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'10;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'11;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'12;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_204 => "assert false".

Definition items_of_state_205 : list item :=
  [ {| prod_item := Prod'parameter_type_list'1;
      dot_pos_item := 3;
      lookaheads_item := [RPAREN't] |} ].
Extract Inlined Constant items_of_state_205 => "assert false".

Definition items_of_state_206 : list item :=
  [ {| prod_item := Prod'parameter_list'1;
      dot_pos_item := 3;
      lookaheads_item := [RPAREN't; COMMA't] |} ].
Extract Inlined Constant items_of_state_206 => "assert false".

Definition items_of_state_207 : list item :=
  [ {| prod_item := Prod'abstract_declarator'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'abstract_declarator'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'abstract_declarator'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'declarator'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'declarator'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'5;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'6;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'7;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'8;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'9;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'10;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'11;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'12;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_declarator'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; PACKED't; LPAREN't; LBRACK't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; PACKED't; LPAREN't; LBRACK't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; PACKED't; LPAREN't; LBRACK't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; PACKED't; LPAREN't; LBRACK't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; PACKED't; LPAREN't; LBRACK't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'5;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; PACKED't; LPAREN't; LBRACK't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'6;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; PACKED't; LPAREN't; LBRACK't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'7;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; PACKED't; LPAREN't; LBRACK't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'parameter_declaration'0;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'parameter_declaration'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'parameter_declaration'2;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'pointer'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'pointer'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'pointer'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'pointer'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |} ].
Extract Inlined Constant items_of_state_207 => "assert false".

Definition items_of_state_208 : list item :=
  [ {| prod_item := Prod'abstract_declarator'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'abstract_declarator'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'abstract_declarator'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'declaration_specifiers'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'6;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'7;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declarator'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'declarator'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'direct_abstract_declarator'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'0;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'5;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'6;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'7;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'8;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'9;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'10;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'10;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'11;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'12;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'12;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_declarator'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; PACKED't; LPAREN't; LBRACK't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; PACKED't; LPAREN't; LBRACK't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; PACKED't; LPAREN't; LBRACK't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; PACKED't; LPAREN't; LBRACK't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; PACKED't; LPAREN't; LBRACK't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; PACKED't; LPAREN't; LBRACK't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'5;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; PACKED't; LPAREN't; LBRACK't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'6;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; PACKED't; LPAREN't; LBRACK't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'7;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; PACKED't; LPAREN't; LBRACK't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'function_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'parameter_declaration'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'parameter_declaration'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'parameter_declaration'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'parameter_list'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'parameter_list'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'parameter_type_list'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'parameter_type_list'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'pointer'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'pointer'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'pointer'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'pointer'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'storage_class_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'0;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'1;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'5;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'6;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'7;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'8;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'9;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'10;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'11;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'12;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_208 => "assert false".

Definition items_of_state_209 : list item :=
  [ {| prod_item := Prod'direct_abstract_declarator'12;
      dot_pos_item := 2;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |} ].
Extract Inlined Constant items_of_state_209 => "assert false".

Definition items_of_state_210 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; HAT't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; HAT't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't] |};
    {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'2;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'4;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'6;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'8;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; HAT't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; HAT't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; HAT't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; HAT't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; HAT't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'type_qualifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier_list'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier_list'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_210 => "assert false".

Definition items_of_state_211 : list item :=
  [ {| prod_item := Prod'direct_abstract_declarator'8;
      dot_pos_item := 2;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |} ].
Extract Inlined Constant items_of_state_211 => "assert false".

Definition items_of_state_212 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; HAT't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; HAT't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't] |};
    {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'2;
      dot_pos_item := 2;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'6;
      dot_pos_item := 2;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; HAT't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; HAT't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; HAT't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; HAT't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; HAT't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'type_qualifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier_list'1;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_212 => "assert false".

Definition items_of_state_213 : list item :=
  [ {| prod_item := Prod'direct_abstract_declarator'6;
      dot_pos_item := 3;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |} ].
Extract Inlined Constant items_of_state_213 => "assert false".

Definition items_of_state_214 : list item :=
  [ {| prod_item := Prod'direct_abstract_declarator'2;
      dot_pos_item := 3;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |} ].
Extract Inlined Constant items_of_state_214 => "assert false".

Definition items_of_state_215 : list item :=
  [ {| prod_item := Prod'direct_abstract_declarator'2;
      dot_pos_item := 4;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |} ].
Extract Inlined Constant items_of_state_215 => "assert false".

Definition items_of_state_216 : list item :=
  [ {| prod_item := Prod'direct_abstract_declarator'4;
      dot_pos_item := 2;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |} ].
Extract Inlined Constant items_of_state_216 => "assert false".

Definition items_of_state_217 : list item :=
  [ {| prod_item := Prod'direct_abstract_declarator'4;
      dot_pos_item := 3;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |} ].
Extract Inlined Constant items_of_state_217 => "assert false".

Definition items_of_state_218 : list item :=
  [ {| prod_item := Prod'abstract_declarator'0;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'abstract_declarator'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'declarator'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'5;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'6;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'7;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'8;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'9;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'10;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'11;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'12;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_declarator'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; PACKED't; LPAREN't; LBRACK't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; PACKED't; LPAREN't; LBRACK't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; PACKED't; LPAREN't; LBRACK't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; PACKED't; LPAREN't; LBRACK't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; PACKED't; LPAREN't; LBRACK't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'5;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; PACKED't; LPAREN't; LBRACK't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'6;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; PACKED't; LPAREN't; LBRACK't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'7;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; PACKED't; LPAREN't; LBRACK't; COMMA't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_218 => "assert false".

Definition items_of_state_219 : list item :=
  [ {| prod_item := Prod'abstract_declarator'1;
      dot_pos_item := 2;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'3;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'5;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'7;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'9;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'11;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |} ].
Extract Inlined Constant items_of_state_219 => "assert false".

Definition items_of_state_220 : list item :=
  [ {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'declaration_specifiers'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'6;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'7;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'9;
      dot_pos_item := 2;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'11;
      dot_pos_item := 2;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'enum_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'function_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'parameter_declaration'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'parameter_declaration'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'parameter_declaration'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'parameter_list'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'parameter_list'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'parameter_type_list'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'parameter_type_list'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'storage_class_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'0;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'1;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'5;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'6;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'7;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'8;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'9;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'10;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'11;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'12;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_220 => "assert false".

Definition items_of_state_221 : list item :=
  [ {| prod_item := Prod'direct_abstract_declarator'11;
      dot_pos_item := 3;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |} ].
Extract Inlined Constant items_of_state_221 => "assert false".

Definition items_of_state_222 : list item :=
  [ {| prod_item := Prod'direct_abstract_declarator'9;
      dot_pos_item := 3;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |} ].
Extract Inlined Constant items_of_state_222 => "assert false".

Definition items_of_state_223 : list item :=
  [ {| prod_item := Prod'direct_abstract_declarator'9;
      dot_pos_item := 4;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |} ].
Extract Inlined Constant items_of_state_223 => "assert false".

Definition items_of_state_224 : list item :=
  [ {| prod_item := Prod'parameter_list'0;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |} ].
Extract Inlined Constant items_of_state_224 => "assert false".

Definition items_of_state_225 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; HAT't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; HAT't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't] |};
    {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'1;
      dot_pos_item := 2;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'3;
      dot_pos_item := 2;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'5;
      dot_pos_item := 2;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'7;
      dot_pos_item := 2;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; HAT't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; HAT't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; HAT't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; HAT't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; HAT't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'type_qualifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier_list'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier_list'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_225 => "assert false".

Definition items_of_state_226 : list item :=
  [ {| prod_item := Prod'direct_abstract_declarator'7;
      dot_pos_item := 3;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |} ].
Extract Inlined Constant items_of_state_226 => "assert false".

Definition items_of_state_227 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; HAT't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; HAT't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't] |};
    {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'1;
      dot_pos_item := 3;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'5;
      dot_pos_item := 3;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; HAT't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; HAT't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; HAT't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; HAT't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; HAT't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'type_qualifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier_list'1;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_227 => "assert false".

Definition items_of_state_228 : list item :=
  [ {| prod_item := Prod'direct_abstract_declarator'5;
      dot_pos_item := 4;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |} ].
Extract Inlined Constant items_of_state_228 => "assert false".

Definition items_of_state_229 : list item :=
  [ {| prod_item := Prod'direct_abstract_declarator'1;
      dot_pos_item := 4;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |} ].
Extract Inlined Constant items_of_state_229 => "assert false".

Definition items_of_state_230 : list item :=
  [ {| prod_item := Prod'direct_abstract_declarator'1;
      dot_pos_item := 5;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |} ].
Extract Inlined Constant items_of_state_230 => "assert false".

Definition items_of_state_231 : list item :=
  [ {| prod_item := Prod'direct_abstract_declarator'3;
      dot_pos_item := 3;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |} ].
Extract Inlined Constant items_of_state_231 => "assert false".

Definition items_of_state_232 : list item :=
  [ {| prod_item := Prod'direct_abstract_declarator'3;
      dot_pos_item := 4;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |} ].
Extract Inlined Constant items_of_state_232 => "assert false".

Definition items_of_state_233 : list item :=
  [ {| prod_item := Prod'direct_abstract_declarator'10;
      dot_pos_item := 2;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |} ].
Extract Inlined Constant items_of_state_233 => "assert false".

Definition items_of_state_234 : list item :=
  [ {| prod_item := Prod'direct_abstract_declarator'10;
      dot_pos_item := 3;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |} ].
Extract Inlined Constant items_of_state_234 => "assert false".

Definition items_of_state_235 : list item :=
  [ {| prod_item := Prod'attribute_specifier_list'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier_list'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'declarator'0;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; EQ't; COMMA't; COLON't] |};
    {| prod_item := Prod'direct_declarator'2;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'3;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'4;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'5;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'6;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'7;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_235 => "assert false".

Definition items_of_state_236 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; HAT't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; HAT't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't] |};
    {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't] |};
    {| prod_item := Prod'direct_declarator'2;
      dot_pos_item := 2;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'3;
      dot_pos_item := 2;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'4;
      dot_pos_item := 2;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'5;
      dot_pos_item := 2;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; HAT't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; HAT't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; HAT't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; HAT't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; HAT't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'type_qualifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier_list'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier_list'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_236 => "assert false".

Definition items_of_state_237 : list item :=
  [ {| prod_item := Prod'direct_declarator'5;
      dot_pos_item := 3;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_237 => "assert false".

Definition items_of_state_238 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; HAT't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; HAT't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't] |};
    {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't] |};
    {| prod_item := Prod'direct_declarator'2;
      dot_pos_item := 3;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'4;
      dot_pos_item := 3;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; HAT't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; HAT't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; HAT't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; HAT't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; HAT't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'type_qualifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier_list'1;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; RESTRICT't; RBRACK't; PLUS't; PACKED't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; CONST't; BUILTIN_VA_ARG't; BANG't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_238 => "assert false".

Definition items_of_state_239 : list item :=
  [ {| prod_item := Prod'direct_declarator'4;
      dot_pos_item := 4;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_239 => "assert false".

Definition items_of_state_240 : list item :=
  [ {| prod_item := Prod'direct_declarator'2;
      dot_pos_item := 4;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_240 => "assert false".

Definition items_of_state_241 : list item :=
  [ {| prod_item := Prod'direct_declarator'2;
      dot_pos_item := 5;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_241 => "assert false".

Definition items_of_state_242 : list item :=
  [ {| prod_item := Prod'direct_declarator'3;
      dot_pos_item := 3;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_242 => "assert false".

Definition items_of_state_243 : list item :=
  [ {| prod_item := Prod'direct_declarator'3;
      dot_pos_item := 4;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_243 => "assert false".

Definition items_of_state_244 : list item :=
  [ {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LBRACE't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LBRACE't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LBRACE't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LBRACE't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier_list'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LBRACE't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'declarator'0;
      dot_pos_item := 2;
      lookaheads_item := [SEMICOLON't; RPAREN't; LBRACE't; EQ't; COMMA't; COLON't] |} ].
Extract Inlined Constant items_of_state_244 => "assert false".

Definition items_of_state_245 : list item :=
  [ {| prod_item := Prod'attribute_specifier_list'1;
      dot_pos_item := 2;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; OTHER_NAME't; LBRACE't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_245 => "assert false".

Definition items_of_state_246 : list item :=
  [ {| prod_item := Prod'abstract_declarator'2;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'3;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'5;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'7;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'9;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'11;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |} ].
Extract Inlined Constant items_of_state_246 => "assert false".

Definition items_of_state_247 : list item :=
  [ {| prod_item := Prod'direct_declarator'1;
      dot_pos_item := 2;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_247 => "assert false".

Definition items_of_state_248 : list item :=
  [ {| prod_item := Prod'direct_declarator'1;
      dot_pos_item := 3;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_248 => "assert false".

Definition items_of_state_249 : list item :=
  [ {| prod_item := Prod'direct_abstract_declarator'0;
      dot_pos_item := 2;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |} ].
Extract Inlined Constant items_of_state_249 => "assert false".

Definition items_of_state_250 : list item :=
  [ {| prod_item := Prod'direct_abstract_declarator'0;
      dot_pos_item := 3;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't; COMMA't] |} ].
Extract Inlined Constant items_of_state_250 => "assert false".

Definition items_of_state_251 : list item :=
  [ {| prod_item := Prod'parameter_declaration'0;
      dot_pos_item := 2;
      lookaheads_item := [RPAREN't; COMMA't] |} ].
Extract Inlined Constant items_of_state_251 => "assert false".

Definition items_of_state_252 : list item :=
  [ {| prod_item := Prod'parameter_declaration'1;
      dot_pos_item := 2;
      lookaheads_item := [RPAREN't; COMMA't] |} ].
Extract Inlined Constant items_of_state_252 => "assert false".

Definition items_of_state_253 : list item :=
  [ {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LBRACE't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LBRACE't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LBRACE't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LBRACE't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier_list'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RPAREN't; PACKED't; LBRACE't; EQ't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'declarator'1;
      dot_pos_item := 3;
      lookaheads_item := [SEMICOLON't; RPAREN't; LBRACE't; EQ't; COMMA't; COLON't] |} ].
Extract Inlined Constant items_of_state_253 => "assert false".

Definition items_of_state_254 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'constant_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'struct_declarator'2;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_254 => "assert false".

Definition items_of_state_255 : list item :=
  [ {| prod_item := Prod'struct_declarator'2;
      dot_pos_item := 2;
      lookaheads_item := [SEMICOLON't; COMMA't] |} ].
Extract Inlined Constant items_of_state_255 => "assert false".

Definition items_of_state_256 : list item :=
  [ {| prod_item := Prod'constant_expression'0;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RBRACK't; RBRACE't; COMMA't; COLON't] |} ].
Extract Inlined Constant items_of_state_256 => "assert false".

Definition items_of_state_257 : list item :=
  [ {| prod_item := Prod'struct_declaration'0;
      dot_pos_item := 2;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; SIGNED't; SHORT't; RESTRICT't; RBRACE't; PACKED't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_declarator_list'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; COMMA't] |} ].
Extract Inlined Constant items_of_state_257 => "assert false".

Definition items_of_state_258 : list item :=
  [ {| prod_item := Prod'struct_declaration'0;
      dot_pos_item := 3;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; SIGNED't; SHORT't; RESTRICT't; RBRACE't; PACKED't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_258 => "assert false".

Definition items_of_state_259 : list item :=
  [ {| prod_item := Prod'declarator'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't; COLON't] |};
    {| prod_item := Prod'declarator'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't; COLON't] |};
    {| prod_item := Prod'direct_declarator'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'5;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'6;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'7;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; COMMA't; COLON't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'pointer'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; LPAREN't] |};
    {| prod_item := Prod'pointer'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; LPAREN't] |};
    {| prod_item := Prod'pointer'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; LPAREN't] |};
    {| prod_item := Prod'pointer'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; LPAREN't] |};
    {| prod_item := Prod'struct_declarator'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'struct_declarator'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'struct_declarator'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'struct_declarator_list'1;
      dot_pos_item := 2;
      lookaheads_item := [SEMICOLON't; COMMA't] |} ].
Extract Inlined Constant items_of_state_259 => "assert false".

Definition items_of_state_260 : list item :=
  [ {| prod_item := Prod'struct_declarator_list'1;
      dot_pos_item := 3;
      lookaheads_item := [SEMICOLON't; COMMA't] |} ].
Extract Inlined Constant items_of_state_260 => "assert false".

Definition items_of_state_261 : list item :=
  [ {| prod_item := Prod'struct_declarator'0;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'struct_declarator'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; COMMA't] |} ].
Extract Inlined Constant items_of_state_261 => "assert false".

Definition items_of_state_262 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'constant_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'struct_declarator'1;
      dot_pos_item := 2;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_262 => "assert false".

Definition items_of_state_263 : list item :=
  [ {| prod_item := Prod'struct_declarator'1;
      dot_pos_item := 3;
      lookaheads_item := [SEMICOLON't; COMMA't] |} ].
Extract Inlined Constant items_of_state_263 => "assert false".

Definition items_of_state_264 : list item :=
  [ {| prod_item := Prod'struct_declarator_list'0;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; COMMA't] |} ].
Extract Inlined Constant items_of_state_264 => "assert false".

Definition items_of_state_265 : list item :=
  [ {| prod_item := Prod'struct_declaration_list'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; SIGNED't; SHORT't; RESTRICT't; RBRACE't; PACKED't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_declaration_list'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; SIGNED't; SHORT't; RESTRICT't; RBRACE't; PACKED't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'1;
      dot_pos_item := 3;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_265 => "assert false".

Definition items_of_state_266 : list item :=
  [ {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'specifier_qualifier_list'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't; COLON't] |};
    {| prod_item := Prod'specifier_qualifier_list'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't; COLON't] |};
    {| prod_item := Prod'specifier_qualifier_list'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't; COLON't] |};
    {| prod_item := Prod'specifier_qualifier_list'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't; COLON't] |};
    {| prod_item := Prod'struct_declaration'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; SIGNED't; SHORT't; RESTRICT't; RBRACE't; PACKED't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_declaration'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; SIGNED't; SHORT't; RESTRICT't; RBRACE't; PACKED't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_declaration_list'1;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; SIGNED't; SHORT't; RESTRICT't; RBRACE't; PACKED't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'0;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'1;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'1;
      dot_pos_item := 4;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'5;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'6;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'7;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'8;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'9;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'10;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'11;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'12;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; PACKED't; LPAREN't; LONG't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; COLON't; CHAR't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_266 => "assert false".

Definition items_of_state_267 : list item :=
  [ {| prod_item := Prod'struct_or_union_specifier'1;
      dot_pos_item := 5;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_267 => "assert false".

Definition items_of_state_268 : list item :=
  [ {| prod_item := Prod'specifier_qualifier_list'2;
      dot_pos_item := 2;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COLON't] |} ].
Extract Inlined Constant items_of_state_268 => "assert false".

Definition items_of_state_269 : list item :=
  [ {| prod_item := Prod'specifier_qualifier_list'0;
      dot_pos_item := 2;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; RPAREN't; LPAREN't; LBRACK't; COLON't] |} ].
Extract Inlined Constant items_of_state_269 => "assert false".

Definition items_of_state_270 : list item :=
  [ {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 3;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; RBRACK't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACK't; LBRACE't; INT't; INLINE't; INC't; FLOAT't; EXTERN't; EQ't; ENUM't; DOUBLE't; DEC't; CONSTANT't; CONST't; COMMA't; COLON't; CHAR't; BUILTIN_VA_ARG't; BANG't; AUTO't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_270 => "assert false".

Definition items_of_state_271 : list item :=
  [ {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 4;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; RBRACK't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACK't; LBRACE't; INT't; INLINE't; INC't; FLOAT't; EXTERN't; EQ't; ENUM't; DOUBLE't; DEC't; CONSTANT't; CONST't; COMMA't; COLON't; CHAR't; BUILTIN_VA_ARG't; BANG't; AUTO't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_271 => "assert false".

Definition items_of_state_272 : list item :=
  [ {| prod_item := Prod'abstract_declarator'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'abstract_declarator'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'abstract_declarator'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'direct_abstract_declarator'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'5;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'6;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'7;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'8;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'9;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'10;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'11;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'12;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'pointer'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'pointer'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'pointer'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'pointer'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'type_name'0;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'type_name'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't] |} ].
Extract Inlined Constant items_of_state_272 => "assert false".

Definition items_of_state_273 : list item :=
  [ {| prod_item := Prod'abstract_declarator'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'abstract_declarator'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'abstract_declarator'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'declaration_specifiers'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'6;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'7;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_abstract_declarator'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'0;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'5;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'6;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'7;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'8;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'9;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'10;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'10;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'11;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'12;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'12;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'enum_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'function_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'parameter_declaration'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'parameter_declaration'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'parameter_declaration'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'parameter_list'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'parameter_list'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'parameter_type_list'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'parameter_type_list'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'pointer'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'pointer'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'pointer'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'pointer'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'storage_class_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'0;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'1;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'5;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'6;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'7;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'8;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'9;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'10;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'11;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'12;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_273 => "assert false".

Definition items_of_state_274 : list item :=
  [ {| prod_item := Prod'abstract_declarator'0;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'abstract_declarator'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'direct_abstract_declarator'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'5;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'6;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'7;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'8;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'9;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'10;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'11;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'direct_abstract_declarator'12;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; LPAREN't; LBRACK't] |} ].
Extract Inlined Constant items_of_state_274 => "assert false".

Definition items_of_state_275 : list item :=
  [ {| prod_item := Prod'type_name'1;
      dot_pos_item := 2;
      lookaheads_item := [RPAREN't] |} ].
Extract Inlined Constant items_of_state_275 => "assert false".

Definition items_of_state_276 : list item :=
  [ {| prod_item := Prod'argument_expression_list'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 3;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; RBRACK't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACK't; LBRACE't; INT't; INLINE't; INC't; FLOAT't; EXTERN't; EQ't; ENUM't; DOUBLE't; DEC't; CONSTANT't; CONST't; COMMA't; COLON't; CHAR't; BUILTIN_VA_ARG't; BANG't; AUTO't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_276 => "assert false".

Definition items_of_state_277 : list item :=
  [ {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 4;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; RBRACK't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACK't; LBRACE't; INT't; INLINE't; INC't; FLOAT't; EXTERN't; EQ't; ENUM't; DOUBLE't; DEC't; CONSTANT't; CONST't; COMMA't; COLON't; CHAR't; BUILTIN_VA_ARG't; BANG't; AUTO't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_277 => "assert false".

Definition items_of_state_278 : list item :=
  [ {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 2;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 2;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 3;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_278 => "assert false".

Definition items_of_state_279 : list item :=
  [ {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 3;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 3;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 4;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_279 => "assert false".

Definition items_of_state_280 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'c_initializer'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'c_initializer'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'c_initializer'2;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'designation'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; LBRACE't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'designator'0;
      dot_pos_item := 0;
      lookaheads_item := [LBRACK't; EQ't; DOT't] |};
    {| prod_item := Prod'designator'1;
      dot_pos_item := 0;
      lookaheads_item := [LBRACK't; EQ't; DOT't] |};
    {| prod_item := Prod'designator_list'0;
      dot_pos_item := 0;
      lookaheads_item := [LBRACK't; EQ't; DOT't] |};
    {| prod_item := Prod'designator_list'1;
      dot_pos_item := 0;
      lookaheads_item := [LBRACK't; EQ't; DOT't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'initializer_list'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'initializer_list'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'initializer_list'2;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'initializer_list'3;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 4;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 4;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_280 => "assert false".

Definition items_of_state_281 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; HAT't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; HAT't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't] |};
    {| prod_item := Prod'constant_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't] |};
    {| prod_item := Prod'designator'0;
      dot_pos_item := 1;
      lookaheads_item := [LBRACK't; EQ't; DOT't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; HAT't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; HAT't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; HAT't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; HAT't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; HAT't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACK't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACK't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_281 => "assert false".

Definition items_of_state_282 : list item :=
  [ {| prod_item := Prod'designator'0;
      dot_pos_item := 2;
      lookaheads_item := [LBRACK't; EQ't; DOT't] |} ].
Extract Inlined Constant items_of_state_282 => "assert false".

Definition items_of_state_283 : list item :=
  [ {| prod_item := Prod'designator'0;
      dot_pos_item := 3;
      lookaheads_item := [LBRACK't; EQ't; DOT't] |} ].
Extract Inlined Constant items_of_state_283 => "assert false".

Definition items_of_state_284 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'c_initializer'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'c_initializer'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'c_initializer'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RBRACE't; COMMA't] |};
    {| prod_item := Prod'c_initializer'2;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'c_initializer'2;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RBRACE't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'designation'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; LBRACE't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'designator'0;
      dot_pos_item := 0;
      lookaheads_item := [LBRACK't; EQ't; DOT't] |};
    {| prod_item := Prod'designator'1;
      dot_pos_item := 0;
      lookaheads_item := [LBRACK't; EQ't; DOT't] |};
    {| prod_item := Prod'designator_list'0;
      dot_pos_item := 0;
      lookaheads_item := [LBRACK't; EQ't; DOT't] |};
    {| prod_item := Prod'designator_list'1;
      dot_pos_item := 0;
      lookaheads_item := [LBRACK't; EQ't; DOT't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'initializer_list'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'initializer_list'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'initializer_list'2;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'initializer_list'3;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_284 => "assert false".

Definition items_of_state_285 : list item :=
  [ {| prod_item := Prod'designator'1;
      dot_pos_item := 1;
      lookaheads_item := [LBRACK't; EQ't; DOT't] |} ].
Extract Inlined Constant items_of_state_285 => "assert false".

Definition items_of_state_286 : list item :=
  [ {| prod_item := Prod'designator'1;
      dot_pos_item := 2;
      lookaheads_item := [LBRACK't; EQ't; DOT't] |} ].
Extract Inlined Constant items_of_state_286 => "assert false".

Definition items_of_state_287 : list item :=
  [ {| prod_item := Prod'c_initializer'1;
      dot_pos_item := 2;
      lookaheads_item := [SEMICOLON't; RBRACE't; COMMA't] |};
    {| prod_item := Prod'c_initializer'2;
      dot_pos_item := 2;
      lookaheads_item := [SEMICOLON't; RBRACE't; COMMA't] |};
    {| prod_item := Prod'initializer_list'2;
      dot_pos_item := 1;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'initializer_list'3;
      dot_pos_item := 1;
      lookaheads_item := [RBRACE't; COMMA't] |} ].
Extract Inlined Constant items_of_state_287 => "assert false".

Definition items_of_state_288 : list item :=
  [ {| prod_item := Prod'c_initializer'1;
      dot_pos_item := 3;
      lookaheads_item := [SEMICOLON't; RBRACE't; COMMA't] |} ].
Extract Inlined Constant items_of_state_288 => "assert false".

Definition items_of_state_289 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'c_initializer'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'c_initializer'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'c_initializer'2;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'c_initializer'2;
      dot_pos_item := 3;
      lookaheads_item := [SEMICOLON't; RBRACE't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'designation'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; LBRACE't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'designator'0;
      dot_pos_item := 0;
      lookaheads_item := [LBRACK't; EQ't; DOT't] |};
    {| prod_item := Prod'designator'1;
      dot_pos_item := 0;
      lookaheads_item := [LBRACK't; EQ't; DOT't] |};
    {| prod_item := Prod'designator_list'0;
      dot_pos_item := 0;
      lookaheads_item := [LBRACK't; EQ't; DOT't] |};
    {| prod_item := Prod'designator_list'1;
      dot_pos_item := 0;
      lookaheads_item := [LBRACK't; EQ't; DOT't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'initializer_list'2;
      dot_pos_item := 2;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'initializer_list'3;
      dot_pos_item := 2;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_289 => "assert false".

Definition items_of_state_290 : list item :=
  [ {| prod_item := Prod'c_initializer'2;
      dot_pos_item := 4;
      lookaheads_item := [SEMICOLON't; RBRACE't; COMMA't] |} ].
Extract Inlined Constant items_of_state_290 => "assert false".

Definition items_of_state_291 : list item :=
  [ {| prod_item := Prod'designation'0;
      dot_pos_item := 1;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; LBRACE't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'designator'0;
      dot_pos_item := 0;
      lookaheads_item := [LBRACK't; EQ't; DOT't] |};
    {| prod_item := Prod'designator'1;
      dot_pos_item := 0;
      lookaheads_item := [LBRACK't; EQ't; DOT't] |};
    {| prod_item := Prod'designator_list'1;
      dot_pos_item := 1;
      lookaheads_item := [LBRACK't; EQ't; DOT't] |} ].
Extract Inlined Constant items_of_state_291 => "assert false".

Definition items_of_state_292 : list item :=
  [ {| prod_item := Prod'designation'0;
      dot_pos_item := 2;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; LBRACE't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_292 => "assert false".

Definition items_of_state_293 : list item :=
  [ {| prod_item := Prod'designator_list'1;
      dot_pos_item := 2;
      lookaheads_item := [LBRACK't; EQ't; DOT't] |} ].
Extract Inlined Constant items_of_state_293 => "assert false".

Definition items_of_state_294 : list item :=
  [ {| prod_item := Prod'designator_list'0;
      dot_pos_item := 1;
      lookaheads_item := [LBRACK't; EQ't; DOT't] |} ].
Extract Inlined Constant items_of_state_294 => "assert false".

Definition items_of_state_295 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'c_initializer'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'c_initializer'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'c_initializer'2;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'initializer_list'2;
      dot_pos_item := 3;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_295 => "assert false".

Definition items_of_state_296 : list item :=
  [ {| prod_item := Prod'initializer_list'2;
      dot_pos_item := 4;
      lookaheads_item := [RBRACE't; COMMA't] |} ].
Extract Inlined Constant items_of_state_296 => "assert false".

Definition items_of_state_297 : list item :=
  [ {| prod_item := Prod'c_initializer'0;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; RBRACE't; COMMA't] |} ].
Extract Inlined Constant items_of_state_297 => "assert false".

Definition items_of_state_298 : list item :=
  [ {| prod_item := Prod'initializer_list'3;
      dot_pos_item := 3;
      lookaheads_item := [RBRACE't; COMMA't] |} ].
Extract Inlined Constant items_of_state_298 => "assert false".

Definition items_of_state_299 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'c_initializer'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'c_initializer'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'c_initializer'2;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'initializer_list'0;
      dot_pos_item := 1;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_299 => "assert false".

Definition items_of_state_300 : list item :=
  [ {| prod_item := Prod'initializer_list'0;
      dot_pos_item := 2;
      lookaheads_item := [RBRACE't; COMMA't] |} ].
Extract Inlined Constant items_of_state_300 => "assert false".

Definition items_of_state_301 : list item :=
  [ {| prod_item := Prod'initializer_list'1;
      dot_pos_item := 1;
      lookaheads_item := [RBRACE't; COMMA't] |} ].
Extract Inlined Constant items_of_state_301 => "assert false".

Definition items_of_state_302 : list item :=
  [ {| prod_item := Prod'initializer_list'2;
      dot_pos_item := 1;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'initializer_list'3;
      dot_pos_item := 1;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 5;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 5;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_302 => "assert false".

Definition items_of_state_303 : list item :=
  [ {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 6;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_303 => "assert false".

Definition items_of_state_304 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'c_initializer'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'c_initializer'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'c_initializer'2;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'designation'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; LBRACE't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'designator'0;
      dot_pos_item := 0;
      lookaheads_item := [LBRACK't; EQ't; DOT't] |};
    {| prod_item := Prod'designator'1;
      dot_pos_item := 0;
      lookaheads_item := [LBRACK't; EQ't; DOT't] |};
    {| prod_item := Prod'designator_list'0;
      dot_pos_item := 0;
      lookaheads_item := [LBRACK't; EQ't; DOT't] |};
    {| prod_item := Prod'designator_list'1;
      dot_pos_item := 0;
      lookaheads_item := [LBRACK't; EQ't; DOT't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'initializer_list'2;
      dot_pos_item := 2;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'initializer_list'3;
      dot_pos_item := 2;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 6;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; RBRACE't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RIGHT_ASSIGN't; RIGHT't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_304 => "assert false".

Definition items_of_state_305 : list item :=
  [ {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 7;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_305 => "assert false".

Definition items_of_state_306 : list item :=
  [ {| prod_item := Prod'expression'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 2;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_306 => "assert false".

Definition items_of_state_307 : list item :=
  [ {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 3;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_307 => "assert false".

Definition items_of_state_308 : list item :=
  [ {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 2;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_308 => "assert false".

Definition items_of_state_309 : list item :=
  [ {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 3;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_309 => "assert false".

Definition items_of_state_310 : list item :=
  [ {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 4;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'specifier_qualifier_list'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'specifier_qualifier_list'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'specifier_qualifier_list'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'specifier_qualifier_list'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; RPAREN't; LPAREN't; LBRACK't] |};
    {| prod_item := Prod'struct_or_union'0;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'1;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_name'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'type_name'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'type_qualifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'5;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'6;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'7;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'8;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'9;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'10;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'11;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'12;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; STRUCT't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; FLOAT't; ENUM't; DOUBLE't; CONST't; CHAR't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_310 => "assert false".

Definition items_of_state_311 : list item :=
  [ {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 5;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_311 => "assert false".

Definition items_of_state_312 : list item :=
  [ {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 6;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_312 => "assert false".

Definition items_of_state_313 : list item :=
  [ {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 2;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_313 => "assert false".

Definition items_of_state_314 : list item :=
  [ {| prod_item := Prod'enumerator'1;
      dot_pos_item := 3;
      lookaheads_item := [RBRACE't; COMMA't] |} ].
Extract Inlined Constant items_of_state_314 => "assert false".

Definition items_of_state_315 : list item :=
  [ {| prod_item := Prod'enumerator_list'0;
      dot_pos_item := 1;
      lookaheads_item := [RBRACE't; COMMA't] |} ].
Extract Inlined Constant items_of_state_315 => "assert false".

Definition items_of_state_316 : list item :=
  [ {| prod_item := Prod'enum_specifier'1;
      dot_pos_item := 3;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'3;
      dot_pos_item := 3;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enumeration_constant'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; EQ't; COMMA't] |};
    {| prod_item := Prod'enumerator'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'enumerator'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'enumerator_list'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'enumerator_list'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |} ].
Extract Inlined Constant items_of_state_316 => "assert false".

Definition items_of_state_317 : list item :=
  [ {| prod_item := Prod'enum_specifier'1;
      dot_pos_item := 4;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'3;
      dot_pos_item := 4;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enumerator_list'1;
      dot_pos_item := 1;
      lookaheads_item := [RBRACE't; COMMA't] |} ].
Extract Inlined Constant items_of_state_317 => "assert false".

Definition items_of_state_318 : list item :=
  [ {| prod_item := Prod'enum_specifier'1;
      dot_pos_item := 5;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_318 => "assert false".

Definition items_of_state_319 : list item :=
  [ {| prod_item := Prod'enum_specifier'3;
      dot_pos_item := 5;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enumeration_constant'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; EQ't; COMMA't] |};
    {| prod_item := Prod'enumerator'0;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'enumerator'1;
      dot_pos_item := 0;
      lookaheads_item := [RBRACE't; COMMA't] |};
    {| prod_item := Prod'enumerator_list'1;
      dot_pos_item := 2;
      lookaheads_item := [RBRACE't; COMMA't] |} ].
Extract Inlined Constant items_of_state_319 => "assert false".

Definition items_of_state_320 : list item :=
  [ {| prod_item := Prod'enum_specifier'3;
      dot_pos_item := 6;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; COLON't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_320 => "assert false".

Definition items_of_state_321 : list item :=
  [ {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 2;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 2;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_321 => "assert false".

Definition items_of_state_322 : list item :=
  [ {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 3;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 3;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_322 => "assert false".

Definition items_of_state_323 : list item :=
  [ {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 2;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_323 => "assert false".

Definition items_of_state_324 : list item :=
  [ {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 2;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 2;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 2;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_324 => "assert false".

Definition items_of_state_325 : list item :=
  [ {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 3;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 3;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 3;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_325 => "assert false".

Definition items_of_state_326 : list item :=
  [ {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 4;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_326 => "assert false".

Definition items_of_state_327 : list item :=
  [ {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 2;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 2;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 3;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_327 => "assert false".

Definition items_of_state_328 : list item :=
  [ {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 3;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 3;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 4;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_328 => "assert false".

Definition items_of_state_329 : list item :=
  [ {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 2;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RBRACK't; RBRACE't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; COLON't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_329 => "assert false".

Definition items_of_state_330 : list item :=
  [ {| prod_item := Prod'argument_expression_list'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 3;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; RBRACK't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACK't; LBRACE't; INT't; INLINE't; INC't; FLOAT't; EXTERN't; EQ't; ENUM't; DOUBLE't; DEC't; CONSTANT't; CONST't; COMMA't; COLON't; CHAR't; BUILTIN_VA_ARG't; BANG't; AUTO't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_330 => "assert false".

Definition items_of_state_331 : list item :=
  [ {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 4;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RESTRICT't; REGISTER't; RBRACK't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACK't; LBRACE't; INT't; INLINE't; INC't; FLOAT't; EXTERN't; EQ't; ENUM't; DOUBLE't; DEC't; CONSTANT't; CONST't; COMMA't; COLON't; CHAR't; BUILTIN_VA_ARG't; BANG't; AUTO't; ATTRIBUTE't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_331 => "assert false".

Definition items_of_state_332 : list item :=
  [ {| prod_item := Prod'translation_unit_file'1;
      dot_pos_item := 1;
      lookaheads_item := [XOR_ASSIGN't; WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; SUB_ASSIGN't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SLASH't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RETURN't; RESTRICT't; REGISTER't; RBRACK't; RBRACE't; QUESTION't; PTR't; PRAGMA't; PLUS't; PERCENT't; PACKED't; OTHER_NAME't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LONG't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; LBRACE't; INT't; INLINE't; INC't; IF't; HAT't; GT't; GOTO't; GEQ't; FOR't; FLOAT't; EXTERN't; EQEQ't; EQ't; EOF't; ENUM't; ELSE't; ELLIPSIS't; DOUBLE't; DOT't; DO't; DIV_ASSIGN't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; COMMA't; COLON't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BARBAR't; BAR't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND_ASSIGN't; ANDAND't; AND't; ALIGNOF't; ALIGNAS't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_332 => "assert false".

Definition items_of_state_334 : list item :=
  [ {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'declaration'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'declaration'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'declaration_specifiers'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'6;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'7;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'enum_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'external_declaration'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'external_declaration'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'external_declaration'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'function_definition'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'function_definition'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'function_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'0;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'1;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'translation_unit'1;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'translation_unit'2;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'translation_unit_file'0;
      dot_pos_item := 1;
      lookaheads_item := [XOR_ASSIGN't; WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; SUB_ASSIGN't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SLASH't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RETURN't; RESTRICT't; REGISTER't; RBRACK't; RBRACE't; QUESTION't; PTR't; PRAGMA't; PLUS't; PERCENT't; PACKED't; OTHER_NAME't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LONG't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; LBRACE't; INT't; INLINE't; INC't; IF't; HAT't; GT't; GOTO't; GEQ't; FOR't; FLOAT't; EXTERN't; EQEQ't; EQ't; EOF't; ENUM't; ELSE't; ELLIPSIS't; DOUBLE't; DOT't; DO't; DIV_ASSIGN't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; COMMA't; COLON't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BARBAR't; BAR't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND_ASSIGN't; ANDAND't; AND't; ALIGNOF't; ALIGNAS't; ADD_ASSIGN't] |};
    {| prod_item := Prod'type_qualifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'5;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'6;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'7;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'8;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'9;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'10;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'11;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'12;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_334 => "assert false".

Definition items_of_state_335 : list item :=
  [ {| prod_item := Prod'translation_unit'2;
      dot_pos_item := 2;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_335 => "assert false".

Definition items_of_state_336 : list item :=
  [ {| prod_item := Prod'translation_unit_file'0;
      dot_pos_item := 2;
      lookaheads_item := [XOR_ASSIGN't; WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; SUB_ASSIGN't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SLASH't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; RETURN't; RESTRICT't; REGISTER't; RBRACK't; RBRACE't; QUESTION't; PTR't; PRAGMA't; PLUS't; PERCENT't; PACKED't; OTHER_NAME't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LONG't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; LBRACE't; INT't; INLINE't; INC't; IF't; HAT't; GT't; GOTO't; GEQ't; FOR't; FLOAT't; EXTERN't; EQEQ't; EQ't; EOF't; ENUM't; ELSE't; ELLIPSIS't; DOUBLE't; DOT't; DO't; DIV_ASSIGN't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; COMMA't; COLON't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BARBAR't; BAR't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND_ASSIGN't; ANDAND't; AND't; ALIGNOF't; ALIGNAS't; ADD_ASSIGN't] |} ].
Extract Inlined Constant items_of_state_336 => "assert false".

Definition items_of_state_337 : list item :=
  [ {| prod_item := Prod'external_declaration'0;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_337 => "assert false".

Definition items_of_state_338 : list item :=
  [ {| prod_item := Prod'translation_unit'1;
      dot_pos_item := 2;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_338 => "assert false".

Definition items_of_state_339 : list item :=
  [ {| prod_item := Prod'declaration'0;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'declaration'1;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'declarator'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; LBRACE't; EQ't; COMMA't] |};
    {| prod_item := Prod'declarator'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; LBRACE't; EQ't; COMMA't] |};
    {| prod_item := Prod'direct_declarator'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'5;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'6;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'7;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_old_function_declarator'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PACKED't; LONG't; LBRACE't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'function_definition'0;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'function_definition'1;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'init_declarator'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'init_declarator'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'init_declarator_list'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'init_declarator_list'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'old_function_declarator'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PACKED't; LONG't; LBRACE't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'old_function_declarator'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PACKED't; LONG't; LBRACE't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'pointer'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; LPAREN't] |};
    {| prod_item := Prod'pointer'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; LPAREN't] |};
    {| prod_item := Prod'pointer'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; LPAREN't] |};
    {| prod_item := Prod'pointer'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; LPAREN't] |} ].
Extract Inlined Constant items_of_state_339 => "assert false".

Definition items_of_state_340 : list item :=
  [ {| prod_item := Prod'declaration'1;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_340 => "assert false".

Definition items_of_state_341 : list item :=
  [ {| prod_item := Prod'declarator'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; LBRACE't; EQ't; COMMA't] |};
    {| prod_item := Prod'direct_declarator'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'5;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'6;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'7;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_old_function_declarator'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PACKED't; LONG't; LBRACE't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'old_function_declarator'1;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PACKED't; LONG't; LBRACE't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_341 => "assert false".

Definition items_of_state_342 : list item :=
  [ {| prod_item := Prod'old_function_declarator'1;
      dot_pos_item := 2;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PACKED't; LONG't; LBRACE't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_342 => "assert false".

Definition items_of_state_343 : list item :=
  [ {| prod_item := Prod'attribute_specifier_list'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LBRACE't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier_list'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LBRACE't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'declarator'1;
      dot_pos_item := 2;
      lookaheads_item := [SEMICOLON't; LBRACE't; EQ't; COMMA't] |};
    {| prod_item := Prod'direct_declarator'2;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'3;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'4;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'5;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'6;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'7;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_old_function_declarator'0;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PACKED't; LONG't; LBRACE't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_343 => "assert false".

Definition items_of_state_344 : list item :=
  [ {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'declaration_specifiers'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'6;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'declaration_specifiers'7;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; RPAREN't; LPAREN't; LBRACK't; COMMA't] |};
    {| prod_item := Prod'direct_declarator'6;
      dot_pos_item := 2;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'7;
      dot_pos_item := 2;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_old_function_declarator'0;
      dot_pos_item := 2;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PACKED't; LONG't; LBRACE't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'function_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'identifier_list'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'identifier_list'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'parameter_declaration'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'parameter_declaration'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'parameter_declaration'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'parameter_list'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'parameter_list'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'parameter_type_list'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'parameter_type_list'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'storage_class_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'0;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'1;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'5;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'6;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'7;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'8;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'9;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'10;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'11;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'12;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; RPAREN't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; LBRACK't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; COMMA't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_344 => "assert false".

Definition items_of_state_345 : list item :=
  [ {| prod_item := Prod'identifier_list'0;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |} ].
Extract Inlined Constant items_of_state_345 => "assert false".

Definition items_of_state_346 : list item :=
  [ {| prod_item := Prod'direct_old_function_declarator'0;
      dot_pos_item := 3;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PACKED't; LONG't; LBRACE't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'identifier_list'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |} ].
Extract Inlined Constant items_of_state_346 => "assert false".

Definition items_of_state_347 : list item :=
  [ {| prod_item := Prod'direct_old_function_declarator'0;
      dot_pos_item := 4;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PACKED't; LONG't; LBRACE't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_347 => "assert false".

Definition items_of_state_348 : list item :=
  [ {| prod_item := Prod'identifier_list'1;
      dot_pos_item := 2;
      lookaheads_item := [RPAREN't; COMMA't] |} ].
Extract Inlined Constant items_of_state_348 => "assert false".

Definition items_of_state_349 : list item :=
  [ {| prod_item := Prod'identifier_list'1;
      dot_pos_item := 3;
      lookaheads_item := [RPAREN't; COMMA't] |} ].
Extract Inlined Constant items_of_state_349 => "assert false".

Definition items_of_state_350 : list item :=
  [ {| prod_item := Prod'declaration_list'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PACKED't; LONG't; LBRACE't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'declaration_list'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PACKED't; LONG't; LBRACE't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'function_definition'1;
      dot_pos_item := 2;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_350 => "assert false".

Definition items_of_state_351 : list item :=
  [ {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'declaration'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PACKED't; LONG't; LBRACE't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'declaration'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PACKED't; LONG't; LBRACE't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'declaration_list'1;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PACKED't; LONG't; LBRACE't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'declaration_specifiers'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'6;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'7;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'enum_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'function_definition'1;
      dot_pos_item := 3;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'function_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'0;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'1;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'5;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'6;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'7;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'8;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'9;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'10;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'11;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'12;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_351 => "assert false".

Definition items_of_state_352 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'block_item'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'block_item'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'block_item'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'block_item_list'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'block_item_list'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; EOF't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; EOF't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'declaration'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'declaration'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'declaration_specifiers'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'6;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'7;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'enum_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'function_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'0;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'1;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'5;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'6;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'7;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'8;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'9;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'10;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'11;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'12;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_352 => "assert false".

Definition items_of_state_353 : list item :=
  [ {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_353 => "assert false".

Definition items_of_state_354 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_354 => "assert false".

Definition items_of_state_355 : list item :=
  [ {| prod_item := Prod'expression'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_355 => "assert false".

Definition items_of_state_356 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 4;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_356 => "assert false".

Definition items_of_state_357 : list item :=
  [ {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_357 => "assert false".

Definition items_of_state_358 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_358 => "assert false".

Definition items_of_state_359 : list item :=
  [ {| prod_item := Prod'expression'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_359 => "assert false".

Definition items_of_state_360 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 4;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_360 => "assert false".

Definition items_of_state_361 : list item :=
  [ {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_361 => "assert false".

Definition items_of_state_362 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_362 => "assert false".

Definition items_of_state_363 : list item :=
  [ {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_363 => "assert false".

Definition items_of_state_364 : list item :=
  [ {| prod_item := Prod'expression'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_364 => "assert false".

Definition items_of_state_365 : list item :=
  [ {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_365 => "assert false".

Definition items_of_state_366 : list item :=
  [ {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_366 => "assert false".

Definition items_of_state_367 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_367 => "assert false".

Definition items_of_state_368 : list item :=
  [ {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_368 => "assert false".

Definition items_of_state_369 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_369 => "assert false".

Definition items_of_state_370 : list item :=
  [ {| prod_item := Prod'expression'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_370 => "assert false".

Definition items_of_state_371 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'7;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'8;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'9;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'10;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'11;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'12;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'13;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 4;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 4;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'selection_statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_371 => "assert false".

Definition items_of_state_372 : list item :=
  [ {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'0;
      dot_pos_item := 1;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_372 => "assert false".

Definition items_of_state_373 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'0;
      dot_pos_item := 2;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_373 => "assert false".

Definition items_of_state_374 : list item :=
  [ {| prod_item := Prod'expression'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'0;
      dot_pos_item := 3;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_374 => "assert false".

Definition items_of_state_375 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 4;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'0;
      dot_pos_item := 4;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'7;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'8;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'9;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'10;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'11;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'12;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'13;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'selection_statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_375 => "assert false".

Definition items_of_state_376 : list item :=
  [ {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_safe'1;
      dot_pos_item := 1;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_376 => "assert false".

Definition items_of_state_377 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_safe'1;
      dot_pos_item := 2;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_377 => "assert false".

Definition items_of_state_378 : list item :=
  [ {| prod_item := Prod'expression'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_safe'1;
      dot_pos_item := 3;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_378 => "assert false".

Definition items_of_state_379 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'7;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'8;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'9;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'10;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'11;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'12;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'13;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 4;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'selection_statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'selection_statement_safe'1;
      dot_pos_item := 4;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_379 => "assert false".

Definition items_of_state_380 : list item :=
  [ {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'0;
      dot_pos_item := 1;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_380 => "assert false".

Definition items_of_state_381 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'7;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'8;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'9;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'10;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'11;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'12;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'13;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'0;
      dot_pos_item := 2;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'selection_statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_381 => "assert false".

Definition items_of_state_382 : list item :=
  [ {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_safe'0;
      dot_pos_item := 1;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_382 => "assert false".

Definition items_of_state_383 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_safe'0;
      dot_pos_item := 2;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_383 => "assert false".

Definition items_of_state_384 : list item :=
  [ {| prod_item := Prod'expression'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_safe'0;
      dot_pos_item := 3;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_384 => "assert false".

Definition items_of_state_385 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'7;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'8;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'9;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'10;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'11;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'12;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'13;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 4;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 4;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'selection_statement_safe'0;
      dot_pos_item := 4;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'selection_statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_385 => "assert false".

Definition items_of_state_386 : list item :=
  [ {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_386 => "assert false".

Definition items_of_state_387 : list item :=
  [ {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_387 => "assert false".

Definition items_of_state_388 : list item :=
  [ {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_388 => "assert false".

Definition items_of_state_389 : list item :=
  [ {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'2;
      dot_pos_item := 1;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'3;
      dot_pos_item := 1;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'4;
      dot_pos_item := 1;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'5;
      dot_pos_item := 1;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'6;
      dot_pos_item := 1;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'7;
      dot_pos_item := 1;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'8;
      dot_pos_item := 1;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'9;
      dot_pos_item := 1;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'10;
      dot_pos_item := 1;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'11;
      dot_pos_item := 1;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'12;
      dot_pos_item := 1;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'13;
      dot_pos_item := 1;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_389 => "assert false".

Definition items_of_state_390 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'declaration'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; SEMICOLON't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'declaration'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; SEMICOLON't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'declaration_specifiers'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'6;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'7;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'enum_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'function_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'2;
      dot_pos_item := 2;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'3;
      dot_pos_item := 2;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'4;
      dot_pos_item := 2;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'5;
      dot_pos_item := 2;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'6;
      dot_pos_item := 2;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'7;
      dot_pos_item := 2;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'8;
      dot_pos_item := 2;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'9;
      dot_pos_item := 2;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'10;
      dot_pos_item := 2;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'11;
      dot_pos_item := 2;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'12;
      dot_pos_item := 2;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'13;
      dot_pos_item := 2;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'storage_class_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'0;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'1;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'5;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'6;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'7;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'8;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'9;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'10;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'11;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'12;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_390 => "assert false".

Definition items_of_state_391 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'4;
      dot_pos_item := 3;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'7;
      dot_pos_item := 3;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'10;
      dot_pos_item := 3;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'13;
      dot_pos_item := 3;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_391 => "assert false".

Definition items_of_state_392 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 4;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 4;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'7;
      dot_pos_item := 4;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'13;
      dot_pos_item := 4;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_392 => "assert false".

Definition items_of_state_393 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 5;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'7;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'8;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'9;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'10;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'11;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'12;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'13;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'13;
      dot_pos_item := 5;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'selection_statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_393 => "assert false".

Definition items_of_state_394 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'1;
      dot_pos_item := 1;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_394 => "assert false".

Definition items_of_state_395 : list item :=
  [ {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_395 => "assert false".

Definition items_of_state_396 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'declaration'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; SEMICOLON't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'declaration'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; SEMICOLON't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'declaration_specifiers'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'6;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'7;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'enum_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'function_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'storage_class_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'0;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'1;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'5;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'6;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'7;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'8;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'9;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'10;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'11;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'12;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_396 => "assert false".

Definition items_of_state_397 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_397 => "assert false".

Definition items_of_state_398 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 4;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 4;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_398 => "assert false".

Definition items_of_state_399 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 5;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_399 => "assert false".

Definition items_of_state_400 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_400 => "assert false".

Definition items_of_state_401 : list item :=
  [ {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_401 => "assert false".

Definition items_of_state_402 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_402 => "assert false".

Definition items_of_state_403 : list item :=
  [ {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_403 => "assert false".

Definition items_of_state_404 : list item :=
  [ {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_404 => "assert false".

Definition items_of_state_405 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; HAT't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; HAT't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [COLON't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [COLON't] |};
    {| prod_item := Prod'constant_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [COLON't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; NEQ't; HAT't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; NEQ't; HAT't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; NEQ't; HAT't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; HAT't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; HAT't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; COLON't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; COLON't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; COLON't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; COLON't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_405 => "assert false".

Definition items_of_state_406 : list item :=
  [ {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_406 => "assert false".

Definition items_of_state_407 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_407 => "assert false".

Definition items_of_state_408 : list item :=
  [ {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_408 => "assert false".

Definition items_of_state_409 : list item :=
  [ {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_409 => "assert false".

Definition items_of_state_410 : list item :=
  [ {| prod_item := Prod'asm_attributes'0;
      dot_pos_item := 0;
      lookaheads_item := [LPAREN't] |};
    {| prod_item := Prod'asm_attributes'1;
      dot_pos_item := 0;
      lookaheads_item := [LPAREN't] |};
    {| prod_item := Prod'asm_attributes'2;
      dot_pos_item := 0;
      lookaheads_item := [LPAREN't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_410 => "assert false".

Definition items_of_state_411 : list item :=
  [ {| prod_item := Prod'asm_attributes'0;
      dot_pos_item := 0;
      lookaheads_item := [LPAREN't] |};
    {| prod_item := Prod'asm_attributes'1;
      dot_pos_item := 0;
      lookaheads_item := [LPAREN't] |};
    {| prod_item := Prod'asm_attributes'2;
      dot_pos_item := 0;
      lookaheads_item := [LPAREN't] |};
    {| prod_item := Prod'asm_attributes'2;
      dot_pos_item := 1;
      lookaheads_item := [LPAREN't] |} ].
Extract Inlined Constant items_of_state_411 => "assert false".

Definition items_of_state_412 : list item :=
  [ {| prod_item := Prod'asm_attributes'0;
      dot_pos_item := 0;
      lookaheads_item := [LPAREN't] |};
    {| prod_item := Prod'asm_attributes'1;
      dot_pos_item := 0;
      lookaheads_item := [LPAREN't] |};
    {| prod_item := Prod'asm_attributes'1;
      dot_pos_item := 1;
      lookaheads_item := [LPAREN't] |};
    {| prod_item := Prod'asm_attributes'2;
      dot_pos_item := 0;
      lookaheads_item := [LPAREN't] |} ].
Extract Inlined Constant items_of_state_412 => "assert false".

Definition items_of_state_413 : list item :=
  [ {| prod_item := Prod'asm_attributes'1;
      dot_pos_item := 2;
      lookaheads_item := [LPAREN't] |} ].
Extract Inlined Constant items_of_state_413 => "assert false".

Definition items_of_state_414 : list item :=
  [ {| prod_item := Prod'asm_attributes'2;
      dot_pos_item := 2;
      lookaheads_item := [LPAREN't] |} ].
Extract Inlined Constant items_of_state_414 => "assert false".

Definition items_of_state_415 : list item :=
  [ {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_415 => "assert false".

Definition items_of_state_416 : list item :=
  [ {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_416 => "assert false".

Definition items_of_state_417 : list item :=
  [ {| prod_item := Prod'asm_arguments'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'asm_arguments'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'asm_arguments'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'asm_arguments'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 4;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_417 => "assert false".

Definition items_of_state_418 : list item :=
  [ {| prod_item := Prod'asm_arguments'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'asm_arguments'2;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'asm_arguments'3;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'asm_op_name'0;
      dot_pos_item := 0;
      lookaheads_item := [STRING_LITERAL't] |};
    {| prod_item := Prod'asm_op_name'1;
      dot_pos_item := 0;
      lookaheads_item := [STRING_LITERAL't] |};
    {| prod_item := Prod'asm_operand'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't; COLON't] |};
    {| prod_item := Prod'asm_operands'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COLON't] |};
    {| prod_item := Prod'asm_operands'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COLON't] |};
    {| prod_item := Prod'asm_operands_ne'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't; COLON't] |};
    {| prod_item := Prod'asm_operands_ne'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't; COLON't] |} ].
Extract Inlined Constant items_of_state_418 => "assert false".

Definition items_of_state_419 : list item :=
  [ {| prod_item := Prod'asm_op_name'1;
      dot_pos_item := 1;
      lookaheads_item := [STRING_LITERAL't] |} ].
Extract Inlined Constant items_of_state_419 => "assert false".

Definition items_of_state_420 : list item :=
  [ {| prod_item := Prod'asm_op_name'1;
      dot_pos_item := 2;
      lookaheads_item := [STRING_LITERAL't] |} ].
Extract Inlined Constant items_of_state_420 => "assert false".

Definition items_of_state_421 : list item :=
  [ {| prod_item := Prod'asm_op_name'1;
      dot_pos_item := 3;
      lookaheads_item := [STRING_LITERAL't] |} ].
Extract Inlined Constant items_of_state_421 => "assert false".

Definition items_of_state_422 : list item :=
  [ {| prod_item := Prod'asm_operands'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COLON't] |};
    {| prod_item := Prod'asm_operands_ne'0;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't; COLON't] |} ].
Extract Inlined Constant items_of_state_422 => "assert false".

Definition items_of_state_423 : list item :=
  [ {| prod_item := Prod'asm_op_name'0;
      dot_pos_item := 0;
      lookaheads_item := [STRING_LITERAL't] |};
    {| prod_item := Prod'asm_op_name'1;
      dot_pos_item := 0;
      lookaheads_item := [STRING_LITERAL't] |};
    {| prod_item := Prod'asm_operand'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't; COLON't] |};
    {| prod_item := Prod'asm_operands_ne'0;
      dot_pos_item := 2;
      lookaheads_item := [RPAREN't; COMMA't; COLON't] |} ].
Extract Inlined Constant items_of_state_423 => "assert false".

Definition items_of_state_424 : list item :=
  [ {| prod_item := Prod'asm_operands_ne'0;
      dot_pos_item := 3;
      lookaheads_item := [RPAREN't; COMMA't; COLON't] |} ].
Extract Inlined Constant items_of_state_424 => "assert false".

Definition items_of_state_425 : list item :=
  [ {| prod_item := Prod'asm_operand'0;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't; COLON't] |} ].
Extract Inlined Constant items_of_state_425 => "assert false".

Definition items_of_state_426 : list item :=
  [ {| prod_item := Prod'asm_operand'0;
      dot_pos_item := 2;
      lookaheads_item := [RPAREN't; COMMA't; COLON't] |} ].
Extract Inlined Constant items_of_state_426 => "assert false".

Definition items_of_state_427 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_operand'0;
      dot_pos_item := 3;
      lookaheads_item := [RPAREN't; COMMA't; COLON't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_427 => "assert false".

Definition items_of_state_428 : list item :=
  [ {| prod_item := Prod'asm_operand'0;
      dot_pos_item := 4;
      lookaheads_item := [RPAREN't; COMMA't; COLON't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |} ].
Extract Inlined Constant items_of_state_428 => "assert false".

Definition items_of_state_429 : list item :=
  [ {| prod_item := Prod'asm_operand'0;
      dot_pos_item := 5;
      lookaheads_item := [RPAREN't; COMMA't; COLON't] |} ].
Extract Inlined Constant items_of_state_429 => "assert false".

Definition items_of_state_430 : list item :=
  [ {| prod_item := Prod'asm_arguments'1;
      dot_pos_item := 2;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'asm_arguments'2;
      dot_pos_item := 2;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'asm_arguments'3;
      dot_pos_item := 2;
      lookaheads_item := [RPAREN't] |} ].
Extract Inlined Constant items_of_state_430 => "assert false".

Definition items_of_state_431 : list item :=
  [ {| prod_item := Prod'asm_arguments'2;
      dot_pos_item := 3;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'asm_arguments'3;
      dot_pos_item := 3;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'asm_op_name'0;
      dot_pos_item := 0;
      lookaheads_item := [STRING_LITERAL't] |};
    {| prod_item := Prod'asm_op_name'1;
      dot_pos_item := 0;
      lookaheads_item := [STRING_LITERAL't] |};
    {| prod_item := Prod'asm_operand'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't; COLON't] |};
    {| prod_item := Prod'asm_operands'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COLON't] |};
    {| prod_item := Prod'asm_operands'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COLON't] |};
    {| prod_item := Prod'asm_operands_ne'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't; COLON't] |};
    {| prod_item := Prod'asm_operands_ne'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't; COLON't] |} ].
Extract Inlined Constant items_of_state_431 => "assert false".

Definition items_of_state_432 : list item :=
  [ {| prod_item := Prod'asm_arguments'2;
      dot_pos_item := 4;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'asm_arguments'3;
      dot_pos_item := 4;
      lookaheads_item := [RPAREN't] |} ].
Extract Inlined Constant items_of_state_432 => "assert false".

Definition items_of_state_433 : list item :=
  [ {| prod_item := Prod'asm_arguments'3;
      dot_pos_item := 5;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'asm_flags'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'asm_flags'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |} ].
Extract Inlined Constant items_of_state_433 => "assert false".

Definition items_of_state_434 : list item :=
  [ {| prod_item := Prod'asm_flags'0;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'asm_flags'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't] |} ].
Extract Inlined Constant items_of_state_434 => "assert false".

Definition items_of_state_435 : list item :=
  [ {| prod_item := Prod'asm_flags'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'asm_flags'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't] |};
    {| prod_item := Prod'asm_flags'1;
      dot_pos_item := 2;
      lookaheads_item := [RPAREN't] |} ].
Extract Inlined Constant items_of_state_435 => "assert false".

Definition items_of_state_436 : list item :=
  [ {| prod_item := Prod'asm_flags'1;
      dot_pos_item := 3;
      lookaheads_item := [RPAREN't] |} ].
Extract Inlined Constant items_of_state_436 => "assert false".

Definition items_of_state_437 : list item :=
  [ {| prod_item := Prod'asm_arguments'3;
      dot_pos_item := 6;
      lookaheads_item := [RPAREN't] |} ].
Extract Inlined Constant items_of_state_437 => "assert false".

Definition items_of_state_438 : list item :=
  [ {| prod_item := Prod'asm_operands_ne'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't; COLON't] |} ].
Extract Inlined Constant items_of_state_438 => "assert false".

Definition items_of_state_439 : list item :=
  [ {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 5;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_439 => "assert false".

Definition items_of_state_440 : list item :=
  [ {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 6;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_440 => "assert false".

Definition items_of_state_441 : list item :=
  [ {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 7;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_441 => "assert false".

Definition items_of_state_442 : list item :=
  [ {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 4;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_442 => "assert false".

Definition items_of_state_443 : list item :=
  [ {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_443 => "assert false".

Definition items_of_state_444 : list item :=
  [ {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_444 => "assert false".

Definition items_of_state_445 : list item :=
  [ {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_445 => "assert false".

Definition items_of_state_446 : list item :=
  [ {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_446 => "assert false".

Definition items_of_state_447 : list item :=
  [ {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_447 => "assert false".

Definition items_of_state_448 : list item :=
  [ {| prod_item := Prod'expression'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_448 => "assert false".

Definition items_of_state_449 : list item :=
  [ {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_449 => "assert false".

Definition items_of_state_450 : list item :=
  [ {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_450 => "assert false".

Definition items_of_state_451 : list item :=
  [ {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_451 => "assert false".

Definition items_of_state_452 : list item :=
  [ {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_452 => "assert false".

Definition items_of_state_453 : list item :=
  [ {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_453 => "assert false".

Definition items_of_state_454 : list item :=
  [ {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_454 => "assert false".

Definition items_of_state_455 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 4;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_455 => "assert false".

Definition items_of_state_456 : list item :=
  [ {| prod_item := Prod'expression'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 5;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_456 => "assert false".

Definition items_of_state_457 : list item :=
  [ {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 6;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_457 => "assert false".

Definition items_of_state_458 : list item :=
  [ {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 7;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_458 => "assert false".

Definition items_of_state_459 : list item :=
  [ {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 6;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_459 => "assert false".

Definition items_of_state_460 : list item :=
  [ {| prod_item := Prod'expression'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 5;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_460 => "assert false".

Definition items_of_state_461 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 6;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_461 => "assert false".

Definition items_of_state_462 : list item :=
  [ {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 7;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_462 => "assert false".

Definition items_of_state_463 : list item :=
  [ {| prod_item := Prod'expression'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 4;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 4;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_463 => "assert false".

Definition items_of_state_464 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 5;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 5;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_464 => "assert false".

Definition items_of_state_465 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 6;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_465 => "assert false".

Definition items_of_state_466 : list item :=
  [ {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 7;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_466 => "assert false".

Definition items_of_state_467 : list item :=
  [ {| prod_item := Prod'expression'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 6;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_467 => "assert false".

Definition items_of_state_468 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 7;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_468 => "assert false".

Definition items_of_state_469 : list item :=
  [ {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 8;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_469 => "assert false".

Definition items_of_state_470 : list item :=
  [ {| prod_item := Prod'expression'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_470 => "assert false".

Definition items_of_state_471 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 4;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 4;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 4;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 4;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_471 => "assert false".

Definition items_of_state_472 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 5;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 5;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_472 => "assert false".

Definition items_of_state_473 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 6;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_473 => "assert false".

Definition items_of_state_474 : list item :=
  [ {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 7;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_474 => "assert false".

Definition items_of_state_475 : list item :=
  [ {| prod_item := Prod'expression'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 6;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_475 => "assert false".

Definition items_of_state_476 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 7;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_476 => "assert false".

Definition items_of_state_477 : list item :=
  [ {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 8;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_477 => "assert false".

Definition items_of_state_478 : list item :=
  [ {| prod_item := Prod'expression'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 5;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 5;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_478 => "assert false".

Definition items_of_state_479 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 6;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 6;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_479 => "assert false".

Definition items_of_state_480 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 7;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_480 => "assert false".

Definition items_of_state_481 : list item :=
  [ {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 8;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_481 => "assert false".

Definition items_of_state_482 : list item :=
  [ {| prod_item := Prod'expression'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 7;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_482 => "assert false".

Definition items_of_state_483 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 8;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_483 => "assert false".

Definition items_of_state_484 : list item :=
  [ {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 9;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_484 => "assert false".

Definition items_of_state_485 : list item :=
  [ {| prod_item := Prod'declaration'0;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'declaration'1;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'declarator'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; EQ't; COMMA't] |};
    {| prod_item := Prod'declarator'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; EQ't; COMMA't] |};
    {| prod_item := Prod'direct_declarator'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'5;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'6;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'7;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'init_declarator'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'init_declarator'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'init_declarator_list'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'init_declarator_list'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'pointer'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; LPAREN't] |};
    {| prod_item := Prod'pointer'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; LPAREN't] |};
    {| prod_item := Prod'pointer'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; LPAREN't] |};
    {| prod_item := Prod'pointer'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; LPAREN't] |} ].
Extract Inlined Constant items_of_state_485 => "assert false".

Definition items_of_state_486 : list item :=
  [ {| prod_item := Prod'declaration'0;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'init_declarator_list'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; COMMA't] |} ].
Extract Inlined Constant items_of_state_486 => "assert false".

Definition items_of_state_487 : list item :=
  [ {| prod_item := Prod'declaration'0;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_487 => "assert false".

Definition items_of_state_488 : list item :=
  [ {| prod_item := Prod'declarator'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; EQ't; COMMA't] |};
    {| prod_item := Prod'declarator'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; EQ't; COMMA't] |};
    {| prod_item := Prod'direct_declarator'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'5;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'6;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'7;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'init_declarator'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'init_declarator'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'init_declarator_list'1;
      dot_pos_item := 2;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'pointer'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; LPAREN't] |};
    {| prod_item := Prod'pointer'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; LPAREN't] |};
    {| prod_item := Prod'pointer'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; LPAREN't] |};
    {| prod_item := Prod'pointer'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; LPAREN't] |} ].
Extract Inlined Constant items_of_state_488 => "assert false".

Definition items_of_state_489 : list item :=
  [ {| prod_item := Prod'init_declarator_list'1;
      dot_pos_item := 3;
      lookaheads_item := [SEMICOLON't; COMMA't] |} ].
Extract Inlined Constant items_of_state_489 => "assert false".

Definition items_of_state_490 : list item :=
  [ {| prod_item := Prod'init_declarator'0;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'init_declarator'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; COMMA't] |} ].
Extract Inlined Constant items_of_state_490 => "assert false".

Definition items_of_state_491 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'c_initializer'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'c_initializer'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'c_initializer'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'init_declarator'1;
      dot_pos_item := 2;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_491 => "assert false".

Definition items_of_state_492 : list item :=
  [ {| prod_item := Prod'init_declarator'1;
      dot_pos_item := 3;
      lookaheads_item := [SEMICOLON't; COMMA't] |} ].
Extract Inlined Constant items_of_state_492 => "assert false".

Definition items_of_state_493 : list item :=
  [ {| prod_item := Prod'init_declarator_list'0;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; COMMA't] |} ].
Extract Inlined Constant items_of_state_493 => "assert false".

Definition items_of_state_494 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_494 => "assert false".

Definition items_of_state_495 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 4;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 4;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_495 => "assert false".

Definition items_of_state_496 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 5;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_496 => "assert false".

Definition items_of_state_497 : list item :=
  [ {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 6;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_497 => "assert false".

Definition items_of_state_498 : list item :=
  [ {| prod_item := Prod'expression'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 5;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_498 => "assert false".

Definition items_of_state_499 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 6;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_499 => "assert false".

Definition items_of_state_500 : list item :=
  [ {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 7;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_500 => "assert false".

Definition items_of_state_501 : list item :=
  [ {| prod_item := Prod'expression'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 4;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 4;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_501 => "assert false".

Definition items_of_state_502 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 5;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 5;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_502 => "assert false".

Definition items_of_state_503 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 6;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_503 => "assert false".

Definition items_of_state_504 : list item :=
  [ {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 7;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_504 => "assert false".

Definition items_of_state_505 : list item :=
  [ {| prod_item := Prod'expression'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 6;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_505 => "assert false".

Definition items_of_state_506 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 7;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_506 => "assert false".

Definition items_of_state_507 : list item :=
  [ {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 8;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_507 => "assert false".

Definition items_of_state_508 : list item :=
  [ {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'1;
      dot_pos_item := 2;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_508 => "assert false".

Definition items_of_state_509 : list item :=
  [ {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'1;
      dot_pos_item := 3;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_509 => "assert false".

Definition items_of_state_510 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 4;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'1;
      dot_pos_item := 4;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_510 => "assert false".

Definition items_of_state_511 : list item :=
  [ {| prod_item := Prod'expression'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 5;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'1;
      dot_pos_item := 5;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_511 => "assert false".

Definition items_of_state_512 : list item :=
  [ {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 6;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'1;
      dot_pos_item := 6;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_512 => "assert false".

Definition items_of_state_513 : list item :=
  [ {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 7;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'1;
      dot_pos_item := 7;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_513 => "assert false".

Definition items_of_state_514 : list item :=
  [ {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'2;
      dot_pos_item := 1;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_514 => "assert false".

Definition items_of_state_515 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'7;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'8;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'9;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'10;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'11;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'12;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'13;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'2;
      dot_pos_item := 2;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'selection_statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_515 => "assert false".

Definition items_of_state_516 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; HAT't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; HAT't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [COLON't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [COLON't] |};
    {| prod_item := Prod'constant_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [COLON't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; NEQ't; HAT't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; NEQ't; HAT't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; NEQ't; HAT't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; HAT't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; HAT't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; COLON't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'1;
      dot_pos_item := 1;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; COLON't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; COLON't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; COLON't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; COLON't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LPAREN't; LEQ't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; DOT't; DEC't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COLON't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_516 => "assert false".

Definition items_of_state_517 : list item :=
  [ {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'1;
      dot_pos_item := 2;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_517 => "assert false".

Definition items_of_state_518 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'7;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'8;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'9;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'10;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'11;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'12;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'13;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'1;
      dot_pos_item := 3;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'selection_statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_518 => "assert false".

Definition items_of_state_519 : list item :=
  [ {| prod_item := Prod'labeled_statement_statement_safe_'1;
      dot_pos_item := 4;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_519 => "assert false".

Definition items_of_state_520 : list item :=
  [ {| prod_item := Prod'statement_safe'3;
      dot_pos_item := 1;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_520 => "assert false".

Definition items_of_state_521 : list item :=
  [ {| prod_item := Prod'statement_safe'0;
      dot_pos_item := 1;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_521 => "assert false".

Definition items_of_state_522 : list item :=
  [ {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_safe'5;
      dot_pos_item := 1;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_522 => "assert false".

Definition items_of_state_523 : list item :=
  [ {| prod_item := Prod'statement_safe'4;
      dot_pos_item := 1;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_523 => "assert false".

Definition items_of_state_524 : list item :=
  [ {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_safe'2;
      dot_pos_item := 1;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_524 => "assert false".

Definition items_of_state_525 : list item :=
  [ {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_safe'1;
      dot_pos_item := 1;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_525 => "assert false".

Definition items_of_state_526 : list item :=
  [ {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_safe'6;
      dot_pos_item := 1;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_526 => "assert false".

Definition items_of_state_527 : list item :=
  [ {| prod_item := Prod'labeled_statement_statement_safe_'2;
      dot_pos_item := 3;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_527 => "assert false".

Definition items_of_state_528 : list item :=
  [ {| prod_item := Prod'iteration_statement_statement_safe_'13;
      dot_pos_item := 6;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_528 => "assert false".

Definition items_of_state_529 : list item :=
  [ {| prod_item := Prod'expression'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 5;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'7;
      dot_pos_item := 5;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_529 => "assert false".

Definition items_of_state_530 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 6;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'7;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'7;
      dot_pos_item := 6;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'8;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'9;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'10;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'11;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'12;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'13;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'selection_statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_530 => "assert false".

Definition items_of_state_531 : list item :=
  [ {| prod_item := Prod'iteration_statement_statement_safe_'7;
      dot_pos_item := 7;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_531 => "assert false".

Definition items_of_state_532 : list item :=
  [ {| prod_item := Prod'expression'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 4;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 4;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'4;
      dot_pos_item := 4;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'10;
      dot_pos_item := 4;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_532 => "assert false".

Definition items_of_state_533 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 5;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 5;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'4;
      dot_pos_item := 5;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'10;
      dot_pos_item := 5;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_533 => "assert false".

Definition items_of_state_534 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 6;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'7;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'8;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'9;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'10;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'10;
      dot_pos_item := 6;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'11;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'12;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'13;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'selection_statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_534 => "assert false".

Definition items_of_state_535 : list item :=
  [ {| prod_item := Prod'iteration_statement_statement_safe_'10;
      dot_pos_item := 7;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_535 => "assert false".

Definition items_of_state_536 : list item :=
  [ {| prod_item := Prod'expression'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 6;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'4;
      dot_pos_item := 6;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_536 => "assert false".

Definition items_of_state_537 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 7;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'4;
      dot_pos_item := 7;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'7;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'8;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'9;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'10;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'11;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'12;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'13;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'selection_statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_537 => "assert false".

Definition items_of_state_538 : list item :=
  [ {| prod_item := Prod'iteration_statement_statement_safe_'4;
      dot_pos_item := 8;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_538 => "assert false".

Definition items_of_state_539 : list item :=
  [ {| prod_item := Prod'expression'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'2;
      dot_pos_item := 3;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'5;
      dot_pos_item := 3;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'8;
      dot_pos_item := 3;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'11;
      dot_pos_item := 3;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_539 => "assert false".

Definition items_of_state_540 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 4;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 4;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 4;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 4;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'2;
      dot_pos_item := 4;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'5;
      dot_pos_item := 4;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'8;
      dot_pos_item := 4;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'11;
      dot_pos_item := 4;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_540 => "assert false".

Definition items_of_state_541 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 5;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 5;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'5;
      dot_pos_item := 5;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'11;
      dot_pos_item := 5;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_541 => "assert false".

Definition items_of_state_542 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 6;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'7;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'8;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'9;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'10;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'11;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'11;
      dot_pos_item := 6;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'12;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'13;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'selection_statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_542 => "assert false".

Definition items_of_state_543 : list item :=
  [ {| prod_item := Prod'iteration_statement_statement_safe_'11;
      dot_pos_item := 7;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_543 => "assert false".

Definition items_of_state_544 : list item :=
  [ {| prod_item := Prod'expression'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 6;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'5;
      dot_pos_item := 6;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_544 => "assert false".

Definition items_of_state_545 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 7;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'5;
      dot_pos_item := 7;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'7;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'8;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'9;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'10;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'11;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'12;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'13;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'selection_statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_545 => "assert false".

Definition items_of_state_546 : list item :=
  [ {| prod_item := Prod'iteration_statement_statement_safe_'5;
      dot_pos_item := 8;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_546 => "assert false".

Definition items_of_state_547 : list item :=
  [ {| prod_item := Prod'expression'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 5;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 5;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'2;
      dot_pos_item := 5;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'8;
      dot_pos_item := 5;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_547 => "assert false".

Definition items_of_state_548 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 6;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 6;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'2;
      dot_pos_item := 6;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'8;
      dot_pos_item := 6;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_548 => "assert false".

Definition items_of_state_549 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 7;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'7;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'8;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'8;
      dot_pos_item := 7;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'9;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'10;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'11;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'12;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'13;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'selection_statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_549 => "assert false".

Definition items_of_state_550 : list item :=
  [ {| prod_item := Prod'iteration_statement_statement_safe_'8;
      dot_pos_item := 8;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_550 => "assert false".

Definition items_of_state_551 : list item :=
  [ {| prod_item := Prod'expression'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 7;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'2;
      dot_pos_item := 7;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_551 => "assert false".

Definition items_of_state_552 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 8;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'2;
      dot_pos_item := 8;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'7;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'8;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'9;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'10;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'11;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'12;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'13;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'selection_statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_552 => "assert false".

Definition items_of_state_553 : list item :=
  [ {| prod_item := Prod'iteration_statement_statement_safe_'2;
      dot_pos_item := 9;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_553 => "assert false".

Definition items_of_state_554 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'3;
      dot_pos_item := 3;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'6;
      dot_pos_item := 3;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'9;
      dot_pos_item := 3;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'12;
      dot_pos_item := 3;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_554 => "assert false".

Definition items_of_state_555 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 4;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 4;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'6;
      dot_pos_item := 4;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'12;
      dot_pos_item := 4;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_555 => "assert false".

Definition items_of_state_556 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 5;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'7;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'8;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'9;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'10;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'11;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'12;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'12;
      dot_pos_item := 5;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'13;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'selection_statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_556 => "assert false".

Definition items_of_state_557 : list item :=
  [ {| prod_item := Prod'iteration_statement_statement_safe_'12;
      dot_pos_item := 6;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_557 => "assert false".

Definition items_of_state_558 : list item :=
  [ {| prod_item := Prod'expression'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 5;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'6;
      dot_pos_item := 5;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_558 => "assert false".

Definition items_of_state_559 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 6;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'6;
      dot_pos_item := 6;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'7;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'8;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'9;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'10;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'11;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'12;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'13;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'selection_statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_559 => "assert false".

Definition items_of_state_560 : list item :=
  [ {| prod_item := Prod'iteration_statement_statement_safe_'6;
      dot_pos_item := 7;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_560 => "assert false".

Definition items_of_state_561 : list item :=
  [ {| prod_item := Prod'expression'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 4;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 4;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'3;
      dot_pos_item := 4;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'9;
      dot_pos_item := 4;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_561 => "assert false".

Definition items_of_state_562 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 5;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 5;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'3;
      dot_pos_item := 5;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'9;
      dot_pos_item := 5;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; RPAREN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [RPAREN't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; RPAREN't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_562 => "assert false".

Definition items_of_state_563 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 6;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'7;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'8;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'9;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'9;
      dot_pos_item := 6;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'10;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'11;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'12;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'13;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'selection_statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_563 => "assert false".

Definition items_of_state_564 : list item :=
  [ {| prod_item := Prod'iteration_statement_statement_safe_'9;
      dot_pos_item := 7;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_564 => "assert false".

Definition items_of_state_565 : list item :=
  [ {| prod_item := Prod'expression'1;
      dot_pos_item := 1;
      lookaheads_item := [RPAREN't; COMMA't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 6;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'3;
      dot_pos_item := 6;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_565 => "assert false".

Definition items_of_state_566 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 7;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'3;
      dot_pos_item := 7;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'7;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'8;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'9;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'10;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'11;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'12;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'13;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'selection_statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_566 => "assert false".

Definition items_of_state_567 : list item :=
  [ {| prod_item := Prod'iteration_statement_statement_safe_'3;
      dot_pos_item := 8;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_567 => "assert false".

Definition items_of_state_568 : list item :=
  [ {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 5;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_safe'0;
      dot_pos_item := 5;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_568 => "assert false".

Definition items_of_state_569 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'7;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'8;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'9;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'10;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'11;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'12;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'iteration_statement_statement_safe_'13;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'labeled_statement_statement_safe_'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 6;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'selection_statement_safe'0;
      dot_pos_item := 6;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'selection_statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_safe'0;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'1;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'2;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'3;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'4;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'5;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'statement_safe'6;
      dot_pos_item := 0;
      lookaheads_item := [ELSE't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_569 => "assert false".

Definition items_of_state_570 : list item :=
  [ {| prod_item := Prod'selection_statement_safe'0;
      dot_pos_item := 7;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_570 => "assert false".

Definition items_of_state_571 : list item :=
  [ {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 7;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_571 => "assert false".

Definition items_of_state_572 : list item :=
  [ {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 5;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_572 => "assert false".

Definition items_of_state_573 : list item :=
  [ {| prod_item := Prod'labeled_statement_statement_safe_'0;
      dot_pos_item := 3;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_573 => "assert false".

Definition items_of_state_574 : list item :=
  [ {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_574 => "assert false".

Definition items_of_state_575 : list item :=
  [ {| prod_item := Prod'selection_statement_safe'1;
      dot_pos_item := 5;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_575 => "assert false".

Definition items_of_state_576 : list item :=
  [ {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 5;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_576 => "assert false".

Definition items_of_state_577 : list item :=
  [ {| prod_item := Prod'iteration_statement_statement_safe_'0;
      dot_pos_item := 5;
      lookaheads_item := [ELSE't] |} ].
Extract Inlined Constant items_of_state_577 => "assert false".

Definition items_of_state_578 : list item :=
  [ {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 5;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_578 => "assert false".

Definition items_of_state_579 : list item :=
  [ {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 5;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_579 => "assert false".

Definition items_of_state_580 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 6;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_580 => "assert false".

Definition items_of_state_581 : list item :=
  [ {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; EOF't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_581 => "assert false".

Definition items_of_state_582 : list item :=
  [ {| prod_item := Prod'block_item'2;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_582 => "assert false".

Definition items_of_state_583 : list item :=
  [ {| prod_item := Prod'block_item'1;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_583 => "assert false".

Definition items_of_state_584 : list item :=
  [ {| prod_item := Prod'block_item'0;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_584 => "assert false".

Definition items_of_state_585 : list item :=
  [ {| prod_item := Prod'AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'additive_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; PLUS't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'asm_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'assignment_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'assignment_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'attribute_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'block_item'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'block_item'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'block_item'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'block_item_list'1;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'cast_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'cast_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; EOF't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'conditional_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'conditional_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'declaration'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'declaration'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'declaration_specifiers'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'6;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'declaration_specifiers'7;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; STAR't; SEMICOLON't; LPAREN't] |};
    {| prod_item := Prod'enum_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'enum_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'equality_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'equality_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; HAT't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'exclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'exclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; HAT't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'expression_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'expression_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'function_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'inclusive_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'inclusive_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; BAR't; ANDAND't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'7;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'8;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'9;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'10;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'11;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'12;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'iteration_statement_statement_dangerous_'13;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'jump_statement'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'labeled_statement_statement_dangerous_'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'logical_AND_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_AND_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't; ANDAND't] |};
    {| prod_item := Prod'logical_OR_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'logical_OR_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; COMMA't; BARBAR't] |};
    {| prod_item := Prod'multiplicative_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'multiplicative_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [STAR't; SLASH't; SEMICOLON't; RIGHT't; QUESTION't; PLUS't; PERCENT't; NEQ't; MINUS't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'postfix_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'8;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'9;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'postfix_expression'10;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'primary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PTR't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LPAREN't; LEQ't; LEFT_ASSIGN't; LEFT't; LBRACK't; INC't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DOT't; DIV_ASSIGN't; DEC't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'relational_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'relational_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; QUESTION't; NEQ't; LT't; LEQ't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'selection_statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'selection_statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'shift_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'shift_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; RIGHT't; QUESTION't; NEQ't; LT't; LEQ't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; COMMA't; BARBAR't; BAR't; ANDAND't; AND't] |};
    {| prod_item := Prod'statement_dangerous'0;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'1;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'2;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'3;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'4;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'5;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'statement_dangerous'6;
      dot_pos_item := 0;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'storage_class_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'0;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union'1;
      dot_pos_item := 0;
      lookaheads_item := [PACKED't; OTHER_NAME't; LBRACE't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'struct_or_union_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_qualifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'2;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'3;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'4;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'5;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'6;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'7;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'8;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'9;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'10;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'11;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'type_specifier'12;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; STAR't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PACKED't; LPAREN't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'unary_expression'0;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'1;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'2;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'3;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'4;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'5;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'6;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_expression'7;
      dot_pos_item := 0;
      lookaheads_item := [XOR_ASSIGN't; SUB_ASSIGN't; STAR't; SLASH't; SEMICOLON't; RIGHT_ASSIGN't; RIGHT't; QUESTION't; PLUS't; PERCENT't; OR_ASSIGN't; NEQ't; MUL_ASSIGN't; MOD_ASSIGN't; MINUS't; LT't; LEQ't; LEFT_ASSIGN't; LEFT't; HAT't; GT't; GEQ't; EQEQ't; EQ't; DIV_ASSIGN't; COMMA't; BARBAR't; BAR't; AND_ASSIGN't; ANDAND't; AND't; ADD_ASSIGN't] |};
    {| prod_item := Prod'unary_operator'0;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'1;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'2;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'3;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'4;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |};
    {| prod_item := Prod'unary_operator'5;
      dot_pos_item := 0;
      lookaheads_item := [VAR_NAME't; TILDE't; STRING_LITERAL't; STAR't; SIZEOF't; PLUS't; MINUS't; LPAREN't; INC't; DEC't; CONSTANT't; BUILTIN_VA_ARG't; BANG't; AND't; ALIGNOF't] |} ].
Extract Inlined Constant items_of_state_585 => "assert false".

Definition items_of_state_586 : list item :=
  [ {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 3;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; EOF't; ENUM't; ELSE't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_586 => "assert false".

Definition items_of_state_587 : list item :=
  [ {| prod_item := Prod'block_item_list'1;
      dot_pos_item := 2;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_587 => "assert false".

Definition items_of_state_588 : list item :=
  [ {| prod_item := Prod'block_item_list'0;
      dot_pos_item := 1;
      lookaheads_item := [WHILE't; VOLATILE't; VOID't; VAR_NAME't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; TILDE't; SWITCH't; STRUCT't; STRING_LITERAL't; STATIC't; STAR't; SIZEOF't; SIGNED't; SHORT't; SEMICOLON't; RETURN't; RESTRICT't; REGISTER't; RBRACE't; PRAGMA't; PLUS't; PACKED't; OTHER_NAME't; MINUS't; LPAREN't; LONG't; LBRACE't; INT't; INLINE't; INC't; IF't; GOTO't; FOR't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; DO't; DEFAULT't; DEC't; CONTINUE't; CONSTANT't; CONST't; CHAR't; CASE't; BUILTIN_VA_ARG't; BREAK't; BANG't; AUTO't; ATTRIBUTE't; ASM't; AND't; ALIGNOF't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_588 => "assert false".

Definition items_of_state_589 : list item :=
  [ {| prod_item := Prod'declaration_list'1;
      dot_pos_item := 2;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PACKED't; LONG't; LBRACE't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_589 => "assert false".

Definition items_of_state_590 : list item :=
  [ {| prod_item := Prod'function_definition'1;
      dot_pos_item := 4;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_590 => "assert false".

Definition items_of_state_591 : list item :=
  [ {| prod_item := Prod'old_function_declarator'0;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PACKED't; LONG't; LBRACE't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_591 => "assert false".

Definition items_of_state_592 : list item :=
  [ {| prod_item := Prod'attribute_specifier_list'0;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LBRACE't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'attribute_specifier_list'1;
      dot_pos_item := 0;
      lookaheads_item := [SEMICOLON't; PACKED't; LBRACE't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'declarator'0;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; LBRACE't; EQ't; COMMA't] |};
    {| prod_item := Prod'direct_declarator'2;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'3;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'4;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'5;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'6;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_declarator'7;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; PACKED't; LPAREN't; LBRACK't; LBRACE't; EQ't; COMMA't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'direct_old_function_declarator'0;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; RESTRICT't; REGISTER't; PACKED't; LONG't; LBRACE't; INT't; INLINE't; FLOAT't; EXTERN't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_592 => "assert false".

Definition items_of_state_593 : list item :=
  [ {| prod_item := Prod'compound_statement'0;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'compound_statement'1;
      dot_pos_item := 0;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'function_definition'0;
      dot_pos_item := 2;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |};
    {| prod_item := Prod'init_declarator'0;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; COMMA't] |};
    {| prod_item := Prod'init_declarator'1;
      dot_pos_item := 1;
      lookaheads_item := [SEMICOLON't; COMMA't] |} ].
Extract Inlined Constant items_of_state_593 => "assert false".

Definition items_of_state_594 : list item :=
  [ {| prod_item := Prod'function_definition'0;
      dot_pos_item := 3;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_594 => "assert false".

Definition items_of_state_595 : list item :=
  [ {| prod_item := Prod'external_declaration'1;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_595 => "assert false".

Definition items_of_state_596 : list item :=
  [ {| prod_item := Prod'translation_unit'0;
      dot_pos_item := 1;
      lookaheads_item := [VOLATILE't; VOID't; UNSIGNED't; UNION't; UNDERSCORE_BOOL't; TYPEDEF_NAME't; TYPEDEF't; STRUCT't; STATIC't; SIGNED't; SHORT't; SEMICOLON't; RESTRICT't; REGISTER't; PRAGMA't; PACKED't; LONG't; INT't; INLINE't; FLOAT't; EXTERN't; EOF't; ENUM't; DOUBLE't; CONST't; CHAR't; AUTO't; ATTRIBUTE't; ALIGNAS't] |} ].
Extract Inlined Constant items_of_state_596 => "assert false".

Definition items_of_state (s:state) : list item :=
  match s with
    | Init Init'0 => items_of_state_0
    | Ninit Nis'1 => items_of_state_1
    | Ninit Nis'2 => items_of_state_2
    | Ninit Nis'3 => items_of_state_3
    | Ninit Nis'4 => items_of_state_4
    | Ninit Nis'5 => items_of_state_5
    | Ninit Nis'6 => items_of_state_6
    | Ninit Nis'7 => items_of_state_7
    | Ninit Nis'8 => items_of_state_8
    | Ninit Nis'9 => items_of_state_9
    | Ninit Nis'10 => items_of_state_10
    | Ninit Nis'11 => items_of_state_11
    | Ninit Nis'12 => items_of_state_12
    | Ninit Nis'13 => items_of_state_13
    | Ninit Nis'14 => items_of_state_14
    | Ninit Nis'15 => items_of_state_15
    | Ninit Nis'16 => items_of_state_16
    | Ninit Nis'17 => items_of_state_17
    | Ninit Nis'18 => items_of_state_18
    | Ninit Nis'19 => items_of_state_19
    | Ninit Nis'20 => items_of_state_20
    | Ninit Nis'21 => items_of_state_21
    | Ninit Nis'22 => items_of_state_22
    | Ninit Nis'23 => items_of_state_23
    | Ninit Nis'24 => items_of_state_24
    | Ninit Nis'25 => items_of_state_25
    | Ninit Nis'26 => items_of_state_26
    | Ninit Nis'27 => items_of_state_27
    | Ninit Nis'28 => items_of_state_28
    | Ninit Nis'29 => items_of_state_29
    | Ninit Nis'30 => items_of_state_30
    | Ninit Nis'31 => items_of_state_31
    | Ninit Nis'32 => items_of_state_32
    | Ninit Nis'33 => items_of_state_33
    | Ninit Nis'34 => items_of_state_34
    | Ninit Nis'35 => items_of_state_35
    | Ninit Nis'36 => items_of_state_36
    | Ninit Nis'37 => items_of_state_37
    | Ninit Nis'38 => items_of_state_38
    | Ninit Nis'39 => items_of_state_39
    | Ninit Nis'40 => items_of_state_40
    | Ninit Nis'41 => items_of_state_41
    | Ninit Nis'42 => items_of_state_42
    | Ninit Nis'43 => items_of_state_43
    | Ninit Nis'44 => items_of_state_44
    | Ninit Nis'45 => items_of_state_45
    | Ninit Nis'46 => items_of_state_46
    | Ninit Nis'47 => items_of_state_47
    | Ninit Nis'48 => items_of_state_48
    | Ninit Nis'49 => items_of_state_49
    | Ninit Nis'50 => items_of_state_50
    | Ninit Nis'51 => items_of_state_51
    | Ninit Nis'52 => items_of_state_52
    | Ninit Nis'53 => items_of_state_53
    | Ninit Nis'54 => items_of_state_54
    | Ninit Nis'55 => items_of_state_55
    | Ninit Nis'56 => items_of_state_56
    | Ninit Nis'57 => items_of_state_57
    | Ninit Nis'58 => items_of_state_58
    | Ninit Nis'59 => items_of_state_59
    | Ninit Nis'60 => items_of_state_60
    | Ninit Nis'61 => items_of_state_61
    | Ninit Nis'62 => items_of_state_62
    | Ninit Nis'63 => items_of_state_63
    | Ninit Nis'64 => items_of_state_64
    | Ninit Nis'65 => items_of_state_65
    | Ninit Nis'66 => items_of_state_66
    | Ninit Nis'67 => items_of_state_67
    | Ninit Nis'68 => items_of_state_68
    | Ninit Nis'69 => items_of_state_69
    | Ninit Nis'70 => items_of_state_70
    | Ninit Nis'71 => items_of_state_71
    | Ninit Nis'72 => items_of_state_72
    | Ninit Nis'73 => items_of_state_73
    | Ninit Nis'74 => items_of_state_74
    | Ninit Nis'75 => items_of_state_75
    | Ninit Nis'76 => items_of_state_76
    | Ninit Nis'77 => items_of_state_77
    | Ninit Nis'78 => items_of_state_78
    | Ninit Nis'79 => items_of_state_79
    | Ninit Nis'80 => items_of_state_80
    | Ninit Nis'81 => items_of_state_81
    | Ninit Nis'82 => items_of_state_82
    | Ninit Nis'83 => items_of_state_83
    | Ninit Nis'84 => items_of_state_84
    | Ninit Nis'85 => items_of_state_85
    | Ninit Nis'86 => items_of_state_86
    | Ninit Nis'87 => items_of_state_87
    | Ninit Nis'88 => items_of_state_88
    | Ninit Nis'89 => items_of_state_89
    | Ninit Nis'90 => items_of_state_90
    | Ninit Nis'91 => items_of_state_91
    | Ninit Nis'92 => items_of_state_92
    | Ninit Nis'93 => items_of_state_93
    | Ninit Nis'94 => items_of_state_94
    | Ninit Nis'95 => items_of_state_95
    | Ninit Nis'96 => items_of_state_96
    | Ninit Nis'97 => items_of_state_97
    | Ninit Nis'98 => items_of_state_98
    | Ninit Nis'99 => items_of_state_99
    | Ninit Nis'100 => items_of_state_100
    | Ninit Nis'101 => items_of_state_101
    | Ninit Nis'102 => items_of_state_102
    | Ninit Nis'103 => items_of_state_103
    | Ninit Nis'104 => items_of_state_104
    | Ninit Nis'105 => items_of_state_105
    | Ninit Nis'106 => items_of_state_106
    | Ninit Nis'107 => items_of_state_107
    | Ninit Nis'108 => items_of_state_108
    | Ninit Nis'109 => items_of_state_109
    | Ninit Nis'110 => items_of_state_110
    | Ninit Nis'111 => items_of_state_111
    | Ninit Nis'112 => items_of_state_112
    | Ninit Nis'113 => items_of_state_113
    | Ninit Nis'114 => items_of_state_114
    | Ninit Nis'115 => items_of_state_115
    | Ninit Nis'116 => items_of_state_116
    | Ninit Nis'117 => items_of_state_117
    | Ninit Nis'118 => items_of_state_118
    | Ninit Nis'119 => items_of_state_119
    | Ninit Nis'120 => items_of_state_120
    | Ninit Nis'121 => items_of_state_121
    | Ninit Nis'122 => items_of_state_122
    | Ninit Nis'123 => items_of_state_123
    | Ninit Nis'124 => items_of_state_124
    | Ninit Nis'125 => items_of_state_125
    | Ninit Nis'126 => items_of_state_126
    | Ninit Nis'127 => items_of_state_127
    | Ninit Nis'128 => items_of_state_128
    | Ninit Nis'129 => items_of_state_129
    | Ninit Nis'130 => items_of_state_130
    | Ninit Nis'131 => items_of_state_131
    | Ninit Nis'132 => items_of_state_132
    | Ninit Nis'133 => items_of_state_133
    | Ninit Nis'134 => items_of_state_134
    | Ninit Nis'135 => items_of_state_135
    | Ninit Nis'136 => items_of_state_136
    | Ninit Nis'137 => items_of_state_137
    | Ninit Nis'138 => items_of_state_138
    | Ninit Nis'139 => items_of_state_139
    | Ninit Nis'140 => items_of_state_140
    | Ninit Nis'141 => items_of_state_141
    | Ninit Nis'142 => items_of_state_142
    | Ninit Nis'143 => items_of_state_143
    | Ninit Nis'144 => items_of_state_144
    | Ninit Nis'145 => items_of_state_145
    | Ninit Nis'146 => items_of_state_146
    | Ninit Nis'147 => items_of_state_147
    | Ninit Nis'148 => items_of_state_148
    | Ninit Nis'149 => items_of_state_149
    | Ninit Nis'150 => items_of_state_150
    | Ninit Nis'151 => items_of_state_151
    | Ninit Nis'152 => items_of_state_152
    | Ninit Nis'153 => items_of_state_153
    | Ninit Nis'154 => items_of_state_154
    | Ninit Nis'155 => items_of_state_155
    | Ninit Nis'156 => items_of_state_156
    | Ninit Nis'157 => items_of_state_157
    | Ninit Nis'158 => items_of_state_158
    | Ninit Nis'159 => items_of_state_159
    | Ninit Nis'160 => items_of_state_160
    | Ninit Nis'161 => items_of_state_161
    | Ninit Nis'162 => items_of_state_162
    | Ninit Nis'163 => items_of_state_163
    | Ninit Nis'164 => items_of_state_164
    | Ninit Nis'165 => items_of_state_165
    | Ninit Nis'166 => items_of_state_166
    | Ninit Nis'167 => items_of_state_167
    | Ninit Nis'168 => items_of_state_168
    | Ninit Nis'169 => items_of_state_169
    | Ninit Nis'170 => items_of_state_170
    | Ninit Nis'171 => items_of_state_171
    | Ninit Nis'172 => items_of_state_172
    | Ninit Nis'173 => items_of_state_173
    | Ninit Nis'174 => items_of_state_174
    | Ninit Nis'175 => items_of_state_175
    | Ninit Nis'176 => items_of_state_176
    | Ninit Nis'177 => items_of_state_177
    | Ninit Nis'178 => items_of_state_178
    | Ninit Nis'179 => items_of_state_179
    | Ninit Nis'180 => items_of_state_180
    | Ninit Nis'181 => items_of_state_181
    | Ninit Nis'182 => items_of_state_182
    | Ninit Nis'183 => items_of_state_183
    | Ninit Nis'184 => items_of_state_184
    | Ninit Nis'185 => items_of_state_185
    | Ninit Nis'186 => items_of_state_186
    | Ninit Nis'187 => items_of_state_187
    | Ninit Nis'188 => items_of_state_188
    | Ninit Nis'189 => items_of_state_189
    | Ninit Nis'190 => items_of_state_190
    | Ninit Nis'191 => items_of_state_191
    | Ninit Nis'192 => items_of_state_192
    | Ninit Nis'193 => items_of_state_193
    | Ninit Nis'194 => items_of_state_194
    | Ninit Nis'195 => items_of_state_195
    | Ninit Nis'196 => items_of_state_196
    | Ninit Nis'197 => items_of_state_197
    | Ninit Nis'198 => items_of_state_198
    | Ninit Nis'199 => items_of_state_199
    | Ninit Nis'200 => items_of_state_200
    | Ninit Nis'201 => items_of_state_201
    | Ninit Nis'202 => items_of_state_202
    | Ninit Nis'203 => items_of_state_203
    | Ninit Nis'204 => items_of_state_204
    | Ninit Nis'205 => items_of_state_205
    | Ninit Nis'206 => items_of_state_206
    | Ninit Nis'207 => items_of_state_207
    | Ninit Nis'208 => items_of_state_208
    | Ninit Nis'209 => items_of_state_209
    | Ninit Nis'210 => items_of_state_210
    | Ninit Nis'211 => items_of_state_211
    | Ninit Nis'212 => items_of_state_212
    | Ninit Nis'213 => items_of_state_213
    | Ninit Nis'214 => items_of_state_214
    | Ninit Nis'215 => items_of_state_215
    | Ninit Nis'216 => items_of_state_216
    | Ninit Nis'217 => items_of_state_217
    | Ninit Nis'218 => items_of_state_218
    | Ninit Nis'219 => items_of_state_219
    | Ninit Nis'220 => items_of_state_220
    | Ninit Nis'221 => items_of_state_221
    | Ninit Nis'222 => items_of_state_222
    | Ninit Nis'223 => items_of_state_223
    | Ninit Nis'224 => items_of_state_224
    | Ninit Nis'225 => items_of_state_225
    | Ninit Nis'226 => items_of_state_226
    | Ninit Nis'227 => items_of_state_227
    | Ninit Nis'228 => items_of_state_228
    | Ninit Nis'229 => items_of_state_229
    | Ninit Nis'230 => items_of_state_230
    | Ninit Nis'231 => items_of_state_231
    | Ninit Nis'232 => items_of_state_232
    | Ninit Nis'233 => items_of_state_233
    | Ninit Nis'234 => items_of_state_234
    | Ninit Nis'235 => items_of_state_235
    | Ninit Nis'236 => items_of_state_236
    | Ninit Nis'237 => items_of_state_237
    | Ninit Nis'238 => items_of_state_238
    | Ninit Nis'239 => items_of_state_239
    | Ninit Nis'240 => items_of_state_240
    | Ninit Nis'241 => items_of_state_241
    | Ninit Nis'242 => items_of_state_242
    | Ninit Nis'243 => items_of_state_243
    | Ninit Nis'244 => items_of_state_244
    | Ninit Nis'245 => items_of_state_245
    | Ninit Nis'246 => items_of_state_246
    | Ninit Nis'247 => items_of_state_247
    | Ninit Nis'248 => items_of_state_248
    | Ninit Nis'249 => items_of_state_249
    | Ninit Nis'250 => items_of_state_250
    | Ninit Nis'251 => items_of_state_251
    | Ninit Nis'252 => items_of_state_252
    | Ninit Nis'253 => items_of_state_253
    | Ninit Nis'254 => items_of_state_254
    | Ninit Nis'255 => items_of_state_255
    | Ninit Nis'256 => items_of_state_256
    | Ninit Nis'257 => items_of_state_257
    | Ninit Nis'258 => items_of_state_258
    | Ninit Nis'259 => items_of_state_259
    | Ninit Nis'260 => items_of_state_260
    | Ninit Nis'261 => items_of_state_261
    | Ninit Nis'262 => items_of_state_262
    | Ninit Nis'263 => items_of_state_263
    | Ninit Nis'264 => items_of_state_264
    | Ninit Nis'265 => items_of_state_265
    | Ninit Nis'266 => items_of_state_266
    | Ninit Nis'267 => items_of_state_267
    | Ninit Nis'268 => items_of_state_268
    | Ninit Nis'269 => items_of_state_269
    | Ninit Nis'270 => items_of_state_270
    | Ninit Nis'271 => items_of_state_271
    | Ninit Nis'272 => items_of_state_272
    | Ninit Nis'273 => items_of_state_273
    | Ninit Nis'274 => items_of_state_274
    | Ninit Nis'275 => items_of_state_275
    | Ninit Nis'276 => items_of_state_276
    | Ninit Nis'277 => items_of_state_277
    | Ninit Nis'278 => items_of_state_278
    | Ninit Nis'279 => items_of_state_279
    | Ninit Nis'280 => items_of_state_280
    | Ninit Nis'281 => items_of_state_281
    | Ninit Nis'282 => items_of_state_282
    | Ninit Nis'283 => items_of_state_283
    | Ninit Nis'284 => items_of_state_284
    | Ninit Nis'285 => items_of_state_285
    | Ninit Nis'286 => items_of_state_286
    | Ninit Nis'287 => items_of_state_287
    | Ninit Nis'288 => items_of_state_288
    | Ninit Nis'289 => items_of_state_289
    | Ninit Nis'290 => items_of_state_290
    | Ninit Nis'291 => items_of_state_291
    | Ninit Nis'292 => items_of_state_292
    | Ninit Nis'293 => items_of_state_293
    | Ninit Nis'294 => items_of_state_294
    | Ninit Nis'295 => items_of_state_295
    | Ninit Nis'296 => items_of_state_296
    | Ninit Nis'297 => items_of_state_297
    | Ninit Nis'298 => items_of_state_298
    | Ninit Nis'299 => items_of_state_299
    | Ninit Nis'300 => items_of_state_300
    | Ninit Nis'301 => items_of_state_301
    | Ninit Nis'302 => items_of_state_302
    | Ninit Nis'303 => items_of_state_303
    | Ninit Nis'304 => items_of_state_304
    | Ninit Nis'305 => items_of_state_305
    | Ninit Nis'306 => items_of_state_306
    | Ninit Nis'307 => items_of_state_307
    | Ninit Nis'308 => items_of_state_308
    | Ninit Nis'309 => items_of_state_309
    | Ninit Nis'310 => items_of_state_310
    | Ninit Nis'311 => items_of_state_311
    | Ninit Nis'312 => items_of_state_312
    | Ninit Nis'313 => items_of_state_313
    | Ninit Nis'314 => items_of_state_314
    | Ninit Nis'315 => items_of_state_315
    | Ninit Nis'316 => items_of_state_316
    | Ninit Nis'317 => items_of_state_317
    | Ninit Nis'318 => items_of_state_318
    | Ninit Nis'319 => items_of_state_319
    | Ninit Nis'320 => items_of_state_320
    | Ninit Nis'321 => items_of_state_321
    | Ninit Nis'322 => items_of_state_322
    | Ninit Nis'323 => items_of_state_323
    | Ninit Nis'324 => items_of_state_324
    | Ninit Nis'325 => items_of_state_325
    | Ninit Nis'326 => items_of_state_326
    | Ninit Nis'327 => items_of_state_327
    | Ninit Nis'328 => items_of_state_328
    | Ninit Nis'329 => items_of_state_329
    | Ninit Nis'330 => items_of_state_330
    | Ninit Nis'331 => items_of_state_331
    | Ninit Nis'332 => items_of_state_332
    | Ninit Nis'334 => items_of_state_334
    | Ninit Nis'335 => items_of_state_335
    | Ninit Nis'336 => items_of_state_336
    | Ninit Nis'337 => items_of_state_337
    | Ninit Nis'338 => items_of_state_338
    | Ninit Nis'339 => items_of_state_339
    | Ninit Nis'340 => items_of_state_340
    | Ninit Nis'341 => items_of_state_341
    | Ninit Nis'342 => items_of_state_342
    | Ninit Nis'343 => items_of_state_343
    | Ninit Nis'344 => items_of_state_344
    | Ninit Nis'345 => items_of_state_345
    | Ninit Nis'346 => items_of_state_346
    | Ninit Nis'347 => items_of_state_347
    | Ninit Nis'348 => items_of_state_348
    | Ninit Nis'349 => items_of_state_349
    | Ninit Nis'350 => items_of_state_350
    | Ninit Nis'351 => items_of_state_351
    | Ninit Nis'352 => items_of_state_352
    | Ninit Nis'353 => items_of_state_353
    | Ninit Nis'354 => items_of_state_354
    | Ninit Nis'355 => items_of_state_355
    | Ninit Nis'356 => items_of_state_356
    | Ninit Nis'357 => items_of_state_357
    | Ninit Nis'358 => items_of_state_358
    | Ninit Nis'359 => items_of_state_359
    | Ninit Nis'360 => items_of_state_360
    | Ninit Nis'361 => items_of_state_361
    | Ninit Nis'362 => items_of_state_362
    | Ninit Nis'363 => items_of_state_363
    | Ninit Nis'364 => items_of_state_364
    | Ninit Nis'365 => items_of_state_365
    | Ninit Nis'366 => items_of_state_366
    | Ninit Nis'367 => items_of_state_367
    | Ninit Nis'368 => items_of_state_368
    | Ninit Nis'369 => items_of_state_369
    | Ninit Nis'370 => items_of_state_370
    | Ninit Nis'371 => items_of_state_371
    | Ninit Nis'372 => items_of_state_372
    | Ninit Nis'373 => items_of_state_373
    | Ninit Nis'374 => items_of_state_374
    | Ninit Nis'375 => items_of_state_375
    | Ninit Nis'376 => items_of_state_376
    | Ninit Nis'377 => items_of_state_377
    | Ninit Nis'378 => items_of_state_378
    | Ninit Nis'379 => items_of_state_379
    | Ninit Nis'380 => items_of_state_380
    | Ninit Nis'381 => items_of_state_381
    | Ninit Nis'382 => items_of_state_382
    | Ninit Nis'383 => items_of_state_383
    | Ninit Nis'384 => items_of_state_384
    | Ninit Nis'385 => items_of_state_385
    | Ninit Nis'386 => items_of_state_386
    | Ninit Nis'387 => items_of_state_387
    | Ninit Nis'388 => items_of_state_388
    | Ninit Nis'389 => items_of_state_389
    | Ninit Nis'390 => items_of_state_390
    | Ninit Nis'391 => items_of_state_391
    | Ninit Nis'392 => items_of_state_392
    | Ninit Nis'393 => items_of_state_393
    | Ninit Nis'394 => items_of_state_394
    | Ninit Nis'395 => items_of_state_395
    | Ninit Nis'396 => items_of_state_396
    | Ninit Nis'397 => items_of_state_397
    | Ninit Nis'398 => items_of_state_398
    | Ninit Nis'399 => items_of_state_399
    | Ninit Nis'400 => items_of_state_400
    | Ninit Nis'401 => items_of_state_401
    | Ninit Nis'402 => items_of_state_402
    | Ninit Nis'403 => items_of_state_403
    | Ninit Nis'404 => items_of_state_404
    | Ninit Nis'405 => items_of_state_405
    | Ninit Nis'406 => items_of_state_406
    | Ninit Nis'407 => items_of_state_407
    | Ninit Nis'408 => items_of_state_408
    | Ninit Nis'409 => items_of_state_409
    | Ninit Nis'410 => items_of_state_410
    | Ninit Nis'411 => items_of_state_411
    | Ninit Nis'412 => items_of_state_412
    | Ninit Nis'413 => items_of_state_413
    | Ninit Nis'414 => items_of_state_414
    | Ninit Nis'415 => items_of_state_415
    | Ninit Nis'416 => items_of_state_416
    | Ninit Nis'417 => items_of_state_417
    | Ninit Nis'418 => items_of_state_418
    | Ninit Nis'419 => items_of_state_419
    | Ninit Nis'420 => items_of_state_420
    | Ninit Nis'421 => items_of_state_421
    | Ninit Nis'422 => items_of_state_422
    | Ninit Nis'423 => items_of_state_423
    | Ninit Nis'424 => items_of_state_424
    | Ninit Nis'425 => items_of_state_425
    | Ninit Nis'426 => items_of_state_426
    | Ninit Nis'427 => items_of_state_427
    | Ninit Nis'428 => items_of_state_428
    | Ninit Nis'429 => items_of_state_429
    | Ninit Nis'430 => items_of_state_430
    | Ninit Nis'431 => items_of_state_431
    | Ninit Nis'432 => items_of_state_432
    | Ninit Nis'433 => items_of_state_433
    | Ninit Nis'434 => items_of_state_434
    | Ninit Nis'435 => items_of_state_435
    | Ninit Nis'436 => items_of_state_436
    | Ninit Nis'437 => items_of_state_437
    | Ninit Nis'438 => items_of_state_438
    | Ninit Nis'439 => items_of_state_439
    | Ninit Nis'440 => items_of_state_440
    | Ninit Nis'441 => items_of_state_441
    | Ninit Nis'442 => items_of_state_442
    | Ninit Nis'443 => items_of_state_443
    | Ninit Nis'444 => items_of_state_444
    | Ninit Nis'445 => items_of_state_445
    | Ninit Nis'446 => items_of_state_446
    | Ninit Nis'447 => items_of_state_447
    | Ninit Nis'448 => items_of_state_448
    | Ninit Nis'449 => items_of_state_449
    | Ninit Nis'450 => items_of_state_450
    | Ninit Nis'451 => items_of_state_451
    | Ninit Nis'452 => items_of_state_452
    | Ninit Nis'453 => items_of_state_453
    | Ninit Nis'454 => items_of_state_454
    | Ninit Nis'455 => items_of_state_455
    | Ninit Nis'456 => items_of_state_456
    | Ninit Nis'457 => items_of_state_457
    | Ninit Nis'458 => items_of_state_458
    | Ninit Nis'459 => items_of_state_459
    | Ninit Nis'460 => items_of_state_460
    | Ninit Nis'461 => items_of_state_461
    | Ninit Nis'462 => items_of_state_462
    | Ninit Nis'463 => items_of_state_463
    | Ninit Nis'464 => items_of_state_464
    | Ninit Nis'465 => items_of_state_465
    | Ninit Nis'466 => items_of_state_466
    | Ninit Nis'467 => items_of_state_467
    | Ninit Nis'468 => items_of_state_468
    | Ninit Nis'469 => items_of_state_469
    | Ninit Nis'470 => items_of_state_470
    | Ninit Nis'471 => items_of_state_471
    | Ninit Nis'472 => items_of_state_472
    | Ninit Nis'473 => items_of_state_473
    | Ninit Nis'474 => items_of_state_474
    | Ninit Nis'475 => items_of_state_475
    | Ninit Nis'476 => items_of_state_476
    | Ninit Nis'477 => items_of_state_477
    | Ninit Nis'478 => items_of_state_478
    | Ninit Nis'479 => items_of_state_479
    | Ninit Nis'480 => items_of_state_480
    | Ninit Nis'481 => items_of_state_481
    | Ninit Nis'482 => items_of_state_482
    | Ninit Nis'483 => items_of_state_483
    | Ninit Nis'484 => items_of_state_484
    | Ninit Nis'485 => items_of_state_485
    | Ninit Nis'486 => items_of_state_486
    | Ninit Nis'487 => items_of_state_487
    | Ninit Nis'488 => items_of_state_488
    | Ninit Nis'489 => items_of_state_489
    | Ninit Nis'490 => items_of_state_490
    | Ninit Nis'491 => items_of_state_491
    | Ninit Nis'492 => items_of_state_492
    | Ninit Nis'493 => items_of_state_493
    | Ninit Nis'494 => items_of_state_494
    | Ninit Nis'495 => items_of_state_495
    | Ninit Nis'496 => items_of_state_496
    | Ninit Nis'497 => items_of_state_497
    | Ninit Nis'498 => items_of_state_498
    | Ninit Nis'499 => items_of_state_499
    | Ninit Nis'500 => items_of_state_500
    | Ninit Nis'501 => items_of_state_501
    | Ninit Nis'502 => items_of_state_502
    | Ninit Nis'503 => items_of_state_503
    | Ninit Nis'504 => items_of_state_504
    | Ninit Nis'505 => items_of_state_505
    | Ninit Nis'506 => items_of_state_506
    | Ninit Nis'507 => items_of_state_507
    | Ninit Nis'508 => items_of_state_508
    | Ninit Nis'509 => items_of_state_509
    | Ninit Nis'510 => items_of_state_510
    | Ninit Nis'511 => items_of_state_511
    | Ninit Nis'512 => items_of_state_512
    | Ninit Nis'513 => items_of_state_513
    | Ninit Nis'514 => items_of_state_514
    | Ninit Nis'515 => items_of_state_515
    | Ninit Nis'516 => items_of_state_516
    | Ninit Nis'517 => items_of_state_517
    | Ninit Nis'518 => items_of_state_518
    | Ninit Nis'519 => items_of_state_519
    | Ninit Nis'520 => items_of_state_520
    | Ninit Nis'521 => items_of_state_521
    | Ninit Nis'522 => items_of_state_522
    | Ninit Nis'523 => items_of_state_523
    | Ninit Nis'524 => items_of_state_524
    | Ninit Nis'525 => items_of_state_525
    | Ninit Nis'526 => items_of_state_526
    | Ninit Nis'527 => items_of_state_527
    | Ninit Nis'528 => items_of_state_528
    | Ninit Nis'529 => items_of_state_529
    | Ninit Nis'530 => items_of_state_530
    | Ninit Nis'531 => items_of_state_531
    | Ninit Nis'532 => items_of_state_532
    | Ninit Nis'533 => items_of_state_533
    | Ninit Nis'534 => items_of_state_534
    | Ninit Nis'535 => items_of_state_535
    | Ninit Nis'536 => items_of_state_536
    | Ninit Nis'537 => items_of_state_537
    | Ninit Nis'538 => items_of_state_538
    | Ninit Nis'539 => items_of_state_539
    | Ninit Nis'540 => items_of_state_540
    | Ninit Nis'541 => items_of_state_541
    | Ninit Nis'542 => items_of_state_542
    | Ninit Nis'543 => items_of_state_543
    | Ninit Nis'544 => items_of_state_544
    | Ninit Nis'545 => items_of_state_545
    | Ninit Nis'546 => items_of_state_546
    | Ninit Nis'547 => items_of_state_547
    | Ninit Nis'548 => items_of_state_548
    | Ninit Nis'549 => items_of_state_549
    | Ninit Nis'550 => items_of_state_550
    | Ninit Nis'551 => items_of_state_551
    | Ninit Nis'552 => items_of_state_552
    | Ninit Nis'553 => items_of_state_553
    | Ninit Nis'554 => items_of_state_554
    | Ninit Nis'555 => items_of_state_555
    | Ninit Nis'556 => items_of_state_556
    | Ninit Nis'557 => items_of_state_557
    | Ninit Nis'558 => items_of_state_558
    | Ninit Nis'559 => items_of_state_559
    | Ninit Nis'560 => items_of_state_560
    | Ninit Nis'561 => items_of_state_561
    | Ninit Nis'562 => items_of_state_562
    | Ninit Nis'563 => items_of_state_563
    | Ninit Nis'564 => items_of_state_564
    | Ninit Nis'565 => items_of_state_565
    | Ninit Nis'566 => items_of_state_566
    | Ninit Nis'567 => items_of_state_567
    | Ninit Nis'568 => items_of_state_568
    | Ninit Nis'569 => items_of_state_569
    | Ninit Nis'570 => items_of_state_570
    | Ninit Nis'571 => items_of_state_571
    | Ninit Nis'572 => items_of_state_572
    | Ninit Nis'573 => items_of_state_573
    | Ninit Nis'574 => items_of_state_574
    | Ninit Nis'575 => items_of_state_575
    | Ninit Nis'576 => items_of_state_576
    | Ninit Nis'577 => items_of_state_577
    | Ninit Nis'578 => items_of_state_578
    | Ninit Nis'579 => items_of_state_579
    | Ninit Nis'580 => items_of_state_580
    | Ninit Nis'581 => items_of_state_581
    | Ninit Nis'582 => items_of_state_582
    | Ninit Nis'583 => items_of_state_583
    | Ninit Nis'584 => items_of_state_584
    | Ninit Nis'585 => items_of_state_585
    | Ninit Nis'586 => items_of_state_586
    | Ninit Nis'587 => items_of_state_587
    | Ninit Nis'588 => items_of_state_588
    | Ninit Nis'589 => items_of_state_589
    | Ninit Nis'590 => items_of_state_590
    | Ninit Nis'591 => items_of_state_591
    | Ninit Nis'592 => items_of_state_592
    | Ninit Nis'593 => items_of_state_593
    | Ninit Nis'594 => items_of_state_594
    | Ninit Nis'595 => items_of_state_595
    | Ninit Nis'596 => items_of_state_596
  end.
Extract Constant items_of_state => "fun _ -> assert false".

End Aut.

Require Import Main.

Module Parser := Main.Make Aut.
Theorem safe:
  Parser.safe_validator () = true.
Proof eq_refl true<:Parser.safe_validator () = true.

Theorem complete:
  Parser.complete_validator () = true.
Proof eq_refl true<:Parser.complete_validator () = true.

Definition translation_unit_file := Parser.parse safe Aut.Init'0.

Theorem translation_unit_file_correct iterator buffer:
  match translation_unit_file iterator buffer with
    | Parser.Inter.Parsed_pr sem buffer_new =>
      exists word,
        buffer = Parser.Inter.app_str word buffer_new /\
        inhabited (Gram.parse_tree (NT translation_unit_file'nt) word sem)
    | _ => True
  end.
Proof. apply Parser.parse_correct. Qed.

Theorem translation_unit_file_complete (iterator:nat) word buffer_end (output:      (list definition)):
  forall tree:Gram.parse_tree (NT translation_unit_file'nt) word output,
  match translation_unit_file iterator (Parser.Inter.app_str word buffer_end) with
    | Parser.Inter.Fail_pr => False
    | Parser.Inter.Parsed_pr output_res buffer_end_res =>
      output_res = output /\ buffer_end_res = buffer_end  /\
      le (Gram.pt_size tree) iterator
    | Parser.Inter.Timeout_pr => lt iterator (Gram.pt_size tree)
  end.
Proof. apply Parser.parse_complete with (init:=Aut.Init'0); exact complete. Qed.

